var _a;

import * as tsplus_module_1 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatten";
export const CountdownLatchSym = /*#__PURE__*/Symbol.for("@effect/core/concurrent/CountdownLatch");
export const CountdownLatch = {
  $: {}
};
export class CountdownLatchInternal {
  constructor(count, waiters) {
    this[_a] = CountdownLatchSym;
    this._count = count;
    this._waiters = waiters;
  }
  /**
   * Returns the current count.
   */


  get count() {
    return this._count.get;
  }
  /**
   * Decrements the count of the latch, releasing all waiting fibers if the
   * count reaches zero.
   */


  get countDown() {
    return tsplus_module_1.asUnit(tsplus_module_2.flatten(this._count.modify(n => {
      if (n === 0) {
        return [tsplus_module_1.unit, 0];
      }

      if (n === 1) {
        return [this._waiters.succeed(undefined), 0];
      }

      return [tsplus_module_1.unit, n - 1];
    })));
  }
  /**
   * Causes the current fiber to wait until the latch has counted down to zero.
   */


  get await() {
    return this._waiters.await;
  }

}
_a = CountdownLatchSym;
//# sourceMappingURL=definition.mjs.map