var _a;

import * as tsplus_module_1 from "@effect/core/io/Deferred/operations/make";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/whenEffect";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_6 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/zipLeft";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/flatten";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/unit";
export const CyclicBarrierSym = /*#__PURE__*/Symbol.for("@effect/core/concurrent/CyclicBarrier");
export const CyclicBarrier = {
  $: {}
};
export class CyclicBarrierInternal {
  constructor(parties, waiting, lock, action, broken) {
    this[_a] = CyclicBarrierSym;
    this._parties = parties;
    this._waiting = waiting;
    this._lock = lock;
    this._action = action;
    this._broken = broken;
  }
  /**
   * The number of parties required to trip this barrier.
   */


  get parties() {
    return this._parties;
  }
  /**
   * The number of parties currently waiting at the barrier.
   */


  get waiting() {
    return this._waiting.get;
  }
  /**
   * Queries if this barrier is in a broken state.
   */


  get isBroken() {
    return this._broken.get;
  }
  /**
   * Resets the barrier to its initial state. Breaks any waiting party.
   */


  get reset() {
    return tsplus_module_6.uninterruptible(tsplus_module_5.zipRight(this._broken.set(false))(tsplus_module_5.zipRight(this._waiting.set(0))(tsplus_module_5.zipRight(tsplus_module_2.flatMap(deferred => this._lock.set(deferred))(tsplus_module_1.make()))(tsplus_module_4.whenEffect(tsplus_module_3.map(waiting => waiting > 0)(this._waiting.get), this.fail)))));
  }
  /**
   * Waits until all parties have invoked await on this barrier. Fails if the
   * barrier is broken.
   */


  get await() {
    return tsplus_module_6.uninterruptibleMask(({
      restore
    }) => tsplus_module_5.zipRight(tsplus_module_9.flatten(this._waiting.modify(waiting => waiting + 1 === this._parties ? [tsplus_module_8.zipLeft(this.reset)(tsplus_module_5.zipRight(tsplus_module_7.as(this._parties - waiting - 1)(this.succeed))(restore(this._action))), 0] : [tsplus_module_2.flatMap(lock => tsplus_module_7.as(this._parties - waiting - 1)(tsplus_module_6.onInterrupt(() => this.break)(restore(lock.await))))(this._lock.get), waiting + 1])))(tsplus_module_2.flatMap(broken => broken ? tsplus_module_10.fail(undefined) : tsplus_module_11.unit)(this._broken.get)));
  }

  get succeed() {
    return tsplus_module_2.flatMap(deferred => tsplus_module_11.asUnit(deferred.succeed(undefined)))(this._lock.get);
  }

  get fail() {
    return tsplus_module_2.flatMap(deferred => tsplus_module_11.asUnit(deferred.fail(undefined)))(this._lock.get);
  }

  get break() {
    return tsplus_module_5.zipRight(this.fail)(this._broken.set(true));
  }

}
_a = CyclicBarrierSym;
//# sourceMappingURL=definition.mjs.map