import * as tsplus_module_1 from "@effect/core/io/Effect/operations/schedule";
import * as tsplus_module_2 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_3 from "@effect/core/io/Fiber/operations/interrupt";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_5 from "@effect/core/io/Cached/operations/manual";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Creates a new `Cached` value that is automatically refreshed according to
 * the specified policy. Note that error retrying is not performed
 * automatically, so if you want to retry on errors, you should first apply
 * retry policies to the acquisition effect before passing it to this
 * constructor.
 *
 * @tsplus static effect/core/io/Cached.Ops auto
 */

export function auto(acquire, policy) {
  return tsplus_module_6.flatMap(manual => tsplus_module_4.map(() => manual)(tsplus_module_2.acquireRelease(tsplus_module_2.forkDaemon(tsplus_module_2.interruptible(tsplus_module_1.schedule(policy)(manual.refresh))), fiber => tsplus_module_3.interrupt(fiber))))(tsplus_module_5.manual(acquire));
}
//# sourceMappingURL=auto.mjs.map