import * as tsplus_module_1 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@effect/core/io/Cause/operations/foldLeft";
/**
 * Determines if this cause contains or is equal to the specified cause.
 *
 * @tsplus static effect/core/io/Cause.Aspects contains
 * @tsplus pipeable effect/core/io/Cause contains
 */

export function contains(that) {
  return self => {
    if (self === that) {
      return true;
    }

    return tsplus_module_3.foldLeft(false, (acc, cause) => tsplus_module_2.some(acc || tsplus_module_1.equals(cause, that)))(self);
  };
}
//# sourceMappingURL=contains.mjs.map