import * as tsplus_module_1 from "@tsplus/stdlib/io/Eval/run";
import * as tsplus_module_2 from "@tsplus/stdlib/io/Eval/succeed";
import * as tsplus_module_3 from "@tsplus/stdlib/io/Eval/succeedNow";
import * as tsplus_module_4 from "@tsplus/stdlib/io/Eval/suspend";
import * as tsplus_module_5 from "@tsplus/stdlib/io/Eval/flatMap";
import { realCause } from "@effect/core/io/Cause/definition";
/**
 * Finds something and extracts some details from it.
 *
 * @tsplus static effect/core/io/Cause.Aspects find
 * @tsplus pipeable effect/core/io/Cause find
 */

export function find(f) {
  return self => tsplus_module_1.run(findSafe(self, f));
}

function findSafe(self, f) {
  const result = f(self);

  if (result._tag === "Some") {
    return tsplus_module_2.succeed(() => result);
  }

  void 0;

  switch (self._tag) {
    case "Both":
    case "Then":
      {
        return tsplus_module_5.flatMap(leftResult => leftResult._tag === "Some" ? tsplus_module_3.succeedNow(leftResult) : findSafe(self.right, f))(tsplus_module_4.suspend(() => findSafe(self.left, f)));
      }

    case "Stackless":
      {
        return tsplus_module_4.suspend(() => findSafe(self.cause, f));
      }

    default:
      {
        return tsplus_module_2.succeed(() => result);
      }
  }
}
//# sourceMappingURL=find.mjs.map