import * as tsplus_module_1 from "@effect/core/io/Cause/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@effect/core/io/Cause/operations/find";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Maybe/getOrElse";
/**
 * Determines if the `Cause` contains only interruptions and not any `Die` or
 * `Fail` causes.
 *
 * @tsplus getter effect/core/io/Cause isInterruptedOnly
 */

export function isInterruptedOnly(self) {
  return tsplus_module_4.getOrElse_(tsplus_module_3.find(cause => tsplus_module_1.isDieType(cause) || tsplus_module_1.isFailType(cause) ? tsplus_module_2.some(false) : tsplus_module_2.none)(self), () => true);
}
//# sourceMappingURL=isInterruptedOnly.mjs.map