import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/map";
import * as tsplus_module_3 from "@effect/core/io/Cause/operations/fold";
import { Both, Die, Stackless, Then } from "@effect/core/io/Cause/definition";
/**
 * Remove all `Fail` and `Interrupt` nodes from this `Cause`, return only
 * `Die` cause/finalizer defects.
 *
 * @tsplus getter effect/core/io/Cause keepDefects
 */

export function keepDefects(self) {
  return tsplus_module_3.fold(tsplus_module_1.none, () => tsplus_module_1.none, e => tsplus_module_1.some(new Die(e)), () => tsplus_module_1.none, (left, right) => {
    if (left._tag === "Some" && right._tag === "Some") {
      return tsplus_module_1.some(new Then(left.value, right.value));
    }

    if (left._tag === "Some" && right._tag === "None") {
      return tsplus_module_1.some(left.value);
    }

    if (left._tag === "None" && right._tag === "Some") {
      return tsplus_module_1.some(right.value);
    }

    if (left._tag === "None" && right._tag === "None") {
      return tsplus_module_1.none;
    }

    throw new Error("Bug");
  }, (left, right) => {
    if (left._tag === "Some" && right._tag === "Some") {
      return tsplus_module_1.some(new Both(left.value, right.value));
    }

    if (left._tag === "Some" && right._tag === "None") {
      return tsplus_module_1.some(left.value);
    }

    if (left._tag === "None" && right._tag === "Some") {
      return tsplus_module_1.some(right.value);
    }

    if (left._tag === "None" && right._tag === "None") {
      return tsplus_module_1.none;
    }

    throw new Error("Bug");
  }, (causeMaybe, stackless) => tsplus_module_2.map(cause => new Stackless(cause, stackless))(causeMaybe))(self);
}
//# sourceMappingURL=keepDefects.mjs.map