import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashSet/operations/add";
import * as tsplus_module_3 from "@effect/core/io/Cause/definition";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashSet/operations/map";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/HashSet/operations/flatMap";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/HashSet/operations/union";
import * as tsplus_module_7 from "@effect/core/io/Cause/operations/fold";
import { Die, Fail, Interrupt, Stackless } from "@effect/core/io/Cause/definition";
/**
 * Linearizes this cause to a set of parallel causes where each parallel cause
 * contains a linear sequence of failures.
 *
 * @tsplus getter effect/core/io/Cause linearize
 */

export function linearize(self) {
  return tsplus_module_7.fold(tsplus_module_1.empty(), e => tsplus_module_2.add(new Fail(e))(tsplus_module_1.empty()), d => tsplus_module_2.add(new Die(d))(tsplus_module_1.empty()), fiberId => tsplus_module_2.add(new Interrupt(fiberId))(tsplus_module_1.empty()), (left, right) => tsplus_module_5.flatMap(l => tsplus_module_4.map(r => tsplus_module_3.combineSeq(l, r))(right))(left), (left, right) => tsplus_module_6.union(right)(left), (cause, stackless) => tsplus_module_4.map(c => new Stackless(c, stackless))(cause))(self);
}
//# sourceMappingURL=linearize.mjs.map