import * as tsplus_module_1 from "@effect/core/io/Cause/operations/isInterrupted";
import * as tsplus_module_2 from "@effect/core/io/FiberId/operations/ids";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashSet/operations/map";
import * as tsplus_module_4 from "@effect/core/io/Cause/operations/interruptors";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/HashSet/operations/flatMap";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/HashSet/operations/reduce";
import * as tsplus_module_7 from "@effect/core/io/Cause/errors";
import * as tsplus_module_8 from "@effect/core/io/Cause/operations/defects";
import * as tsplus_module_9 from "@tsplus/stdlib/collections/List/head";
import * as tsplus_module_10 from "@tsplus/stdlib/data/Maybe/getOrElse";
import * as tsplus_module_11 from "@effect/core/io/Cause/operations/failureMaybe";
import * as tsplus_module_12 from "@tsplus/stdlib/data/Maybe/map";
/**
 * Squashes a `Cause` down to a single defect, chosen to be the "most
 * important" defect.
 *
 * @tsplus static effect/core/io/Cause.Aspects squashWith
 * @tsplus pipeable effect/core/io/Cause squashWith
 */

export function squashWith(f) {
  return self => tsplus_module_10.getOrElse_(tsplus_module_12.map(f)(tsplus_module_11.failureMaybe(self)), () => {
    if (tsplus_module_1.isInterrupted(self)) {
      const fibers = tsplus_module_6.reduce("", (acc, id) => `${acc}, ${id}`)(tsplus_module_5.flatMap(fiberId => tsplus_module_3.map(n => `#${n}`)(tsplus_module_2.ids(fiberId)))(tsplus_module_4.interruptors(self)));
      return new tsplus_module_7.InterruptedException(`Interrupted by fibers: ${fibers}`);
    }

    return tsplus_module_10.getOrElse_(tsplus_module_9.head(tsplus_module_8.defects(self)), () => new tsplus_module_7.InterruptedException());
  });
}
//# sourceMappingURL=squashWith.mjs.map