import * as tsplus_module_1 from "@effect/core/io/Cause/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/map";
import * as tsplus_module_4 from "@effect/core/io/Cause/operations/fold";
import { Stackless } from "@effect/core/io/Cause/definition";
/**
 * Remove all `Die` causes that the specified partial function is defined at,
 * returning `Some` with the remaining causes or `None` if there are no
 * remaining causes.
 *
 * @tsplus static effect/core/io/Cause.Aspects stripSomeDefects
 * @tsplus pipeable effect/core/io/Cause stripSomeDefects
 */

export function stripSomeDefects(pf) {
  return cause => tsplus_module_4.fold(tsplus_module_2.some(tsplus_module_1.empty), e => tsplus_module_2.some(tsplus_module_1.fail(e)), t => pf(t) ? tsplus_module_2.none : tsplus_module_2.some(tsplus_module_1.die(t)), fiberId => tsplus_module_2.some(tsplus_module_1.interrupt(fiberId)), (x, y) => {
    if (tsplus_module_2.isSome(x) && tsplus_module_2.isSome(y)) {
      return tsplus_module_2.some(tsplus_module_1.combineSeq(x.value, y.value));
    }

    if (tsplus_module_2.isSome(x) && tsplus_module_2.isNone(y)) {
      return tsplus_module_2.some(x.value);
    }

    if (tsplus_module_2.isNone(x) && tsplus_module_2.isSome(y)) {
      return tsplus_module_2.some(y.value);
    }

    return tsplus_module_2.none;
  }, (x, y) => {
    if (tsplus_module_2.isSome(x) && tsplus_module_2.isSome(y)) {
      return tsplus_module_2.some(tsplus_module_1.combinePar(x.value, y.value));
    }

    if (tsplus_module_2.isSome(x) && tsplus_module_2.isNone(y)) {
      return tsplus_module_2.some(x.value);
    }

    if (tsplus_module_2.isNone(x) && tsplus_module_2.isSome(y)) {
      return tsplus_module_2.some(y.value);
    }

    return tsplus_module_2.none;
  }, (causeOption, stackless) => tsplus_module_3.map(cause => new Stackless(cause, stackless))(causeOption))(cause);
}
//# sourceMappingURL=stripSomeDefects.mjs.map