import * as tsplus_module_1 from "@effect/core/io/Cause/operations/squashWith";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/sandbox";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/foldEffect";
/**
 * Attempts to convert defects into a failure, throwing away all information
 * about the cause of the failure.
 *
 * @tsplus static effect/core/io/Effect.Aspects absorbWith
 * @tsplus pipeable effect/core/io/Effect absorbWith
 */

export function absorbWith(f) {
  return self => tsplus_module_5.foldEffect(cause => tsplus_module_2.fail(tsplus_module_1.squashWith(f)(cause)), tsplus_module_3.succeed)(tsplus_module_4.sandbox(self));
}
//# sourceMappingURL=absorbWith.mjs.map