import * as tsplus_module_1 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/ensuring";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/suspendSucceed";
/**
 * A more powerful variant of `acquireReleaseInterruptible` that allows the
 * `release` effect to depend on the `Exit` value specified when the scope
 * is closed.
 *
 * @tsplus static effect/core/io/Effect.Ops acquireReleaseInterruptibleExit
 * @tsplus fluent effect/core/io/Effect acquireReleaseInterruptibleExit
 */

export function acquireReleaseInterruptibleExit(acquire, release) {
  return tsplus_module_3.suspendSucceed(() => tsplus_module_2.ensuring(tsplus_module_1.addFinalizerExit(release))(acquire));
}
//# sourceMappingURL=acquireReleaseInterruptibleExit.mjs.map