import * as tsplus_module_1 from "@effect/core/io/FiberId/operations/none";
export const _async = _async_1;
import { IAsync } from "@effect/core/io/Effect/definition/primitives";
/**
 * Imports an asynchronous side-effect into a pure `Effect` value. See
 * `asyncMaybe` for the more expressive variant of this function that can
 * return a value synchronously.
 *
 * The callback function `Effect<R, E, A> => any` must be called at most once.
 *
 * @tsplus static effect/core/io/Effect.Ops async
 */

function _async_1(register) {
  return new IAsync(register, tsplus_module_1.none);
}

export { _async_1 as async };
/**
 * Imports an asynchronous side-effect into a pure `Effect` value. See
 * `asyncMaybe` for the more expressive variant of this function that can
 * return a value synchronously.
 *
 * The callback function `Effect<R, E, A> => any` must be called at most once.
 *
 * The list of fibers, that may complete the async callback, is used to
 * provide better diagnostics.
 *
 * @tsplus static effect/core/io/Effect.Ops asyncBlockingOn
 */

export function asyncBlockingOn(register, blockingOn) {
  return new IAsync(register, blockingOn);
}
//# sourceMappingURL=async.mjs.map