import * as tsplus_module_1 from "@effect/core/io/FiberId/operations/none";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_5 from "@effect/core/io/Fiber/_internal/runtime";
export const asyncMaybeBlockingOn = asyncMaybeBlockingOn_1;
/**
 * Imports an asynchronous effect into a pure `Effect` value, possibly returning
 * the value synchronously.
 *
 * If the register function returns a value synchronously, then the callback
 * function `Effect<R, E, A> => any` must not be called. Otherwise the callback
 * function must be called at most once.
 *
 * @tsplus static effect/core/io/Effect.Ops asyncMaybe
 */

export function asyncMaybe(register) {
  return asyncMaybeBlockingOn_1(register, tsplus_module_1.none);
}
/**
 * Imports an asynchronous effect into a pure `Effect` value, possibly returning
 * the value synchronously.
 *
 * If the register function returns a value synchronously, then the callback
 * function `Effect<R, E, A> => any` must not be called. Otherwise the callback
 * function must be called at most once.
 *
 * The list of fibers, that may complete the async callback, is used to
 * provide better diagnostics.
 *
 * @tsplus static effect/core/io/Effect.Ops asyncMaybeBlockingOn
 */

function asyncMaybeBlockingOn_1(register, blockingOn) {
  return tsplus_module_5.asyncInterruptBlockingOn(cb => tsplus_module_4.fold(() => tsplus_module_3.left(tsplus_module_2.unit), tsplus_module_3.right)(register(cb)), blockingOn);
}
//# sourceMappingURL=asyncMaybe.mjs.map