import * as tsplus_module_1 from "@effect/core/io/Effect/definition";
import * as tsplus_module_2 from "@effect/core/io/Cause/definition";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/sync";
/**
 * Imports a synchronous side-effect into a pure `Effect` value, translating any
 * thrown exceptions into typed failed effects creating with `Effect.fail`.
 *
 * @tsplus static effect/core/io/Effect.Ops attempt
 */

export function attempt(f) {
  return tsplus_module_3.sync(() => {
    try {
      return f();
    } catch (error) {
      throw new tsplus_module_1.Effect.Error(tsplus_module_2.fail(error));
    }
  });
}
//# sourceMappingURL=attempt.mjs.map