import * as tsplus_module_1 from "@effect/core/io/Effect/operations/cachedInvalidate";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/map";
/**
 * Returns an effect that, if evaluated, will return the cached result of this
 * effect. Cached results will expire after `timeToLive` duration.
 *
 * @tsplus static effect/core/io/Effect.Aspects cached
 * @tsplus pipeable effect/core/io/Effect cached
 */

export function cached(timeToLive) {
  return self => tsplus_module_2.map(tuple => tuple[0])(tsplus_module_1.cachedInvalidate(timeToLive)(self));
}
//# sourceMappingURL=cached.mjs.map