import * as tsplus_module_1 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@effect/core/io/Ref/operations/make";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/io/Deferred/operations/make";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/dieSync";
import * as tsplus_module_8 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_9 from "@effect/core/io/Clock/operations/currentTime";
/**
 * Returns an effect that, if evaluated, will return the cached result of this
 * effect. Cached results will expire after `timeToLive` duration. In
 * addition, returns an effect that can be used to invalidate the current
 * cached value before the `timeToLive` duration expires.
 *
 * @tsplus static effect/core/io/Effect.Aspects cachedInvalidate
 * @tsplus pipeable effect/core/io/Effect cachedInvalidate
 */

export function cachedInvalidate(timeToLive) {
  return self => tsplus_module_5.flatMap(environment => tsplus_module_4.map(cache => [tsplus_module_1.provideEnvironment(environment)(get(self, timeToLive, cache)), invalidate(cache)])(tsplus_module_3.makeSynchronized(() => tsplus_module_2.none)))(tsplus_module_1.environment());
}

function compute(self, timeToLive, start) {
  return tsplus_module_5.flatMap(deferred => tsplus_module_4.map(() => tsplus_module_2.some([start + timeToLive.millis, deferred]))(tsplus_module_1.intoDeferred(deferred)(self)))(tsplus_module_6.make());
}

function get(self, timeToLive, cache) {
  return tsplus_module_1.uninterruptibleMask(({
    restore
  }) => tsplus_module_5.flatMap(time => tsplus_module_5.flatMap(a => a._tag === "None" ? tsplus_module_7.dieSync(() => "Bug") : restore(a.value[1].await))(cache.updateSomeAndGetEffect(_ => tsplus_module_8.fold(() => tsplus_module_2.some(compute(self, timeToLive, time)), ([end]) => end - time <= 0 ? tsplus_module_2.some(compute(self, timeToLive, time)) : tsplus_module_2.none)(_))))(tsplus_module_9.currentTime));
}

function invalidate(cache) {
  return cache.set(tsplus_module_2.none);
}
//# sourceMappingURL=cachedInvalidate.mjs.map