import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/catchSomeDefect";
/**
 * Recovers from all defects with provided function.
 *
 * **WARNING**: There is no sensible way to recover from defects. This
 * method should be used only at the boundary between Effect and an external
 * system, to transmit information on a defect for diagnostic or explanatory
 * purposes.
 *
 * @tsplus static effect/core/io/Effect.Aspects catchAllDefect
 * @tsplus pipeable effect/core/io/Effect catchAllDefect
 */

export function catchAllDefect(f) {
  return self => tsplus_module_2.catchSomeDefect(d => tsplus_module_1.some(f(d)))(self);
}
//# sourceMappingURL=catchAllDefect.mjs.map