import * as tsplus_module_1 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/unrefineWith";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/catchAll";
/**
 * Recovers from some or all of the defects with provided partial function.
 *
 * **WARNING**: There is no sensible way to recover from defects. This
 * method should be used only at the boundary between Effect and an external
 * system, to transmit information on a defect for diagnostic or explanatory
 * purposes.
 *
 * @tsplus static effect/core/io/Effect.Aspects catchSomeDefect
 * @tsplus pipeable effect/core/io/Effect catchSomeDefect
 */

export function catchSomeDefect(pf) {
  return self => tsplus_module_3.catchAll(s => s)(tsplus_module_2.unrefineWith(pf, tsplus_module_1.fail)(self));
}
//# sourceMappingURL=catchSomeDefect.mjs.map