import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_6 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_7 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_8 from "@tsplus/stdlib/collections/Chunk/operations/append";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/zipWith";
export const collectWhile = collectWhile_1;
import { ArrTypeId, concreteChunk, SingletonTypeId } from "@tsplus/stdlib/collections/Chunk";
/**
 * Transforms all elements of the chunk for as long as the specified partial
 * function is defined.
 *
 * @tsplus static effect/core/io/Effect.Ops collectWhile
 */

function collectWhile_1(self, f) {
  const chunk = tsplus_module_1.from(self);
  void 0;

  switch (chunk._typeId) {
    case SingletonTypeId:
      {
        return tsplus_module_6.fold(() => tsplus_module_3.succeed(tsplus_module_2.empty()), b => tsplus_module_5.map(tsplus_module_4.single)(b))(f(chunk.a));
      }

    case ArrTypeId:
      {
        const array = chunk._arrayLike();

        let dest = tsplus_module_3.succeed(tsplus_module_2.empty());

        for (let i = 0; i < array.length; i++) {
          const rhs = f(array[i]);

          if (tsplus_module_7.isSome(rhs)) {
            dest = tsplus_module_9.zipWith(rhs.value, (a, b) => tsplus_module_8.append(b)(a))(dest);
          } else {
            return dest;
          }
        }

        return dest;
      }

    default:
      {
        return collectWhile_1(chunk._materialize(), f);
      }
  }
}
//# sourceMappingURL=collectWhile.mjs.map