import * as tsplus_module_1 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/failSync";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/suspendSucceed";
/**
 * Evaluate the predicate, return the given `A` as success if predicate returns
 * true, and the given `E` as error otherwise
 *
 * For effectful conditionals, see `ifEffect`.
 *
 * @tsplus static effect/core/io/Effect.Ops cond
 */

export function cond(predicate, result, error) {
  return tsplus_module_3.suspendSucceed(() => predicate() ? tsplus_module_1.sync(result) : tsplus_module_2.failSync(error));
}
//# sourceMappingURL=cond.mjs.map