import * as tsplus_module_1 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/getOrElse";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Fail with `e` if the supplied `PartialFunction` does not match, otherwise
 * continue with the returned value.
 *
 * @tsplus static effect/core/io/Effect.Aspects continueOrFailEffect
 * @tsplus pipeable effect/core/io/Effect continueOrFailEffect
 */

export function continueOrFailEffect(e, pf) {
  return self => tsplus_module_3.flatMap(v => tsplus_module_2.getOrElse_(pf(v), () => tsplus_module_1.fail(e)))(self);
}
//# sourceMappingURL=continueOrFailEffect.mjs.map