import * as tsplus_module_1 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/serviceWith";
/**
 * @tsplus static effect/core/io/Effect.Ops deriveLifted
 */

export function deriveLifted(S) {
  return (functions, constants, values) => {
    const ret = {};

    for (const k of functions) {
      ret[k] = (...args) => tsplus_module_1.serviceWithEffect(S, h => h[k](...args));
    }

    for (const k of constants) {
      ret[k] = tsplus_module_1.serviceWithEffect(S, h => h[k]);
    }

    for (const k of values) {
      ret[k] = tsplus_module_2.serviceWith(S, h => h[k]);
    }

    return ret;
  };
}
/**
 * @tsplus static effect/core/io/Effect.Ops deriveAccessEffect
 */

export function deriveAccessEffect(S) {
  return generics => {
    const ret = {};

    for (const k of generics) {
      ret[k] = (f, trace) => tsplus_module_1.serviceWithEffect(S, h => f(h[k]));
    }

    return ret;
  };
}
/**
 * @tsplus static effect/core/io/Effect.Ops deriveAccess
 */

export function deriveAccess(S) {
  return generics => {
    const ret = {};

    for (const k of generics) {
      ret[k] = (f, trace) => tsplus_module_2.serviceWith(S, h => f(h[k]));
    }

    return ret;
  };
}
//# sourceMappingURL=derive.mjs.map