import * as tsplus_module_1 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_2 from "@effect/core/io/Cause/operations/interruptors";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/withFiberRuntime";
/**
 * Constructs an effect based on information about the current fiber, such as
 * its identity.
 *
 * @tsplus static effect/core/io/Effect.Ops descriptorWith
 */

export function descriptorWith(f) {
  return tsplus_module_3.withFiberRuntime((state, status) => {
    return f({
      id: state.id,
      status,
      interrupters: tsplus_module_2.interruptors(state.getFiberRef(tsplus_module_1.interruptedCause))
    });
  });
}
//# sourceMappingURL=descriptorWith.mjs.map