import * as tsplus_module_1 from "@effect/core/io/Cause/errors";
import * as tsplus_module_2 from "@effect/core/io/Cause/definition";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/failCauseSync";
/**
 * Returns an effect that dies with a `RuntimeException` having the specified
 * text message. This method can be used for terminating a fiber because a
 * defect has been detected in the code.
 *
 * @tsplus static effect/core/io/Effect.Ops dieMessage
 */

export function dieMessage(message) {
  return tsplus_module_3.failCauseSync(() => tsplus_module_2.stackless(tsplus_module_2.die(new tsplus_module_1.RuntimeError(message))));
}
//# sourceMappingURL=dieMessage.mjs.map