import * as tsplus_module_1 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/succeed";
/**
 * Binds an effectful value in a `do` scope
 *
 * @tsplus static effect/core/io/Effect.Aspects bind
 * @tsplus pipeable effect/core/io/Effect bind
 */

export function bind(tag, f) {
  return self => tsplus_module_2.flatMap(k => tsplus_module_1.map(a => ({ ...k,
    [tag]: a
  }))(f(k)))(self);
}
/**
 * Like bind for values
 *
 * @tsplus static effect/core/io/Effect.Aspects bindValue
 * @tsplus pipeable effect/core/io/Effect bindValue
 */

export function bindValue(tag, f) {
  return self => tsplus_module_1.map(k => ({ ...k,
    [tag]: f(k)
  }))(self);
}
/**
 * @tsplus static effect/core/io/Effect.Ops Do
 */

export function Do() {
  return tsplus_module_3.succeed({});
}
//# sourceMappingURL=do.mjs.map