import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/foldEffect";
/**
 * Returns an effect whose failure and success have been lifted into an
 * `Either`. The resulting effect cannot fail, because the failure case has
 * been exposed as part of the `Either` success case.
 *
 * This method is useful for recovering from effects that may fail.
 *
 * The error parameter of the returned `Effect` is `never`, since it is
 * guaranteed the effect does not model failure.
 *
 * @tsplus getter effect/core/io/Effect either
 */

export function either(self) {
  return tsplus_module_3.foldEffect(e => tsplus_module_2.succeed(tsplus_module_1.left(e)), a => tsplus_module_2.succeed(tsplus_module_1.right(a)))(self);
}
//# sourceMappingURL=either.mjs.map