import * as tsplus_module_1 from "@effect/core/io/Cause/definition";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/foldCauseEffect";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_5 from "@effect/core/io/Fiber/_internal/runtime";
/**
 * Returns an effect that, if this effect _starts_ execution, then the
 * specified `finalizer` is guaranteed to begin execution, whether this effect
 * succeeds, fails, or is interrupted.
 *
 * For use cases that need access to the effect's result, see `onExit`.
 *
 * Finalizers offer very powerful guarantees, but they are low-level, and
 * should generally not be used for releasing resources. For higher-level
 * logic built on `ensuring`, see `acquireReleaseWith`.
 *
 * @tsplus static effect/core/io/Effect.Aspects ensuring
 * @tsplus pipeable effect/core/io/Effect ensuring
 */

export function ensuring(finalizer) {
  return self => tsplus_module_5.uninterruptibleMask(mask => tsplus_module_3.foldCauseEffect(cause1 => tsplus_module_3.foldCauseEffect(cause2 => tsplus_module_2.failCause(tsplus_module_1.combineSeq(cause1, cause2)), () => tsplus_module_2.failCause(cause1))(finalizer), a => tsplus_module_4.map(() => a)(finalizer))(mask.restore(self)));
}
//# sourceMappingURL=ensuring.mjs.map