import * as tsplus_module_1 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/supervised";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/ensuring";
import * as tsplus_module_4 from "@effect/core/io/Supervisor/definition";
/**
 * Acts on the children of this fiber, guaranteeing the specified callback
 * will be invoked, whether or not this effect succeeds.
 *
 * @tsplus static effect/core/io/Effect.Aspects ensuringChildren
 * @tsplus pipeable effect/core/io/Effect ensuringChildren
 */

export function ensuringChildren(children) {
  return self => tsplus_module_1.flatMap(supervisor => tsplus_module_3.ensuring(tsplus_module_1.flatMap(children)(supervisor.value))(tsplus_module_2.supervised(supervisor)(self)))(tsplus_module_4.track);
}
//# sourceMappingURL=ensuringChildren.mjs.map