import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/suspendSucceed";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_6 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/parallelism";
import * as tsplus_module_8 from "@tsplus/stdlib/collections/Collection/functions";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/dieMessage";
import * as tsplus_module_12 from "@tsplus/stdlib/collections/Chunk/operations/size";
import * as tsplus_module_13 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_14 from "@effect/core/io/Effect/operations/tap";
import * as tsplus_module_15 from "@tsplus/stdlib/collections/Chunk/operations/head";
import * as tsplus_module_16 from "@effect/core/io/Effect/operations/replicate";
import * as tsplus_module_17 from "@tsplus/stdlib/data/Function";
import * as tsplus_module_18 from "@tsplus/stdlib/collections/Chunk/operations/zipWithIndex";
import * as tsplus_module_19 from "@effect/core/io/FiberId/operations/none";
import * as tsplus_module_20 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_21 from "@tsplus/stdlib/data/AtomicNumber";
import * as tsplus_module_22 from "@effect/core/io/Exit/operations/collectAllPar";
import * as tsplus_module_23 from "@effect/core/io/Cause/operations/stripFailures";
import * as tsplus_module_24 from "@effect/core/io/Cause/definition";
import * as tsplus_module_25 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_26 from "@effect/core/io/Fiber/operations/interrupt";
import * as tsplus_module_27 from "@effect/core/io/Effect/operations/foldCauseEffect";
import * as tsplus_module_28 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_29 from "@effect/core/io/Effect/operations/transplant";
import * as tsplus_module_30 from "@tsplus/stdlib/collections/Chunk/operations/collect";
import * as tsplus_module_31 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_32 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_33 from "@tsplus/stdlib/collections/Chunk/operations/append";
import * as tsplus_module_34 from "@effect/core/io/Effect/operations/zipWith";
import * as tsplus_module_35 from "@effect/core/io/Effect/operations/exit";
import * as tsplus_module_36 from "@effect/core/io/Fiber/operations/inheritAll";
import * as tsplus_module_37 from "@effect/core/io/Effect/operations/flatten";
import * as tsplus_module_38 from "@effect/core/io/Fiber/operations/await";
import * as tsplus_module_39 from "@effect/core/io/Exit/operations/unit";
import * as tsplus_module_40 from "@effect/core/io/Exit/operations/collectAll";
import * as tsplus_module_41 from "@tsplus/stdlib/data/Maybe/getOrElse";
import * as tsplus_module_42 from "@tsplus/stdlib/collections/mutable/MutableQueue/bounded";
import * as tsplus_module_43 from "@tsplus/stdlib/collections/mutable/MutableQueue/unbounded";
import * as tsplus_module_44 from "@tsplus/stdlib/data/AtomicBoolean";
import * as tsplus_module_45 from "@effect/core/io/Deferred/operations/make";
import * as tsplus_module_46 from "@tsplus/stdlib/collections/mutable/MutableQueue";
import * as tsplus_module_47 from "@tsplus/stdlib/collections/Chunk/operations/splitAt";
import * as tsplus_module_48 from "@tsplus/stdlib/collections/Chunk/operations/zip";
import * as tsplus_module_49 from "@tsplus/stdlib/collections/Chunk/operations/forEach";
import * as tsplus_module_50 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_51 from "@effect/core/io/Effect/operations/whenEffect";
import * as tsplus_module_52 from "@effect/core/io/Effect/operations/withFiberRuntime";
import * as tsplus_module_53 from "@tsplus/stdlib/collections/Chunk/operations/concat";
import * as tsplus_module_54 from "@tsplus/stdlib/collections/Chunk/operations/filter";
import * as tsplus_module_55 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_56 from "@tsplus/stdlib/collections/Chunk/operations/drop";
import * as tsplus_module_57 from "@tsplus/stdlib/collections/Chunk/operations/prepend";
import * as tsplus_module_58 from "@effect/core/io/Effect/operations/fiberId";
export const forEach = forEach_1;
export const forEachDiscard = forEachDiscard_1;
export const forEachPar = forEachPar_1;
export const forEachParDiscard = forEachParDiscard_1;
export const collectAll = collectAll_1;
export const collectAllPar = collectAllPar_1;
export const collectAllWith = collectAllWith_1;
export const collectAllWithPar = collectAllWithPar_1;
export const collectAllWithEffect = collectAllWithEffect_1;
import { _In, _Out, QueueSym } from "@effect/core/io/Queue/definition";
import { unsafeCompleteDeferred } from "@effect/core/io/Queue/operations/_internal/unsafeCompleteDeferred";
import { unsafeCompleteTakers } from "@effect/core/io/Queue/operations/_internal/unsafeCompleteTakers";
import { unsafeOfferAll } from "@effect/core/io/Queue/operations/_internal/unsafeOfferAll";
import { unsafePollAll } from "@effect/core/io/Queue/operations/_internal/unsafePollAll";
import { unsafePollN } from "@effect/core/io/Queue/operations/_internal/unsafePollN";
import { unsafeRemove } from "@effect/core/io/Queue/operations/_internal/unsafeRemove";
import { Exited } from "@effect/core/io/Scope/ReleaseMap/_internal/State";
import { ArrTypeId, concreteChunk, SingletonTypeId } from "@tsplus/stdlib/collections/Chunk"; // -----------------------------------------------------------------------------
// forEach
// -----------------------------------------------------------------------------

/**
 * Applies the function `f` to each element of the `Collection<A>` and returns
 * the results in a new `Chunk<B>`.
 *
 * For a parallel version of this method, see `forEachPar`. If you do not need
 * the results, see `forEachDiscard` for a more efficient implementation.
 *
 * @tsplus static effect/core/io/Effect.Ops forEach
 */

function forEach_1(as, f) {
  return tsplus_module_3.suspendSucceed(() => {
    const acc = [];
    return tsplus_module_2.map(() => tsplus_module_1.from(acc))(forEachDiscard_1(as, a => tsplus_module_2.map(b => {
      acc.push(b);
    })(f(a))));
  });
} // -----------------------------------------------------------------------------
// forEachWithIndex
// -----------------------------------------------------------------------------

/**
 * Same as `forEach`, except that the function `f` is supplied
 * a second argument that corresponds to the index (starting from 0)
 * of the current element being iterated over.
 *
 * @tsplus static effect/core/io/Effect.Ops forEachWithIndex
 */


export function forEachWithIndex(as, f) {
  return tsplus_module_3.suspendSucceed(() => {
    let index = 0;
    const acc = [];
    return tsplus_module_2.map(() => tsplus_module_1.from(acc))(forEachDiscard_1(as, a => tsplus_module_2.map(b => {
      acc.push(b);
      index++;
    })(f(a, index))));
  });
} // -----------------------------------------------------------------------------
// forEachDiscard
// -----------------------------------------------------------------------------

/**
 * Applies the function `f` to each element of the `Collection<A>` and runs
 * produced effects sequentially.
 *
 * Equivalent to `unit(forEach(as, f))`, but without the cost of building
 * the list of results.
 *
 * @tsplus static effect/core/io/Effect.Ops forEachDiscard
 */

function forEachDiscard_1(as, f) {
  return tsplus_module_3.suspendSucceed(() => forEachDiscardLoop(as[Symbol.iterator](), f));
}

function forEachDiscardLoop(iterator, f) {
  const next = iterator.next();
  return next.done ? tsplus_module_4.unit : tsplus_module_5.flatMap(() => forEachDiscardLoop(iterator, f))(f(next.value));
} // -----------------------------------------------------------------------------
// forEachPar
// -----------------------------------------------------------------------------

/**
 * Applies the function `f` to each element of the `Collection<A>` in parallel,
 * and returns the results in a new `Chunk<B>`.
 *
 * For a sequential version of this method, see `forEach`.
 *
 * @tsplus static effect/core/io/Effect.Ops forEachPar
 */


function forEachPar_1(as, f) {
  return tsplus_module_7.parallelismWith(option => tsplus_module_6.fold(() => forEachParUnbounded(as, f), n => forEachParN(as, n, f))(option));
}
/**
 * Applies the function `f` to each element of the `Collection<A>` in parallel,
 * and returns the results in a new `Chunk<B>`.
 */


function forEachParUnbounded(as, f) {
  return tsplus_module_3.suspendSucceed(() => tsplus_module_5.flatMap(array => tsplus_module_2.map(() => tsplus_module_1.from(array))(forEachParUnboundedDiscard(tsplus_module_8.map((a, n) => [a, n])(as), ([a, n]) => tsplus_module_5.flatMap(b => tsplus_module_9.sync(() => {
    array[n] = b;
  }))(tsplus_module_3.suspendSucceed(() => f(a))))))(tsplus_module_10.succeed([])));
}

function forEachParN(as, n, f) {
  return tsplus_module_3.suspendSucceed(() => {
    if (n < 1) {
      return tsplus_module_11.dieMessage(`Unexpected nonpositive value "${n}" passed to foreachParN`);
    }

    const as0 = tsplus_module_1.from(as);
    const size = tsplus_module_12.size(as0);

    if (size === 0) {
      return tsplus_module_10.succeed(tsplus_module_13.empty());
    }

    function worker(queue, array) {
      return tsplus_module_5.flatMap(_ => tsplus_module_6.fold(() => tsplus_module_4.unit, ([a, n]) => tsplus_module_5.flatMap(() => worker(queue, array))(tsplus_module_14.tap(b => tsplus_module_9.sync(() => {
        array[n] = b;
      }))(f(a))))(_))(tsplus_module_2.map(_ => tsplus_module_15.head(_))(queue.takeUpTo(1)));
    }

    return tsplus_module_5.flatMap(array => tsplus_module_5.flatMap(queue => tsplus_module_5.flatMap(() => tsplus_module_2.map(() => tsplus_module_1.from(array))(forEachParUnboundedDiscard(tsplus_module_16.replicate(n)(worker(queue, array)), tsplus_module_17.identity)))(queue.offerAll(tsplus_module_18.zipWithIndex(as0))))(makeBoundedQueue(size)))(tsplus_module_9.sync(() => new Array(size)));
  });
} // -----------------------------------------------------------------------------
// forEachParWithIndex
// -----------------------------------------------------------------------------

/**
 * Same as `forEachPar`, except that the function `f` is supplied
 * a second argument that corresponds to the index (starting from 0)
 * of the current element being iterated over.
 *
 * @tsplus static effect/core/io/Effect.Ops forEachParWithIndex
 */


export function forEachParWithIndex(as, f) {
  return tsplus_module_3.suspendSucceed(() => tsplus_module_5.flatMap(array => tsplus_module_2.map(() => tsplus_module_1.from(array))(forEachParDiscard_1(tsplus_module_8.map((a, n) => [a, n])(as), ([a, n]) => tsplus_module_5.flatMap(b => tsplus_module_9.sync(() => {
    array[n] = b;
  }))(tsplus_module_3.suspendSucceed(() => f(a, n))))))(tsplus_module_9.sync(() => [])));
} // -----------------------------------------------------------------------------
// forEachParDiscard
// -----------------------------------------------------------------------------

/**
 * Applies the function `f` to each element of the `Collection<A>` and runs
 * produced effects in parallel, discarding the results.
 *
 * For a sequential version of this method, see `forEachDiscard`.
 *
 * Optimized to avoid keeping full tree of effects, so that method could be
 * able to handle large input sequences. Additionally, interrupts all effects
 * on any failure.
 *
 * @tsplus static effect/core/io/Effect.Ops forEachParDiscard
 */

function forEachParDiscard_1(as, f) {
  return tsplus_module_7.parallelismWith(option => tsplus_module_6.fold(() => forEachParUnboundedDiscard(as, f), n => forEachParNDiscard(as, n, f))(option));
}

function forEachParUnboundedDiscard(as, f) {
  return tsplus_module_3.suspendSucceed(() => {
    const bs = tsplus_module_1.from(as);
    const size = tsplus_module_12.size(bs);

    if (size === 0) {
      return tsplus_module_4.unit;
    }

    return tsplus_module_20.uninterruptibleMask(({
      restore
    }) => {
      const deferred = tsplus_module_20.unsafeMakeDeferred(tsplus_module_19.none);
      const ref = new tsplus_module_21.AtomicNumber(0);
      return tsplus_module_5.flatMap(fibers => tsplus_module_27.foldCauseEffect(cause => tsplus_module_5.flatMap(exits => {
        const collected = tsplus_module_22.collectAllPar(exits);

        if (collected._tag === "Some" && collected.value._tag === "Failure") {
          return tsplus_module_25.failCause(tsplus_module_24.combinePar(tsplus_module_23.stripFailures(cause), collected.value.cause));
        }

        return tsplus_module_25.failCause(tsplus_module_23.stripFailures(cause));
      })(forEachParUnbounded(fibers, fiber => tsplus_module_26.interrupt(fiber))), _ => forEachDiscard_1(fibers, fiber => fiber.inheritAll))(restore(deferred.await)))(tsplus_module_29.transplant(graft => forEach_1(bs, a => tsplus_module_20.forkDaemon(graft(tsplus_module_27.foldCauseEffect(cause => tsplus_module_28.zipRight(tsplus_module_25.failCause(cause))(deferred.fail(undefined)), () => {
        if (ref.incrementAndGet() === size) {
          deferred.unsafeDone(tsplus_module_4.unit);
          return tsplus_module_4.unit;
        } else {
          return tsplus_module_4.unit;
        }
      })(restore(tsplus_module_3.suspendSucceed(() => f(a)))))))));
    });
  });
}

function forEachParNDiscard(as, n, f) {
  return tsplus_module_3.suspendSucceed(() => {
    const bs = tsplus_module_1.from(as);
    const size = tsplus_module_12.size(bs);

    if (size === 0) {
      return tsplus_module_4.unit;
    }

    function worker(queue) {
      return tsplus_module_5.flatMap(option => tsplus_module_6.fold(() => tsplus_module_4.unit, a => tsplus_module_5.flatMap(() => worker(queue))(f(a)))(option))(tsplus_module_2.map(chunk => tsplus_module_15.head(chunk))(queue.takeUpTo(1)));
    }

    return tsplus_module_5.flatMap(queue => tsplus_module_5.flatMap(() => forEachParUnboundedDiscard(tsplus_module_16.replicate(n)(worker(queue)), tsplus_module_17.identity))(queue.offerAll(as)))(makeBoundedQueue(size));
  });
} // -----------------------------------------------------------------------------
// forEachExec
// -----------------------------------------------------------------------------

/**
 * Applies the function `f` to each element of the `Collection<A>` and returns
 * the result in a new `Chunk<B>` using the specified execution strategy.
 *
 * @tsplus static effect/core/io/Effect.Ops forEachExec
 */


export function forEachExec(as, f, strategy) {
  return tsplus_module_3.suspendSucceed(() => {
    switch (strategy._tag) {
      case "Parallel":
        {
          return tsplus_module_7.withParallelismUnbounded(forEachPar_1(as, f));
        }

      case "ParallelN":
        {
          return tsplus_module_7.withParallelism(strategy.n)(forEachPar_1(as, f));
        }

      case "Sequential":
        {
          return forEach_1(as, f);
        }
    }
  });
} // -----------------------------------------------------------------------------
// collectAll
// -----------------------------------------------------------------------------

/**
 * Evaluate each effect in the structure from left to right, and collect the
 * results. For a parallel version, see `collectAllPar`.
 *
 * @tsplus static effect/core/io/Effect.Ops collectAll
 */

function collectAll_1(as) {
  return forEach_1(as, tsplus_module_17.identity);
} // -----------------------------------------------------------------------------
// collectAllPar
// -----------------------------------------------------------------------------

/**
 * Evaluate each effect in the structure in parallel, and collect the
 * results. For a sequential version, see `collectAll`.
 *
 * @tsplus static effect/core/io/Effect.Ops collectAllPar
 */


function collectAllPar_1(as) {
  return forEachPar_1(as, tsplus_module_17.identity);
} // -----------------------------------------------------------------------------
// collectAllDiscard
// -----------------------------------------------------------------------------

/**
 * Evaluate each effect in the structure from left to right, and discard the
 * results. For a parallel version, see `collectAllParDiscard`.
 *
 * @tsplus static effect/core/io/Effect.Ops collectAllDiscard
 */


export function collectAllDiscard(as) {
  return forEachDiscard_1(as, tsplus_module_17.identity);
} // -----------------------------------------------------------------------------
// collectAllParDiscard
// -----------------------------------------------------------------------------

/**
 * Evaluate each effect in the structure in parallel, and discard the
 * results. For a sequential version, see `collectAllDiscard`.
 *
 * @tsplus static effect/core/io/Effect.Ops collectAllParDiscard
 */

export function collectAllParDiscard(as) {
  return forEachParDiscard_1(as, tsplus_module_17.identity);
} // -----------------------------------------------------------------------------
// collectAllWith
// -----------------------------------------------------------------------------

/**
 * Evaluate each effect in the structure with `collectAll`, and collect
 * the results with given partial function.
 *
 * @tsplus static effect/core/io/Effect.Ops collectAllWith
 */

function collectAllWith_1(as, pf) {
  return tsplus_module_2.map(chunk => tsplus_module_30.collect(pf)(chunk))(collectAll_1(as));
} // -----------------------------------------------------------------------------
// collectAllWithPar
// -----------------------------------------------------------------------------

/**
 * Evaluate each effect in the structure with `collectAll`, and collect
 * the results with given partial function.
 *
 * @tsplus static effect/core/io/Effect.Ops collectAllWithPar
 */


function collectAllWithPar_1(as, pf) {
  return tsplus_module_2.map(chunk => tsplus_module_30.collect(pf)(chunk))(collectAllPar_1(as));
} // -----------------------------------------------------------------------------
// collectAllWithEffect
// -----------------------------------------------------------------------------

/**
 * Returns a filtered, mapped subset of the elements of this chunk based on a
 * partial function.
 *
 * @tsplus static effect/core/io/Effect.Ops collectAllWithEffect
 */


function collectAllWithEffect_1(self, f) {
  const chunk = tsplus_module_1.from(self);
  void 0;

  switch (chunk._typeId) {
    case SingletonTypeId:
      {
        return tsplus_module_6.fold(() => tsplus_module_10.succeed(tsplus_module_13.empty()), b => tsplus_module_2.map(tsplus_module_31.single)(b))(f(chunk.a));
      }

    case ArrTypeId:
      {
        const array = chunk._arrayLike();

        let dest = tsplus_module_10.succeed(tsplus_module_13.empty());

        for (let i = 0; i < array.length; i++) {
          const rhs = f(array[i]);

          if (tsplus_module_32.isSome(rhs)) {
            dest = tsplus_module_34.zipWith(rhs.value, (a, b) => tsplus_module_33.append(b)(a))(dest);
          }
        }

        return dest;
      }

    default:
      {
        return collectAllWithEffect_1(chunk._materialize(), f);
      }
  }
} // -----------------------------------------------------------------------------
// collectAllSuccesses
// -----------------------------------------------------------------------------

/**
 * Evaluate and run each effect in the structure and collect discarding failed ones.
 *
 * @tsplus static effect/core/io/Effect.Ops collectAllSuccesses
 */


export function collectAllSuccesses(as) {
  return collectAllWith_1(tsplus_module_8.map(effect => tsplus_module_35.exit(effect))(as), exit => exit._tag === "Success" ? tsplus_module_32.some(exit.value) : tsplus_module_32.none);
} // -----------------------------------------------------------------------------
// collectAllSuccessesPar
// -----------------------------------------------------------------------------

/**
 * Evaluate and run each effect in the structure in parallel, and collect discarding failed ones.
 *
 * @tsplus static effect/core/io/Effect.Ops collectAllSuccessesPar
 */

export function collectAllSuccessesPar(as) {
  return collectAllWithPar_1(tsplus_module_8.map(effect => tsplus_module_35.exit(effect))(as), exit => exit._tag === "Success" ? tsplus_module_32.some(exit.value) : tsplus_module_32.none);
} // -----------------------------------------------------------------------------
// Fiber
// -----------------------------------------------------------------------------

/**
 * Joins all fibers, awaiting their _successful_ completion.
 * Attempting to join a fiber that has erred will result in
 * a catchable error, _if_ that error does not result from interruption.
 */

export function fiberJoinAll(as) {
  return tsplus_module_14.tap(() => forEach_1(as, fiber => tsplus_module_36.inheritAll(fiber)))(tsplus_module_37.flatten(fiberWaitAll(as)));
}
/**
 * Awaits on all fibers to be completed, successfully or not.
 */

export function fiberWaitAll(as) {
  return tsplus_module_35.exit(forEachPar_1(as, fiber => tsplus_module_37.flatten(tsplus_module_38._await(fiber))));
} // -----------------------------------------------------------------------------
// ReleaseMap
// -----------------------------------------------------------------------------

/**
 * Releases all the finalizers in the releaseMap according to the ExecutionStrategy.
 */

export function releaseMapReleaseAll(self, ex, execStrategy) {
  return tsplus_module_37.flatten(self.ref.modify(s => {
    switch (s._tag) {
      case "Exited":
        {
          return [tsplus_module_4.unit, s];
        }

      case "Running":
        {
          switch (execStrategy._tag) {
            case "Sequential":
              {
                return [tsplus_module_5.flatMap(results => tsplus_module_41.getOrElse_(tsplus_module_40.collectAll(results), () => tsplus_module_39.unit))(forEach_1(Array.from(s.finalizers()).reverse(), ([_, f]) => tsplus_module_35.exit(s.update(f)(ex)))), new Exited(s.nextKey, ex, s.update)];
              }

            case "Parallel":
              {
                return [tsplus_module_5.flatMap(results => tsplus_module_41.getOrElse_(tsplus_module_22.collectAllPar(results), () => tsplus_module_39.unit))(forEachPar_1(Array.from(s.finalizers()).reverse(), ([_, f]) => tsplus_module_35.exit(s.update(f)(ex)))), new Exited(s.nextKey, ex, s.update)];
              }

            case "ParallelN":
              {
                return [tsplus_module_7.withParallelism(execStrategy.n)(tsplus_module_5.flatMap(results => tsplus_module_41.getOrElse_(tsplus_module_22.collectAllPar(results), () => tsplus_module_39.unit))(forEachPar_1(Array.from(s.finalizers()).reverse(), ([_, f]) => tsplus_module_35.exit(s.update(f)(ex))))), new Exited(s.nextKey, ex, s.update)];
              }
          }
        }
    }
  }));
} // -----------------------------------------------------------------------------
// ReleaseMap
// -----------------------------------------------------------------------------

export function makeBoundedQueue(requestedCapacity) {
  return tsplus_module_5.flatMap(queue => createQueue(queue, new BackPressureStrategy()))(tsplus_module_9.sync(() => tsplus_module_42.bounded(requestedCapacity)));
}
export function createQueue(queue, strategy) {
  return tsplus_module_2.map(deferred => unsafeCreateQueue(queue, tsplus_module_43.unbounded(), deferred, new tsplus_module_44.AtomicBoolean(false), strategy))(tsplus_module_45.make());
}

class QueueImpl {
  get [_In]() {
    return a => a;
  }

  get [QueueSym]() {
    return QueueSym;
  }

  get [_Out]() {
    return a => a;
  }

  constructor(queue, takers, shutdownHook, shutdownFlag, strategy) {
    this.queue = queue;
    this.takers = takers;
    this.shutdownHook = shutdownHook;
    this.shutdownFlag = shutdownFlag;
    this.strategy = strategy;
  }

  offer(a) {
    return tsplus_module_3.suspendSucceed(() => {
      if (this.shutdownFlag.get) {
        return tsplus_module_20.interrupt;
      }

      let noRemaining;

      if (this.queue.isEmpty) {
        const taker = this.takers.poll(tsplus_module_46.EmptyMutableQueue);

        if (taker !== tsplus_module_46.EmptyMutableQueue) {
          unsafeCompleteDeferred(taker, a);
          noRemaining = true;
        } else {
          noRemaining = false;
        }
      } else {
        noRemaining = false;
      }

      if (noRemaining) {
        return tsplus_module_10.succeed(true);
      } // Not enough takers, offer to the queue


      const succeeded = this.queue.offer(a);
      unsafeCompleteTakers(this.strategy, this.queue, this.takers);
      return succeeded ? tsplus_module_10.succeed(true) : this.strategy.handleSurplus(tsplus_module_31.single(a), this.queue, this.takers, this.shutdownFlag);
    });
  }

  offerAll(as) {
    return tsplus_module_3.suspendSucceed(() => {
      if (this.shutdownFlag.get) {
        return tsplus_module_20.interrupt;
      }

      const as0 = tsplus_module_1.from(as);
      const pTakers = this.queue.isEmpty ? unsafePollN(this.takers, tsplus_module_12.size(as0)) : tsplus_module_13.empty();
      const [forTakers, remaining] = tsplus_module_47.splitAt(tsplus_module_12.size(pTakers))(as0);
      tsplus_module_49.forEach(([taker, item]) => {
        unsafeCompleteDeferred(taker, item);
      })(tsplus_module_48.zip(forTakers)(pTakers));

      if (tsplus_module_50.isEmpty(remaining)) {
        return tsplus_module_10.succeed(true);
      } // Not enough takers, offer to the queue


      const surplus = unsafeOfferAll(this.queue, remaining);
      unsafeCompleteTakers(this.strategy, this.queue, this.takers);
      return tsplus_module_50.isEmpty(surplus) ? tsplus_module_10.succeed(true) : this.strategy.handleSurplus(surplus, this.queue, this.takers, this.shutdownFlag);
    });
  }

  get capacity() {
    return this.queue.capacity;
  }

  get size() {
    return tsplus_module_3.suspendSucceed(() => this.shutdownFlag.get ? tsplus_module_20.interrupt : tsplus_module_10.succeed(this.queue.size - this.takers.size + this.strategy.surplusSize));
  }

  get awaitShutdown() {
    return this.shutdownHook.await;
  }

  get isShutdown() {
    return tsplus_module_9.sync(() => this.shutdownFlag.get);
  }

  get shutdown() {
    return tsplus_module_20.uninterruptible(tsplus_module_52.withFiberRuntime(state => {
      this.shutdownFlag.set(true);
      return tsplus_module_4.asUnit(tsplus_module_51.whenEffect(this.shutdownHook.succeed(undefined), tsplus_module_28.zipRight(this.strategy.shutdown)(forEachParDiscard_1(unsafePollAll(this.takers), deferred => deferred.interruptAs(state.id)))));
    }));
  }

  get isFull() {
    return tsplus_module_2.map(size => size === this.capacity)(this.size);
  }

  get isEmpty() {
    return tsplus_module_2.map(size => size === 0)(this.size);
  }

  get take() {
    return tsplus_module_52.withFiberRuntime(state => {
      if (this.shutdownFlag.get) {
        return tsplus_module_20.interrupt;
      }

      const item = this.queue.poll(tsplus_module_46.EmptyMutableQueue);

      if (item !== tsplus_module_46.EmptyMutableQueue) {
        this.strategy.unsafeOnQueueEmptySpace(this.queue, this.takers);
        return tsplus_module_10.succeed(item);
      } else {
        // Add the deferred to takers, then:
        // - Try to take again in case a value was added since
        // - Wait for the deferred to be completed
        // - Clean up resources in case of interruption
        const deferred = tsplus_module_20.unsafeMakeDeferred(state.id);
        return tsplus_module_20.onInterrupt(() => {
          return tsplus_module_9.sync(() => unsafeRemove(this.takers, deferred));
        })(tsplus_module_3.suspendSucceed(() => {
          this.takers.offer(deferred);
          unsafeCompleteTakers(this.strategy, this.queue, this.takers);
          return this.shutdownFlag.get ? tsplus_module_20.interrupt : deferred.await;
        }));
      }
    });
  }

  get takeAll() {
    return tsplus_module_3.suspendSucceed(() => this.shutdownFlag.get ? tsplus_module_20.interrupt : tsplus_module_9.sync(() => {
      const as = unsafePollAll(this.queue);
      this.strategy.unsafeOnQueueEmptySpace(this.queue, this.takers);
      return as;
    }));
  }

  takeUpTo(max) {
    return tsplus_module_3.suspendSucceed(() => this.shutdownFlag.get ? tsplus_module_20.interrupt : tsplus_module_9.sync(() => {
      const as = unsafePollN(this.queue, max);
      this.strategy.unsafeOnQueueEmptySpace(this.queue, this.takers);
      return as;
    }));
  }

  takeRemainderLoop(self, min, max, acc) {
    if (max < min) {
      return tsplus_module_10.succeed(acc);
    }

    return tsplus_module_5.flatMap(bs => {
      const remaining = min - bs.length;

      if (remaining === 1) {
        return tsplus_module_2.map(b => tsplus_module_33.append(b)(tsplus_module_53.concat(bs)(acc)))(self.take);
      }

      if (remaining > 1) {
        return tsplus_module_5.flatMap(b => this.takeRemainderLoop(self, remaining - 1, max - bs.length - 1, tsplus_module_33.append(b)(tsplus_module_53.concat(bs)(acc))))(self.take);
      }

      return tsplus_module_10.succeed(tsplus_module_53.concat(bs)(acc));
    })(self.takeUpTo(max));
  }

  takeBetween(min, max) {
    return tsplus_module_3.suspendSucceed(() => this.takeRemainderLoop(this, min, max, tsplus_module_13.empty()));
  }

  takeN(n) {
    return this.takeBetween(n, n);
  }

  get poll() {
    return tsplus_module_2.map(chunk => tsplus_module_15.head(chunk))(this.takeUpTo(1));
  }

}

export function unsafeCreateQueue(queue, takers, shutdownHook, shutdownFlag, strategy) {
  return new QueueImpl(queue, takers, shutdownHook, shutdownFlag, strategy);
}
export function makeBackPressureStrategy() {
  return new BackPressureStrategy();
}
export class BackPressureStrategy {
  constructor() {
    /**
     * - `A` is an item to add
     * - `Deferred<never, boolean>` is the deferred completing the whole `offerAll`
     * - `boolean` indicates if it's the last item to offer (deferred should be
     *    completed once this item is added)
     */
    this.putters = tsplus_module_43.unbounded();
  }

  handleSurplus(as, queue, takers, isShutdown) {
    return tsplus_module_52.withFiberRuntime(state => {
      const deferred = tsplus_module_20.unsafeMakeDeferred(state.id);
      return tsplus_module_20.onInterrupt(() => tsplus_module_9.sync(() => this.unsafeRemove(deferred)))(tsplus_module_3.suspendSucceed(() => {
        this.unsafeOffer(as, deferred);
        this.unsafeOnQueueEmptySpace(queue, takers);
        unsafeCompleteTakers(this, queue, takers);
        return isShutdown.get ? tsplus_module_20.interrupt : deferred.await;
      }));
    });
  }

  unsafeRemove(deferred) {
    unsafeOfferAll(this.putters, tsplus_module_54.filter(([, _]) => _ !== deferred)(unsafePollAll(this.putters)));
  }

  unsafeOffer(as, deferred) {
    let bs = as;

    while (tsplus_module_12.size(bs) > 0) {
      const head = tsplus_module_55.unsafeGet(0)(bs);
      bs = tsplus_module_56.drop(1)(bs);

      if (tsplus_module_12.size(bs) === 0) {
        this.putters.offer([head, deferred, true]);
      } else {
        this.putters.offer([head, deferred, false]);
      }
    }
  }

  unsafeOnQueueEmptySpace(queue, takers) {
    let keepPolling = true;

    while (keepPolling && !queue.isFull) {
      const putter = this.putters.poll(tsplus_module_46.EmptyMutableQueue);

      if (putter !== tsplus_module_46.EmptyMutableQueue) {
        const offered = queue.offer(putter[0]);

        if (offered && putter[2]) {
          unsafeCompleteDeferred(putter[1], true);
        } else if (!offered) {
          unsafeOfferAll(this.putters, tsplus_module_57.prepend(putter)(unsafePollAll(this.putters)));
        }

        unsafeCompleteTakers(this, queue, takers);
      } else {
        keepPolling = false;
      }
    }
  }

  get surplusSize() {
    return this.putters.size;
  }

  get shutdown() {
    return tsplus_module_5.flatMap(fiberId => tsplus_module_5.flatMap(putters => tsplus_module_2.map(() => void 0)(forEachPar_1(putters, ([_, promise, lastItem]) => lastItem ? promise.interruptAs(fiberId) : tsplus_module_4.unit)))(tsplus_module_9.sync(() => unsafePollAll(this.putters))))(tsplus_module_58.fiberId);
  }

}
//# sourceMappingURL=excl-forEach.mjs.map