import * as tsplus_module_1 from "@effect/core/io/Effect/operations/suspendSucceed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Determines whether any element of the `Collection<A>` satisfies the effectual
 * predicate `f`, working sequentially.
 *
 * @tsplus static effect/core/io/Effect.Ops exists
 */

export function exists(as, f) {
  return tsplus_module_1.suspendSucceed(() => loop(as[Symbol.iterator](), f));
}

function loop(iterator, f) {
  const next = iterator.next();

  if (next.done) {
    return tsplus_module_2.succeed(false);
  }

  return tsplus_module_3.flatMap(b => b ? tsplus_module_2.succeed(b) : tsplus_module_1.suspendSucceed(() => loop(iterator, f)))(f(next.value));
}
//# sourceMappingURL=exists.mjs.map