import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/ifEffect";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/excl-forEach";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/foldEffect";

const _found = /*#__PURE__*/Symbol("found");
/**
 * Determines whether any element of the `Collection<A>` satisfies the effectual
 * predicate `f`, working in parallel. Interrupts all effects on any failure or
 * finding an element that satisfies the predicate.
 *
 * @tsplus static effect/core/io/Effect.Ops existsPar
 */


export function existsPar(as, f) {
  return tsplus_module_6.foldEffect(e => e === _found ? tsplus_module_1.succeed(true) : tsplus_module_2.fail(e), () => tsplus_module_1.succeed(false))(tsplus_module_5.forEachPar(as, a => tsplus_module_4.ifEffect(f(a), tsplus_module_2.fail(_found), tsplus_module_3.unit)));
}
//# sourceMappingURL=existsPar.mjs.map