import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/suspendSucceed";
import { concreteChunkId } from "@tsplus/stdlib/collections/Chunk";
/**
 * Returns the first element that satisfies the effectful predicate.
 *
 * @tsplus static effect/core/io/Effect.Ops find
 */

export function find(self, f) {
  return tsplus_module_5.suspendSucceed(() => {
    const chunk = tsplus_module_1.from(self);

    const iterator = chunk._arrayLikeIterator();

    let next;

    const loop = (iterator, array, i, length) => {
      if (i < length) {
        const a = array[i];
        return tsplus_module_4.flatMap(r => r ? tsplus_module_3.succeed(tsplus_module_2.some(a)) : loop(iterator, array, i + 1, length))(f(a));
      } else if (!(next = iterator.next()).done) {
        return loop(iterator, next.value, 0, next.value.length);
      } else {
        return tsplus_module_3.succeed(tsplus_module_2.none);
      }
    };

    next = iterator.next();

    if (!next.done) {
      return loop(iterator, next.value, 0, next.value.length);
    } else {
      return tsplus_module_3.succeed(tsplus_module_2.none);
    }
  });
}
//# sourceMappingURL=find.mjs.map