import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_2 from "@effect/core/io/Cause/errors";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/dieSync";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/unsafeHead";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/Chunk/operations/unsafeTail";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/orElse";
import * as tsplus_module_8 from "@tsplus/stdlib/collections/Chunk/operations/reduce";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/suspendSucceed";
/**
 * Returns an effect that runs this effect and in case of failure, runs each
 * of the specified effects in order until one of them succeeds.
 *
 * @tsplus static effect/core/io/Effect.Ops firstSuccessOf
 */

export function firstSuccessOf(effects) {
  return tsplus_module_9.suspendSucceed(() => {
    const chunk = tsplus_module_1.from(effects);

    if (chunk.length <= 0) {
      return tsplus_module_3.dieSync(() => new tsplus_module_2.IllegalArgumentException(`received empty collection of effects`));
    }

    const head = tsplus_module_4.unsafeHead(chunk);
    const tail = chunk.length === 1 ? tsplus_module_5.empty() : tsplus_module_6.unsafeTail(chunk);
    return tsplus_module_8.reduce(head, (b, a) => tsplus_module_7.orElse(() => a)(b))(tail);
  });
}
//# sourceMappingURL=firstSuccessOf.mjs.map