import { IOnSuccess } from "@effect/core/io/Effect/definition/primitives";
/**
 * Returns an effect that models the execution of this effect, followed by the
 * passing of its value to the specified continuation function `k`, followed
 * by the effect that it returns.
 *
 * @tsplus static effect/core/io/Effect.Aspects flatMap
 * @tsplus pipeable effect/core/io/Effect flatMap
 */

export function flatMap(f) {
  return self => new IOnSuccess(self, f);
}
//# sourceMappingURL=flatMap.mjs.map