import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/foldEffect";
/**
 * Folds over the failure value or the success value to yield an effect that
 * does not fail, but succeeds with the value returned by the left or right
 * function passed to `fold`.
 *
 * @tsplus static effect/core/io/Effect.Aspects fold
 * @tsplus pipeable effect/core/io/Effect fold
 */

export function fold(failure, success) {
  return self => tsplus_module_2.foldEffect(e => tsplus_module_1.succeed(failure(e)), a => tsplus_module_1.succeed(success(a)))(self);
}
//# sourceMappingURL=fold.mjs.map