import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/foldCauseEffect";
/**
 * A more powerful version of `fold` that allows recovering from any kind of
 * failure except interruptions.
 *
 * @tsplus static effect/core/io/Effect.Aspects foldCause
 * @tsplus pipeable effect/core/io/Effect foldCause
 */

export function foldCause(failure, success) {
  return self => tsplus_module_2.foldCauseEffect(c => tsplus_module_1.succeed(failure(c)), a => tsplus_module_1.succeed(success(a)))(self);
}
//# sourceMappingURL=foldCause.mjs.map