import * as tsplus_module_1 from "@effect/core/io/Effect/operations/suspendSucceed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Determines whether all elements of the `Collection<A>` satisfies the effectual
 * predicate `f`.
 *
 * @tsplus static effect/core/io/Effect.Ops forAll
 */

export function forAll(as, f) {
  return tsplus_module_1.suspendSucceed(() => loop(as[Symbol.iterator](), f));
}

function loop(iterator, f) {
  const next = iterator.next();
  return next.done ? tsplus_module_2.succeed(true) : tsplus_module_3.flatMap(b => b ? tsplus_module_1.suspendSucceed(() => loop(iterator, f)) : tsplus_module_2.succeed(b))(f(next.value));
}
//# sourceMappingURL=forAll.mjs.map