import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeedNone";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/foldCauseEffect";
/**
 * Returns a new effect that will pass the success value of this effect to the
 * provided callback. If this effect fails, then the failure will be ignored.
 *
 * @tsplus static effect/core/io/Effect.Aspects forEachEffect
 * @tsplus pipeable effect/core/io/Effect forEachEffect
 */

export function forEachEffect(f) {
  return self => tsplus_module_4.foldCauseEffect(() => tsplus_module_1.succeedNone, a => tsplus_module_3.map(tsplus_module_2.some)(f(a)))(self);
}
//# sourceMappingURL=forEachEffect.mjs.map