import * as tsplus_module_1 from "@effect/core/io/Fiber/operations/interrupt";
import * as tsplus_module_2 from "@effect/core/io/Scope/operations/addFinalizer";
import * as tsplus_module_3 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/tap";
/**
 * Forks the effect in the specified scope. The fiber will be interrupted
 * when the scope is closed.
 *
 * @tsplus static effect/core/io/Effect.Aspects forkIn
 * @tsplus pipeable effect/core/io/Effect forkIn
 */

export function forkIn(scope) {
  return self => tsplus_module_3.uninterruptibleMask(({
    restore
  }) => tsplus_module_4.tap(fiber => tsplus_module_2.addFinalizer(tsplus_module_1.interrupt(fiber))(scope))(tsplus_module_3.forkDaemon(restore(self))));
}
//# sourceMappingURL=forkIn.mjs.map