import * as tsplus_module_1 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_3 from "@effect/core/io/Fiber/operations/interrupt";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/fiberIdWith";
import * as tsplus_module_5 from "@effect/core/io/Scope/operations/addFinalizer";
import * as tsplus_module_6 from "@effect/core/io/Scope/operations/close";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/onExit";
import * as tsplus_module_8 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/tap";
import * as tsplus_module_10 from "@effect/core/io/Scope/operations/fork";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_12 from "@effect/core/io/Effect/operations/scopeWith";
/**
 * Forks the fiber in a `Scope`, interrupting it when the scope is closed.
 *
 * @tsplus getter effect/core/io/Effect forkScoped
 */

export function forkScoped(self) {
  return tsplus_module_8.uninterruptibleMask(({
    restore
  }) => tsplus_module_12.scopeWith(scope => tsplus_module_11.flatMap(child => tsplus_module_9.tap(fiber => tsplus_module_5.addFinalizer(tsplus_module_4.fiberIdWith(fiberId => tsplus_module_1.equals(fiberId, fiber.id) ? tsplus_module_2.unit : tsplus_module_3.interrupt(fiber)))(child))(tsplus_module_8.forkDaemon(tsplus_module_7.onExit(e => tsplus_module_6.close(e)(child))(restore(self)))))(tsplus_module_10.fork(scope))));
}
//# sourceMappingURL=forkScoped.mjs.map