import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Maybe/fold";
/**
 * Lifts an `Maybe` into an `Effect` but preserves the error as an option in
 * the error channel, making it easier to compose in some scenarios.
 *
 * @tsplus static effect/core/io/Effect.Ops fromMaybe
 */

export function fromMaybe(option) {
  return tsplus_module_4.fold(() => tsplus_module_2.fail(tsplus_module_1.none), tsplus_module_3.succeed)(option);
}
//# sourceMappingURL=fromMaybe.mjs.map