import * as tsplus_module_1 from "@effect/core/io/Effect/operations/failSync";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/fold";
/**
 * Lifts an `Maybe` into an `Effect`. If the option is not defined, fail with
 * the specified `e` value.
 *
 * @tsplus static effect/core/io/Effect.Ops getOrFailWith
 */

export function getOrFailWith(option, e) {
  return tsplus_module_3.fold(() => tsplus_module_1.failSync(e), tsplus_module_2.succeed)(option);
}
//# sourceMappingURL=getOrFailWith.mjs.map