import * as tsplus_module_1 from "@effect/core/io/Effect/operations/logging";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/foldCause";
/**
 * Returns a new effect that ignores the success or failure of this effect,
 * but which also logs failures at the Debug level, just in case the failure
 * turns out to be important.
 *
 * @tsplus getter effect/core/io/Effect ignoreLogged
 */

export function ignoreLogged(self) {
  return tsplus_module_3.foldCause(cause => tsplus_module_1.logDebugCauseMessage("An error was silently ignored because it is not anticipated to be useful", cause), () => tsplus_module_2.unit)(self);
}
//# sourceMappingURL=ignoreLogged.mjs.map