import * as tsplus_module_1 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/suspendSucceed";
export const iterate = iterate_1;
/**
 * Iterates with the specified effectual function. The moral equivalent of:
 *
 * ```typescript
 * let s = initial
 *
 * while (cont(s)) {
 *   s = body(s)
 * }
 *
 * return s
 * ```
 *
 * @tsplus static effect/core/io/Effect.Ops iterate
 */

function iterate_1(initial, cont) {
  return body => tsplus_module_3.suspendSucceed(() => {
    if (cont(initial)) {
      return tsplus_module_1.flatMap(z2 => iterate_1(z2, cont)(body))(body(initial));
    }

    return tsplus_module_2.succeed(initial);
  });
}
//# sourceMappingURL=iterate.mjs.map