import * as tsplus_module_1 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/suspendSucceed";
export const loopDiscard = loopDiscard_1;
/**
 * Loops with the specified effectual function purely for its effects. The
 * moral equivalent of:
 *
 * ```typescript
 * var s = initial
 *
 * while (cont(s)) {
 *   body(s)
 *   s = inc(s)
 * }
 * ```
 *
 * @tsplus static effect/core/io/Effect.Ops loopDiscard
 */

function loopDiscard_1(initial, cont, inc) {
  return body => {
    return tsplus_module_3.suspendSucceed(() => {
      return cont(initial) ? tsplus_module_1.zipRight(loopDiscard_1(inc(initial), cont, inc)(body))(body(initial)) : tsplus_module_2.unit;
    });
  };
}
//# sourceMappingURL=loopDiscard.mjs.map