import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/append";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/suspendSucceed";
import { concreteChunkId } from "@tsplus/stdlib/collections/Chunk";
/**
 * Statefully and effectfully maps over the elements of this chunk to produce
 * new elements.
 *
 * @tsplus static effect/core/io/Effect.Ops mapAccum
 */

export function mapAccum(self, s, f) {
  return tsplus_module_7.suspendSucceed(() => {
    const chunk = tsplus_module_1.from(self);

    const iterator = chunk._arrayLikeIterator();

    let dest = tsplus_module_2.succeed(s);
    let builder = tsplus_module_3.empty();
    let next;

    while ((next = iterator.next()) && !next.done) {
      const array = next.value;
      const length = array.length;
      let i = 0;

      while (i < length) {
        const a = array[i];
        dest = tsplus_module_6.flatMap(state => tsplus_module_5.map(([s, b]) => {
          builder = tsplus_module_4.append(b)(builder);
          return s;
        })(f(state, a)))(dest);
        i++;
      }
    }

    return tsplus_module_5.map(s => [s, builder])(dest);
  });
}
//# sourceMappingURL=mapAccum.mjs.map