import * as tsplus_module_1 from "@effect/core/io/Effect/operations/failSync";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/foldEffect";
/**
 * Returns an effect whose failure and success channels have been mapped by
 * the specified pair of functions, `f` and `g`.
 *
 * @tsplus static effect/core/io/Effect.Aspects mapBoth
 * @tsplus pipeable effect/core/io/Effect mapBoth
 */

export function mapBoth(f, g) {
  return self => tsplus_module_3.foldEffect(e => tsplus_module_1.failSync(() => f(e)), a => tsplus_module_2.sync(() => g(a)))(self);
}
//# sourceMappingURL=mapBoth.mjs.map