import * as tsplus_module_1 from "@effect/core/io/Effect/operations/failSync";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_3 from "@effect/core/io/Cause/operations/failureOrCause";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/foldCauseEffect";
/**
 * Returns an effect with its error channel mapped using the specified
 * function. This can be used to lift a "smaller" error into a "larger" error.
 *
 * @tsplus static effect/core/io/Effect.Aspects mapError
 * @tsplus pipeable effect/core/io/Effect mapError
 */

export function mapError(f) {
  return self => tsplus_module_6.foldCauseEffect(cause => tsplus_module_4.fold(e => tsplus_module_1.failSync(() => f(e)), tsplus_module_2.failCause)(tsplus_module_3.failureOrCause(cause)), tsplus_module_5.succeed)(self);
}
//# sourceMappingURL=mapError.mjs.map