import * as tsplus_module_1 from "@effect/core/io/Effect/operations/failCauseSync";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/foldCauseEffect";
/**
 * Returns an effect with its full cause of failure mapped using the specified
 * function. This can be used to transform errors while preserving the
 * original structure of `Cause`.
 *
 * See `absorb`, `sandbox`, `catchAllCause` for other functions for dealing
 * with defects.
 *
 * @tsplus static effect/core/io/Effect.Aspects mapErrorCause
 * @tsplus pipeable effect/core/io/Effect mapErrorCause
 */

export function mapErrorCause(f) {
  return self => tsplus_module_3.foldCauseEffect(c => tsplus_module_1.failCauseSync(() => f(c)), tsplus_module_2.succeed)(self);
}
//# sourceMappingURL=mapErrorCause.mjs.map