import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/fromNullable";
import * as tsplus_module_2 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_3 from "@effect/core/io/Deferred/operations/make";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/tap";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_7 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_9 from "@effect/core/io/Ref/operations/make";
/**
 * Returns a memoized version of the specified effectual function.
 *
 * @tsplus static effect/core/io/Effect.Ops memoize
 */

export function memoizeF(f) {
  return tsplus_module_5.map(ref => a => tsplus_module_8.flatMap(deferred => deferred.await)(ref.modifyEffect(map => {
    const result = tsplus_module_1.fromNullable(map.get(a));
    return tsplus_module_7.fold(() => tsplus_module_5.map(deferred => [deferred, map.set(a, deferred)])(tsplus_module_4.tap(deferred => tsplus_module_2.fork(tsplus_module_2.intoDeferred(deferred)(f(a))))(tsplus_module_3.make())), deferred => tsplus_module_6.succeed([deferred, map]))(result);
  })))(tsplus_module_9.makeSynchronized(() => new Map()));
}
//# sourceMappingURL=memoizeF.mjs.map