import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/zipWith";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Collection/functions";
/**
 * Merges an `Collection<Effect<R, E, A>>` to a single `Effect<R, E, B>`, working
 * sequentially.
 *
 * @tsplus static effect/core/io/Effect.Ops mergeAll
 */

export function mergeAll(as, zero, f) {
  return tsplus_module_3.reduce(tsplus_module_1.succeed(zero), (acc, a) => tsplus_module_2.zipWith(a, f)(acc))(as);
}
//# sourceMappingURL=mergeAll.mjs.map