import * as tsplus_module_1 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/excl-forEach";
import * as tsplus_module_3 from "@effect/core/io/Ref/operations/make";
/**
 * Merges an `Collection<Effect<R, E, A>>` to a single `Effect<R, E, A>`, working
 * in parallel.
 *
 * Due to the parallel nature of this combinator, `f` must be both:
 * - commutative: `f(a, b) == f(b, a)`
 * - associative: `f(a, f(b, c)) == f(f(a, b), c)`
 *
 * It's unsafe to execute side effects inside `f`, as `f` may be executed
 * more than once for some of `in` elements during effect execution.
 *
 * @tsplus static effect/core/io/Effect.Ops mergeAllPar
 */

export function mergeAllPar(as, zero, f) {
  return tsplus_module_1.flatMap(acc => tsplus_module_1.flatMap(() => acc.get)(tsplus_module_2.forEachParDiscard(as, effect => tsplus_module_1.flatMap(a => acc.update(b => f(b, a)))(effect))))(tsplus_module_3.makeRef(() => zero));
}
//# sourceMappingURL=mergeAllPar.mjs.map