import * as tsplus_module_1 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_3 from "@effect/core/io/Fiber/_internal/runtime"; // `setTimeout` is limited to take delays which are 32-bit values

const MAX_SET_TIMEOUT_VALUE = 2 ** 31 - 1;
/**
 * Returns a effect that will never produce anything. The moral equivalent of
 * `while(true) {}`, only without the wasted CPU cycles.
 *
 * @tsplus static effect/core/io/Effect.Ops never
 */

export const never = /*#__PURE__*/tsplus_module_3.asyncInterrupt(() => {
  const interval = setInterval(() => {//
  }, MAX_SET_TIMEOUT_VALUE);
  return tsplus_module_2.left(tsplus_module_1.sync(() => clearInterval(interval)));
});
//# sourceMappingURL=never.mjs.map