import * as tsplus_module_1 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_2 from "@effect/core/io/Fiber/_internal/runtime";
/**
 * Ensures that a cleanup functions runs, whether this effect succeeds, fails,
 * or is interrupted.
 *
 * @tsplus static effect/core/io/Effect.Aspects onExit
 * @tsplus pipeable effect/core/io/Effect onExit
 */

export function onExit(cleanup) {
  return self => tsplus_module_2.acquireUseReleaseExit(tsplus_module_1.unit, () => self, (_, exit) => cleanup(exit));
}
//# sourceMappingURL=onExit.mjs.map