import * as tsplus_module_1 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_2 from "@effect/core/io/Cause/operations/failureOrCause";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_4 from "@effect/core/io/Fiber/_internal/runtime";
/**
 * Runs the specified effect if this effect is terminated, either because of a
 * defect or because of interruption.
 *
 * @tsplus static effect/core/io/Effect.Aspects onTermination
 * @tsplus pipeable effect/core/io/Effect onTermination
 */

export function onTermination(cleanup) {
  return self => tsplus_module_4.acquireUseReleaseExit(tsplus_module_1.unit, () => self, (_, exit) => exit._tag === "Failure" ? tsplus_module_3.fold(() => tsplus_module_1.unit, cleanup)(tsplus_module_2.failureOrCause(exit.cause)) : tsplus_module_1.unit);
}
//# sourceMappingURL=onTermination.mjs.map