import * as tsplus_module_1 from "@effect/core/io/Effect/operations/die";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/foldEffect";
/**
 * Keeps none of the errors, and terminates the fiber with them, using the
 * specified function to convert the `E` into a `Throwable`.
 *
 * @tsplus static effect/core/io/Effect.Aspects orDieWith
 * @tsplus pipeable effect/core/io/Effect orDieWith
 */

export function orDieWith(f) {
  return self => tsplus_module_3.foldEffect(e => tsplus_module_1.die(f(e)), tsplus_module_2.succeed)(self);
}
//# sourceMappingURL=orDieWith.mjs.map