import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/tryOrElse";
/**
 * Returns an effect that will produce the value of this effect, unless it
 * fails, in which case, it will produce the value of the specified effect.
 *
 * @tsplus static effect/core/io/Effect.Aspects orElseEither
 * @tsplus pipeable effect/core/io/Effect orElseEither
 */

export function orElseEither(that) {
  return self => tsplus_module_4.tryOrElse(() => tsplus_module_2.map(tsplus_module_1.right)(that()), a => tsplus_module_3.succeed(tsplus_module_1.left(a)))(self);
}
//# sourceMappingURL=orElseEither.mjs.map