import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/catchAll";
/**
 * Returns an effect that will produce the value of this effect, unless it
 * fails with the `None` value, in which case it will produce the value of
 * the specified effect.
 *
 * @tsplus static effect/core/io/Effect.Aspects orElseOptional
 * @tsplus pipeable effect/core/io/Effect orElseOptional
 */

export function orElseOptional(that) {
  return self => tsplus_module_4.catchAll(option => tsplus_module_3.fold(that, e => tsplus_module_2.fail(tsplus_module_1.some(e)))(option))(self);
}
//# sourceMappingURL=orElseOptional.mjs.map