import * as tsplus_module_1 from "@effect/core/io/Cause/operations/failures";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/foldCauseEffect";
/**
 * Exposes all parallel errors in a single call.
 *
 * @tsplus getter effect/core/io/Effect parallelErrors
 */

export function parallelErrors(self) {
  return tsplus_module_6.foldCauseEffect(cause => {
    const errors = tsplus_module_2.from(tsplus_module_1.failures(cause));
    return errors.length === 0 ? tsplus_module_3.failCause(cause) : tsplus_module_4.fail(errors);
  }, tsplus_module_5.succeed)(self);
}
//# sourceMappingURL=parallelErrors.mjs.map