import * as tsplus_module_1 from "@tsplus/stdlib/data/Function";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/either";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/excl-forEach";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/map";
import { partitionMap } from "@effect/core/io/Effect/operations/_internal/partitionMap";
/**
 * Feeds elements of type `A` to a function `f` that returns an effect.
 * Collects all successes and failures in a tupled fashion.
 *
 * @tsplus static effect/core/io/Effect.Ops partition
 */

export function partition(as, f) {
  return tsplus_module_4.map(chunk => partitionMap(chunk, tsplus_module_1.identity))(tsplus_module_3.forEach(as, a => tsplus_module_2.either(f(a))));
}
//# sourceMappingURL=partition.mjs.map