import * as tsplus_module_1 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/environmentWithEffect";
/**
 * Provides the effect with the single service it requires. If the effect
 * requires more than one service use `provideEnvironment` instead.
 *
 * @tsplus static effect/core/io/Effect.Aspects provideServiceEffect
 * @tsplus pipeable effect/core/io/Effect provideServiceEffect
 */

export function provideServiceEffect(tag, effect) {
  return self => tsplus_module_3.environmentWithEffect(env => tsplus_module_2.flatMap(service => tsplus_module_1.provideEnvironment(env.add(tag, service))(self))(effect));
}
//# sourceMappingURL=provideServiceEffect.mjs.map