import * as tsplus_module_1 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_2 from "@effect/core/io/Fiber/operations/interrupt";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/zipLeft";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/reduce";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_7 from "@effect/core/io/Fiber/operations/inheritAll";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_10 from "@tsplus/stdlib/collections/Chunk/operations/prepend";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/excl-forEach";
import * as tsplus_module_12 from "@tsplus/stdlib/collections/Chunk/operations/size";
import * as tsplus_module_13 from "@effect/core/io/Ref/operations/make";
import * as tsplus_module_14 from "@effect/core/io/Deferred/operations/make";
import * as tsplus_module_15 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_16 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_17 from "@effect/core/io/Effect/operations/flatten";
import * as tsplus_module_18 from "@effect/core/io/Exit/operations/foldEffect";
/**
 * Returns an effect that races this effect with all the specified effects,
 * yielding the value of the first effect to succeed with a value. Losers of
 * the race will be interrupted immediately
 *
 * @tsplus static effect/core/io/Effect.Aspects raceAll
 * @tsplus pipeable effect/core/io/Effect raceAll
 */

export function raceAll(effects) {
  return self => tsplus_module_5.flatMap(ios => tsplus_module_5.flatMap(done => tsplus_module_5.flatMap(fails => tsplus_module_6.uninterruptibleMask(({
    restore
  }) => tsplus_module_5.flatMap(head => tsplus_module_5.flatMap(tail => {
    const fs = tsplus_module_10.prepend(head)(tail);
    return tsplus_module_5.flatMap(() => {
      const inheritAll = res => tsplus_module_8.as(res[0])(tsplus_module_7.inheritAll(res[1]));

      return tsplus_module_6.onInterrupt(() => tsplus_module_4.reduce(tsplus_module_1.unit, (io, fiber) => tsplus_module_3.zipLeft(tsplus_module_2.interrupt(fiber))(io))(fs))(restore(tsplus_module_5.flatMap(inheritAll)(done.await)));
    })(tsplus_module_4.reduce(tsplus_module_1.unit, (io, fiber) => tsplus_module_9.zipRight(tsplus_module_6.fork(tsplus_module_5.flatMap(arbiter(fs, fiber, done, fails))(fiber.await)))(io))(fs));
  })(tsplus_module_11.forEach(ios, io => tsplus_module_6.fork(tsplus_module_6.interruptible(io)))))(tsplus_module_6.fork(tsplus_module_6.interruptible(self)))))(tsplus_module_13.makeRef(() => tsplus_module_12.size(ios))))(tsplus_module_14.make()))(tsplus_module_16.sync(() => tsplus_module_15.from(effects)));
}

function arbiter(fibers, winner, promise, fails) {
  return exit => {
    return tsplus_module_18.foldEffect(e => tsplus_module_17.flatten(fails.modify(c => [c === 0 ? tsplus_module_1.asUnit(promise.failCause(() => e)) : tsplus_module_1.unit, c - 1])), a => tsplus_module_5.flatMap(set => set ? tsplus_module_4.reduce(tsplus_module_1.unit, (io, fiber) => fiber === winner ? io : tsplus_module_3.zipLeft(tsplus_module_2.interrupt(fiber))(io))(fibers) : tsplus_module_1.unit)(promise.succeed([a, winner])))(exit);
  };
}
//# sourceMappingURL=raceAll.mjs.map