import * as tsplus_module_1 from "@effect/core/io/Fiber/operations/inheritAll";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_3 from "@effect/core/io/Fiber/operations/await";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/raceFibersWith";
/**
 * Returns an effect that races this effect with the specified effect, calling
 * the specified finisher as soon as one result or the other has been computed.
 *
 * @tsplus static effect/core/io/Effect.Aspects raceWith
 * @tsplus pipeable effect/core/io/Effect raceWith
 */

export function raceWith(that, leftDone, rightDone) {
  return self => tsplus_module_4.raceFibersWith(that, (winner, loser) => tsplus_module_2.flatMap(exit => {
    switch (exit._tag) {
      case "Success":
        {
          return tsplus_module_2.flatMap(() => leftDone(exit, loser))(tsplus_module_1.inheritAll(winner));
        }

      case "Failure":
        {
          return leftDone(exit, loser);
        }
    }
  })(tsplus_module_3._await(winner)), (winner, loser) => tsplus_module_2.flatMap(exit => {
    switch (exit._tag) {
      case "Success":
        {
          return tsplus_module_2.flatMap(() => rightDone(exit, loser))(tsplus_module_1.inheritAll(winner));
        }

      case "Failure":
        {
          return rightDone(exit, loser);
        }
    }
  })(tsplus_module_3._await(winner)))(self);
}
//# sourceMappingURL=raceWith.mjs.map