import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Collection/functions";
/**
 * Folds an `Collection<A>` using an effectual function f, working sequentially from left to right.
 *
 * @tsplus static effect/core/io/Effect.Ops reduce
 */

export function reduce(as, z, f) {
  return tsplus_module_3.reduce(tsplus_module_1.succeed(z), (acc, el) => tsplus_module_2.flatMap(a => f(a, el))(acc))(as);
}
//# sourceMappingURL=reduce.mjs.map