import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/reduceRight";
/**
 * Folds an `Collection<A>` using an effectual function f, working sequentially from left to right.
 *
 * @tsplus static effect/core/io/Effect.Ops reduceRight
 */

export function reduceRight_(as, z, f) {
  return tsplus_module_4.reduceRight(tsplus_module_1.succeed(z), (el, acc) => tsplus_module_2.flatMap(a => f(el, a))(acc))(tsplus_module_3.from(as));
}
//# sourceMappingURL=reduceRight.mjs.map