import * as tsplus_module_1 from "@effect/core/io/Effect/operations/die";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/catchAll";
/**
 * Keeps some of the errors, and terminates the fiber with the rest, using
 * the specified function to convert the `E` into a `Throwable`.
 *
 * @tsplus static effect/core/io/Effect.Aspects refineOrDieWith
 * @tsplus pipeable effect/core/io/Effect refineOrDieWith
 */

export function refineOrDieWith(pf, f) {
  return self => tsplus_module_4.catchAll(e => tsplus_module_3.fold(() => tsplus_module_1.die(f(e)), e1 => tsplus_module_2.fail(e1))(pf(e)))(self);
}
//# sourceMappingURL=refineOrDieWith.mjs.map