import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Maybe/fold";
/**
 * Continue with the returned computation if the `PartialFunction` matches,
 * translating the successful match into a failure, otherwise continue with
 * our held value.
 *
 * @tsplus static effect/core/io/Effect.Aspects rejectEffect
 * @tsplus pipeable effect/core/io/Effect rejectEffect
 */

export function rejectEffect(pf) {
  return self => tsplus_module_3.flatMap(a => tsplus_module_4.fold(() => tsplus_module_1.succeed(a), effect => tsplus_module_3.flatMap(tsplus_module_2.fail)(effect))(pf(a)))(self);
}
//# sourceMappingURL=rejectEffect.mjs.map