import * as tsplus_module_1 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/repeatOrElse";
/**
 * Returns a new effect that repeats this effect according to the specified
 * schedule or until the first failure. Scheduled recurrences are in addition
 * to the first execution, so that `io.repeat(Schedule.once)` yields an effect
 * that executes `io`, and then if that succeeds, executes `io` an additional
 * time.
 *
 * @tsplus static effect/core/io/Effect.Aspects repeat
 * @tsplus pipeable effect/core/io/Effect repeat
 */

export function repeat(schedule) {
  return self => tsplus_module_2.repeatOrElse(schedule, (e, _) => tsplus_module_1.fail(e))(self);
}
//# sourceMappingURL=repeat.mjs.map