import * as tsplus_module_1 from "@effect/core/io/Effect/operations/suspendSucceed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/yieldNow";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Returns a new effect that repeats this effect the specified number of times
 * or until the first failure. Repeats are in addition to the first execution,
 * so that `io.repeatN(1)` yields an effect that executes `io`, and then if
 * that succeeds, executes `io` an additional time.
 *
 * @tsplus static effect/core/io/Effect.Aspects repeatN
 * @tsplus pipeable effect/core/io/Effect repeatN
 */

export function repeatN(n) {
  return self => tsplus_module_1.suspendSucceed(() => loop(self, n));
}

function loop(self, n) {
  return tsplus_module_5.flatMap(a => n <= 0 ? tsplus_module_2.succeed(a) : tsplus_module_4.zipRight(loop(self, n - 1))(tsplus_module_3.yieldNow))(self);
}
//# sourceMappingURL=repeatN.mjs.map