import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/merge";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/repeatOrElseEither";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/map";
/**
 * Returns a new effect that repeats this effect according to the specified
 * schedule or until the first failure, at which point, the failure value and
 * schedule output are passed to the specified handler.
 *
 * Scheduled recurrences are in addition to the first execution, so that
 * `io.repeat(Schedule.once)` yields an effect that executes `io`, and then if
 * that succeeds, executes `io` an additional time.
 *
 * @tsplus static effect/core/io/Effect.Aspects repeatOrElse
 * @tsplus pipeable effect/core/io/Effect repeatOrElse
 */

export function repeatOrElse(schedule, orElse) {
  return self => tsplus_module_3.map(either => tsplus_module_1.merge(either))(tsplus_module_2.repeatOrElseEither(schedule, orElse)(self));
}
//# sourceMappingURL=repeatOrElse.mjs.map