import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/foldEffect";
import * as tsplus_module_5 from "@effect/core/io/Schedule/operations/driver";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/orDie";
/**
 * Returns a new effect that repeats this effect according to the specified
 * schedule or until the first failure, at which point, the failure value and
 * schedule output are passed to the specified handler.
 *
 * Scheduled recurrences are in addition to the first execution, so that
 * `io.repeat(Schedule.once)` yields an effect that executes `io`, and then if
 * that succeeds, executes `io` an additional time.
 *
 * @tsplus static effect/core/io/Effect.Aspects repeatOrElseEither
 * @tsplus pipeable effect/core/io/Effect repeatOrElseEither
 */

export function repeatOrElseEither(schedule, orElse) {
  return self => tsplus_module_6.flatMap(driver => tsplus_module_4.foldEffect(e => tsplus_module_3.map(tsplus_module_1.left)(orElse(e, tsplus_module_2.none)), a => repeatOrElseEitherLoop(self, driver, orElse, a))(self))(tsplus_module_5.driver(schedule));
}

function repeatOrElseEitherLoop(self, driver, orElse, value) {
  return tsplus_module_4.foldEffect(() => tsplus_module_3.map(tsplus_module_1.right)(tsplus_module_7.orDie(driver.last)), b => tsplus_module_4.foldEffect(e => tsplus_module_3.map(tsplus_module_1.left)(orElse(e, tsplus_module_2.some(b))), a => repeatOrElseEitherLoop(self, driver, orElse, a))(self))(driver.next(value));
}
//# sourceMappingURL=repeatOrElseEither.mjs.map