import * as tsplus_module_1 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/retryOrElse";
/**
 * Retries with the specified retry policy. Retries are done following the
 * failure of the original `io` (up to a fixed maximum with `once` or `recurs`
 * for example), so that that `io.retry(Schedule.once)` means "execute `io`
 * and in case of failure, try again once".
 *
 * @tsplus static effect/core/io/Effect.Aspects retry
 * @tsplus pipeable effect/core/io/Effect retry
 */

export function retry(policy) {
  return self => tsplus_module_2.retryOrElse(policy, (e, _) => tsplus_module_1.fail(e))(self);
}
//# sourceMappingURL=retry.mjs.map