import * as tsplus_module_1 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/yieldNow";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/catchAll";
/**
 * Retries this effect the specified number of times.
 *
 * @tsplus static effect/core/io/Effect.Aspects retryN
 * @tsplus pipeable effect/core/io/Effect retryN
 */

export function retryN(n) {
  return self => retryNLoop(self, n);
}

function retryNLoop(self, n) {
  return tsplus_module_4.catchAll(e => n < 0 ? tsplus_module_1.fail(e) : tsplus_module_3.zipRight(retryNLoop(self, n - 1))(tsplus_module_2.yieldNow))(self);
}
//# sourceMappingURL=retryN.mjs.map