import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/merge";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/retryOrElseEither";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/map";
/**
 * Retries with the specified schedule, until it fails, and then both the
 * value produced by the schedule together with the last error are passed to
 * the recovery function.
 *
 * @tsplus static effect/core/io/Effect.Aspects retryOrElse
 * @tsplus pipeable effect/core/io/Effect retryOrElse
 */

export function retryOrElse(policy, orElse) {
  return self => tsplus_module_3.map(either => tsplus_module_1.merge(either))(tsplus_module_2.retryOrElseEither(policy, orElse)(self));
}
//# sourceMappingURL=retryOrElse.mjs.map