import * as tsplus_module_1 from "@effect/core/io/Schedule/operations/driver";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/orDie";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/foldEffect";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/catchAll";
/**
 * Retries with the specified schedule, until it fails, and then both the
 * value produced by the schedule together with the last error are passed to
 * the recovery function.
 *
 * @tsplus static effect/core/io/Effect.Aspects retryOrElseEither
 * @tsplus pipeable effect/core/io/Effect retryOrElseEither
 */

export function retryOrElseEither(policy, orElse) {
  return self => tsplus_module_2.flatMap(driver => retryOrElseEitherLoop(self, driver, orElse))(tsplus_module_1.driver(policy));
}

function retryOrElseEitherLoop(self, driver, orElse) {
  return tsplus_module_7.catchAll(e => tsplus_module_6.foldEffect(() => tsplus_module_2.flatMap(out => tsplus_module_4.map(tsplus_module_3.left)(orElse(e, out)))(tsplus_module_5.orDie(driver.last)), () => retryOrElseEitherLoop(self, driver, orElse))(driver.next(e)))(tsplus_module_4.map(tsplus_module_3.right)(self));
}
//# sourceMappingURL=retryOrElseEither.mjs.map