import * as tsplus_module_1 from "@effect/core/io/Runtime/definition";
import * as tsplus_module_2 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/withFiberRuntime";
import * as tsplus_module_5 from "@effect/core/io/RuntimeFlags/definition";
import * as tsplus_module_6 from "@tsplus/stdlib/service/Env";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/ImmutableMap/empty";
import { FiberRefs } from "@effect/core/io/FiberRefs";
/**
 * Returns an effect that accesses the runtime, which can be used to
 * (unsafely) execute tasks. This is useful for integration with legacy code
 * that must call back into Effect code.
 *
 * @tsplus static effect/core/io/Effect.Ops runtime
 */

export function runtime() {
  return tsplus_module_4.withFiberRuntime((state, status) => tsplus_module_3.succeed(new tsplus_module_1.Runtime(state.getFiberRef(tsplus_module_2.currentEnvironment), status.runtimeFlags, state.getFiberRefs)));
}
export const defaultFlags = /*#__PURE__*/tsplus_module_5.RuntimeFlags(tsplus_module_5.RuntimeFlags.FiberRoots, tsplus_module_5.RuntimeFlags.Interruption, tsplus_module_5.RuntimeFlags.CooperativeYielding);
export const defaultRuntime = /*#__PURE__*/new tsplus_module_1.Runtime(tsplus_module_6.Env.empty, defaultFlags, /*#__PURE__*/new FiberRefs( /*#__PURE__*/tsplus_module_7.empty()));
/**
 * @tsplus fluent effect/core/io/Effect unsafeRunPromise
 * @tsplus static effect/core/io/Effect.Aspects unsafeRunPromise
 */

export const unsafeRunPromise = defaultRuntime.unsafeRunPromise;
/**
 * @tsplus fluent effect/core/io/Effect unsafeRunAsync
 * @tsplus static effect/core/io/Effect.Aspects unsafeRunAsync
 */

export const unsafeRunAsync = defaultRuntime.unsafeRunAsync;
/**
 * @tsplus fluent effect/core/io/Effect unsafeRunAsyncWith
 * @tsplus static effect/core/io/Effect.Aspects unsafeRunAsyncWith
 */

export const unsafeRunAsyncWith = defaultRuntime.unsafeRunAsyncWith;
/**
 * @tsplus fluent effect/core/io/Effect unsafeRunPromiseExit
 * @tsplus static effect/core/io/Effect.Aspects unsafeRunPromiseExit
 */

export const unsafeRunPromiseExit = defaultRuntime.unsafeRunPromiseExit;
/**
 * @tsplus fluent effect/core/io/Effect unsafeRunWith
 * @tsplus static effect/core/io/Effect.Aspects unsafeRunWith
 */

export const unsafeRunWith = defaultRuntime.unsafeRunWith;
/**
 * @tsplus fluent effect/core/io/Effect unsafeRunSync
 * @tsplus static effect/core/io/Effect.Aspects unsafeRunSync
 */

export const unsafeRunSync = defaultRuntime.unsafeRunSync;
/**
 * @tsplus fluent effect/core/io/Effect unsafeRunSyncExit
 * @tsplus static effect/core/io/Effect.Aspects unsafeRunSyncExit
 */

export const unsafeRunSyncExit = defaultRuntime.unsafeRunSyncExit;
//# sourceMappingURL=runtime.mjs.map