import * as tsplus_module_1 from "@effect/core/io/Schedule/operations/driver";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/orDie";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/foldEffect";
/**
 * Runs this effect according to the specified schedule.
 *
 * See `scheduleFrom` for a variant that allows the schedule's decision to
 * depend on the result of this effect.
 *
 * @tsplus static effect/core/io/Effect.Aspects scheduleFrom
 * @tsplus pipeable effect/core/io/Effect scheduleFrom
 */

export function scheduleFrom(a, schedule) {
  return self => tsplus_module_2.flatMap(scheduleFromLoop(self, a))(tsplus_module_1.driver(schedule));
}

function scheduleFromLoop(self, value) {
  return driver => tsplus_module_4.foldEffect(() => tsplus_module_3.orDie(driver.last), () => tsplus_module_2.flatMap(a => scheduleFromLoop(self, a)(driver))(self))(driver.next(value));
}
//# sourceMappingURL=scheduleFrom.mjs.map