import * as tsplus_module_1 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/excl-forEach";
/**
 * Applicative structure.
 *
 * @tsplus static effect/core/io/Effect.Ops struct
 */

export function struct(r) {
  return tsplus_module_1.map(values => {
    const res = {};

    for (const [k, v] of values) {
      res[k] = v;
    }

    return res;
  })(tsplus_module_2.forEach(Object.entries(r), ([_, e]) => tsplus_module_1.map(a => [_, a])(e)));
}
/**
 * Applicative structure processed in parallel.
 *
 * @tsplus static effect/core/io/Effect.Ops structPar
 */

export function structPar(r) {
  return tsplus_module_1.map(values => {
    const res = {};

    for (const [k, v] of values) {
      res[k] = v;
    }

    return res;
  })(tsplus_module_2.forEachPar(Object.entries(r), ([_, e]) => tsplus_module_1.map(a => [_, a])(e)));
}
//# sourceMappingURL=struct.mjs.map