import * as tsplus_module_1 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Summarizes a effect by computing some value before and after execution, and
 * then combining the values to produce a summary, together with the result of
 * execution.
 *
 * @tsplus static effect/core/io/Effect.Aspects summarized
 * @tsplus pipeable effect/core/io/Effect summarized
 */

export function summarized(summary, f) {
  return self => tsplus_module_2.flatMap(start => tsplus_module_2.flatMap(value => tsplus_module_1.map(end => [f(start, end), value])(summary))(self))(summary);
}
//# sourceMappingURL=summarized.mjs.map