import * as tsplus_module_1 from "@tsplus/stdlib/data/Function";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/attempt";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Returns a lazily constructed effect, whose construction may itself require
 * effects. When no environment is required (i.e., when `R == unknown`) it is
 * conceptually equivalent to `flatten(succeed(io))`.
 *
 * @tsplus static effect/core/io/Effect.Ops suspend
 */

export function suspend(f) {
  return tsplus_module_3.flatMap(tsplus_module_1.identity)(tsplus_module_2.attempt(f));
}
//# sourceMappingURL=suspend.mjs.map