import * as tsplus_module_1 from "@tsplus/stdlib/data/Function";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Returns a lazily constructed effect, whose construction may itself require
 * effects. The effect must not throw any exceptions. When no environment is
 * required (i.e., when `R == unknown`) it is conceptually equivalent to
 * `flatten(succeed(effect))`. If you wonder if the effect throws
 * exceptions, do not use this method, use `suspend`.
 *
 * @tsplus static effect/core/io/Effect.Ops suspendSucceed
 */

export function suspendSucceed(effect) {
  return tsplus_module_3.flatMap(tsplus_module_1.identity)(tsplus_module_2.sync(effect));
}
//# sourceMappingURL=suspendSucceed.mjs.map