import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/append";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/suspendSucceed";
import { concreteChunkId } from "@tsplus/stdlib/collections/Chunk";
/**
 * Takes all elements so long as the effectual predicate returns true.
 *
 * @tsplus static effect/core/io/Effect.Ops takeWhile
 */

export function takeWhileEffect(self, f) {
  return tsplus_module_7.suspendSucceed(() => {
    const chunk = tsplus_module_1.from(self);

    const iterator = chunk._arrayLikeIterator();

    let next;
    let taking = tsplus_module_2.succeed(true);
    let builder = tsplus_module_3.empty();

    while ((next = iterator.next()) && !next.done) {
      const array = next.value;
      const len = array.length;
      let i = 0;

      while (i < len) {
        const a = array[i];
        taking = tsplus_module_6.flatMap(d => tsplus_module_5.map(b => {
          if (b) {
            builder = tsplus_module_4.append(a)(builder);
          }

          return b;
        })(d ? f(a) : tsplus_module_2.succeed(false)))(taking);
        i++;
      }
    }

    return tsplus_module_5.map(() => builder)(taking);
  });
}
//# sourceMappingURL=takeWhile.mjs.map