import * as tsplus_module_1 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_3 from "@effect/core/io/Cause/operations/failureOrCause";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/foldCauseEffect";
/**
 * Returns an effect that effectfully "peeks" at the failure or success of
 * this effect.
 *
 * @tsplus static effect/core/io/Effect.Aspects tapBoth
 * @tsplus pipeable effect/core/io/Effect tapBoth
 */

export function tapBoth(f, g) {
  return self => tsplus_module_6.foldCauseEffect(cause => tsplus_module_4.fold(e => tsplus_module_2.zipRight(tsplus_module_1.failCause(cause))(f(e)), () => tsplus_module_1.failCause(cause))(tsplus_module_3.failureOrCause(cause)), a => tsplus_module_5.as(a)(g(a)))(self);
}
//# sourceMappingURL=tapBoth.mjs.map