import * as tsplus_module_1 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_2 from "@effect/core/io/Cause/operations/stripFailures";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/foldCauseEffect";
/**
 * Returns an effect that effectually "peeks" at the defect of this effect.
 *
 * @tsplus static effect/core/io/Effect.Aspects tapDefect
 * @tsplus pipeable effect/core/io/Effect tapDefect
 */

export function tapDefect(f) {
  return self => tsplus_module_5.foldCauseEffect(cause => tsplus_module_3.zipRight(tsplus_module_1.failCause(cause))(f(tsplus_module_2.stripFailures(cause))), tsplus_module_4.succeed)(self);
}
//# sourceMappingURL=tapDefect.mjs.map