import * as tsplus_module_1 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_3 from "@effect/core/io/Cause/operations/failureOrCause";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/foldCauseEffect";
/**
 * Returns an effect that effectfully "peeks" at the failure of this effect.
 *
 * @tsplus static effect/core/io/Effect.Aspects tapError
 * @tsplus pipeable effect/core/io/Effect tapError
 */

export function tapError(f) {
  return self => tsplus_module_6.foldCauseEffect(cause => tsplus_module_4.fold(e => tsplus_module_2.zipRight(tsplus_module_1.failCause(cause))(f(e)), () => tsplus_module_1.failCause(cause))(tsplus_module_3.failureOrCause(cause)), tsplus_module_5.succeed)(self);
}
//# sourceMappingURL=tapError.mjs.map