import * as tsplus_module_1 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/foldCauseEffect";
/**
 * Returns an effect that effectually "peeks" at the cause of the failure of
 * this effect.
 *
 * @tsplus static effect/core/io/Effect.Aspects tapErrorCause
 * @tsplus pipeable effect/core/io/Effect tapErrorCause
 */

export function tapErrorCause(f) {
  return self => tsplus_module_4.foldCauseEffect(cause => tsplus_module_2.zipRight(tsplus_module_1.failCause(cause))(f(cause)), tsplus_module_3.succeed)(self);
}
//# sourceMappingURL=tapErrorCause.mjs.map