import * as tsplus_module_1 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/getOrElse";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/tap";
/**
 * Returns an effect that effectfully "peeks" at the success of this effect.
 * If the partial function isn't defined at the input, the result is
 * equivalent to the original effect.
 *
 * @tsplus static effect/core/io/Effect.Aspects tapSome
 * @tsplus pipeable effect/core/io/Effect tapSome
 */

export function tapSome(pf) {
  return self => tsplus_module_3.tap(a => tsplus_module_2.getOrElse_(pf(a), () => tsplus_module_1.unit))(self);
}
//# sourceMappingURL=tapSome.mjs.map