import * as tsplus_module_1 from "@effect/core/io/Effect/operations/summarized";
import { DurationInternal } from "@tsplus/stdlib/data/Duration";
/**
 * A more powerful variation of `timed` that allows specifying the clock.
 *
 * @tsplus static effect/core/io/Effect.Aspects timedWith
 * @tsplus pipeable effect/core/io/Effect timedWith
 */

export function timedWith(milliseconds) {
  return self => tsplus_module_1.summarized(milliseconds, (start, end) => new DurationInternal(end - start))(self);
}
//# sourceMappingURL=timedWith.mjs.map