import * as tsplus_module_1 from "@effect/core/io/Effect/operations/failSync";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/timeoutTo";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/flatten";
/**
 * The same as `timeout`, but instead of producing a `None` in the event of
 * timeout, it will produce the specified error.
 *
 * @tsplus static effect/core/io/Effect.Aspects timeoutFail
 * @tsplus pipeable effect/core/io/Effect timeoutFail
 */

export function timeoutFail(e, duration) {
  return self => tsplus_module_4.flatten(tsplus_module_3.timeoutTo(tsplus_module_1.failSync(e), tsplus_module_2.succeed, duration)(self));
}
//# sourceMappingURL=timeoutFail.mjs.map