import * as tsplus_module_1 from "@effect/core/io/Effect/operations/failCauseSync";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/timeoutTo";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/flatten";
/**
 * The same as `timeout`, but instead of producing a `None` in the event of
 * timeout, it will produce the specified failure.
 *
 * @tsplus static effect/core/io/Effect.Aspects timeoutFailCause
 * @tsplus pipeable effect/core/io/Effect timeoutFailCause
 */

export function timeoutFailCause(cause, duration) {
  return self => tsplus_module_4.flatten(tsplus_module_3.timeoutTo(tsplus_module_1.failCauseSync(cause), tsplus_module_2.succeed, duration)(self));
}
//# sourceMappingURL=timeoutFailCause.mjs.map