import * as tsplus_module_1 from "@effect/core/io/Effect/operations/sleep";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_3 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/race";
/**
 * Returns an effect that will timeout this effect, returning either the
 * default value if the timeout elapses before the effect has produced a
 * value or returning the result of applying the function `f` to the
 * success value of the effect.
 *
 * If the timeout elapses without producing a value, the running effect will
 * be safely interrupted.
 *
 * @tsplus static effect/core/io/Effect.Aspects timeoutTo
 * @tsplus pipeable effect/core/io/Effect timeoutTo
 */

export function timeoutTo(def, f, duration) {
  return self => tsplus_module_5.raceFirst(tsplus_module_3.interruptible(tsplus_module_2.as(def)(tsplus_module_1.sleep(duration))))(tsplus_module_4.map(f)(self));
}
//# sourceMappingURL=timeoutTo.mjs.map