import * as tsplus_module_1 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/getOrElse";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/withFiberRuntime";
/**
 * Transplants specified effects so that when those effects fork other
 * effects, the forked effects will be governed by the scope of the fiber that
 * executes this effect.
 *
 * This can be used to "graft" deep grandchildren onto a higher-level scope,
 * effectively extending their lifespans into the parent scope.
 *
 * @tsplus static effect/core/io/Effect.Ops transplant
 */

export function transplant(f) {
  return tsplus_module_4.withFiberRuntime(state => {
    const scopeOverride = state.getFiberRef(tsplus_module_1.forkScopeOverride);
    const scope = tsplus_module_2.getOrElse_(scopeOverride, () => state.scope);
    return f(tsplus_module_1.forkScopeOverride.locally(tsplus_module_3.some(scope)));
  });
}
//# sourceMappingURL=transplant.mjs.map