import * as tsplus_module_1 from "@effect/core/io/Effect/definition";
import * as tsplus_module_2 from "@effect/core/io/Cause/definition";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/sync";
/**
 * Imports a synchronous side-effect into a pure value, translating any
 * thrown exceptions into typed failed effects.
 *
 * @tsplus static effect/core/io/Effect.Ops tryCatch
 */

export function tryCatch(attempt, onThrow) {
  return tsplus_module_3.sync(() => {
    try {
      return attempt();
    } catch (error) {
      throw new tsplus_module_1.Effect.Error(tsplus_module_2.fail(onThrow(error)));
    }
  });
}
//# sourceMappingURL=tryCatch.mjs.map