import * as tsplus_module_1 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_2 from "@effect/core/io/Cause/operations/keepDefects";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/foldCauseEffect";
/**
 * Executed `that` in case `self` fails with a `Cause` that doesn't contain
 * defects, executes `success` in case of successes
 *
 * @tsplus static effect/core/io/Effect.Aspects tryOrElse
 * @tsplus pipeable effect/core/io/Effect tryOrElse
 */

export function tryOrElse(that, success) {
  return self => tsplus_module_4.foldCauseEffect(cause => tsplus_module_3.fold(that, tsplus_module_1.failCause)(tsplus_module_2.keepDefects(cause)), success)(self);
}
//# sourceMappingURL=tryOrElse.mjs.map