import * as tsplus_module_1 from "@tsplus/stdlib/collections/Collection/functions";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/excl-forEach";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/map";
/**
 * Like `forEach` + `identity` with a tuple type.
 *
 * @tsplus static effect/core/io/Effect.Ops tuple
 */

export function tuple(...t) {
  return tsplus_module_3.map(c => tsplus_module_1.toArray(c))(tsplus_module_2.collectAll(t));
}
/**
 * Like tuple but parallel, same as `forEachPar` + `identity` with a tuple type.
 *
 * @tsplus static effect/core/io/Effect.Ops tuplePar
 */

export function tuplePar(...t) {
  return tsplus_module_3.map(c => tsplus_module_1.toArray(c))(tsplus_module_2.collectAllPar(t));
}
//# sourceMappingURL=tuple.mjs.map