import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/append";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Constructs a `Chunk` by repeatedly applying the effectual function `f` as
 * long as it returns `Some`.
 *
 * @tsplus static effect/core/io/Effect.Ops unfold
 */

export function unfold(s, f) {
  return unfoldLoop(s, f, tsplus_module_1.empty());
}

function unfoldLoop(s, f, builder) {
  return tsplus_module_5.flatMap(o => {
    if (tsplus_module_2.isSome(o)) {
      return unfoldLoop(o.value[1], f, tsplus_module_3.append(o.value[0])(builder));
    } else {
      return tsplus_module_4.succeed(builder);
    }
  })(f(s));
}
//# sourceMappingURL=unfold.mjs.map