import * as tsplus_module_1 from "@effect/core/io/Cause/operations/map";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_4 from "@effect/core/io/Cause/definition";
import * as tsplus_module_5 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_6 from "@effect/core/io/Cause/operations/find";
import * as tsplus_module_7 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/catchAllCause";
/**
 * Takes some fiber failures and converts them into errors, using the
 * specified function to convert the `E` into an `E1 | E2`.
 *
 * @tsplus static effect/core/io/Effect.Aspects unrefineWith
 * @tsplus pipeable effect/core/io/Effect unrefineWith
 */

export function unrefineWith(pf, f) {
  return self => tsplus_module_8.catchAllCause(cause => tsplus_module_7.fold(() => tsplus_module_2.failCause(tsplus_module_1.map(f)(cause)), tsplus_module_3.fail)(tsplus_module_6.find(c => tsplus_module_4.isDieType(c) ? pf(c.value) : tsplus_module_5.none)(cause)))(self);
}
//# sourceMappingURL=unrefineWith.mjs.map