import * as tsplus_module_1 from "@effect/core/io/Cause/operations/flatten";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/mapErrorCause";
/**
 * The inverse operation `sandbox(effect)`
 *
 * Terminates with exceptions on the `Left` side of the `Either` error, if it
 * exists. Otherwise extracts the contained `Effect< R, E, A>`
 *
 * @tsplus getter effect/core/io/Effect unsandbox
 */

export function unsandbox(self) {
  return tsplus_module_2.mapErrorCause(cause => tsplus_module_1.flatten(cause))(self);
}
//# sourceMappingURL=unsandbox.mjs.map