import * as tsplus_module_1 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/withFiberRuntime";
/**
 * Updates the `FiberRef` values for the fiber running this effect using the
 * specified function.
 *
 * @tsplus static effect/core/io/Effect.Ops updateFiberRefs
 */

export function updateFiberRefs(f) {
  return tsplus_module_2.withFiberRuntime(state => {
    state.setFiberRefs(f(state.id, state.getFiberRefs));
    return tsplus_module_1.unit;
  });
}
//# sourceMappingURL=updateFiberRefs.mjs.map