import * as tsplus_module_1 from "@effect/core/io/Effect/operations/validateWith";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/partition";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Sequentially zips the this result with the specified result. Combines both
 * `Cause<E1>` when both effects fail.
 *
 * @tsplus static effect/core/io/Effect.Aspects validate
 * @tsplus pipeable effect/core/io/Effect validate
 */

export function validateNow(that) {
  return self => tsplus_module_1.validateWith(that, (a, b) => [a, b])(self);
}
/**
 * Feeds elements of type `A` to `f` and accumulates all errors in error
 * channel or successes in success channel.
 *
 * This combinator is lossy meaning that if there are errors all successes
 * will be lost. To retain all information please use `partition`.
 *
 * @tsplus static effect/core/io/Effect.Ops validate
 */

export function validate(as, f) {
  return tsplus_module_7.flatMap(([es, bs]) => tsplus_module_2.isEmpty(es) ? tsplus_module_4.succeed(tsplus_module_3.from(bs)) : tsplus_module_5.fail(es))(tsplus_module_6.partition(as, f));
}
//# sourceMappingURL=validate.mjs.map