import * as tsplus_module_1 from "@effect/core/io/Effect/operations/validateWithPar";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/partitionPar";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Returns an effect that executes both this effect and the specified effect,
 * in parallel. Combines both Cause<E1>` when both effects fail.
 *
 * @tsplus static effect/core/io/Effect.Aspects validatePar
 * @tsplus pipeable effect/core/io/Effect validatePar
 */

export function validateParNow(that) {
  return self => tsplus_module_1.validateWithPar(that, (a, b) => [a, b])(self);
}
/**
 * Feeds elements of type `A` to `f `and accumulates, in parallel, all errors
 * in error channel or successes in success channel.
 *
 * This combinator is lossy meaning that if there are errors all successes
 * will be lost. To retain all information please use [[partitionPar]].
 *
 * @tsplus static effect/core/io/Effect.Ops validatePar
 */

export function validatePar(as, f) {
  return tsplus_module_7.flatMap(([es, bs]) => tsplus_module_2.isEmpty(es) ? tsplus_module_4.succeed(tsplus_module_3.from(bs)) : tsplus_module_5.fail(es))(tsplus_module_6.partitionPar(as, f));
}
//# sourceMappingURL=validatePar.mjs.map