import * as tsplus_module_1 from "@effect/core/io/Effect/operations/exit";
import * as tsplus_module_2 from "@effect/core/io/Cause/definition";
import * as tsplus_module_3 from "@effect/core/io/Exit/operations/zipWith";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/zipWithPar";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/flatten";
/**
 * Returns an effect that executes both this effect and the specified effect,
 * in parallel, combining their results with the specified `f` function. If
 * both sides fail, then the cause will be combined.
 *
 * @tsplus static effect/core/io/Effect.Aspects validateWithPar
 * @tsplus pipeable effect/core/io/Effect validateWithPar
 */

export function validateWithPar(that, f) {
  return self => tsplus_module_5.flatten(tsplus_module_4.zipWithPar(tsplus_module_1.exit(that), (ea, eb) => tsplus_module_3.zipWith(eb, f, (ca, cb) => tsplus_module_2.combinePar(ca, cb))(ea))(tsplus_module_1.exit(self)));
}
//# sourceMappingURL=validateWithPar.mjs.map