import * as tsplus_module_1 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/filter";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/descriptor";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/supervised";
import * as tsplus_module_7 from "@effect/core/io/Supervisor/definition";
/**
 * Locally installs a supervisor and an effect that succeeds with all the
 * children that have been forked in the returned effect.
 *
 * @tsplus static effect/core/io/Effect.Ops withChildren
 */

export function withChildren(get) {
  return tsplus_module_5.flatMap(supervisor => tsplus_module_6.supervised(supervisor)(get(tsplus_module_5.flatMap(children => tsplus_module_4.map(descriptor => // Filter out the fiber id of whoever is calling `withChildren`
  tsplus_module_2.filter(fiber => !tsplus_module_1.equals(fiber.id, descriptor.id))(children))(tsplus_module_3.descriptor))(supervisor.value))))(tsplus_module_7.track);
}
//# sourceMappingURL=withChildren.mjs.map