import * as tsplus_module_1 from "@effect/core/io/Clock/definition";
import * as tsplus_module_2 from "@effect/core/io/DefaultServices/definition";
/**
 * Sets the implementation of the clock service to the specified value and
 * restores it to its original value when the scope is closed.
 *
 * @tsplus static effect/core/io/Effect.Ops withClockScoped
 */

export function withClockScoped(clock) {
  return tsplus_module_2.currentServices.locallyScopedWith(env => env.add(tsplus_module_1.Clock.Tag, clock));
}
//# sourceMappingURL=withClockScoped.mjs.map