import * as tsplus_module_1 from "@effect/core/io/Fiber/_internal/runtime";
/**
 * A more powerful variant of `withFinalizer` that allows the finalizer to
 * depend on the `Exit` value that the scope is closed with.
 *
 * @tsplus static effect/core/io/Effect.Aspects withFinalizerExit
 * @tsplus pipeable effect/core/io/Effect withFinalizerExit
 */

export function withFinalizerExit(finalizer) {
  return self => tsplus_module_1.acquireReleaseExit(self, (_, exit) => finalizer(exit));
}
//# sourceMappingURL=withFinalizerExit.mjs.map