import * as tsplus_module_1 from "@effect/core/io/Effect/operations/raceFibersWith";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/fiberIdWith";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/transplant";
import * as tsplus_module_4 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_5 from "@effect/core/io/Cause/definition";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_7 from "@effect/core/io/Exit/operations/fold";
import * as tsplus_module_8 from "@effect/core/io/Fiber/operations/interruptAs";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_10 from "@effect/core/io/Fiber/operations/inheritAll";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_12 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_13 from "@effect/core/io/Fiber/operations/await";
/**
 * Sequentially zips this effect with the specified effect using the
 * specified combiner function.
 *
 * @tsplus static effect/core/io/Effect.Aspects zipWithPar
 * @tsplus pipeable effect/core/io/Effect zipWithPar
 */

export function zipWithPar(that, f) {
  return self => {
    const g = (b, a) => f(a, b);

    return tsplus_module_4.uninterruptibleMask(mask => tsplus_module_3.transplant(graft => tsplus_module_2.fiberIdWith(fiberId => tsplus_module_1.raceFibersWith(graft(mask.restore(that)), (w, l) => coordinate(fiberId, f, true, w, l), (w, l) => coordinate(fiberId, g, false, w, l))(graft(mask.restore(self))))));
  };
}

function coordinate(fiberId, f, leftWinner, winner, loser) {
  return tsplus_module_9.flatMap(winnerExit => tsplus_module_7.fold(winnerCause => tsplus_module_9.flatMap(loserExit => tsplus_module_7.fold(loserCause => leftWinner ? tsplus_module_6.failCause(tsplus_module_5.combinePar(winnerCause, loserCause)) : tsplus_module_6.failCause(tsplus_module_5.combinePar(loserCause, winnerCause)), () => tsplus_module_6.failCause(winnerCause))(loserExit))(tsplus_module_8.interruptAsNow(fiberId)(loser)), a => tsplus_module_9.flatMap(loserExit => tsplus_module_7.fold(loserCause => tsplus_module_6.failCause(loserCause), b => tsplus_module_11.zipRight(tsplus_module_12.sync(() => f(a, b)))(tsplus_module_11.zipRight(tsplus_module_10.inheritAll(loser))(tsplus_module_10.inheritAll(winner))))(loserExit))(tsplus_module_13._await(loser)))(winnerExit))(tsplus_module_13._await(winner));
}
//# sourceMappingURL=zipWithPar.mjs.map