import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
/**
 * Effectually flat maps over the value type.
 *
 * @tsplus static effect/core/io/Exit.Aspects flatMapEffect
 * @tsplus pipeable effect/core/io/Exit flatMapEffect
 */

export function flatMapEffect(f) {
  return self => {
    switch (self._tag) {
      case "Failure":
        return tsplus_module_1.succeed(self);

      case "Success":
        return f(self.value);
    }
  };
}
//# sourceMappingURL=flatMapEffect.mjs.map