/**
 * Folds over the value or cause.
 *
 * @tsplus static effect/core/io/Exit.Aspects fold
 * @tsplus pipeable effect/core/io/Exit fold
 */
export function fold(failed, completed) {
  return self => {
    switch (self._tag) {
      case "Failure":
        return failed(self.cause);

      case "Success":
        return completed(self.value);
    }
  };
}
//# sourceMappingURL=fold.mjs.map