import * as tsplus_module_1 from "@effect/core/io/Exit/operations/failCause";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/exit";
/**
 * Applies the function `f` to the successful result of the `Exit` and returns
 * the result in a new `Exit`.
 *
 * @tsplus static effect/core/io/Exit.Aspects forEach
 * @tsplus pipeable effect/core/io/Exit forEach
 */

export function forEach(f) {
  return self => {
    switch (self._tag) {
      case "Failure":
        return tsplus_module_2.succeed(tsplus_module_1.failCause(self.cause));

      case "Success":
        return tsplus_module_3.exit(f(self.value));
    }
  };
}
//# sourceMappingURL=forEach.mjs.map