import * as tsplus_module_1 from "@effect/core/io/Exit/operations/succeed";
/**
 * Maps over the value type.
 *
 * @tsplus static effect/core/io/Exit.Aspects map
 * @tsplus pipeable effect/core/io/Exit map
 */

export function map(f) {
  return self => {
    switch (self._tag) {
      case "Failure":
        return self;

      case "Success":
        return tsplus_module_1.succeed(f(self.value));
    }
  };
}
//# sourceMappingURL=map.mjs.map