import * as tsplus_module_1 from "@effect/core/io/Cause/operations/map";
import * as tsplus_module_2 from "@effect/core/io/Exit/operations/failCause";
import * as tsplus_module_3 from "@effect/core/io/Exit/operations/succeed";
/**
 * Maps over both the error and value type.
 *
 * @tsplus static effect/core/io/Exit.Aspects mapBoth
 * @tsplus pipeable effect/core/io/Exit mapBoth
 */

export function mapBoth(onFailure, onSuccess) {
  return self => {
    switch (self._tag) {
      case "Failure":
        return tsplus_module_2.failCause(tsplus_module_1.map(onFailure)(self.cause));

      case "Success":
        return tsplus_module_3.succeed(onSuccess(self.value));
    }
  };
}
//# sourceMappingURL=mapBoth.mjs.map