import * as tsplus_module_1 from "@effect/core/io/Cause/operations/map";
import * as tsplus_module_2 from "@effect/core/io/Exit/operations/failCause";
/**
 * Maps over the error type.
 *
 * @tsplus static effect/core/io/Exit.Aspects mapError
 * @tsplus pipeable effect/core/io/Exit mapError
 */

export function mapError(f) {
  return self => {
    switch (self._tag) {
      case "Failure":
        return tsplus_module_2.failCause(tsplus_module_1.map(f)(self.cause));

      case "Success":
        return self;
    }
  };
}
//# sourceMappingURL=mapError.mjs.map