import * as tsplus_module_1 from "@effect/core/io/Exit/operations/failCause";
/**
 * Maps over the cause type.
 *
 * @tsplus static effect/core/io/Exit.Aspects mapErrorCause
 * @tsplus pipeable effect/core/io/Exit mapErrorCause
 */

export function mapErrorCause(f) {
  return self => {
    switch (self._tag) {
      case "Failure":
        return tsplus_module_1.failCause(f(self.cause));

      case "Success":
        return self;
    }
  };
}
//# sourceMappingURL=mapErrorCause.mjs.map