import * as tsplus_module_1 from "@effect/core/io/Exit/operations/failCause";
import * as tsplus_module_2 from "@effect/core/io/Exit/operations/succeed";
/**
 * Zips this together with the specified result using the combination
 * functions.
 *
 * @tsplus static effect/core/io/Exit.Aspects zipWith
 * @tsplus pipeable effect/core/io/Exit zipWith
 */

export function zipWith(that, f, g) {
  return self => {
    switch (self._tag) {
      case "Failure":
        {
          switch (that._tag) {
            case "Success":
              {
                return self;
              }

            case "Failure":
              {
                return tsplus_module_1.failCause(g(self.cause, that.cause));
              }
          }
        }

      case "Success":
        {
          switch (that._tag) {
            case "Success":
              {
                return tsplus_module_2.succeed(f(self.value, that.value));
              }

            case "Failure":
              {
                return that;
              }
          }
        }
    }
  };
}
//# sourceMappingURL=zipWith.mjs.map