import * as tsplus_module_1 from "@effect/core/io/FiberId/operations/none";
import * as tsplus_module_2 from "@effect/core/io/Fiber/operations/id";
import * as tsplus_module_3 from "@effect/core/io/FiberId/operations/combine";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Collection/functions";
import * as tsplus_module_5 from "@effect/core/io/Fiber/operations/await";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/flatten";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/excl-forEach";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/exit";
import * as tsplus_module_9 from "@tsplus/stdlib/collections/Chunk/operations/flatten";
import * as tsplus_module_10 from "@effect/core/io/Fiber/operations/children";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_12 from "@effect/core/io/Fiber/operations/inheritAll";
import * as tsplus_module_13 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_14 from "@effect/core/io/Exit/operations/succeed";
import * as tsplus_module_15 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_16 from "@tsplus/stdlib/collections/Chunk/operations/prepend";
import * as tsplus_module_17 from "@effect/core/io/Cause/definition";
import * as tsplus_module_18 from "@effect/core/io/Exit/operations/zipWith";
import * as tsplus_module_19 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_20 from "@tsplus/stdlib/collections/Chunk/operations/reduceRight";
import * as tsplus_module_21 from "@effect/core/io/Fiber/operations/poll";
import * as tsplus_module_22 from "@effect/core/io/Fiber/operations/interruptAs";
import { makeSynthetic } from "@effect/core/io/Fiber/definition";
/**
 * Collects all fibers into a single fiber producing an in-order list of the
 * results.
 *
 * @tsplus static effect/core/io/Fiber.Ops collectAll
 */

export function collectAll(fibers) {
  return makeSynthetic({
    id: tsplus_module_4.reduce(tsplus_module_1.none, (id, fiber) => tsplus_module_3.combine(tsplus_module_2.id(fiber))(id))(fibers),
    await: tsplus_module_8.exit(tsplus_module_7.forEachPar(fibers, fiber => tsplus_module_6.flatten(tsplus_module_5._await(fiber)))),
    children: tsplus_module_11.map(_ => tsplus_module_9.flatten(_))(tsplus_module_7.forEachPar(fibers, fiber => tsplus_module_10.children(fiber))),
    inheritAll: tsplus_module_7.forEachDiscard(fibers, fiber => tsplus_module_12.inheritAll(fiber)),
    poll: tsplus_module_11.map(chunk => tsplus_module_20.reduceRight(tsplus_module_15.some(tsplus_module_14.succeed(tsplus_module_13.empty())), (a, b) => tsplus_module_19.fold(() => tsplus_module_15.none, ra => tsplus_module_19.fold(() => tsplus_module_15.none, rb => tsplus_module_15.some(tsplus_module_18.zipWith(rb, (_a, _b) => tsplus_module_16.prepend(_a)(_b), tsplus_module_17.combinePar)(ra)))(b))(a))(chunk))(tsplus_module_7.forEach(fibers, fiber => tsplus_module_21.poll(fiber))),
    interruptAsFork: fiberId => tsplus_module_7.forEachDiscard(fibers, fiber => tsplus_module_22.interruptAsFork(fiberId)(fiber))
  });
}
//# sourceMappingURL=collectAll.mjs.map