import * as tsplus_module_1 from "@effect/core/io/FiberId/operations/none";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_5 from "@tsplus/stdlib/data/Maybe/definition";
import { makeSynthetic } from "@effect/core/io/Fiber/definition";
/**
 * A fiber that is done with the specified `Exit` value.
 *
 * @tsplus static effect/core/io/Fiber.Ops done
 */

export function done(exit) {
  return makeSynthetic({
    id: tsplus_module_1.none,
    await: tsplus_module_2.succeed(exit),
    children: tsplus_module_2.succeed(tsplus_module_3.empty()),
    inheritAll: tsplus_module_4.unit,
    poll: tsplus_module_2.succeed(tsplus_module_5.some(exit)),
    interruptAsFork: () => tsplus_module_4.unit
  });
}
//# sourceMappingURL=done.mjs.map