import * as tsplus_module_1 from "@effect/core/io/Fiber/operations/interruptAs";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/fiberId";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Interrupts the fiber from whichever fiber is calling this method. If the
 * fiber has already exited, the returned effect will resume immediately.
 * Otherwise, the effect will resume when the fiber exits.
 *
 * @tsplus getter effect/core/io/Fiber interrupt
 * @tsplus getter effect/core/io/RuntimeFiber interrupt
 */

export function interrupt(self) {
  return tsplus_module_3.flatMap(fiberId => tsplus_module_1.interruptAsNow(fiberId)(self))(tsplus_module_2.fiberId);
}
//# sourceMappingURL=interrupt.mjs.map