import * as tsplus_module_1 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_2 from "@effect/core/io/Fiber/operations/interruptAs";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/zipLeft";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Collection/functions";
/**
 * Interrupts all fibers as by the specified fiber, awaiting their
 * interruption.
 *
 * @tsplus static effect/core/io/Fiber.Ops interruptAllAs
 */

export function interruptAllAs(fibers, fiberId) {
  return tsplus_module_4.reduce(tsplus_module_1.unit, (io, fiber) => tsplus_module_3.zipLeft(tsplus_module_2.interruptAsNow(fiberId)(fiber))(io))(fibers);
}
//# sourceMappingURL=interruptAllAs.mjs.map