import * as tsplus_module_1 from "@effect/core/io/Fiber/operations/interrupt";
import * as tsplus_module_2 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/unit";
/**
 * Interrupts the fiber from whichever fiber is calling this method. The
 * interruption will happen in a separate daemon fiber, and the returned
 * effect will always resume immediately without waiting.
 *
 * @tsplus getter effect/core/io/Fiber interruptFork
 * @tsplus getter effect/core/io/RuntimeFiber interruptFork
 */

export function interruptFork(self) {
  return tsplus_module_3.asUnit(tsplus_module_2.forkDaemon(tsplus_module_1.interrupt(self)));
}
//# sourceMappingURL=interruptFork.mjs.map