import * as tsplus_module_1 from "@effect/core/io/Fiber/operations/inheritAll";
import * as tsplus_module_2 from "@effect/core/io/Fiber/operations/await";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/flatten";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/zipLeft";
/**
 * Joins the fiber, which suspends the joining fiber until the result of the
 * fiber has been determined. Attempting to join a fiber that has erred will
 * result in a catchable error. Joining an interrupted fiber will result in an
 * "inner interruption" of this fiber, unlike interruption triggered by
 * another fiber, "inner interruption" can be caught and recovered.
 *
 * @tsplus getter effect/core/io/Fiber join
 * @tsplus getter effect/core/io/RuntimeFiber join
 */

export function join(self) {
  return tsplus_module_4.zipLeft(tsplus_module_1.inheritAll(self))(tsplus_module_3.flatten(tsplus_module_2._await(self)));
}
//# sourceMappingURL=join.mjs.map