import * as tsplus_module_1 from "@effect/core/io/Fiber/operations/collectAll";
import * as tsplus_module_2 from "@effect/core/io/Fiber/operations/join";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/unit";
/**
 * Joins all fibers, awaiting their _successful_ completion. Attempting to
 * join a fiber that has erred will result in a catchable error, _if_ that
 * error does not result from interruption.
 *
 * @tsplus static effect/core/io/Fiber.Ops joinAll
 */

export function joinAll(fibers) {
  return tsplus_module_3.asUnit(tsplus_module_2.join(tsplus_module_1.collectAll(fibers)));
}
//# sourceMappingURL=joinAll.mjs.map