import * as tsplus_module_1 from "@effect/core/io/Fiber/operations/id";
import * as tsplus_module_2 from "@effect/core/io/Exit/operations/forEach";
import * as tsplus_module_3 from "@effect/core/io/Fiber/operations/await";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_5 from "@effect/core/io/Fiber/operations/children";
import * as tsplus_module_6 from "@effect/core/io/Fiber/operations/inheritAll";
import * as tsplus_module_7 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_10 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_11 from "@effect/core/io/Fiber/operations/poll";
import * as tsplus_module_12 from "@effect/core/io/Fiber/operations/interruptAs";
import { makeSynthetic } from "@effect/core/io/Fiber/definition";
/**
 * Effectually maps over the value the fiber computes.
 *
 * @tsplus static effect/core/io/Fiber.Aspects mapEffect
 * @tsplus static effect/core/io/RuntimeFiber.Aspects mapEffect
 * @tsplus pipeable effect/core/io/Fiber mapEffect
 * @tsplus pipeable effect/core/io/RuntimeFiber mapEffect
 */

export function mapEffect(f) {
  return self => makeSynthetic({
    id: tsplus_module_1.id(self),
    await: tsplus_module_4.flatMap(_ => tsplus_module_2.forEach(f)(_))(tsplus_module_3._await(self)),
    children: tsplus_module_5.children(self),
    inheritAll: tsplus_module_6.inheritAll(self),
    poll: tsplus_module_4.flatMap(_ => tsplus_module_10.fold(() => tsplus_module_8.succeed(tsplus_module_7.none), exit => tsplus_module_9.map(tsplus_module_7.some)(tsplus_module_2.forEach(f)(exit)))(_))(tsplus_module_11.poll(self)),
    interruptAsFork: id => tsplus_module_12.interruptAsFork(id)(self)
  });
}
//# sourceMappingURL=mapEffect.mjs.map