import * as tsplus_module_1 from "@effect/core/io/Fiber/operations/id";
import * as tsplus_module_2 from "@effect/core/io/FiberId/operations/getOrElse";
import * as tsplus_module_3 from "@effect/core/io/Fiber/operations/await";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/zipWith";
import * as tsplus_module_5 from "@effect/core/io/Fiber/operations/children";
import * as tsplus_module_6 from "@effect/core/io/Fiber/operations/inheritAll";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_8 from "@effect/core/io/Fiber/operations/interruptAs";
import * as tsplus_module_9 from "@effect/core/io/Fiber/operations/poll";
import * as tsplus_module_10 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_11 from "@tsplus/stdlib/data/Maybe/fold";
import { makeSynthetic } from "@effect/core/io/Fiber/definition";
/**
 * Returns a fiber that prefers `this` fiber, but falls back to the `that` one
 * when `this` one fails. Interrupting the returned fiber will interrupt both
 * fibers, sequentially, from left to right.
 *
 * @tsplus pipeable-operator effect/core/io/Fiber |
 * @tsplus pipeable-operator effect/core/io/RuntimeFiber |
 * @tsplus static effect/core/io/Fiber.Aspects orElse
 * @tsplus static effect/core/io/RuntimeFiber.Aspects orElse
 * @tsplus pipeable effect/core/io/Fiber orElse
 * @tsplus pipeable effect/core/io/RuntimeFiber orElse
 */

export function orElse(that) {
  return self => makeSynthetic({
    id: tsplus_module_2.getOrElse(() => tsplus_module_1.id(that))(tsplus_module_1.id(self)),
    await: tsplus_module_4.zipWith(tsplus_module_3._await(that), (e1, e2) => e1._tag === "Success" ? e1 : e2)(tsplus_module_3._await(self)),
    children: tsplus_module_5.children(self),
    inheritAll: tsplus_module_7.zipRight(tsplus_module_6.inheritAll(self))(tsplus_module_6.inheritAll(that)),
    interruptAsFork: id => tsplus_module_7.zipRight(tsplus_module_8.interruptAsNow(id)(that))(tsplus_module_8.interruptAsNow(id)(self)),
    poll: tsplus_module_4.zipWith(tsplus_module_9.poll(that), (o1, o2) => tsplus_module_11.fold(() => tsplus_module_10.none, _ => _._tag === "Success" ? o1 : o2)(o1))(tsplus_module_9.poll(self))
  });
}
//# sourceMappingURL=orElse.mjs.map