import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@effect/core/io/Fiber/operations/map";
import * as tsplus_module_3 from "@effect/core/io/Fiber/operations/orElse";
/**
 * Returns a fiber that prefers `this` fiber, but falls back to the `that` one
 * when `this` one fails. Interrupting the returned fiber will interrupt both
 * fibers, sequentially, from left to right.
 *
 * @tsplus static effect/core/io/Fiber.Aspects orElseEither
 * @tsplus static effect/core/io/RuntimeFiber.Aspects orElseEither
 * @tsplus pipeable effect/core/io/Fiber orElseEither
 * @tsplus pipeable effect/core/io/RuntimeFiber orElseEither
 */

export function orElseEither(that) {
  return self => tsplus_module_3.orElse(tsplus_module_2.map(tsplus_module_1.right)(that()))(tsplus_module_2.map(tsplus_module_1.left)(self));
}
//# sourceMappingURL=orElseEither.mjs.map