import * as tsplus_module_1 from "@effect/core/io/Fiber/operations/id";
import * as tsplus_module_2 from "@effect/core/io/FiberId/operations/getOrElse";
import * as tsplus_module_3 from "@effect/core/io/Fiber/operations/await";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/flatten";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/zipWithPar";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/exit";
import * as tsplus_module_7 from "@effect/core/io/Fiber/operations/children";
import * as tsplus_module_8 from "@effect/core/io/Fiber/operations/inheritAll";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_10 from "@effect/core/io/Fiber/operations/interruptAs";
import * as tsplus_module_11 from "@effect/core/io/Fiber/operations/poll";
import * as tsplus_module_12 from "@effect/core/io/Cause/definition";
import * as tsplus_module_13 from "@effect/core/io/Exit/operations/zipWith";
import * as tsplus_module_14 from "@tsplus/stdlib/data/Maybe/map";
import * as tsplus_module_15 from "@tsplus/stdlib/data/Maybe/flatMap";
import * as tsplus_module_16 from "@effect/core/io/Effect/operations/zipWith";
import { makeSynthetic } from "@effect/core/io/Fiber/definition";
/**
 * Zips this fiber with the specified fiber, combining their results using the
 * specified combiner function. Both joins and interruptions are performed in
 * sequential order from left to right.
 *
 * @tsplus static effect/core/io/Fiber.Aspects zipWith
 * @tsplus static effect/core/io/RuntimeFiber.Aspects zipWith
 * @tsplus pipeable effect/core/io/Fiber zipWith
 * @tsplus pipeable effect/core/io/RuntimeFiber zipWith
 */

export function zipWith(that, f) {
  return self => makeSynthetic({
    id: tsplus_module_2.getOrElse(() => tsplus_module_1.id(that))(tsplus_module_1.id(self)),
    await: tsplus_module_6.exit(tsplus_module_5.zipWithPar(tsplus_module_4.flatten(tsplus_module_3._await(that)), f)(tsplus_module_4.flatten(tsplus_module_3._await(self)))),
    children: tsplus_module_7.children(self),
    inheritAll: tsplus_module_9.zipRight(tsplus_module_8.inheritAll(self))(tsplus_module_8.inheritAll(that)),
    interruptAsFork: id => tsplus_module_9.zipRight(tsplus_module_10.interruptAsFork(id)(that))(tsplus_module_10.interruptAsFork(id)(self)),
    poll: tsplus_module_16.zipWith(tsplus_module_11.poll(that), (oa, ob) => tsplus_module_15.flatMap(ea => tsplus_module_14.map(eb => tsplus_module_13.zipWith(eb, f, tsplus_module_12.combinePar)(ea))(ob))(oa))(tsplus_module_11.poll(self))
  });
}
//# sourceMappingURL=zipWith.mjs.map