var _a, _b, _c;

import * as tsplus_module_1 from "@tsplus/stdlib/structure/Hash";
import * as tsplus_module_2 from "@tsplus/stdlib/structure/Equals";
export const isFiberStatus = isFiberStatus_1;
export const FiberStatusSym = /*#__PURE__*/Symbol.for("@effect/core/Fiber/FiberStatus");
export const FiberStatus = {};
export class Done {
  constructor() {
    this._tag = "Done";
    this[_a] = FiberStatusSym;
  }

  [(_a = FiberStatusSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.hashString(this._tag);
  }

  [tsplus_module_2.Equals.sym](that) {
    return isFiberStatus_1(that) && that._tag === "Done";
  }

}
export class Running {
  constructor(runtimeFlags) {
    this.runtimeFlags = runtimeFlags;
    this._tag = "Running";
    this[_b] = FiberStatusSym;
  }

  [(_b = FiberStatusSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString(this._tag), tsplus_module_1.hashNumber(this.runtimeFlags));
  }

  [tsplus_module_2.Equals.sym](that) {
    return isFiberStatus_1(that) && that._tag === "Running" && this.runtimeFlags === that.runtimeFlags;
  }

}
export class Suspended {
  constructor(runtimeFlags, blockingOn) {
    this.runtimeFlags = runtimeFlags;
    this.blockingOn = blockingOn;
    this._tag = "Suspended";
    this[_c] = FiberStatusSym;
  }

  [(_c = FiberStatusSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString(this._tag), tsplus_module_1.combine(tsplus_module_1.hashNumber(this.runtimeFlags), tsplus_module_1.hashUnknown(this.blockingOn)));
  }

  [tsplus_module_2.Equals.sym](that) {
    return isFiberStatus_1(that) && that._tag === "Suspended" && this.runtimeFlags === that.runtimeFlags && tsplus_module_2.equals(this.blockingOn, that.blockingOn);
  }

}
/**
 * @tsplus static effect/core/io/Fiber/Status.Ops isFiberStatus
 */

function isFiberStatus_1(u) {
  return typeof u === "object" && u != null && FiberStatusSym in u;
}
//# sourceMappingURL=status.mjs.map