var _a, _b, _c;

import * as tsplus_module_1 from "@tsplus/stdlib/structure/Hash";
import * as tsplus_module_2 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashSet/operations/equals";
export const isFiberId = isFiberId_1;
export const FiberIdSym = /*#__PURE__*/Symbol.for("@effect/core/io/FiberId");
export const FiberId = {
  $: {}
};
/**
 * @tsplus macro remove
 */

export function realFiberId(_) {//
}
export class None {
  constructor() {
    this._tag = "None";
    this[_a] = FiberIdSym;
  }

  [(_a = FiberIdSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.hashString(this._tag);
  }

  [tsplus_module_2.Equals.sym](that) {
    if (isFiberId_1(that)) {
      void 0;
      return that._tag === "None";
    }

    return false;
  }

}
export class RuntimeFiberId {
  constructor(id, startTimeMillis) {
    this.id = id;
    this.startTimeMillis = startTimeMillis;
    this._tag = "Runtime";
    this[_b] = FiberIdSym;
  }

  [(_b = FiberIdSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString(this._tag), tsplus_module_1.combine(tsplus_module_1.hashNumber(this.id), tsplus_module_1.hashNumber(this.startTimeMillis)));
  }

  [tsplus_module_2.Equals.sym](that) {
    if (isFiberId_1(that)) {
      void 0;
      return this._tag === that._tag && this.id === that.id && this.startTimeMillis === that.startTimeMillis;
    }

    return false;
  }

}
export class CompositeFiberId {
  constructor(fiberIds) {
    this.fiberIds = fiberIds;
    this._tag = "Composite";
    this[_c] = FiberIdSym;
  }

  [(_c = FiberIdSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString(this._tag), tsplus_module_1.hashUnknown(this.fiberIds));
  }

  [tsplus_module_2.Equals.sym](that) {
    if (isFiberId_1(that)) {
      void 0;
      return that._tag === "Composite" && tsplus_module_3.equals(that.fiberIds)(this.fiberIds);
    }

    return false;
  }

}
/**
 * Checks if the specified unknown value is a `FiberId`.
 *
 * @tsplus static effect/core/io/FiberId.Ops isFiberId
 */

function isFiberId_1(self) {
  return typeof self === "object" && self != null && FiberIdSym in self;
}
//# sourceMappingURL=definition.mjs.map