import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/from";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashSet/operations/add";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashSet/operations/union";
import { CompositeFiberId, realFiberId } from "@effect/core/io/FiberId/definition";
/**
 * Combine two `FiberId`s.
 *
 * @tsplus pipeable-operator effect/core/io/FiberId +
 * @tsplus static effect/core/io/FiberId.Aspects combine
 * @tsplus pipeable effect/core/io/FiberId combine
 */

export function combine(that) {
  return self => {
    void 0;

    switch (self._tag) {
      case "None":
        {
          return that;
        }

      case "Runtime":
        {
          void 0;

          switch (that._tag) {
            case "None":
              {
                return self;
              }

            case "Runtime":
              {
                return new CompositeFiberId(tsplus_module_1.from([self, that]));
              }

            case "Composite":
              {
                return new CompositeFiberId(tsplus_module_2.add(self)(that.fiberIds));
              }
          }
        }

      case "Composite":
        {
          void 0;

          switch (that._tag) {
            case "None":
              {
                return self;
              }

            case "Runtime":
              {
                return new CompositeFiberId(tsplus_module_2.add(that)(self.fiberIds));
              }

            case "Composite":
              {
                return new CompositeFiberId(tsplus_module_3.union(that.fiberIds)(self.fiberIds));
              }
          }
        }
    }
  };
}
//# sourceMappingURL=combine.mjs.map