import * as tsplus_module_1 from "@effect/core/io/FiberId/operations/ids";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/map";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/join";
/**
 * Creates a string representing the name of the current thread of execution
 * represented by the specified `FiberId`.
 *
 * @tsplus getter effect/core/io/FiberId threadName
 */

export function threadName(self) {
  const identifiers = tsplus_module_4.join(",")(tsplus_module_3.map(n => `${n}`)(tsplus_module_2.from(tsplus_module_1.ids(self))));
  const plural = identifiers.length > 1;
  return `effect-fiber${plural ? "s" : ""}-${identifiers}`;
}
//# sourceMappingURL=threadName.mjs.map