import * as tsplus_module_1 from "@effect/core/io/FiberId/operations/none";
import * as tsplus_module_2 from "@effect/core/io/RuntimeFlags/definition";
import * as tsplus_module_3 from "@effect/core/io/RuntimeFlags/operations/isEnabled";
import { Stateful } from "@effect/core/io/Fiber/_internal/message";
export const FiberScope = {};
export class Global {
  constructor() {
    this.fiberId = tsplus_module_1.none;
  }

  add(runtimeFlags, child) {
    if (tsplus_module_3.isEnabled(tsplus_module_2.RuntimeFlags.FiberRoots)(runtimeFlags)) {
      _roots_1.add(child);

      child.addObserver(() => {
        _roots_1.delete(child);
      });
    }
  }

}
export class Local {
  constructor(fiberId, parent) {
    this.fiberId = fiberId;
    this.parent = parent;
  }

  add(_runtimeFlags, child) {
    this.parent.tell(new Stateful(parentFiber => {
      parentFiber.addChild(child);
      child.addObserver(() => {
        parentFiber.removeChild(child);
      });
    }));
  }

}
/**
 * The global scope. Anything forked onto the global scope is not supervised,
 * and will only terminate on its own accord (never from interruption of a
 * parent fiber, because there is no parent fiber).
 *
 * @tsplus static effect/core/io/FiberScope.Ops global
 */

export const globalScope = /*#__PURE__*/new Global();
/**
 * Unsafely creats a new `Scope` from a `Fiber`.
 *
 * @tsplus static effect/core/io/FiberScope.Ops make
 */

export function make(fiber) {
  return new Local(fiber.id, fiber);
}
/**
 * @tsplus static effect/core/io/FiberScope.Ops _roots
 */

const _roots_1 = /*#__PURE__*/new Set();

export const _roots = _roots_1;
//# sourceMappingURL=definition.mjs.map