import * as tsplus_module_1 from "@effect/core/io/Hub/operations/strategy";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/flatMap";
import { makeBounded } from "@effect/core/io/Hub/operations/_internal/makeBounded";
import { makeHub } from "@effect/core/io/Hub/operations/_internal/makeHub";
/**
 * Creates a bounded hub with the back pressure strategy. The hub will retain
 * messages until they have been taken by all subscribers, applying back
 * pressure to publishers if the hub is at capacity.
 *
 * For best performance use capacities that are powers of two.
 *
 * @tsplus static effect/core/io/Hub.Ops bounded
 */

export function bounded(requestedCapacity) {
  return tsplus_module_3.flatMap(atomicHub => makeHub(atomicHub, tsplus_module_1.backPressureStrategy()))(tsplus_module_2.sync(() => makeBounded(requestedCapacity)));
}
//# sourceMappingURL=bounded.mjs.map