import * as tsplus_module_1 from "@tsplus/stdlib/structure/Hash";
import * as tsplus_module_2 from "@tsplus/stdlib/structure/Equals";
export const InterruptStatus = {
  $: {}
};
export class InterruptStatusImpl {
  constructor(isInterruptible) {
    this.isInterruptible = isInterruptible;
  }

  get isUninterruptible() {
    return !this.isInterruptible;
  }

  get toBoolean() {
    return this.isInterruptible;
  }

  [tsplus_module_1.Hash.sym]() {
    return tsplus_module_1.hashUnknown(this.isInterruptible);
  }

  [tsplus_module_2.Equals.sym](u) {
    return u instanceof InterruptStatusImpl && this.isInterruptible === u.isInterruptible;
  }

}
/**
 * Indicates the fiber can be interrupted right now.
 *
 * @tsplus static effect/core/io/InterruptStatus.Ops Interruptible
 */

const Interruptible_1 = /*#__PURE__*/new InterruptStatusImpl(true);
export const Interruptible = Interruptible_1;
/**
 * Indicates the fiber cannot be interrupted right now.
 *
 * @tsplus static effect/core/io/InterruptStatus.Ops Uninterruptible
 */

const Uninterruptible_1 = /*#__PURE__*/new InterruptStatusImpl(false);
export const Uninterruptible = Uninterruptible_1;
/**
 * @tsplus static effect/core/io/InterruptStatus.Ops fromBoolean
 */

export function fromBoolean(b) {
  return b ? Interruptible_1 : Uninterruptible_1;
}
//# sourceMappingURL=definition.mjs.map