import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/fromNullable";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_3 from "@effect/core/io/Scope/operations/addFinalizerExit";
import * as tsplus_module_4 from "@effect/core/io/Exit/operations/fold";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/inheritFiberRefs";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/onExit";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_10 from "@effect/core/io/Scope/operations/close";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_12 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_13 from "@effect/core/io/Effect/operations/whenEffect";
import * as tsplus_module_14 from "@effect/core/io/Effect/operations/getFiberRefs";
import * as tsplus_module_15 from "@effect/core/io/Effect/operations/zip";
import * as tsplus_module_16 from "@effect/core/io/Effect/operations/exit";
import * as tsplus_module_17 from "@effect/core/io/Scope/operations/make";
import * as tsplus_module_18 from "@effect/core/io/Effect/operations/do";
import * as tsplus_module_19 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_20 from "@effect/core/io/Ref/operations/make";
import * as tsplus_module_21 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_22 from "@effect/core/io/Deferred/operations/make";
import * as tsplus_module_23 from "@effect/core/io/Effect/operations/flatten";
import * as tsplus_module_24 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_25 from "@effect/core/io/Scope/definition";
import * as tsplus_module_26 from "@effect/core/io/Effect/operations/scopeWith";
import * as tsplus_module_27 from "@effect/core/io/Effect/operations/foldCauseEffect";
import * as tsplus_module_28 from "@effect/core/io/Scope/operations/extend";
import * as tsplus_module_29 from "@effect/core/io/Effect/operations/zipWithPar";
import * as tsplus_module_30 from "@tsplus/stdlib/data/Match";
export const buildWithScope = buildWithScope_1;
export const withScope = withScope_1;
export const isFresh = isFresh_1;
import { instruction } from "@effect/core/io/Layer/definition";
import { constant } from "@tsplus/stdlib/data/Function";
/**
 * A `MemoMap` memoizes layers.
 */

export class MemoMap {
  constructor(ref) {
    this.ref = ref;
  }
  /**
   * Checks the memo map to see if a layer exists. If it is, immediately
   * returns it. Otherwise, obtains the layer, stores it in the memo map,
   * and adds a finalizer to the `Scope`.
   */


  getOrElseMemoize(layer, scope) {
    return tsplus_module_23.flatten(this.ref.modifyEffect(map => {
      const inMap = tsplus_module_1.fromNullable(map.get(layer));

      switch (inMap._tag) {
        case "Some":
          {
            const [acquire, release] = inMap.value;
            const cached = tsplus_module_8.onExit(exit => tsplus_module_4.fold(() => tsplus_module_2.unit, () => tsplus_module_3.addFinalizerExit(release)(scope))(exit))(tsplus_module_7.flatMap(([b, refs]) => tsplus_module_6.as(b)(tsplus_module_5.inheritFiberRefs(refs)))(acquire));
            return tsplus_module_9.succeed([cached, map]);
          }

        case "None":
          {
            return tsplus_module_7.flatMap(observers => tsplus_module_7.flatMap(deferred => tsplus_module_21.map(finalizerRef => {
              const resource = tsplus_module_19.uninterruptibleMask(({
                restore
              }) => tsplus_module_7.flatMap(({
                innerScope,
                outerScope
              }) => tsplus_module_7.flatMap(exit => {
                switch (exit._tag) {
                  case "Failure":
                    {
                      return tsplus_module_11.zipRight(tsplus_module_12.failCause(exit.cause))(tsplus_module_11.zipRight(tsplus_module_10.close(exit)(innerScope))(deferred.failCause(() => exit.cause)));
                    }

                  case "Success":
                    {
                      return tsplus_module_6.as(exit.value[0])(tsplus_module_11.zipRight(deferred.succeed(exit.value))(tsplus_module_11.zipRight(tsplus_module_3.addFinalizerExit(e => tsplus_module_7.flatMap(fin => fin(e))(finalizerRef.get))(outerScope))(tsplus_module_11.zipRight(observers.update(n => n + 1))(finalizerRef.set(exit => tsplus_module_13.whenEffect(observers.modify(n => [n === 1, n - 1]), tsplus_module_10.close(exit)(innerScope)))))));
                    }
                }
              })(tsplus_module_16.exit(restore(tsplus_module_7.flatMap(f => tsplus_module_15.zip(tsplus_module_14.getFiberRefs)(f(this)))(withScope_1(innerScope)(layer))))))(tsplus_module_18.bind("innerScope", () => tsplus_module_17.make)(tsplus_module_18.bindValue("outerScope", () => scope)(tsplus_module_18.Do()))));
              const memoized = [tsplus_module_8.onExit(exit => tsplus_module_4.fold(() => tsplus_module_2.unit, () => observers.update(n => n + 1))(exit))(deferred.await), e => tsplus_module_7.flatMap(fin => fin(e))(finalizerRef.get)];
              return [resource, isFresh_1(layer) ? map : map.set(layer, memoized)];
            })(tsplus_module_20.makeSynchronized(() => constant(tsplus_module_2.unit))))(tsplus_module_22.make()))(tsplus_module_20.makeSynchronized(() => 0));
          }
      }
    }));
  }

}
/**
 * Creates an empty `MemoMap`.
 */

export function makeMemoMap() {
  return tsplus_module_7.flatMap(r => tsplus_module_24.sync(() => new MemoMap(r)))(tsplus_module_20.makeSynchronized(() => new Map()));
}
/**
 * Builds a layer into a scoped value.
 *
 * @tsplus getter effect/core/io/Layer build
 */

export function build(self) {
  return tsplus_module_19.serviceWithEffect(tsplus_module_25.Scope.Tag, scope => buildWithScope_1(scope)(self));
}
/**
 * Builds a layer into an Effect value. Any resources associated with this layer
 * will be released when the specified scope is closed unless their scope has
 * been extended. This allows building layers where the lifetime of some of
 * the services output by the layer exceed the lifetime of the effect the
 * layer is provided to.
 *
 * @tsplus static effect/core/io/Layer.Aspects buildWithScope
 * @tsplus pipeable effect/core/io/Layer buildWithScope
 */

function buildWithScope_1(scope) {
  return self => tsplus_module_7.flatMap(memoMap => tsplus_module_7.flatMap(run => run(memoMap))(withScope_1(scope)(self)))(makeMemoMap());
}
/**
 * @tsplus static effect/core/io/Layer.Aspects withScope
 * @tsplus pipeable effect/core/io/Layer withScope
 */


function withScope_1(scope) {
  return self => tsplus_module_30.matchTag_(self, {
    LayerApply: _ => tsplus_module_24.sync(() => _memoMap => _.self),
    LayerExtendScope: _ => tsplus_module_24.sync(() => memoMap => tsplus_module_26.scopeWith(scope => memoMap.getOrElseMemoize(_.self, scope))),
    LayerFold: _ => tsplus_module_24.sync(() => memoMap => tsplus_module_27.foldCauseEffect(e => memoMap.getOrElseMemoize(_.failure(e), scope), r => memoMap.getOrElseMemoize(_.success(r), scope))(memoMap.getOrElseMemoize(_.self, scope))),
    LayerFresh: _ => tsplus_module_24.sync(() => __ => buildWithScope_1(scope)(_.self)),
    LayerScoped: _ => tsplus_module_24.sync(() => __ => tsplus_module_28.extend(_.self)(scope)),
    LayerSuspend: _ => tsplus_module_24.sync(() => memoMap => memoMap.getOrElseMemoize(_.self(), scope)),
    LayerTo: _ => tsplus_module_24.sync(() => memoMap => tsplus_module_7.flatMap(r => tsplus_module_19.provideEnvironment(r)(memoMap.getOrElseMemoize(_.that, scope)))(memoMap.getOrElseMemoize(_.self, scope))),
    LayerZipWithPar: _ => tsplus_module_24.sync(() => memoMap => tsplus_module_29.zipWithPar(memoMap.getOrElseMemoize(_.that, scope), _.f)(memoMap.getOrElseMemoize(_.self, scope)))
  });
}
/**
 * Returns whether this layer is a fresh version that will not be shared.
 *
 * @tsplus getter effect/core/io/Layer isFresh
 */


function isFresh_1(self) {
  return self._tag === "LayerFresh";
}
//# sourceMappingURL=memoMap.mjs.map