import * as tsplus_module_1 from "@effect/core/io/Layer/operations/failCause";
import * as tsplus_module_2 from "@effect/core/io/Cause/operations/failureOrCause";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_4 from "@effect/core/io/Layer/operations/foldCauseLayer";
/**
 * Feeds the error or output services of this layer into the input of either
 * the specified `failure` or `success` layers, resulting in a new layer with
 * the inputs of this layer, and the error or outputs of the specified layer.
 *
 * @tsplus static effect/core/io/Layer.Aspects foldLayer
 * @tsplus pipeable effect/core/io/Layer foldLayer
 */

export function foldLayer(failure, success) {
  return self => tsplus_module_4.foldCauseLayer(cause => tsplus_module_3.fold(failure, cause => tsplus_module_1.failCause(() => cause))(tsplus_module_2.failureOrCause(cause)), success)(self);
}
//# sourceMappingURL=foldLayer.mjs.map