import * as tsplus_module_1 from "@effect/core/io/Layer/operations/fail";
import * as tsplus_module_2 from "@effect/core/io/Layer/operations/catchAll";
/**
 * Returns a layer with its error channel mapped using the specified function.
 *
 * @tsplus static effect/core/io/Layer.Aspects mapError
 * @tsplus pipeable effect/core/io/Layer mapError
 */

export function mapError(f) {
  return self => tsplus_module_2.catchAll(e => tsplus_module_1.fail(() => f(e)))(self);
}
//# sourceMappingURL=mapError.mjs.map