import * as tsplus_module_1 from "@effect/core/io/Layer/operations/environment";
import * as tsplus_module_2 from "@effect/core/io/Layer/operations/merge";
import { ILayerTo } from "@effect/core/io/Layer/definition";
/**
 * Feeds the output services of this builder into the input of the specified
 * builder, resulting in a new builder with the inputs of this builder as
 * well as any leftover inputs, and the outputs of the specified builder.
 *
 * @tsplus pipeable-operator effect/core/io/Layer >>
 * @tsplus static effect/core/io/Layer.Aspects provideTo
 * @tsplus pipeable effect/core/io/Layer provideTo
 */

export function provideTo(that) {
  return self => new ILayerTo(tsplus_module_2.merge(self)(tsplus_module_1.environment()), // @ts-expect-error
  that);
}
//# sourceMappingURL=provideTo.mjs.map