import * as tsplus_module_1 from "@effect/core/io/Layer/operations/provideTo";
import * as tsplus_module_2 from "@effect/core/io/Layer/operations/merge";
/**
 * Feeds the output services of this layer into the input of the specified
 * layer, resulting in a new layer with the inputs of this layer, and the
 * outputs of both layers.
 *
 * @tsplus pipeable-operator effect/core/io/Layer >
 * @tsplus static effect/core/io/Layer.Aspects provideToAndMerge
 * @tsplus pipeable effect/core/io/Layer provideToAndMerge
 */

export function provideToAndMerge(that) {
  return self => tsplus_module_2.merge(tsplus_module_1.provideTo(that)(self))(self);
}
//# sourceMappingURL=provideToAndMerge.mjs.map