import * as tsplus_module_1 from "@tsplus/stdlib/service/Tag";
import * as tsplus_module_2 from "@effect/core/io/Layer/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Layer/operations/flatMap";
import * as tsplus_module_4 from "@effect/core/io/Layer/operations/suspend";
import * as tsplus_module_5 from "@effect/core/io/Layer/operations/fresh";
import * as tsplus_module_6 from "@effect/core/io/Layer/operations/catchAll";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_8 from "@effect/core/io/Schedule/Intervals";
import * as tsplus_module_9 from "@effect/core/io/Clock/operations/sleep";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_12 from "@effect/core/io/Clock/operations/currentTime";
import * as tsplus_module_13 from "@effect/core/io/Layer/operations/fromEffect";
import { DurationInternal } from "@tsplus/stdlib/data/Duration";
/**
 * Retries constructing this layer according to the specified schedule.
 *
 * @tsplus static effect/core/io/Layer.Aspects retry
 * @tsplus pipeable effect/core/io/Layer retry
 */

export function retry(schedule) {
  return self => tsplus_module_4.suspend(() => {
    const stateTag = tsplus_module_1.Tag();
    return tsplus_module_3.flatMap(env => loop(self, schedule, stateTag, env.get(stateTag).state))(tsplus_module_2.succeed(stateTag)({
      state: schedule.initial
    }));
  });
}

function loop(self, schedule, stateTag, s) {
  return tsplus_module_6.catchAll(e => tsplus_module_3.flatMap(env => tsplus_module_5.fresh(loop(self, schedule, stateTag, env.get(stateTag).state)))(update(schedule, stateTag, e, s)))(self);
}

function update(schedule, stateTag, e, s) {
  return tsplus_module_13.fromEffect(stateTag)(tsplus_module_11.flatMap(now => tsplus_module_11.flatMap(([state, _, decision]) => decision._tag === "Done" ? tsplus_module_7.fail(e) : tsplus_module_10.as({
    state
  })(tsplus_module_9.sleep(new DurationInternal(tsplus_module_8.start(decision.intervals) - now))))(schedule.step(now, e, s)))(tsplus_module_12.currentTime));
}
//# sourceMappingURL=retry.mjs.map