import * as tsplus_module_1 from "@effect/core/io/LogLevel/instances/Ord";
import * as tsplus_module_2 from "@tsplus/stdlib/prelude/Ord/operations";
/**
 * @tsplus pipeable-operator effect/core/io/LogLevel <
 * @tsplus static effect/core/io/LogLevel.Aspects lessThen
 * @tsplus pipeable effect/core/io/LogLevel lessThan
 */

export function lessThan(that) {
  return self => tsplus_module_2.lt(tsplus_module_1.ordLogLevel)(self, that);
}
/**
 * @tsplus pipeable-operator effect/core/io/LogLevel <=
 * @tsplus static effect/core/io/LogLevel.Aspects lessThanEqual
 * @tsplus pipeable effect/core/io/LogLevel lessThanEqual
 */

export function lessThanEqual(that) {
  return self => tsplus_module_2.leq(tsplus_module_1.ordLogLevel)(self, that);
}
/**
 * @tsplus pipeable-operator effect/core/io/LogLevel >
 * @tsplus static effect/core/io/LogLevel.Aspects greaterThan
 * @tsplus pipeable effect/core/io/LogLevel greaterThan
 */

export function greaterThan(that) {
  return self => tsplus_module_2.gt(tsplus_module_1.ordLogLevel)(self, that);
}
/**
 * @tsplus pipeable-operator effect/core/io/LogLevel >=
 * @tsplus static effect/core/io/LogLevel.Aspects greaterThanEqual
 * @tsplus pipeable effect/core/io/LogLevel greaterThanEqual
 */

export function greaterThanEqual(that) {
  return self => !tsplus_module_2.lt(tsplus_module_1.ordLogLevel)(self, that);
}
//# sourceMappingURL=ordinal.mjs.map