import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Returns a version of this logger that only logs messages when the log level
 * satisfies the specified predicate.
 *
 * @tsplus static effect/core/io/Logger.Aspects filterLogLevel
 * @tsplus pipeable effect/core/io/Logger filterLogLevel
 */

export function filterLogLevel(f) {
  return self => ({
    apply: (fiberId, logLevel, message, cause, context, spans, annotations) => {
      return f(logLevel) ? tsplus_module_1.some(self.apply(fiberId, logLevel, message, cause, context, spans, annotations)) : tsplus_module_1.none;
    }
  });
}
//# sourceMappingURL=filterLogLevel.mjs.map