var _a, _b, _c, _d, _e, _f;

import * as tsplus_module_1 from "@tsplus/stdlib/structure/Hash";
import * as tsplus_module_2 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashMap/_internal/hashMap";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/equals";
export const isCounterState = isCounterState_1;
export const isGaugeState = isGaugeState_1;
export const isFrequencyState = isFrequencyState_1;
export const isHistogramState = isHistogramState_1;
export const isSummaryState = isSummaryState_1;
export const MetricStateSym = /*#__PURE__*/Symbol.for("@effect/core/io/Metrics/MetricState");
export const _Type = /*#__PURE__*/Symbol.for("@effect/core/io/Metrics/MetricState/Type");
export const CounterStateSym = /*#__PURE__*/Symbol.for("@effect/core/io/Metrics/MetricState/Counter");
export const GaugeStateSym = /*#__PURE__*/Symbol.for("@effect/core/io/Metrics/MetricState/Gauge");
export const FrequencyStateSym = /*#__PURE__*/Symbol.for("@effect/core/io/Metrics/MetricState/Frequency");
export const HistogramStateSym = /*#__PURE__*/Symbol.for("@effect/core/io/Metrics/MetricState/Histogram");
export const SummaryStateSym = /*#__PURE__*/Symbol.for("@effect/core/io/Metrics/MetricState/Summary");
export const MetricState = {};
export class BaseMetricState {
  constructor() {
    this[_a] = MetricStateSym;
  }

}
_a = MetricStateSym;
export class CounterState extends BaseMetricState {
  constructor(count) {
    super();
    this.count = count;
    this[_b] = CounterStateSym;
  }

  [(_b = CounterStateSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString("@effect/core/io/Metrics/MetricState/Counter"), tsplus_module_1.hashNumber(this.count));
  }

  [tsplus_module_2.Equals.sym](u) {
    return isCounterState_1(u) && this.count === u.count;
  }

}
export class GaugeState extends BaseMetricState {
  constructor(value) {
    super();
    this.value = value;
    this[_c] = GaugeStateSym;
  }

  [(_c = GaugeStateSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString("@effect/core/io/Metrics/MetricState/Gauge"), tsplus_module_1.hashNumber(this.value));
  }

  [tsplus_module_2.Equals.sym](u) {
    return isGaugeState_1(u) && this.value === u.value;
  }

}
export class FrequencyState extends BaseMetricState {
  constructor(occurrences) {
    super();
    this.occurrences = occurrences;
    this[_d] = FrequencyStateSym;
  }

  [(_d = FrequencyStateSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString("@effect/core/io/Metrics/MetricState/Frequency"), tsplus_module_1.hashIterator(this.occurrences[Symbol.iterator]()));
  }

  [tsplus_module_2.Equals.sym](u) {
    return isFrequencyState_1(u) && tsplus_module_3.equals_(this.occurrences, u.occurrences);
  }

}
export class HistogramState extends BaseMetricState {
  constructor(buckets, count, min, max, sum) {
    super();
    this.buckets = buckets;
    this.count = count;
    this.min = min;
    this.max = max;
    this.sum = sum;
    this[_e] = HistogramStateSym;
  }

  [(_e = HistogramStateSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString("@effect/core/io/Metrics/MetricState/Histogram"), tsplus_module_1.combine(tsplus_module_1.hashUnknown(this.buckets), tsplus_module_1.combine(tsplus_module_1.hashNumber(this.count), tsplus_module_1.combine(tsplus_module_1.hashNumber(this.min), tsplus_module_1.combine(tsplus_module_1.hashNumber(this.max), tsplus_module_1.hashNumber(this.sum))))));
  }

  [tsplus_module_2.Equals.sym](u) {
    return isHistogramState_1(u) && tsplus_module_4.equals(u.buckets)(this.buckets) && this.count === u.count && this.min === u.min && this.max === u.max && this.sum === u.sum;
  }

}
export class SummaryState extends BaseMetricState {
  constructor(error, quantiles, count, min, max, sum) {
    super();
    this.error = error;
    this.quantiles = quantiles;
    this.count = count;
    this.min = min;
    this.max = max;
    this.sum = sum;
    this[_f] = SummaryStateSym;
  }

  [(_f = SummaryStateSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString("@effect/core/io/Metrics/MetricState/Summary"), tsplus_module_1.combine(tsplus_module_1.hashNumber(this.error), tsplus_module_1.combine(tsplus_module_1.hashUnknown(this.quantiles), tsplus_module_1.combine(tsplus_module_1.hashNumber(this.count), tsplus_module_1.combine(tsplus_module_1.hashNumber(this.min), tsplus_module_1.combine(tsplus_module_1.hashNumber(this.max), tsplus_module_1.hashNumber(this.sum)))))));
  }

  [tsplus_module_2.Equals.sym](u) {
    return isSummaryState_1(u) && this.error === u.error && tsplus_module_4.equals(u.quantiles)(this.quantiles) && this.count === u.count && this.min === u.min && this.max === u.max && this.sum === u.sum;
  }

}
/**
 * @tsplus static effect/core/io/Metrics/MetricState.Ops Counter
 */

export function counter(count) {
  return new CounterState(count);
}
/**
 * @tsplus static effect/core/io/Metrics/MetricState.Ops Gauge
 */

export function gauge(value) {
  return new GaugeState(value);
}
/**
 * @tsplus static effect/core/io/Metrics/MetricState.Ops Frequency
 */

export function frequency(occurrences) {
  return new FrequencyState(occurrences);
}
/**
 * @tsplus static effect/core/io/Metrics/MetricState.Ops Histogram
 */

export function histogram(buckets, count, min, max, sum) {
  return new HistogramState(buckets, count, min, max, sum);
}
/**
 * @tsplus static effect/core/io/Metrics/MetricState.Ops Summary
 */

export function summary(error, quantiles, count, min, max, sum) {
  return new SummaryState(error, quantiles, count, min, max, sum);
}
/**
 * @tsplus static effect/core/io/Metrics/MetricState.Ops isCounterState
 */

function isCounterState_1(u) {
  return typeof u === "object" && u != null && CounterStateSym in u;
}
/**
 * @tsplus static effect/core/io/Metrics/MetricState.Ops isGaugeState
 */


function isGaugeState_1(u) {
  return typeof u === "object" && u != null && GaugeStateSym in u;
}
/**
 * @tsplus static effect/core/io/Metrics/MetricState.Ops isFrequencyState
 */


function isFrequencyState_1(u) {
  return typeof u === "object" && u != null && FrequencyStateSym in u;
}
/**
 * @tsplus static effect/core/io/Metrics/MetricState.Ops isHistogramState
 */


function isHistogramState_1(u) {
  return typeof u === "object" && u != null && HistogramStateSym in u;
}
/**
 * @tsplus static effect/core/io/Metrics/MetricState.Ops isSummaryState
 */


function isSummaryState_1(u) {
  return typeof u === "object" && u != null && SummaryStateSym in u;
}
//# sourceMappingURL=MetricState.mjs.map