import * as tsplus_module_1 from "@effect/core/io/Metrics/definition";
/**
 * Returns a new metric that is powered by this one, but which accepts updates
 * of the specified new type, which must be transformable to the input type of
 * this metric.
 *
 * @tsplus static effect/core/io/Metrics/Metric.Aspects contramap
 * @tsplus pipeable effect/core/io/Metrics/Metric contramap
 */

export function contramap(f) {
  return self => tsplus_module_1.Metric(self.keyType, (input, extraTags) => self.unsafeUpdate(f(input), extraTags), self.unsafeValue);
}
//# sourceMappingURL=contramap.mjs.map