import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/union";
import * as tsplus_module_2 from "@effect/core/io/Metrics/definition";
import * as tsplus_module_3 from "@effect/core/io/Metrics/operations/map";
import { constVoid } from "@tsplus/stdlib/data/Function";
/**
 * Returns a new metric, which is identical in every way to this one, except
 * dynamic tags are added based on the update values. Note that the metric
 * returned by this method does not return any useful information, due to the
 * dynamic nature of the added tags.
 *
 * @tsplus static effect/core/io/Metrics/Metric.Aspects taggedWith
 * @tsplus pipeable effect/core/io/Metrics/Metric taggedWith
 */

export function taggedWith(f) {
  return self => tsplus_module_3.map(constVoid)(tsplus_module_2.Metric(self.keyType, (input, extraTags) => self.unsafeUpdate(input, tsplus_module_1.union(extraTags)(f(input))), self.unsafeValue));
}
//# sourceMappingURL=taggedWith.mjs.map