import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/union";
import * as tsplus_module_2 from "@effect/core/io/Metrics/definition";
/**
 * Returns a new metric, which is identical in every way to this one, except
 * the specified tags have been added to the tags of this metric.
 *
 * @tsplus static effect/core/io/Metrics/Metric.Aspects taggedWithLabelSet
 * @tsplus pipeable effect/core/io/Metrics/Metric taggedWithLabelSet
 */

export function taggedWithLabelSet(extraTags) {
  return self => tsplus_module_2.Metric(self.keyType, (input, extraTags1) => self.unsafeUpdate(input, tsplus_module_1.union(extraTags1)(extraTags)), extraTags1 => self.unsafeValue(tsplus_module_1.union(extraTags1)(extraTags)));
}
//# sourceMappingURL=taggedWithLabelSet.mjs.map