import * as tsplus_module_1 from "@effect/core/io/Metrics/Boundaries";
import * as tsplus_module_2 from "@effect/core/io/Metrics/operations/histogram";
import * as tsplus_module_3 from "@effect/core/io/Metrics/operations/tagged";
import * as tsplus_module_4 from "@effect/core/io/Metrics/operations/contramap";
/**
 * Creates a timer metric, based on a histogram, which keeps track of
 * durations in milliseconds. The unit of time will automatically be added to
 * the metric as a tag (i.e. `"time_unit: milliseconds"`).
 *
 * @tsplus static effect/core/io/Metrics/Metric.Ops timer
 */

export function timer(name) {
  const boundaries = tsplus_module_1.exponential(1, 2, 100);
  const base = tsplus_module_3.tagged("time_unit", "milliseconds")(tsplus_module_2.histogram(name, boundaries));
  return tsplus_module_4.contramap(duration => duration.millis)(base);
}
//# sourceMappingURL=timer.mjs.map