import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/empty";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/map";
/**
 * Returns an aspect that will update this metric with the specified constant
 * value every time the aspect is applied to an effect, regardless of whether
 * that effect fails or succeeds.
 *
 * @tsplus static effect/core/io/Metrics/Metric.Aspects trackAll
 * @tsplus pipeable effect/core/io/Metrics/Metric trackAll
 */

export function trackAll(input) {
  return self => {
    return effect => tsplus_module_2.map(a => {
      self.unsafeUpdate(input, tsplus_module_1.empty());
      return a;
    })(effect);
  };
}
//# sourceMappingURL=trackAll.mjs.map