import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/empty";
import * as tsplus_module_2 from "@effect/core/io/Cause/operations/defects";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/List/forEach";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/tapDefect";
/**
 * Returns an aspect that will update this metric with the result of applying
 * the specified function to the defect throwables of the effects that the
 * aspect is applied to.
 *
 * @tsplus static effect/core/io/Metrics/Metric.Aspects trackDefectWith
 * @tsplus pipeable effect/core/io/Metrics/Metric trackDefectWith
 */

export function trackDefectWith(f) {
  return self => {
    const updater = defect => self.unsafeUpdate(f(defect), tsplus_module_1.empty());

    return effect => tsplus_module_5.tapDefect(cause => tsplus_module_4.sync(() => tsplus_module_3.forEach(updater)(tsplus_module_2.defects(cause))))(effect);
  };
}
//# sourceMappingURL=trackDefectWith.mjs.map