import * as tsplus_module_1 from "@effect/core/io/Metrics/operations/update";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/tapError";
/**
 * Returns an aspect that will update this metric with the result of applying
 * the specified function to the error value of the effects that the aspect is
 * applied to.
 *
 * @tsplus static effect/core/io/Metrics/Metric.Aspects trackErrorWith
 * @tsplus pipeable effect/core/io/Metrics/Metric trackErrorWith
 */

export function trackErrorWith(f) {
  return self => {
    const updater = error => tsplus_module_1.update(f(error))(self);

    return effect => tsplus_module_2.tapError(updater)(effect);
  };
}
//# sourceMappingURL=trackErrorWith.mjs.map