import * as tsplus_module_1 from "@effect/core/io/Metrics/operations/update";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/tap";
/**
 * Returns an aspect that will update this metric with the result of applying
 * the specified function to the success value of the effects that the aspect is
 * applied to.
 *
 * @tsplus static effect/core/io/Metrics/Metric.Aspects trackSuccessWith
 * @tsplus pipeable effect/core/io/Metrics/Metric trackSuccessWith
 */

export function trackSuccessWith(f) {
  return self => {
    const updater = value => tsplus_module_1.update(f(value))(self);

    return effect => tsplus_module_2.tap(updater)(effect);
  };
}
//# sourceMappingURL=trackSuccessWith.mjs.map