import * as tsplus_module_1 from "@tsplus/stdlib/collections/mutable/MutableQueue";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/prepend";
import { unsafeCompleteDeferred } from "@effect/core/io/Queue/operations/_internal/unsafeCompleteDeferred";
import { unsafeOfferAll } from "@effect/core/io/Queue/operations/_internal/unsafeOfferAll";
import { unsafePollAll } from "@effect/core/io/Queue/operations/_internal/unsafePollAll";
export function unsafeCompleteTakers(strategy, queue, takers) {
  // Check both a taker and an item are in the queue, starting with the taker
  let keepPolling = true;

  while (keepPolling && !queue.isEmpty) {
    const taker = takers.poll(tsplus_module_1.EmptyMutableQueue);

    if (taker !== tsplus_module_1.EmptyMutableQueue) {
      const element = queue.poll(tsplus_module_1.EmptyMutableQueue);

      if (element !== tsplus_module_1.EmptyMutableQueue) {
        unsafeCompleteDeferred(taker, element);
        strategy.unsafeOnQueueEmptySpace(queue, takers);
      } else {
        unsafeOfferAll(takers, tsplus_module_2.prepend(taker)(unsafePollAll(takers)));
      }

      keepPolling = true;
    } else {
      keepPolling = false;
    }
  }
}
//# sourceMappingURL=unsafeCompleteTakers.mjs.map