import * as tsplus_module_1 from "@effect/core/io/Queue/operations/strategy";
import * as tsplus_module_2 from "@effect/core/io/Queue/external/create";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/mutable/MutableQueue/bounded";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Makes a new bounded queue with sliding strategy. When the capacity of the
 * queue is reached, new elements will be added and the old elements will be
 * dropped.
 *
 * **Note**: When possible use only power of 2 capacities; this will provide
 * better performance by utilising an optimised version of the underlying
 * `RingBuffer`.
 *
 * @tsplus static effect/core/io/Queue.Ops sliding
 */

export function sliding(requestedCapacity) {
  return tsplus_module_5.flatMap(queue => tsplus_module_2.create(queue, tsplus_module_1.slidingStrategy()))(tsplus_module_4.sync(() => tsplus_module_3.bounded(requestedCapacity)));
}
//# sourceMappingURL=sliding.mjs.map