import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/size";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/mutable/MutableQueue";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/Chunk/operations/drop";
import { unsafeCompleteTakers } from "@effect/core/io/Queue/operations/_internal/unsafeCompleteTakers";
export const Strategy = {};
export class DroppingStrategy {
  // Do nothing, drop the surplus
  handleSurplus(_as, _queue, _takers, _isShutdown) {
    return tsplus_module_1.succeed(false);
  }

  unsafeOnQueueEmptySpace(_queue) {//
  }

  get surplusSize() {
    return 0;
  }

  get shutdown() {
    return tsplus_module_2.unit;
  }

}
export class SlidingStrategy {
  handleSurplus(as, queue, takers, _isShutdown) {
    return tsplus_module_3.sync(() => {
      this.unsafeSlidingOffer(queue, as);
      unsafeCompleteTakers(this, queue, takers);
      return true;
    });
  }

  unsafeOnQueueEmptySpace(_queue) {//
  }

  get surplusSize() {
    return 0;
  }

  get shutdown() {
    return tsplus_module_2.unit;
  }

  unsafeSlidingOffer(queue, as) {
    let bs = as;

    while (tsplus_module_4.size(bs) > 0) {
      if (queue.capacity === 0) {
        return;
      } // Poll 1 and retry


      queue.poll(tsplus_module_5.EmptyMutableQueue);

      if (queue.offer(tsplus_module_6.unsafeGet(0)(bs))) {
        bs = tsplus_module_7.drop(1)(bs);
      }
    }
  }

}
/**
 * @tsplus static effect/core/io/Queue/Strategy.Ops Sliding
 */

export function slidingStrategy() {
  return new SlidingStrategy();
}
/**
 * @tsplus static effect/core/io/Queue/Strategy.Ops Dropping
 */

export function dropppingStrategy() {
  return new DroppingStrategy();
}
//# sourceMappingURL=strategy.mjs.map