var _a;

import * as tsplus_module_1 from "@tsplus/stdlib/io/Random/PCGRandom";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/excl-forEach";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/suspendSucceed";
import * as tsplus_module_7 from "@effect/core/io/Random/definition";
import * as tsplus_module_8 from "@effect/core/io/Layer/operations/fromValue";
import { RandomSym } from "@effect/core/io/Random/definition";
export class LiveRandom {
  constructor(seed) {
    this.seed = seed;
    this[_a] = RandomSym;
    this.PRNG = new tsplus_module_1.PCGRandom(seed);
  }

  get next() {
    return tsplus_module_2.sync(() => this.PRNG.number());
  }

  get nextBoolean() {
    return tsplus_module_3.map(n => n > 0.5)(this.next);
  }

  get nextInt() {
    return tsplus_module_2.sync(() => this.PRNG.integer(0));
  }

  nextRange(low, high) {
    return tsplus_module_3.map(n => (high - low) * n + low)(this.next);
  }

  nextIntBetween(low, high) {
    return tsplus_module_2.sync(() => this.PRNG.integer(high - low) + low);
  }

  shuffle(collection) {
    return shuffleWith(collection, n => this.nextIntBetween(0, n));
  }

}
_a = RandomSym;

function shuffleWith(collection, nextIntBounded) {
  return tsplus_module_6.suspendSucceed(() => {
    return tsplus_module_4.flatMap(buffer => {
      const swap = (i1, i2) => tsplus_module_2.sync(() => {
        const tmp = buffer[i1];
        buffer[i1] = buffer[i2];
        buffer[i2] = tmp;
        return buffer;
      });

      const ns = [];

      for (let i = buffer.length; i >= 2; i = i - 1) {
        ns.push(i);
      }

      return tsplus_module_3.map(() => buffer)(tsplus_module_5.forEachDiscard(ns, n => tsplus_module_4.flatMap(k => swap(n - 1, k))(nextIntBounded(n))));
    })(tsplus_module_2.sync(() => {
      const buffer = [];

      for (const element of collection) {
        buffer.push(element);
      }

      return buffer;
    }));
  });
}
/**
 * @tsplus static effect/core/io/Random.Ops default
 */


const defaultRandom_1 = /*#__PURE__*/new LiveRandom( /*#__PURE__*/Math.random() * 4294967296 >>> 0);
export const defaultRandom = defaultRandom_1;
/**
 * @tsplus static effect/core/io/Random.Ops live
 */

export const live = /*#__PURE__*/tsplus_module_8.fromValue(tsplus_module_7.Random.Tag, () => defaultRandom_1);
//# sourceMappingURL=live.mjs.map