import * as tsplus_module_1 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_3 from "@effect/core/stm/TSemaphore/operations/withPermit";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_6 from "@tsplus/stdlib/data/Maybe/getOrElse";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/sync";
import { _A, RefSym, SynchronizedSym } from "@effect/core/io/Ref/definition";
export class SynchronizedInternal {
  get [RefSym]() {
    return RefSym;
  }

  get [SynchronizedSym]() {
    return SynchronizedSym;
  }

  get [_A]() {
    return a => a;
  }

  constructor(ref, semaphore) {
    this.ref = ref;
    this.semaphore = semaphore;
  }

  modifyEffect(f) {
    return tsplus_module_3.withPermit(this.semaphore)(tsplus_module_2.flatMap(tp => {
      const [b, a] = tp;
      return tsplus_module_1.as(b)(this.ref.set(a));
    })(tsplus_module_2.flatMap(f)(this.get)));
  }

  getAndUpdateEffect(f) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [v, result])(f(v)));
  }

  getAndUpdateSomeEffect(pf) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [v, result])(tsplus_module_6.getOrElse_(pf(v), () => tsplus_module_5.succeed(v))));
  }

  modifySomeEffect(fallback, pf) {
    return this.modifyEffect(v => tsplus_module_6.getOrElse_(pf(v), () => tsplus_module_5.succeed([fallback, v])));
  }

  updateEffect(f) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [undefined, result])(f(v)));
  }

  updateAndGetEffect(f) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [result, result])(f(v)));
  }

  updateSomeEffect(pf) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [undefined, result])(tsplus_module_6.getOrElse_(pf(v), () => tsplus_module_5.succeed(v))));
  }

  updateSomeAndGetEffect(pf) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [result, result])(tsplus_module_6.getOrElse_(pf(v), () => tsplus_module_5.succeed(v))));
  }

  get get() {
    return this.ref.get;
  }

  modify(f) {
    return this.modifyEffect(a => tsplus_module_7.sync(() => f(a)));
  }

  set(a) {
    return tsplus_module_3.withPermit(this.semaphore)(this.ref.set(a));
  }

  getAndSet(a) {
    return this.modify(v => [v, a]);
  }

  getAndUpdate(f) {
    return this.modify(v => [v, f(v)]);
  }

  getAndUpdateSome(pf) {
    return this.modify(v => [v, tsplus_module_6.getOrElse_(pf(v), () => v)]);
  }

  modifySome(fallback, pf) {
    return this.modify(v => tsplus_module_6.getOrElse_(pf(v), () => [fallback, v]));
  }

  update(f) {
    return this.modify(v => [undefined, f(v)]);
  }

  updateAndGet(f) {
    return this.modify(v => {
      const result = f(v);
      return [result, result];
    });
  }

  updateSome(pf) {
    return this.modify(v => [undefined, tsplus_module_6.getOrElse_(pf(v), () => v)]);
  }

  updateSomeAndGet(pf) {
    return this.modify(v => {
      const result = tsplus_module_6.getOrElse_(pf(v), () => v);
      return [result, result];
    });
  }

}
//# sourceMappingURL=SynchronizedInternal.mjs.map