import * as tsplus_module_1 from "@effect/core/io/Reloadable/operations/_internal/ReloadableInternal";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/ignoreLogged";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/schedule";
import * as tsplus_module_4 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_5 from "@effect/core/io/Fiber/operations/interrupt";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_7 from "@effect/core/io/Reloadable/operations/manual";
import * as tsplus_module_8 from "@effect/core/io/Layer/memoMap";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_10 from "@effect/core/io/Layer/operations/scoped";
/**
 * Makes a new reloadable service from a layer that describes the construction
 * of a static service. The service is automatically reloaded according to the
 * provided schedule.
 *
 * @tsplus static effect/core/io/Reloadable.Ops auto
 */

export function auto(outTag, layer, policy) {
  return tsplus_module_10.scoped(tsplus_module_1.reloadableTag(outTag), tsplus_module_9.flatMap(env => {
    const reloadable = env.unsafeGet(tsplus_module_1.reloadableTag(outTag));
    return tsplus_module_6.map(() => reloadable)(tsplus_module_4.acquireRelease(tsplus_module_4.forkDaemon(tsplus_module_3.schedule(policy)(tsplus_module_2.ignoreLogged(reloadable.reload))), fiber => tsplus_module_5.interrupt(fiber)));
  })(tsplus_module_8.build(tsplus_module_7.manual(outTag, layer))));
}
//# sourceMappingURL=auto.mjs.map