import * as tsplus_module_1 from "@effect/core/io/Reloadable/operations/_internal/ReloadableInternal";
import * as tsplus_module_2 from "@effect/core/io/Reloadable/operations/auto";
import * as tsplus_module_3 from "@effect/core/io/Layer/memoMap";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_5 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_7 from "@effect/core/io/Layer/operations/scoped";
/**
 * Makes a new reloadable service from a layer that describes the construction
 * of a static service. The service is automatically reloaded according to a
 * schedule, which is extracted from the input to the layer.
 *
 * @tsplus static effect/core/io/Reloadable.Ops autoFromConfig
 */

export function autoFromConfig(outTag, layer, scheduleFromConfig) {
  return tsplus_module_7.scoped(tsplus_module_1.reloadableTag(outTag), tsplus_module_6.flatMap(input => {
    const policy = scheduleFromConfig(input);
    return tsplus_module_4.map(env => env.unsafeGet(tsplus_module_1.reloadableTag(outTag)))(tsplus_module_3.build(tsplus_module_2.auto(outTag, layer, policy)));
  })(tsplus_module_5.environment()));
}
//# sourceMappingURL=autoFromConfig.mjs.map