import * as tsplus_module_1 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_2 from "@effect/core/io/Schedule/operations/modifyDelayEffect";
import { DurationInternal } from "@tsplus/stdlib/data/Duration";
/**
 * Returns a new schedule with the given effectfully computed delay added to
 * every interval defined by this schedule.
 *
 * @tsplus static effect/core/io/Schedule.Aspects addDelayEffect
 * @tsplus pipeable effect/core/io/Schedule addDelayEffect
 */

export function addDelayEffect(f) {
  return self => tsplus_module_2.modifyDelayEffect((out, duration) => tsplus_module_1.map(delay => new DurationInternal(duration.millis + delay.millis))(f(out)))(self);
}
//# sourceMappingURL=addDelayEffect.mjs.map