import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/flatMap";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns a new schedule that first executes this schedule to completion, and
 * then executes the specified schedule to completion.
 *
 * @tsplus pipeable-operator effect/core/io/Schedule %
 * @tsplus static effect/core/io/Schedule.Aspects andThenEither
 * @tsplus pipeable effect/core/io/Schedule andThenEither
 */

export function andThenEither(that) {
  return self => makeWithState([self.initial, that.initial, true], (now, input, state) => state[2] ? tsplus_module_4.flatMap(([lState, out, decision]) => {
    switch (decision._tag) {
      case "Done":
        {
          return tsplus_module_2.map(([rState, out, decision]) => [[lState, rState, false], tsplus_module_1.rightW(out), decision])(that.step(now, input, state[1]));
        }

      case "Continue":
        {
          return tsplus_module_3.succeed([[lState, state[1], true], tsplus_module_1.leftW(out), decision]);
        }
    }
  })(self.step(now, input, state[0])) : tsplus_module_2.map(([rState, out, decision]) => [[state[0], rState, false], tsplus_module_1.rightW(out), decision])(that.step(now, input, state[1])));
}
//# sourceMappingURL=andThenEither.mjs.map