import * as tsplus_module_1 from "@effect/core/io/Schedule/Intervals";
import * as tsplus_module_2 from "@effect/core/io/Schedule/Decision";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/zipWith";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns a new schedule that has both the inputs and outputs of this and the
 * specified schedule.
 *
 * @tsplus pipeable-operator effect/core/io/Schedule **
 * @tsplus static effect/core/io/Schedule.Aspects bothInOut
 * @tsplus pipeable effect/core/io/Schedule bothInOut
 */

export function bothInOut(that) {
  return self => makeWithState([self.initial, that.initial], (now, [in1, in2], state) => tsplus_module_3.zipWith(that.step(now, in2, state[1]), ([lState, out, lDecision], [rState, out2, rDecision]) => {
    if (lDecision._tag === "Continue" && rDecision._tag === "Continue") {
      const interval = tsplus_module_1.union(rDecision.intervals)(lDecision.intervals);
      return [[lState, rState], [out, out2], tsplus_module_2._continue(interval)];
    }

    return [[lState, rState], [out, out2], tsplus_module_2.done];
  })(self.step(now, in1, state[0])));
}
//# sourceMappingURL=bothInOut.mjs.map