import * as tsplus_module_1 from "@effect/core/io/Schedule/Decision";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/flatMap";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns a new schedule that passes each input and output of this schedule
 * to the specified function, and then determines whether or not to continue
 * based on the return value of the function.
 *
 * @tsplus static effect/core/io/Schedule.Aspects checkEffect
 * @tsplus pipeable effect/core/io/Schedule checkEffect
 */

export function checkEffect(test) {
  return self => makeWithState(self.initial, (now, input, state) => tsplus_module_4.flatMap(([state, out, decision]) => {
    switch (decision._tag) {
      case "Done":
        {
          return tsplus_module_2.succeed([state, out, tsplus_module_1.done]);
        }

      case "Continue":
        {
          return tsplus_module_3.map(cont => {
            if (cont) {
              return [state, out, decision];
            }

            return [state, out, tsplus_module_1.done];
          })(test(input, out));
        }
    }
  })(self.step(now, input, state)));
}
//# sourceMappingURL=checkEffect.mjs.map