import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Either/fold";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns a new schedule that allows choosing between feeding inputs to this
 * schedule, or feeding inputs to the specified schedule.
 *
 * @tsplus pipeable-operator effect/core/io/Schedule +
 * @tsplus static effect/core/io/Schedule.Aspects choose
 * @tsplus pipeable effect/core/io/Schedule choose
 */

export function choose(that) {
  return self => makeWithState([self.initial, that.initial], (now, either, state) => tsplus_module_3.fold(input => tsplus_module_2.map(([lState, out, decision]) => [[lState, state[1]], tsplus_module_1.left(out), decision])(self.step(now, input, state[0])), input2 => tsplus_module_2.map(([rState, out2, decision]) => [[state[0], rState], tsplus_module_1.right(out2), decision])(that.step(now, input2, that.initial)))(either));
}
//# sourceMappingURL=choose.mjs.map