import * as tsplus_module_1 from "@effect/core/io/Schedule/Decision";
import * as tsplus_module_2 from "@effect/core/io/Schedule/Intervals";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/flatMap";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns the composition of this schedule and the specified schedule, by
 * piping the output of this one into the input of the other. Effects
 * described by this schedule will always be executed before the effects
 * described by the second schedule.
 *
 * @tsplus pipeable-operator effect/core/io/Schedule >>
 * @tsplus static effect/core/io/Schedule.Aspects compose
 * @tsplus pipeable effect/core/io/Schedule compose
 */

export function compose(that) {
  return self => makeWithState([self.initial, that.initial], (now, input, state) => tsplus_module_4.flatMap(([lState, out, lDecision]) => tsplus_module_3.map(([rState, out2, rDecision]) => lDecision._tag === "Done" ? [[lState, rState], out2, tsplus_module_1.done] : rDecision._tag === "Done" ? [[lState, rState], out2, tsplus_module_1.done] : [[lState, rState], out2, tsplus_module_1._continue(tsplus_module_2.max(rDecision.intervals)(lDecision.intervals))])(that.step(now, out, state[1])))(self.step(now, input, state[0])));
}
//# sourceMappingURL=compose.mjs.map