import * as tsplus_module_1 from "@effect/core/io/Effect/operations/flatMap";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns a new schedule that deals with a narrower class of inputs than this
 * schedule.
 *
 * @tsplus static effect/core/io/Schedule.Aspects contramapEffect
 * @tsplus pipeable effect/core/io/Schedule contramapEffect
 */

export function contramapEffect(f) {
  return self => makeWithState(self.initial, (now, input2, state) => tsplus_module_1.flatMap(input => self.step(now, input, state))(f(input2)));
}
//# sourceMappingURL=contramapEffect.mjs.map