import * as tsplus_module_1 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_2 from "@effect/core/io/Schedule/operations/delayedEffect";
/**
 * Returns a new schedule with the specified effectfully computed delay added
 * before the start of each interval produced by this schedule.
 *
 * @tsplus static effect/core/io/Schedule.Aspects delayed
 * @tsplus pipeable effect/core/io/Schedule delayed
 */

export function delayed(f) {
  return self => tsplus_module_2.delayedEffect(duration => tsplus_module_1.sync(() => f(duration)))(self);
}
//# sourceMappingURL=delayed.mjs.map