import * as tsplus_module_1 from "@effect/core/io/Schedule/operations/modifyDelayEffect";
/**
 * Returns a new schedule with the specified effectfully computed delay added
 * before the start of each interval produced by this schedule.
 *
 * @tsplus static effect/core/io/Schedule.Aspects delayedEffect
 * @tsplus pipeable effect/core/io/Schedule delayedEffect
 */

export function delayedEffect(f) {
  return self => tsplus_module_1.modifyDelayEffect((_, delay) => f(delay))(self);
}
//# sourceMappingURL=delayedEffect.mjs.map