import * as tsplus_module_1 from "@tsplus/stdlib/data/Duration";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Schedule/Intervals";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/flatMap";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
import { DurationInternal } from "@tsplus/stdlib/data/Duration";
/**
 * Returns a new schedule that outputs the delay between each occurence.
 *
 * @tsplus getter effect/core/io/Schedule delays
 */

export function delays(self) {
  return makeWithState(self.initial, (now, input, state) => tsplus_module_4.flatMap(([state, _, decision]) => {
    switch (decision._tag) {
      case "Done":
        {
          return tsplus_module_2.succeed([state, tsplus_module_1.millis(0), decision]);
        }

      case "Continue":
        {
          return tsplus_module_2.succeed([state, new DurationInternal(tsplus_module_3.start(decision.intervals) - now), decision]);
        }
    }
  })(self.step(now, input, state)));
}
//# sourceMappingURL=delays.mjs.map