import * as tsplus_module_1 from "@tsplus/stdlib/exceptions";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/failSync";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_6 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_8 from "@effect/core/io/Ref/operations/make";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_11 from "@effect/core/io/Schedule/Intervals";
import * as tsplus_module_12 from "@effect/core/io/Effect/operations/sleep";
import * as tsplus_module_13 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_14 from "@effect/core/io/Clock/operations/currentTime";
import { Driver } from "@effect/core/io/Schedule/Driver";
import { DurationInternal } from "@tsplus/stdlib/data/Duration";
/**
 * Returns a driver that can be used to step the schedule, appropriately
 * handling sleeping.
 *
 * @tsplus getter effect/core/io/Schedule driver
 */

export function driver(self) {
  return tsplus_module_7.map(ref => {
    const last = tsplus_module_5.flatMap(([element, _]) => tsplus_module_4.fold(() => tsplus_module_2.failSync(() => new tsplus_module_1.NoSuchElement()), out => tsplus_module_3.succeed(out))(element))(ref.get);
    const reset = ref.set([tsplus_module_6.none, self.initial]);
    const state = tsplus_module_7.map(tuple => tuple[1])(ref.get);
    return new Driver(next(self, ref), last, reset, state);
  })(tsplus_module_8.makeRef(() => [tsplus_module_6.none, self.initial]));
}

function next(self, ref) {
  return input => tsplus_module_5.flatMap(({
    now,
    decision: [state, out, decision]
  }) => decision._tag === "Done" ? tsplus_module_10.zipRight(tsplus_module_9.fail(tsplus_module_6.none))(ref.set([tsplus_module_6.some(out), state])) : tsplus_module_10.zipRight(tsplus_module_13.as(out)(tsplus_module_12.sleep(new DurationInternal(tsplus_module_11.start(decision.intervals) - now))))(ref.set([tsplus_module_6.some(out), state])))(tsplus_module_5.flatMap(state => tsplus_module_5.flatMap(now => tsplus_module_7.map(decision => ({
    now,
    decision
  }))(self.step(now, input, state)))(tsplus_module_14.currentTime))(tsplus_module_7.map(tuple => tuple[1])(ref.get)));
}
//# sourceMappingURL=driver.mjs.map