import * as tsplus_module_1 from "@effect/core/io/Schedule/Interval";
import * as tsplus_module_2 from "@effect/core/io/Schedule/Decision";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Duration";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/succeed";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * A schedule that can recur one time, the specified amount of time into the
 * future.
 *
 * @tsplus static effect/core/io/Schedule.Ops duration
 */

export function duration(duration) {
  return makeWithState(true, (now, _, state) => tsplus_module_4.succeed(state ? [false, duration, tsplus_module_2.continueWith(tsplus_module_1.after(now + duration.millis))] : [false, tsplus_module_3.millis(0), tsplus_module_2.done]));
}
//# sourceMappingURL=duration.mjs.map