import * as tsplus_module_1 from "@effect/core/io/Schedule/operations/repeatForever";
import * as tsplus_module_2 from "@effect/core/io/Schedule/operations/map";
import * as tsplus_module_3 from "@effect/core/io/Schedule/operations/delayedUsing";
import { DurationInternal } from "@tsplus/stdlib/data/Duration";
/**
 * A schedule that always recurs, but will wait a certain amount between
 * repetitions, given by `base * factor.pow(n)`, where `n` is the number of
 * repetitions so far. Returns the current duration between recurrences.
 *
 * @tsplus static effect/core/io/Schedule.Ops exponential
 */

export function exponential(base, factor = 2.0) {
  return tsplus_module_3.delayedUsing(tsplus_module_2.map(i => new DurationInternal(base.millis * Math.pow(factor, i)))(tsplus_module_1.repeatForever));
}
//# sourceMappingURL=exponential.mjs.map