import * as tsplus_module_1 from "@tsplus/stdlib/data/Duration";
import * as tsplus_module_2 from "@effect/core/io/Schedule/operations/unfold";
import * as tsplus_module_3 from "@effect/core/io/Schedule/operations/map";
import * as tsplus_module_4 from "@effect/core/io/Schedule/operations/delayedUsing";
/**
 * A schedule that always recurs, increasing delays by summing the preceding
 * two delays (similar to the fibonacci sequence). Returns the current
 * duration between recurrences.
 *
 * @tsplus static effect/core/io/Schedule.Ops fibonacci
 */

export function fibonacci(one) {
  return tsplus_module_4.delayedUsing(tsplus_module_3.map(out => out[0])(tsplus_module_2.unfold([one, one], ([a1, a2]) => [a2, tsplus_module_1.add(a2)(a1)])));
}
//# sourceMappingURL=fibonacci.mjs.map