import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/flatMap";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns a new schedule that effectfully folds over the outputs of this one.
 *
 * @tsplus static effect/core/io/Schedule.Aspects foldEffect
 * @tsplus pipeable effect/core/io/Schedule foldEffect
 */

export function foldEffect(z, f) {
  return self => makeWithState([self.initial, z], (now, input, [s, z]) => tsplus_module_3.flatMap(([s, out, decision]) => decision._tag === "Done" ? tsplus_module_1.succeed([[s, z], z, decision]) : tsplus_module_2.map(z2 => [[s, z2], z, decision])(f(z, out)))(self.step(now, input, s)));
}
//# sourceMappingURL=foldEffect.mjs.map