import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatMap";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns a new schedule that loops this one continuously, resetting the
 * state when this schedule is done.
 *
 * @tsplus getter effect/core/io/Schedule forever
 */

export function forever(self) {
  return makeWithState(self.initial, (now, input, state) => {
    function step(now, input, state) {
      return tsplus_module_2.flatMap(([state, out, decision]) => decision._tag === "Done" ? step(now, input, self.initial) : tsplus_module_1.succeed([state, out, decision]))(self.step(now, input, state));
    }

    return step(now, input, state);
  });
}
//# sourceMappingURL=forever.mjs.map