import * as tsplus_module_1 from "@effect/core/io/Random/operations/next";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_3 from "@effect/core/io/Schedule/operations/delayedEffect";
export const jittered = jittered_1;
import { DurationInternal } from "@tsplus/stdlib/data/Duration";
/**
 * Returns a new schedule that randomly modifies the size of the intervals of
 * this schedule.
 *
 * The new interval size is between `min * old interval size` and `max * old
 * interval size`.
 *
 * @tsplus static effect/core/io/Schedule.Aspects jittered
 * @tsplus pipeable effect/core/io/Schedule jittered
 */

function jittered_1(min, max) {
  return self => tsplus_module_3.delayedEffect(duration => tsplus_module_2.map(random => {
    const d = duration.millis;
    const jittered = d * min * (1 - random) + d * max * random;
    return new DurationInternal(jittered);
  })(tsplus_module_1.next))(self);
}
/**
 * Returns a new schedule that randomly modifies the size of the intervals of
 * this schedule.
 *
 * The new interval size is between `min * old interval size` and `max * old
 * interval size`.
 *
 * @tsplus getter effect/core/io/Schedule jitteredDefault
 */


export function jitteredDefault(self) {
  return jittered_1(0.8, 1.2)(self);
}
//# sourceMappingURL=jittered.mjs.map