import * as tsplus_module_1 from "@effect/core/io/Schedule/operations/repeatForever";
import * as tsplus_module_2 from "@effect/core/io/Schedule/operations/map";
import * as tsplus_module_3 from "@effect/core/io/Schedule/operations/delayedUsing";
import { DurationInternal } from "@tsplus/stdlib/data/Duration";
/**
 * A schedule that always recurs, but will repeat on a linear time interval,
 * given by `base * n` where `n` is the number of repetitions so far. Returns
 * the current duration between recurrences.
 *
 * @tsplus static effect/core/io/Schedule.Ops linear
 */

export function linear(base) {
  return tsplus_module_3.delayedUsing(tsplus_module_2.map(i => new DurationInternal(base.millis * (i + 1)))(tsplus_module_1.repeatForever));
}
//# sourceMappingURL=linear.mjs.map