import * as tsplus_module_1 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatMap";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns a new schedule that maps the output of this schedule through the
 * specified effectful function.
 *
 * @tsplus static effect/core/io/Schedule.Aspects mapEffect
 * @tsplus pipeable effect/core/io/Schedule mapEffect
 */

export function mapEffect(f) {
  return self => makeWithState(self.initial, (now, input, state) => tsplus_module_2.flatMap(([state, out, decision]) => tsplus_module_1.map(out2 => [state, out2, decision])(f(out)))(self.step(now, input, state)));
}
//# sourceMappingURL=mapEffect.mjs.map