import * as tsplus_module_1 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatMap";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns a new schedule that applies the current one but runs the specified
 * effect for every decision of this schedule. This can be used to create
 * schedules that log failures, decisions, or computed values.
 *
 * @tsplus static effect/core/io/Schedule.Aspects onDecision
 * @tsplus pipeable effect/core/io/Schedule onDecision
 */

export function onDecision(f) {
  return self => makeWithState(self.initial, (now, input, state) => tsplus_module_2.flatMap(([state, out, decision]) => tsplus_module_1.as([state, out, decision])(f(state, out, decision)))(self.step(now, input, state)));
}
//# sourceMappingURL=onDecision.mjs.map