import * as tsplus_module_1 from "@effect/core/io/Fiber/_internal/runtime";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns a new schedule with its environment provided to it, so the
 * resulting schedule does not require any environment.
 *
 * @tsplus static effect/core/io/Schedule.Aspects provideEnvironment
 * @tsplus pipeable effect/core/io/Schedule provideEnvironment
 */

export function provideEnvironment(environment) {
  return self => makeWithState(self.initial, (now, input, state) => tsplus_module_1.provideEnvironment(environment)(self.step(now, input, state)));
}
//# sourceMappingURL=provideEnvironment.mjs.map