import * as tsplus_module_1 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/environmentWithEffect";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns a new schedule with the single service it requires provided to it.
 * If the schedule requires multiple services use `provideEnvironment`
 * instead.
 *
 * @tsplus static effect/core/io/Schedule.Aspects provideService
 * @tsplus pipeable effect/core/io/Schedule provideService
 */

export function provideService(tag, service) {
  return self => makeWithState(self.initial, (now, input, state) => tsplus_module_2.environmentWithEffect(env => tsplus_module_1.provideEnvironment(env.add(tag, service))(self.step(now, input, state))));
}
//# sourceMappingURL=provideService.mjs.map