import * as tsplus_module_1 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_2 from "@effect/core/io/Schedule/operations/reconsiderEffect";
/**
 * Returns a new schedule that reconsiders every decision made by this
 * schedule, possibly modifying the next interval and the output type in the
 * process.
 *
 * @tsplus static effect/core/io/Schedule.Aspects reconsider
 * @tsplus pipeable effect/core/io/Schedule reconsider
 */

export function reconsider(f) {
  return self => tsplus_module_2.reconsiderEffect((state, out, decision) => tsplus_module_1.sync(() => f(state, out, decision)))(self);
}
//# sourceMappingURL=reconsider.mjs.map