import * as tsplus_module_1 from "@effect/core/io/Schedule/Decision";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/flatMap";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns a new schedule that effectfully reconsiders every decision made by
 * this schedule, possibly modifying the next interval and the output type in
 * the process.
 *
 * @tsplus static effect/core/io/Schedule.Aspects reconsiderEffect
 * @tsplus pipeable effect/core/io/Schedule reconsiderEffect
 */

export function reconsiderEffect(f) {
  return self => makeWithState(self.initial, (now, input, state) => tsplus_module_4.flatMap(([state, out, decision]) => decision._tag === "Done" ? tsplus_module_3.map(either => tsplus_module_2.fold(out2 => [state, out2, tsplus_module_1.done], ([out2]) => [state, out2, tsplus_module_1.done])(either))(f(state, out, decision)) : tsplus_module_3.map(either => tsplus_module_2.fold(out2 => [state, out2, tsplus_module_1.done], ([out2, interval]) => [state, out2, tsplus_module_1.continueWith(interval)])(either))(f(state, out, decision)))(self.step(now, input, state)));
}
//# sourceMappingURL=reconsiderEffect.mjs.map