import * as tsplus_module_1 from "@tsplus/stdlib/data/Duration";
import * as tsplus_module_2 from "@effect/core/io/Schedule/operations/elapsed";
import * as tsplus_module_3 from "@effect/core/io/Schedule/operations/intersect";
import * as tsplus_module_4 from "@effect/core/io/Schedule/operations/resetWhen";
import * as tsplus_module_5 from "@effect/core/io/Schedule/operations/map";
/**
 * Return a new schedule that automatically resets the schedule to its initial
 * state after some time of inactivity defined by `duration`.
 *
 * @tsplus static effect/core/io/Schedule.Aspects resetAfter
 * @tsplus pipeable effect/core/io/Schedule resetAfter
 */

export function resetAfter(duration) {
  return self => {
    return tsplus_module_5.map(out => out[0])(tsplus_module_4.resetWhen(t => tsplus_module_1.greaterThenOrEqual(duration)(t[1]))(tsplus_module_3.intersect(tsplus_module_2.elapsed)(self)));
  };
}
//# sourceMappingURL=resetAfter.mjs.map