import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/flatMap";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Resets the schedule when the specified predicate on the schedule output
 * evaluates to true.
 *
 * @tsplus static effect/core/io/Schedule.Aspects resetWhen
 * @tsplus pipeable effect/core/io/Schedule resetWhen
 */

export function resetWhen(f) {
  return self => makeWithState(self.initial, (now, input, state) => tsplus_module_2.flatMap(([state, out, decision]) => f(out) ? self.step(now, input, self.initial) : tsplus_module_1.succeed([state, out, decision]))(self.step(now, input, state)));
}
//# sourceMappingURL=resetWhen.mjs.map