import * as tsplus_module_1 from "@tsplus/stdlib/collections/List/from";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/List/definition";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/append";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_7 from "@effect/core/io/Schedule/Intervals";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Runs a schedule using the provided inputs, and collects all outputs.
 *
 * @tsplus static effect/core/io/Schedule.Aspects run
 * @tsplus pipeable effect/core/io/Schedule run
 */

export function run(now, input) {
  return self => runLoop(self, now, tsplus_module_1.from(input), self.initial, tsplus_module_2.empty());
}

function runLoop(self, now, inputs, state, acc) {
  if (tsplus_module_3.isNil(inputs)) {
    return tsplus_module_4.succeed(acc);
  }

  const input = inputs.head;
  const nextInputs = inputs.tail;
  return tsplus_module_8.flatMap(([state, out, decision]) => {
    switch (decision._tag) {
      case "Done":
        {
          return tsplus_module_6.sync(() => tsplus_module_5.append(out)(acc));
        }

      case "Continue":
        {
          return runLoop(self, tsplus_module_7.start(decision.intervals), nextInputs, state, tsplus_module_5.append(out)(acc));
        }
    }
  })(self.step(now, input, state));
}
//# sourceMappingURL=run.mjs.map