import * as tsplus_module_1 from "@effect/core/io/Effect/operations/zipRight";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns a new schedule that effectfully processes every input to this
 * schedule.
 *
 * @tsplus static effect/core/io/Schedule.Aspects tapInput
 * @tsplus pipeable effect/core/io/Schedule tapInput
 */

export function tapInput(f) {
  return self => makeWithState(self.initial, (now, input, state) => tsplus_module_1.zipRight(self.step(now, input, state))(f(input)));
}
//# sourceMappingURL=tapInput.mjs.map