import * as tsplus_module_1 from "@effect/core/io/Effect/operations/tap";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Returns a new schedule that effectfully processes every output from this
 * schedule.
 *
 * @tsplus static effect/core/io/Schedule.Aspects tapOutput
 * @tsplus pipeable effect/core/io/Schedule tapOutput
 */

export function tapOutput(f) {
  return self => makeWithState(self.initial, (now, input, state) => tsplus_module_1.tap(([, out]) => f(out))(self.step(now, input, state)));
}
//# sourceMappingURL=tapOutput.mjs.map