import * as tsplus_module_1 from "@effect/core/io/Schedule/Interval";
import * as tsplus_module_2 from "@effect/core/io/Schedule/Decision";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/sync";
import { makeWithState } from "@effect/core/io/Schedule/operations/_internal/makeWithState";
/**
 * Unfolds a schedule that repeats one time from the specified state and
 * iterator.
 *
 * @tsplus static effect/core/io/Schedule.Ops unfold
 */

export function unfold(initial, f) {
  return makeWithState(initial, (now, _, state) => tsplus_module_3.sync(() => [f(state), state, tsplus_module_2.continueWith(tsplus_module_1.after(now))]));
}
//# sourceMappingURL=unfold.mjs.map