import * as tsplus_module_1 from "@effect/core/io/Schedule/Intervals";
import * as tsplus_module_2 from "@effect/core/io/Schedule/operations/unionWith";
/**
 * Returns a new schedule that performs a geometric union on the intervals
 * defined by both schedules.
 *
 * @tsplus pipeable-operator effect/core/io/Schedule ||
 * @tsplus static effect/core/io/Schedule.Aspects union
 * @tsplus pipeable effect/core/io/Schedule union
 */

export function union(that) {
  return self => tsplus_module_2.unionWith(that, (x, y) => tsplus_module_1.union(y)(x))(self);
}
//# sourceMappingURL=union.mjs.map