import * as tsplus_module_1 from "@effect/core/io/Effect/operations/negate";
import * as tsplus_module_2 from "@effect/core/io/Schedule/operations/checkEffect";
/**
 * Returns a new schedule that continues until the specified effectful
 * predicate on the input evaluates to true.
 *
 * @tsplus static effect/core/io/Schedule.Aspects untilInputEffect
 * @tsplus pipeable effect/core/io/Schedule untilInputEffect
 */

export function untilInputEffect(f) {
  return self => tsplus_module_2.checkEffect((input, _) => tsplus_module_1.negate(f(input)))(self);
}
//# sourceMappingURL=untilInputEffect.mjs.map