import * as tsplus_module_1 from "@effect/core/io/Schedule/operations/check";
/**
 * Returns a new schedule that continues until the specified predicate on the
 * output evaluates to true.
 *
 * @tsplus static effect/core/io/Schedule.Aspects untilOutput
 * @tsplus pipeable effect/core/io/Schedule untilOutput
 */

export function untilOutput(f) {
  return self => tsplus_module_1.check((_, out) => !f(out))(self);
}
//# sourceMappingURL=untilOutput.mjs.map