import * as tsplus_module_1 from "@effect/core/io/Effect/operations/negate";
import * as tsplus_module_2 from "@effect/core/io/Schedule/operations/checkEffect";
/**
 * Returns a new schedule that continues until the specified effectful
 * predicate on the output evaluates to true.
 *
 * @tsplus static effect/core/io/Schedule.Aspects untilOutputEffect
 * @tsplus pipeable effect/core/io/Schedule untilOutputEffect
 */

export function untilOutputEffect(f) {
  return self => tsplus_module_2.checkEffect((_, out) => tsplus_module_1.negate(f(out)))(self);
}
//# sourceMappingURL=untilOutputEffect.mjs.map