import * as tsplus_module_1 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_2 from "@effect/core/io/Scope/ReleaseMap/operations/release";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_4 from "@effect/core/io/Scope/ReleaseMap/operations/addIfOpen";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/map";
/**
 * Adds a finalizer to the finalizers associated with this scope. If the
 * finalizers associated with this scope have already been run this
 * finalizer will be run immediately.
 *
 * The finalizer returned from this method will remove the original
 * finalizer from the map and run it.
 *
 * @tsplus static effect/core/io/ReleaseMap.Aspects add
 * @tsplus pipeable effect/core/io/ReleaseMap add
 */

export function add(finalizer) {
  return self => tsplus_module_5.map(_ => tsplus_module_3.fold(() => () => tsplus_module_1.unit, k => e => tsplus_module_2.release(k, e)(self))(_))(tsplus_module_4.addIfOpen(finalizer)(self));
}
//# sourceMappingURL=add.mjs.map