import * as tsplus_module_1 from "@effect/core/io/Scope/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/service/Env";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/provideSomeEnvironment";
/**
 * Extends the scope of an `Effect` workflow that needs a scope into this
 * scope by providing it to the workflow but not closing the scope when the
 * workflow completes execution. This allows extending a scoped value into a
 * larger scope.
 *
 * @tsplus static effect/core/io/Scope.Aspects extend
 * @tsplus pipeable effect/core/io/Scope extend
 * @tsplus pipeable effect/core/io/Scope/Closeable extend
 */

export function extend(effect) {
  return self => tsplus_module_3.provideSomeEnvironment(env => env.merge(tsplus_module_2.Env(tsplus_module_1.Scope.Tag, self)))(effect);
}
//# sourceMappingURL=extend.mjs.map