import * as tsplus_module_1 from "@effect/core/io/Scope/operations/close";
import * as tsplus_module_2 from "@effect/core/io/Scope/operations/extend";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/onExit";
/**
 * Uses the scope by providing it to an `Effect` workflow that needs a scope,
 * guaranteeing that the scope is closed with the result of that workflow as
 * soon as the workflow completes execution, whether by success, failure, or
 * interruption.
 *
 * @tsplus pipeable effect/core/io/Scope/Closeable use
 */

export function use(effect) {
  return self => tsplus_module_3.onExit(exit => tsplus_module_1.close(exit)(self))(tsplus_module_2.extend(effect)(self));
}
//# sourceMappingURL=use.mjs.map