import * as tsplus_module_1 from "@effect/core/io/Effect/operations/addFinalizer";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_3 from "@effect/core/io/Ref/operations/make";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_5 from "@effect/core/io/Exit/operations/fail";
import * as tsplus_module_6 from "@effect/core/io/Scope/operations/close";
import * as tsplus_module_7 from "@effect/core/io/Scope/definition";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/provideSomeEnvironment";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/onError";
import * as tsplus_module_10 from "@effect/core/io/Scope/operations/make";
import * as tsplus_module_11 from "@effect/core/io/Fiber/_internal/runtime";
import { ScopedRefInternal } from "@effect/core/io/ScopedRef/operations/_internal/ScopedRefInternal";
/**
 * Creates a new `ScopedRef` from an effect that resourcefully produces a
 * value.
 *
 * @tsplus static effect/core/io/ScopedRef.Ops fromAcquire
 */

export function fromAcquire(acquire) {
  return tsplus_module_11.uninterruptibleMask(({
    restore
  }) => tsplus_module_4.flatMap(newScope => tsplus_module_4.flatMap(a => tsplus_module_4.flatMap(ref => {
    const scopedRef = new ScopedRefInternal(ref);
    return tsplus_module_2.map(() => scopedRef)(tsplus_module_1.addFinalizer(scopedRef.close));
  })(tsplus_module_3.makeSynchronized(() => [newScope, a])))(tsplus_module_9.onError(cause => tsplus_module_6.close(tsplus_module_5.fail(cause))(newScope))(restore(tsplus_module_8.provideSomeEnvironment(env => env.add(tsplus_module_7.Scope.Tag, newScope))(acquire)))))(tsplus_module_10.make));
}
//# sourceMappingURL=fromAcquire.mjs.map