var _a, _b;

import * as tsplus_module_1 from "@effect/core/stm/STM/Versioned";
import { Versioned } from "@effect/core/stm/STM/Versioned";
import { concreteTRef } from "@effect/core/stm/TRef/operations/_internal/TRefInternal";
export const EntrySym = /*#__PURE__*/Symbol.for("@effect/core/stm/STM/Entry");
/**
 * @tsplus type effect/core/stm/STM/Entry
 * @tsplus companion effect/core/stm/STM/Entry.Ops
 */

export class Entry {
  constructor(use) {
    this.use = use;
    this[_a] = EntrySym;
  }

}
_a = EntrySym;
/**
 * @tsplus static effect/core/stm/STM/Entry.Ops __call
 */

export function makeEntry(tref0, isNew0) {
  void 0;
  const versioned = tref0.versioned;
  const ops = new EntryOps(tref0, versioned, versioned.value, isNew0, false);
  return new Entry(f => f(ops));
}
export const EntryOpsSym = /*#__PURE__*/Symbol.for("@effect/core/stm/STM/Entry/Ops");
export class EntryOps {
  constructor(tref, expected, newValue, isNew, isChanged) {
    this[_b] = EntryOpsSym;
    this.tref = tref;
    this.expected = expected;
    this.newValue = newValue;
    this.isNew = isNew;
    this._isChanged = isChanged;
  }

  unsafeSet(value) {
    this._isChanged = true;
    this.newValue = value;
  }

  unsafeGet() {
    return this.newValue;
  }

  commit() {
    void 0;
    this.tref.versioned = tsplus_module_1.make(this.newValue);
  }

  copy() {
    const ops = new EntryOps(this.tref, this.expected, this.newValue, this.isNew, this.isChanged());
    return new Entry(f => f(ops));
  }

  isInvalid() {
    return !this.isValid();
  }

  isValid() {
    void 0;
    return this.tref.versioned === this.expected;
  }

  isChanged() {
    return this._isChanged;
  }

  toString() {
    return `Entry(expected.value = ${this.expected.value}, newValue = ${this.newValue}, tref = ${this.tref}, isChanged = ${this.isChanged()})`;
  }

}
_b = EntryOpsSym;
//# sourceMappingURL=Entry.mjs.map