import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
/**
 * Recovers from specified error.
 *
 * @tsplus static effect/core/stm/STM.Aspects catchTag
 * @tsplus pipeable effect/core/stm/STM catchTag
 */

export function catchTag(k, f, __trace) {
  return self => tsplus_module_1.catchAll(e => {
    if ("_tag" in e && e["_tag"] === k) {
      return f(e);
    }

    return tsplus_module_1.fail(() => e);
  })(self);
}
//# sourceMappingURL=catchTag.mjs.map