import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/compact";
import * as tsplus_module_2 from "@effect/core/stm/STM/operations/unsome";
import * as tsplus_module_3 from "@effect/core/stm/STM/operations/forEach";
import * as tsplus_module_4 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_5 from "@effect/core/stm/STM/operations/collectSTM";
/**
 * Evaluate each effect in the structure from left to right, collecting the
 * the successful values and discarding the empty cases.
 *
 * @tsplus static effect/core/stm/STM.Ops collect
 */

export function collect(as, f) {
  return tsplus_module_4.map(chunk => tsplus_module_1.compact(chunk))(tsplus_module_3.forEach(as, a => tsplus_module_2.unsome(f(a))));
}
/**
 * Simultaneously filters and maps the value produced by this effect.
 *
 * @tsplus static effect/core/stm/STM.Aspects collect
 * @tsplus pipeable effect/core/stm/STM collect
 */

export function collectNow(pf) {
  return self => tsplus_module_5.collectSTM(_ => tsplus_module_4.succeed(pf(_)))(self);
}
//# sourceMappingURL=collect.mjs.map