import * as tsplus_module_1 from "@effect/core/stm/STM/operations/suspend";
import * as tsplus_module_2 from "@effect/core/stm/STM/operations/succeedNone";
import * as tsplus_module_3 from "@effect/core/stm/STM/operations/succeedSome";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_5 from "@effect/core/stm/STM/definition/primitives";
/**
 * Collects the first element of the `Collection<A?` for which the effectual
 * function `f` returns `Some`.
 *
 * @tsplus static effect/core/stm/STM.Ops collectFirst
 */

export function collectFirst(as, f) {
  return tsplus_module_1.suspend(() => loop(as[Symbol.iterator](), f));
}

function loop(iterator, f) {
  const next = iterator.next();
  return next.done ? tsplus_module_2.succeedNone : tsplus_module_5.flatMap(option => tsplus_module_4.fold(() => loop(iterator, f), tsplus_module_3.succeedSome)(option))(f(next.value));
}
//# sourceMappingURL=collectFirst.mjs.map