import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@effect/core/stm/STM/operations/failSync";
import * as tsplus_module_3 from "@effect/core/stm/STM/operations/suspend";
/**
 * Evaluate the predicate, return the given `A` as success if predicate returns
 * true, and the given `E` as error otherwise
 *
 * For effectful conditionals, see `ifSTM`.
 *
 * @tsplus static effect/core/stm/STM.Ops cond
 */

export function cond(predicate, result, error) {
  return tsplus_module_3.suspend(() => predicate() ? tsplus_module_1.sync(result) : tsplus_module_2.failSync(error));
}
//# sourceMappingURL=cond.mjs.map