import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/getOrElse";
/**
 * Fail with `e` if the supplied partial function does not match, otherwise
 * continue with the returned value.
 *
 * @tsplus static effect/core/stm/STM.Aspects continueOrFailSTM
 * @tsplus pipeable effect/core/stm/STM continueOrFailSTM
 */

export function continueOrFailSTM(e, pf) {
  return self => tsplus_module_1.flatMap(a => tsplus_module_2.getOrElse_(pf(a), () => tsplus_module_1.fail(e)))(self);
}
//# sourceMappingURL=continueOrFailSTM.mjs.map