import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/map";
import * as tsplus_module_3 from "@effect/core/stm/STM/operations/continueOrRetrySTM";
/**
 * Retry the transaction if the supplied partial function does not match,
 * otherwise succeed with the returned value.
 *
 * @tsplus static effect/core/stm/STM.Aspects continueOrRetry
 * @tsplus pipeable effect/core/stm/STM continueOrRetry
 */

export function continueOrRetry(pf) {
  return self => tsplus_module_3.continueOrRetrySTM(x => tsplus_module_2.map(tsplus_module_1.succeed)(pf(x)))(self);
}
//# sourceMappingURL=continueOrRetry.mjs.map