import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
/**
 * Binds an effectful value in a `do` scope
 *
 * @tsplus static effect/core/stm/STM.Aspects bind
 * @tsplus pipeable effect/core/stm/STM bind
 */

export function bind(tag, f) {
  return self => tsplus_module_1.flatMap(k => tsplus_module_1.map(a => ({ ...k,
    [tag]: a
  }))(f(k)))(self);
}
/**
 * Like bind for values
 *
 * @tsplus static effect/core/stm/STM.Aspects bindValue
 * @tsplus pipeable effect/core/stm/STM bindValue
 */

export function bindValue(tag, f) {
  return self => tsplus_module_1.map(k => ({ ...k,
    [tag]: f(k)
  }))(self);
}
/**
 * @tsplus static effect/core/stm/STM.Ops Do
 */

export function Do() {
  return tsplus_module_1.succeed({});
}
//# sourceMappingURL=do.mjs.map