import * as tsplus_module_1 from "@effect/core/stm/STM/operations/suspend";
import * as tsplus_module_2 from "@effect/core/stm/STM/definition/primitives";
/**
 * Determines whether any element of the `Collection<A>` satisfies the effectual
 * predicate `f`.
 *
 * @tsplus static effect/core/stm/STM.Ops exists
 */

export function exists(as, f) {
  return tsplus_module_1.suspend(() => loop(as[Symbol.iterator](), f));
}

function loop(iterator, f) {
  const next = iterator.next();

  if (next.done) {
    return tsplus_module_2.succeed(false);
  }

  return tsplus_module_2.flatMap(b => b ? tsplus_module_2.succeed(b) : tsplus_module_1.suspend(() => loop(iterator, f)))(f(next.value));
}
//# sourceMappingURL=exists.mjs.map