import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@effect/core/stm/STM/operations/flipWith";
/**
 * Creates a composite effect that represents this effect followed by another
 * one that may depend on the error produced by this one.
 *
 * @tsplus static effect/core/stm/STM.Aspects flatMapError
 * @tsplus pipeable effect/core/stm/STM flatMapError
 */

export function flatMapError(f) {
  return self => tsplus_module_2.flipWith(_ => tsplus_module_1.flatMap(f)(_))(self);
}
//# sourceMappingURL=flatMapError.mjs.map