import * as tsplus_module_1 from "@effect/core/stm/STM/operations/suspend";
import * as tsplus_module_2 from "@effect/core/stm/STM/definition/primitives";
/**
 * Determines whether all elements of the `Collection<A>` satisfies the effectual
 * predicate `f`.
 *
 * @tsplus static effect/core/stm/STM.Ops forAll
 */

export function forAll(as, f) {
  return tsplus_module_1.suspend(() => loop(as[Symbol.iterator](), f));
}

function loop(iterator, f) {
  const next = iterator.next();
  return next.done ? tsplus_module_2.succeed(true) : tsplus_module_2.flatMap(b => b ? loop(iterator, f) : tsplus_module_2.succeed(b))(f(next.value));
}
//# sourceMappingURL=forAll.mjs.map