import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_3 from "@effect/core/stm/STM/operations/suspend";
/**
 * Applies the function `f` to each element of the `Collection<A>` and
 * returns a transactional effect that produces a new `Chunk<B>`.
 *
 * @tsplus static effect/core/stm/STM.Ops forEach
 */

export function forEach(as, f) {
  return tsplus_module_3.suspend(() => {
    let stm = tsplus_module_1.succeed([]);

    for (const a of as) {
      stm = tsplus_module_1.zipWith(f(a), (acc, b) => {
        acc.push(b);
        return acc;
      })(stm);
    }

    return tsplus_module_1.map(tsplus_module_2.from)(stm);
  });
}
//# sourceMappingURL=forEach.mjs.map