import * as tsplus_module_1 from "@effect/core/stm/STM/operations/suspend";
import * as tsplus_module_2 from "@effect/core/stm/STM/operations/unit";
import * as tsplus_module_3 from "@effect/core/stm/STM/definition/primitives";
/**
 * Applies the function `f` to each element of the `Collection<A>` and runs
 * produced effects sequentially.
 *
 * Equivalent to `unit(forEach(as, f))`, but without the cost of building
 * the list of results.
 *
 * @tsplus static effect/core/stm/STM.Ops forEachDiscard
 */

export function forEachDiscard(as, f) {
  return tsplus_module_1.suspend(() => loop(as[Symbol.iterator](), f));
}

function loop(iterator, f) {
  const next = iterator.next();
  return next.done ? tsplus_module_2.unit_ : tsplus_module_3.zipRight(loop(iterator, f))(f(next.value));
}
//# sourceMappingURL=forEachDiscard.mjs.map