import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@effect/core/stm/STM/operations/suspend";
export const iterate = iterate_1;
/**
 * Iterates with the specified effectual function. The moral equivalent of:
 *
 * ```typescript
 * let s = initial
 *
 * while (cont(s)) {
 *   s = body(s)
 * }
 *
 * return s
 * ```
 *
 * @tsplus static effect/core/stm/STM.Ops iterate
 */

function iterate_1(initial, cont) {
  return body => {
    return tsplus_module_2.suspend(() => {
      if (cont(initial)) {
        return tsplus_module_1.flatMap(z2 => iterate_1(z2, cont)(body))(body(initial));
      }

      return tsplus_module_1.succeed(initial);
    });
  };
}
//# sourceMappingURL=iterate.mjs.map