import * as tsplus_module_1 from "@effect/core/stm/STM/operations/failSync";
import * as tsplus_module_2 from "@effect/core/stm/STM/definition/primitives";
/**
 * Returns an `STM` effect whose failure and success channels have been mapped by
 * the specified pair of functions, `f` and `g`.
 *
 * @tsplus static effect/core/stm/STM.Aspects mapBoth
 * @tsplus pipeable effect/core/stm/STM mapBoth
 */

export function mapBoth(g, f) {
  return self => tsplus_module_2.foldSTM(e => tsplus_module_1.failSync(() => g(e)), a => tsplus_module_2.sync(() => f(a)))(self);
}
//# sourceMappingURL=mapBoth.mjs.map