import * as tsplus_module_1 from "@effect/core/stm/STM/operations/tryCatch";
import * as tsplus_module_2 from "@effect/core/stm/STM/definition/primitives";
/**
 * Returns an effect whose success is mapped by the specified side effecting
 * `f` function, translating any thrown exceptions into typed failed effects.
 *
 * @tsplus static effect/core/stm/STM.Aspects mapTryCatch
 * @tsplus pipeable effect/core/stm/STM mapTryCatch
 */

export function mapTryCatch(f, onThrow) {
  return self => tsplus_module_2.flatMap(a => tsplus_module_1.tryCatch(() => f(a), onThrow))(self);
}
//# sourceMappingURL=mapTryCatch.mjs.map