import * as tsplus_module_1 from "@effect/core/stm/STM/operations/dieSync";
import * as tsplus_module_2 from "@effect/core/stm/STM/operations/mapError";
import * as tsplus_module_3 from "@effect/core/stm/STM/definition/primitives";
/**
 * Keeps none of the errors, and terminates the fiber running the `STM` effect
 * with them, using the specified function to convert the `E` into a
 * `unknown` defect.
 *
 * @tsplus static effect/core/stm/STM.Aspects orDieWith
 * @tsplus pipeable effect/core/stm/STM orDieWith
 */

export function orDieWith(f) {
  return self => tsplus_module_3.catchAll(e => tsplus_module_1.dieSync(() => e))(tsplus_module_2.mapError(f)(self));
}
//# sourceMappingURL=orDieWith.mjs.map