import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@effect/core/stm/STM/operations/orTry";
import { prepareResetJournal, STMEffect } from "@effect/core/stm/STM/definition/primitives";
/**
 * Tries this effect first, and if it fails or retries, tries the other
 * effect.
 *
 * @tsplus pipeable-operator effect/core/stm/STM |
 * @tsplus static effect/core/stm/STM.Aspects orElse
 * @tsplus pipeable effect/core/stm/STM orElse
 */

export function orElse(that) {
  return self => tsplus_module_1.flatMap(reset => tsplus_module_1.catchAll(() => tsplus_module_1.zipRight(that())(tsplus_module_1.sync(() => reset())))(tsplus_module_2.orTry(() => tsplus_module_1.zipRight(that())(tsplus_module_1.sync(() => reset())))(self)))(new STMEffect(journal => prepareResetJournal(journal)));
}
//# sourceMappingURL=orElse.mjs.map