import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_3 from "@effect/core/stm/STM/operations/orElse";
/**
 * Returns a transactional effect that will produce the value of this effect
 * in left side, unless it fails or retries, in which case, it will produce
 * the value of the specified effect in right side.
 *
 * @tsplus static effect/core/stm/STM.Aspects orElseEither
 * @tsplus pipeable effect/core/stm/STM orElseEither
 */

export function orElseEither(that) {
  return self => tsplus_module_3.orElse(() => tsplus_module_2.map(tsplus_module_1.right)(that()))(tsplus_module_2.map(tsplus_module_1.left)(self));
}
//# sourceMappingURL=orElseEither.mjs.map