import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/fold";
/**
 * Returns an effect that will produce the value of this effect, unless it
 * fails with the `None` value, in which case it will produce the value of the
 * specified effect.
 *
 * @tsplus static effect/core/stm/STM.Aspects orElseOptional
 * @tsplus pipeable effect/core/stm/STM orElseOptional
 */

export function orElseOptional(that) {
  return self => tsplus_module_2.catchAll(option => tsplus_module_3.fold(that, e => tsplus_module_2.fail(tsplus_module_1.some(e)))(option))(self);
}
//# sourceMappingURL=orElseOptional.mjs.map