import { STMOnRetry } from "@effect/core/stm/STM/definition/primitives";
/**
 * Tries this effect first, and if it enters retry, then it tries the other
 * effect. This is an equivalent of haskell's orElse.
 *
 * @tsplus static effect/core/stm/STM.Aspects orTry
 * @tsplus pipeable effect/core/stm/STM orTry
 */

export function orTry(that) {
  return self => new STMOnRetry(self, that);
}
//# sourceMappingURL=orTry.mjs.map