import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Collection/functions";
import * as tsplus_module_3 from "@effect/core/stm/STM/operations/suspend";
/**
 * Folds an `Collection<A>` using an effectual function f, working sequentially
 * from left to right.
 *
 * @tsplus static effect/core/stm/STM.Ops reduce
 */

export function reduce(as, z, f) {
  return tsplus_module_3.suspend(() => tsplus_module_2.reduce(tsplus_module_1.succeed(z), (acc, el) => tsplus_module_1.flatMap(a => f(a, el))(acc))(as));
}
//# sourceMappingURL=reduce.mjs.map