import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Collection/functions";
import * as tsplus_module_3 from "@effect/core/stm/STM/operations/suspend";
/**
 * Reduces an `Collection<STM<R, E, A>>` to a single `STM<R, E, A>`, working
 * sequentially.
 *
 * @tsplus static effect/core/stm/STM.Ops reduceAll
 */

export function reduceAll(a, as, f) {
  return tsplus_module_3.suspend(() => tsplus_module_2.reduce(a, (acc, a) => tsplus_module_1.zipWith(a, f)(acc))(as));
}
//# sourceMappingURL=reduceAll.mjs.map