import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/reduceRight";
import * as tsplus_module_4 from "@effect/core/stm/STM/operations/suspend";
/**
 * Folds an `Collection<A>` using an effectual function f, working sequentially from left to right.
 *
 * @tsplus static effect/core/stm/STM.Ops reduceRight
 */

export function reduceRight_(as, z, f) {
  return tsplus_module_4.suspend(() => tsplus_module_3.reduceRight(tsplus_module_1.succeed(z), (el, acc) => tsplus_module_1.flatMap(a => f(el, a))(acc))(tsplus_module_2.from(as)));
}
//# sourceMappingURL=reduceRight.mjs.map