import * as tsplus_module_1 from "@effect/core/stm/STM/operations/dieSync";
import * as tsplus_module_2 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/fold";
/**
 * Keeps some of the errors, and terminates the fiber with the rest, using
 * the specified function to convert the `E` into a `Throwable`.
 *
 * @tsplus static effect/core/stm/STM.Aspects refineOrDieWith
 * @tsplus pipeable effect/core/stm/STM refineOrDieWith
 */

export function refineOrDieWith(pf, f) {
  return self => tsplus_module_2.catchAll(e => tsplus_module_3.fold(() => tsplus_module_1.dieSync(() => f(e)), e1 => tsplus_module_2.fail(e1))(pf(e)))(self);
}
//# sourceMappingURL=refineOrDieWith.mjs.map