import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/fold";
/**
 * Continue with the returned computation if the `PartialFunction` matches,
 * translating the successful match into a failure, otherwise continue with
 * our held value.
 *
 * @tsplus static effect/core/stm/STM.Aspects rejectSTM
 * @tsplus pipeable effect/core/stm/STM rejectSTM
 */

export function rejectSTM(pf) {
  return self => tsplus_module_1.flatMap(a => tsplus_module_2.fold(() => tsplus_module_1.succeed(a), effect => tsplus_module_1.flatMap(tsplus_module_1.fail)(effect))(pf(a)))(self);
}
//# sourceMappingURL=rejectSTM.mjs.map