import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/range";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/map";
export const replicate = replicate_1;
/**
 * Replicates the given effect `n` times.
 *
 * @tsplus static effect/core/stm/STM.Ops replicate
 */

function replicate_1(n, stm) {
  return tsplus_module_2.map(() => stm)(tsplus_module_1.range(0, n - 1));
}
/**
 * Replicates the given effect `n` times.
 *
 * @tsplus static effect/core/stm/STM.Aspects replicate
 * @tsplus pipeable effect/core/stm/STM replicate
 */


export function replicateNow(n) {
  return self => replicate_1(n, self);
}
//# sourceMappingURL=replicate.mjs.map