import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
/**
 * Summarizes a `STM` effect by computing a provided value before and after
 * execution, and then combining the values to produce a summary, together
 * with the result of execution.
 *
 * @tsplus static effect/core/stm/STM.Aspects summarized
 * @tsplus pipeable effect/core/stm/STM summarized
 */

export function summarized(summary, f) {
  return self => tsplus_module_1.flatMap(start => tsplus_module_1.flatMap(value => tsplus_module_1.map(end => [f(start, end), value])(summary))(self))(summary);
}
//# sourceMappingURL=summarized.mjs.map