import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@effect/core/stm/STM/operations/failSync";
import * as tsplus_module_3 from "@effect/core/stm/STM/operations/suspend";
/**
 * Imports a synchronous side-effect into a pure value, translating any
 * thrown exceptions into typed failed effects.
 *
 * @tsplus static effect/core/stm/STM.Ops tryCatch
 */

export function tryCatch(attempt, onThrow) {
  return tsplus_module_3.suspend(() => {
    try {
      return tsplus_module_1.succeed(attempt());
    } catch (error) {
      return tsplus_module_2.failSync(() => onThrow(error));
    }
  });
}
//# sourceMappingURL=tryCatch.mjs.map