import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_3 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_4 from "@effect/core/stm/STM/operations/partition";
/**
 * Feeds elements of type `A` to `f` and accumulates all errors in error
 * channel or successes in success channel.
 *
 * This combinator is lossy meaning that if there are errors all successes
 * will be lost. To retain all information please use `partition`.
 *
 * @tsplus static effect/core/stm/STM.Ops validate
 */

export function validate(as, f) {
  return tsplus_module_3.flatMap(([es, bs]) => tsplus_module_1.isEmpty(es) ? tsplus_module_3.succeed(tsplus_module_2.from(bs)) : tsplus_module_3.fail(es))(tsplus_module_4.partition(as, f));
}
//# sourceMappingURL=validate.mjs.map