import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/flatMap";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@effect/core/stm/TArray/operations/find";
import * as tsplus_module_4 from "@effect/core/stm/STM/definition/primitives";
/**
 * Finds the result of applying a partial function to the first value in its
 * domain.
 *
 * @tsplus static effect/core/stm/TArray.Aspects collectFirst
 * @tsplus pipeable effect/core/stm/TArray collectFirst
 */

export function collectFirst(pf) {
  return self => tsplus_module_4.map(option => tsplus_module_1.flatMap(pf)(option))(tsplus_module_3.find(a => tsplus_module_2.isSome(pf(a)))(self));
}
//# sourceMappingURL=collectFirst.mjs.map