import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_3 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_4 from "@effect/core/stm/STM/operations/effect";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
/**
 * Get the index of the first entry in the array, starting at a specific
 * index, matching a predicate.
 *
 * @tsplus static effect/core/stm/TArray.Aspects indexWhereFrom
 * @tsplus pipeable effect/core/stm/TArray indexWhereFrom
 */

export function indexWhereFrom(f, from) {
  return self => {
    if (from < 0) {
      return tsplus_module_1.succeed(-1);
    }

    return tsplus_module_4.effect(journal => {
      let i = from;
      let found = false;
      void 0;

      while (!found && i < self.chunk.length) {
        const a = tsplus_module_3.unsafeGet(journal)(tsplus_module_2.unsafeGet(i)(self.chunk));
        found = f(a);
        i = i + 1;
      }

      return found ? i - 1 : -1;
    });
  };
}
//# sourceMappingURL=indexWhereFrom.mjs.map