import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_3 from "@effect/core/stm/TRef/operations/get";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
/**
 * Starting at specified index, get the index of the next entry that matches a
 * transactional predicate.
 *
 * @tsplus static effect/core/stm/TArray.Aspects indexWhereFromSTM
 * @tsplus pipeable effect/core/stm/TArray indexWhereFromSTM
 */

export function indexWhereFromSTM(f, from) {
  return self => {
    if (from < 0) {
      return tsplus_module_1.succeed(-1);
    }

    return forIndex(self, from, f);
  };
}

function forIndex(self, index, f) {
  void 0;
  return index < self.chunk.length ? tsplus_module_1.flatMap(result => result ? tsplus_module_1.succeed(index) : forIndex(self, index + 1, f))(tsplus_module_1.flatMap(f)(tsplus_module_3.get(tsplus_module_2.unsafeGet(index)(self.chunk)))) : tsplus_module_1.succeed(-1);
}
//# sourceMappingURL=indexWhereFromSTM.mjs.map