import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_3 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_4 from "@effect/core/stm/STM/operations/effect";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
/**
 * Get the first index of a specific value in the array, bounded above by a
 * specific index, or -1 if it does not occur.
 *
 * @tsplus static effect/core/stm/TArray.Aspects lastIndexOfFrom
 * @tsplus pipeable effect/core/stm/TArray lastIndexOfFrom
 */

export function lastIndexOfFrom(equivalence, value, end) {
  return self => {
    void 0;

    if (end >= self.chunk.length) {
      return tsplus_module_1.succeed(-1);
    }

    return tsplus_module_4.effect(journal => {
      let i = end;
      let found = false;

      while (!found && i >= 0) {
        const element = tsplus_module_3.unsafeGet(journal)(tsplus_module_2.unsafeGet(i)(self.chunk));
        found = equivalence.equals(element, value);
        i = i - 1;
      }

      return found ? i + 1 : -1;
    });
  };
}
//# sourceMappingURL=lastIndexOfFrom.mjs.map