import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_2 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_3 from "@effect/core/stm/STM/operations/effect";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
/**
 * Atomically folds using a pure function.
 *
 * @tsplus static effect/core/stm/TArray.Aspects reduce
 * @tsplus pipeable effect/core/stm/TArray reduce
 */

export function reduce(zero, f) {
  return self => tsplus_module_3.effect(journal => {
    let result = zero;
    let i = 0;
    void 0;

    while (i < self.chunk.length) {
      const value = tsplus_module_2.unsafeGet(journal)(tsplus_module_1.unsafeGet(i)(self.chunk));
      result = f(result, value);
      i = i + 1;
    }

    return result;
  });
}
//# sourceMappingURL=reduce.mjs.map