import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_2 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/fromNullable";
import * as tsplus_module_4 from "@effect/core/stm/STM/operations/effect";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
/**
 * Atomically reduce the array, if non-empty, by a binary operator.
 *
 * @tsplus static effect/core/stm/TArray.Aspects reduceMaybe
 * @tsplus pipeable effect/core/stm/TArray reduceMaybe
 */

export function reduceMaybe(f) {
  return self => tsplus_module_4.effect(journal => {
    let i = 0;
    let result = undefined;
    void 0;

    while (i < self.chunk.length) {
      const a = tsplus_module_2.unsafeGet(journal)(tsplus_module_1.unsafeGet(i)(self.chunk));
      result = result == null ? a : f(a, result);
      i = i + 1;
    }

    return tsplus_module_3.fromNullable(result);
  });
}
//# sourceMappingURL=reduceMaybe.mjs.map