import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_2 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_3 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_4 from "@effect/core/stm/STM/operations/effect";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
/**
 * Atomically updates all elements using a pure function.
 *
 * @tsplus static effect/core/stm/TArray.Aspects transform
 * @tsplus pipeable effect/core/stm/TArray transform
 */

export function transform(f) {
  return self => tsplus_module_4.effect(journal => {
    let i = 0;
    void 0;

    while (i < self.chunk.length) {
      const current = tsplus_module_2.unsafeGet(journal)(tsplus_module_1.unsafeGet(i)(self.chunk));
      tsplus_module_3.unsafeSet(f(current), journal)(tsplus_module_1.unsafeGet(i)(self.chunk));
      i = i + 1;
    }
  });
}
//# sourceMappingURL=transform.mjs.map