import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_2 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_3 from "@effect/core/stm/STM/operations/effect";
import * as tsplus_module_4 from "@effect/core/stm/TRef/operations/get";
import * as tsplus_module_5 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_6 from "@effect/core/stm/STM/operations/forEach";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
/**
 * Atomically updates all elements using a transactional effect.
 *
 * @tsplus static effect/core/stm/TArray.Aspects transformSTM
 * @tsplus pipeable effect/core/stm/TArray transformSTM
 */

export function transformSTM(f) {
  return self => {
    void 0;
    return tsplus_module_5.flatMap(newData => tsplus_module_3.effect(journal => {
      for (let i = 0; i < newData.length; i++) {
        const value = tsplus_module_1.unsafeGet(i)(newData);
        const entry = tsplus_module_1.unsafeGet(i)(self.chunk);
        tsplus_module_2.unsafeSet(value, journal)(entry);
      }
    }))(tsplus_module_6.forEach(self.chunk, tref => tsplus_module_5.flatMap(f)(tsplus_module_4.get(tref))));
  };
}
//# sourceMappingURL=transformSTM.mjs.map