import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_2 from "@effect/core/stm/TRef/operations/update";
import * as tsplus_module_3 from "@tsplus/stdlib/exceptions";
import * as tsplus_module_4 from "@effect/core/stm/STM/operations/dieSync";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
/**
 * Updates element in the array with given function.
 *
 * @tsplus static effect/core/stm/TArray.Aspects update
 * @tsplus pipeable effect/core/stm/TArray update
 */

export function update(index, f) {
  return self => {
    void 0;

    if (0 <= index && index < self.chunk.length) {
      return tsplus_module_2.update(f)(tsplus_module_1.unsafeGet(index)(self.chunk));
    } else {
      return tsplus_module_4.dieSync(() => new tsplus_module_3.IndexOutOfBounds(index, 0, self.chunk.length));
    }
  };
}
//# sourceMappingURL=update.mjs.map