import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_2 from "@effect/core/stm/TRef/operations/set";
import * as tsplus_module_3 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_4 from "@effect/core/stm/TRef/operations/get";
import * as tsplus_module_5 from "@tsplus/stdlib/exceptions";
import * as tsplus_module_6 from "@effect/core/stm/STM/operations/dieSync";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
/**
 * Atomically updates element in the array with given transactional effect.
 *
 * @tsplus static effect/core/stm/TArray.Aspects updateSTM
 * @tsplus pipeable effect/core/stm/TArray updateSTM
 */

export function updateSTM(index, f) {
  return self => {
    void 0;

    if (0 <= index && index < self.chunk.length) {
      return tsplus_module_3.flatMap(currentVal => tsplus_module_3.flatMap(newVal => tsplus_module_2.set(newVal)(tsplus_module_1.unsafeGet(index)(self.chunk)))(f(currentVal)))(tsplus_module_4.get(tsplus_module_1.unsafeGet(index)(self.chunk)));
    } else {
      return tsplus_module_6.dieSync(() => new tsplus_module_5.IndexOutOfBounds(index, 0, self.chunk.length));
    }
  };
}
//# sourceMappingURL=updateSTM.mjs.map