import { TDequeueOps } from "@effect/core/stm/THub/definition/TDequeue";
export const THubSym = /*#__PURE__*/Symbol.for("@effect/core/stm/THub");
export const _A = /*#__PURE__*/Symbol.for("@effect/core/stm/THub/A");
export const THub = {
  $: {},
  TDequeue: TDequeueOps,
  Node: {}
};
/**
 * A strategy that retries if the hub is at capacity.
 *
 * @tsplus static effect/core/stm/THub.Ops BackPressure
 */

export const BackPressure = {
  _tag: "BackPressure"
};
/**
 * A strategy that drops new messages if the hub is at capacity.
 *
 * @tsplus static effect/core/stm/THub.Ops Dropping
 */

export const Dropping = {
  _tag: "Dropping"
};
/**
 * A strategy that drops old messages if the hub is at capacity.
 *
 * @tsplus static effect/core/stm/THub.Ops Sliding
 */

export const Sliding = {
  _tag: "Sliding"
};
//# sourceMappingURL=THub.mjs.map