import * as tsplus_module_1 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_2 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_3 from "@effect/core/stm/THub/definition";
import * as tsplus_module_4 from "@effect/core/stm/THub/operations/_internal/InternalNode";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/HashSet/operations/remove";
import * as tsplus_module_6 from "@effect/core/stm/STM/operations/effect";
import { concreteTDequeue } from "@effect/core/stm/THub/operations/_internal/InternalTDequeue";
/**
 * Shuts down the queue.
 *
 * @tsplus getter effect/core/stm/THub/TDequeue shutdown
 */

export function shutdown(self) {
  void 0;
  return tsplus_module_6.effect(journal => {
    let currentSubscriberHead = tsplus_module_1.unsafeGet(journal)(self.subscriberHead);

    if (currentSubscriberHead != null) {
      tsplus_module_2.unsafeSet(undefined, journal)(self.subscriberHead);
      let loop = true;

      while (loop) {
        const node = tsplus_module_1.unsafeGet(journal)(currentSubscriberHead);

        if (node == null) {
          loop = false;
        } else {
          const head = node.head;
          const tail = node.tail;

          if (head != null) {
            const subscribers = node.subscribers;

            if (subscribers == 1) {
              const size = tsplus_module_1.unsafeGet(journal)(self.hubSize);
              const updatedNode = tsplus_module_4.make(undefined, 0, node.tail);
              tsplus_module_2.unsafeSet(updatedNode, journal)(currentSubscriberHead);
              tsplus_module_2.unsafeSet(tail, journal)(self.publisherHead);
              tsplus_module_2.unsafeSet(size - 1, journal)(self.hubSize);
            } else {
              const updatedNode = tsplus_module_4.make(undefined, subscribers - 1, node.tail);
              tsplus_module_2.unsafeSet(updatedNode, journal)(currentSubscriberHead);
            }
          }

          currentSubscriberHead = tail;
        }
      }

      const currentSubscriberCount = tsplus_module_1.unsafeGet(journal)(self.subscriberCount);
      tsplus_module_2.unsafeSet(currentSubscriberCount - 1, journal)(self.subscriberCount);
      tsplus_module_2.unsafeSet(tsplus_module_5.remove(self.subscriberHead)(tsplus_module_1.unsafeGet(journal)(self.subscribers)), journal)(self.subscribers);
    }
  });
}
//# sourceMappingURL=shutdown.mjs.map