import * as tsplus_module_1 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_2 from "@effect/core/stm/STM/operations/effect";
import { STMInterruptException } from "@effect/core/stm/STM";
import { concreteTDequeue } from "@effect/core/stm/THub/operations/_internal/InternalTDequeue";
/**
 * The current number of values in the queue.
 *
 * @tsplus getter effect/core/stm/THub/TDequeue size
 */

export function size(self) {
  void 0;
  return tsplus_module_2.effect((journal, fiberId) => {
    let currentSubscriberHead = tsplus_module_1.unsafeGet(journal)(self.subscriberHead);

    if (currentSubscriberHead == null) {
      throw new STMInterruptException(fiberId);
    }

    let loop = true;
    let size = 0;

    while (loop) {
      const node = tsplus_module_1.unsafeGet(journal)(currentSubscriberHead);

      if (node == null) {
        loop = false;
      } else {
        const head = node.head;
        const tail = node.tail;

        if (head != null) {
          size += 1;

          if (size == Number.MAX_SAFE_INTEGER) {
            loop = false;
          }
        }

        currentSubscriberHead = tail;
      }
    }

    return size;
  });
}
//# sourceMappingURL=size.mjs.map