import * as tsplus_module_1 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_2 from "@effect/core/stm/THub/definition";
import * as tsplus_module_3 from "@effect/core/stm/THub/operations/_internal/InternalNode";
import * as tsplus_module_4 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_5 from "@effect/core/stm/STM/operations/effect";
import { STMInterruptException, STMRetryException } from "@effect/core/stm/STM";
import { concreteTDequeue } from "@effect/core/stm/THub/operations/_internal/InternalTDequeue";
/**
 * Takes a value from the queue.
 *
 * @tsplus getter effect/core/stm/THub/TDequeue take
 */

export function take(self) {
  void 0;
  return tsplus_module_5.effect((journal, fiberId) => {
    let currentSubscriberHead = tsplus_module_1.unsafeGet(journal)(self.subscriberHead);

    if (currentSubscriberHead == null) {
      throw new STMInterruptException(fiberId);
    }

    let a = undefined;
    let loop = true;

    while (loop) {
      const node = tsplus_module_1.unsafeGet(journal)(currentSubscriberHead);

      if (node == null) {
        throw new STMRetryException();
      }

      const head = node.head;
      const tail = node.tail;

      if (head != null) {
        const subscribers = node.subscribers;

        if (subscribers == 1) {
          const size = tsplus_module_1.unsafeGet(journal)(self.hubSize);
          const updatedNode = tsplus_module_3.make(undefined, 0, node.tail);
          tsplus_module_4.unsafeSet(updatedNode, journal)(currentSubscriberHead);
          tsplus_module_4.unsafeSet(tail, journal)(self.publisherHead);
          tsplus_module_4.unsafeSet(size - 1, journal)(self.hubSize);
        } else {
          const updatedNode = tsplus_module_3.make(node.head, subscribers - 1, node.tail);
          tsplus_module_4.unsafeSet(updatedNode, journal)(currentSubscriberHead);
        }

        tsplus_module_4.unsafeSet(tail, journal)(self.subscriberHead);
        a = head;
        loop = false;
      } else {
        currentSubscriberHead = tail;
      }
    }

    return a;
  });
}
//# sourceMappingURL=take.mjs.map