import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@effect/core/stm/THub/operations/TDequeue/takeRemainder";
import * as tsplus_module_3 from "@effect/core/stm/STM/operations/suspend";
/**
 * Takes a number of elements from the queue between the specified minimum and
 * maximum. If there are fewer than the minimum number of elements available,
 * retries until at least the minimum number of elements have been collected.
 *
 * @tsplus static effect/core/stm/THub/TDequeue.Aspects takeBetween
 * @tsplus pipeable effect/core/stm/THub/TDequeue takeBetween
 */

export function takeBetween(min, max) {
  return self => tsplus_module_3.suspend(() => tsplus_module_2.takeRemainder(min, max, tsplus_module_1.empty())(self));
}
//# sourceMappingURL=takeBetween.mjs.map