import * as tsplus_module_1 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/builder";
import * as tsplus_module_3 from "@effect/core/stm/THub/definition";
import * as tsplus_module_4 from "@effect/core/stm/THub/operations/_internal/InternalNode";
import * as tsplus_module_5 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_6 from "@effect/core/stm/STM/operations/effect";
import { STMInterruptException } from "@effect/core/stm/STM";
import { concreteTDequeue } from "@effect/core/stm/THub/operations/_internal/InternalTDequeue";
/**
 * Takes up to the specified number of values from the queue.
 *
 * @tsplus static effect/core/stm/THub/TDequeue.Aspects takeUpTo
 * @tsplus pipeable effect/core/stm/THub/TDequeue takeUpTo
 */

export function takeUpTo(max) {
  return self => {
    void 0;
    return tsplus_module_6.effect((journal, fiberId) => {
      let currentSubscriberHead = tsplus_module_1.unsafeGet(journal)(self.subscriberHead);

      if (currentSubscriberHead == null) {
        throw new STMInterruptException(fiberId);
      }

      const builder = tsplus_module_2.builder();
      let n = 0;

      while (n != max) {
        const node = tsplus_module_1.unsafeGet(journal)(currentSubscriberHead);

        if (node == null) {
          n = max;
        } else {
          const head = node.head;
          const tail = node.tail;

          if (head != null) {
            const subscribers = node.subscribers;

            if (subscribers == 1) {
              const size = tsplus_module_1.unsafeGet(journal)(self.hubSize);
              const updatedNode = tsplus_module_4.make(undefined, 0, node.tail);
              tsplus_module_5.unsafeSet(updatedNode, journal)(currentSubscriberHead);
              tsplus_module_5.unsafeSet(tail, journal)(self.publisherHead);
              tsplus_module_5.unsafeSet(size - 1, journal)(self.hubSize);
            } else {
              const updatedNode = tsplus_module_4.make(node.head, subscribers - 1, node.tail);
              tsplus_module_5.unsafeSet(updatedNode, journal)(currentSubscriberHead);
            }

            builder.append(head);
            n += 1;
          }

          currentSubscriberHead = tail;
        }
      }

      tsplus_module_5.unsafeSet(currentSubscriberHead, journal)(self.subscriberHead);
      return builder.build();
    });
  };
}
//# sourceMappingURL=takeUpTo.mjs.map