import * as tsplus_module_1 from "@effect/core/stm/THub/definition/THub";
import * as tsplus_module_2 from "@effect/core/stm/THub/operations/THub/make";
/**
 * Creates a bounded hub with the back pressure strategy. The hub will retain
 * messages until they have been taken by all subscribers, applying back
 * pressure to publishers if the hub is at capacity.
 *
 * @tsplus static effect/core/stm/THub.Ops bounded
 */

export function bounded(requestedCapacity) {
  return tsplus_module_2.make(requestedCapacity, tsplus_module_1.BackPressure);
}
//# sourceMappingURL=bounded.mjs.map