import * as tsplus_module_1 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_2 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashSet/operations/forEach";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashSet/operations/empty";
import * as tsplus_module_5 from "@effect/core/stm/STM/operations/effect";
import { concreteTHub } from "@effect/core/stm/THub/operations/_internal/InternalTHub";
/**
 * Shuts down the hub.
 *
 * @tsplus getter effect/core/stm/THub shutdown
 */

export function shutdown(self) {
  void 0;
  return tsplus_module_5.effect(journal => {
    const currentPublisherTail = tsplus_module_1.unsafeGet(journal)(self.publisherTail);

    if (currentPublisherTail == null) {
      tsplus_module_2.unsafeSet(undefined, journal)(self.publisherTail);
      const currentSubscribers = tsplus_module_1.unsafeGet(journal)(self.subscribers);
      tsplus_module_3.forEach(_ => tsplus_module_2.unsafeSet(undefined, journal)(_))(currentSubscribers);
      tsplus_module_2.unsafeSet(tsplus_module_4.empty(), journal)(self.subscribers);
    }
  });
}
//# sourceMappingURL=shutdown.mjs.map