import * as tsplus_module_1 from "@effect/core/stm/THub/definition/THub";
import * as tsplus_module_2 from "@effect/core/stm/THub/operations/THub/make";
/**
 * Creates a bounded hub with the sliding strategy. The hub will add new
 * messages and drop old messages if the hub is at capacity.
 *
 * For best performance use capacities that are powers of two.
 *
 * @tsplus static effect/core/stm/THub.Ops sliding
 */

export function sliding(requestedCapacity) {
  return tsplus_module_2.make(requestedCapacity, tsplus_module_1.Sliding);
}
//# sourceMappingURL=sliding.mjs.map