import * as tsplus_module_1 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_2 from "@effect/core/stm/TMap/operations/indexOf";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_4 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/List/partition";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/List/definition";
import * as tsplus_module_7 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_8 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_9 from "@tsplus/stdlib/collections/Chunk/operations/forEach";
import * as tsplus_module_10 from "@effect/core/stm/STM/operations/effect";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
import { concreteTMap } from "@effect/core/stm/TMap/operations/_internal/InternalTMap";
/**
 * Deletes all entries associated with the specified keys.
 *
 * @tsplus static effect/core/stm/TMap.Aspects deleteAll
 * @tsplus pipeable effect/core/stm/TMap deleteAll
 */

export function deleteAll(ks) {
  return self => {
    void 0;
    return tsplus_module_10.effect(journal => {
      tsplus_module_9.forEach(k => {
        const buckets = tsplus_module_1.unsafeGet(journal)(self.tBuckets);
        void 0;
        const idx = tsplus_module_2.indexOf(k, buckets.chunk.length);
        const bucket = tsplus_module_1.unsafeGet(journal)(tsplus_module_3.unsafeGet(idx)(buckets.chunk));
        const [toRemove, toRetain] = tsplus_module_5.partition(_ => !tsplus_module_4.equals(_[0], k))(bucket);

        if (tsplus_module_6.isCons(toRemove)) {
          const currSize = tsplus_module_1.unsafeGet(journal)(self.tSize);
          tsplus_module_7.unsafeSet(toRetain, journal)(tsplus_module_3.unsafeGet(idx)(buckets.chunk));
          tsplus_module_7.unsafeSet(currSize - 1, journal)(self.tSize);
        }
      })(tsplus_module_8.from(ks));
    });
  };
}
//# sourceMappingURL=deleteAll.mjs.map