import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/stm/STM/operations/succeedNone";
import * as tsplus_module_3 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_5 from "@effect/core/stm/STM/operations/succeedSome";
import * as tsplus_module_6 from "@effect/core/stm/TMap/operations/foldSTM";
/**
 * Finds the key/value pair matching the specified predicate, and uses the
 * provided effectful function to extract a value out of it.
 *
 * @tsplus static effect/core/stm/TMap.Aspects findSTM
 * @tsplus pipeable effect/core/stm/TMap findSTM
 */

export function findSTM(f) {
  return self => tsplus_module_6.foldSTM(tsplus_module_1.empty(), (a, kv) => {
    if (tsplus_module_1.isNone(a)) {
      return tsplus_module_3.foldSTM(_ => tsplus_module_4.fold(() => tsplus_module_2.succeedNone, e => tsplus_module_3.fail(e))(_), tsplus_module_5.succeedSome)(f(kv));
    }

    return tsplus_module_3.succeed(a);
  })(self);
}
//# sourceMappingURL=findSTM.mjs.map