import * as tsplus_module_1 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/List/reduce";
import * as tsplus_module_4 from "@effect/core/stm/STM/operations/effect";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
import { concreteTMap } from "@effect/core/stm/TMap/operations/_internal/InternalTMap";
/**
 * Atomically folds using a pure function.
 *
 * @tsplus static effect/core/stm/TMap.Aspects fold
 * @tsplus pipeable effect/core/stm/TMap fold
 */

export function fold(zero, op) {
  return self => {
    void 0;
    return tsplus_module_4.effect(journal => {
      const buckets = tsplus_module_1.unsafeGet(journal)(self.tBuckets);
      void 0;
      let res = zero;
      let i = 0;

      while (i < buckets.chunk.length) {
        const bucket = tsplus_module_2.unsafeGet(i)(buckets.chunk);
        const items = tsplus_module_1.unsafeGet(journal)(bucket);
        res = tsplus_module_3.reduce(res, op)(items);
        i += 1;
      }

      return res;
    });
  };
}
//# sourceMappingURL=fold.mjs.map