import * as tsplus_module_1 from "@tsplus/stdlib/collections/List/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/List/forEach";
import * as tsplus_module_3 from "@effect/core/stm/TMap/operations/indexOf";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/List/prepend";
import * as tsplus_module_5 from "@effect/core/stm/TRef/operations/make";
import * as tsplus_module_6 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_7 from "@effect/core/stm/TArray/operations/from";
import * as tsplus_module_8 from "@tsplus/stdlib/collections/List/from";
import * as tsplus_module_9 from "@effect/core/stm/STM/operations/suspend";
import { InternalTMap } from "@effect/core/stm/TMap/operations/_internal/InternalTMap";
const INITIAL_CAPACITY = 16;

function nextPowerOfTwo(size) {
  const n = -1 >>> Math.clz32(size - 1);
  return n < 0 ? 1 : n + 1;
}

function allocate(capacity, data) {
  const buckets = Array.from({
    length: capacity
  }, () => tsplus_module_1.nil());
  const distinct = new Map();
  tsplus_module_2.forEach(kv => distinct.set(kv[0], kv[1]))(data);
  let size = 0;

  for (const kv0 of distinct) {
    const kv = kv0;
    const idx = tsplus_module_3.indexOf(kv[0], capacity);
    buckets[idx] = tsplus_module_4.prepend(kv)(buckets[idx]);
    size += 1;
  }

  return tsplus_module_6.flatMap(tArray => tsplus_module_6.flatMap(tBuckets => tsplus_module_6.map(tSize => new InternalTMap(tBuckets, tSize))(tsplus_module_5.make(() => size)))(tsplus_module_5.make(() => tArray)))(tsplus_module_7.from(buckets));
}
/**
 * Makes a new `TMap` initialized with provided iterable.
 *
 * @tsplus static effect/core/stm/TMap.Ops fromIterable
 */


export function fromIterable(data0) {
  return tsplus_module_9.suspend(() => {
    const data = tsplus_module_8.from(data0);
    const size = tsplus_module_1.length(data);
    const capacity = size < INITIAL_CAPACITY ? INITIAL_CAPACITY : nextPowerOfTwo(size);
    return allocate(capacity, data);
  });
}
//# sourceMappingURL=fromIterable.mjs.map