import * as tsplus_module_1 from "@effect/core/stm/TMap/operations/put";
import * as tsplus_module_2 from "@effect/core/stm/STM/operations/as";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_4 from "@effect/core/stm/TMap/operations/get";
import * as tsplus_module_5 from "@effect/core/stm/STM/definition/primitives";
/**
 * If the key `k` is not already associated with a value, stores the provided
 * value, otherwise merge the existing value with the new one using function
 * `f` and store the result
 *
 * @tsplus static effect/core/stm/TMap.Aspects merge
 * @tsplus pipeable effect/core/stm/TMap merge
 */

export function merge_(k, v, f) {
  return self => tsplus_module_5.flatMap(_ => tsplus_module_3.fold(() => tsplus_module_2.as(v)(tsplus_module_1.put(k, v)(self)), v0 => {
    const v1 = f([v0, v]);
    return tsplus_module_2.as(v1)(tsplus_module_1.put(k, v1)(self));
  })(_))(tsplus_module_4.get(k)(self));
}
//# sourceMappingURL=merge.mjs.map