import * as tsplus_module_1 from "@tsplus/stdlib/collections/List/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_3 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_4 from "@effect/core/stm/TMap/operations/indexOf";
import * as tsplus_module_5 from "@effect/core/stm/TRef/operations/unsafeMake";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_7 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_8 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_9 from "@tsplus/stdlib/collections/List/exists";
import * as tsplus_module_10 from "@tsplus/stdlib/collections/List/map";
import * as tsplus_module_11 from "@effect/core/stm/STM/operations/effect";
import { concreteTArray, InternalTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
import { concreteTMap } from "@effect/core/stm/TMap/operations/_internal/InternalTMap";
const LOAD_FACTOR = .75;

function resize(self, journal, buckets, k, v) {
  void 0;
  const capacity = buckets.chunk.length;
  const newCapacity = capacity << 1;
  const newBuckets = Array.from({
    length: newCapacity
  }, () => tsplus_module_1.nil());
  let i = 0;

  while (i < capacity) {
    const pairs = tsplus_module_3.unsafeGet(journal)(tsplus_module_2.unsafeGet(i)(buckets.chunk));

    for (const pair of pairs) {
      const idx = tsplus_module_4.indexOf(pair[0], newCapacity);
      newBuckets[idx] = tsplus_module_1.cons(pair, newBuckets[idx]);
    }

    i += 1;
  }

  const newIdx = tsplus_module_4.indexOf(k, newCapacity);
  newBuckets[newIdx] = tsplus_module_1.cons([k, v], newBuckets[newIdx]);
  const newArray = new Array(newCapacity);
  i = 0;

  while (i < newCapacity) {
    newArray[i] = tsplus_module_5.unsafeMake(newBuckets[i]);
    i += 1;
  }

  void 0;
  tsplus_module_7.unsafeSet(new InternalTArray(tsplus_module_6.from(newArray)), journal)(self.tBuckets);
}
/**
 * Stores new binding into the map.
 *
 * @tsplus static effect/core/stm/TMap.Aspects put
 * @tsplus pipeable effect/core/stm/TMap put
 */


export function put(k, v) {
  return self => {
    void 0;
    return tsplus_module_11.effect(journal => {
      const buckets = tsplus_module_3.unsafeGet(journal)(self.tBuckets);
      void 0;
      const capacity = buckets.chunk.length;
      const idx = tsplus_module_4.indexOf(k, capacity);
      const bucket = tsplus_module_3.unsafeGet(journal)(tsplus_module_2.unsafeGet(idx)(buckets.chunk));
      const shouldUpdate = tsplus_module_9.exists(_ => tsplus_module_8.equals(_[0], k))(bucket);

      if (shouldUpdate) {
        const newBucket = tsplus_module_10.map(kv => tsplus_module_8.equals(kv[0], k) ? [k, v] : kv)(bucket);
        tsplus_module_7.unsafeSet(newBucket, journal)(tsplus_module_2.unsafeGet(idx)(buckets.chunk));
      } else {
        const newSize = tsplus_module_3.unsafeGet(journal)(self.tSize) + 1;
        tsplus_module_7.unsafeSet(newSize, journal)(self.tSize);

        if (capacity * LOAD_FACTOR < newSize) {
          resize(self, journal, buckets, k, v);
        } else {
          const newBucket = tsplus_module_1.cons([k, v], bucket);
          tsplus_module_7.unsafeSet(newBucket, journal)(tsplus_module_2.unsafeGet(idx)(buckets.chunk));
        }
      }
    });
  };
}
//# sourceMappingURL=put.mjs.map