import * as tsplus_module_1 from "@tsplus/stdlib/data/Function";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/List/exists";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/List/empty";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/List/prepend";
import * as tsplus_module_8 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_9 from "@effect/core/stm/STM/operations/effect";
import * as tsplus_module_10 from "@effect/core/stm/STM/operations/continueOrRetry";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
import { concreteTMap } from "@effect/core/stm/TMap/operations/_internal/InternalTMap";
/**
 * Takes the first matching value, or retries until there is one.
 *
 * @tsplus static effect/core/stm/TMap.Aspects takeFirst
 * @tsplus pipeable effect/core/stm/TMap takeFirst
 */

export function takeFirst(pf) {
  return self => {
    void 0;
    return tsplus_module_10.continueOrRetry(tsplus_module_1.identity)(tsplus_module_9.effect(journal => {
      let result = tsplus_module_2.none;
      const size = tsplus_module_3.unsafeGet(journal)(self.tSize);
      const buckets = tsplus_module_3.unsafeGet(journal)(self.tBuckets);
      void 0;
      const capacity = buckets.chunk.length;
      let i = 0;

      while (i < capacity && tsplus_module_2.isNone(result)) {
        const bucket = tsplus_module_3.unsafeGet(journal)(tsplus_module_4.unsafeGet(i)(buckets.chunk));
        const recreate = tsplus_module_5.exists(_ => tsplus_module_2.isSome(pf(_)))(bucket);

        if (recreate) {
          let newBucket = tsplus_module_6.empty();

          for (const pair of bucket) {
            result = pf(pair);

            if (tsplus_module_2.isSome(result)) {
              newBucket = tsplus_module_7.prepend(pair)(newBucket);
              break;
            }
          }

          tsplus_module_8.unsafeSet(newBucket, journal)(tsplus_module_4.unsafeGet(i)(buckets.chunk));
        }

        i += 1;
      }

      if (tsplus_module_2.isSome(result)) {
        tsplus_module_8.unsafeSet(size - 1, journal)(self.tSize);
      }

      return result;
    }));
  };
}
//# sourceMappingURL=takeFirst.mjs.map