import * as tsplus_module_1 from "@tsplus/stdlib/data/Function";
import * as tsplus_module_2 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/builder";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_5 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/List/exists";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/List/empty";
import * as tsplus_module_8 from "@tsplus/stdlib/collections/List/prepend";
import * as tsplus_module_9 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_10 from "@tsplus/stdlib/collections/List/definition";
import * as tsplus_module_11 from "@tsplus/stdlib/collections/Chunk/operations/size";
import * as tsplus_module_12 from "@tsplus/stdlib/data/Maybe/fromPredicate";
import * as tsplus_module_13 from "@effect/core/stm/STM/operations/effect";
import * as tsplus_module_14 from "@effect/core/stm/STM/operations/continueOrRetry";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
import { concreteTMap } from "@effect/core/stm/TMap/operations/_internal/InternalTMap";
/**
 * Takes all matching values, or retries until there is at least one.
 *
 * @tsplus static effect/core/stm/TMap.Aspects takeSome
 * @tsplus pipeable effect/core/stm/TMap takeSome
 */

export function takeSome(pf) {
  return self => {
    void 0;
    return tsplus_module_14.continueOrRetry(tsplus_module_1.identity)(tsplus_module_13.effect(journal => {
      const buckets = tsplus_module_2.unsafeGet(journal)(self.tBuckets);
      const chunkBuilder = tsplus_module_3.builder();
      void 0;
      const capacity = buckets.chunk.length;
      let i = 0;
      let newSize = 0;

      while (i < capacity) {
        const bucket = tsplus_module_2.unsafeGet(journal)(tsplus_module_4.unsafeGet(i)(buckets.chunk));
        const recreate = tsplus_module_6.exists(_ => tsplus_module_5.isSome(pf(_)))(bucket);

        if (recreate) {
          let newBucket = tsplus_module_7.empty();

          for (const pair of bucket) {
            const result = pf(pair);

            if (tsplus_module_5.isSome(result)) {
              chunkBuilder.append(result.value);
            } else {
              newBucket = tsplus_module_8.prepend(pair)(newBucket);
              newSize += 1;
            }
          }

          tsplus_module_9.unsafeSet(newBucket, journal)(tsplus_module_4.unsafeGet(i)(buckets.chunk));
        } else {
          newSize += tsplus_module_10.length(bucket);
        }

        i += 1;
      }

      tsplus_module_9.unsafeSet(newSize, journal)(self.tSize);
      return tsplus_module_12.fromPredicate(chunkBuilder.build(), _ => tsplus_module_11.size(_) > 0);
    }));
  };
}
//# sourceMappingURL=takeSome.mjs.map