import * as tsplus_module_1 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/List/definition";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_4 from "@effect/core/stm/TMap/operations/indexOf";
import * as tsplus_module_5 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/List/exists";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/List/prepend";
import * as tsplus_module_8 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_9 from "@effect/core/stm/STM/operations/effect";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
import { concreteTMap } from "@effect/core/stm/TMap/operations/_internal/InternalTMap";
/**
 * Atomically updates all bindings using a pure function.
 *
 * @tsplus static effect/core/stm/TMap.Aspects transform
 * @tsplus pipeable effect/core/stm/TMap transform
 */

export function transform(f) {
  return self => {
    void 0;
    return tsplus_module_9.effect(journal => {
      const buckets = tsplus_module_1.unsafeGet(journal)(self.tBuckets);
      void 0;
      const capacity = buckets.chunk.length;
      const newBuckets = Array.from({
        length: capacity
      }, () => tsplus_module_2.nil());
      let i = 0;
      let newSize = 0;

      while (i < capacity) {
        const bucket = tsplus_module_3.unsafeGet(i)(buckets.chunk);
        const pairs = tsplus_module_1.unsafeGet(journal)(bucket);

        for (const pair of pairs) {
          const newPair = f(pair);
          const idx = tsplus_module_4.indexOf(newPair[0], capacity);
          const newBucket = newBuckets[idx];

          if (!tsplus_module_6.exists(_ => tsplus_module_5.equals(_[0], newPair[0]))(newBucket)) {
            newBuckets[idx] = tsplus_module_7.prepend(newPair)(newBucket);
            newSize += 1;
          }
        }

        i += 1;
      }

      i = 0;

      while (i < capacity) {
        tsplus_module_8.unsafeSet(newBuckets[i], journal)(tsplus_module_3.unsafeGet(i)(buckets.chunk));
        i += 1;
      }

      tsplus_module_8.unsafeSet(newSize, journal)(self.tSize);
    });
  };
}
//# sourceMappingURL=transform.mjs.map