import * as tsplus_module_1 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/List/definition";
import * as tsplus_module_3 from "@effect/core/stm/TMap/operations/indexOf";
import * as tsplus_module_4 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/List/exists";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/List/prepend";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_8 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_9 from "@effect/core/stm/STM/operations/effect";
import * as tsplus_module_10 from "@effect/core/stm/STM/operations/forEach";
import * as tsplus_module_11 from "@effect/core/stm/TMap/operations/toChunk";
import * as tsplus_module_12 from "@effect/core/stm/STM/definition/primitives";
import { concreteTArray } from "@effect/core/stm/TArray/operations/_internal/InternalTArray";
import { concreteTMap } from "@effect/core/stm/TMap/operations/_internal/InternalTMap";
/**
 * Atomically updates all bindings using a transactional function.
 *
 * @tsplus static effect/core/stm/TMap.Aspects transformSTM
 * @tsplus pipeable effect/core/stm/TMap transformSTM
 */

export function transformSTM(f) {
  return self => {
    void 0;
    return tsplus_module_12.flatMap(newData => tsplus_module_9.effect(journal => {
      const buckets = tsplus_module_1.unsafeGet(journal)(self.tBuckets);
      void 0;
      const capacity = buckets.chunk.length;
      const newBuckets = Array.from({
        length: capacity
      }, () => tsplus_module_2.nil());
      let newSize = 0;

      for (const newPair of newData) {
        const idx = tsplus_module_3.indexOf(newPair[0], capacity);
        const newBucket = newBuckets[idx];

        if (!tsplus_module_5.exists(_ => tsplus_module_4.equals(_[0], newPair[0]))(newBucket)) {
          newBuckets[idx] = tsplus_module_6.prepend(newPair)(newBucket);
          newSize += 1;
        }
      }

      let i = 0;

      while (i < capacity) {
        tsplus_module_8.unsafeSet(newBuckets[i], journal)(tsplus_module_7.unsafeGet(i)(buckets.chunk));
        i += 1;
      }

      tsplus_module_8.unsafeSet(newSize, journal)(self.tSize);
    }))(tsplus_module_12.flatMap(data => tsplus_module_10.forEach(data, f))(tsplus_module_11.toChunk(self)));
  };
}
//# sourceMappingURL=transformSTM.mjs.map