import * as tsplus_module_1 from "@tsplus/stdlib/collections/SortedMap/entries";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/builder";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/splitAt";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/SortedMap/remove";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/SortedMap/set";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/Chunk/operations/size";
import * as tsplus_module_8 from "@tsplus/stdlib/collections/Chunk/operations/flatten";
import * as tsplus_module_9 from "@effect/core/stm/TRef/operations/modify";
import { concreteTPriorityQueue } from "@effect/core/stm/TPriorityQueue/operations/_internal/InternalTPriorityQueue";
/**
 * Takes up to the specified maximum number of elements from the queue.
 *
 * @tsplus static effect/core/stm/TPriorityQueue.Aspects takeUpTo
 * @tsplus pipeable effect/core/stm/TPriorityQueue takeUpTo
 */

export function takeUpTo(n) {
  return self => {
    void 0;
    return tsplus_module_9.modify(map => {
      const entries = tsplus_module_1.entries(map);
      const builder = tsplus_module_2.builder();
      let updated = map;
      let e;
      let i = 0;

      while (!(e = entries.next()).done && i < n) {
        const [a, as] = e.value;
        const [l, r] = tsplus_module_3.splitAt(n - i)(as);
        builder.append(l);

        if (tsplus_module_4.isEmpty(r)) {
          updated = tsplus_module_5.remove_(map, a);
        } else {
          updated = tsplus_module_6.set(a, r)(map);
        }

        i += tsplus_module_7.size(l);
      }

      return [tsplus_module_8.flatten(builder.build()), updated];
    })(self.map);
  };
}
//# sourceMappingURL=takeUpTo.mjs.map