import * as tsplus_module_1 from "@effect/core/stm/TQueue/definition";
import * as tsplus_module_2 from "@effect/core/stm/TQueue/operations/make";
/**
 * Creates a bounded queue with the back pressure strategy. The queue will
 * retain values until they have been taken, applying back pressure to
 * offerors if the queue is at capacity.
 *
 * For best performance use capacities that are powers of two.
 *
 * @tsplus static effect/core/stm/TQueue.Ops bounded
 */

export function bounded(requestedCapacity) {
  return tsplus_module_2.make(requestedCapacity, tsplus_module_1.BackPressure);
}
//# sourceMappingURL=bounded.mjs.map