import * as tsplus_module_1 from "@effect/core/stm/TQueue/definition";
import * as tsplus_module_2 from "@effect/core/stm/TQueue/operations/make";
/**
 * Creates a bounded queue with the dropping strategy. The queue will drop new
 * values if the queue is at capacity.
 *
 * For best performance use capacities that are powers of two.
 *
 * @tsplus static effect/core/stm/TQueue.Ops dropping
 */

export function dropping(requestedCapacity) {
  return tsplus_module_2.make(requestedCapacity, tsplus_module_1.Dropping);
}
//# sourceMappingURL=dropping.mjs.map