import * as tsplus_module_1 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_2 from "@effect/core/stm/TQueue/operations/take";
export const seek = seek_1;
/**
 * Drops elements from the queue while they do not satisfy the predicate,
 * taking and returning the first element that does satisfy the predicate.
 * Retries if no elements satisfy the predicate.
 *
 * @tsplus static effect/core/stm/TQueue.Aspects seek
 * @tsplus pipeable effect/core/stm/TQueue seek
 */

function seek_1(f) {
  return self => tsplus_module_1.flatMap(b => f(b) ? tsplus_module_1.succeed(b) : seek_1(f)(self))(tsplus_module_2.take(self));
}
//# sourceMappingURL=seek.mjs.map