import * as tsplus_module_1 from "@effect/core/stm/TQueue/definition";
import * as tsplus_module_2 from "@effect/core/stm/TQueue/operations/make";
/**
 * Creates a bounded queue with the sliding strategy. The queue will add new
 * values and drop old values if the queue is at capacity.
 *
 * For best performance use capacities that are powers of two.
 *
 * @tsplus static effect/core/stm/TQueue.Ops sliding
 */

export function sliding(requestedCapacity) {
  return tsplus_module_2.make(requestedCapacity, tsplus_module_1.Sliding);
}
//# sourceMappingURL=sliding.mjs.map