import * as tsplus_module_1 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_2 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/ImmutableQueue/dequeue";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_5 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_6 from "@effect/core/stm/STM/operations/effect";
import { STMInterruptException, STMRetryException } from "@effect/core/stm/STM";
import { concreteTQueue } from "@effect/core/stm/TQueue/operations/_internal/InternalTQueue";
/**
 * Takes a value from the queue.
 *
 * @tsplus getter effect/core/stm/TQueue take
 */

export function take(self) {
  void 0;
  return tsplus_module_6.effect((journal, fiberId) => {
    const queue = tsplus_module_1.unsafeGet(journal)(self.ref);

    if (tsplus_module_2.equals(queue, null)) {
      throw new STMInterruptException(fiberId);
    }

    const item = tsplus_module_3.dequeue(queue);

    if (tsplus_module_4.isSome(item)) {
      const [a, queue] = item.value;
      tsplus_module_5.unsafeSet(queue, journal)(self.ref);
      return a;
    }

    throw new STMRetryException();
  });
}
//# sourceMappingURL=take.mjs.map