import * as tsplus_module_1 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_2 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/ImmutableQueue/splitAt";
import * as tsplus_module_4 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_6 from "@effect/core/stm/STM/operations/effect";
import { STMInterruptException } from "@effect/core/stm/STM";
import { concreteTQueue } from "@effect/core/stm/TQueue/operations/_internal/InternalTQueue";
/**
 * Takes up to the specified number of values from the queue.
 *
 * @tsplus static effect/core/stm/TQueue.Aspects takeUpTo
 * @tsplus pipeable effect/core/stm/TQueue takeUpTo
 */

export function takeUpTo(max) {
  return self => {
    void 0;
    return tsplus_module_6.effect((journal, fiberId) => {
      const queue = tsplus_module_1.unsafeGet(journal)(self.ref);

      if (tsplus_module_2.equals(queue, null)) {
        throw new STMInterruptException(fiberId);
      }

      const [toTake, remaining] = tsplus_module_3.splitAt(max)(queue);
      tsplus_module_4.unsafeSet(remaining, journal)(self.ref);
      return tsplus_module_5.from(toTake);
    });
  };
}
//# sourceMappingURL=takeUpTo.mjs.map