var _a;

import * as tsplus_module_1 from "@tsplus/stdlib/io/Random/PCGRandom";
import * as tsplus_module_2 from "@effect/core/stm/TRef/operations/make";
import * as tsplus_module_3 from "@effect/core/stm/STM/definition/primitives";
import * as tsplus_module_4 from "@effect/core/stm/TRandom/definition";
import * as tsplus_module_5 from "@effect/core/io/Layer/operations/fromEffect";
import * as tsplus_module_6 from "@effect/core/stm/TRef/operations/modify";
import * as tsplus_module_7 from "@effect/core/stm/TArray/operations/toChunk";
import * as tsplus_module_8 from "@effect/core/stm/STM/operations/forEachDiscard";
import * as tsplus_module_9 from "@effect/core/stm/TArray/operations/update";
import * as tsplus_module_10 from "@effect/core/stm/TArray/operations/get";
import * as tsplus_module_11 from "@effect/core/stm/TArray/operations/updateSTM";
import * as tsplus_module_12 from "@effect/core/stm/STM/operations/tap";
import * as tsplus_module_13 from "@effect/core/stm/STM/operations/unit";
import * as tsplus_module_14 from "@effect/core/stm/TArray/operations/from";
import { TRandomSym } from "@effect/core/stm/TRandom/definition";
/**
 * @tsplus static effect/core/stm/TRandom.Ops default
 */

const defaultTRandom_1 = /*#__PURE__*/tsplus_module_3.map(_ => new LiveTRandom(_))( /*#__PURE__*/tsplus_module_2.make(() => new tsplus_module_1.PCGRandom(Math.random() * 4294967296 >>> 0).getState())).commit;
export const defaultTRandom = defaultTRandom_1;
/**
 * @tsplus static effect/core/stm/TRandom.Ops live
 */

export const live = /*#__PURE__*/tsplus_module_5.fromEffect(tsplus_module_4.TRandom.Tag)(defaultTRandom_1);

function rndInt(state) {
  const prng = new tsplus_module_1.PCGRandom();
  prng.setState(state);
  return [prng.integer(0), prng.getState()];
}

function rndIntBetween(low, high) {
  return state => {
    const prng = new tsplus_module_1.PCGRandom();
    prng.setState(state);
    return [prng.integer(high - low) + low, prng.getState()];
  };
}

function rndNumber(state) {
  const prng = new tsplus_module_1.PCGRandom();
  prng.setState(state);
  return [prng.number(), prng.getState()];
}

export class LiveTRandom {
  constructor(state) {
    this.state = state;
    this[_a] = TRandomSym;
  }

  withState(f) {
    return tsplus_module_6.modify(f)(this.state);
  }

  get next() {
    return this.withState(rndNumber);
  }

  get nextBoolean() {
    return tsplus_module_3.flatMap(n => tsplus_module_3.succeed(n > 0.5))(this.next);
  }

  get nextInt() {
    return this.withState(rndInt);
  }

  nextRange(low, high) {
    return tsplus_module_3.flatMap(n => tsplus_module_3.succeed((high - low) * n + low))(this.next);
  }

  nextIntBetween(low, high) {
    return this.withState(rndIntBetween(low, high));
  }

  shuffle(collection) {
    return shuffleWith(collection, n => this.nextIntBetween(0, n));
  }

}
_a = TRandomSym;

function shuffleWith(collection, nextIntBounded) {
  return (() => {
    const array = Array.from(collection);
    return tsplus_module_3.flatMap(buffer => {
      const swap = (i1, i2) => tsplus_module_13.unit(tsplus_module_12.tap(tmp => tsplus_module_9.update(i2, _ => tmp)(buffer))(tsplus_module_12.tap(() => tsplus_module_11.updateSTM(i1, _ => tsplus_module_10.get(i2)(buffer))(buffer))(tsplus_module_10.get(i1)(buffer))));

      const ns = [];

      for (let i = array.length; i >= 2; i = i - 1) {
        ns.push(i);
      }

      return tsplus_module_3.flatMap(() => tsplus_module_7.toChunk(buffer))(tsplus_module_8.forEachDiscard(ns, n => tsplus_module_3.flatMap(k => swap(n - 1, k))(nextIntBounded(n))));
    })(tsplus_module_14.from(array));
  })();
}
//# sourceMappingURL=live.mjs.map