import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashMap/operations/isEmpty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashMap/operations/size";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashMap/_internal/hashMap";
import { concreteReadLock } from "@effect/core/stm/TReentrantLock/operations/_internal/InternalReadLock";
/**
 * Determines if there is no other holder of read locks aside from the
 * specified fiber id. If there are no other holders of read locks aside
 * from the specified fiber id, then it is safe to upgrade the read lock
 * into a write lock.
 *
 * @tsplus static effect/core/stm/TReentrantLock/ReadLock.Aspects noOtherHolder
 * @tsplus pipeable effect/core/stm/TReentrantLock/ReadLock noOtherHolder
 */

export function noOtherHolder(fiberId) {
  return self => {
    void 0;
    return tsplus_module_1.isEmpty(self.readers) || tsplus_module_2.size(self.readers) === 1 && tsplus_module_3.has_(self.readers, fiberId);
  };
}
//# sourceMappingURL=noOtherHolder.mjs.map