import * as tsplus_module_1 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_2 from "@effect/core/stm/TReentrantLock/operations/ReadLock/noOtherHolder";
import * as tsplus_module_3 from "@effect/core/stm/TReentrantLock/definition";
import * as tsplus_module_4 from "@effect/core/stm/TReentrantLock/operations/WriteLock/make";
import * as tsplus_module_5 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_6 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_7 from "@effect/core/stm/STM/operations/effect";
import { STMRetryException } from "@effect/core/stm/STM";
import { InternalReadLock } from "@effect/core/stm/TReentrantLock/operations/_internal/InternalReadLock";
import { concreteTReentrantLock } from "@effect/core/stm/TReentrantLock/operations/_internal/InternalTReentrantLock";
import { InternalWriteLock } from "@effect/core/stm/TReentrantLock/operations/_internal/InternalWriteLock";
/**
 * Acquires a write lock. The transaction will suspend until no other fibers
 * are holding read or write locks. Succeeds with the number of write locks
 * held by this fiber.
 *
 * @tsplus getter effect/core/stm/TReentrantLock acquireWrite
 */

export function acquireWrite(self) {
  void 0;
  return tsplus_module_7.effect((journal, fiberId) => {
    const lock = tsplus_module_1.unsafeGet(journal)(self.data);

    if (lock instanceof InternalReadLock && tsplus_module_2.noOtherHolder(fiberId)(lock)) {
      tsplus_module_5.unsafeSet(tsplus_module_4.make(1, lock.readLocksHeld(fiberId), fiberId), journal)(self.data);
      return 1;
    }

    if (lock instanceof InternalWriteLock && tsplus_module_6.equals(fiberId, lock.fiberId)) {
      tsplus_module_5.unsafeSet(tsplus_module_4.make(lock.writeLocks + 1, lock.readLocks, fiberId), journal)(self.data);
      return lock.writeLocks + 1;
    }

    throw new STMRetryException();
  });
}
//# sourceMappingURL=acquireWrite.mjs.map