import * as tsplus_module_1 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_2 from "@effect/core/stm/TReentrantLock/operations/ReadLock/adjust";
import * as tsplus_module_3 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_4 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_5 from "@effect/core/stm/TReentrantLock/definition";
import * as tsplus_module_6 from "@effect/core/stm/TReentrantLock/operations/WriteLock/make";
import * as tsplus_module_7 from "@effect/core/stm/STM/operations/effect";
import { STMRetryException } from "@effect/core/stm/STM";
import { InternalReadLock } from "@effect/core/stm/TReentrantLock/operations/_internal/InternalReadLock";
import { concreteTReentrantLock } from "@effect/core/stm/TReentrantLock/operations/_internal/InternalTReentrantLock";
import { InternalWriteLock } from "@effect/core/stm/TReentrantLock/operations/_internal/InternalWriteLock";
/**
 * @tsplus static effect/core/stm/TReentrantLock.Aspects adjustRead
 * @tsplus pipeable effect/core/stm/TReentrantLock adjustRead
 */

export function adjustRead(delta) {
  return self => {
    void 0;
    return tsplus_module_7.effect((journal, fiberId) => {
      const lock = tsplus_module_1.unsafeGet(journal)(self.data);

      if (lock instanceof InternalReadLock) {
        const res = tsplus_module_2.adjust(fiberId, delta)(lock);
        tsplus_module_3.unsafeSet(res, journal)(self.data);
        return res.readLocksHeld(fiberId);
      }

      if (lock instanceof InternalWriteLock && tsplus_module_4.equals(lock.fiberId, fiberId)) {
        const newTotal = lock.readLocks + delta;

        if (newTotal < 0) {
          throw new Error(`Defect: Fiber ${fiberId} releasing read locks it does not hold, newTotal: ${newTotal}`);
        }

        tsplus_module_3.unsafeSet(tsplus_module_6.make(lock.writeLocks, newTotal, fiberId), journal)(self.data);
        return newTotal;
      }

      throw new STMRetryException();
    });
  };
}
//# sourceMappingURL=adjustRead.mjs.map