import * as tsplus_module_1 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_2 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_3 from "@effect/core/stm/TReentrantLock/operations/ReadLock/apply";
import * as tsplus_module_4 from "@effect/core/stm/TReentrantLock/definition";
import * as tsplus_module_5 from "@effect/core/stm/TReentrantLock/operations/WriteLock/make";
import * as tsplus_module_6 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_7 from "@effect/core/stm/STM/operations/effect";
import { concreteTReentrantLock } from "@effect/core/stm/TReentrantLock/operations/_internal/InternalTReentrantLock";
import { InternalWriteLock } from "@effect/core/stm/TReentrantLock/operations/_internal/InternalWriteLock";
/**
 * Releases a write lock held by this fiber. Succeeds with the outstanding
 * number of write locks held by this fiber.
 *
 * @tsplus getter effect/core/stm/TReentrantLock releaseWrite
 */

export function releaseWrite(self) {
  void 0;
  return tsplus_module_7.effect((journal, fiberId) => {
    const lock = tsplus_module_1.unsafeGet(journal)(self.data);
    let res;

    if (lock instanceof InternalWriteLock && tsplus_module_2.equals(fiberId, lock.fiberId) && lock.writeLocks >= 1) {
      if (lock.writeLocks === 1) {
        res = tsplus_module_3.apply(fiberId, lock.readLocks);
      } else {
        res = tsplus_module_5.make(lock.writeLocks - 1, lock.readLocks, fiberId);
      }
    } else {
      throw new Error(`Defect: Fiber ${fiberId} releasing write lock it does not hold: ${lock}`);
    }

    tsplus_module_6.unsafeSet(res, journal)(self.data);
    return res.writeLocksHeld(fiberId);
  });
}
//# sourceMappingURL=releaseWrite.mjs.map