import * as tsplus_module_1 from "@effect/core/stm/TReentrantLock/operations/TReentrantLock/acquireWrite";
import * as tsplus_module_2 from "@effect/core/stm/TReentrantLock/operations/TReentrantLock/releaseWrite";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/ensuring";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_5 from "@effect/core/io/Fiber/_internal/runtime";
/**
 * Runs the specified workflow with a write lock.
 *
 * @tsplus static effect/core/stm/TReentrantLock.Aspects withWriteLock
 * @tsplus pipeable effect/core/stm/TReentrantLock withWriteLock
 */

export function withWriteLock(effect) {
  return self => tsplus_module_5.uninterruptibleMask(_ => tsplus_module_4.zipRight(tsplus_module_3.ensuring(tsplus_module_2.releaseWrite(self).commit)(_.restore(effect)))(_.restore(tsplus_module_1.acquireWrite(self).commit)));
}
//# sourceMappingURL=withWriteLock.mjs.map