import * as tsplus_module_1 from "@effect/core/stm/STM/operations/effect";
import { getOrMakeEntry } from "@effect/core/stm/TRef/operations/_internal/getOrMakeEntry";
/**
 * Sets the value of the `TRef` and returns the old value.
 *
 * @tsplus static effect/core/stm/TRef.Aspects getAndSet
 * @tsplus pipeable effect/core/stm/TRef getAndSet
 */

export function getAndSet(value) {
  return self => tsplus_module_1.effect(journal => {
    const entry = getOrMakeEntry(self, journal);
    const oldValue = entry.use(_ => _.unsafeGet());
    entry.use(_ => _.unsafeSet(value));
    return oldValue;
  });
}
//# sourceMappingURL=getAndSet.mjs.map