import * as tsplus_module_1 from "@effect/core/stm/STM/operations/effect";
import { getOrMakeEntry } from "@effect/core/stm/TRef/operations/_internal/getOrMakeEntry";
/**
 * Updates the value of the variable, returning a function of the specified
 * value.
 *
 * @tsplus static effect/core/stm/TRef.Aspects modify
 * @tsplus pipeable effect/core/stm/TRef modify
 */

export function modify(f) {
  return self => tsplus_module_1.effect(journal => {
    const entry = getOrMakeEntry(self, journal);
    const [retValue, newValue] = entry.use(_ => f(_.unsafeGet()));
    entry.use(_ => _.unsafeSet(newValue));
    return retValue;
  });
}
//# sourceMappingURL=modify.mjs.map