import * as tsplus_module_1 from "@effect/core/stm/STM/operations/effect";
import { getOrMakeEntry } from "@effect/core/stm/TRef/operations/_internal/getOrMakeEntry";
/**
 * Updates the value of the variable.
 *
 * @tsplus static effect/core/stm/TRef.Aspects update
 * @tsplus pipeable effect/core/stm/TRef update
 */

export function update(f) {
  return self => tsplus_module_1.effect(journal => {
    const entry = getOrMakeEntry(self, journal);
    const newValue = entry.use(_ => f(_.unsafeGet()));
    entry.use(_ => _.unsafeSet(newValue));
    return undefined;
  });
}
//# sourceMappingURL=update.mjs.map