import * as tsplus_module_1 from "@effect/core/stm/STM/operations/effect";
import { getOrMakeEntry } from "@effect/core/stm/TRef/operations/_internal/getOrMakeEntry";
/**
 * Updates the value of the variable and returns the new value.
 *
 * @tsplus static effect/core/stm/TRef.Aspects updateAndGet
 * @tsplus pipeable effect/core/stm/TRef updateAndGet
 */

export function updateAndGet(f) {
  return self => tsplus_module_1.effect(journal => {
    const entry = getOrMakeEntry(self, journal);
    const newValue = entry.use(_ => f(_.unsafeGet()));
    entry.use(_ => _.unsafeSet(newValue));
    return newValue;
  });
}
//# sourceMappingURL=updateAndGet.mjs.map