import * as tsplus_module_1 from "@effect/core/io/Cause/errors";
import * as tsplus_module_2 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_3 from "@effect/core/stm/TRef/operations/unsafeSet";
import { STMEffect, STMRetryException } from "@effect/core/stm/STM/definition/primitives";
import { concreteTSemaphore } from "@effect/core/stm/TSemaphore/operations/_internal/TSemaphoreInternal";
/**
 * Acquires the specified number of permits in a transactional context.
 *
 * @tsplus static effect/core/stm/TSemaphore.Aspects acquireN
 * @tsplus pipeable effect/core/stm/TSemaphore acquireN
 */

export function acquireN(n) {
  return self => {
    void 0;
    return new STMEffect(journal => {
      if (n < 0) {
        throw new tsplus_module_1.IllegalArgumentException(`Unexpected negative value ${n} passed to acquireN`);
      }

      const value = tsplus_module_2.unsafeGet(journal)(self.permits);

      if (value < n) {
        throw new STMRetryException();
      } else {
        return tsplus_module_3.unsafeSet(value - n, journal)(self.permits);
      }
    });
  };
}
//# sourceMappingURL=acquireN.mjs.map