import * as tsplus_module_1 from "@effect/core/io/Cause/errors";
import * as tsplus_module_2 from "@effect/core/stm/TRef/operations/unsafeGet";
import * as tsplus_module_3 from "@effect/core/stm/TRef/operations/unsafeSet";
import * as tsplus_module_4 from "@effect/core/stm/STM/operations/effect";
import { concreteTSemaphore } from "@effect/core/stm/TSemaphore/operations/_internal/TSemaphoreInternal";
/**
 * Releases the specified number of permits in a transactional context
 *
 * @tsplus static effect/core/stm/TSemaphore.Aspects releaseN
 * @tsplus pipeable effect/core/stm/TSemaphore releaseN
 */

export function releaseN(n) {
  return self => {
    void 0;
    return tsplus_module_4.effect(journal => {
      if (n < 0) {
        throw new tsplus_module_1.IllegalArgumentException(`Unexpected negative value ${n} passed to releaseN`);
      }

      const current = tsplus_module_2.unsafeGet(journal)(self.permits);
      return tsplus_module_3.unsafeSet(current + n, journal)(self.permits);
    });
  };
}
//# sourceMappingURL=releaseN.mjs.map