import * as tsplus_module_1 from "@effect/core/stm/TSemaphore/operations/acquireN";
import * as tsplus_module_2 from "@effect/core/stm/TSemaphore/operations/releaseN";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/ensuring";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_5 from "@effect/core/io/Fiber/_internal/runtime";
/**
 * Executes the specified effect, acquiring the specified number of permits
 * immediately before the effect begins execution and releasing them
 * immediately after the effect completes execution, whether by success,
 * failure, or interruption.
 *
 * @tsplus static effect/core/stm/TSemaphore.Aspects withPermits
 * @tsplus pipeable effect/core/stm/TSemaphore withPermits
 */

export function withPermits(permits) {
  return self => {
    return effect => tsplus_module_5.uninterruptibleMask(({
      restore
    }) => tsplus_module_4.zipRight(tsplus_module_3.ensuring(tsplus_module_2.releaseN(permits)(self).commit)(restore(effect)))(restore(tsplus_module_1.acquireN(permits)(self).commit)));
  };
}
//# sourceMappingURL=withPermits.mjs.map