import * as tsplus_module_1 from "@effect/core/stm/TSemaphore/operations/acquireN";
import * as tsplus_module_2 from "@effect/core/stm/TSemaphore/operations/releaseN";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/acquireReleaseInterruptible";
/**
 * Returns a scoped effect that describes acquiring the specified number of
 * permits and releasing them when the scope is closed.
 *
 * @tsplus static effect/core/stm/TSemaphore.Aspects withPermitsScoped
 * @tsplus pipeable effect/core/stm/TSemaphore withPermitsScoped
 */

export function withPermitsScoped(permits) {
  return self => tsplus_module_3.acquireReleaseInterruptible(tsplus_module_1.acquireN(permits)(self).commit, tsplus_module_2.releaseN(permits)(self).commit);
}
//# sourceMappingURL=withPermitsScoped.mjs.map