import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/has";
import * as tsplus_module_2 from "@effect/core/stm/TSet/operations/retainIfDiscard";
import * as tsplus_module_3 from "@effect/core/stm/TSet/operations/toHashSet";
import * as tsplus_module_4 from "@effect/core/stm/STM/definition/primitives";
/**
 * Atomically transforms the set into the intersection of itself and the
 * provided set.
 *
 * @tsplus static effect/core/stm/TSet.Aspects intersect
 * @tsplus pipeable effect/core/stm/TSet intersect
 */

export function intersect(other) {
  return self => tsplus_module_4.flatMap(vals => tsplus_module_2.retainIfDiscard(_ => tsplus_module_1.has(_)(vals))(self))(tsplus_module_3.toHashSet(other));
}
//# sourceMappingURL=intersect.mjs.map