import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/suspend";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/unwrap";
/**
 * Creates a channel backed by a buffer. When the buffer is empty, the channel
 * will simply passthrough its input as output. However, when the buffer is
 * non-empty, the value inside the buffer will be passed along as output.
 *
 * @tsplus static effect/core/stream/Channel.Ops buffer
 */

export function buffer(empty, isEmpty, ref) {
  return tsplus_module_1.suspend(() => bufferInternal(empty, isEmpty, ref));
}

function bufferInternal(empty, isEmpty, ref) {
  return tsplus_module_7.unwrap(ref.modify(value => isEmpty(value) ? [tsplus_module_6.readWith(inElem => tsplus_module_3.flatMap(() => bufferInternal(empty, isEmpty, ref))(tsplus_module_2.write(inElem)), inErr => tsplus_module_4.fail(inErr), inDone => tsplus_module_5.succeed(inDone)), value] : [tsplus_module_3.flatMap(() => bufferInternal(empty, isEmpty, ref))(tsplus_module_2.write(value)), empty]));
}
//# sourceMappingURL=buffer.mjs.map