import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_2 from "@effect/core/io/Cause/operations/failureOrCause";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/catchAllCause";
/**
 * Returns a new channel that is the same as this one, except if this channel
 * errors for any typed error, then the returned channel will switch over to
 * using the fallback channel returned by the specified error handler.
 *
 * @tsplus static effect/core/stream/Channel.Aspects catchAll
 * @tsplus pipeable effect/core/stream/Channel catchAll
 */

export function catchAll(f) {
  return self => tsplus_module_4.catchAllCause(cause => tsplus_module_3.fold(outErr => f(outErr), cause => tsplus_module_1.failCause(cause))(tsplus_module_2.failureOrCause(cause)))(self);
}
//# sourceMappingURL=catchAll.mjs.map