import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/succeed";
import { ContinuationK, Fold } from "@effect/core/stream/Channel/definition/primitives";
/**
 * Returns a new channel that is the same as this one, except if this channel
 * errors for any cause at all, then the returned channel will switch over to
 * using the fallback channel returned by the specified error handler.
 *
 * @tsplus static effect/core/stream/Channel.Aspects catchAllCause
 * @tsplus pipeable effect/core/stream/Channel catchAllCause
 */

export function catchAllCause(f) {
  return self => new Fold(self, new ContinuationK(tsplus_module_1.succeed, f));
}
//# sourceMappingURL=catchAllCause.mjs.map