import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/pipeTo";
/**
 * Returns a new channel, which is the same as this one, except its outputs
 * are filtered and transformed by the specified partial function.
 *
 * @tsplus static effect/core/stream/Channel.Aspects collect
 * @tsplus pipeable effect/core/stream/Channel collect
 */

export function collect(pf) {
  return self => {
    const collector = tsplus_module_6.readWith(out => tsplus_module_3.fold(() => collector, out2 => tsplus_module_2.flatMap(() => collector)(tsplus_module_1.write(out2)))(pf(out)), e => tsplus_module_4.fail(e), z => tsplus_module_5.succeed(z));
    return tsplus_module_7.pipeTo(collector)(self);
  };
}
//# sourceMappingURL=collect.mjs.map