import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/concatMapWith";
/**
 * Returns a new channel whose outputs are fed to the specified factory
 * function, which creates new channels in response. These new channels are
 * sequentially concatenated together, and all their outputs appear as outputs
 * of the newly returned channel.
 *
 * @tsplus static effect/core/stream/Channel.Aspects concatMap
 * @tsplus pipeable effect/core/stream/Channel concatMap
 */

export function concatMap(f) {
  return self => tsplus_module_1.concatMapWith(f, () => undefined, () => undefined)(self);
}
//# sourceMappingURL=concatMap.mjs.map