import { ConcatAll } from "@effect/core/stream/Channel/definition/primitives";
/**
 * Returns a new channel whose outputs are fed to the specified factory
 * function, which creates new channels in response. These new channels are
 * sequentially concatenated together, and all their outputs appear as outputs
 * of the newly returned channel. The provided merging function is used to
 * merge the terminal values of all channels into the single terminal value of
 * the returned channel.
 *
 * @tsplus static effect/core/stream/Channel.Aspects concatMapWithCustom
 * @tsplus pipeable effect/core/stream/Channel concatMapWithCustom
 */

export function concatMapWithCustom(f, g, h, onPull, onEmit) {
  return self => new ConcatAll(g, h, onPull, onEmit, () => self, f);
}
//# sourceMappingURL=concatMapWithCustom.mjs.map