import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/builder";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/sync";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/suspend";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/readWith";
/**
 * Returns a new channel, which is the same as this one, except that all the
 * outputs are collected and bundled into a tuple together with the terminal
 * value of this channel.
 *
 * As the channel returned from this channel collects all of this channel's
 * output into an in- memory chunk, it is not safe to call this method on
 * channels that output a large or unbounded number of values.
 *
 * @tsplus getter effect/core/stream/Channel doneCollect
 */

export function doneCollect(self) {
  return tsplus_module_5.suspend(() => {
    const builder = tsplus_module_1.builder();
    return tsplus_module_4.flatMap(z => tsplus_module_2.sync(() => [builder.build(), z]))(tsplus_module_3.pipeTo(reader(builder))(self));
  });
}

function reader(builder) {
  return tsplus_module_8.readWith(outElem => tsplus_module_4.flatMap(() => reader(builder))(tsplus_module_2.sync(() => {
    builder.append(outElem);
  })), outErr => tsplus_module_6.fail(outErr), outDone => tsplus_module_7.succeed(outDone));
}
//# sourceMappingURL=doneCollect.mjs.map