import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/interruptWhen";
/**
 * Returns a new channel, which is the same as this one, except it will be
 * interrupted when the specified deferred is completed. If the deferred is
 * completed before the underlying channel is done, then the returned channel
 * will yield the value of the deferred. Otherwise, if the underlying channel
 * finishes first, then the returned channel will yield the value of the
 * underlying channel.
 *
 * @tsplus static effect/core/stream/Channel.Aspects interruptWhenDeferred
 * @tsplus pipeable effect/core/stream/Channel interruptWhenDeferred
 */

export function interruptWhenDeferred(deferred) {
  return self => tsplus_module_1.interruptWhen(deferred.await)(self);
}
//# sourceMappingURL=interruptWhenDeferred.mjs.map