import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/sync";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/flatMap";
/**
 * Returns a new channel, which is the same as this one, except the terminal
 * value of the returned channel is created by applying the specified function
 * to the terminal value of this channel.
 *
 * @tsplus static effect/core/stream/Channel.Aspects map
 * @tsplus pipeable effect/core/stream/Channel map
 */

export function map(f) {
  return self => tsplus_module_2.flatMap(z => tsplus_module_1.sync(() => f(z)))(self);
}
//# sourceMappingURL=map.mjs.map