import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/flatMap";
/**
 * Returns a new channel, which is the same as this one, except the terminal
 * value of the returned channel is created by applying the specified
 * effectful function to the terminal value of this channel.
 *
 * @tsplus static effect/core/stream/Channel.Aspects mapEffect
 * @tsplus pipeable effect/core/stream/Channel mapEffect
 */

export function mapEffect(f) {
  return self => tsplus_module_2.flatMap(z => tsplus_module_1.fromEffect(f(z)))(self);
}
//# sourceMappingURL=mapEffect.mjs.map