import * as tsplus_module_1 from "@effect/core/io/Cause/operations/map";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/mapErrorCause";
/**
 * Returns a new channel, which is the same as this one, except the failure
 * value of the returned channel is created by applying the specified function
 * to the failure value of this channel.
 *
 * @tsplus static effect/core/stream/Channel.Aspects mapError
 * @tsplus pipeable effect/core/stream/Channel mapError
 */

export function mapError(f) {
  return self => tsplus_module_2.mapErrorCause(cause => tsplus_module_1.map(f)(cause))(self);
}
//# sourceMappingURL=mapError.mjs.map