import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/catchAllCause";
/**
 * A more powerful version of `mapError` which also surfaces the `Cause`
 * of the channel failure.
 *
 * @tsplus static effect/core/stream/Channel.Aspects mapErrorCause
 * @tsplus pipeable effect/core/stream/Channel mapErrorCause
 */

export function mapErrorCause(f) {
  return self => tsplus_module_2.catchAllCause(cause => tsplus_module_1.failCause(f(cause)))(self);
}
//# sourceMappingURL=mapErrorCause.mjs.map