import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/pipeTo";
/**
 * Maps the output of this channel using the specified function.
 *
 * @tsplus static effect/core/stream/Channel.Aspects mapOut
 * @tsplus pipeable effect/core/stream/Channel mapOut
 */

export function mapOut(f) {
  return self => {
    const reader = tsplus_module_5.readWith(outElem => tsplus_module_2.flatMap(() => reader)(tsplus_module_1.write(f(outElem))), outErr => tsplus_module_3.fail(outErr), outDone => tsplus_module_4.succeed(outDone));
    return tsplus_module_6.pipeTo(reader)(self);
  };
}
//# sourceMappingURL=mapOut.mjs.map