import * as tsplus_module_1 from "@effect/core/stream/Channel/MergeStrategy";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_6 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/flatten";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/foldCause";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/unwrap";
import * as tsplus_module_10 from "@tsplus/stdlib/prelude/Equivalence/boolean";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_12 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_13 from "@effect/core/io/Fiber/operations/interruptAll";
import * as tsplus_module_14 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_15 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_16 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_17 from "@effect/core/stm/TSemaphore/operations/withPermits";
import * as tsplus_module_18 from "@effect/core/io/Fiber/operations/interrupt";
import * as tsplus_module_19 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_20 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_21 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_22 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_23 from "@effect/core/io/Effect/operations/raceWith";
import * as tsplus_module_24 from "@effect/core/stm/TSemaphore/operations/withPermit";
import * as tsplus_module_25 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_26 from "@effect/core/io/Effect/operations/race";
import * as tsplus_module_27 from "@effect/core/stream/Channel/operations/toPull";
import * as tsplus_module_28 from "@effect/core/io/Effect/operations/scoped";
import * as tsplus_module_29 from "@effect/core/io/Deferred/operations/make";
import * as tsplus_module_30 from "@effect/core/io/Effect/operations/do";
import * as tsplus_module_31 from "@effect/core/io/Effect/operations/tap";
import * as tsplus_module_32 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_33 from "@effect/core/io/Effect/operations/when";
import * as tsplus_module_34 from "@effect/core/io/Effect/operations/foldCauseEffect";
import * as tsplus_module_35 from "@effect/core/io/Effect/operations/repeatWhileEquals";
import * as tsplus_module_36 from "@effect/core/io/Effect/operations/forkScoped";
import * as tsplus_module_37 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_38 from "@effect/core/io/Effect/operations/repeatUntil";
import * as tsplus_module_39 from "@effect/core/io/Effect/operations/catchAllCause";
import * as tsplus_module_40 from "@effect/core/stm/TSemaphore/operations/makeCommit";
import * as tsplus_module_41 from "@effect/core/io/Ref/operations/make";
import * as tsplus_module_42 from "@effect/core/io/Queue/operations/unbounded";
import * as tsplus_module_43 from "@effect/core/io/Queue/external/bounded";
import * as tsplus_module_44 from "@effect/core/io/Effect/operations/addFinalizer";
import * as tsplus_module_45 from "@effect/core/io/Effect/operations/withChildren";
import * as tsplus_module_46 from "@effect/core/stream/Channel/operations/unwrapScoped";
/**
 * @tsplus static effect/core/stream/Channel.Ops mergeAllWith
 */

export function mergeAllWith(channels, n, f, bufferSize = 16, mergeStrategy = tsplus_module_1.BackPressure) {
  return tsplus_module_46.unwrapScoped(tsplus_module_32.map(queue => {
    const consumer = tsplus_module_9.unwrap(tsplus_module_8.foldCause(cause => tsplus_module_2.failCause(cause), either => tsplus_module_6.fold(outDone => tsplus_module_3.succeed(outDone), outElem => tsplus_module_5.flatMap(() => consumer)(tsplus_module_4.write(outElem)))(either))(tsplus_module_7.flatten(queue.take)));
    return consumer;
  })(tsplus_module_45.withChildren(getChildren => tsplus_module_14.flatMap(() => tsplus_module_14.flatMap(queue => tsplus_module_14.flatMap(cancelers => tsplus_module_14.flatMap(lastDone => tsplus_module_14.flatMap(errorSignal => tsplus_module_14.flatMap(permits => tsplus_module_14.flatMap(pull => {
    const evaluatePull = pull => tsplus_module_39.catchAllCause(cause => tsplus_module_15.zipRight(tsplus_module_16.asUnit(errorSignal.succeed(undefined)))(queue.offer(tsplus_module_11.failCause(cause))))(tsplus_module_14.flatMap(option => tsplus_module_22.fold(() => tsplus_module_16.unit, outDone => lastDone.update(_ => tsplus_module_22.fold(() => tsplus_module_37.some(outDone), lastDone => tsplus_module_37.some(f(lastDone, outDone)))(_)))(option))(tsplus_module_38.repeatUntil(option => tsplus_module_37.isSome(option))(tsplus_module_14.flatMap(either => tsplus_module_6.fold(done => tsplus_module_20.succeed(tsplus_module_37.some(done)), out => tsplus_module_12.as(tsplus_module_37.none)(queue.offer(tsplus_module_20.succeed(tsplus_module_19.right(out)))))(either))(pull))));

    return tsplus_module_32.map(() => queue)(tsplus_module_36.forkScoped(tsplus_module_35.repeatWhileEquals(tsplus_module_10.boolean, true)(tsplus_module_34.foldCauseEffect(cause => tsplus_module_15.zipRight(tsplus_module_12.as(false)(queue.offer(tsplus_module_11.failCause(cause))))(tsplus_module_14.flatMap(tsplus_module_13.interruptAll)(getChildren)), either => tsplus_module_6.fold(outDone => tsplus_module_23.raceWith(tsplus_module_17.withPermits(n)(permits)(tsplus_module_16.unit), (_, permitAcquisition) => tsplus_module_15.zipRight(tsplus_module_12.as(false)(tsplus_module_18.interrupt(permitAcquisition)))(tsplus_module_14.flatMap(tsplus_module_13.interruptAll)(getChildren)), (_, failureAwait) => tsplus_module_15.zipRight(tsplus_module_14.flatMap(option => tsplus_module_22.fold(() => queue.offer(tsplus_module_20.succeed(tsplus_module_19.left(outDone))), lastDone => queue.offer(tsplus_module_21.sync(() => tsplus_module_19.left(f(lastDone, outDone)))))(option))(lastDone.get))(tsplus_module_18.interrupt(failureAwait)))(errorSignal.await), channel => {
      switch (mergeStrategy._tag) {
        case "BackPressure":
          {
            return tsplus_module_32.map(({
              errored
            }) => !errored)(tsplus_module_30.bind("errored", () => errorSignal.isDone)(tsplus_module_31.tap(({
              latch
            }) => latch.await)(tsplus_module_31.tap(({
              latch,
              raceIOs
            }) => tsplus_module_25.fork(tsplus_module_24.withPermit(permits)(tsplus_module_15.zipRight(raceIOs)(latch.succeed(undefined)))))(tsplus_module_30.bindValue("raceIOs", () => tsplus_module_28.scoped(tsplus_module_14.flatMap(pull => tsplus_module_26.race(errorSignal.await)(evaluatePull(pull)))(tsplus_module_27.toPull(channel))))(tsplus_module_30.bind("latch", () => tsplus_module_29.make())(tsplus_module_30.Do()))))));
          }

        case "BufferSliding":
          {
            return tsplus_module_32.map(({
              errored
            }) => !errored)(tsplus_module_30.bind("errored", () => errorSignal.isDone)(tsplus_module_31.tap(({
              latch
            }) => latch.await)(tsplus_module_31.tap(({
              latch,
              raceIOs
            }) => tsplus_module_25.fork(tsplus_module_24.withPermit(permits)(tsplus_module_15.zipRight(raceIOs)(latch.succeed(undefined)))))(tsplus_module_30.bindValue("raceIOs", ({
              canceler
            }) => tsplus_module_28.scoped(tsplus_module_14.flatMap(pull => tsplus_module_26.race(canceler.await)(tsplus_module_26.race(errorSignal.await)(evaluatePull(pull))))(tsplus_module_27.toPull(channel))))(tsplus_module_31.tap(({
              canceler
            }) => cancelers.offer(canceler))(tsplus_module_31.tap(({
              size
            }) => tsplus_module_33.when(() => size >= n, tsplus_module_14.flatMap(deferred => deferred.succeed(undefined))(cancelers.take)))(tsplus_module_30.bind("size", () => cancelers.size)(tsplus_module_30.bind("latch", () => tsplus_module_29.make())(tsplus_module_30.bind("canceler", () => tsplus_module_29.make())(tsplus_module_30.Do()))))))))));
          }
      }
    })(either))(pull))));
  })(tsplus_module_27.toPull(channels)))(tsplus_module_40.makeCommit(n)))(tsplus_module_29.make()))(tsplus_module_41.makeRef(() => tsplus_module_37.none)))(tsplus_module_25.acquireRelease(tsplus_module_42.unbounded(), queue => queue.shutdown)))(tsplus_module_25.acquireRelease(tsplus_module_43.bounded(bufferSize), queue => queue.shutdown)))(tsplus_module_44.addFinalizer(tsplus_module_14.flatMap(tsplus_module_13.interruptAll)(getChildren))))));
}
//# sourceMappingURL=mergeAllWith.mjs.map