import * as tsplus_module_1 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_2 from "@effect/core/stream/Channel/MergeState";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/zipWith";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/embedInput";
import * as tsplus_module_7 from "@effect/core/io/Fiber/operations/join";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/raceWith";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/unwrap";
import * as tsplus_module_10 from "@effect/core/io/Exit/operations/failCause";
import * as tsplus_module_11 from "@effect/core/io/Exit/operations/succeed";
import * as tsplus_module_12 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_13 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_14 from "@effect/core/io/Exit/operations/fold";
import * as tsplus_module_15 from "@effect/core/io/Effect/operations/exit";
import * as tsplus_module_16 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_17 from "@effect/core/io/Fiber/operations/interrupt";
import * as tsplus_module_18 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_19 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_20 from "@effect/core/stream/Channel/operations/zipRight";
import * as tsplus_module_21 from "@effect/core/io/Fiber/operations/await";
import * as tsplus_module_22 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_23 from "@effect/core/stream/Channel/operations/toPull";
import * as tsplus_module_24 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_25 from "@effect/core/stream/Channel/operations/fromInput";
import * as tsplus_module_26 from "@effect/core/stream/Channel/SingleProducerAsyncInput";
import * as tsplus_module_27 from "@effect/core/stream/Channel/operations/unwrapScoped";
import { concreteMergeDecision } from "@effect/core/stream/Channel/MergeDecision";
/**
 * Returns a new channel, which is the merge of this channel and the specified
 * channel, where the behavior of the returned channel on left or right early
 * termination is decided by the specified `leftDone` and `rightDone` merge
 * decisions.
 *
 * @tsplus static effect/core/stream/Channel.Aspects mergeWith
 * @tsplus pipeable effect/core/stream/Channel mergeWith
 */

export function mergeWith_(that, leftDone, rightDone) {
  return self => tsplus_module_27.unwrapScoped(tsplus_module_24.flatMap(input => {
    const queueReader = tsplus_module_25.fromInput(input);
    return tsplus_module_24.flatMap(pullL => tsplus_module_16.map(pullR => {
      const handleSide = (exit, fiber, pull) => (done, both, single) => {
        const onDecision = decision => {
          void 0;

          if (decision._tag === "Done") {
            return tsplus_module_19.succeed(tsplus_module_4.fromEffect(tsplus_module_18.zipRight(decision.io)(tsplus_module_17.interrupt(fiber))));
          }

          return tsplus_module_16.map(exit => tsplus_module_14.fold(cause => tsplus_module_4.fromEffect(decision.f(tsplus_module_10.failCause(cause))), either => tsplus_module_13.fold(done => tsplus_module_4.fromEffect(decision.f(tsplus_module_11.succeed(done))), elem => tsplus_module_20.zipRight(go(single(decision.f)))(tsplus_module_12.write(elem)))(either))(exit))(tsplus_module_21._await(fiber));
        };

        return tsplus_module_14.fold(cause => onDecision(done(tsplus_module_10.failCause(cause))), either => tsplus_module_13.fold(z => onDecision(done(tsplus_module_11.succeed(z))), elem => tsplus_module_19.succeed(tsplus_module_5.flatMap(() => tsplus_module_5.flatMap(leftFiber => go(both(leftFiber, fiber)))(tsplus_module_4.fromEffect(tsplus_module_1.forkDaemon(pull))))(tsplus_module_12.write(elem))))(either))(exit);
      };

      const go = state => {
        switch (state._tag) {
          case "BothRunning":
            {
              const lj = tsplus_module_7.join(state.left);
              const rj = tsplus_module_7.join(state.right);
              return tsplus_module_9.unwrap(tsplus_module_8.raceWith(rj, (leftEx, _) => handleSide(leftEx, state.right, pullL)(leftDone, (l, r) => tsplus_module_2.bothRunning(l, r), _ => tsplus_module_2.leftDone(_)), (rightEx, _) => handleSide(rightEx, state.left, pullR)(rightDone, (l, r) => tsplus_module_2.bothRunning(r, l), _ => tsplus_module_2.rightDone(_)))(lj));
            }

          case "LeftDone":
            {
              return tsplus_module_9.unwrap(tsplus_module_16.map(exit => tsplus_module_14.fold(cause => tsplus_module_4.fromEffect(state.f(tsplus_module_10.failCause(cause))), either => tsplus_module_13.fold(done => tsplus_module_4.fromEffect(state.f(tsplus_module_11.succeed(done))), elem => tsplus_module_5.flatMap(() => go(tsplus_module_2.leftDone(state.f)))(tsplus_module_12.write(elem)))(either))(exit))(tsplus_module_15.exit(pullR)));
            }

          case "RightDone":
            {
              return tsplus_module_9.unwrap(tsplus_module_16.map(exit => tsplus_module_14.fold(cause => tsplus_module_4.fromEffect(state.f(tsplus_module_10.failCause(cause))), either => tsplus_module_13.fold(done => tsplus_module_4.fromEffect(state.f(tsplus_module_11.succeed(done))), elem => tsplus_module_5.flatMap(() => go(tsplus_module_2.rightDone(state.f)))(tsplus_module_12.write(elem)))(either))(exit))(tsplus_module_15.exit(pullL)));
            }
        }
      };

      return tsplus_module_6.embedInput(input)(tsplus_module_5.flatMap(go)(tsplus_module_4.fromEffect(tsplus_module_3.zipWith(tsplus_module_1.forkDaemon(pullR), (left, right) => tsplus_module_2.bothRunning(left, right))(tsplus_module_1.forkDaemon(pullL)))));
    })(tsplus_module_23.toPull(tsplus_module_22.pipeTo(that)(queueReader))))(tsplus_module_23.toPull(tsplus_module_22.pipeTo(self)(queueReader)));
  })(tsplus_module_26.make()));
}
//# sourceMappingURL=mergeWith.mjs.map