import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_3 from "@effect/core/io/Cause/errors";
import * as tsplus_module_4 from "@effect/core/io/Cause/definition";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/failCauseSync";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/readWithCause";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/pipeTo";
import { isChannelError } from "@effect/core/io/Cause/errors";
/**
 * @tsplus static effect/core/stream/Channel.Aspects pipeToOrFail
 * @tsplus pipeable effect/core/stream/Channel pipeToOrFail
 */

export function pipeToOrFail(that) {
  return self => {
    const reader = tsplus_module_7.readWith(outElem => tsplus_module_2.flatMap(() => reader)(tsplus_module_1.write(outElem)), outErr => tsplus_module_5.failCauseSync(() => tsplus_module_4.die(new tsplus_module_3.ChannelError(outErr))), outDone => tsplus_module_6.succeed(outDone));
    const writer = tsplus_module_10.readWithCause(outElem => tsplus_module_2.flatMap(() => writer)(tsplus_module_1.write(outElem)), cause => tsplus_module_4.isDieType(cause) && isChannelError(cause.value) ? tsplus_module_8.fail(cause.value.error) : tsplus_module_9.failCause(cause), outDone => tsplus_module_6.succeed(outDone));
    return tsplus_module_11.pipeTo(writer)(tsplus_module_11.pipeTo(that)(tsplus_module_11.pipeTo(reader)(self)));
  };
}
//# sourceMappingURL=pipeToOrFail.mjs.map