import * as tsplus_module_1 from "@effect/core/io/Effect/operations/suspendSucceed";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Function";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_5 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/done";
import { ChannelExecutor, readUpstream } from "@effect/core/stream/Channel/ChannelExecutor";
import { concreteChannelState } from "@effect/core/stream/Channel/ChannelState";
/**
 * Runs a channel until the end is received.
 *
 * @tsplus getter effect/core/stream/Channel runScoped
 */

export function runScoped(self) {
  return tsplus_module_6.flatMap(exec => tsplus_module_1.suspendSucceed(() => interpret(exec.run(), exec)))(tsplus_module_5.acquireReleaseExit(tsplus_module_3.sync(() => new ChannelExecutor(() => self, undefined, tsplus_module_2.identity)), (exec, exit) => {
    const finalize = exec.close(exit);
    return finalize != null ? finalize : tsplus_module_4.unit;
  }));
}

function interpret(channelState, exec) {
  void 0;

  switch (channelState._tag) {
    case "Effect":
      {
        return tsplus_module_6.flatMap(() => interpret(exec.run(), exec))(channelState.effect);
      }

    case "Emit":
      {
        // Can't really happen because Out <:< Nothing. So just skip ahead.
        return interpret(exec.run(), exec);
      }

    case "Done":
      {
        return tsplus_module_7.done(exec.getDone());
      }

    case "Read":
      {
        return readUpstream(channelState, () => interpret(exec.run(), exec));
      }
  }
}
//# sourceMappingURL=runScoped.mjs.map