import * as tsplus_module_1 from "@effect/core/io/Effect/operations/suspendSucceed";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Function";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_5 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_8 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_9 from "@effect/core/io/Exit/operations/fold";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/flatMap";
import { ChannelExecutor, readUpstream } from "@effect/core/stream/Channel/ChannelExecutor";
import { concreteChannelState } from "@effect/core/stream/Channel/ChannelState";
/**
 * Interpret a `Channel` to a managed pull.
 *
 * @tsplus getter effect/core/stream/Channel toPull
 * @tsplus static effect/core/stream/Channel.Ops toPull
 */

export function toPull(self) {
  return tsplus_module_6.map(exec => tsplus_module_1.suspendSucceed(() => interpret(exec.run(), exec)))(tsplus_module_5.acquireReleaseExit(tsplus_module_3.sync(() => new ChannelExecutor(() => self, undefined, tsplus_module_2.identity)), (exec, exit) => {
    const finalize = exec.close(exit);
    return finalize == null ? tsplus_module_4.unit : finalize;
  }));
}

function interpret(channelState, exec) {
  void 0;

  switch (channelState._tag) {
    case "Done":
      {
        return tsplus_module_9.fold(cause => tsplus_module_7.failCause(cause), done => tsplus_module_3.sync(() => tsplus_module_8.left(done)))(exec.getDone());
      }

    case "Emit":
      {
        return tsplus_module_3.sync(() => tsplus_module_8.right(exec.getEmit()));
      }

    case "Effect":
      {
        return tsplus_module_10.flatMap(() => interpret(exec.run(), exec))(channelState.effect);
      }

    case "Read":
      {
        return readUpstream(channelState, () => interpret(exec.run(), exec));
      }
  }
}
//# sourceMappingURL=toPull.mjs.map