import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/suspend";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_5 from "@effect/core/io/Exit/operations/failCause";
import * as tsplus_module_6 from "@effect/core/io/Exit/operations/succeed";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/readWithCause";
/**
 * @tsplus getter effect/core/stream/Channel toQueue
 * @tsplus static effect/core/stream/Channel.Ops toQueue
 */

export function toQueue(queue) {
  return tsplus_module_1.suspend(() => toQueueInternal(queue));
}

function toQueueInternal(queue) {
  return tsplus_module_7.readWithCause(elem => tsplus_module_4.flatMap(() => toQueueInternal(queue))(tsplus_module_3.fromEffect(queue.offer(tsplus_module_2.right(elem)))), cause => tsplus_module_3.fromEffect(queue.offer(tsplus_module_2.left(tsplus_module_5.failCause(cause)))), done => tsplus_module_3.fromEffect(queue.offer(tsplus_module_2.left(tsplus_module_6.succeed(done)))));
}
//# sourceMappingURL=toQueue.mjs.map