import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/map";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/flatMap";
/**
 * Returns a new channel that is the sequential composition of this channel
 * and the specified channel. The returned channel terminates with a tuple of
 * the terminal values of both channels.
 *
 * @tsplus pipeable-operator effect/core/stream/Channel +
 * @tsplus static effect/core/stream/Channel.Aspects zip
 * @tsplus pipeable effect/core/stream/Channel zip
 */

export function zip(that) {
  return self => tsplus_module_2.flatMap(a => tsplus_module_1.map(b => [a, b])(that))(self);
}
//# sourceMappingURL=zip.mjs.map