import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/map";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/flatMap";
/**
 * Returns a new channel that is the sequential composition of this channel
 * and the specified channel. The returned channel terminates with a flattened
 * tuple of the terminal values of both channels.
 *
 * @tsplus static effect/core/stream/Channel.Aspects zipFlatten
 * @tsplus pipeable effect/core/stream/Channel zipFlatten
 */

export function zipFlatten(that) {
  return self => tsplus_module_2.flatMap(a => tsplus_module_1.map(b => [...a, b])(that))(self);
}
//# sourceMappingURL=zipFlatten.mjs.map