import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/as";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/flatMap";
/**
 * Returns a new channel that is the sequential composition of this channel
 * and the specified channel. The returned channel terminates with the
 * terminal value of this channel.
 *
 * @tsplus pipeable-operator effect/core/stream/Channel <
 * @tsplus static effect/core/stream/Channel.Aspects zipLeft
 * @tsplus pipeable effect/core/stream/Channel zipLeft
 */

export function zipLeft(that) {
  return self => tsplus_module_2.flatMap(z => tsplus_module_1.as(z)(that))(self);
}
//# sourceMappingURL=zipLeft.mjs.map