import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/flatMap";
/**
 * Returns a new channel that is the sequential composition of this channel
 * and the specified channel. The returned channel terminates with the
 * terminal value of that channel.
 *
 * @tsplus pipeable-operator effect/core/stream/Channel >
 * @tsplus static effect/core/stream/Channel.Aspects zipRight
 * @tsplus pipeable effect/core/stream/Channel zipRight
 */

export function zipRight(that) {
  return self => tsplus_module_1.flatMap(() => that)(self);
}
//# sourceMappingURL=zipRight.mjs.map