import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/map";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/flatMap";
/**
 * Returns a new channel that is the sequential composition of this channel
 * and the specified channel. The returned channel terminates with the result
 * of calling the specified function on the terminal values of both channels.
 *
 * @tsplus static effect/core/stream/Channel.Aspects zipWith
 * @tsplus pipeable effect/core/stream/Channel zipWith
 */

export function zipWith(that, f) {
  return self => tsplus_module_2.flatMap(a => tsplus_module_1.map(b => f(a, b))(that))(self);
}
//# sourceMappingURL=zipWith.mjs.map