var _a;

import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/fromQueueWithShutdown";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/flattenExitMaybe";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/flatMapPar";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashMap/operations/set";
import * as tsplus_module_5 from "@effect/core/io/Exit/operations/map";
import * as tsplus_module_6 from "@effect/core/io/Exit/operations/succeed";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_11 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_12 from "@tsplus/stdlib/collections/HashMap/operations/get";
import * as tsplus_module_13 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_14 from "@effect/core/stream/Stream/operations/mapEffect";
import * as tsplus_module_15 from "@effect/core/stream/Stream/operations/distributedWithDynamic";
import * as tsplus_module_16 from "@tsplus/stdlib/collections/HashMap/operations/empty";
import * as tsplus_module_17 from "@effect/core/io/Ref/operations/make";
import * as tsplus_module_18 from "@effect/core/io/Queue/external/bounded";
import * as tsplus_module_19 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_20 from "@effect/core/io/Deferred/operations/make";
import * as tsplus_module_21 from "@effect/core/stream/Stream/operations/unwrapScoped";
import * as tsplus_module_22 from "@effect/core/stream/Stream/operations/zipWithIndex";
import * as tsplus_module_23 from "@effect/core/stream/Stream/operations/filterEffect";
import * as tsplus_module_24 from "@effect/core/stream/Stream/operations/map";
import { GroupBySym } from "@effect/core/stream/GroupBy/definition/base";
import { _A, _E, _K, _R, _V } from "@effect/core/stream/GroupBy/definition/symbols";
import { mapDequeue } from "@effect/core/stream/GroupBy/operations/_internal/mapDequeue";
export class GroupByInternal {
  constructor(stream, key, buffer) {
    this.stream = stream;
    this.key = key;
    this.buffer = buffer;
    this[_a] = GroupBySym;
  }
  /**
   * Run the function across all groups, collecting the results in an
   * arbitrary order.
   */


  apply(f) {
    return tsplus_module_3.flatMapPar(Number.MAX_SAFE_INTEGER, ([key, queue]) => f(key, tsplus_module_2.flattenExitMaybe(tsplus_module_1.fromQueueWithShutdown(queue))), this.buffer)(this.grouped());
  }

  grouped() {
    return tsplus_module_21.unwrapScoped(tsplus_module_9.flatMap(decider => tsplus_module_9.flatMap(out => tsplus_module_9.flatMap(ref => tsplus_module_9.flatMap(add => tsplus_module_13.map(() => tsplus_module_2.flattenExitMaybe(tsplus_module_1.fromQueueWithShutdown(out)))(decider.succeed((k, _) => tsplus_module_9.flatMap(option => tsplus_module_11.fold(() => tsplus_module_9.flatMap(([id, queue]) => tsplus_module_8.as(n => n === id)(tsplus_module_7.zipRight(out.offer(tsplus_module_6.succeed([k, mapDequeue(queue, exit => tsplus_module_5.map(_ => _[1])(exit))])))(ref.update(map => tsplus_module_4.set(k, id)(map)))))(add), id => tsplus_module_10.succeed(n => n === id))(option))(tsplus_module_13.map(map => tsplus_module_12.get(k)(map))(ref.get)))))(tsplus_module_15.distributedWithDynamic(this.buffer, ([k, v]) => tsplus_module_9.flatMap(f => f(k, v))(decider.await), exit => out.offer(exit))(tsplus_module_14.mapEffect(this.key)(this.stream))))(tsplus_module_17.makeRef(() => tsplus_module_16.empty())))(tsplus_module_19.acquireRelease(tsplus_module_18.bounded(this.buffer), queue => queue.shutdown)))(tsplus_module_20.make()));
  }
  /**
   * Only consider the first `n` groups found in the stream.
   */


  first(n) {
    return new FirstInternal(this.stream, this.key, this.buffer, n);
  }
  /**
   * Filter the groups to be processed.
   */


  filter(f) {
    return new FilterInternal(this.stream, this.key, this.buffer, f);
  }

}
_a = GroupBySym;
/**
 * @tsplus macro remove
 */

export function concreteGroupBy(_) {//
}
export class FirstInternal extends GroupByInternal {
  constructor(stream, key, buffer, n) {
    super(stream, key, buffer);
    this.n = n;
  }

  grouped() {
    return tsplus_module_24.map(tuple => tuple[0])(tsplus_module_23.filterEffect(elem => {
      const [[_, queue], i] = elem;
      return i < this.n ? tsplus_module_8.as(true)(tsplus_module_10.succeed(elem)) : tsplus_module_8.as(false)(queue.shutdown);
    })(tsplus_module_22.zipWithIndex(super.grouped())));
  }

}
export class FilterInternal extends GroupByInternal {
  constructor(stream, key, buffer, f) {
    super(stream, key, buffer);
    this.f = f;
  }

  grouped() {
    return tsplus_module_23.filterEffect(elem => {
      const [k, queue] = elem;
      return this.f(k) ? tsplus_module_8.as(true)(tsplus_module_10.succeed(elem)) : tsplus_module_8.as(false)(queue.shutdown);
    })(super.grouped());
  }

}
//# sourceMappingURL=GroupByInternal.mjs.map