import * as tsplus_module_1 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/map";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/map";
import { _Out, QueueSym } from "@effect/core/io/Queue/definition";

class MapDequeueImpl {
  constructor(dequeue, f) {
    this.dequeue = dequeue;
    this.f = f;
  }

  get take() {
    return tsplus_module_1.map(this.f)(this.dequeue.take);
  }

  get takeAll() {
    return tsplus_module_1.map(all => tsplus_module_2.map(this.f)(all))(this.dequeue.takeAll);
  }

  takeUpTo(max) {
    return tsplus_module_1.map(upTo => tsplus_module_2.map(this.f)(upTo))(this.dequeue.takeUpTo(max));
  }

  takeBetween(min, max) {
    return tsplus_module_1.map(upTo => tsplus_module_2.map(this.f)(upTo))(this.dequeue.takeBetween(min, max));
  }

  takeN(n) {
    return tsplus_module_1.map(upTo => tsplus_module_2.map(this.f)(upTo))(this.dequeue.takeN(n));
  }

  get poll() {
    return tsplus_module_1.map(m => tsplus_module_3.map(this.f)(m))(this.dequeue.poll);
  }

  get [_Out]() {
    return a => a;
  }

  get capacity() {
    return this.dequeue.capacity;
  }

  get size() {
    return this.dequeue.size;
  }

  get awaitShutdown() {
    return this.dequeue.awaitShutdown;
  }

  get isShutdown() {
    return this.dequeue.isShutdown;
  }

  get shutdown() {
    return this.dequeue.shutdown;
  }

  get isFull() {
    return this.dequeue.isFull;
  }

  get isEmpty() {
    return this.dequeue.isEmpty;
  }

  get [QueueSym]() {
    return QueueSym;
  }

}

export function mapDequeue(dequeue, f) {
  return new MapDequeueImpl(dequeue, f);
}
//# sourceMappingURL=mapDequeue.mjs.map