import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashMap/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashMap/_internal/hashMap";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashMap/operations/update";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashMap/operations/set";
import * as tsplus_module_5 from "@effect/core/stream/Sink/operations/foldWeighted";
/**
 * A sink that collects first `n` keys into a map. The keys are calculated
 * from inputs using the keying function `key`; if multiple inputs use the the
 * same key, they are merged using the `f` function.
 *
 * @tsplus static effect/core/stream/Sink.Ops collectAllToMapN
 */

export function collectAllToMapN(n, key, f) {
  return tsplus_module_5.foldWeighted(tsplus_module_1.empty(), (acc, in_) => tsplus_module_2.has_(acc, key(in_)) ? 0 : 1, n, (acc, in_) => {
    const k = key(in_);
    return tsplus_module_2.has_(acc, k) ? tsplus_module_3.update(k, v => f(v, in_))(acc) : tsplus_module_4.set(k, in_)(acc);
  });
}
//# sourceMappingURL=collectAllToMapN.mjs.map