import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/as";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/bufferChunk";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_9 from "@effect/core/io/Ref/operations/make";
import * as tsplus_module_10 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/zip";
import * as tsplus_module_12 from "@tsplus/stdlib/collections/Chunk/operations/flatten";
import * as tsplus_module_13 from "@effect/core/stream/Channel/operations/doneCollect";
import * as tsplus_module_14 from "@effect/core/stream/Channel/operations/foldChannel";
import { concreteSink, SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * Repeatedly runs the sink for as long as its results satisfy the predicate
 * `p`. The sink's results will be accumulated using the stepping function
 * `f`.
 *
 * @tsplus static effect/core/stream/Sink.Aspects collectAllWhileWith
 * @tsplus pipeable effect/core/stream/Sink collectAllWhileWith
 */

export function collectAllWhileWith(z, p, f) {
  return self => {
    void 0;
    return new SinkInternal(tsplus_module_2.flatMap(([leftoversRef, upstreamDoneRef]) => {
      const upstreamMarker = tsplus_module_6.readWith(chunk => tsplus_module_2.flatMap(() => upstreamMarker)(tsplus_module_1.write(chunk)), err => tsplus_module_3.fail(err), x => tsplus_module_5.as(x)(tsplus_module_4.fromEffect(upstreamDoneRef.set(true))));
      return tsplus_module_8.pipeTo(loop(self, leftoversRef, upstreamDoneRef, z, p, f))(tsplus_module_8.pipeTo(tsplus_module_7.bufferChunk(leftoversRef))(upstreamMarker));
    })(tsplus_module_4.fromEffect(tsplus_module_11.zip(tsplus_module_9.makeRef(() => false))(tsplus_module_9.makeRef(() => tsplus_module_10.empty())))));
  };
}

function loop(self, leftoversRef, upstreamDoneRef, currentResult, p, f) {
  void 0;
  return tsplus_module_14.foldChannel(err => tsplus_module_3.fail(err), ([leftovers, doneValue]) => p(doneValue) ? tsplus_module_2.flatMap(() => tsplus_module_2.flatMap(upstreamDone => {
    const accumulatedResult = f(currentResult, doneValue);
    return upstreamDone ? tsplus_module_5.as(accumulatedResult)(tsplus_module_1.write(tsplus_module_12.flatten(leftovers))) : loop(self, leftoversRef, upstreamDoneRef, accumulatedResult, p, f);
  })(tsplus_module_4.fromEffect(upstreamDoneRef.get)))(tsplus_module_4.fromEffect(leftoversRef.set(tsplus_module_12.flatten(leftovers)))) : tsplus_module_5.as(currentResult)(tsplus_module_1.write(tsplus_module_12.flatten(leftovers))))(tsplus_module_13.doneCollect(self.channel));
}
//# sourceMappingURL=collectAllWhileWith.mjs.map