import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/pipeTo";
import { concreteSink, SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * Transforms this sink's input chunks. `f` must preserve chunking-invariance.
 *
 * @tsplus static effect/core/stream/Sink.Aspects contramapChunks
 * @tsplus pipeable effect/core/stream/Sink contramapChunks
 */

export function contramapChunks(f) {
  return self => {
    const loop = tsplus_module_5.readWith(chunk => tsplus_module_2.flatMap(() => loop)(tsplus_module_1.write(f(chunk))), err => tsplus_module_3.fail(err), done => tsplus_module_4.succeed(done));
    void 0;
    return new SinkInternal(tsplus_module_6.pipeTo(self.channel)(loop));
  };
}
//# sourceMappingURL=contramapChunks.mjs.map