import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/pipeToOrFail";
import { concreteSink, SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * Effectfully transforms this sink's input chunks. `f` must preserve
 * chunking-invariance.
 *
 * @tsplus static effect/core/stream/Sink.Aspects contramapChunksEffect
 * @tsplus pipeable effect/core/stream/Sink contramapChunksEffect
 */

export function contramapChunksEffect(f) {
  return self => {
    const loop = tsplus_module_6.readWith(chunk => tsplus_module_3.flatMap(() => loop)(tsplus_module_3.flatMap(chunk => tsplus_module_1.write(chunk))(tsplus_module_2.fromEffect(f(chunk)))), err => tsplus_module_4.fail(err), done => tsplus_module_5.succeed(done));
    void 0;
    return new SinkInternal(tsplus_module_7.pipeToOrFail(self.channel)(loop));
  };
}
//# sourceMappingURL=contramapChunksEffect.mjs.map