import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/dropWhile";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/identity";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/readWith";
import { SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * @tsplus static effect/core/stream/Sink.Ops dropWhile
 */

export function dropWhile(p) {
  const loop = tsplus_module_8.readWith(chunk => {
    const leftover = tsplus_module_1.dropWhile(p)(chunk);
    const more = tsplus_module_2.isEmpty(leftover);
    return more ? loop : tsplus_module_5.flatMap(() => tsplus_module_3.identity())(tsplus_module_4.write(leftover));
  }, err => tsplus_module_6.fail(err), () => tsplus_module_7.unit);
  return new SinkInternal(loop);
}
//# sourceMappingURL=dropWhile.mjs.map