import * as tsplus_module_1 from "@effect/core/stream/Sink/operations/fail";
import * as tsplus_module_2 from "@effect/core/stream/Sink/operations/foldSink";
/**
 * Runs this sink until it yields a result, then uses that result to create
 * another sink from the provided function which will continue to run until it
 * yields a result.
 *
 * This function essentially runs sinks in sequence.
 *
 * @tsplus static effect/core/stream/Sink.Aspects flatMap
 * @tsplus pipeable effect/core/stream/Sink flatMap
 */

export function flatMap(f) {
  return self => tsplus_module_2.foldSink_(e => tsplus_module_1.fail(e), f)(self);
}
//# sourceMappingURL=flatMap.mjs.map