import * as tsplus_module_1 from "@effect/core/stream/Sink/operations/suspend";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/isNonEmpty";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/as";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_8 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_9 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_10 from "@tsplus/stdlib/collections/Chunk/operations/drop";
import { SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * A sink that folds its inputs with the provided function, termination
 * predicate and initial state.
 *
 * @tsplus static effect/core/stream/Sink.Ops fold
 */

export function fold(z, cont, f) {
  return tsplus_module_1.suspend(() => new SinkInternal(reader(z, cont, f)));
}

function reader(z, cont, f) {
  return !cont(z) ? tsplus_module_2.succeed(z) : tsplus_module_7.readWith(chunk => {
    const [nextS, leftovers] = foldChunkSplit(z, chunk, cont, f);
    return tsplus_module_3.isNonEmpty(leftovers) ? tsplus_module_5.as(nextS)(tsplus_module_4.write(leftovers)) : reader(nextS, cont, f);
  }, err => tsplus_module_6.fail(err), () => tsplus_module_2.succeed(z));
}

function foldChunkSplit(z, chunk, cont, f) {
  return foldInternal(z, chunk, cont, f, 0, chunk.length);
}

function foldInternal(z, chunk, cont, f, index, length) {
  if (index === length) {
    return [z, tsplus_module_8.empty()];
  }

  const z1 = f(z, tsplus_module_9.unsafeGet(index)(chunk));
  return cont(z1) ? foldInternal(z1, chunk, cont, f, index + 1, length) : [z1, tsplus_module_10.drop(index + 1)(chunk)];
}
//# sourceMappingURL=fold.mjs.map