import * as tsplus_module_1 from "@effect/core/stream/Sink/operations/suspend";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/readWith";
import { SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * A sink that folds its input chunks with the provided function, termination
 * predicate and initial state. The `cont` condition is checked only for the
 * initial value and at the end of processing of each chunk. `f` and `cont`
 * must preserve chunking-invariance.
 *
 * @tsplus static effect/core/stream/Sink.Ops foldChunksEffect
 */

export function foldChunksEffect(z, cont, f) {
  return tsplus_module_1.suspend(() => new SinkInternal(reader(z, cont, f)));
}

function reader(z, cont, f) {
  return cont(z) ? tsplus_module_6.readWith(chunk => tsplus_module_3.flatMap(nextS => reader(nextS, cont, f))(tsplus_module_2.fromEffect(f(z, chunk))), err => tsplus_module_4.fail(err), () => tsplus_module_5.succeed(z)) : tsplus_module_5.succeed(z);
}
//# sourceMappingURL=foldChunksEffect.mjs.map