import * as tsplus_module_1 from "@effect/core/stream/Sink/operations/suspend";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/as";
import * as tsplus_module_5 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_10 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_12 from "@tsplus/stdlib/collections/Chunk/operations/drop";
import * as tsplus_module_13 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_14 from "@effect/core/io/Effect/operations/flatMap";
import { SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * A sink that effectfully folds its inputs with the provided function,
 * termination predicate and initial state.
 *
 * @tsplus static effect/core/stream/Sink.Ops foldEffect
 */

export function foldEffect(z, cont, f) {
  return tsplus_module_1.suspend(() => new SinkInternal(reader(z, cont, f)));
}

function reader(z, cont, f) {
  if (!cont(z)) {
    return tsplus_module_2.succeed(z);
  }

  return tsplus_module_9.readWith(chunk => tsplus_module_7.flatMap(([nextS, leftovers]) => tsplus_module_5.fold(() => reader(nextS, cont, f), leftover => tsplus_module_4.as(nextS)(tsplus_module_3.write(leftover)))(leftovers))(tsplus_module_6.fromEffect(foldChunkSplitEffect(z, chunk, cont, f))), err => tsplus_module_8.fail(err), () => tsplus_module_2.succeed(z));
}

function foldChunkSplitEffect(z, chunk, cont, f) {
  return foldEffectInternal(z, chunk, cont, f, 0, chunk.length);
}

function foldEffectInternal(z, chunk, cont, f, index, length) {
  if (index === length) {
    return tsplus_module_11.succeed([z, tsplus_module_10.none]);
  }

  return tsplus_module_14.flatMap(z1 => cont(z1) ? foldEffectInternal(z1, chunk, cont, f, index + 1, length) : tsplus_module_11.succeed([z1, tsplus_module_10.some(tsplus_module_12.drop(index + 1)(chunk))]))(f(z, tsplus_module_13.unsafeGet(index)(chunk)));
}
//# sourceMappingURL=foldEffect.mjs.map