import * as tsplus_module_1 from "@effect/core/stream/Sink/operations/foldChunks";
import * as tsplus_module_2 from "@effect/core/stream/Sink/operations/dropLeftover";
import { constTrue } from "@tsplus/stdlib/data/Function";
/**
 * A sink that folds its input chunks with the provided function and initial
 * state. `f` must preserve chunking-invariance.
 *
 * @tsplus static effect/core/stream/Sink.Ops foldLeftChunks
 */

export function foldLeftChunks(z, f) {
  return tsplus_module_2.dropLeftover(tsplus_module_1.foldChunks(z, constTrue, f));
}
//# sourceMappingURL=foldLeftChunks.mjs.map