import * as tsplus_module_1 from "@tsplus/stdlib/data/AtomicReference";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/isNonEmpty";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/filter";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/writeChunk";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/sync";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/identity";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/zipRight";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/as";
import * as tsplus_module_12 from "@effect/core/stream/Channel/operations/doneCollect";
import * as tsplus_module_13 from "@effect/core/stream/Channel/operations/suspend";
import * as tsplus_module_14 from "@effect/core/stream/Channel/operations/foldChannel";
import { concreteSink, SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * @tsplus static effect/core/stream/Sink.Aspects foldSink
 * @tsplus pipeable effect/core/stream/Sink foldSink
 */

export function foldSink_(failure, success) {
  return self => {
    void 0;
    return new SinkInternal(tsplus_module_14.foldChannel(err => {
      const result = failure(err);
      void 0;
      return result.channel;
    }, ([leftovers, z]) => tsplus_module_13.suspend(() => {
      const leftoversRef = new tsplus_module_1.AtomicReference(tsplus_module_3.filter(chunk => tsplus_module_2.isNonEmpty(chunk))(leftovers));
      const refReader = tsplus_module_7.flatMap(chunk => tsplus_module_4.writeChunk(chunk))(tsplus_module_6.sync(() => leftoversRef.getAndSet(tsplus_module_5.empty())));
      const passThrough = tsplus_module_8.identity();
      const result = success(z);
      void 0;
      const continuationSink = tsplus_module_10.pipeTo(result.channel)(tsplus_module_9.zipRight(passThrough)(refReader));
      return tsplus_module_7.flatMap(([newLeftovers, z1]) => tsplus_module_9.zipRight(tsplus_module_11.as(z1)(tsplus_module_4.writeChunk(newLeftovers)))(tsplus_module_7.flatMap(chunk => tsplus_module_4.writeChunk(chunk))(tsplus_module_6.sync(() => leftoversRef.get))))(tsplus_module_12.doneCollect(continuationSink));
    }))(tsplus_module_12.doneCollect(self.channel)));
  };
}
//# sourceMappingURL=foldSink.mjs.map