import * as tsplus_module_1 from "@effect/core/stream/Sink/operations/fold";
import * as tsplus_module_2 from "@effect/core/stream/Sink/operations/map";
/**
 * Creates a sink that folds elements of type `In` into a structure of type
 * `S` until `max` elements have been folded.
 *
 * Like `foldWeighted`, but with a constant cost function of 1.
 *
 * @tsplus static effect/core/stream/Sink.Ops foldUntil
 */

export function foldUntil(z, max, f) {
  return tsplus_module_2.map(tuple => tuple[0])(tsplus_module_1.fold([z, 0], tuple => tuple[1] < max, ([o, count], i) => [f(o, i), count + 1]));
}
//# sourceMappingURL=foldUntil.mjs.map