import * as tsplus_module_1 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_2 from "@effect/core/stream/Sink/operations/foldEffect";
import * as tsplus_module_3 from "@effect/core/stream/Sink/operations/map";
/**
 * Creates a sink that effectfully folds elements of type `In` into a
 * structure of type `S` until `max` elements have been folded.
 *
 * Like `foldWeightedEffect`, but with a constant cost function of 1.
 *
 * @tsplus static effect/core/stream/Sink.Ops foldUntilEffect
 */

export function foldUntilEffect(z, max, f) {
  return tsplus_module_3.map(tuple => tuple[0])(tsplus_module_2.foldEffect([z, 0], tuple => tuple[1] < max, ([o, count], i) => tsplus_module_1.map(s => [s, count + 1])(f(o, i))));
}
//# sourceMappingURL=foldUntilEffect.mjs.map