import * as tsplus_module_1 from "@effect/core/io/Effect/operations/excl-forEach";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/readWithCause";
import { SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * A sink that executes the provided effectful function for every element fed
 * to it.
 *
 * @tsplus static effect/core/stream/Sink.Ops forEach
 */

export function forEach(f) {
  const process = tsplus_module_6.readWithCause(chunk => tsplus_module_3.flatMap(() => process)(tsplus_module_2.fromEffect(tsplus_module_1.forEachDiscard(chunk, f))), cause => tsplus_module_4.failCause(cause), () => tsplus_module_5.unit);
  return new SinkInternal(process);
}
//# sourceMappingURL=forEach.mjs.map