import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/readWithCause";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/drop";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_8 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/catchAll";
import { SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * A sink that executes the provided effectful function for every element fed
 * to it until `f` evaluates to `false`.
 *
 * @tsplus static effect/core/stream/Sink.Ops forEachWhile
 */

export function forEachWhile(f) {
  const process = tsplus_module_3.readWithCause(input => go(f, input, 0, input.length, process), cause => tsplus_module_1.failCause(cause), () => tsplus_module_2.unit);
  return new SinkInternal(process);
}

function go(f, chunk, index, length, cont) {
  return index === length ? cont : tsplus_module_10.catchAll(e => tsplus_module_7.flatMap(() => tsplus_module_4.fail(e))(tsplus_module_6.write(tsplus_module_5.drop(index)(chunk))))(tsplus_module_7.flatMap(b => b ? go(f, chunk, index + 1, length, cont) : tsplus_module_6.write(tsplus_module_5.drop(index)(chunk)))(tsplus_module_9.fromEffect(f(tsplus_module_8.unsafeGet(index)(chunk)))));
}
//# sourceMappingURL=forEachWhile.mjs.map