import * as tsplus_module_1 from "@effect/core/stream/Sink/operations/fromQueue";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_5 from "@effect/core/stream/Sink/operations/unwrapScoped";
/**
 * Create a sink which enqueues each element into the specified queue. The
 * queue will be shutdown once the stream is closed.
 *
 * @tsplus static effect/core/stream/Sink.Ops fromQueueWithShutdown
 */

export function fromQueueWithShutdown(queue) {
  return tsplus_module_5.unwrapScoped(tsplus_module_4.map(q => tsplus_module_1.fromQueue(q))(tsplus_module_3.acquireRelease(tsplus_module_2.succeed(queue), q => q.shutdown)));
}
//# sourceMappingURL=fromQueueWithShutdown.mjs.map