import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/orElse";
import { concreteSink, SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * Returns a new sink that will perform the operations of this one, until
 * failure, and then it will switch over to the operations of the specified
 * fallback sink.
 *
 * @tsplus pipeable-operator effect/core/stream/Sink |
 * @tsplus static effect/core/stream/Sink.Aspects orElse
 * @tsplus pipeable effect/core/stream/Sink orElse
 */

export function orElse(that) {
  return self => {
    void 0;
    return new SinkInternal(tsplus_module_1.orElse(() => {
      const that0 = that();
      void 0;
      return that0.channel;
    })(self.channel));
  };
}
//# sourceMappingURL=orElse.mjs.map