import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/done";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_4 from "@effect/core/stream/Channel/MergeDecision";
import * as tsplus_module_5 from "@effect/core/stream/Sink/operations/raceWith";
/**
 * Runs both sinks in parallel on the input, returning the result or the error
 * from the one that finishes first.
 *
 * @tsplus static effect/core/stream/Sink.Aspects raceBoth
 * @tsplus pipeable effect/core/stream/Sink raceBoth
 */

export function raceBoth(that, capacity = 16) {
  return self => tsplus_module_5.raceWith(that, selfDone => tsplus_module_4.done(tsplus_module_3.map(tsplus_module_1.left)(tsplus_module_2.done(selfDone))), thatDone => tsplus_module_4.done(tsplus_module_3.map(tsplus_module_1.right)(tsplus_module_2.done(thatDone))), capacity)(self);
}
//# sourceMappingURL=raceBoth.mjs.map