import * as tsplus_module_1 from "@effect/core/io/Effect/operations/done";
import * as tsplus_module_2 from "@effect/core/stream/Channel/MergeDecision";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/mergeWith";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/toHub";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/fromHubScoped";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_9 from "@effect/core/io/Hub/operations/bounded";
import * as tsplus_module_10 from "@effect/core/stream/Sink/operations/unwrapScoped";
import { concreteSink, SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * Runs both sinks in parallel on the input, using the specified merge
 * function as soon as one result or the other has been computed.
 *
 * @tsplus static effect/core/stream/Sink.Aspects raceWith
 * @tsplus pipeable effect/core/stream/Sink raceWith
 */

export function raceWith(that, leftDone, rightDone, capacity = 16) {
  return self => tsplus_module_10.unwrapScoped(tsplus_module_8.flatMap(hub => tsplus_module_8.flatMap(c1 => tsplus_module_7.map(c2 => {
    const reader = tsplus_module_5.toHub(hub);
    void 0;
    void 0;
    const writer = tsplus_module_3.mergeWith_(tsplus_module_4.pipeTo(that.channel)(c2), leftDone, rightDone)(tsplus_module_4.pipeTo(self.channel)(c1));
    const channel = tsplus_module_3.mergeWith_(writer, () => tsplus_module_2._await(exit => tsplus_module_1.done(exit)), done => tsplus_module_2.done(tsplus_module_1.done(done)))(reader);
    return new SinkInternal(channel);
  })(tsplus_module_6.fromHubScoped(hub)))(tsplus_module_6.fromHubScoped(hub)))(tsplus_module_9.bounded(capacity)));
}
//# sourceMappingURL=raceWith.mjs.map