import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/flatten";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/concat";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/pipeToOrFail";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/doneCollect";
import * as tsplus_module_9 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_10 from "@effect/core/io/Ref/operations/make";
import * as tsplus_module_11 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_12 from "@tsplus/stdlib/collections/Chunk/operations/indexWhere";
import * as tsplus_module_13 from "@tsplus/stdlib/collections/Chunk/operations/splitAt";
import * as tsplus_module_14 from "@tsplus/stdlib/collections/Chunk/operations/indexWhereFrom";
import * as tsplus_module_15 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_16 from "@effect/core/stream/Channel/operations/readWithCause";
import { concreteSink, SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * Splits the sink on the specified predicate, returning a new sink that
 * consumes elements until an element after the first satisfies the specified
 * predicate.
 *
 * @tsplus static effect/core/stream/Sink.Aspects splitWhere
 * @tsplus pipeable effect/core/stream/Sink splitWhere
 */

export function splitWhere(f) {
  return self => {
    void 0;
    return new SinkInternal(tsplus_module_5.flatMap(ref => tsplus_module_5.flatMap(([leftovers, z]) => tsplus_module_5.flatMap(leftover => tsplus_module_5.flatMap(() => tsplus_module_1.succeed(z))(tsplus_module_4.write(tsplus_module_3.concat(tsplus_module_2.flatten(leftovers))(leftover))))(tsplus_module_6.fromEffect(ref.get)))(tsplus_module_8.doneCollect(tsplus_module_7.pipeToOrFail(self.channel)(splitter(false, ref, f)))))(tsplus_module_6.fromEffect(tsplus_module_10.makeRef(() => tsplus_module_9.empty()))));
  };
}

function splitter(written, leftovers, f) {
  return tsplus_module_16.readWithCause(input => {
    if (tsplus_module_11.isEmpty(input)) {
      return splitter(written, leftovers, f);
    }

    if (written) {
      const index = tsplus_module_12.indexWhere(f)(input);

      if (index === -1) {
        return tsplus_module_5.flatMap(() => splitter(true, leftovers, f))(tsplus_module_4.write(input));
      }

      const [left, right] = tsplus_module_13.splitAt(index)(input);
      return tsplus_module_5.flatMap(() => tsplus_module_6.fromEffect(leftovers.set(right)))(tsplus_module_4.write(left));
    }

    const index = tsplus_module_14.indexWhereFrom(1, f)(input);

    if (index === -1) {
      return tsplus_module_5.flatMap(() => splitter(true, leftovers, f))(tsplus_module_4.write(input));
    }

    const [left, right] = tsplus_module_13.splitAt(Math.max(index, 1))(input);
    return tsplus_module_5.flatMap(() => tsplus_module_6.fromEffect(leftovers.set(right)))(tsplus_module_4.write(left));
  }, cause => tsplus_module_15.failCause(cause), done => tsplus_module_1.succeed(done));
}
//# sourceMappingURL=splitWhere.mjs.map