import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/map";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/flatMap";
import { concreteSink, SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * Summarize a sink by running an effect when the sink starts and again when
 * it completes
 *
 * @tsplus static effect/core/stream/Sink.Aspects summarized
 * @tsplus pipeable effect/core/stream/Sink summarized
 */

export function summarized(summary, f) {
  return self => new SinkInternal(tsplus_module_3.flatMap(start => {
    void 0;
    return tsplus_module_3.flatMap(done => tsplus_module_2.map(end => [done, f(start, end)])(tsplus_module_1.fromEffect(summary)))(self.channel);
  })(tsplus_module_1.fromEffect(summary)));
}
//# sourceMappingURL=summarized.mjs.map