import * as tsplus_module_1 from "@effect/core/io/Clock/operations/currentTime";
import * as tsplus_module_2 from "@effect/core/stream/Sink/operations/summarized";
import * as tsplus_module_3 from "@effect/core/stream/Sink/operations/drain";
import * as tsplus_module_4 from "@effect/core/stream/Sink/operations/map";
export const withDuration = withDuration_1;
import { DurationInternal } from "@tsplus/stdlib/data/Duration";
/**
 * Returns the sink that executes this one and times its execution in
 * milliseconds.
 *
 * @tsplus getter effect/core/stream/Sink timed
 */

function withDuration_1(self) {
  return tsplus_module_2.summarized(tsplus_module_1.currentTime, (start, end) => new DurationInternal(end - start))(self);
}
/**
 * Times the execution of a sink in milliseconds.
 *
 * @tsplus static effect/core/stream/Sink.Aspects timed
 */


export function timed() {
  return tsplus_module_4.map(tuple => tuple[1])(withDuration_1(tsplus_module_3.drain()));
}
//# sourceMappingURL=timed.mjs.map