import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/as";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_7 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_8 from "@tsplus/stdlib/collections/Chunk/operations/flatten";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/doneCollect";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/foldChannel";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/bufferChunk";
import * as tsplus_module_12 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_13 from "@effect/core/io/Ref/operations/make";
import * as tsplus_module_14 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_15 from "@effect/core/io/Effect/operations/zip";
import { concreteSink, SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
/**
 * Creates a sink that produces values until one verifies the predicate `f`.
 *
 * @tsplus static effect/core/stream/Sink.Aspects untilOutputEffect
 * @tsplus pipeable effect/core/stream/Sink untilOutputEffect
 */

export function untilOutputEffect(f) {
  return self => {
    void 0;
    return new SinkInternal(tsplus_module_2.flatMap(([leftoversRef, upstreamDoneRef]) => {
      const upstreamMarker = tsplus_module_6.readWith(chunk => tsplus_module_2.flatMap(() => upstreamMarker)(tsplus_module_1.write(chunk)), err => tsplus_module_3.fail(err), done => tsplus_module_5.as(done)(tsplus_module_4.fromEffect(upstreamDoneRef.set(true))));
      const loop = tsplus_module_10.foldChannel(err => tsplus_module_3.fail(err), ([leftovers, doneValue]) => tsplus_module_2.flatMap(satisfied => tsplus_module_2.flatMap(() => tsplus_module_2.flatMap(upstreamDone => satisfied ? tsplus_module_5.as(tsplus_module_7.some(doneValue))(tsplus_module_1.write(tsplus_module_8.flatten(leftovers))) : upstreamDone ? tsplus_module_5.as(tsplus_module_7.none)(tsplus_module_1.write(tsplus_module_8.flatten(leftovers))) : loop)(tsplus_module_4.fromEffect(upstreamDoneRef.get)))(tsplus_module_4.fromEffect(leftoversRef.set(tsplus_module_8.flatten(leftovers)))))(tsplus_module_4.fromEffect(f(doneValue))))(tsplus_module_9.doneCollect(self.channel));
      return tsplus_module_12.pipeTo(loop)(tsplus_module_12.pipeTo(tsplus_module_11.bufferChunk(leftoversRef))(upstreamMarker));
    })(tsplus_module_4.fromEffect(tsplus_module_15.zip(tsplus_module_13.makeRef(() => false))(tsplus_module_13.makeRef(() => tsplus_module_14.empty())))));
  };
}
//# sourceMappingURL=untilOutputEffect.mjs.map