import * as tsplus_module_1 from "@effect/core/stream/Sink/operations/map";
import * as tsplus_module_2 from "@effect/core/stream/Sink/operations/flatMap";
/**
 * Feeds inputs to this sink until it yields a result, then switches over to
 * the provided sink until it yields a result, finally combining the two
 * results with `f`.
 *
 * @tsplus static effect/core/stream/Sink.Aspects zipWith
 * @tsplus pipeable effect/core/stream/Sink zipWith
 */

export function zipWith(that, f) {
  return self => tsplus_module_2.flatMap(z => tsplus_module_1.map(z1 => f(z, z1))(that))(self);
}
//# sourceMappingURL=zipWith.mjs.map