import * as tsplus_module_1 from "@effect/core/stream/SortedByKey/operations/zipAllSortedByKeyWith";
/**
 * Zips this stream that is sorted by distinct keys and the specified stream
 * that is sorted by distinct keys to produce a new stream that is sorted by
 * distinct keys. Combines values associated with each key into a tuple,
 * using the specified values `defaultLeft` and `defaultRight` to fill in
 * missing values.
 *
 * This allows zipping potentially unbounded streams of data by key in
 * constant space but the caller is responsible for ensuring that the
 * streams are sorted by distinct keys.
 *
 * @tsplus static effect/core/stream/SortedByKey.Aspects zipAllSortedByKey
 * @tsplus pipeable effect/core/stream/SortedByKey zipAllSortedByKey
 * @tsplus static effect/core/stream/Stream.Aspects zipAllSortedByKey
 * @tsplus pipeable effect/core/stream/Stream zipAllSortedByKey
 */

export function zipAllSortedByKey(ord, that, defaultLeft, defaultRight) {
  return self => tsplus_module_1.zipAllSortedByKeyWith(ord, that, a => [a, defaultRight], b => [defaultLeft, b], (a, b) => [a, b])(self);
}
//# sourceMappingURL=zipAllSortedByKey.mjs.map