import * as tsplus_module_1 from "@tsplus/stdlib/data/Function";
import * as tsplus_module_2 from "@effect/core/stream/SortedByKey/operations/zipAllSortedByKeyWith";
/**
 * Zips this stream that is sorted by distinct keys and the specified stream
 * that is sorted by distinct keys to produce a new stream that is sorted by
 * distinct keys. Keeps only values from this stream, using the specified
 * value `default` to fill in missing values.
 *
 * This allows zipping potentially unbounded streams of data by key in
 * constant space but the caller is responsible for ensuring that the
 * streams are sorted by distinct keys.
 *
 * @tsplus static effect/core/stream/SortedByKey.Aspects zipAllSortedByKeyLeft
 * @tsplus pipeable effect/core/stream/SortedByKey zipAllSortedByKeyLeft
 * @tsplus static effect/core/stream/Stream.Aspects zipAllSortedByKeyLeft
 * @tsplus pipeable effect/core/stream/Stream zipAllSortedByKeyLeft
 */

export function zipAllSortedByKeyLeft(ord, that, def) {
  return self => tsplus_module_2.zipAllSortedByKeyWith(ord, that, tsplus_module_1.identity, () => def, (a, _) => a)(self);
}
//# sourceMappingURL=zipAllSortedByKeyLeft.mjs.map