import * as tsplus_module_1 from "@tsplus/stdlib/data/Function";
import * as tsplus_module_2 from "@effect/core/stream/SortedByKey/operations/zipAllSortedByKeyWith";
/**
 * Zips this stream that is sorted by distinct keys and the specified stream
 * that is sorted by distinct keys to produce a new stream that is sorted by
 * distinct keys. Keeps only values from that stream, using the specified
 * value `default` to fill in missing values.
 *
 * This allows zipping potentially unbounded streams of data by key in
 * constant space but the caller is responsible for ensuring that the
 * streams are sorted by distinct keys.
 *
 * @tsplus static effect/core/stream/SortedByKey.Aspects zipAllSortedByKeyRight
 * @tsplus pipeable effect/core/stream/SortedByKey zipAllSortedByKeyRight
 * @tsplus static effect/core/stream/Stream.Aspects zipAllSortedByKeyRight
 * @tsplus pipeable effect/core/stream/Stream zipAllSortedByKeyRight
 */

export function zipAllSortedByKeyRight(ord, that, def) {
  return self => tsplus_module_2.zipAllSortedByKeyWith(ord, that, () => def, tsplus_module_1.identity, (_, b) => b)(self);
}
//# sourceMappingURL=zipAllSortedByKeyRight.mjs.map