import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/dieSync";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/dieMessage";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_6 from "@effect/core/io/Exit/operations/mapBoth";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/done";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/mapBoth";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/mapError";
import * as tsplus_module_11 from "@effect/core/io/Cause/operations/map";
import * as tsplus_module_12 from "@effect/core/io/Effect/operations/failCauseSync";
export const Emit = {};
/**
 * @tsplus static effect/core/stream/Stream/Emit.Ops __call
 */

export function apply(fn) {
  const ops = {
    chunk(as) {
      return this(tsplus_module_1.succeed(as));
    },

    die(err) {
      return this(tsplus_module_2.dieSync(() => err));
    },

    dieMessage(message) {
      return this(tsplus_module_3.dieMessage(message));
    },

    done(exit) {
      return this(tsplus_module_7.done(tsplus_module_6.mapBoth(e => tsplus_module_4.some(e), a => tsplus_module_5.single(a))(exit)));
    },

    end() {
      return this(tsplus_module_8.fail(tsplus_module_4.none));
    },

    fail(e) {
      return this(tsplus_module_8.fail(tsplus_module_4.some(e)));
    },

    fromEffect(io) {
      return this(tsplus_module_9.mapBoth(e => tsplus_module_4.some(e), a => tsplus_module_5.single(a))(io));
    },

    fromEffectChunk(io) {
      return this(tsplus_module_10.mapError(e => tsplus_module_4.some(e))(io));
    },

    halt(cause) {
      return this(tsplus_module_12.failCauseSync(() => tsplus_module_11.map(e => tsplus_module_4.some(e))(cause)));
    },

    single(a) {
      return this(tsplus_module_1.succeed(tsplus_module_5.single(a)));
    }

  };
  return Object.assign(fn, ops);
}
//# sourceMappingURL=Emit.mjs.map