import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/suspend";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_10 from "@tsplus/stdlib/collections/Chunk/operations/concat";
import * as tsplus_module_11 from "@tsplus/stdlib/collections/Chunk/operations/splitAt";
import * as tsplus_module_12 from "@tsplus/stdlib/collections/Chunk/operations/materialize";
import * as tsplus_module_13 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_14 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_15 from "@tsplus/stdlib/collections/List/from";
import * as tsplus_module_16 from "@tsplus/stdlib/collections/List/find";
import * as tsplus_module_17 from "@tsplus/stdlib/data/Maybe/definition";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
const emptyByteChunk = /*#__PURE__*/tsplus_module_1.empty();
const emptyStringChunk = /*#__PURE__*/tsplus_module_1.empty();
export function utf8DecodeNoBom(stream) {
  void 0;
  return new StreamInternal(tsplus_module_3.suspend(() => tsplus_module_2.pipeTo(readThenTransduce(emptyByteChunk))(stream.channel)));
}

function readThenTransduce(buffer) {
  return tsplus_module_9.readWith(received => {
    const [string, buffered] = process(buffer, received);
    return tsplus_module_5.flatMap(() => readThenTransduce(buffered))(tsplus_module_4.write(string));
  }, err => tsplus_module_6.fail(err), () => tsplus_module_7.isEmpty(buffer) ? tsplus_module_8.unit : tsplus_module_4.write(stringChunkFrom(buffer)));
}

function process(buffered, received) {
  const bytes = tsplus_module_10.concat(received)(buffered);
  const [chunk, rest] = tsplus_module_11.splitAt(computeSplitIndex(bytes))(bytes);

  if (tsplus_module_7.isEmpty(chunk)) {
    return [emptyStringChunk, tsplus_module_12.materialize(rest)];
  }

  if (tsplus_module_7.isEmpty(rest)) {
    return [stringChunkFrom(chunk), emptyByteChunk];
  }

  return [stringChunkFrom(chunk), rest];
}

function stringChunkFrom(bytes) {
  return tsplus_module_13.single(String.fromCharCode(...bytes));
}

function computeSplitIndex(chunk) {
  // There are 3 bad patterns we need to check to detect an incomplete chunk:
  // - 2/3/4 byte sequences that start on the last byte
  // - 3/4 byte sequences that start on the second-to-last byte
  // - 4 byte sequences that start on the third-to-last byte
  //
  // Otherwise, we can convert the entire concatenated chunk to a string.
  const size = chunk.length;

  if (size >= 1 && tsplus_module_17.isSome(tsplus_module_16.find(f => f(tsplus_module_14.unsafeGet(size - 1)(chunk)))(tsplus_module_15.make(is2ByteStart, is3ByteStart, is4ByteStart)))) {
    return size - 1;
  }

  if (size >= 2 && tsplus_module_17.isSome(tsplus_module_16.find(f => f(tsplus_module_14.unsafeGet(size - 2)(chunk)))(tsplus_module_15.make(is3ByteStart, is4ByteStart)))) {
    return size - 2;
  }

  if (size >= 3 && is4ByteStart(tsplus_module_14.unsafeGet(size - 3)(chunk))) {
    return size - 3;
  }

  return size;
}

function is2ByteStart(byte) {
  return (byte & 0xe0) === 0xc0;
}

function is3ByteStart(byte) {
  return (byte & 0xf0) === 0xe0;
}

function is4ByteStart(byte) {
  return (byte & 0xf8) === 0xf0;
}
//# sourceMappingURL=utf8DecodeNoBom.mjs.map