import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/suspend";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/fromChunk";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_9 from "@tsplus/stdlib/collections/Chunk/operations/concat";
import * as tsplus_module_10 from "@tsplus/stdlib/collections/Chunk/operations/splitAt";
import * as tsplus_module_11 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
export function utfDecodeDetectingBom(bomSize, processBom) {
  return stream => {
    void 0;
    return new StreamInternal(tsplus_module_3.suspend(() => tsplus_module_2.pipeTo(lookingForBom(tsplus_module_1.empty(), bomSize, processBom))(stream.channel)));
  };
}

function passThrough(decodingPipeline) {
  return tsplus_module_8.readWith(received => {
    const stream = decodingPipeline(tsplus_module_4.fromChunk(received));
    void 0;
    return tsplus_module_5.flatMap(() => passThrough(decodingPipeline))(stream.channel);
  }, err => tsplus_module_6.fail(err), () => tsplus_module_7.unit);
}

function lookingForBom(buffer, bomSize, processBom) {
  return tsplus_module_8.readWith(received => {
    const data = tsplus_module_9.concat(received)(buffer);

    if (data.length >= bomSize) {
      const [bom, rest] = tsplus_module_10.splitAt(bomSize)(data);
      const [dataWithoutBom, decodingPipeline] = processBom(bom);
      const stream = decodingPipeline(tsplus_module_4.fromChunk(tsplus_module_9.concat(rest)(dataWithoutBom)));
      void 0;
      return tsplus_module_5.flatMap(() => passThrough(decodingPipeline))(stream.channel);
    }

    return lookingForBom(data, bomSize, processBom);
  }, err => tsplus_module_6.fail(err), () => {
    if (tsplus_module_11.isEmpty(buffer)) {
      return tsplus_module_7.unit;
    }

    const [dataWithoutBom, decodingPipeline] = processBom(buffer);
    const stream = decodingPipeline(tsplus_module_4.fromChunk(dataWithoutBom));
    void 0;
    return tsplus_module_5.flatMap(() => passThrough(decodingPipeline))(stream.channel);
  });
}
//# sourceMappingURL=utfDecodeDetectingBom.mjs.map