import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/suspend";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_10 from "@tsplus/stdlib/collections/Chunk/operations/concat";
import * as tsplus_module_11 from "@tsplus/stdlib/collections/Chunk/operations/splitAt";
import * as tsplus_module_12 from "@tsplus/stdlib/collections/Chunk/operations/materialize";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
import { stringChunkFrom } from "@effect/core/stream/Stream/operations/_internal/stringChunkFrom";
const emptyByteChunk = /*#__PURE__*/tsplus_module_1.empty();
const emptyStringChunk = /*#__PURE__*/tsplus_module_1.empty();
export function utfDecodeFixedLength(charset, fixedLength) {
  return stream => {
    void 0;
    return new StreamInternal(tsplus_module_3.suspend(() => tsplus_module_2.pipeTo(readThenTransduce(emptyByteChunk, charset, fixedLength))(stream.channel)));
  };
}

function readThenTransduce(buffer, charset, fixedLength) {
  return tsplus_module_9.readWith(received => {
    const [string, buffered] = process(buffer, received, charset, fixedLength);
    return tsplus_module_5.flatMap(() => readThenTransduce(buffered, charset, fixedLength))(tsplus_module_4.write(string));
  }, err => tsplus_module_6.fail(err), () => tsplus_module_7.isEmpty(buffer) ? tsplus_module_8.unit : tsplus_module_4.write(stringChunkFrom(buffer, charset)));
}

function process(buffered, received, charset, fixedLength) {
  const bytes = tsplus_module_10.concat(received)(buffered);
  const remainder = bytes.length % fixedLength;

  if (remainder === 0) {
    return [stringChunkFrom(bytes, charset), emptyByteChunk];
  }

  if (bytes.length > fixedLength) {
    const [fullChunk, rest] = tsplus_module_11.splitAt(bytes.length - remainder)(bytes);
    return [stringChunkFrom(fullChunk, charset), rest];
  }

  return [emptyStringChunk, tsplus_module_12.materialize(bytes)];
}
//# sourceMappingURL=utfDecodeFixedLength.mjs.map