import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/_internal/HandoffSignal";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/_internal/Handoff";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_5 from "@effect/core/stream/Stream/SinkEndReason";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/readWithCause";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/Chunk/operations/isNonEmpty";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/zipRight";
import * as tsplus_module_12 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_13 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_14 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_15 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_16 from "@effect/core/stream/Channel/operations/unwrap";
import * as tsplus_module_17 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_18 from "@effect/core/io/Effect/operations/forkScoped";
import * as tsplus_module_19 from "@effect/core/stream/Channel/operations/pipeToOrFail";
import * as tsplus_module_20 from "@effect/core/stream/Channel/operations/doneCollect";
import * as tsplus_module_21 from "@effect/core/stream/Channel/operations/runScoped";
import * as tsplus_module_22 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_23 from "@effect/core/stream/Stream/operations/unwrapScoped";
import * as tsplus_module_24 from "@effect/core/io/Ref/operations/make";
import * as tsplus_module_25 from "@effect/core/io/Schedule/operations/driver";
import * as tsplus_module_26 from "@effect/core/io/Effect/operations/tuple";
import * as tsplus_module_27 from "@effect/core/stream/Stream/operations/fromEffect";
import * as tsplus_module_28 from "@effect/core/stream/Stream/operations/flatMap";
import * as tsplus_module_29 from "@tsplus/stdlib/collections/Chunk/operations/flatten";
import * as tsplus_module_30 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_31 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_32 from "@tsplus/stdlib/collections/Chunk/operations/make";
import * as tsplus_module_33 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_34 from "@effect/core/stream/Channel/operations/unwrapScoped";
import * as tsplus_module_35 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_36 from "@effect/core/io/Fiber/operations/join";
import * as tsplus_module_37 from "@effect/core/io/Fiber/operations/interrupt";
import * as tsplus_module_38 from "@effect/core/io/Effect/operations/done";
import * as tsplus_module_39 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_40 from "@effect/core/io/Cause/operations/failureOrCause";
import * as tsplus_module_41 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_42 from "@effect/core/io/Effect/operations/foldCauseEffect";
import * as tsplus_module_43 from "@effect/core/io/Effect/operations/raceWith";
import { concreteSink } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Aggregates elements using the provided sink until it completes, or until
 * the delay signalled by the schedule has passed.
 *
 * This operator divides the stream into two asynchronous islands. Operators
 * upstream of this operator run on one fiber, while downstream operators run
 * on another. Elements will be aggregated by the sink until the downstream
 * fiber pulls the aggregated value, or until the schedule's delay has passed.
 *
 * Aggregated elements will be fed into the schedule to determine the delays
 * between pulls.
 *
 * @param sink Used for the aggregation
 * @param schedule Used for signalling for when to stop the aggregation
 *
 * @tsplus static effect/core/stream/Stream.Aspects aggregateWithinEither
 * @tsplus pipeable effect/core/stream/Stream aggregateWithinEither
 */

export function aggregateWithinEither(sink, schedule) {
  return self => {
    return tsplus_module_28.flatMap(([handoff, sinkEndReason, sinkLeftovers, scheduleDriver, consumed]) => {
      const handoffProducer = tsplus_module_6.readWithCause(input => tsplus_module_4.flatMap(() => handoffProducer)(tsplus_module_3.fromEffect(tsplus_module_2.offer(tsplus_module_1.emit(input))(handoff))), cause => tsplus_module_3.fromEffect(tsplus_module_2.offer(tsplus_module_1.halt(cause))(handoff)), () => tsplus_module_3.fromEffect(tsplus_module_2.offer(tsplus_module_1.end(tsplus_module_5.upstreamEnd))(handoff)));
      const handoffConsumer = tsplus_module_16.unwrap(tsplus_module_15.flatMap(leftovers => tsplus_module_7.isNonEmpty(leftovers) ? tsplus_module_10.zipRight(tsplus_module_9.sync(() => tsplus_module_4.flatMap(() => handoffConsumer)(tsplus_module_8.write(leftovers))))(consumed.set(true)) : tsplus_module_13.map(signal => {
        switch (signal._tag) {
          case "Emit":
            {
              return tsplus_module_4.flatMap(() => handoffConsumer)(tsplus_module_11.zipRight(tsplus_module_8.write(signal.elements))(tsplus_module_3.fromEffect(consumed.set(true))));
            }

          case "Halt":
            {
              return tsplus_module_12.failCause(signal.error);
            }

          case "End":
            {
              return signal.reason._tag === "ScheduleEnd" ? tsplus_module_13.map(p => p ? tsplus_module_3.fromEffect(sinkEndReason.set(tsplus_module_5.scheduleEnd)) : tsplus_module_4.flatMap(() => handoffConsumer)(tsplus_module_3.fromEffect(sinkEndReason.set(tsplus_module_5.scheduleEnd))))(consumed.get) : tsplus_module_3.fromEffect(sinkEndReason.set(signal.reason));
            }
        }
      })(tsplus_module_2.take(handoff)))(sinkLeftovers.getAndSet(tsplus_module_14.empty())));
      void 0;
      void 0;
      const stream = tsplus_module_15.flatMap(() => tsplus_module_15.flatMap(sinkFiber => tsplus_module_13.map(scheduleFiber => new StreamInternal(scheduledAggregator(sink, handoff, sinkEndReason, sinkLeftovers, scheduleDriver, consumed, handoffProducer, handoffConsumer, sinkFiber, scheduleFiber)))(tsplus_module_18.forkScoped(timeout(scheduleDriver, tsplus_module_17.none))))(tsplus_module_18.forkScoped(tsplus_module_21.runScoped(tsplus_module_20.doneCollect(tsplus_module_19.pipeToOrFail(sink.channel)(handoffConsumer))))))(tsplus_module_18.forkScoped(tsplus_module_21.runScoped(tsplus_module_22.pipeTo(handoffProducer)(self.channel))));
      return tsplus_module_23.unwrapScoped(stream);
    })(tsplus_module_27.fromEffect(tsplus_module_26.tuple(tsplus_module_2.make(), tsplus_module_24.makeRef(() => tsplus_module_5.scheduleEnd), tsplus_module_24.makeRef(() => tsplus_module_14.empty()), tsplus_module_25.driver(schedule), tsplus_module_24.makeRef(() => false))));
  };
}

function timeout(scheduleDriver, last) {
  return scheduleDriver.next(last);
}

function handleSide(sink, handoff, sinkEndReason, sinkLeftovers, scheduleDriver, consumed, handoffProducer, handoffConsumer, forkSink, leftovers, b, c) {
  return tsplus_module_16.unwrap(tsplus_module_10.zipRight(tsplus_module_13.map(reason => {
    switch (reason._tag) {
      case "ScheduleEnd":
        {
          return tsplus_module_34.unwrapScoped(tsplus_module_15.flatMap(isConsumed => tsplus_module_15.flatMap(sinkFiber => tsplus_module_13.map(scheduleFiber => {
            const toWrite = tsplus_module_33.fold(() => tsplus_module_31.single(tsplus_module_30.right(b)), c => tsplus_module_32.make(tsplus_module_30.right(b), tsplus_module_30.left(c)))(c);
            return isConsumed ? tsplus_module_4.flatMap(() => scheduledAggregator(sink, handoff, sinkEndReason, sinkLeftovers, scheduleDriver, consumed, handoffProducer, handoffConsumer, sinkFiber, scheduleFiber))(tsplus_module_8.write(toWrite)) : scheduledAggregator(sink, handoff, sinkEndReason, sinkLeftovers, scheduleDriver, consumed, handoffProducer, handoffConsumer, sinkFiber, scheduleFiber);
          })(tsplus_module_18.forkScoped(timeout(scheduleDriver, tsplus_module_17.some(b)))))(forkSink))(consumed.get));
        }

      case "UpstreamEnd":
        {
          return tsplus_module_16.unwrap(tsplus_module_13.map(p => p ? tsplus_module_8.write(tsplus_module_31.single(tsplus_module_30.right(b))) : tsplus_module_35.unit)(consumed.get));
        }
    }
  })(sinkEndReason.get))(sinkLeftovers.set(tsplus_module_29.flatten(leftovers))));
}

function scheduledAggregator(sink, handoff, sinkEndReason, sinkLeftovers, scheduleDriver, consumed, handoffProducer, handoffConsumer, sinkFiber, scheduleFiber) {
  void 0;
  const forkSink = tsplus_module_10.zipRight(tsplus_module_18.forkScoped(tsplus_module_21.runScoped(tsplus_module_20.doneCollect(tsplus_module_19.pipeToOrFail(sink.channel)(handoffConsumer)))))(consumed.set(false));
  return tsplus_module_16.unwrap(tsplus_module_43.raceWith(tsplus_module_36.join(scheduleFiber), (sinkExit, scheduleFiber) => tsplus_module_10.zipRight(tsplus_module_13.map(([leftovers, b]) => handleSide(sink, handoff, sinkEndReason, sinkLeftovers, scheduleDriver, consumed, handoffProducer, handoffConsumer, forkSink, leftovers, b, tsplus_module_17.none))(tsplus_module_38.done(sinkExit)))(tsplus_module_37.interrupt(scheduleFiber)), (scheduleExit, sinkFiber) => tsplus_module_42.foldCauseEffect(cause => tsplus_module_41.fold(() => tsplus_module_10.zipRight(tsplus_module_13.map(([leftovers, b]) => handleSide(sink, handoff, sinkEndReason, sinkLeftovers, scheduleDriver, consumed, handoffProducer, handoffConsumer, forkSink, leftovers, b, tsplus_module_17.none))(tsplus_module_36.join(sinkFiber)))(tsplus_module_39.forkDaemon(tsplus_module_2.offer(tsplus_module_1.end(tsplus_module_5.scheduleEnd))(handoff))), cause => tsplus_module_10.zipRight(tsplus_module_13.map(([leftovers, b]) => handleSide(sink, handoff, sinkEndReason, sinkLeftovers, scheduleDriver, consumed, handoffProducer, handoffConsumer, forkSink, leftovers, b, tsplus_module_17.none))(tsplus_module_36.join(sinkFiber)))(tsplus_module_39.forkDaemon(tsplus_module_2.offer(tsplus_module_1.halt(cause))(handoff))))(tsplus_module_40.failureOrCause(cause)), c => tsplus_module_10.zipRight(tsplus_module_13.map(([leftovers, b]) => handleSide(sink, handoff, sinkEndReason, sinkLeftovers, scheduleDriver, consumed, handoffProducer, handoffConsumer, forkSink, leftovers, b, tsplus_module_17.some(c)))(tsplus_module_36.join(sinkFiber)))(tsplus_module_39.forkDaemon(tsplus_module_2.offer(tsplus_module_1.end(tsplus_module_5.scheduleEnd))(handoff))))(tsplus_module_38.done(scheduleExit)))(tsplus_module_36.join(sinkFiber)));
}
//# sourceMappingURL=aggregateWithinEither.mjs.map