import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/asyncMaybe";
export const _async = _async_1;
/**
 * Creates a stream from an asynchronous callback that can be called multiple
 * times. The optionality of the error type `E` can be used to signal the end
 * of the stream, by setting it to `None`.
 *
 * @tsplus static effect/core/stream/Stream.Ops async
 */

function _async_1(register, outputBuffer = 16) {
  return tsplus_module_2.asyncMaybe(callback => {
    register(callback);
    return tsplus_module_1.none;
  }, outputBuffer);
}

export { _async_1 as async };
//# sourceMappingURL=async.mjs.map