import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_7 from "@effect/core/stream/Take/operations/done";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/fold";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/unwrap";
import * as tsplus_module_11 from "@effect/core/stream/Take/operations/fromPull";
import * as tsplus_module_12 from "@effect/core/io/Cause/operations/isInterrupted";
import * as tsplus_module_13 from "@effect/core/stream/Stream/Emit";
import * as tsplus_module_14 from "@effect/core/io/Effect/operations/runtime";
import * as tsplus_module_15 from "@effect/core/io/Queue/external/bounded";
import * as tsplus_module_16 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_17 from "@effect/core/io/Effect/operations/do";
import * as tsplus_module_18 from "@effect/core/io/Effect/operations/tap";
import * as tsplus_module_19 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_20 from "@effect/core/stream/Channel/operations/unwrapScoped";
import { isFiberFailure } from "@effect/core/io/Cause/errors";
import { Emit } from "@effect/core/stream/Stream/Emit";
import { StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Creates a stream from an asynchronous callback that can be called multiple
 * times The registration of the callback itself returns an effect. The
 * optionality of the error type `E` can be used to signal the end of the
 * stream, by setting it to `None`.
 *
 * @tsplus static effect/core/stream/Stream.Ops asyncEffect
 */

export function asyncEffect(register, outputBuffer = 16) {
  return new StreamInternal(tsplus_module_20.unwrapScoped(tsplus_module_19.map(({
    output
  }) => {
    const loop = tsplus_module_10.unwrap(tsplus_module_9.fold(maybeError => tsplus_module_5.flatMap(() => tsplus_module_3.fold(() => tsplus_module_1.unit, e => tsplus_module_2.fail(e))(maybeError))(tsplus_module_4.fromEffect(output.shutdown)), a => tsplus_module_5.flatMap(() => loop)(tsplus_module_6.write(a)))(tsplus_module_8.flatMap(take => tsplus_module_7.done(take))(output.take)));
    return loop;
  })(tsplus_module_18.tap(({
    output,
    runtime
  }) => register(tsplus_module_13.apply(async k => {
    try {
      runtime.unsafeRunPromise(tsplus_module_8.flatMap(take => output.offer(take))(tsplus_module_11.fromPull(k)));
    } catch (e) {
      if (isFiberFailure(e)) {
        if (!tsplus_module_12.isInterrupted(e.cause)) {
          throw e;
        }
      }
    }
  })))(tsplus_module_17.bind("runtime", () => tsplus_module_14.runtime())(tsplus_module_17.bind("output", () => tsplus_module_16.acquireRelease(tsplus_module_15.bounded(outputBuffer), queue => queue.shutdown))(tsplus_module_17.Do()))))));
}
//# sourceMappingURL=asyncEffect.mjs.map