import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/repeatEffectChunkMaybe";
import * as tsplus_module_2 from "@effect/core/stream/Pull/operations/end";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_4 from "@effect/core/stream/Take/operations/done";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/onError";
import * as tsplus_module_7 from "@effect/core/io/Ref/operations/make";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_9 from "@effect/core/stream/Take/operations/fromPull";
import * as tsplus_module_10 from "@effect/core/io/Cause/operations/isInterrupted";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/runtime";
import * as tsplus_module_12 from "@effect/core/io/Queue/external/bounded";
import * as tsplus_module_13 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_14 from "@effect/core/stream/Stream/operations/scoped";
import * as tsplus_module_15 from "@effect/core/stream/Stream/operations/flatMap";
import { isFiberFailure } from "@effect/core/io/Cause/errors";
/**
 * Creates a stream from an asynchronous callback that can be called multiple
 * times. The registration of the callback itself returns an a scoped
 * resource. The optionality of the error type `E` can be used to signal the
 * end of the stream, by setting it to `None`.
 *
 * @tsplus static effect/core/stream/Stream.Ops asyncScoped
 */

export function asyncScoped(register, outputBuffer = 16) {
  return tsplus_module_15.flatMap(pull => tsplus_module_1.repeatEffectChunkMaybe(pull))(tsplus_module_14.scoped(tsplus_module_5.flatMap(output => tsplus_module_5.flatMap(runtime => tsplus_module_5.flatMap(() => tsplus_module_8.map(done => tsplus_module_5.flatMap(isDone => isDone ? tsplus_module_2.end : tsplus_module_6.onError(() => tsplus_module_3.zipRight(output.shutdown)(done.set(true)))(tsplus_module_5.flatMap(take => tsplus_module_4.done(take))(output.take)))(done.get))(tsplus_module_7.makeRef(() => false)))(register(async k => {
    try {
      runtime.unsafeRunPromise(tsplus_module_5.flatMap(take => output.offer(take))(tsplus_module_9.fromPull(k)));
    } catch (e) {
      if (isFiberFailure(e)) {
        if (!tsplus_module_10.isInterrupted(e.cause)) {
          throw e;
        }
      }
    }
  })))(tsplus_module_11.runtime()))(tsplus_module_13.acquireRelease(tsplus_module_12.bounded(outputBuffer), queue => queue.shutdown))));
}
//# sourceMappingURL=asyncScoped.mjs.map