import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/suspend";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/concat";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/splitAt";
import * as tsplus_module_6 from "@effect/core/stream/Stream/operations/fromChunk";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/failCauseSync";
import * as tsplus_module_9 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_11 from "@effect/core/stream/Stream/operations/empty";
import * as tsplus_module_12 from "@effect/core/stream/Channel/operations/readWithCause";
import * as tsplus_module_13 from "@effect/core/stream/Channel/operations/failCause";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Reads the first `n` values from the stream and uses them to choose the
 * pipeline that will be used for the remainder of the stream.
 *
 * @tsplus static effect/core/stream/Stream.Aspects branchAfter
 * @tsplus pipeable effect/core/stream/Stream branchAfter
 */

export function branchAfter(n, f) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_3.suspend(() => tsplus_module_2.pipeTo(collecting(tsplus_module_1.empty(), n, f))(self.channel)));
  };
}

function collecting(buffer, n, f) {
  return tsplus_module_12.readWithCause(chunk => {
    const newBuffer = tsplus_module_4.concat(chunk)(buffer);

    if (newBuffer.length >= n) {
      const [inputs, inputs1] = tsplus_module_5.splitAt(n)(newBuffer);
      const pipeline = f(inputs);
      const stream = pipeline(tsplus_module_6.fromChunk(inputs1));
      void 0;
      return tsplus_module_7.flatMap(() => emitting(pipeline))(stream.channel);
    }

    return collecting(newBuffer, n, f);
  }, cause => tsplus_module_8.failCauseSync(() => cause), () => {
    if (tsplus_module_9.isEmpty(buffer)) {
      return tsplus_module_10.unit;
    }

    const pipeline = f(buffer);
    const stream = pipeline(tsplus_module_11.empty);
    void 0;
    return stream.channel;
  });
}

function emitting(pipeline) {
  return tsplus_module_12.readWithCause(chunk => {
    const stream = pipeline(tsplus_module_6.fromChunk(chunk));
    void 0;
    return tsplus_module_7.flatMap(() => emitting(pipeline))(stream.channel);
  }, cause => tsplus_module_13.failCause(cause), () => tsplus_module_10.unit);
}
//# sourceMappingURL=branchAfter.mjs.map