import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/fromQueueWithShutdown";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/flattenTake";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/map";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/broadcastedQueues";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/map";
/**
 * Fan out the stream, producing a list of streams that have the same elements
 * as this stream. The driver stream will only ever advance the `maximumLag`
 * chunks before the slowest downstream stream.
 *
 * @tsplus static effect/core/stream/Stream.Aspects broadcast
 * @tsplus pipeable effect/core/stream/Stream broadcast
 */

export function broadcast(n, maximumLag) {
  return self => tsplus_module_5.map(chunk => tsplus_module_3.map(queue => tsplus_module_2.flattenTake(tsplus_module_1.fromQueueWithShutdown(queue)))(chunk))(tsplus_module_4.broadcastedQueues(n, maximumLag)(self));
}
//# sourceMappingURL=broadcast.mjs.map