import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/fromQueue";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/scoped";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/flatMap";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/flattenTake";
import * as tsplus_module_5 from "@effect/core/stream/Stream/operations/broadcastedQueuesDynamic";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/map";
/**
 * Fan out the stream, producing a dynamic number of streams that have the
 * same elements as this stream. The driver stream will only ever advance the
 * `maximumLag` chunks before the slowest downstream stream.
 *
 * @tsplus static effect/core/stream/Stream.Aspects broadcastDynamic
 * @tsplus pipeable effect/core/stream/Stream broadcastDynamic
 */

export function broadcastDynamic(maximumLag) {
  return self => tsplus_module_6.map(effect => tsplus_module_4.flattenTake(tsplus_module_3.flatMap(queue => tsplus_module_1.fromQueue(queue))(tsplus_module_2.scoped(effect))))(tsplus_module_5.broadcastedQueuesDynamic(maximumLag)(self));
}
//# sourceMappingURL=broadcastDynamic.mjs.map