import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/runIntoHubScoped";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/forkScoped";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/fill";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/excl-forEach";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_7 from "@effect/core/io/Hub/operations/bounded";
/**
 * Converts the stream to a managed list of queues. Every value will be
 * replicated to every queue with the slowest queue being allowed to buffer
 * `maximumLag` chunks before the driver is back pressured.
 *
 * Queues can unsubscribe from upstream by shutting down.
 *
 * @tsplus static effect/core/stream/Stream.Aspects broadcastedQueues
 * @tsplus pipeable effect/core/stream/Stream broadcastedQueues
 */

export function broadcastedQueues(n, maximumLag) {
  return self => tsplus_module_6.flatMap(hub => tsplus_module_6.flatMap(queues => tsplus_module_3.map(() => queues)(tsplus_module_2.forkScoped(tsplus_module_1.runIntoHubScoped(hub)(self))))(tsplus_module_5.collectAll(tsplus_module_4.fill(n, () => hub.subscribe))))(tsplus_module_7.bounded(maximumLag));
}
//# sourceMappingURL=broadcastedQueues.mjs.map