import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/toHub";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/map";
/**
 * Converts the stream to a managed dynamic amount of queues. Every chunk will
 * be replicated to every queue with the slowest queue being allowed to buffer
 * `maximumLag` chunks before the driver is back pressured.
 *
 * Queues can unsubscribe from upstream by shutting down.
 *
 * @tsplus static effect/core/stream/Stream.Aspects broadcastedQueuesDynamic
 * @tsplus pipeable effect/core/stream/Stream broadcastedQueuesDynamic
 */

export function broadcastedQueuesDynamic(maximumLag) {
  return self => tsplus_module_2.map(hub => hub.subscribe)(tsplus_module_1.toHub(maximumLag)(self));
}
//# sourceMappingURL=broadcastedQueuesDynamic.mjs.map