import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/toQueue";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/stream/Take/operations/fold";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/unwrapScoped";
import { StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Allows a faster producer to progress independently of a slower consumer by
 * buffering up to `capacity` chunks in a queue.
 *
 * Note: prefer capacities that are powers of 2 for better performance.
 *
 * @tsplus static effect/core/stream/Stream.Aspects bufferChunks
 * @tsplus pipeable effect/core/stream/Stream bufferChunks
 */

export function bufferChunks(capacity) {
  return self => {
    const queue = tsplus_module_1.toQueue(capacity)(self);
    return new StreamInternal(tsplus_module_9.unwrapScoped(tsplus_module_8.map(queue => {
      const process = tsplus_module_5.flatMap(take => tsplus_module_6.fold(tsplus_module_2.unit, cause => tsplus_module_3.failCause(cause), a => tsplus_module_5.flatMap(() => process)(tsplus_module_4.write(a)))(take))(tsplus_module_7.fromEffect(queue.take));
      return process;
    })(queue)));
  };
}
//# sourceMappingURL=bufferChunks.mjs.map