import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/failCause";
import * as tsplus_module_2 from "@effect/core/io/Cause/operations/failureOrCause";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/catchAllCause";
/**
 * Switches over to the stream produced by the provided function in case this
 * one fails with a typed error.
 *
 * @tsplus static effect/core/stream/Stream.Aspects catchAll
 * @tsplus pipeable effect/core/stream/Stream catchAll
 */

export function catchAll(f) {
  return self => tsplus_module_4.catchAllCause(cause => tsplus_module_3.fold(f, cause => tsplus_module_1.failCause(cause))(tsplus_module_2.failureOrCause(cause)))(self);
}
//# sourceMappingURL=catchAll.mjs.map