import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/catchAllCause";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Switches over to the stream produced by the provided function in case this
 * one fails. Allows recovery from all causes of failure, including
 * interruption if the stream is uninterruptible.
 *
 * @tsplus static effect/core/stream/Stream.Aspects catchAllCause
 * @tsplus pipeable effect/core/stream/Stream catchAllCause
 */

export function catchAllCause(f) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_1.catchAllCause(cause => {
      const stream = f(cause);
      void 0;
      return stream.channel;
    })(self.channel));
  };
}
//# sourceMappingURL=catchAllCause.mjs.map