import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/fail";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/getOrElse";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/catchAll";
/**
 * Switches over to the stream produced by the provided function in case this
 * one fails with some typed error.
 *
 * @tsplus static effect/core/stream/Stream.Aspects catchSome
 * @tsplus pipeable effect/core/stream/Stream catchSome
 */

export function catchSome(pf) {
  return self => tsplus_module_3.catchAll(e => tsplus_module_2.getOrElse_(pf(e), () => tsplus_module_1.fail(e)))(self);
}
//# sourceMappingURL=catchSome.mjs.map