import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/failCause";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/getOrElse";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/catchAllCause";
/**
 * Switches over to the stream produced by the provided function in case this
 * one fails with some errors. Allows recovery from all causes of failure,
 * including interruption if the stream is uninterruptible.
 *
 * @tsplus static effect/core/stream/Stream.Aspects catchSomeCause
 * @tsplus pipeable effect/core/stream/Stream catchSomeCause
 */

export function catchSomeCause(pf) {
  return self => tsplus_module_3.catchAllCause(cause => tsplus_module_2.getOrElse_(pf(cause), () => tsplus_module_1.failCause(cause)))(self);
}
//# sourceMappingURL=catchSomeCause.mjs.map