import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/fail";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/catchAll";
/**
 * Recovers from specified error.
 *
 * @tsplus static effect/core/stream/Stream.Aspects catchTag
 * @tsplus pipeable effect/core/stream/Stream catchTag
 */

export function catchTag(k, f) {
  return self => tsplus_module_2.catchAll(e => {
    if ("_tag" in e && e["_tag"] === k) {
      return f(e);
    }

    return tsplus_module_1.fail(e);
  })(self);
}
//# sourceMappingURL=catchTag.mjs.map