import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/append";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/reduce";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/readWithCause";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Returns a new stream that only emits elements that are not equal to the
 * previous element emitted, using the specified function to determine whether
 * two elements are equal.
 *
 * @tsplus static effect/core/stream/Stream.Aspects changesWith
 * @tsplus pipeable effect/core/stream/Stream changesWith
 */

export function changesWith(f) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_2.pipeTo(writer(tsplus_module_1.none, f))(self.channel));
  };
}

function writer(last, f) {
  return tsplus_module_10.readWithCause(chunk => {
    const [newLast, newChunk] = tsplus_module_5.reduce([last, tsplus_module_3.empty()], ([option, as], a) => tsplus_module_1.isSome(option) && f(option.value, a) ? [tsplus_module_1.some(a), as] : [tsplus_module_1.some(a), tsplus_module_4.append(a)(as)])(chunk);
    return tsplus_module_7.flatMap(() => writer(newLast, f))(tsplus_module_6.write(newChunk));
  }, cause => tsplus_module_8.failCause(cause), () => tsplus_module_9.unit);
}
//# sourceMappingURL=changesWith.mjs.map