import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/Chunk/operations/append";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_9 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/reduce";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_12 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_13 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_14 from "@effect/core/stream/Channel/operations/readWithCause";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Returns a new stream that only emits elements that are not equal to the
 * previous element emitted, using the specified effectual function to
 * determine whether two elements are equal.
 *
 * @tsplus static effect/core/stream/Stream.Aspects changesWithEffect
 * @tsplus pipeable effect/core/stream/Stream changesWithEffect
 */

export function changesWithEffect(f) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_2.pipeTo(writer(tsplus_module_1.none, f))(self.channel));
  };
}

function writer(last, f) {
  return tsplus_module_14.readWithCause(chunk => tsplus_module_4.flatMap(([newLast, newChunk]) => tsplus_module_4.flatMap(() => writer(newLast, f))(tsplus_module_3.write(newChunk)))(tsplus_module_11.fromEffect(tsplus_module_10.reduce(chunk, [last, tsplus_module_5.empty()], ([option, as], a) => tsplus_module_9.fold(() => tsplus_module_7.succeed([tsplus_module_1.some(a), tsplus_module_6.append(a)(as)]), value => tsplus_module_8.map(b => b ? [tsplus_module_1.some(a), as] : [tsplus_module_1.some(a), tsplus_module_6.append(a)(as)])(f(value, a)))(option)))), cause => tsplus_module_12.failCause(cause), () => tsplus_module_13.unit);
}
//# sourceMappingURL=changesWithEffect.mjs.map