import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/chunks";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/unchunks";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/suspend";
/**
 * Performs the specified stream transformation with the chunk structure of
 * the stream exposed.
 *
 * @tsplus static effect/core/stream/Stream.Aspects chunksWith
 * @tsplus pipeable effect/core/stream/Stream chunksWith
 */

export function chunksWith(f) {
  return self => tsplus_module_3.suspend(() => tsplus_module_2.unchunks(f(tsplus_module_1.chunks(self))));
}
//# sourceMappingURL=chunksWith.mjs.map