import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/readWithCause";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_11 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_12 from "@effect/core/stream/Channel/operations/unwrap";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Performs an effectful filter and map in a single step.
 *
 * @tsplus static effect/core/stream/Stream.Aspects collectEffect
 * @tsplus pipeable effect/core/stream/Stream collectEffect
 */

export function collectEffect(pf) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_2.pipeTo(loop(tsplus_module_1.empty()[Symbol.iterator](), pf))(self.channel));
  };
}

function loop(chunkIterator, pf) {
  const next = chunkIterator.next();

  if (next.done) {
    return tsplus_module_5.readWithCause(elem => loop(elem[Symbol.iterator](), pf), err => tsplus_module_3.failCause(err), done => tsplus_module_4.succeed(done));
  } else {
    return tsplus_module_12.unwrap(tsplus_module_11.fold(() => tsplus_module_6.sync(() => loop(chunkIterator, pf)), effect => tsplus_module_10.map(a1 => tsplus_module_9.flatMap(() => loop(chunkIterator, pf))(tsplus_module_8.write(tsplus_module_7.single(a1))))(effect))(pf(next.value)));
  }
}
//# sourceMappingURL=collectEffect.mjs.map