import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/collectWhile";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/size";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/pipeTo";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Transforms all elements of the stream for as long as the specified partial
 * function is defined.
 *
 * @tsplus static effect/core/stream/Stream.Aspects collectWhile
 * @tsplus pipeable effect/core/stream/Stream collectWhile
 */

export function collectWhile(pf) {
  return self => {
    const loop = tsplus_module_7.readWith(input => {
      const mapped = tsplus_module_1.collectWhile(pf)(input);
      return tsplus_module_2.size(mapped) === tsplus_module_2.size(input) ? tsplus_module_4.flatMap(() => loop)(tsplus_module_3.write(mapped)) : tsplus_module_3.write(mapped);
    }, err => tsplus_module_5.fail(err), done => tsplus_module_6.succeed(done));
    void 0;
    return new StreamInternal(tsplus_module_8.pipeTo(loop)(self.channel));
  };
}
//# sourceMappingURL=collectWhile.mjs.map