import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/readWithCause";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_8 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_12 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_13 from "@effect/core/stream/Channel/operations/unwrap";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Effectfully transforms all elements of the stream for as long as the
 * specified partial function is defined.
 *
 * @tsplus static effect/core/stream/Stream.Aspects collectWhileEffect
 * @tsplus pipeable effect/core/stream/Stream collectWhileEffect
 */

export function collectWhileEffect(pf) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_2.pipeTo(loop(tsplus_module_1.empty()[Symbol.iterator](), pf))(self.channel));
  };
}

function loop(chunkIterator, pf) {
  const next = chunkIterator.next();

  if (next.done) {
    return tsplus_module_5.readWithCause(elem => loop(elem[Symbol.iterator](), pf), err => tsplus_module_3.failCause(err), done => tsplus_module_4.succeed(done));
  } else {
    return tsplus_module_13.unwrap(tsplus_module_12.fold(() => tsplus_module_7.succeed(tsplus_module_6.unit), effect => tsplus_module_11.map(a1 => tsplus_module_10.flatMap(() => loop(chunkIterator, pf))(tsplus_module_9.write(tsplus_module_8.single(a1))))(effect))(pf(next.value)));
  }
}
//# sourceMappingURL=collectWhileEffect.mjs.map