import * as tsplus_module_1 from "@effect/core/io/Effect/operations/done";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/unsome";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/unfoldEffect";
import * as tsplus_module_5 from "@effect/core/stream/Stream/operations/_internal/Handoff";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/writeChunk";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/concatMap";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/runScoped";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/forkScoped";
import * as tsplus_module_12 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_13 from "@effect/core/stream/Channel/operations/unwrapScoped";
import * as tsplus_module_14 from "@effect/core/io/Exit/operations/succeed";
import * as tsplus_module_15 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_16 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_17 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_18 from "@effect/core/io/Cause/operations/map";
import * as tsplus_module_19 from "@effect/core/io/Exit/operations/failCause";
import * as tsplus_module_20 from "@effect/core/io/Exit/operations/fail";
import * as tsplus_module_21 from "@effect/core/stream/Channel/operations/readWithCause";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Combines the elements from this stream and the specified stream by
 * repeatedly applying the function `f` to extract an element using both sides
 * and conceptually "offer" it to the destination stream. `f` can maintain
 * some internal state to control the combining process, with the initial
 * state being specified by `s`.
 *
 * Where possible, prefer `Stream.combineChunks` for a more efficient
 * implementation.
 *
 * @tsplus static effect/core/stream/Stream.Aspects combine
 * @tsplus pipeable effect/core/stream/Stream combine
 */

export function combine(that, s, f) {
  return self => new StreamInternal(tsplus_module_13.unwrapScoped(tsplus_module_3.flatMap(left => tsplus_module_3.flatMap(right => tsplus_module_3.flatMap(latchL => tsplus_module_3.flatMap(latchR => {
    void 0;
    return tsplus_module_3.flatMap(() => {
      void 0;
      return tsplus_module_12.map(() => {
        const pullLeft = tsplus_module_6.zipRight(tsplus_module_3.flatMap(exit => tsplus_module_1.done(exit))(tsplus_module_5.take(left)))(tsplus_module_5.offer(undefined)(latchL));
        const pullRight = tsplus_module_6.zipRight(tsplus_module_3.flatMap(exit => tsplus_module_1.done(exit))(tsplus_module_5.take(right)))(tsplus_module_5.offer(undefined)(latchR));
        const stream = tsplus_module_4.unfoldEffect(s, s => tsplus_module_3.flatMap(exit => tsplus_module_2.unsome(tsplus_module_1.done(exit)))(f(s, pullLeft, pullRight)));
        void 0;
        return stream.channel;
      })(tsplus_module_11.forkScoped(tsplus_module_10.runScoped(tsplus_module_9.pipeTo(producer(right, latchR))(tsplus_module_8.concatMap(chunk => tsplus_module_7.writeChunk(chunk))(that.channel)))));
    })(tsplus_module_11.forkScoped(tsplus_module_10.runScoped(tsplus_module_9.pipeTo(producer(left, latchL))(tsplus_module_8.concatMap(chunk => tsplus_module_7.writeChunk(chunk))(self.channel)))));
  })(tsplus_module_5.make()))(tsplus_module_5.make()))(tsplus_module_5.make()))(tsplus_module_5.make())));
}

function producer(handoff, latch) {
  return tsplus_module_16.flatMap(() => tsplus_module_21.readWithCause(value => tsplus_module_16.flatMap(() => producer(handoff, latch))(tsplus_module_15.fromEffect(tsplus_module_5.offer(tsplus_module_14.succeed(value))(handoff))), cause => tsplus_module_15.fromEffect(tsplus_module_5.offer(tsplus_module_19.failCause(tsplus_module_18.map(tsplus_module_17.some)(cause)))(handoff)), () => tsplus_module_16.flatMap(() => producer(handoff, latch))(tsplus_module_15.fromEffect(tsplus_module_5.offer(tsplus_module_20.fail(tsplus_module_17.none))(handoff)))))(tsplus_module_15.fromEffect(tsplus_module_5.take(latch)));
}
//# sourceMappingURL=combine.mjs.map