import * as tsplus_module_1 from "@effect/core/io/Effect/operations/done";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/unsome";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/unfoldChunkEffect";
import * as tsplus_module_5 from "@effect/core/stream/Take/operations/done";
import * as tsplus_module_6 from "@effect/core/stream/Stream/operations/_internal/Handoff";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/runScoped";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/forkScoped";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_12 from "@effect/core/stream/Channel/operations/unwrapScoped";
import * as tsplus_module_13 from "@effect/core/stream/Take/operations/chunk";
import * as tsplus_module_14 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_15 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_16 from "@effect/core/stream/Take/operations/failCause";
import * as tsplus_module_17 from "@effect/core/stream/Take/operations/end";
import * as tsplus_module_18 from "@effect/core/stream/Channel/operations/readWithCause";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Combines the chunks from this stream and the specified stream by repeatedly
 * applying the function `f` to extract a chunk using both sides and
 * conceptually "offer" it to the destination stream. `f` can maintain some
 * internal state to control the combining process, with the initial state
 * being specified by `s`.
 *
 * @tsplus static effect/core/stream/Stream.Aspects combineChunks
 * @tsplus pipeable effect/core/stream/Stream combineChunks
 */

export function combineChunks(that, s, f) {
  return self => new StreamInternal(tsplus_module_12.unwrapScoped(tsplus_module_3.flatMap(left => tsplus_module_3.flatMap(right => tsplus_module_3.flatMap(latchL => tsplus_module_3.flatMap(latchR => {
    void 0;
    return tsplus_module_3.flatMap(() => {
      void 0;
      return tsplus_module_11.map(() => {
        const pullLeft = tsplus_module_7.zipRight(tsplus_module_3.flatMap(take => tsplus_module_5.done(take))(tsplus_module_6.take(left)))(tsplus_module_6.offer(undefined)(latchL));
        const pullRight = tsplus_module_7.zipRight(tsplus_module_3.flatMap(take => tsplus_module_5.done(take))(tsplus_module_6.take(right)))(tsplus_module_6.offer(undefined)(latchR));
        const stream = tsplus_module_4.unfoldChunkEffect(s, s => tsplus_module_3.flatMap(exit => tsplus_module_2.unsome(tsplus_module_1.done(exit)))(f(s, pullLeft, pullRight)));
        void 0;
        return stream.channel;
      })(tsplus_module_10.forkScoped(tsplus_module_9.runScoped(tsplus_module_8.pipeTo(producer(right, latchR))(that.channel))));
    })(tsplus_module_10.forkScoped(tsplus_module_9.runScoped(tsplus_module_8.pipeTo(producer(left, latchL))(self.channel))));
  })(tsplus_module_6.make()))(tsplus_module_6.make()))(tsplus_module_6.make()))(tsplus_module_6.make())));
}

function producer(handoff, latch) {
  return tsplus_module_15.flatMap(() => tsplus_module_18.readWithCause(chunk => tsplus_module_15.flatMap(() => producer(handoff, latch))(tsplus_module_14.fromEffect(tsplus_module_6.offer(tsplus_module_13.chunk(chunk))(handoff))), cause => tsplus_module_14.fromEffect(tsplus_module_6.offer(tsplus_module_16.failCause(cause))(handoff)), () => tsplus_module_15.flatMap(() => producer(handoff, latch))(tsplus_module_14.fromEffect(tsplus_module_6.offer(tsplus_module_17.end)(handoff)))))(tsplus_module_14.fromEffect(tsplus_module_6.take(latch)));
}
//# sourceMappingURL=combineChunks.mjs.map