import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/map";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/flatMap";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/mapOut";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/concatMap";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Composes this stream with the specified stream to create a cartesian
 * product of elements. The `that` stream would be run multiple times, for
 * every element in the `this` stream.
 *
 * See also `Stream.zip` for the more common point-wise variant.
 *
 * @tsplus static effect/core/stream/Stream.Aspects crossFlatten
 * @tsplus pipeable effect/core/stream/Stream crossFlatten
 */

export function crossFlatten(that) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_4.concatMap(a => {
      void 0;
      return tsplus_module_3.mapOut(b => tsplus_module_2.flatMap(a => tsplus_module_1.map(b => [...a, b])(b))(a))(that.channel);
    })(self.channel));
  };
}
//# sourceMappingURL=crossFlatten.mjs.map