import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/cross";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/map";
/**
 * Composes this stream with the specified stream to create a cartesian
 * product of elements, but keeps only elements from this stream. The `that`
 * stream would be run multiple times, for every element in the `this` stream.
 *
 * See also `Stream.zipLeft` for the more common point-wise variant.
 *
 * @tsplus pipeable-operator effect/core/stream/Stream <
 * @tsplus static effect/core/stream/Stream.Aspects crossLeft
 * @tsplus pipeable effect/core/stream/Stream crossLeft
 */

export function crossLeft(that) {
  return self => tsplus_module_2.map(tuple => tuple[0])(tsplus_module_1.cross(that)(self));
}
//# sourceMappingURL=crossLeft.mjs.map