import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/cross";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/map";
/**
 * Composes this stream with the specified stream to create a cartesian
 * product of elements, but keeps only elements from that stream. The `that`
 * stream would be run multiple times, for every element in the `this` stream.
 *
 * See also `Stream.zipRight` for the more common point-wise variant.
 *
 * @tsplus pipeable-operator effect/core/stream/Stream >
 * @tsplus static effect/core/stream/Stream.Aspects crossRight
 * @tsplus pipeable effect/core/stream/Stream crossRight
 */

export function crossRight(that) {
  return self => tsplus_module_2.map(tuple => tuple[1])(tsplus_module_1.cross(that)(self));
}
//# sourceMappingURL=crossRight.mjs.map