import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/map";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/flatMap";
/**
 * Composes this stream with the specified stream to create a cartesian
 * product of elements with a specified function. The `that` stream would be
 * run multiple times, for every element in the `this` stream.
 *
 * See also `Stream.zip` for the more common point-wise variant.
 *
 * @tsplus static effect/core/stream/Stream.Aspects crossWith
 * @tsplus pipeable effect/core/stream/Stream crossWith
 */

export function crossWith(that, f) {
  return self => tsplus_module_2.flatMap(a => tsplus_module_1.map(b => f(a, b))(that))(self);
}
//# sourceMappingURL=crossWith.mjs.map