import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/runScoped";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/forkScoped";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/scoped";
import * as tsplus_module_5 from "@effect/core/stream/Stream/operations/crossRight";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/unwrap";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_9 from "@effect/core/stream/Stream/operations/_internal/Handoff";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_11 from "@effect/core/io/Fiber/operations/join";
import * as tsplus_module_12 from "@effect/core/io/Fiber/operations/interrupt";
import * as tsplus_module_13 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_14 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_15 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_16 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_17 from "@effect/core/io/Exit/operations/fold";
import * as tsplus_module_18 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_19 from "@effect/core/io/Effect/operations/raceWith";
import * as tsplus_module_20 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_21 from "@effect/core/stream/Stream/operations/_internal/HandoffSignal";
import * as tsplus_module_22 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_23 from "@tsplus/stdlib/collections/Chunk/operations/last";
import * as tsplus_module_24 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_25 from "@effect/core/stream/Stream/SinkEndReason";
import * as tsplus_module_26 from "@effect/core/stream/Channel/operations/readWithCause";
import * as tsplus_module_27 from "@effect/core/io/Clock/operations/sleep";
import * as tsplus_module_28 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_29 from "@effect/core/io/Effect/operations/transplant";
import * as tsplus_module_30 from "@effect/core/stream/Stream/operations/unwrap";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";

class NotStarted {
  constructor() {
    this._tag = "NotStarted";
  }

}

class Previous {
  constructor(fiber) {
    this.fiber = fiber;
    this._tag = "Previous";
  }

}

class Current {
  constructor(fiber) {
    this.fiber = fiber;
    this._tag = "Current";
  }

}
/**
 * Delays the emission of values by holding new values for a set duration. If
 * no new values arrive during that time the value is emitted, however if a
 * new value is received during the holding period the previous value is
 * discarded and the process is repeated with the new value.
 *
 * This operator is useful if you have a stream of "bursty" events which
 * eventually settle down and you only need the final event of the burst.
 *
 * @example A search engine may only want to initiate a search after a user has
 * paused typing so as to not prematurely recommend results.
 *
 * @tsplus static effect/core/stream/Stream.Aspects debounce
 * @tsplus pipeable effect/core/stream/Stream debounce
 */


export function debounce(duration) {
  return self => tsplus_module_30.unwrap(tsplus_module_29.transplant(grafter => tsplus_module_10.map(handoff => {
    function enqueue(last) {
      return tsplus_module_10.map(fiber => consumer(new Previous(fiber)))(grafter(tsplus_module_28.fork(tsplus_module_13.as(last)(tsplus_module_27.sleep(duration)))));
    }

    const producer = tsplus_module_26.readWithCause(input => tsplus_module_24.fold(() => producer, last => tsplus_module_15.flatMap(() => producer)(tsplus_module_22.fromEffect(tsplus_module_9.offer(tsplus_module_21.emit(tsplus_module_20.single(last)))(handoff))))(tsplus_module_23.last(input)), cause => tsplus_module_22.fromEffect(tsplus_module_9.offer(tsplus_module_21.halt(cause))(handoff)), () => tsplus_module_22.fromEffect(tsplus_module_9.offer(tsplus_module_21.end(tsplus_module_25.upstreamEnd))(handoff)));

    function consumer(state) {
      return tsplus_module_6.unwrap((() => {
        switch (state._tag) {
          case "NotStarted":
            {
              return tsplus_module_10.map(signal => {
                switch (signal._tag) {
                  case "Emit":
                    {
                      return tsplus_module_6.unwrap(enqueue(signal.elements));
                    }

                  case "Halt":
                    {
                      return tsplus_module_7.failCause(signal.error);
                    }

                  case "End":
                    {
                      return tsplus_module_8.unit;
                    }
                }
              })(tsplus_module_9.take(handoff));
            }

          case "Current":
            {
              return tsplus_module_10.map(signal => {
                switch (signal._tag) {
                  case "Emit":
                    {
                      return tsplus_module_6.unwrap(enqueue(signal.elements));
                    }

                  case "Halt":
                    {
                      return tsplus_module_7.failCause(signal.error);
                    }

                  case "End":
                    {
                      return tsplus_module_8.unit;
                    }
                }
              })(tsplus_module_11.join(state.fiber));
            }

          case "Previous":
            {
              return tsplus_module_19.raceWith(tsplus_module_9.take(handoff), (exit, current) => tsplus_module_17.fold(cause => tsplus_module_13.as(tsplus_module_7.failCause(cause))(tsplus_module_12.interrupt(current)), chunk => tsplus_module_16.succeed(tsplus_module_15.flatMap(() => consumer(new Current(current)))(tsplus_module_14.write(chunk))))(exit), (exit, previous) => tsplus_module_17.fold(cause => tsplus_module_13.as(tsplus_module_7.failCause(cause))(tsplus_module_12.interrupt(previous)), signal => {
                switch (signal._tag) {
                  case "Emit":
                    {
                      return tsplus_module_18.flatMap(() => enqueue(signal.elements))(tsplus_module_12.interrupt(previous));
                    }

                  case "Halt":
                    {
                      return tsplus_module_13.as(tsplus_module_7.failCause(signal.error))(tsplus_module_12.interrupt(previous));
                    }

                  case "End":
                    {
                      return tsplus_module_10.map(chunk => tsplus_module_15.flatMap(() => tsplus_module_8.unit)(tsplus_module_14.write(chunk)))(tsplus_module_11.join(previous));
                    }
                }
              })(exit))(tsplus_module_11.join(state.fiber));
            }
        }
      })());
    }

    void 0;
    return tsplus_module_5.crossRight(new StreamInternal(consumer(new NotStarted())))(tsplus_module_4.scoped(tsplus_module_3.forkScoped(tsplus_module_2.runScoped(tsplus_module_1.pipeTo(producer)(self.channel)))));
  })(tsplus_module_9.make())));
}
//# sourceMappingURL=debounce.mjs.map