import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashMap/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/List/empty";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashMap/operations/set";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/List/prepend";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/reduceRight";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/HashMap/operations/unsafeGet";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_9 from "@tsplus/stdlib/collections/Chunk/operations/range";
import * as tsplus_module_10 from "@tsplus/stdlib/collections/Chunk/operations/map";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/excl-forEach";
import * as tsplus_module_12 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_13 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_14 from "@effect/core/stream/Stream/operations/distributedWithDynamic";
import * as tsplus_module_15 from "@effect/core/io/Deferred/operations/make";
/**
 * More powerful version of `Stream.broadcast`. Allows to provide a function
 * that determines what queues should receive which elements. The decide
 * function will receive the indices of the queues in the resulting list.
 *
 * @tsplus static effect/core/stream/Stream.Aspects distributedWith
 * @tsplus pipeable effect/core/stream/Stream distributedWith
 */

export function distributedWith(n, maximumLag, decide) {
  return self => tsplus_module_12.flatMap(deferred => tsplus_module_12.flatMap(next => tsplus_module_12.flatMap(entries => {
    const [mappings, queues] = tsplus_module_5.reduceRight([tsplus_module_1.empty(), tsplus_module_2.empty()], ([mapping, queue], [mappings, queues]) => [tsplus_module_3.set(mapping[0], mapping[1])(mappings), tsplus_module_4.prepend(queue)(queues)])(entries);
    return tsplus_module_8.as(queues)(deferred.succeed(a => tsplus_module_7.map(f => key => f(tsplus_module_6.unsafeGet(key)(mappings)))(decide(a))));
  })(tsplus_module_11.collectAll(tsplus_module_10.map(id => tsplus_module_7.map(([key, queue]) => [[key, id], queue])(next))(tsplus_module_9.range(0, n - 1)))))(tsplus_module_14.distributedWithDynamic(maximumLag, a => tsplus_module_12.flatMap(f => f(a))(deferred.await), () => tsplus_module_13.unit)(self)))(tsplus_module_15.make());
}
//# sourceMappingURL=distributedWith.mjs.map