import * as tsplus_module_1 from "@tsplus/stdlib/data/AtomicNumber";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/flatten";
import * as tsplus_module_4 from "@effect/core/stm/TSemaphore/operations/withPermit";
import * as tsplus_module_5 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_6 from "@effect/core/io/Cause/operations/map";
import * as tsplus_module_7 from "@effect/core/io/Exit/operations/failCause";
import * as tsplus_module_8 from "@effect/core/io/Exit/operations/fail";
import * as tsplus_module_9 from "@effect/core/stream/Stream/operations/runForEachScoped";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/foldCauseEffect";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/forkScoped";
import * as tsplus_module_12 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_13 from "@effect/core/io/Cause/operations/isInterrupted";
import * as tsplus_module_14 from "@effect/core/io/Effect/operations/catchSomeCause";
import * as tsplus_module_15 from "@effect/core/io/Effect/operations/excl-forEach";
import * as tsplus_module_16 from "@tsplus/stdlib/collections/HashMap/operations/values";
import * as tsplus_module_17 from "@tsplus/stdlib/collections/HashMap/operations/set";
import * as tsplus_module_18 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_19 from "@effect/core/io/Queue/external/bounded";
import * as tsplus_module_20 from "@effect/core/io/Effect/operations/do";
import * as tsplus_module_21 from "@effect/core/io/Effect/operations/tap";
import * as tsplus_module_22 from "@effect/core/io/Ref/operations/make";
import * as tsplus_module_23 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_24 from "@effect/core/stm/TSemaphore/operations/makeCommit";
import * as tsplus_module_25 from "@tsplus/stdlib/collections/HashMap/operations/empty";
import * as tsplus_module_26 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_27 from "@tsplus/stdlib/collections/List/definition";
import * as tsplus_module_28 from "@tsplus/stdlib/collections/HashMap/operations/removeMany";
import * as tsplus_module_29 from "@tsplus/stdlib/collections/List/empty";
import * as tsplus_module_30 from "@tsplus/stdlib/collections/List/prepend";
import * as tsplus_module_31 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_32 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_33 from "@effect/core/io/Exit/operations/succeed";
import * as tsplus_module_34 from "@effect/core/io/Effect/operations/reduce";
const distributedWithDynamicId = /*#__PURE__*/new tsplus_module_1.AtomicNumber(0);
/**
 * More powerful version of `Stream.distributedWith`. This returns a function
 * that will produce new queues and corresponding indices. You can also provide
 * a function that will be executed after the final events are enqueued in all
 * queues. Shutdown of the queues is handled by the driver. Downstream users can
 * also shutdown queues manually. In this case the driver will continue but no
 * longer backpressure on them.
 *
 * @tsplus static effect/core/stream/Stream.Aspects distributedWithDynamic
 * @tsplus pipeable effect/core/stream/Stream distributedWithDynamic
 */

export function distributedWithDynamic(maximumLag, decide, done = () => tsplus_module_2.unit) {
  return self => tsplus_module_23.flatMap(queuesRef => tsplus_module_12.map(add => add)(tsplus_module_23.flatMap(queuesLock => tsplus_module_23.flatMap(newQueue => {
    const finalize = endTake => // Make sure that no queues are currently being added
    tsplus_module_4.withPermit(queuesLock)(tsplus_module_2.asUnit(tsplus_module_21.tap(() => done(endTake))(tsplus_module_21.tap(({
      queues
    }) => tsplus_module_15.forEach(queues, queue => tsplus_module_14.catchSomeCause(cause => tsplus_module_13.isInterrupted(cause) ? tsplus_module_5.some(tsplus_module_2.unit) : tsplus_module_5.none)(queue.offer(endTake))))(tsplus_module_20.bind("queues", () => tsplus_module_12.map(map => tsplus_module_16.values(map))(queuesRef.get))(tsplus_module_21.tap(() => // All newly created queues should end immediately
    newQueue.set(tsplus_module_12.map(({
      id,
      queue
    }) => [id, queue])(tsplus_module_21.tap(({
      id,
      queue
    }) => queuesRef.update(map => tsplus_module_17.set(id, queue)(map)))(tsplus_module_20.bind("id", () => tsplus_module_18.sync(() => distributedWithDynamicId.incrementAndGet()))(tsplus_module_21.tap(({
      queue
    }) => queue.offer(endTake))(tsplus_module_20.bind("queue", () => tsplus_module_19.bounded(1))(tsplus_module_20.Do())))))))(tsplus_module_20.Do()))))));

    return tsplus_module_12.map(() => tsplus_module_4.withPermit(queuesLock)(tsplus_module_3.flatten(newQueue.get)))(tsplus_module_11.forkScoped(tsplus_module_10.foldCauseEffect(cause => finalize(tsplus_module_7.failCause(tsplus_module_6.map(tsplus_module_5.some)(cause))), () => finalize(tsplus_module_8.fail(tsplus_module_5.none)))(tsplus_module_9.runForEachScoped(a => offer(queuesRef, decide, a))(self))));
  })(tsplus_module_22.makeRef(() => tsplus_module_12.map(({
    id,
    queue
  }) => [id, queue])(tsplus_module_21.tap(({
    id,
    queue
  }) => queuesRef.update(map => tsplus_module_17.set(id, queue)(map)))(tsplus_module_20.bind("id", () => tsplus_module_18.sync(() => distributedWithDynamicId.incrementAndGet()))(tsplus_module_20.bind("queue", () => tsplus_module_19.bounded(maximumLag))(tsplus_module_20.Do())))))))(tsplus_module_24.makeCommit(1))))(tsplus_module_26.acquireRelease(tsplus_module_22.makeRef(() => tsplus_module_25.empty()), map => tsplus_module_23.flatMap(queues => tsplus_module_15.forEach(queues, ([, queue]) => queue.shutdown))(map.get)));
}

function offer(ref, decide, a) {
  return tsplus_module_2.asUnit(tsplus_module_23.flatMap(shouldProcess => tsplus_module_23.flatMap(queues => tsplus_module_12.map(() => void 0)(tsplus_module_23.flatMap(ids => tsplus_module_27.isNil(ids) ? tsplus_module_2.unit : ref.update(map => tsplus_module_28.removeMany(ids)(map)))(tsplus_module_34.reduce(queues, tsplus_module_29.empty(), (acc, [id, queue]) => shouldProcess(id) ? tsplus_module_10.foldCauseEffect(cause => // Ignore all downstream queues that were shut down and remove
  // them later
  tsplus_module_13.isInterrupted(cause) ? tsplus_module_31.succeed(tsplus_module_30.prepend(id)(acc)) : tsplus_module_32.failCause(cause), () => tsplus_module_31.succeed(acc))(queue.offer(tsplus_module_33.succeed(a))) : tsplus_module_31.succeed(acc)))))(ref.get))(decide(a)));
}
//# sourceMappingURL=distributedWithDynamic.mjs.map