import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/interruptWhenDeferred";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/unit";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/runForEachScoped";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/catchAllCause";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/forkScoped";
import * as tsplus_module_6 from "@effect/core/stream/Stream/operations/scoped";
import * as tsplus_module_7 from "@effect/core/stream/Stream/operations/crossRight";
import * as tsplus_module_8 from "@effect/core/io/Deferred/operations/make";
import * as tsplus_module_9 from "@effect/core/stream/Stream/operations/fromEffect";
import * as tsplus_module_10 from "@effect/core/stream/Stream/operations/flatMap";
/**
 * Drains the provided stream in the background for as long as this stream is
 * running. If this stream ends before `other`, `other` will be interrupted.
 * If `other` fails, this stream will fail with that error.
 *
 * @tsplus static effect/core/stream/Stream.Aspects drainFork
 * @tsplus pipeable effect/core/stream/Stream drainFork
 */

export function drainFork(other) {
  return self => tsplus_module_10.flatMap(backgroundDied => tsplus_module_7.crossRight(tsplus_module_1.interruptWhenDeferred(backgroundDied)(self))(tsplus_module_6.scoped(tsplus_module_5.forkScoped(tsplus_module_4.catchAllCause(cause => backgroundDied.failCause(() => cause))(tsplus_module_3.runForEachScoped(() => tsplus_module_2.unit)(other))))))(tsplus_module_9.fromEffect(tsplus_module_8.make()));
}
//# sourceMappingURL=drainFork.mjs.map