import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/drop";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/identity";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/readWith";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Drops the specified number of elements from this stream.
 *
 * @tsplus static effect/core/stream/Stream.Aspects drop
 * @tsplus pipeable effect/core/stream/Stream drop
 */

export function drop(n) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_1.pipeTo(loop(n))(self.channel));
  };
}

function loop(r) {
  return tsplus_module_9.readWith(chunk => {
    const dropped = tsplus_module_2.drop(r)(chunk);
    const leftover = Math.max(0, r - chunk.length);
    const more = tsplus_module_3.isEmpty(chunk) || leftover > 0;
    return more ? loop(leftover) : tsplus_module_6.flatMap(() => tsplus_module_4.identity())(tsplus_module_5.write(dropped));
  }, err => tsplus_module_7.fail(err), () => tsplus_module_8.unit);
}
//# sourceMappingURL=drop.mjs.map