import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/drop";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/dropWhile";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/via";
/**
 * Creates a pipeline that drops elements until the specified predicate
 * evaluates to true.
 *
 * @tsplus static effect/core/stream/Stream.Aspects dropUntil
 * @tsplus pipeable effect/core/stream/Stream dropUntil
 */

export function dropUntil(f) {
  return self => tsplus_module_3.via(tsplus_module_1.drop(1))(tsplus_module_2.dropWhile(a => !f(a))(self));
}
//# sourceMappingURL=dropUntil.mjs.map