import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/dropWhile";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/identity";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/readWith";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Creates a pipeline that drops elements while the specified predicate
 * evaluates to `true`.
 *
 * @tsplus static effect/core/stream/Stream.Aspects dropWhile
 * @tsplus pipeable effect/core/stream/Stream dropWhile
 */

export function dropWhile(f) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_1.pipeTo(dropWhileInternal(f))(self.channel));
  };
}

function dropWhileInternal(f) {
  return tsplus_module_9.readWith(chunk => {
    const out = tsplus_module_2.dropWhile(f)(chunk);
    return tsplus_module_3.isEmpty(out) ? dropWhileInternal(f) : tsplus_module_6.flatMap(() => tsplus_module_4.identity())(tsplus_module_5.write(out));
  }, err => tsplus_module_7.fail(err), out => tsplus_module_8.succeed(out));
}
//# sourceMappingURL=dropWhile.mjs.map