import * as tsplus_module_1 from "@effect/core/stream/Sink/operations/dropWhileEffect";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/pipeThrough";
/**
 * Drops all elements of the stream for as long as the specified predicate
 * produces an effect that evalutates to `true`.
 *
 * @tsplus static effect/core/stream/Stream.Aspects dropWhileEffect
 * @tsplus pipeable effect/core/stream/Stream dropWhileEffect
 */

export function dropWhileEffect(f) {
  return self => tsplus_module_2.pipeThrough(tsplus_module_1.dropWhileEffect(f))(self);
}
//# sourceMappingURL=dropWhileEffect.mjs.map