import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/make";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/map";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/catchAll";
/**
 * Returns a stream whose failures and successes have been lifted into an
 * `Either`. The resulting stream cannot fail, because the failures have been
 * exposed as part of the `Either` success case.
 *
 * @note The stream will end as soon as the first error occurs.
 *
 * @tsplus getter effect/core/stream/Stream either
 */

export function either(self) {
  return tsplus_module_4.catchAll(e => tsplus_module_2.make(tsplus_module_1.left(e)))(tsplus_module_3.map(tsplus_module_1.right)(self));
}
//# sourceMappingURL=either.mjs.map