import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/writeChunk";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/concatMap";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/mergeMap";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Maps each element of this stream to another stream and returns the
 * non-deterministic merge of those streams, executing up to `n` inner streams
 * concurrently. Up to `bufferSize` elements of the produced streams may be
 * buffered in memory by this operator.
 *
 * @tsplus static effect/core/stream/Stream.Aspects flatMapPar
 * @tsplus pipeable effect/core/stream/Stream flatMapPar
 */

export function flatMapPar(n, f, bufferSize = 16) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_3.mergeMap(n, a => {
      const stream = f(a);
      void 0;
      return stream.channel;
    }, bufferSize)(tsplus_module_2.concatMap(tsplus_module_1.writeChunk)(self.channel)));
  };
}
//# sourceMappingURL=flatMapPar.mjs.map