import * as tsplus_module_1 from "@tsplus/stdlib/data/Function";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/flatMapPar";
/**
 * Flattens a stream of streams into a stream by executing a non-deterministic
 * concurrent merge. Up to `n` streams may be consumed in parallel and up to
 * `outputBuffer` elements may be buffered by this operator.
 *
 * @tsplus static effect/core/stream/Stream.Aspects flattenPar
 * @tsplus pipeable effect/core/stream/Stream flattenPar
 */

export function flattenPar(n, outputBuffer = 16) {
  return self => tsplus_module_2.flatMapPar(n, tsplus_module_1.identity, outputBuffer)(self);
}
//# sourceMappingURL=flattenPar.mjs.map