import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/fromChunkQueue";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/map";
/**
 * Creates a stream from a subscription to a hub in the context of a scoped
 * effect. The scoped effect describes subscribing to receive messages from
 * the hub while the stream describes taking messages from the hub.
 *
 * @tsplus static effect/core/stream/Stream.Ops fromChunkHubScoped
 */

export function fromChunkHubScoped(hub) {
  return tsplus_module_2.map(queue => tsplus_module_1.fromChunkQueue(queue))(hub.subscribe);
}
//# sourceMappingURL=fromChunkHubScoped.mjs.map