import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/fromChunkHubScoped";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/ensuring";
/**
 * Creates a stream from a subscription to a hub in the context of a scoped
 * effect. The scoped effect describes subscribing to receive messages from
 * the hub while the stream describes taking messages from the hub.
 *
 * The hub will be shut down once the stream is closed.
 *
 * @tsplus static effect/core/stream/Stream.Ops fromChunkHubScopedWithShutdown
 */

export function fromChunkHubScopedWithShutdown(hub) {
  return tsplus_module_2.ensuring(hub.shutdown)(tsplus_module_1.fromChunkHubScoped(hub));
}
//# sourceMappingURL=fromChunkHubScopedWithShutdown.mjs.map