import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/fromQueue";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/scoped";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/flatMap";
import { DEFAULT_CHUNK_SIZE } from "@effect/core/stream/Stream/definition";
/**
 * Creates a stream from a subscription to a hub.
 *
 * @param maxChunkSize
 *   Maximum number of queued elements to put in one chunk in the stream.
 *
 * @tsplus static effect/core/stream/Stream.Ops fromHub
 */

export function fromHub(hub, maxChunkSize = DEFAULT_CHUNK_SIZE) {
  return tsplus_module_3.flatMap(queue => tsplus_module_1.fromQueue(queue, maxChunkSize))(tsplus_module_2.scoped(hub.subscribe));
}
//# sourceMappingURL=fromHub.mjs.map