import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/ensuring";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/fromHubScoped";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/map";
import { DEFAULT_CHUNK_SIZE } from "@effect/core/stream/Stream/definition";
/**
 * Creates a stream from a subscription to a hub in the context of a scoped
 * effect. The scoped effect describes subscribing to receive messages from
 * the hub while the stream describes taking messages from the hub.
 *
 * The hub will be shut down once the stream is closed.
 *
 * @param maxChunkSize
 *   Maximum number of queued elements to put in one chunk in the stream.
 *
 * @tsplus static effect/core/stream/Stream.Ops fromHubScopedWithShutdown
 */

export function fromHubScopedWithShutdown(hub, maxChunkSize = DEFAULT_CHUNK_SIZE) {
  return tsplus_module_3.map(stream => tsplus_module_1.ensuring(hub.shutdown)(stream))(tsplus_module_2.fromHubScoped(hub, maxChunkSize));
}
//# sourceMappingURL=fromHubScopedWithShutdown.mjs.map