import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/fromHub";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/ensuring";
import { DEFAULT_CHUNK_SIZE } from "@effect/core/stream/Stream/definition";
/**
 * Creates a stream from a subscription to a hub.
 *
 * The hub will be shut down once the stream is closed.
 *
 * @param maxChunkSize
 *   Maximum number of queued elements to put in one chunk in the stream.
 *
 * @tsplus static effect/core/stream/Stream.Ops fromHubWithShutdown
 */

export function fromHubWithShutdown(hub, maxChunkSize = DEFAULT_CHUNK_SIZE) {
  return tsplus_module_2.ensuring(hub.shutdown)(tsplus_module_1.fromHub(hub, maxChunkSize));
}
//# sourceMappingURL=fromHubWithShutdown.mjs.map