import * as tsplus_module_1 from "@effect/core/io/Cause/operations/isInterrupted";
import * as tsplus_module_2 from "@effect/core/stream/Pull/operations/end";
import * as tsplus_module_3 from "@effect/core/stream/Pull/operations/failCause";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/catchAllCause";
import * as tsplus_module_7 from "@effect/core/stream/Stream/operations/repeatEffectChunkMaybe";
import { DEFAULT_CHUNK_SIZE } from "@effect/core/stream/Stream/definition";
/**
 * Creates a stream from a `Queue` of values.
 *
 * @param maxChunkSize
 *   Maximum number of queued elements to put in one chunk in the stream.
 *
 * @tsplus static effect/core/stream/Stream.Ops fromQueue
 */

export function fromQueue(queue, maxChunkSize = DEFAULT_CHUNK_SIZE) {
  return tsplus_module_7.repeatEffectChunkMaybe(tsplus_module_6.catchAllCause(cause => queue.isShutdown && tsplus_module_1.isInterrupted(cause) ? tsplus_module_2.end : tsplus_module_3.failCause(cause))(tsplus_module_5.map(tsplus_module_4.from)(queue.takeBetween(1, maxChunkSize))));
}
//# sourceMappingURL=fromQueue.mjs.map