import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/fromQueue";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/ensuring";
import { DEFAULT_CHUNK_SIZE } from "@effect/core/stream/Stream/definition";
/**
 * Creates a stream from a `Queue` of values. The queue will be shutdown once
 * the stream is closed.
 *
 * @param maxChunkSize
 *   Maximum number of queued elements to put in one chunk in the stream.
 *
 * @tsplus static effect/core/stream/Stream.Ops fromQueueWithShutdown
 */

export function fromQueueWithShutdown(queue, maxChunkSize = DEFAULT_CHUNK_SIZE) {
  return tsplus_module_2.ensuring(queue.shutdown)(tsplus_module_1.fromQueue(queue, maxChunkSize));
}
//# sourceMappingURL=fromQueueWithShutdown.mjs.map