import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_8 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/readWithCause";
import * as tsplus_module_10 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_11 from "@tsplus/stdlib/collections/Chunk/operations/append";
import * as tsplus_module_12 from "@tsplus/stdlib/collections/Chunk/operations/reduce";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Creates a stream that groups on adjacent keys, calculated by function f.
 *
 * @tsplus static effect/core/stream/Stream.Aspects groupAdjacentBy
 * @tsplus pipeable effect/core/stream/Stream groupAdjacentBy
 */

export function groupAdjacentBy(f) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_2.pipeTo(chunkAdjacent(tsplus_module_1.none, f))(self.channel));
  };
}

function chunkAdjacent(buffer, f) {
  return tsplus_module_9.readWithCause(chunk => {
    const [outputs, newBuffer] = go(chunk, buffer, f);
    return tsplus_module_4.flatMap(() => chunkAdjacent(newBuffer, f))(tsplus_module_3.write(outputs));
  }, cause => tsplus_module_5.failCause(cause), () => tsplus_module_8.fold(() => tsplus_module_6.unit, o => tsplus_module_3.write(tsplus_module_7.single(o)))(buffer));
}

function go(input, state, f) {
  return tsplus_module_12.reduce([tsplus_module_10.empty(), state], ([os, o], a) => tsplus_module_8.fold(() => [os, tsplus_module_1.some([f(a), tsplus_module_7.single(a)])], agg => {
    const k2 = f(a);
    const [k, aggregated] = agg;

    if (k === k2) {
      return [os, tsplus_module_1.some([k, tsplus_module_11.append(a)(aggregated)])];
    } else {
      return [tsplus_module_11.append(agg)(os), tsplus_module_1.some([k2, tsplus_module_7.single(a)])];
    }
  })(o))(input);
}
//# sourceMappingURL=groupAdjacentBy.mjs.map