import * as tsplus_module_1 from "@effect/core/io/Effect/operations/sleep";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/haltWhen";
/**
 * Specialized version of haltWhen which halts the evaluation of this stream
 * after the given duration.
 *
 * An element in the process of being pulled will not be interrupted when the
 * given duration completes. See `interruptAfter` for this behavior.
 *
 * @tsplus static effect/core/stream/Stream.Aspects haltAfter
 * @tsplus pipeable effect/core/stream/Stream haltAfter
 */

export function haltAfter(duration) {
  return self => tsplus_module_2.haltWhen(tsplus_module_1.sleep(duration))(self);
}
//# sourceMappingURL=haltAfter.mjs.map