import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/fold";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/unwrap";
import * as tsplus_module_8 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/pipeTo";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Halts the evaluation of this stream when the provided deferred resolves.
 *
 * If the deferred completes with a failure, the stream will emit that failure.
 *
 * @tsplus static effect/core/stream/Stream.Aspects haltWhenDeferred
 * @tsplus pipeable effect/core/stream/Stream haltWhenDeferred
 */

export function haltWhenDeferred(deferred) {
  return self => {
    const writer = tsplus_module_7.unwrap(tsplus_module_9.map(option => tsplus_module_8.fold(() => tsplus_module_5.readWith(input => tsplus_module_2.flatMap(() => writer)(tsplus_module_1.write(input)), err => tsplus_module_3.fail(err), () => tsplus_module_4.unit), io => tsplus_module_7.unwrap(tsplus_module_6.fold(e => tsplus_module_3.fail(e), () => tsplus_module_4.unit)(io)))(option))(deferred.poll));
    void 0;
    return new StreamInternal(tsplus_module_10.pipeTo(writer)(self.channel));
  };
}
//# sourceMappingURL=haltWhenDeferred.mjs.map