import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/make";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/forever";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/interleaveWith";
/**
 * Interleaves this stream and the specified stream deterministically by
 * alternating pulling values from this stream and the specified stream. When
 * one stream is exhausted all remaining values in the other stream will be
 * pulled.
 *
 * @tsplus static effect/core/stream/Stream.Aspects interleave
 * @tsplus pipeable effect/core/stream/Stream interleave
 */

export function interleave(that) {
  return self => tsplus_module_3.interleaveWith(that, tsplus_module_2.forever(tsplus_module_1.make(true, false)))(self);
}
//# sourceMappingURL=interleave.mjs.map