import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/writeChunk";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/concatMap";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/runScoped";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/forkScoped";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_7 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_8 from "@effect/core/stream/Stream/operations/_internal/Handoff";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/unwrapScoped";
import * as tsplus_module_10 from "@effect/core/stream/Take/operations/single";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_12 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_13 from "@effect/core/stream/Take/operations/failCause";
import * as tsplus_module_14 from "@effect/core/stream/Take/operations/end";
import * as tsplus_module_15 from "@effect/core/stream/Channel/operations/readWithCause";
import * as tsplus_module_16 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_17 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_18 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_19 from "@effect/core/stream/Take/operations/fold";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Combines this stream and the specified stream deterministically using the
 * stream of boolean values `b` to control which stream to pull from next.
 * `true` indicates to pull from this stream and `false` indicates to pull
 * from the specified stream. Only consumes as many elements as requested by
 * `b`. If either this stream or the specified stream are exhausted further
 * requests for values from that stream will be ignored.
 *
 * @tsplus static effect/core/stream/Stream.Aspects interleaveWith
 * @tsplus pipeable effect/core/stream/Stream interleaveWith
 */

export function interleaveWith(that, b) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_9.unwrapScoped(tsplus_module_7.flatMap(left => tsplus_module_7.flatMap(right => tsplus_module_7.flatMap(() => {
      void 0;
      return tsplus_module_6.map(() => {
        void 0;
        return tsplus_module_3.pipeTo(process(left, right, false, false))(tsplus_module_2.concatMap(tsplus_module_1.writeChunk)(b.channel));
      })(tsplus_module_5.forkScoped(tsplus_module_4.runScoped(tsplus_module_3.pipeTo(producer(right))(tsplus_module_2.concatMap(tsplus_module_1.writeChunk)(that.channel)))));
    })(tsplus_module_5.forkScoped(tsplus_module_4.runScoped(tsplus_module_3.pipeTo(producer(left))(tsplus_module_2.concatMap(tsplus_module_1.writeChunk)(self.channel))))))(tsplus_module_8.make()))(tsplus_module_8.make())));
  };
}

function producer(handoff) {
  return tsplus_module_15.readWithCause(value => tsplus_module_12.flatMap(() => producer(handoff))(tsplus_module_11.fromEffect(tsplus_module_8.offer(tsplus_module_10.single(value))(handoff))), cause => tsplus_module_11.fromEffect(tsplus_module_8.offer(tsplus_module_13.failCause(cause))(handoff)), () => tsplus_module_11.fromEffect(tsplus_module_8.offer(tsplus_module_14.end)(handoff)));
}

function process(left, right, leftDone, rightDone) {
  return tsplus_module_15.readWithCause(bool => {
    if (bool && !leftDone) {
      return tsplus_module_12.flatMap(take => tsplus_module_19.fold(rightDone ? tsplus_module_16.unit : process(left, right, true, rightDone), cause => tsplus_module_17.failCause(cause), chunk => tsplus_module_12.flatMap(() => process(left, right, leftDone, rightDone))(tsplus_module_18.write(chunk)))(take))(tsplus_module_11.fromEffect(tsplus_module_8.take(left)));
    }

    if (!bool && !rightDone) {
      return tsplus_module_12.flatMap(take => tsplus_module_19.fold(leftDone ? tsplus_module_16.unit : process(left, right, leftDone, true), cause => tsplus_module_17.failCause(cause), chunk => tsplus_module_12.flatMap(() => process(left, right, leftDone, rightDone))(tsplus_module_18.write(chunk)))(take))(tsplus_module_11.fromEffect(tsplus_module_8.take(right)));
    }

    return process(left, right, leftDone, rightDone);
  }, cause => tsplus_module_17.failCause(cause), () => tsplus_module_16.unit);
}
//# sourceMappingURL=interleaveWith.mjs.map