import * as tsplus_module_1 from "@effect/core/io/Effect/operations/sleep";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/interruptWhen";
/**
 * Specialized version of interruptWhen which interrupts the evaluation of
 * this stream after the given duration.
 *
 * @tsplus static effect/core/stream/Stream.Aspects interruptAfter
 * @tsplus pipeable effect/core/stream/Stream interruptAfter
 */

export function interruptAfter(duration) {
  return self => tsplus_module_2.interruptWhen(tsplus_module_1.sleep(duration))(self);
}
//# sourceMappingURL=interruptAfter.mjs.map