import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/builder";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/forEach";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/readWith";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Intersperse stream with provided element.
 *
 * @tsplus static effect/core/stream/Stream.Aspects intersperse
 * @tsplus pipeable effect/core/stream/Stream intersperse
 */

export function intersperse(middle) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_1.pipeTo(writer(middle, true))(self.channel));
  };
}

function writer(middle, isFirst) {
  return tsplus_module_8.readWith(chunk => {
    const builder = tsplus_module_2.builder();
    let flagResult = isFirst;
    tsplus_module_3.forEach(value => {
      if (flagResult) {
        flagResult = false;
        builder.append(value);
      } else {
        builder.append(middle);
        builder.append(value);
      }
    })(chunk);
    return tsplus_module_5.flatMap(() => writer(middle, flagResult))(tsplus_module_4.write(builder.build()));
  }, err => tsplus_module_6.fail(err), () => tsplus_module_7.unit);
}
//# sourceMappingURL=intersperse.mjs.map