import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/unfold";
/**
 * Returns an infinite stream of iterative function application: `a`, `f(a)`,
 * `f(f(a))`, `f(f(f(a)))`, ...
 *
 * @tsplus static effect/core/stream/Stream.Ops iterate
 */

export function iterate(a, f) {
  return tsplus_module_2.unfold(a, a => tsplus_module_1.some([a, f(a)]));
}
//# sourceMappingURL=iterate.mjs.map