import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/mapAccum";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/readWith";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Statefully maps over the elements of this stream to produce new elements.
 *
 * @tsplus static effect/core/stream/Stream.Aspects mapAccum
 * @tsplus pipeable effect/core/stream/Stream mapAccum
 */

export function mapAccum(s, f) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_1.pipeTo(accumulator(s, f))(self.channel));
  };
}

function accumulator(current, f) {
  return tsplus_module_7.readWith(input => {
    const [nextS, a1s] = tsplus_module_2.mapAccum(current, f)(input);
    return tsplus_module_4.flatMap(() => accumulator(nextS, f))(tsplus_module_3.write(a1s));
  }, err => tsplus_module_5.fail(err), () => tsplus_module_6.unit);
}
//# sourceMappingURL=mapAccum.mjs.map