import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/mapError";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/map";
/**
 * Returns a stream whose failure and success channels have been mapped by the
 * specified pair of functions, `f` and `g`.
 *
 * @tsplus static effect/core/stream/Stream.Aspects mapBoth
 * @tsplus pipeable effect/core/stream/Stream mapBoth
 */

export function mapBoth(f, g) {
  return self => tsplus_module_2.map(g)(tsplus_module_1.mapError(f)(self));
}
//# sourceMappingURL=mapBoth.mjs.map