import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/flatMap";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/map";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/chunksWith";
/**
 * Maps each element to an Collection, and flattens the Collections into the
 * output of this stream.
 *
 * @tsplus static effect/core/stream/Stream.Aspects mapConcat
 * @tsplus pipeable effect/core/stream/Stream mapConcat
 */

export function mapConcat(f) {
  return self => tsplus_module_4.chunksWith(chunk => tsplus_module_3.map(chunk => tsplus_module_2.flatMap(a => tsplus_module_1.from(f(a)))(chunk))(chunk))(self);
}
//# sourceMappingURL=mapConcat.mjs.map