import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/readWithCause";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/suspendSucceed";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/unwrap";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Maps over elements of the stream with the specified effectful function.
 *
 * @tsplus static effect/core/stream/Stream.Aspects mapEffect
 * @tsplus pipeable effect/core/stream/Stream mapEffect
 */

export function mapEffect(f) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_2.pipeTo(loop(tsplus_module_1.empty()[Symbol.iterator](), f))(self.channel));
  };
}

function loop(chunkIterator, f) {
  const next = chunkIterator.next();

  if (next.done) {
    return tsplus_module_5.readWithCause(elem => loop(elem[Symbol.iterator](), f), err => tsplus_module_3.failCause(err), done => tsplus_module_4.succeed(done));
  } else {
    return tsplus_module_11.unwrap(tsplus_module_10.map(a1 => tsplus_module_8.flatMap(() => loop(chunkIterator, f))(tsplus_module_7.write(tsplus_module_6.single(a1))))(tsplus_module_9.suspendSucceed(() => f(next.value))));
  }
}
//# sourceMappingURL=mapEffect.mjs.map