import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/writeChunk";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/concatMap";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/mapOutEffectPar";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/mapOut";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Maps over elements of the stream with the specified effectful function,
 * executing up to `n` invocations of `f` concurrently. Transformed elements
 * will be emitted in the original order.
 *
 * @note This combinator destroys the chunking structure. It's recommended to use
 * rechunk afterwards.
 *
 * @tsplus static effect/core/stream/Stream.Aspects mapEffectPar
 * @tsplus pipeable effect/core/stream/Stream mapEffectPar
 */

export function mapEffectPar(n, f) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_5.mapOut(tsplus_module_1.single)(tsplus_module_4.mapOutEffectPar(n, f)(tsplus_module_3.concatMap(tsplus_module_2.writeChunk)(self.channel))));
  };
}
//# sourceMappingURL=mapEffectPar.mjs.map