import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/fromEffect";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/flatMapPar";
/**
 * Maps over elements of the stream with the specified effectful function,
 * executing up to `n` invocations of `f` concurrently. The element order is
 * not enforced by this combinator, and elements may be reordered.
 *
 * @tsplus static effect/core/stream/Stream.Aspects mapEffectParUnordered
 * @tsplus pipeable effect/core/stream/Stream mapEffectParUnordered
 */

export function mapEffectParUnordered(n, f) {
  return self => tsplus_module_2.flatMapPar(n, a => tsplus_module_1.fromEffect(f(a)))(self);
}
//# sourceMappingURL=mapEffectParUnordered.mjs.map