import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/mapEffect";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/groupByKey";
import * as tsplus_module_3 from "@effect/core/stream/GroupBy/operations/mergeGroupBy";
/**
 * Maps over elements of the stream with the specified effectful function,
 * partitioned by `p` executing invocations of `f` concurrently. The number of
 * concurrent invocations of `f` is determined by the number of different
 * outputs of type `K`. Up to `buffer` elements may be buffered per partition.
 * Transformed elements may be reordered but the order within a partition is
 * maintained.
 *
 * @tsplus static effect/core/stream/Stream.Aspects mapEffectPartitioned
 * @tsplus pipeable effect/core/stream/Stream mapEffectPartitioned
 */

export function mapEffectPartitioned(keyBy, f, buffer = 16) {
  return self => tsplus_module_3.mergeGroupBy((_, s) => tsplus_module_1.mapEffect(f)(s))(tsplus_module_2.groupByKey(keyBy, buffer)(self));
}
//# sourceMappingURL=mapEffectPartitioned.mjs.map