import * as tsplus_module_1 from "@effect/core/stream/Stream/TerminationStrategy";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/mergeWith";
/**
 * Merges this stream and the specified stream together.
 *
 * New produced stream will terminate when both specified stream terminate if
 * no termination strategy is specified.
 *
 * @tsplus static effect/core/stream/Stream.Aspects merge
 * @tsplus pipeable effect/core/stream/Stream merge
 */

export function merge(that, strategy = tsplus_module_1.both) {
  return self => tsplus_module_2.mergeWith(that, a => a, a => a, strategy)(self);
}
//# sourceMappingURL=merge.mjs.map