import * as tsplus_module_1 from "@effect/core/stream/Stream/TerminationStrategy";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/mergeWith";
/**
 * Merges this stream and the specified stream together to produce a stream of
 * eithers.
 *
 * @tsplus static effect/core/stream/Stream.Aspects mergeEither
 * @tsplus pipeable effect/core/stream/Stream mergeEither
 */

export function mergeEither(that, strategy = tsplus_module_1.both) {
  return self => tsplus_module_3.mergeWith(that, a => tsplus_module_2.leftW(a), a2 => tsplus_module_2.rightW(a2), strategy)(self);
}
//# sourceMappingURL=mergeEither.mjs.map