import * as tsplus_module_1 from "@effect/core/stream/Stream/TerminationStrategy";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/merge";
/**
 * Merges this stream and the specified stream together. New produced stream
 * will terminate when either stream terminates.
 *
 * @tsplus static effect/core/stream/Stream.Aspects mergeTerminateEither
 * @tsplus pipeable effect/core/stream/Stream mergeTerminateEither
 */

export function mergeTerminateEither(that) {
  return self => tsplus_module_2.merge(that, tsplus_module_1.either)(self);
}
//# sourceMappingURL=mergeTerminateEither.mjs.map