import * as tsplus_module_1 from "@effect/core/stream/Stream/TerminationStrategy";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/map";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/mergeWith";
import * as tsplus_module_4 from "@effect/core/io/Exit/operations/isSuccess";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/done";
import * as tsplus_module_6 from "@effect/core/stream/Channel/MergeDecision";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Merges this stream and the specified stream together to a common element
 * type with the specified mapping functions.
 *
 * New produced stream will terminate when both specified stream terminate if
 * no termination strategy is specified.
 *
 * @tsplus static effect/core/stream/Stream.Aspects mergeWith
 * @tsplus pipeable effect/core/stream/Stream mergeWith
 */

export function mergeWith(that, left, right, strategy = tsplus_module_1.both) {
  return self => {
    const leftStream = tsplus_module_2.map(left)(self);
    const rightStream = tsplus_module_2.map(right)(that);
    void 0;
    void 0;
    const stream = tsplus_module_3.mergeWith_(rightStream.channel, handler(strategy._tag === "Either" || strategy._tag === "Left"), handler(strategy._tag === "Either" || strategy._tag === "Right"))(leftStream.channel);
    return new StreamInternal(stream);
  };
}

function handler(terminate) {
  return exit => {
    return terminate || !tsplus_module_4.isSuccess(exit) ? tsplus_module_6.done(tsplus_module_5.done(exit)) : tsplus_module_6._await(exit => tsplus_module_5.done(exit));
  };
}
//# sourceMappingURL=mergeWith.mjs.map