import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/intersperseAffixes";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/mkString";
/**
 * Returns a combined string resulting from concatenating each of the values
 * from the stream beginning with `before` interspersed with `middle` and
 * ending with `after`.
 *
 * @tsplus static effect/core/stream/Stream.Aspects mkStringAffixes
 * @tsplus pipeable effect/core/stream/Stream mkStringAffixes
 */

export function mkStringAffixes(start, middle, end) {
  return self => tsplus_module_2.mkString(tsplus_module_1.intersperseAffixes(start, middle, end)(self));
}
//# sourceMappingURL=mkStringAffixes.mjs.map