import * as tsplus_module_1 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/fromEffect";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/catchAllCause";
/**
 * Runs the specified effect if this stream fails, providing the error to the
 * effect if it exists.
 *
 * Note: Unlike `Effect.onError`, there is no guarantee that the provided
 * effect will not be interrupted.
 *
 * @tsplus static effect/core/stream/Stream.Aspects onError
 * @tsplus pipeable effect/core/stream/Stream onError
 */

export function onError(cleanup) {
  return self => tsplus_module_4.catchAllCause(cause => tsplus_module_3.fromEffect(tsplus_module_2.zipRight(tsplus_module_1.failCause(cause))(cleanup(cause))))(self);
}
//# sourceMappingURL=onError.mjs.map