import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/map";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/orElse";
/**
 * Switches to the provided stream in case this one fails with a typed error.
 *
 * See also `Stream.catchAll`.
 *
 * @tsplus static effect/core/stream/Stream.Aspects orElseEither
 * @tsplus pipeable effect/core/stream/Stream orElseEither
 */

export function orElseEither(that) {
  return self => tsplus_module_3.orElse(() => tsplus_module_2.map(tsplus_module_1.right)(that()))(tsplus_module_2.map(tsplus_module_1.left)(self));
}
//# sourceMappingURL=orElseEither.mjs.map