import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/failSync";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/orElse";
/**
 * Fails with given error in case this one fails with a typed error.
 *
 * See also `Stream.catchAll`.
 *
 * @tsplus static effect/core/stream/Stream.Aspects orElseFail
 * @tsplus pipeable effect/core/stream/Stream orElseFail
 */

export function orElseFail(e) {
  return self => tsplus_module_2.orElse(() => tsplus_module_1.failSync(e))(self);
}
//# sourceMappingURL=orElseFail.mjs.map