import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/fail";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/catchAll";
/**
 * Switches to the provided stream in case this one fails with the `None`
 * value.
 *
 * See also `Stream.catchAll`.
 *
 * @tsplus static effect/core/stream/Stream.Aspects orElseOptional
 * @tsplus pipeable effect/core/stream/Stream orElseOptional
 */

export function orElseOptional(that) {
  return self => tsplus_module_4.catchAll(option => tsplus_module_3.fold(that, e => tsplus_module_2.fail(tsplus_module_1.some(e)))(option))(self);
}
//# sourceMappingURL=orElseOptional.mjs.map