import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/paginateChunk";
/**
 * Like `unfold`, but allows the emission of values to end one step further than
 * the unfolding of the state. This is useful for embedding paginated APIs,
 * hence the name.
 *
 * @tsplus static effect/core/stream/Stream.Ops paginate
 */

export function paginate(s, f) {
  return tsplus_module_2.paginateChunk(s, s => {
    const [a, maybeS] = f(s);
    return [tsplus_module_1.single(a), maybeS];
  });
}
//# sourceMappingURL=paginate.mjs.map