import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/suspend";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/zipRight";
import * as tsplus_module_5 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/unwrap";
import { StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Like `unfoldChunkEffect`, but allows the emission of values to end one step
 * further than the unfolding of the state. This is useful for embedding
 * paginated APIs, hence the name.
 *
 * @tsplus static effect/core/stream/Stream.Ops paginateChunkEffect
 */

export function paginateChunkEffect(s, f) {
  return new StreamInternal(tsplus_module_1.suspend(() => loop(s, f)));
}

function loop(s, f) {
  return tsplus_module_7.unwrap(tsplus_module_6.map(([as, maybeS]) => tsplus_module_5.fold(() => tsplus_module_4.zipRight(tsplus_module_2.unit)(tsplus_module_3.write(as)), s => tsplus_module_4.zipRight(loop(s, f))(tsplus_module_3.write(as)))(maybeS))(f(s)));
}
//# sourceMappingURL=paginateChunkEffect.mjs.map