import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/partitionEither";
/**
 * Partition a stream using a predicate. The first stream will contain all
 * element evaluated to true and the second one will contain all element
 * evaluated to false. The faster stream may advance by up to buffer elements
 * further than the slower one.
 *
 * @tsplus static effect/core/stream/Stream.Aspects partition
 * @tsplus pipeable effect/core/stream/Stream partition
 */

export function partition(p, buffer = 16) {
  return self => tsplus_module_3.partitionEither(a => p(a) ? tsplus_module_2.succeed(tsplus_module_1.left(a)) : tsplus_module_2.succeed(tsplus_module_1.right(a)), buffer)(self);
}
//# sourceMappingURL=partition.mjs.map