import * as tsplus_module_1 from "@tsplus/stdlib/collections/List/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/List/unsafeHead";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/fromQueueWithShutdown";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/flattenExitMaybe";
import * as tsplus_module_5 from "@effect/core/stream/Stream/operations/collectLeft";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/List/unsafeLast";
import * as tsplus_module_7 from "@effect/core/stream/Stream/operations/collectRight";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/dieMessage";
import * as tsplus_module_10 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_11 from "@effect/core/stream/Stream/operations/mapEffect";
import * as tsplus_module_12 from "@effect/core/stream/Stream/operations/distributedWith";
import * as tsplus_module_13 from "@effect/core/io/Effect/operations/flatMap";
/**
 * Split a stream by a predicate. The faster stream may advance by up to
 * buffer elements further than the slower one.
 *
 * @tsplus static effect/core/stream/Stream.Aspects partitionEither
 * @tsplus pipeable effect/core/stream/Stream partitionEither
 */

export function partitionEither(p, buffer = 16) {
  return self => tsplus_module_13.flatMap(dequeues => {
    if (tsplus_module_1.length(dequeues) === 2) {
      return tsplus_module_8.succeed([tsplus_module_5.collectLeft(tsplus_module_4.flattenExitMaybe(tsplus_module_3.fromQueueWithShutdown(tsplus_module_2.unsafeHead(dequeues)))), tsplus_module_7.collectRight(tsplus_module_4.flattenExitMaybe(tsplus_module_3.fromQueueWithShutdown(tsplus_module_6.unsafeLast(dequeues))))]);
    }

    return tsplus_module_9.dieMessage(`Stream.partitionEither: expected two streams but received: ${tsplus_module_1.length(dequeues)}`);
  })(tsplus_module_12.distributedWith(2, buffer, either => tsplus_module_10.fold(() => tsplus_module_8.succeed(_ => _ === 0), () => tsplus_module_8.succeed(_ => _ === 1))(either))(tsplus_module_11.mapEffect(p)(self)));
}
//# sourceMappingURL=partitionEither.mjs.map