import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/tapErrorCause";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/runScoped";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/forkScoped";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_10 from "@effect/core/stream/Stream/operations/_internal/Handoff";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/unwrap";
import * as tsplus_module_12 from "@effect/core/stream/Sink/operations/fromEffect";
import * as tsplus_module_13 from "@effect/core/stream/Sink/operations/fail";
import * as tsplus_module_14 from "@effect/core/stream/Sink/operations/zipRight";
import * as tsplus_module_15 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_16 from "@effect/core/stream/Channel/operations/readWithCause";
import * as tsplus_module_17 from "@effect/core/stream/Sink/operations/exposeLeftover";
import * as tsplus_module_18 from "@effect/core/stream/Sink/operations/foldSink";
import * as tsplus_module_19 from "@effect/core/io/Deferred/operations/make";
import * as tsplus_module_20 from "@effect/core/io/Effect/operations/flatten";
import { SinkInternal } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
import { StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
export class Emit {
  constructor(elements) {
    this.elements = elements;
    this._tag = "Emit";
  }

}
export class Halt {
  constructor(error) {
    this.error = error;
    this._tag = "Halt";
  }

}
export class End {
  constructor() {
    this._tag = "End";
  }

}
/**
 * Peels off enough material from the stream to construct a `Z` using the
 * provided `Sink` and then returns both the `Z` and the rest of the
 * `Stream` in a scope. Like all scoped values, the provided stream is valid
 * only within the scope.
 *
 * @tsplus static effect/core/stream/Stream.Aspects peel
 * @tsplus pipeable effect/core/stream/Stream peel
 */

export function peel(sink) {
  return self => tsplus_module_20.flatten(tsplus_module_4.flatMap(deferred => tsplus_module_5.map(handoff => {
    const consumer = tsplus_module_18.foldSink_(e => tsplus_module_14.zipRight(tsplus_module_13.fail(e))(tsplus_module_12.fromEffect(deferred.fail(e))), ([z1, leftovers]) => {
      const loop = tsplus_module_16.readWithCause(chunk => tsplus_module_7.flatMap(() => loop)(tsplus_module_15.fromEffect(tsplus_module_10.offer(new Emit(chunk))(handoff))), cause => tsplus_module_7.flatMap(() => tsplus_module_8.failCause(cause))(tsplus_module_15.fromEffect(tsplus_module_10.offer(new Halt(cause))(handoff))), () => tsplus_module_7.flatMap(() => tsplus_module_9.unit)(tsplus_module_15.fromEffect(tsplus_module_10.offer(new End())(handoff))));
      return new SinkInternal(tsplus_module_7.flatMap(() => loop)(tsplus_module_7.flatMap(() => tsplus_module_15.fromEffect(tsplus_module_10.offer(new Emit(leftovers))(handoff)))(tsplus_module_15.fromEffect(deferred.succeed(z1)))));
    })(tsplus_module_17.exposeLeftover(sink));
    const producer = tsplus_module_11.unwrap(tsplus_module_5.map(signal => {
      switch (signal._tag) {
        case "Emit":
          {
            return tsplus_module_7.flatMap(() => producer)(tsplus_module_6.write(signal.elements));
          }

        case "Halt":
          {
            return tsplus_module_8.failCause(signal.error);
          }

        case "End":
          {
            return tsplus_module_9.unit;
          }
      }
    })(tsplus_module_10.take(handoff)));
    return tsplus_module_5.map(z => [z, new StreamInternal(producer)])(tsplus_module_4.flatMap(() => deferred.await)(tsplus_module_3.forkScoped(tsplus_module_2.runScoped(consumer)(tsplus_module_1.tapErrorCause(cause => deferred.failCause(() => cause))(self)))));
  })(tsplus_module_10.make()))(tsplus_module_19.make()));
}
//# sourceMappingURL=peel.mjs.map