import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/repeatEither";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/collectRight";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/repeated";
import { StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Repeats the entire stream using the specified schedule. The stream will
 * execute normally, and then repeat again according to the provided schedule.
 *
 * @tsplus static effect/core/stream/Stream.Aspects repeat
 * @tsplus pipeable effect/core/stream/Stream repeat
 */

export function repeatNow(schedule) {
  return self => tsplus_module_2.collectRight(tsplus_module_1.repeatEither(schedule)(self));
}
/**
 * Repeats the provided value infinitely.
 *
 * @tsplus static effect/core/stream/Stream.Ops repeat
 */

export function repeat(a) {
  return new StreamInternal(tsplus_module_5.repeated(tsplus_module_4.write(tsplus_module_3.single(a))));
}
//# sourceMappingURL=repeat.mjs.map