import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeedNone";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/catchAll";
import * as tsplus_module_7 from "@effect/core/stream/Stream/operations/unfoldChunkEffect";
/**
 * Creates a stream from an effect producing chunks of `A` values until it
 * fails with `None`.
 *
 * @tsplus static effect/core/stream/Stream.Ops repeatEffectChunkMaybe
 */

export function repeatEffectChunkMaybe(effect) {
  return tsplus_module_7.unfoldChunkEffect(effect, eff => tsplus_module_6.catchAll(option => tsplus_module_3.fold(() => tsplus_module_1.succeedNone, e => tsplus_module_2.fail(e))(option))(tsplus_module_5.map(chunk => tsplus_module_4.some([chunk, eff]))(eff)));
}
//# sourceMappingURL=repeatEffectChunkMaybe.mjs.map