import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/repeatWith";
/**
 * Repeats the entire stream using the specified schedule. The stream will
 * execute normally, and then repeat again according to the provided schedule.
 * The schedule output will be emitted at the end of each repetition.
 *
 * @tsplus static effect/core/stream/Stream.Aspects repeatEither
 * @tsplus pipeable effect/core/stream/Stream repeatEither
 */

export function repeatEither(schedule) {
  return self => tsplus_module_2.repeatWith(schedule, a => tsplus_module_1.rightW(a), b => tsplus_module_1.leftW(b))(self);
}
//# sourceMappingURL=repeatEither.mjs.map