import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/repeatElementsWith";
/**
 * Repeats each element of the stream using the provided schedule. When the
 * schedule is finished, then the output of the schedule will be emitted into
 * the stream. Repetitions are done in addition to the first execution, which
 * means using `Schedule.recurs(1)` actually results in the original effect,
 * plus an additional recurrence, for a total of two repetitions of each value
 * in the stream.
 *
 * @tsplus static effect/core/stream/Stream.Aspects repeatElementsEither
 * @tsplus pipeable effect/core/stream/Stream repeatElementsEither
 */

export function repeatElementsEither(schedule) {
  return self => tsplus_module_2.repeatElementsWith(schedule, a => tsplus_module_1.rightW(a), b => tsplus_module_1.leftW(b))(self);
}
//# sourceMappingURL=repeatElementsEither.mjs.map