import * as tsplus_module_1 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_4 from "@effect/core/io/Schedule/operations/driver";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/unwrap";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_8 from "@tsplus/stdlib/collections/Chunk/operations/drop";
import * as tsplus_module_9 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_12 from "@tsplus/stdlib/collections/Chunk/operations/head";
import * as tsplus_module_13 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_14 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_15 from "@effect/core/io/Effect/operations/orDie";
import * as tsplus_module_16 from "@effect/core/io/Effect/operations/tap";
import * as tsplus_module_17 from "@effect/core/io/Effect/operations/orElse";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Repeats each element of the stream using the provided schedule. When the
 * schedule is finished, then the output of the schedule will be emitted into
 * the stream. Repetitions are done in addition to the first execution, which
 * means using `Schedule.recurs(1)` actually results in the original effect,
 * plus an additional recurrence, for a total of two repetitions of each value
 * in the stream.
 *
 * This function accepts two conversion functions, which allow the output of
 * this stream and the output of the provided schedule to be unified into a
 * single type. For example, `Either` or similar data type.
 *
 * @tsplus static effect/core/stream/Stream.Aspects repeatElementsWith
 * @tsplus pipeable effect/core/stream/Stream repeatElementsWith
 */

export function repeatElementsWith(schedule, f, g) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_7.pipeTo(tsplus_module_6.unwrap(tsplus_module_5.map(driver => {
      const loop = tsplus_module_3.readWith(chunk => feed(loop, driver, f, g, chunk), err => tsplus_module_1.fail(err), () => tsplus_module_2.unit);
      return loop;
    })(tsplus_module_4.driver(schedule))))(self.channel));
  };
}

function feed(loop, driver, f, g, input) {
  return tsplus_module_13.fold(() => loop, a => tsplus_module_11.flatMap(() => step(loop, driver, f, g, tsplus_module_8.drop(1)(input), a))(tsplus_module_10.write(tsplus_module_9.single(f(a)))))(tsplus_module_12.head(input));
}

function step(loop, driver, f, g, input, value) {
  const advance = tsplus_module_14.as(tsplus_module_11.flatMap(() => step(loop, driver, f, g, input, value))(tsplus_module_10.write(tsplus_module_9.single(f(value)))))(driver.next(value));
  const reset = tsplus_module_5.map(b => tsplus_module_11.flatMap(() => feed(loop, driver, f, g, input))(tsplus_module_10.write(tsplus_module_9.single(g(b)))))(tsplus_module_16.tap(() => driver.reset)(tsplus_module_15.orDie(driver.last)));
  return tsplus_module_6.unwrap(tsplus_module_17.orElse(() => reset)(advance));
}
//# sourceMappingURL=repeatElementsWith.mjs.map