import * as tsplus_module_1 from "@effect/core/io/Effect/operations/orDie";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/map";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/unwrap";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/fold";
import * as tsplus_module_10 from "@effect/core/io/Schedule/operations/driver";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/fromEffect";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Repeats the entire stream using the specified schedule. The stream will
 * execute normally, and then repeat again according to the provided schedule.
 * The schedule output will be emitted at the end of each repetition and can
 * be unified with the stream elements using the provided functions.
 *
 * @tsplus static effect/core/stream/Stream.Aspects repeatWith
 * @tsplus pipeable effect/core/stream/Stream repeatWith
 */

export function repeatWith(schedule, f, g) {
  return self => new StreamInternal(tsplus_module_8.flatMap(driver => {
    const scheduleOutput = tsplus_module_2.map(g)(tsplus_module_1.orDie(driver.last));
    const stream = tsplus_module_3.map(f)(self);
    void 0;
    const process = stream.channel;
    const loop = tsplus_module_7.unwrap(tsplus_module_9.fold(() => tsplus_module_4.unit, () => tsplus_module_8.flatMap(() => loop)(tsplus_module_8.flatMap(() => tsplus_module_7.unwrap(tsplus_module_2.map(c => tsplus_module_6.write(tsplus_module_5.single(c)))(scheduleOutput)))(process)))(driver.next(undefined)));
    return tsplus_module_8.flatMap(() => loop)(process);
  })(tsplus_module_11.fromEffect(tsplus_module_10.driver(schedule))));
}
//# sourceMappingURL=repeatWith.mjs.map