import * as tsplus_module_1 from "@effect/core/io/Effect/operations/fail";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/tap";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/foldEffect";
import * as tsplus_module_5 from "@effect/core/stream/Stream/operations/unwrap";
import * as tsplus_module_6 from "@effect/core/stream/Stream/operations/catchAll";
import * as tsplus_module_7 from "@effect/core/io/Schedule/operations/driver";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/map";
/**
 * When the stream fails, retry it according to the given schedule
 *
 * This retries the entire stream, so will re-execute all of the stream's
 * acquire operations.
 *
 * The schedule is reset as soon as the first element passes through the
 * stream again.
 *
 * @param schedule Schedule receiving as input the errors of the stream.
 *
 * @tsplus static effect/core/stream/Stream.Aspects retry
 * @tsplus pipeable effect/core/stream/Stream retry
 */

export function retry(schedule) {
  return self => tsplus_module_5.unwrap(tsplus_module_8.map(driver => {
    const loop = tsplus_module_6.catchAll(e => tsplus_module_5.unwrap(tsplus_module_4.foldEffect(() => tsplus_module_1.fail(e), () => tsplus_module_3.sync(() => tsplus_module_2.tap(() => driver.reset)(loop)))(driver.next(e))))(self);
    return loop;
  })(tsplus_module_7.driver(schedule)));
}
//# sourceMappingURL=retry.mjs.map