import * as tsplus_module_1 from "@effect/core/io/Effect/operations/failSync";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/mapEffect";
/**
 * Fails with given error 'e' if value is `Left`.
 *
 * @tsplus static effect/core/stream/Stream.Aspects rightOrFail
 * @tsplus pipeable effect/core/stream/Stream rightOrFail
 */

export function rightOrFail(error) {
  return self => tsplus_module_4.mapEffect(either => tsplus_module_3.fold(() => tsplus_module_1.failSync(error), tsplus_module_2.succeed)(either))(self);
}
//# sourceMappingURL=rightOrFail.mjs.map