import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/runFoldWhileScoped";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/scoped";
import { constTrue } from "@tsplus/stdlib/data/Function";
/**
 * Executes a pure fold over the stream of values - reduces all elements in
 * the stream to a value of type `S`.
 *
 * @tsplus static effect/core/stream/Stream.Aspects runFold
 * @tsplus pipeable effect/core/stream/Stream runFold
 */

export function runFold(s, f) {
  return self => tsplus_module_2.scoped(tsplus_module_1.runFoldWhileScoped(s, constTrue, f)(self));
}
//# sourceMappingURL=runFold.mjs.map