import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/runFoldWhileScopedEffect";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/scoped";
import { constTrue } from "@tsplus/stdlib/data/Function";
/**
 * Executes a pure fold over the stream of values - reduces all elements in
 * the stream to a value of type `S`.
 *
 * @tsplus static effect/core/stream/Stream.Aspects runFoldEffect
 * @tsplus pipeable effect/core/stream/Stream runFoldEffect
 */

export function runFoldEffect(s, f) {
  return self => tsplus_module_2.scoped(tsplus_module_1.runFoldWhileScopedEffect(s, constTrue, f)(self));
}
//# sourceMappingURL=runFoldEffect.mjs.map