import * as tsplus_module_1 from "@effect/core/stream/Sink/operations/fold";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/runScoped";
/**
 * Executes a pure fold over the stream of values. Returns a scoped value
 * that represents the scope of the stream. Stops the fold early when the
 * condition is not fulfilled.
 *
 * @param cont A function which defines the early termination condition.
 *
 * @tsplus static effect/core/stream/Stream.Aspects runFoldWhileScoped
 * @tsplus pipeable effect/core/stream/Stream runFoldWhileScoped
 */

export function runFoldWhileScoped(s, cont, f) {
  return self => tsplus_module_2.runScoped(tsplus_module_1.fold(s, cont, f))(self);
}
//# sourceMappingURL=runFoldWhileScoped.mjs.map