import * as tsplus_module_1 from "@effect/core/stream/Sink/operations/foldEffect";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/runScoped";
/**
 * Executes an effectful fold over the stream of values. Returns a scoped
 * value that represents the scope of the stream. Stops the fold early when
 * the condition is not fulfilled.
 *
 * @param cont A function which defines the early termination condition.
 *
 * @tsplus static effect/core/stream/Stream.Aspects runFoldWhileScopedEffect
 * @tsplus pipeable effect/core/stream/Stream runFoldWhileScopedEffect
 */

export function runFoldWhileScopedEffect(s, cont, f) {
  return self => tsplus_module_2.runScoped(tsplus_module_1.foldEffect(s, cont, f))(self);
}
//# sourceMappingURL=runFoldWhileScopedEffect.mjs.map