import * as tsplus_module_1 from "@effect/core/stream/Sink/operations/forEachChunk";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/runScoped";
/**
 * Like `Stream.runForEachChunk`, but returns a scoped `Effect` so the
 * finalization order can be controlled.
 *
 * @tsplus static effect/core/stream/Stream.Aspects runForEachChunkScoped
 * @tsplus pipeable effect/core/stream/Stream runForEachChunkScoped
 */

export function runForEachChunkScoped(f) {
  return self => tsplus_module_2.runScoped(tsplus_module_1.forEachChunk(f))(self);
}
//# sourceMappingURL=runForEachChunkScoped.mjs.map