import * as tsplus_module_1 from "@effect/core/stream/Sink/operations/forEach";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/runScoped";
/**
 * Like `Stream.forEach`, but returns an `Effect` so the finalization
 * order can be controlled.
 *
 * @tsplus static effect/core/stream/Stream.Aspects runForEachScoped
 * @tsplus pipeable effect/core/stream/Stream runForEachScoped
 */

export function runForEachScoped(f) {
  return self => tsplus_module_2.runScoped(tsplus_module_1.forEach(f))(self);
}
//# sourceMappingURL=runForEachScoped.mjs.map