import * as tsplus_module_1 from "@effect/core/stream/Sink/operations/forEachWhile";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/runScoped";
/**
 * Like `Stream.runForEachWhile`, but returns a scoped `Effect` so the
 * finalization order can be controlled.
 *
 * @tsplus static effect/core/stream/Stream.Aspects runForEachWhileScoped
 * @tsplus pipeable effect/core/stream/Stream runForEachWhileScoped
 */

export function runForEachWhileScoped(f) {
  return self => tsplus_module_2.runScoped(tsplus_module_1.forEachWhile(f))(self);
}
//# sourceMappingURL=runForEachWhileScoped.mjs.map