import * as tsplus_module_1 from "@effect/core/stream/Take/operations/chunk";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_4 from "@effect/core/stream/Take/operations/failCause";
import * as tsplus_module_5 from "@effect/core/stream/Take/operations/end";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/readWithCause";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/mapOutEffect";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/drain";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/runScoped";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/unit";
import { concreteStream } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Like `Stream.runIntoQueue`, but provides the result as a scoped effect to
 * allow for scope composition.
 *
 * @tsplus static effect/core/stream/Stream.Aspects runIntoQueueScoped
 * @tsplus pipeable effect/core/stream/Stream runIntoQueueScoped
 */

export function runIntoQueueScoped(queue) {
  return self => {
    const writer = tsplus_module_6.readWithCause(input => tsplus_module_3.flatMap(() => writer)(tsplus_module_2.write(tsplus_module_1.chunk(input))), cause => tsplus_module_2.write(tsplus_module_4.failCause(cause)), () => tsplus_module_2.write(tsplus_module_5.end));
    void 0;
    return tsplus_module_11.asUnit(tsplus_module_10.runScoped(tsplus_module_9.drain(tsplus_module_8.mapOutEffect(take => queue.offer(take))(tsplus_module_7.pipeTo(writer)(self.channel)))));
  };
}
//# sourceMappingURL=runIntoQueueScoped.mjs.map