import * as tsplus_module_1 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/mapAccumEffect";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/flatMap";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Statefully and effectfully maps over the elements of this stream to produce
 * all intermediate results of type `S` given an initial S.
 *
 * @tsplus static effect/core/stream/Stream.Aspects scanEffect
 * @tsplus pipeable effect/core/stream/Stream scanEffect
 */

export function scanEffect(s, f) {
  return self => new StreamInternal(tsplus_module_5.flatMap(() => {
    const stream = tsplus_module_2.mapAccumEffect(s, (s, a) => tsplus_module_1.map(s => [s, s])(f(s, a)))(self);
    void 0;
    return stream.channel;
  })(tsplus_module_4.write(tsplus_module_3.single(s))));
}
//# sourceMappingURL=scanEffect.mjs.map