import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/scheduleWith";
/**
 * Schedules the output of the stream using the provided `schedule` and emits
 * its output at the end (if `schedule` is finite).
 *
 * @tsplus static effect/core/stream/Stream.Aspects scheduleEither
 * @tsplus pipeable effect/core/stream/Stream scheduleEither
 */

export function scheduleEither(schedule) {
  return self => tsplus_module_2.scheduleWith(schedule, a => tsplus_module_1.rightW(a), b => tsplus_module_1.leftW(b))(self);
}
//# sourceMappingURL=scheduleEither.mjs.map