import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_3 from "@effect/core/io/Schedule/operations/driver";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/Chunk/operations/make";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/orDie";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_11 from "@effect/core/io/Effect/operations/zipLeft";
import * as tsplus_module_12 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_13 from "@effect/core/io/Effect/operations/foldEffect";
import * as tsplus_module_14 from "@effect/core/stream/Channel/operations/unwrap";
import * as tsplus_module_15 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_16 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_17 from "@effect/core/stream/Channel/operations/readWithCause";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Schedules the output of the stream using the provided `schedule` and emits
 * its output at the end (if `schedule` is finite). Uses the provided function
 * to align the stream and schedule outputs on the same type.
 *
 * @tsplus static effect/core/stream/Stream.Aspects scheduleWith
 * @tsplus pipeable effect/core/stream/Stream scheduleWith
 */

export function scheduleWith(schedule, f, g) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_5.flatMap(driver => tsplus_module_2.pipeTo(loop(driver, tsplus_module_1.empty(), f, g, 0))(self.channel))(tsplus_module_4.fromEffect(tsplus_module_3.driver(schedule))));
  };
}

function loop(driver, chunk, f, g, index) {
  if (index < chunk.length) {
    const a = tsplus_module_6.unsafeGet(index)(chunk);
    const channel = tsplus_module_13.foldEffect(() => tsplus_module_11.zipLeft(driver.reset)(tsplus_module_10.map(b => tsplus_module_5.flatMap(() => loop(driver, chunk, f, g, index + 1))(tsplus_module_8.write(tsplus_module_7.make(f(a), g(b)))))(tsplus_module_9.orDie(driver.last))), () => tsplus_module_12.succeed(tsplus_module_5.flatMap(() => loop(driver, chunk, f, g, index + 1))(tsplus_module_8.write(tsplus_module_7.make(f(a))))))(driver.next(a));
    return tsplus_module_14.unwrap(channel);
  }

  return tsplus_module_17.readWithCause(chunk => loop(driver, chunk, f, g, 0), cause => tsplus_module_15.failCause(cause), tsplus_module_16.succeed);
}
//# sourceMappingURL=scheduleWith.mjs.map