import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/concat";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/splitWhere";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/Chunk/operations/drop";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_12 from "@tsplus/stdlib/collections/Chunk/operations/find";
import * as tsplus_module_13 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_14 from "@effect/core/stream/Channel/operations/readWith";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Splits elements based on a predicate.
 *
 * @tsplus static effect/core/stream/Stream.Aspects split
 * @tsplus pipeable effect/core/stream/Stream split
 */

export function split(f) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_2.pipeTo(loop(tsplus_module_1.empty(), f))(self.channel));
  };
}

function splitInternal(leftovers, input, f) {
  const [chunk, remaining] = tsplus_module_4.splitWhere(f)(tsplus_module_3.concat(input)(leftovers));
  return tsplus_module_5.isEmpty(chunk) || tsplus_module_5.isEmpty(remaining) ? loop(tsplus_module_3.concat(tsplus_module_6.drop(1)(remaining))(chunk), f) : tsplus_module_9.flatMap(() => splitInternal(tsplus_module_1.empty(), tsplus_module_6.drop(1)(remaining), f))(tsplus_module_8.write(tsplus_module_7.single(chunk)));
}

function loop(leftovers, f) {
  return tsplus_module_14.readWith(input => splitInternal(leftovers, input, f), err => tsplus_module_10.fail(err), () => tsplus_module_5.isEmpty(leftovers) ? tsplus_module_11.unit : tsplus_module_13.isNone(tsplus_module_12.find(f)(leftovers)) ? tsplus_module_9.flatMap(() => tsplus_module_11.unit)(tsplus_module_8.write(tsplus_module_7.single(leftovers))) : tsplus_module_9.flatMap(() => tsplus_module_11.unit)(splitInternal(tsplus_module_1.empty(), leftovers, f)));
}
//# sourceMappingURL=split.mjs.map