import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/builder";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Maybe/getOrElse";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/Chunk/operations/zipWithIndex";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/Chunk/operations/drop";
import * as tsplus_module_8 from "@tsplus/stdlib/collections/Chunk/operations/reduce";
import * as tsplus_module_9 from "@tsplus/stdlib/collections/Chunk/operations/forEach";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_12 from "@effect/core/stream/Channel/operations/failCause";
import * as tsplus_module_13 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_14 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_15 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_16 from "@effect/core/stream/Channel/operations/readWithCause";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Splits strings on newlines. Handles both Windows newlines (`\r\n`) and UNIX
 * newlines (`\n`).
 *
 * @tsplus static effect/core/stream/Stream.Ops splitLines
 */

export function splitLines(self) {
  void 0;
  return new StreamInternal(tsplus_module_2.pipeTo(next(tsplus_module_1.none, false))(self.channel));
}

function next(leftover, wasSplitCRLF) {
  return tsplus_module_16.readWithCause(incomingChunk => {
    const buffer = tsplus_module_3.builder();
    let inCRLF = wasSplitCRLF;
    let carry = tsplus_module_4.getOrElse_(leftover, () => "");
    tsplus_module_9.forEach(string => {
      const concatenated = carry + string;

      if (concatenated.length > 0) {
        // If we had a split CRLF, start reading from the last character of
        // the leftover, which was the '\r'. Otherwise we just skip over the
        // entire previous leftover, as it doesn't contain a newline.
        const continueFrom = inCRLF && carry.length > 0 ? carry.length - 1 : carry.length;
        const [sliceStart, _, midCRLF] = tsplus_module_8.reduce([0, false, inCRLF], ([sliceStart, skipNext, midCRLF], [char, index]) => {
          if (skipNext) {
            return [sliceStart, false, false];
          }

          switch (char) {
            case "\n":
              {
                buffer.append(concatenated.substring(sliceStart, index));
                return [index + 1, false, midCRLF];
              }

            case "\r":
              {
                if (index + 1 < concatenated.length && concatenated[index + 1] === "\n") {
                  buffer.append(concatenated.substring(sliceStart, index));
                  return [index + 2, true, false];
                }

                if (index === concatenated.length - 1) {
                  return [sliceStart, false, true];
                }

                return [sliceStart, false, false];
              }

            default:
              {
                return [sliceStart, false, midCRLF];
              }
          }
        })(tsplus_module_7.drop(continueFrom)(tsplus_module_6.zipWithIndex(tsplus_module_5.from(concatenated))));
        carry = concatenated.slice(sliceStart);
        inCRLF = midCRLF;
      }
    })(incomingChunk);
    return tsplus_module_11.flatMap(() => next(carry.length > 0 ? tsplus_module_1.some(carry) : tsplus_module_1.none, inCRLF))(tsplus_module_10.write(buffer.build()));
  }, cause => tsplus_module_14.fold(() => tsplus_module_12.failCause(cause), value => tsplus_module_11.flatMap(() => tsplus_module_12.failCause(cause))(tsplus_module_10.write(tsplus_module_13.single(value))))(leftover), done => tsplus_module_14.fold(() => tsplus_module_15.succeed(done), value => tsplus_module_11.flatMap(() => tsplus_module_15.succeed(done))(tsplus_module_10.write(tsplus_module_13.single(value))))(leftover));
}
//# sourceMappingURL=splitLines.mjs.map