import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/forEach";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/sync";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/unwrap";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
import { RingBufferNew } from "@effect/core/support/RingBufferNew";
/**
 * Takes the last specified number of elements from this stream.
 *
 * @tsplus static effect/core/stream/Stream.Aspects takeRight
 * @tsplus pipeable effect/core/stream/Stream takeRight
 */

export function takeRight(n) {
  return self => {
    if (n <= 0) {
      return tsplus_module_1.empty;
    }

    void 0;
    return new StreamInternal(tsplus_module_11.unwrap(tsplus_module_10.map(queue => {
      const reader = tsplus_module_7.readWith(input => {
        tsplus_module_2.forEach(a => queue.put(a))(input);
        return reader;
      }, err => tsplus_module_3.fail(err), () => tsplus_module_6.flatMap(() => tsplus_module_4.unit)(tsplus_module_5.write(queue.toChunk())));
      return tsplus_module_8.pipeTo(reader)(self.channel);
    })(tsplus_module_9.sync(() => new RingBufferNew(n)))));
  };
}
//# sourceMappingURL=takeRight.mjs.map