import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/takeWhile";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/drop";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/take";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/Chunk/operations/concat";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_10 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/pipeTo";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Takes all elements of the stream until the specified predicate evaluates to
 * `true`.
 *
 * @tsplus static effect/core/stream/Stream.Aspects takeUntil
 * @tsplus pipeable effect/core/stream/Stream takeUntil
 */

export function takeUntil(f) {
  return self => {
    const loop = tsplus_module_10.readWith(chunk => {
      const taken = tsplus_module_1.takeWhile(a => !f(a))(chunk);
      const last = tsplus_module_3.take(1)(tsplus_module_2.drop(taken.length)(chunk));
      return tsplus_module_4.isEmpty(last) ? tsplus_module_6.flatMap(() => loop)(tsplus_module_5.write(taken)) : tsplus_module_5.write(tsplus_module_7.concat(last)(taken));
    }, err => tsplus_module_8.fail(err), done => tsplus_module_9.succeed(done));
    void 0;
    return new StreamInternal(tsplus_module_11.pipeTo(loop)(self.channel));
  };
}
//# sourceMappingURL=takeUntil.mjs.map