import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/takeWhile";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/pipeTo";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Creates a pipeline that takes elements while the specified predicate
 * evaluates to `true`.
 *
 * @tsplus static effect/core/stream/Stream.Aspects takeWhile
 * @tsplus pipeable effect/core/stream/Stream takeWhile
 */

export function takeWhile(f) {
  return self => {
    const loop = tsplus_module_6.readWith(chunk => {
      const taken = tsplus_module_1.takeWhile(f)(chunk);
      const more = taken.length === chunk.length;
      return more ? tsplus_module_3.flatMap(() => loop)(tsplus_module_2.write(taken)) : tsplus_module_2.write(taken);
    }, err => tsplus_module_4.fail(err), done => tsplus_module_5.succeed(done));
    void 0;
    return new StreamInternal(tsplus_module_7.pipeTo(loop)(self.channel));
  };
}
//# sourceMappingURL=takeWhile.mjs.map