import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/fromEffect";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/fail";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/crossRight";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/catchAll";
/**
 * Returns a stream that effectfully "peeks" at the failure of the stream.
 *
 * @tsplus static effect/core/stream/Stream.Aspects tapError
 * @tsplus pipeable effect/core/stream/Stream tapError
 */

export function tapError(f) {
  return self => tsplus_module_4.catchAll(e => tsplus_module_3.crossRight(tsplus_module_2.fail(e))(tsplus_module_1.fromEffect(f(e))))(self);
}
//# sourceMappingURL=tapError.mjs.map