import * as tsplus_module_1 from "@effect/core/io/Effect/operations/failCause";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/zipRight";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/fromEffect";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/catchAllCause";
/**
 * Returns a stream that effectfully "peeks" at the cause of failure of the
 * stream.
 *
 * @tsplus static effect/core/stream/Stream.Aspects tapErrorCause
 * @tsplus pipeable effect/core/stream/Stream tapErrorCause
 */

export function tapErrorCause(f) {
  return self => tsplus_module_4.catchAllCause(e => tsplus_module_3.fromEffect(tsplus_module_2.zipRight(tsplus_module_1.failCause(e))(f(e))))(self);
}
//# sourceMappingURL=tapErrorCause.mjs.map