import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/fromQueueWithShutdown";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/flattenTake";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_4 from "@effect/core/stream/Take/operations/chunk";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_7 from "@effect/core/stream/Take/operations/failCause";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/readWithCause";
import * as tsplus_module_9 from "@effect/core/stream/Stream/operations/run";
import * as tsplus_module_10 from "@effect/core/stream/Stream/operations/execute";
import * as tsplus_module_11 from "@effect/core/stream/Stream/TerminationStrategy";
import * as tsplus_module_12 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_13 from "@effect/core/stream/Stream/operations/merge";
import * as tsplus_module_14 from "@effect/core/io/Queue/external/bounded";
import * as tsplus_module_15 from "@effect/core/stream/Stream/operations/fromEffect";
import * as tsplus_module_16 from "@effect/core/stream/Stream/operations/flatMap";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Sends all elements emitted by this stream to the specified sink in addition
 * to emitting them.
 *
 * @tsplus static effect/core/stream/Stream.Aspects tapSink
 * @tsplus pipeable effect/core/stream/Stream tapSink
 */

export function tapSink(sink) {
  return self => tsplus_module_16.flatMap(queue => {
    const right = tsplus_module_2.flattenTake(tsplus_module_1.fromQueueWithShutdown(queue, 1));
    const loop = tsplus_module_8.readWithCause(chunk => tsplus_module_6.flatMap(() => loop)(tsplus_module_6.flatMap(() => tsplus_module_3.write(chunk))(tsplus_module_5.fromEffect(queue.offer(tsplus_module_4.chunk(chunk))))), cause => tsplus_module_5.fromEffect(queue.offer(tsplus_module_7.failCause(cause))), () => tsplus_module_5.fromEffect(queue.shutdown));
    void 0;
    return tsplus_module_13.merge(tsplus_module_10.execute(tsplus_module_9.run(sink)(right)), tsplus_module_11.both)(new StreamInternal(tsplus_module_12.pipeTo(loop)(self.channel)));
  })(tsplus_module_15.fromEffect(tsplus_module_14.bounded(1)));
}
//# sourceMappingURL=tapSink.mjs.map