import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/throttleEnforceEffect";
/**
 * Throttles the chunks of this stream according to the given bandwidth
 * parameters using the token bucket algorithm. Allows for burst in the
 * processing of elements by allowing the token bucket to accumulate tokens up
 * to a `units + burst` threshold. Chunks that do not meet the bandwidth
 * constraints are dropped. The weight of each chunk is determined by the
 * `costFn` function.
 *
 * @tsplus static effect/core/stream/Stream.Aspects throttleEnforce
 * @tsplus pipeable effect/core/stream/Stream throttleEnforce
 */

export function throttleEnforce(units, duration, costFn, burst = 0) {
  return self => tsplus_module_2.throttleEnforceEffect(units, duration, input => tsplus_module_1.succeed(costFn(input)), burst)(self);
}
//# sourceMappingURL=throttleEnforce.mjs.map