import * as tsplus_module_1 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/throttleShapeEffect";
/**
 * Delays the chunks of this stream according to the given bandwidth
 * parameters using the token bucket algorithm. Allows for burst in the
 * processing of elements by allowing the token bucket to accumulate tokens up
 * to a `units + burst` threshold. The weight of each chunk is determined by
 * the `costFn` function.
 *
 * @tsplus static effect/core/stream/Stream.Aspects throttleShape
 * @tsplus pipeable effect/core/stream/Stream throttleShape
 */

export function throttleShape(units, duration, costFn, burst = 0) {
  return self => tsplus_module_2.throttleShapeEffect(units, duration, input => tsplus_module_1.succeed(costFn(input)), burst)(self);
}
//# sourceMappingURL=throttleShape.mjs.map