var _a;

import * as tsplus_module_1 from "@effect/core/io/Cause/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/timeoutFailCause";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/catchSomeCause";
export const StreamTimeoutErrorSym = /*#__PURE__*/Symbol.for("@effect/core/stream/Stream/StreamTimeoutError");
export class StreamTimeoutError {
  constructor(message) {
    this.message = message;
    this[_a] = "StreamTimeoutError";
  }

}
_a = StreamTimeoutErrorSym;
export function isStreamTimeoutError(u) {
  return u instanceof StreamTimeoutError && u[StreamTimeoutErrorSym] === "StreamTimeoutError";
}
/**
 * Switches the stream if it does not produce a value after the spcified
 * duration.
 *
 * @tsplus static effect/core/stream/Stream.Aspects timeoutTo
 * @tsplus pipeable effect/core/stream/Stream timeoutTo
 */

export function timeoutTo(duration, that) {
  return self => tsplus_module_4.catchSomeCause(cause => tsplus_module_1.isDieType(cause) && isStreamTimeoutError(cause.value) ? tsplus_module_2.some(that) : tsplus_module_2.none)(tsplus_module_3.timeoutFailCause(() => tsplus_module_1.die(new StreamTimeoutError()), duration)(self));
}
//# sourceMappingURL=timeoutTo.mjs.map