import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/runIntoHubScoped";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/forkScoped";
import * as tsplus_module_3 from "@effect/core/io/Hub/operations/bounded";
import * as tsplus_module_4 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/tap";
/**
 * Converts the stream to a scoped hub of chunks. After the scope is closed,
 * the hub will never again produce values and should be discarded.
 *
 * @tsplus static effect/core/stream/Stream.Aspects toHub
 * @tsplus pipeable effect/core/stream/Stream toHub
 */

export function toHub(capacity) {
  return self => tsplus_module_5.tap(hub => tsplus_module_2.forkScoped(tsplus_module_1.runIntoHubScoped(hub)(self)))(tsplus_module_4.acquireRelease(tsplus_module_3.bounded(capacity), hub => hub.shutdown));
}
//# sourceMappingURL=toHub.mjs.map