import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/runIntoQueueScoped";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/forkScoped";
import * as tsplus_module_3 from "@effect/core/io/Queue/external/bounded";
import * as tsplus_module_4 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/tap";
/**
 * Converts the stream to a scoped queue of chunks. After the scope is closed,
 * the queue will never again produce values and should be discarded.
 *
 * @tsplus static effect/core/stream/Stream.Aspects toQueue
 * @tsplus pipeable effect/core/stream/Stream toQueue
 */

export function toQueue(capacity = 2) {
  return self => tsplus_module_5.tap(queue => tsplus_module_2.forkScoped(tsplus_module_1.runIntoQueueScoped(queue)(self)))(tsplus_module_4.acquireRelease(tsplus_module_3.bounded(capacity), queue => queue.shutdown));
}
//# sourceMappingURL=toQueue.mjs.map