import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/runIntoQueueElementsScoped";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/forkScoped";
import * as tsplus_module_3 from "@effect/core/io/Queue/external/bounded";
import * as tsplus_module_4 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/tap";
/**
 * Converts the stream to a scoped queue of elements. After the scope is
 * closed, the queue will never again produce values and should be discarded.
 *
 * @tsplus static effect/core/stream/Stream.Aspects toQueueOfElements
 * @tsplus pipeable effect/core/stream/Stream toQueueOfElements
 */

export function toQueueOfElements(capacity = 2) {
  return self => tsplus_module_5.tap(queue => tsplus_module_2.forkScoped(tsplus_module_1.runIntoQueueElementsScoped(queue)(self)))(tsplus_module_4.acquireRelease(tsplus_module_3.bounded(capacity), queue => queue.shutdown));
}
//# sourceMappingURL=toQueueOfElements.mjs.map