import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/runIntoQueueScoped";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/forkScoped";
import * as tsplus_module_3 from "@effect/core/io/Queue/operations/unbounded";
import * as tsplus_module_4 from "@effect/core/io/Fiber/_internal/runtime";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/tap";
/**
 * Converts the stream into an unbounded scoped queue. After the scope is
 * closed, the queue will never again produce values and should be discarded.
 *
 * @tsplus getter effect/core/stream/Stream toQueueUnbounded
 */

export function toQueueUnbounded(self) {
  return tsplus_module_5.tap(queue => tsplus_module_2.forkScoped(tsplus_module_1.runIntoQueueScoped(queue)(self)))(tsplus_module_4.acquireRelease(tsplus_module_3.unbounded(), queue => queue.shutdown));
}
//# sourceMappingURL=toQueueUnbounded.mjs.map