import * as tsplus_module_1 from "@tsplus/stdlib/data/AtomicReference";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_3 from "@tsplus/stdlib/data/AtomicBoolean";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_5 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/succeed";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/sync";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/readWith";
import * as tsplus_module_10 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_11 from "@effect/core/stream/Channel/operations/writeChunk";
import * as tsplus_module_12 from "@effect/core/stream/Channel/operations/suspend";
import * as tsplus_module_13 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_14 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_15 from "@effect/core/stream/Channel/operations/doneCollect";
import * as tsplus_module_16 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_17 from "@effect/core/stream/Channel/operations/pipeToOrFail";
import * as tsplus_module_18 from "@tsplus/stdlib/collections/Chunk/operations/isNonEmpty";
import * as tsplus_module_19 from "@tsplus/stdlib/collections/Chunk/operations/filter";
import * as tsplus_module_20 from "@tsplus/stdlib/collections/Chunk/operations/concat";
import { concreteSink } from "@effect/core/stream/Sink/operations/_internal/SinkInternal";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Applies the transducer to the stream and emits its outputs.
 *
 * @tsplus static effect/core/stream/Stream.Aspects fromSink
 * @tsplus pipeable effect/core/stream/Stream transduce
 */

export function transduce(sink) {
  return self => {
    void 0;
    return new StreamInternal(tsplus_module_12.suspend(() => {
      const leftovers = new tsplus_module_1.AtomicReference(tsplus_module_2.empty());
      const upstreamDone = new tsplus_module_3.AtomicBoolean(false);
      const upstreamMarker = tsplus_module_9.readWith(chunk => tsplus_module_5.flatMap(() => upstreamMarker)(tsplus_module_4.write(chunk)), err => tsplus_module_6.fail(err), done => tsplus_module_5.flatMap(() => tsplus_module_7.succeed(done))(tsplus_module_8.sync(() => upstreamDone.set(true))));
      const buffer = tsplus_module_12.suspend(() => {
        const leftover = leftovers.get;

        if (tsplus_module_10.isEmpty(leftover)) {
          return tsplus_module_9.readWith(chunk => tsplus_module_5.flatMap(() => buffer)(tsplus_module_4.write(chunk)), err => tsplus_module_6.fail(err), done => tsplus_module_7.succeed(done));
        }

        leftovers.set(tsplus_module_2.empty());
        return tsplus_module_5.flatMap(() => buffer)(tsplus_module_11.writeChunk(leftover));
      });
      void 0;
      const transducer = tsplus_module_5.flatMap(([leftover, z]) => tsplus_module_5.flatMap(([done, newLeftovers]) => {
        const nextChannel = done && tsplus_module_10.isEmpty(newLeftovers) ? tsplus_module_13.unit : transducer;
        return tsplus_module_5.flatMap(() => nextChannel)(tsplus_module_4.write(tsplus_module_14.single(z)));
      })(tsplus_module_8.sync(() => [upstreamDone.get, concatAndGet(leftovers, leftover)])))(tsplus_module_15.doneCollect(sink.channel));
      return tsplus_module_16.pipeTo(tsplus_module_17.pipeToOrFail(transducer)(buffer))(tsplus_module_16.pipeTo(upstreamMarker)(self.channel));
    }));
  };
}

function concatAndGet(leftovers, chunk) {
  const ls = leftovers.get;
  const concat = tsplus_module_20.concat(tsplus_module_19.filter(c => tsplus_module_18.isNonEmpty(c))(chunk))(ls);
  leftovers.set(concat);
  return concat;
}
//# sourceMappingURL=transduce.mjs.map