import * as tsplus_module_1 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/unwrapScoped";
import * as tsplus_module_3 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_4 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_5 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/fromEffect";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/readWith";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Transduce a stream using a chunk processing function.
 *
 * @tsplus static effect/core/stream/Stream.Ops transducePush
 */

export function transducePush(push) {
  return stream => {
    const channel = tsplus_module_2.unwrapScoped(tsplus_module_1.map(push => pull(push))(push));
    void 0;
    return new StreamInternal(tsplus_module_3.pipeTo(channel)(stream.channel));
  };
}

function pull(push) {
  return tsplus_module_9.readWith(input => tsplus_module_7.flatMap(() => pull(push))(tsplus_module_7.flatMap(out => tsplus_module_4.write(out))(tsplus_module_6.fromEffect(push(tsplus_module_5.some(input))))), err => tsplus_module_8.fail(err), () => tsplus_module_7.flatMap(out => tsplus_module_4.write(out))(tsplus_module_6.fromEffect(push(tsplus_module_5.none))));
}
//# sourceMappingURL=transducePush.mjs.map