import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/take";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/drop";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/via";
import { Utf8 } from "@effect/core/stream/Stream/operations/_internal/bom";
import { utf8DecodeNoBom } from "@effect/core/stream/Stream/operations/_internal/utf8DecodeNoBom";
import { utfDecodeDetectingBom } from "@effect/core/stream/Stream/operations/_internal/utfDecodeDetectingBom"; // TODO(Mike/Max): look into utf16 and utf32 encodings

/**
 * Determines the right encoder to use based on the Byte Order Mark (BOM). If it
 * doesn't detect one, it defaults to utf8Decode.
 *
 * @tsplus getter effect/core/stream/Stream utfDecode
 */

export function utfDecode(self) {
  return tsplus_module_4.via(utfDecodeDetectingBom(4, bytes => tsplus_module_2.corresponds_(tsplus_module_1.take(3)(bytes), Utf8, (a, b) => a === b) ? [tsplus_module_3.drop(3)(bytes), utf8DecodeNoBom] : [bytes, utf8DecodeNoBom]))(self);
}
//# sourceMappingURL=utfDecode.mjs.map