import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/zipWith";
/**
 * Zips this stream with another point-wise and emits tuples of elements from
 * both streams.
 *
 * The new stream will end when one of the sides ends.
 *
 * @tsplus static effect/core/stream/Stream.Aspects zip
 * @tsplus pipeable effect/core/stream/Stream zip
 */

export function zip(that) {
  return self => tsplus_module_1.zipWith(that, (a, a2) => [a, a2])(self);
}
//# sourceMappingURL=zip.mjs.map