import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/zipAllWith";
/**
 * Zips this stream with another point-wise, creating a new stream of pairs of
 * elements from both sides.
 *
 * The defaults `defaultLeft` and `defaultRight` will be used if the streams
 * have different lengths and one of the streams has ended before the other.
 *
 * @tsplus static effect/core/stream/Stream.Aspects zipAllFlatten
 * @tsplus pipeable effect/core/stream/Stream zipAllFlatten
 */

export function zipAllFlatten(that, defaultLeft, defaultRight) {
  return self => tsplus_module_1.zipAllWith(that, a => [...a, defaultRight], a2 => [...defaultLeft, a2], (a, a2) => [...a, a2])(self);
}
//# sourceMappingURL=zipAllFlatten.mjs.map