import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/zipWithChunks";
import { zipRightChunks } from "@effect/core/stream/Stream/operations/_internal/zipRightChunks";
/**
 * Zips this stream with another point-wise, but keeps only the outputs of the
 * other stream.
 *
 * The new stream will end when one of the sides ends.
 *
 * @tsplus static effect/core/stream/Stream.Aspects zipRight
 * @tsplus pipeable effect/core/stream/Stream zipRight
 */

export function zipRight(that) {
  return self => tsplus_module_1.zipWithChunks(that, zipRightChunks)(self);
}
//# sourceMappingURL=zipRight.mjs.map