import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/zipWithChunks";
import { zipChunks } from "@effect/core/stream/Stream/operations/_internal/zipChunks";
/**
 * Zips this stream with another point-wise and applies the function to the
 * paired elements.
 *
 * The new stream will end when one of the sides ends.
 *
 * @tsplus static effect/core/stream/Stream.Aspects zipWith
 * @tsplus pipeable effect/core/stream/Stream zipWith
 */

export function zipWith(that, f) {
  return self => tsplus_module_1.zipWithChunks(that, (leftChunk, rightChunk) => zipChunks(leftChunk, rightChunk, f))(self);
}
//# sourceMappingURL=zipWith.mjs.map