import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/size";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/map";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/fromChunk";
import * as tsplus_module_5 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_6 from "@effect/core/stream/Stream/operations/repeatEffectMaybe";
import * as tsplus_module_7 from "@effect/core/stream/Stream/operations/mergeEither";
import * as tsplus_module_8 from "@effect/core/stream/Stream/operations/mapEffect";
import * as tsplus_module_9 from "@effect/core/stream/Stream/operations/flatMap";
import * as tsplus_module_10 from "@effect/core/stream/Stream/operations/concat";
import * as tsplus_module_11 from "@effect/core/io/Ref/operations/make";
import * as tsplus_module_12 from "@effect/core/stream/Stream/operations/fromEffect";
import * as tsplus_module_13 from "@effect/core/io/Fiber/operations/join";
import * as tsplus_module_14 from "@effect/core/io/Effect/operations/done";
import * as tsplus_module_15 from "@effect/core/io/Effect/operations/zipWith";
import * as tsplus_module_16 from "@effect/core/io/Effect/operations/raceWith";
import * as tsplus_module_17 from "@effect/core/stream/Stream/operations/fromEffectMaybe";
import * as tsplus_module_18 from "@effect/core/stream/Stream/operations/toPull";
import * as tsplus_module_19 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_20 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_21 from "@effect/core/stream/Stream/operations/fromPull";
import * as tsplus_module_22 from "@tsplus/stdlib/collections/Chunk/operations/isEmpty";
import * as tsplus_module_23 from "@effect/core/io/Effect/operations/succeed";
/**
 * Zips the two streams so that when a value is emitted by either of the two
 * streams, it is combined with the latest value from the other stream to
 * produce a result.
 *
 * Note: tracking the latest value is done on a per-chunk basis. That means
 * that emitted elements that are not the last value in chunks will never be
 * used for zipping.
 *
 * @tsplus static effect/core/stream/Stream.Aspects zipWithLatest
 * @tsplus pipeable effect/core/stream/Stream zipWithLatest
 */

export function zipWithLatest(that, f) {
  return self => tsplus_module_21.fromPull(tsplus_module_20.flatMap(left => tsplus_module_20.flatMap(right => tsplus_module_18.toPull(tsplus_module_9.flatMap(([l, r, leftFirst]) => tsplus_module_9.flatMap(latest => tsplus_module_10.concat(tsplus_module_9.flatMap(chunk => tsplus_module_4.fromChunk(chunk))(tsplus_module_8.mapEffect(either => tsplus_module_5.fold(leftChunk => latest.modify(([_, rightLatest]) => [tsplus_module_3.map(a => f(a, rightLatest))(leftChunk), [tsplus_module_2.unsafeGet(tsplus_module_1.size(leftChunk) - 1)(leftChunk), rightLatest]]), rightChunk => latest.modify(([leftLatest, _]) => [tsplus_module_3.map(a2 => f(leftLatest, a2))(rightChunk), [leftLatest, tsplus_module_2.unsafeGet(tsplus_module_1.size(rightChunk) - 1)(rightChunk)]]))(either))(tsplus_module_7.mergeEither(tsplus_module_6.repeatEffectMaybe(right))(tsplus_module_6.repeatEffectMaybe(left)))))(tsplus_module_4.fromChunk(leftFirst ? tsplus_module_3.map(a2 => f(tsplus_module_2.unsafeGet(tsplus_module_1.size(l) - 1)(l), a2))(r) : tsplus_module_3.map(a => f(a, tsplus_module_2.unsafeGet(tsplus_module_1.size(r) - 1)(r)))(l))))(tsplus_module_12.fromEffect(tsplus_module_11.makeRef(() => [tsplus_module_2.unsafeGet(tsplus_module_1.size(l) - 1)(l), tsplus_module_2.unsafeGet(tsplus_module_1.size(r) - 1)(r)]))))(tsplus_module_17.fromEffectMaybe(tsplus_module_16.raceWith(right, (leftDone, rightFiber) => tsplus_module_15.zipWith(tsplus_module_13.join(rightFiber), (left, right) => [left, right, true])(tsplus_module_14.done(leftDone)), (rightDone, leftFiber) => tsplus_module_15.zipWith(tsplus_module_13.join(leftFiber), (right, left) => [left, right, false])(tsplus_module_14.done(rightDone)))(left)))))(tsplus_module_19.map(pullNonEmpty)(tsplus_module_18.toPull(that))))(tsplus_module_19.map(pullNonEmpty)(tsplus_module_18.toPull(self))));
}

function pullNonEmpty(pull) {
  return tsplus_module_20.flatMap(chunk => tsplus_module_22.isEmpty(chunk) ? pullNonEmpty(pull) : tsplus_module_23.succeed(chunk))(pull);
}
//# sourceMappingURL=zipWithLatest.mjs.map