import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/stream/Channel/operations/pipeTo";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/map";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/mapAccum";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/collect";
import * as tsplus_module_6 from "@effect/core/stream/Channel/operations/write";
import * as tsplus_module_7 from "@effect/core/stream/Channel/operations/flatMap";
import * as tsplus_module_8 from "@effect/core/stream/Channel/operations/fail";
import * as tsplus_module_9 from "@effect/core/stream/Channel/operations/unit";
import * as tsplus_module_10 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_11 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_12 from "@effect/core/stream/Channel/operations/readWith";
import { concreteStream, StreamInternal } from "@effect/core/stream/Stream/operations/_internal/StreamInternal";
/**
 * Zips each element with the next element if present.
 *
 * @tsplus getter effect/core/stream/Stream zipWithNext
 */

export function zipWithNext(self) {
  void 0;
  return new StreamInternal(tsplus_module_2.pipeTo(process(tsplus_module_1.none))(self.channel));
}

function process(last) {
  return tsplus_module_12.readWith(input => {
    const [newLast, chunk] = tsplus_module_4.mapAccum(last, (prev, curr) => [tsplus_module_1.some(curr), tsplus_module_3.map(a => [a, curr])(prev)])(input);
    const out = tsplus_module_5.collect(option => tsplus_module_1.isSome(option) ? tsplus_module_1.some([option.value[0], tsplus_module_1.some(option.value[1])]) : tsplus_module_1.none)(chunk);
    return tsplus_module_7.flatMap(() => process(newLast))(tsplus_module_6.write(out));
  }, err => tsplus_module_8.fail(err), () => tsplus_module_11.fold(() => tsplus_module_9.unit, a => tsplus_module_7.flatMap(() => tsplus_module_9.unit)(tsplus_module_6.write(tsplus_module_10.single([a, tsplus_module_1.none]))))(last));
}
//# sourceMappingURL=zipWithNext.mjs.map