import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/make";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/concat";
import * as tsplus_module_3 from "@effect/core/stream/Stream/operations/fromHubScoped";
import * as tsplus_module_4 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/stm/TSemaphore/operations/withPermit";
import * as tsplus_module_7 from "@effect/core/stream/Stream/operations/unwrapScoped";
import * as tsplus_module_8 from "@effect/core/io/Effect/operations/as";
import * as tsplus_module_9 from "@effect/core/io/Effect/operations/tap";
import * as tsplus_module_10 from "@effect/core/io/Effect/operations/succeed";
import * as tsplus_module_11 from "@tsplus/stdlib/data/Maybe/getOrElse";
import * as tsplus_module_12 from "@effect/core/io/Effect/operations/sync";
import { _A, RefSym, SynchronizedSym } from "@effect/core/io/Ref/definition";
import { SubscriptionRefSym } from "@effect/core/stream/SubscriptionRef/definition";
export class SubscriptionRefInternal {
  get [RefSym]() {
    return RefSym;
  }

  get [SynchronizedSym]() {
    return SynchronizedSym;
  }

  get [SubscriptionRefSym]() {
    return SubscriptionRefSym;
  }

  get [_A]() {
    return a => a;
  }

  constructor(ref, hub, semaphore) {
    this.ref = ref;
    this.hub = hub;
    this.semaphore = semaphore;
  }

  get changes() {
    return tsplus_module_7.unwrapScoped(tsplus_module_6.withPermit(this.semaphore)(tsplus_module_5.flatMap(a => tsplus_module_4.map(stream => tsplus_module_2.concat(stream)(tsplus_module_1.make(a)))(tsplus_module_3.fromHubScoped(this.hub)))(this.ref.get)));
  }

  modifyEffect(f) {
    return tsplus_module_6.withPermit(this.semaphore)(tsplus_module_5.flatMap(tp => {
      const [b, a] = tp;
      return tsplus_module_9.tap(() => this.hub.publish(a))(tsplus_module_8.as(b)(this.ref.set(a)));
    })(tsplus_module_5.flatMap(f)(this.get)));
  }

  getAndUpdateEffect(f) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [v, result])(f(v)));
  }

  getAndUpdateSomeEffect(pf) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [v, result])(tsplus_module_11.getOrElse_(pf(v), () => tsplus_module_10.succeed(v))));
  }

  modifySomeEffect(fallback, pf) {
    return this.modifyEffect(v => tsplus_module_11.getOrElse_(pf(v), () => tsplus_module_10.succeed([fallback, v])));
  }

  updateEffect(f) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [undefined, result])(f(v)));
  }

  updateAndGetEffect(f) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [result, result])(f(v)));
  }

  updateSomeEffect(pf) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [undefined, result])(tsplus_module_11.getOrElse_(pf(v), () => tsplus_module_10.succeed(v))));
  }

  updateSomeAndGetEffect(pf) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [result, result])(tsplus_module_11.getOrElse_(pf(v), () => tsplus_module_10.succeed(v))));
  }

  get get() {
    return this.ref.get;
  }

  modify(f) {
    return this.modifyEffect(a => tsplus_module_12.sync(() => f(a)));
  }

  set(a) {
    return tsplus_module_6.withPermit(this.semaphore)(tsplus_module_9.tap(() => this.hub.publish(a))(this.ref.set(a)));
  }

  getAndSet(a) {
    return this.modify(v => [v, a]);
  }

  getAndUpdate(f) {
    return this.modify(v => [v, f(v)]);
  }

  getAndUpdateSome(pf) {
    return this.modify(v => [v, tsplus_module_11.getOrElse_(pf(v), () => v)]);
  }

  modifySome(fallback, pf) {
    return this.modify(v => tsplus_module_11.getOrElse_(pf(v), () => [fallback, v]));
  }

  update(f) {
    return this.modify(v => [undefined, f(v)]);
  }

  updateAndGet(f) {
    return this.modify(v => {
      const result = f(v);
      return [result, result];
    });
  }

  updateSome(pf) {
    return this.modify(v => [undefined, tsplus_module_11.getOrElse_(pf(v), () => v)]);
  }

  updateSomeAndGet(pf) {
    return this.modify(v => {
      const result = tsplus_module_11.getOrElse_(pf(v), () => v);
      return [result, result];
    });
  }

}
//# sourceMappingURL=SubscriptionRefInternal.mjs.map