import * as tsplus_module_1 from "@effect/core/io/Cause/operations/flipCauseMaybe";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_3 from "@effect/core/io/Exit/operations/foldEffect";
import { concreteTake } from "@effect/core/stream/Take/operations/_internal/TakeInternal";
/**
 * Effectful version of `Take.fold`.
 *
 * Folds over the failure cause, success value and end-of-stream marker to
 * yield an effect.
 *
 * @tsplus static effect/core/stream/Take.Aspects foldEffect
 * @tsplus pipeable effect/core/stream/Take foldEffect
 */

export function foldEffect(end, error, value) {
  return self => {
    void 0;
    return tsplus_module_3.foldEffect(cause => tsplus_module_2.fold(() => end, error)(tsplus_module_1.flipCauseMaybe(cause)), value)(self._exit);
  };
}
//# sourceMappingURL=foldEffect.mjs.map