import * as tsplus_module_1 from "@effect/core/stream/Take/operations/end";
import * as tsplus_module_2 from "@effect/core/stream/Take/operations/failCause";
import * as tsplus_module_3 from "@effect/core/io/Cause/operations/flipCauseMaybe";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_5 from "@effect/core/stream/Take/operations/chunk";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/foldCause";
/**
 * Creates effect from `Pull<R, E, A>` that does not fail, but succeeds with the
 * `Take<E, A>`. Any error returned from stream when pulling is converted to
 * `Take.failCause`, and the end of stream to `Take.end`.
 *
 * @tsplus static effect/core/stream/Take.Ops fromPull
 */

export function fromPull(pull) {
  return tsplus_module_6.foldCause(cause => tsplus_module_4.fold(() => tsplus_module_1.end, tsplus_module_2.failCause)(tsplus_module_3.flipCauseMaybe(cause)), tsplus_module_5.chunk)(pull);
}
//# sourceMappingURL=fromPull.mjs.map