import * as tsplus_module_1 from "@effect/core/io/Cause/errors";
import * as tsplus_module_2 from "@effect/core/io/Effect/operations/dieSync";
import * as tsplus_module_3 from "@effect/core/testing/Sample/operations/shrinkIntegral";
import * as tsplus_module_4 from "@effect/core/io/Random/operations/nextIntBetween";
import * as tsplus_module_5 from "@effect/core/io/Effect/operations/map";
import * as tsplus_module_6 from "@effect/core/io/Effect/operations/suspendSucceed";
import * as tsplus_module_7 from "@effect/core/testing/Gen/operations/fromEffectSample";
/**
 * A generator of integers inside the specified range: [start, end]. The
 * shrinker will shrink toward the lower end of the range ("smallest").
 *
 * @tsplus static effect/core/testing/Gen.Ops int
 */

export function int(constraints = {}) {
  return tsplus_module_7.fromEffectSample(tsplus_module_6.suspendSucceed(() => {
    const min = constraints.min ?? Number.MIN_SAFE_INTEGER;
    const max = constraints.max ?? Number.MAX_SAFE_INTEGER;
    return min > max || min < Number.MIN_SAFE_INTEGER || max > Number.MAX_SAFE_INTEGER ? tsplus_module_2.dieSync(() => new tsplus_module_1.IllegalArgumentException("invalid bounds")) : tsplus_module_5.map(tsplus_module_3.shrinkIntegral(min))(tsplus_module_4.nextIntBetween(min, max));
  }));
}
//# sourceMappingURL=int.mjs.map