import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/map";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/map";
import * as tsplus_module_3 from "@effect/core/testing/Gen/definition";
/**
 * Discards the shrinker for this generator and applies a new shrinker by
 * mapping each value to a sample using the specified function. This is useful
 * when the process to shrink a value is simpler than the process used to
 * generate it.
 *
 * @tsplus static effect/core/testing/Gen.Aspects reshrink
 * @tsplus pipeable effect/core/testing/Gen reshrink
 */

export function reshrink(f) {
  return self => tsplus_module_3.Gen(tsplus_module_2.map(maybe => tsplus_module_1.map(sample => f(sample.value))(maybe))(self.sample));
}
//# sourceMappingURL=reshrink.mjs.map