import * as tsplus_module_1 from "@effect/core/testing/Gen/operations/exponential";
import * as tsplus_module_2 from "@effect/core/testing/Gen/operations/map";
import * as tsplus_module_3 from "@effect/core/testing/Gen/operations/size";
import * as tsplus_module_4 from "@effect/core/testing/Gen/operations/flatMap";
import * as tsplus_module_5 from "@effect/core/testing/Sample/operations/shrinkIntegral";
import * as tsplus_module_6 from "@effect/core/testing/Gen/operations/reshrink";
import { clamp } from "@effect/core/testing/_internal/math";
/**
 * A sized generator that uses an exponential distribution of size values. The
 * values generated will be strongly concentrated towards the lower end of the
 * range but a few larger values will still be generated.
 *
 * @tsplus static effect/core/testing/Gen.Ops small
 */

export function small(f, min = 0) {
  const gen = tsplus_module_4.flatMap(max => tsplus_module_2.map(n => clamp(Math.round(n * max / 10.0), min, max))(tsplus_module_1.exponential))(tsplus_module_3.size);
  return tsplus_module_4.flatMap(f)(tsplus_module_6.reshrink(tsplus_module_5.shrinkIntegral(min))(gen));
}
//# sourceMappingURL=small.mjs.map