import * as tsplus_module_1 from "@tsplus/stdlib/collections/SortedMap/set";
import * as tsplus_module_2 from "@tsplus/stdlib/prelude/Ord/common";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/SortedMap/empty";
import * as tsplus_module_4 from "@tsplus/stdlib/exceptions";
import * as tsplus_module_5 from "@tsplus/stdlib/data/Maybe/getOrElse";
import * as tsplus_module_6 from "@effect/core/testing/Gen/operations/uniform";
import * as tsplus_module_7 from "@effect/core/testing/Gen/operations/flatMap";
import * as tsplus_module_8 from "@tsplus/stdlib/data/Maybe/definition";
import { concreteSortedMap } from "@tsplus/stdlib/collections/SortedMap/_internal/SortedMapInternal";
/**
 * A generator which chooses one of the given generators according to their
 * weights. For example, the following generator will generate 90% true and
 * 10% false values.
 *
 * @tsplus static effect/core/testing/Gen.Ops weighted
 */

export function weighted(...gens) {
  const sum = gens.reduce((acc, [_, n]) => acc + n, 0);
  const [map, _] = gens.reduce(([map, acc], [gen, d]) => (acc + d) / sum > acc / sum ? [tsplus_module_1.set((acc + d) / sum, gen)(map), acc + d] : [map, acc], [tsplus_module_3.empty(tsplus_module_2.number), 0]);
  return tsplus_module_7.flatMap(n => tsplus_module_5.getOrElse_(getGreaterThanEqual(map, n), () => {
    throw new tsplus_module_4.NoSuchElement();
  }))(tsplus_module_6.uniform());
}

function getGreaterThanEqual(map, key) {
  void 0;
  const cmp = map.tree.ord.compare;
  let n = map.tree.root;
  let lastValue = tsplus_module_8.empty();

  while (n) {
    const d = cmp(key, n.key);

    if (d <= 0) {
      lastValue = tsplus_module_8.some(n.value);
      n = n.left;
    } else {
      if (lastValue._tag === "Some") {
        break;
      }

      n = n.right;
    }
  }

  return lastValue;
}
//# sourceMappingURL=weighted.mjs.map