import * as tsplus_module_1 from "@tsplus/stdlib/service/Tag";
import * as tsplus_module_2 from "@effect/core/io/DefaultServices/definition";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/environmentWith";
import * as tsplus_module_4 from "@effect/core/io/Layer/operations/fromEffect";
import * as tsplus_module_5 from "@effect/core/io/Fiber/_internal/runtime";
export const live = live_1;
export const Live = {
  Tag: /*#__PURE__*/tsplus_module_1.Tag()
};
/**
 * Constructs a new `Live` service that implements the `Live` interface. This
 * typically should not be necessary as the `TestEnvironment` already includes
 * the `Live` service but could be useful if you are mixing in interfaces to
 * create your own environment type.
 *
 * @tsplus static effect/core/testing/Live.Ops default
 */

export const defaultLive = /*#__PURE__*/tsplus_module_4.fromEffect(Live.Tag)( /*#__PURE__*/tsplus_module_3.environmentWith(env => ({
  provide: effect => tsplus_module_2.currentServices.locallyWith(_ => _.merge(env))(effect)
})));
/**
 * Provides a workflow with the "live" default ZIO services.
 *
 * @tsplus static effect/core/testing/Live.Ops live
 */

function live_1(effect) {
  return tsplus_module_5.serviceWithEffect(Live.Tag, live => live.provide(effect));
}
/**
 * Runs a transformation function with the live default Effect services while
 * ensuring that the workflow itself is run with the test services.
 *
 * @tsplus static effect/core/testing/Live.Ops withLive
 */


export function withLive(effect, f) {
  return tsplus_module_2.currentServices.getWith(services => live_1(f(tsplus_module_2.currentServices.locally(services)(effect))));
}
//# sourceMappingURL=Live.mjs.map