import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/unfold";
import * as tsplus_module_3 from "@effect/core/testing/Sample/operations/unfold";
/**
 * @tsplus static effect/core/testing/Sample.Ops shrinkBigInt
 */

export function shrinkBigInt(smallest) {
  return a => tsplus_module_3.unfold(a, max => [max, tsplus_module_2.unfold(smallest, min => {
    const mid = min + (max - min) / BigInt(2);

    if (mid === max) {
      return tsplus_module_1.none;
    } else if (bigIntAbs(max - mid) === BigInt(1)) {
      return tsplus_module_1.some([mid, max]);
    } else {
      return tsplus_module_1.some([mid, mid]);
    }
  })]);
}

function bigIntAbs(x) {
  return x < BigInt(0) ? -x : x;
}
//# sourceMappingURL=shrinkBigInt.mjs.map