import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@effect/core/stream/Stream/operations/unfold";
import * as tsplus_module_3 from "@effect/core/testing/Sample/operations/unfold";
/**
 * @tsplus static effect/core/testing/Sample.Ops shrinkFractional
 */

export function shrinkFractional(smallest) {
  return a => tsplus_module_3.unfold(a, max => [max, tsplus_module_2.unfold(smallest, min => {
    const mid = min + (max - min) / 2;

    if (mid === max) {
      return tsplus_module_1.none;
    } else if (Math.abs(max - mid) < 0.001) {
      return tsplus_module_1.some([min, max]);
    } else {
      return tsplus_module_1.some([mid, mid]);
    }
  })]);
}
//# sourceMappingURL=shrinkFractional.mjs.map