import * as tsplus_module_1 from "@effect/core/stream/Stream/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/map";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/getOrElse";
import * as tsplus_module_4 from "@effect/core/stream/Stream/operations/takeUntil";
import * as tsplus_module_5 from "@effect/core/stream/Stream/operations/flatMap";
import * as tsplus_module_6 from "@effect/core/stream/Stream/operations/make";
import * as tsplus_module_7 from "@effect/core/stream/Stream/operations/concat";
export const shrinkSearch = shrinkSearch_1;
/**
 * Converts the shrink tree into a stream of shrinkings by recursively
 * searching the shrink tree, using the specified function to determine
 * whether a value is a failure. The resulting stream will contain all values
 * explored, regardless of whether they are successes or failures.
 *
 * @tsplus static effect/core/testing/Sample.Aspects shrinkSearch
 * @tsplus pipeable effect/core/testing/Sample shrinkSearch
 */

function shrinkSearch_1(f) {
  return self => f(self.value) ? tsplus_module_7.concat(tsplus_module_5.flatMap(maybe => tsplus_module_3.getOrElse_(tsplus_module_2.map(sample => shrinkSearch_1(f)(sample))(maybe), () => tsplus_module_1.empty))(tsplus_module_4.takeUntil(maybe => {
    switch (maybe._tag) {
      case "None":
        {
          return false;
        }

      case "Some":
        {
          return f(maybe.value.value);
        }
    }
  })(self.shrink)))(tsplus_module_6.make(self.value)) : tsplus_module_6.make(self.value);
}
//# sourceMappingURL=shrinkSearch.mjs.map