import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/concat";
/**
 * @tsplus static effect/core/testing/TestAnnotation.Ops compose
 */

export function compose(left, right) {
  if (tsplus_module_1.isLeft(left) && tsplus_module_1.isLeft(right)) {
    return tsplus_module_1.left(left.left + right.left);
  }

  if (tsplus_module_1.isRight(left) && tsplus_module_1.isRight(right)) {
    return tsplus_module_1.right(tsplus_module_2.concat(right.right)(left.right));
  }

  if (tsplus_module_1.isRight(left) && tsplus_module_1.isLeft(right)) {
    return right;
  }

  if (tsplus_module_1.isLeft(left) && tsplus_module_1.isRight(right)) {
    return right;
  }

  throw new Error("bug");
}
//# sourceMappingURL=compose.mjs.map