export const SuspendedWarningData = {};
/**
 * State indicating that a test has not adjusted the clock.
 *
 * @tsplus static effect/core/testing/TestClock.SuspendedWarningData.Ops Start
 */

export const start = {
  _tag: "Start"
};
/**
 * State indicating that a test has adjusted the clock but a fiber is still
 * running with a reference to the fiber that will display the warning
 * message.
 *
 * @tsplus static effect/core/testing/TestClock.SuspendedWarningData.Ops Pending
 */

export function pending(fiber) {
  return {
    _tag: "Pending",
    fiber
  };
}
/**
 * State indicating that the warning message has already been displayed.
 *
 * @tsplus static effect/core/testing/TestClock.SuspendedWarningData.Ops Done
 */

export const done = {
  _tag: "Done"
};
//# sourceMappingURL=SuspendedWarningData.mjs.map