export const WarningData = {};
/**
 * SState indicating that a test has not used time.
 *
 * @tsplus static effect/core/testing/TestClock.WarningData.Ops Start
 */

export const start = {
  _tag: "Start"
};
/**
 * State indicating that a test has used time but has not adjusted the
 * `TestClock` with a reference to the fiber that will display the warning
 * message.
 *
 * @tsplus static effect/core/testing/TestClock.WarningData.Ops Pending
 */

export function pending(fiber) {
  return {
    _tag: "Pending",
    fiber
  };
}
/**
 * State indicating that a test has used time or the warning message has
 * already been displayed.
 *
 * @tsplus static effect/core/testing/TestClock.WarningData.Ops Done
 */

export const done = {
  _tag: "Done"
};
//# sourceMappingURL=WarningData.mjs.map