import * as tsplus_module_1 from "@tsplus/stdlib/service/Tag";
import * as tsplus_module_2 from "@effect/core/io/Layer/operations/succeed";
import * as tsplus_module_3 from "@effect/core/io/Effect/operations/serviceWith";
export const live = live_1;
export const TestConfig = /*#__PURE__*/Object.assign(params => params, {
  $: {},
  Tag: /*#__PURE__*/tsplus_module_1.Tag()
});
/**
 * Constructs a new `TestConfig` service with the specified settings.
 *
 * @tsplus static effect/core/testing/TestConfig.Ops live
 */

function live_1(params) {
  return tsplus_module_2.succeed(TestConfig.Tag)(TestConfig(params));
}
/**
 * Constructs a new `TestConfig` with the default settings.
 *
 * @tsplus static effect/core/testing/TestConfig.Ops default
 */


export const defaultTestConfig = /*#__PURE__*/live_1({
  repeats: 100,
  retries: 100,
  samples: 200,
  shrinks: 1000
});
/**
 * The number of times to repeat tests to ensure they are stable.
 *
 * @tsplus static effect/core/testing/TestConfig.Ops repeats
 */

export const repeats = /*#__PURE__*/tsplus_module_3.serviceWith(TestConfig.Tag, _ => _.repeats);
/**
 * The number of times to retry flaky tests.
 *
 * @tsplus static effect/core/testing/TestConfig.Ops retries
 */

export const retries = /*#__PURE__*/tsplus_module_3.serviceWith(TestConfig.Tag, _ => _.retries);
/**
 * The number of sufficient samples to check for a random variable.
 *
 * @tsplus static effect/core/testing/TestConfig.Ops samples
 */

export const samples = /*#__PURE__*/tsplus_module_3.serviceWith(TestConfig.Tag, _ => _.samples);
/**
 * The maximum number of shrinkings to minimize large failures.
 *
 * @tsplus static effect/core/testing/TestConfig.Ops shrinks
 */

export const shrinks = /*#__PURE__*/tsplus_module_3.serviceWith(TestConfig.Tag, _ => _.shrinks);
//# sourceMappingURL=TestConfig.mjs.map