/**
 * Combines the specified deterministic generators to return a new
 * deterministic generator that generates all of the values generated by the
 * specified generators.
 *
 * @tsplus static effect/core/testing/Gen.Ops concatAll
 */
export function concatAll<R, A>(gens: Collection<Gen<R, A>>): Gen<R, A> {
  return Gen.suspend(gens.reduce(Gen.empty as Gen<R, A>, (acc, curr) => acc.concat(curr)))
}
