"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CountdownLatchSym = exports.CountdownLatchInternal = exports.CountdownLatch = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unit"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatten"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a;

const CountdownLatchSym = /*#__PURE__*/Symbol.for("@effect/core/concurrent/CountdownLatch");
exports.CountdownLatchSym = CountdownLatchSym;
const CountdownLatch = {
  $: {}
};
exports.CountdownLatch = CountdownLatch;

class CountdownLatchInternal {
  constructor(count, waiters) {
    this[_a] = CountdownLatchSym;
    this._count = count;
    this._waiters = waiters;
  }
  /**
   * Returns the current count.
   */


  get count() {
    return this._count.get;
  }
  /**
   * Decrements the count of the latch, releasing all waiting fibers if the
   * count reaches zero.
   */


  get countDown() {
    return tsplus_module_1.asUnit(tsplus_module_2.flatten(this._count.modify(n => {
      if (n === 0) {
        return [tsplus_module_1.unit, 0];
      }

      if (n === 1) {
        return [this._waiters.succeed(undefined), 0];
      }

      return [tsplus_module_1.unit, n - 1];
    })));
  }
  /**
   * Causes the current fiber to wait until the latch has counted down to zero.
   */


  get await() {
    return this._waiters.await;
  }

}

exports.CountdownLatchInternal = CountdownLatchInternal;
_a = CountdownLatchSym;
//# sourceMappingURL=definition.js.map