"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CyclicBarrierSym = exports.CyclicBarrierInternal = exports.CyclicBarrier = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Deferred/operations/make"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/whenEffect"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipRight"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/as"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipLeft"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatten"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/fail"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unit"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a;

const CyclicBarrierSym = /*#__PURE__*/Symbol.for("@effect/core/concurrent/CyclicBarrier");
exports.CyclicBarrierSym = CyclicBarrierSym;
const CyclicBarrier = {
  $: {}
};
exports.CyclicBarrier = CyclicBarrier;

class CyclicBarrierInternal {
  constructor(parties, waiting, lock, action, broken) {
    this[_a] = CyclicBarrierSym;
    this._parties = parties;
    this._waiting = waiting;
    this._lock = lock;
    this._action = action;
    this._broken = broken;
  }
  /**
   * The number of parties required to trip this barrier.
   */


  get parties() {
    return this._parties;
  }
  /**
   * The number of parties currently waiting at the barrier.
   */


  get waiting() {
    return this._waiting.get;
  }
  /**
   * Queries if this barrier is in a broken state.
   */


  get isBroken() {
    return this._broken.get;
  }
  /**
   * Resets the barrier to its initial state. Breaks any waiting party.
   */


  get reset() {
    return tsplus_module_6.uninterruptible(tsplus_module_5.zipRight(this._broken.set(false))(tsplus_module_5.zipRight(this._waiting.set(0))(tsplus_module_5.zipRight(tsplus_module_2.flatMap(deferred => this._lock.set(deferred))(tsplus_module_1.make()))(tsplus_module_4.whenEffect(tsplus_module_3.map(waiting => waiting > 0)(this._waiting.get), this.fail)))));
  }
  /**
   * Waits until all parties have invoked await on this barrier. Fails if the
   * barrier is broken.
   */


  get await() {
    return tsplus_module_6.uninterruptibleMask(({
      restore
    }) => tsplus_module_5.zipRight(tsplus_module_9.flatten(this._waiting.modify(waiting => waiting + 1 === this._parties ? [tsplus_module_8.zipLeft(this.reset)(tsplus_module_5.zipRight(tsplus_module_7.as(this._parties - waiting - 1)(this.succeed))(restore(this._action))), 0] : [tsplus_module_2.flatMap(lock => tsplus_module_7.as(this._parties - waiting - 1)(tsplus_module_6.onInterrupt(() => this.break)(restore(lock.await))))(this._lock.get), waiting + 1])))(tsplus_module_2.flatMap(broken => broken ? tsplus_module_10.fail(undefined) : tsplus_module_11.unit)(this._broken.get)));
  }

  get succeed() {
    return tsplus_module_2.flatMap(deferred => tsplus_module_11.asUnit(deferred.succeed(undefined)))(this._lock.get);
  }

  get fail() {
    return tsplus_module_2.flatMap(deferred => tsplus_module_11.asUnit(deferred.fail(undefined)))(this._lock.get);
  }

  get break() {
    return tsplus_module_5.zipRight(this.fail)(this._broken.set(true));
  }

}

exports.CyclicBarrierInternal = CyclicBarrierInternal;
_a = CyclicBarrierSym;
//# sourceMappingURL=definition.js.map