import { Effect } from "@effect/core/io/Effect/definition";
import { Schedule } from "@effect/core/io/Schedule/definition";
import { Scope } from "@effect/core/io/Scope/definition";
import { Cached } from "@effect/core/io/Cached/definition";
/**
 * Creates a new `Cached` value that is automatically refreshed according to
 * the specified policy. Note that error retrying is not performed
 * automatically, so if you want to retry on errors, you should first apply
 * retry policies to the acquisition effect before passing it to this
 * constructor.
 * @tsplus static effect/core/io/Cached.Ops auto
 * @tsplus location "@effect/core/io/Cached/operations/auto"
 */
export declare function auto<R, Error, Resource, State, Env, In, Out>(acquire: Effect<R, Error, Resource>, policy: Schedule<State, Env, In, Out>): Effect<R | Env | Scope, never, Cached<Error, Resource>>;
//# sourceMappingURL=auto.d.ts.map