import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
import { Cached } from "@effect/core/io/Cached/definition";
/**
 * Creates a new `Cached` value that must be manually refreshed by calling
 * the refresh method. Note that error retrying is not performed
 * automatically, so if you want to retry on errors, you should first apply
 * retry policies to the acquisition effect before passing it to this
 * constructor.
 * @tsplus static effect/core/io/Cached.Ops manual
 * @tsplus location "@effect/core/io/Cached/operations/manual"
 */
export declare function manual<R, Error, Resource>(acquire: Effect<R, Error, Resource>): Effect<R | Scope, never, Cached<Error, Resource>>;
//# sourceMappingURL=manual.d.ts.map