import { Cause } from "@effect/core/io/Cause/definition";
export declare const FiberFailureSymbol: unique symbol;
export declare class FiberFailure<E> extends Error {
    readonly cause: Cause<E>;
    readonly [FiberFailureSymbol] = "FiberFailure";
    constructor(cause: Cause<E>);
}
export declare function isFiberFailure(u: unknown): u is FiberFailure<unknown>;
export declare const RuntimeErrorSymbol: unique symbol;
export declare class RuntimeError {
    readonly message?: string | undefined;
    readonly [RuntimeErrorSymbol] = "RuntimeError";
    constructor(message?: string | undefined);
}
export declare function isRuntime(u: unknown): u is RuntimeError;
export declare const ChannelErrorSymbol: unique symbol;
export type ChannelErrorSymbol = typeof ChannelErrorSymbol;
export declare class ChannelError<E> {
    readonly error: E;
    readonly [ChannelErrorSymbol]: ChannelErrorSymbol;
    constructor(error: E);
}
export declare function isChannelError(u: unknown): u is ChannelError<unknown>;
export declare const InterruptedSymbol: unique symbol;
export declare class InterruptedException extends Error {
    readonly [InterruptedSymbol] = "InterruptedException";
    constructor(message?: string);
}
export declare function isInterruptedException(u: unknown): u is InterruptedException;
export declare const IllegalStateExceptionSymbol: unique symbol;
export declare class IllegalStateException extends Error {
    readonly [IllegalStateExceptionSymbol] = "IllegalStateException";
    constructor(message?: string);
}
export declare function isIllegalStateException(u: unknown): u is IllegalStateException;
export declare const IllegalArgumentExceptionSymbol: unique symbol;
export declare class IllegalArgumentException extends Error {
    readonly [IllegalArgumentExceptionSymbol] = "IllegalArgumentException";
    constructor(message?: string);
}
export declare function isIllegalArgumentException(u: unknown): u is IllegalArgumentException;
//# sourceMappingURL=errors.d.ts.map