"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RuntimeErrorSymbol = exports.RuntimeError = exports.InterruptedSymbol = exports.InterruptedException = exports.IllegalStateExceptionSymbol = exports.IllegalStateException = exports.IllegalArgumentExceptionSymbol = exports.IllegalArgumentException = exports.FiberFailureSymbol = exports.FiberFailure = exports.ChannelErrorSymbol = exports.ChannelError = void 0;
exports.isChannelError = isChannelError;
exports.isFiberFailure = isFiberFailure;
exports.isIllegalArgumentException = isIllegalArgumentException;
exports.isIllegalStateException = isIllegalStateException;
exports.isInterruptedException = isInterruptedException;
exports.isRuntime = isRuntime;

var _a, _b, _c, _d, _e, _f; // -----------------------------------------------------------------------------
// Fiber Failure
// -----------------------------------------------------------------------------
// TODO(Mike/Max): implementation
// import { pretty } from "./Pretty"


const FiberFailureSymbol = /*#__PURE__*/Symbol.for("@effect/core/Cause/errors/FiberFailure");
exports.FiberFailureSymbol = FiberFailureSymbol;

class FiberFailure extends Error {
  // readonly pretty = pretty(this.cause)
  constructor(cause) {
    super();
    this.cause = cause;
    this[_a] = "FiberFailure";
    this.name = this[FiberFailureSymbol];
    delete this.stack;
  }

}

exports.FiberFailure = FiberFailure;
_a = FiberFailureSymbol;

function isFiberFailure(u) {
  return u instanceof Error && u[FiberFailureSymbol] === "FiberFailure";
} // // -----------------------------------------------------------------------------
// // Untraced
// // -----------------------------------------------------------------------------
// export const UntracedSymbol: unique symbol = Symbol.for(
//   "@effect/core/Cause/errors/Untraced"
// )
// export class Untraced extends Error {
//   readonly [UntracedSymbol] = "Untraced"
//   constructor(message?: string) {
//     super(message)
//     delete this.stack
//     this.name = this[UntracedSymbol]
//   }
// }
// export const isUntraced = (u: unknown): u is Untraced =>
//   u instanceof Error && u[UntracedSymbol] === "Untraced"
// -----------------------------------------------------------------------------
// Runtime
// -----------------------------------------------------------------------------


const RuntimeErrorSymbol = /*#__PURE__*/Symbol.for("@effect/core/Cause/errors/Runtime");
exports.RuntimeErrorSymbol = RuntimeErrorSymbol;

class RuntimeError {
  constructor(message) {
    this.message = message;
    this[_b] = "RuntimeError";
  }

}

exports.RuntimeError = RuntimeError;
_b = RuntimeErrorSymbol;

function isRuntime(u) {
  return u instanceof RuntimeError && u[RuntimeErrorSymbol] === "RuntimeError";
} // -----------------------------------------------------------------------------
// Channel
// -----------------------------------------------------------------------------


const ChannelErrorSymbol = /*#__PURE__*/Symbol.for("@effect/core/Cause/errors/Channel");
exports.ChannelErrorSymbol = ChannelErrorSymbol;

class ChannelError {
  constructor(error) {
    this.error = error;
    this[_c] = ChannelErrorSymbol;
  }

}

exports.ChannelError = ChannelError;
_c = ChannelErrorSymbol;

function isChannelError(u) {
  return typeof u === "object" && u != null && ChannelErrorSymbol in u;
} // -----------------------------------------------------------------------------
// Interrupted
// -----------------------------------------------------------------------------


const InterruptedSymbol = /*#__PURE__*/Symbol.for("@effect/core/Cause/errors/Interrupted");
exports.InterruptedSymbol = InterruptedSymbol;

class InterruptedException extends Error {
  constructor(message) {
    super(message);
    this[_d] = "InterruptedException";
    this.name = this[InterruptedSymbol];
  }

}

exports.InterruptedException = InterruptedException;
_d = InterruptedSymbol;

function isInterruptedException(u) {
  return u instanceof Error && u[InterruptedSymbol] === "InterruptedException";
} // -----------------------------------------------------------------------------
// Illegal State
// -----------------------------------------------------------------------------


const IllegalStateExceptionSymbol = /*#__PURE__*/Symbol.for("@effect/core/Cause/errors/IllegalState");
exports.IllegalStateExceptionSymbol = IllegalStateExceptionSymbol;

class IllegalStateException extends Error {
  constructor(message) {
    super(message);
    this[_e] = "IllegalStateException";
    this.name = this[IllegalStateExceptionSymbol];
  }

}

exports.IllegalStateException = IllegalStateException;
_e = IllegalStateExceptionSymbol;

function isIllegalStateException(u) {
  return u instanceof Error && u[IllegalStateExceptionSymbol] === "IllegalStateException";
} // -----------------------------------------------------------------------------
// Illegal Argument
// -----------------------------------------------------------------------------


const IllegalArgumentExceptionSymbol = /*#__PURE__*/Symbol.for("@effect/core/Cause/errors/IllegalArgument");
exports.IllegalArgumentExceptionSymbol = IllegalArgumentExceptionSymbol;

class IllegalArgumentException extends Error {
  constructor(message) {
    super(message);
    this[_f] = "IllegalArgumentException";
    this.name = this[IllegalArgumentExceptionSymbol];
  }

}

exports.IllegalArgumentException = IllegalArgumentException;
_f = IllegalArgumentExceptionSymbol;

function isIllegalArgumentException(u) {
  return u instanceof Error && u[IllegalArgumentExceptionSymbol] === "IllegalArgumentException";
}
//# sourceMappingURL=errors.js.map