import { Cause } from "@effect/core/io/Cause/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Retrieve the first checked error on the `Left` if available, if there are
 * no checked errors return the rest of the `Cause` that is known to contain
 * only `Die` or `Interrupt` causes.
 * @tsplus getter effect/core/io/Cause failureOrCause
 * @tsplus location "@effect/core/io/Cause/operations/failureOrCause"
 */
export declare function failureOrCause<E>(self: Cause<E>): Either<E, Cause<never>>;
//# sourceMappingURL=failureOrCause.d.ts.map