"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fold = fold;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/io/Eval/run"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/io/Eval/succeed"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/io/Eval/suspend"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/io/Eval/zipWith"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/io/Eval/map"));

var _definition = /*#__PURE__*/require("@effect/core/io/Cause/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Folds over the cases of this cause with the specified functions.
 *
 * @tsplus static effect/core/io/Cause.Aspects fold
 * @tsplus pipeable effect/core/io/Cause fold
 */
function fold(onEmptyCause, onFailCause, onDieCause, onInterruptCause, onThenCause, onBothCause, onStacklessCause) {
  return self => tsplus_module_1.run(foldSafe(self, onEmptyCause, onFailCause, onDieCause, onInterruptCause, onThenCause, onBothCause, onStacklessCause));
}

function foldSafe(self, onEmptyCause, onFailCause, onDieCause, onInterruptCause, onThenCause, onBothCause, onStacklessCause) {
  void 0;

  switch (self._tag) {
    case "Empty":
      {
        return tsplus_module_2.succeed(() => onEmptyCause);
      }

    case "Fail":
      {
        return tsplus_module_2.succeed(() => onFailCause(self.value));
      }

    case "Die":
      {
        return tsplus_module_2.succeed(() => onDieCause(self.value));
      }

    case "Interrupt":
      {
        return tsplus_module_2.succeed(() => onInterruptCause(self.fiberId));
      }

    case "Both":
      {
        return tsplus_module_4.zipWith(tsplus_module_3.suspend(() => foldSafe(self.right, onEmptyCause, onFailCause, onDieCause, onInterruptCause, onThenCause, onBothCause, onStacklessCause)), (left, right) => onBothCause(left, right))(tsplus_module_3.suspend(() => foldSafe(self.left, onEmptyCause, onFailCause, onDieCause, onInterruptCause, onThenCause, onBothCause, onStacklessCause)));
      }

    case "Then":
      {
        return tsplus_module_4.zipWith(tsplus_module_3.suspend(() => foldSafe(self.right, onEmptyCause, onFailCause, onDieCause, onInterruptCause, onThenCause, onBothCause, onStacklessCause)), (left, right) => onThenCause(left, right))(tsplus_module_3.suspend(() => foldSafe(self.left, onEmptyCause, onFailCause, onDieCause, onInterruptCause, onThenCause, onBothCause, onStacklessCause)));
      }

    case "Stackless":
      {
        return tsplus_module_5.map(z => onStacklessCause(z, self.stackless))(tsplus_module_3.suspend(() => foldSafe(self.cause, onEmptyCause, onFailCause, onDieCause, onInterruptCause, onThenCause, onBothCause, onStacklessCause)));
      }
  }
}
//# sourceMappingURL=fold.js.map