"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.foldLeft = foldLeft;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Stack"));

var _definition = /*#__PURE__*/require("@effect/core/io/Cause/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Folds over the cause to statefully compute a value.
 *
 * @tsplus static effect/core/io/Cause.Aspects foldLeft
 * @tsplus pipeable effect/core/io/Cause foldLeft
 */
function foldLeft(initial, f) {
  return self => {
    let acc = initial;
    void 0;
    let current = self;
    let causes = undefined;

    while (current) {
      const result = f(acc, current);
      acc = result._tag === "Some" ? result.value : acc;
      void 0;

      switch (current._tag) {
        case "Then":
          {
            causes = new tsplus_module_1.Stack(current.right, causes);
            void 0;
            current = current.left;
            break;
          }

        case "Both":
          {
            causes = new tsplus_module_1.Stack(current.right, causes);
            void 0;
            current = current.left;
            break;
          }

        case "Stackless":
          {
            void 0;
            current = current.cause;
            break;
          }

        default:
          {
            current = undefined;
            break;
          }
      }

      if (!current && causes) {
        void 0;
        current = causes.value;
        causes = causes.previous;
      }
    }

    return acc;
  };
}
//# sourceMappingURL=foldLeft.js.map