"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.keepDefects = keepDefects;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/map"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Cause/operations/fold"));

var _definition2 = /*#__PURE__*/require("@effect/core/io/Cause/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Remove all `Fail` and `Interrupt` nodes from this `Cause`, return only
 * `Die` cause/finalizer defects.
 *
 * @tsplus getter effect/core/io/Cause keepDefects
 */
function keepDefects(self) {
  return tsplus_module_3.fold(tsplus_module_1.none, () => tsplus_module_1.none, e => tsplus_module_1.some(new _definition2.Die(e)), () => tsplus_module_1.none, (left, right) => {
    if (left._tag === "Some" && right._tag === "Some") {
      return tsplus_module_1.some(new _definition2.Then(left.value, right.value));
    }

    if (left._tag === "Some" && right._tag === "None") {
      return tsplus_module_1.some(left.value);
    }

    if (left._tag === "None" && right._tag === "Some") {
      return tsplus_module_1.some(right.value);
    }

    if (left._tag === "None" && right._tag === "None") {
      return tsplus_module_1.none;
    }

    throw new Error("Bug");
  }, (left, right) => {
    if (left._tag === "Some" && right._tag === "Some") {
      return tsplus_module_1.some(new _definition2.Both(left.value, right.value));
    }

    if (left._tag === "Some" && right._tag === "None") {
      return tsplus_module_1.some(left.value);
    }

    if (left._tag === "None" && right._tag === "Some") {
      return tsplus_module_1.some(right.value);
    }

    if (left._tag === "None" && right._tag === "None") {
      return tsplus_module_1.none;
    }

    throw new Error("Bug");
  }, (causeMaybe, stackless) => tsplus_module_2.map(cause => new _definition2.Stackless(cause, stackless))(causeMaybe))(self);
}
//# sourceMappingURL=keepDefects.js.map