import { FiberId } from "@effect/core/io/FiberId/definition";
import { Cause } from "@effect/core/io/Cause/definition";
import { Eval } from "@tsplus/stdlib/io/Eval/definition";
import { Doc } from "@effect/printer/Doc";
export interface Renderer<E = unknown> {
    readonly lineWidth: number;
    readonly ribbonFraction: number;
    readonly renderError: (error: E) => string[];
    readonly renderUnknown: (error: unknown) => string[];
}
export type Segment = Sequential | Parallel | Failure;
export type Step = Parallel | Failure;
export interface Failure {
    readonly _tag: "Failure";
    readonly lines: ReadonlyArray<Doc<never>>;
}
export interface Parallel {
    readonly _tag: "Parallel";
    readonly all: ReadonlyArray<Sequential>;
}
export interface Sequential {
    readonly _tag: "Sequential";
    readonly all: ReadonlyArray<Step>;
}
export declare function Failure(lines: ReadonlyArray<Doc<never>>): Failure;
export declare function Sequential(all: ReadonlyArray<Step>): Sequential;
export declare function Parallel(all: ReadonlyArray<Sequential>): Parallel;
export declare const defaultRenderer: Renderer;
/**
 * Returns a `String` with the cause pretty-printed.
 * @tsplus static effect/core/io/Cause.Aspects pretty
 * @tsplus pipeable effect/core/io/Cause pretty
 * @tsplus location "@effect/core/io/Cause/operations/pretty"
 */
export declare function pretty<E>(renderer?: Renderer<E>): (self: Cause<E>) => string;
//# sourceMappingURL=pretty.d.ts.map