"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.stripFailures = stripFailures;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Cause/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Cause/operations/fold"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Discards all typed failures kept on this `Cause`.
 *
 * @tsplus getter effect/core/io/Cause stripFailures
 */
function stripFailures(self) {
  return tsplus_module_2.fold(tsplus_module_1.empty, () => tsplus_module_1.empty, defect => new tsplus_module_1.Die(defect), fiberId => new tsplus_module_1.Interrupt(fiberId), (left, right) => new tsplus_module_1.Then(left, right), (left, right) => new tsplus_module_1.Both(left, right), (cause, stackless) => new tsplus_module_1.Stackless(cause, stackless))(self);
}
//# sourceMappingURL=stripFailures.js.map