"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.stripSomeDefects = stripSomeDefects;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Cause/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/map"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Cause/operations/fold"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Remove all `Die` causes that the specified partial function is defined at,
 * returning `Some` with the remaining causes or `None` if there are no
 * remaining causes.
 *
 * @tsplus static effect/core/io/Cause.Aspects stripSomeDefects
 * @tsplus pipeable effect/core/io/Cause stripSomeDefects
 */
function stripSomeDefects(pf) {
  return cause => tsplus_module_4.fold(tsplus_module_2.some(tsplus_module_1.empty), e => tsplus_module_2.some(tsplus_module_1.fail(e)), t => pf(t) ? tsplus_module_2.none : tsplus_module_2.some(tsplus_module_1.die(t)), fiberId => tsplus_module_2.some(tsplus_module_1.interrupt(fiberId)), (x, y) => {
    if (tsplus_module_2.isSome(x) && tsplus_module_2.isSome(y)) {
      return tsplus_module_2.some(tsplus_module_1.combineSeq(x.value, y.value));
    }

    if (tsplus_module_2.isSome(x) && tsplus_module_2.isNone(y)) {
      return tsplus_module_2.some(x.value);
    }

    if (tsplus_module_2.isNone(x) && tsplus_module_2.isSome(y)) {
      return tsplus_module_2.some(y.value);
    }

    return tsplus_module_2.none;
  }, (x, y) => {
    if (tsplus_module_2.isSome(x) && tsplus_module_2.isSome(y)) {
      return tsplus_module_2.some(tsplus_module_1.combinePar(x.value, y.value));
    }

    if (tsplus_module_2.isSome(x) && tsplus_module_2.isNone(y)) {
      return tsplus_module_2.some(x.value);
    }

    if (tsplus_module_2.isNone(x) && tsplus_module_2.isSome(y)) {
      return tsplus_module_2.some(y.value);
    }

    return tsplus_module_2.none;
  }, (causeOption, stackless) => tsplus_module_3.map(cause => new tsplus_module_1.Stackless(cause, stackless))(causeOption))(cause);
}
//# sourceMappingURL=stripSomeDefects.js.map