"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LiveClock = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/sync"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unit"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Either/definition"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var _definition2 = /*#__PURE__*/require("@effect/core/io/Clock/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a;

class LiveClock {
  constructor() {
    this[_a] = _definition2.ClockSym;
  }

  get currentTime() {
    return tsplus_module_1.sync(() => this.unsafeCurrentTime);
  }

  get unsafeCurrentTime() {
    return new Date().getTime();
  }

  get scheduler() {
    return tsplus_module_2.succeed(_definition2.globalScheduler);
  }

  sleep(duration) {
    return tsplus_module_5.asyncInterrupt(cb => {
      const canceler = _definition2.globalScheduler.unsafeSchedule(() => cb(tsplus_module_3.unit), duration);

      return tsplus_module_4.left(tsplus_module_1.sync(canceler));
    });
  }

}

exports.LiveClock = LiveClock;
_a = _definition2.ClockSym;
//# sourceMappingURL=live.js.map