import { Effect } from "@effect/core/io/Effect/definition";
/**
 * @tsplus type effect/core/io/Deferred/State
 */
export type DeferredState<E, A> = Pending<E, A> | Done<E, A>;
/**
 * @tsplus type effect/core/io/Deferred/State.Ops
 */
export interface DeferredStateOps {
}
export declare const DeferredState: DeferredStateOps;
export declare class Pending<E, A> {
    readonly joiners: Array<(_: Effect<never, E, A>) => void>;
    readonly _tag = "Pending";
    constructor(joiners: Array<(_: Effect<never, E, A>) => void>);
}
export declare class Done<E, A> {
    readonly value: Effect<never, E, A>;
    readonly _tag = "Done";
    constructor(value: Effect<never, E, A>);
}
/**
 * @tsplus static effect/core/io/Deferred/State.Ops pending
 * @tsplus location "@effect/core/io/Deferred/_internal/DeferredState"
 */
export declare function pending<E, A>(joiners: Array<(_: Effect<never, E, A>) => void>): DeferredState<E, A>;
/**
 * @tsplus static effect/core/io/Deferred/State.Ops done
 * @tsplus location "@effect/core/io/Deferred/_internal/DeferredState"
 */
export declare function done<E, A>(value: Effect<never, E, A>): DeferredState<E, A>;
//# sourceMappingURL=DeferredState.d.ts.map