"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.IYieldNow = exports.IWhileLoop = exports.IUpdateRuntimeFlagsUninterruptible = exports.IUpdateRuntimeFlagsInterruptible = exports.IUpdateRuntimeFlagsDynamic = exports.IUpdateRuntimeFlags = exports.ISync = exports.ISuccess = exports.IStateful = exports.IOnSuccessAndFailure = exports.IOnSuccess = exports.IOnFailure = exports.IFailure = exports.IAsync = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/RuntimeFlags/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/RuntimeFlags/patch/operations/enable"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var _base = /*#__PURE__*/require("@effect/core/io/Effect/definition/base");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;

class ISync {
  constructor(evaluate) {
    this.evaluate = evaluate;
    this[_a] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this._tag = "Sync";
  }

}

exports.ISync = ISync;
_a = _base.EffectURI;

class IAsync {
  constructor(register, blockingOn) {
    this.register = register;
    this.blockingOn = blockingOn;
    this[_b] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this._tag = "Async";
  }

}

exports.IAsync = IAsync;
_b = _base.EffectURI;

class IOnSuccessAndFailure {
  constructor(first, successK, failK) {
    this.first = first;
    this.successK = successK;
    this.failK = failK;
    this[_c] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this._tag = "OnSuccessAndFailure";
  }

}

exports.IOnSuccessAndFailure = IOnSuccessAndFailure;
_c = _base.EffectURI;

class IOnSuccess {
  constructor(first, successK) {
    this.first = first;
    this.successK = successK;
    this[_d] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this._tag = "OnSuccess";
  }

}

exports.IOnSuccess = IOnSuccess;
_d = _base.EffectURI;

class IOnFailure {
  constructor(first, failK) {
    this.first = first;
    this.failK = failK;
    this[_e] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this._tag = "OnFailure";
  }

}

exports.IOnFailure = IOnFailure;
_e = _base.EffectURI;

class IUpdateRuntimeFlags {
  constructor(update) {
    this.update = update;
    this[_f] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this._tag = "UpdateRuntimeFlags";
  }

}

exports.IUpdateRuntimeFlags = IUpdateRuntimeFlags;
_f = _base.EffectURI;

class IUpdateRuntimeFlagsDynamic {
  constructor(update, scope) {
    this.update = update;
    this.scope = scope;
    this[_g] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this._tag = "UpdateRuntimeFlagsWithin";
  }

}

exports.IUpdateRuntimeFlagsDynamic = IUpdateRuntimeFlagsDynamic;
_g = _base.EffectURI;

class IUpdateRuntimeFlagsInterruptible {
  constructor(effect) {
    this.effect = effect;
    this[_h] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this._tag = "UpdateRuntimeFlagsWithin";
    this.update = tsplus_module_2.enable(tsplus_module_1.RuntimeFlags.Interruption);

    this.scope = () => this.effect;
  }

}

exports.IUpdateRuntimeFlagsInterruptible = IUpdateRuntimeFlagsInterruptible;
_h = _base.EffectURI;

class IUpdateRuntimeFlagsUninterruptible {
  constructor(effect) {
    this.effect = effect;
    this[_j] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this._tag = "UpdateRuntimeFlagsWithin";
    this.update = tsplus_module_2.disable(tsplus_module_1.RuntimeFlags.Interruption);

    this.scope = () => this.effect;
  }

}

exports.IUpdateRuntimeFlagsUninterruptible = IUpdateRuntimeFlagsUninterruptible;
_j = _base.EffectURI;

class IStateful {
  constructor(onState) {
    this.onState = onState;
    this[_k] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this._tag = "Stateful";
  }

}

exports.IStateful = IStateful;
_k = _base.EffectURI;

class IWhileLoop {
  constructor(check, body, process) {
    this.check = check;
    this.body = body;
    this.process = process;
    this[_l] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this._tag = "WhileLoop";
  }

}

exports.IWhileLoop = IWhileLoop;
_l = _base.EffectURI;

class IYieldNow {
  constructor() {
    this[_m] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this._tag = "YieldNow";
  }

}

exports.IYieldNow = IYieldNow;
_m = _base.EffectURI;

class IFailure {
  constructor(cause) {
    this.cause = cause;
    this[_o] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this._tag = "Failure";
  }

  [(_o = _base.EffectURI, tsplus_module_3.Hash.sym)]() {
    return tsplus_module_3.hashUnknown(this.cause);
  }

  [tsplus_module_4.Equals.sym](that) {
    return that instanceof IFailure && tsplus_module_4.equals(this.cause, that.cause);
  }

}

exports.IFailure = IFailure;

class ISuccess {
  constructor(value) {
    this.value = value;
    this[_p] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this._tag = "Success";
  }

  [(_p = _base.EffectURI, tsplus_module_3.Hash.sym)]() {
    return tsplus_module_3.hashUnknown(this.value);
  }

  [tsplus_module_4.Equals.sym](that) {
    return that instanceof ISuccess && tsplus_module_4.equals(this.value, that.value);
  }

}

exports.ISuccess = ISuccess;
//# sourceMappingURL=primitives.js.map