import { Duration } from "@tsplus/stdlib/data/Duration";
import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Deferred } from "@effect/core/io/Deferred/definition";
import { Ref } from "@effect/core/io/Ref/definition";
/**
 * Returns an effect that, if evaluated, will return the cached result of this
 * effect. Cached results will expire after `timeToLive` duration. In
 * addition, returns an effect that can be used to invalidate the current
 * cached value before the `timeToLive` duration expires.
 * @tsplus static effect/core/io/Effect.Aspects cachedInvalidate
 * @tsplus pipeable effect/core/io/Effect cachedInvalidate
 * @tsplus location "@effect/core/io/Effect/operations/cachedInvalidate"
 */
export declare function cachedInvalidate(timeToLive: Duration): <R, E, A>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R, never, readonly [import("../definition").Effect<never, E, A>, import("../definition").Effect<never, never, void>]>;
//# sourceMappingURL=cachedInvalidate.d.ts.map