"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cachedInvalidate = cachedInvalidate;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Ref/operations/make"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Deferred/operations/make"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/dieSync"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fold"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Clock/operations/currentTime"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Returns an effect that, if evaluated, will return the cached result of this
 * effect. Cached results will expire after `timeToLive` duration. In
 * addition, returns an effect that can be used to invalidate the current
 * cached value before the `timeToLive` duration expires.
 *
 * @tsplus static effect/core/io/Effect.Aspects cachedInvalidate
 * @tsplus pipeable effect/core/io/Effect cachedInvalidate
 */
function cachedInvalidate(timeToLive) {
  return self => tsplus_module_5.flatMap(environment => tsplus_module_4.map(cache => [tsplus_module_1.provideEnvironment(environment)(get(self, timeToLive, cache)), invalidate(cache)])(tsplus_module_3.makeSynchronized(() => tsplus_module_2.none)))(tsplus_module_1.environment());
}

function compute(self, timeToLive, start) {
  return tsplus_module_5.flatMap(deferred => tsplus_module_4.map(() => tsplus_module_2.some([start + timeToLive.millis, deferred]))(tsplus_module_1.intoDeferred(deferred)(self)))(tsplus_module_6.make());
}

function get(self, timeToLive, cache) {
  return tsplus_module_1.uninterruptibleMask(({
    restore
  }) => tsplus_module_5.flatMap(time => tsplus_module_5.flatMap(a => a._tag === "None" ? tsplus_module_7.dieSync(() => "Bug") : restore(a.value[1].await))(cache.updateSomeAndGetEffect(_ => tsplus_module_8.fold(() => tsplus_module_2.some(compute(self, timeToLive, time)), ([end]) => end - time <= 0 ? tsplus_module_2.some(compute(self, timeToLive, time)) : tsplus_module_2.none)(_))))(tsplus_module_9.currentTime));
}

function invalidate(cache) {
  return cache.set(tsplus_module_2.none);
}
//# sourceMappingURL=cachedInvalidate.js.map