import { Cause } from "@effect/core/io/Cause/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Recovers from all errors with provided `Cause`.
 *
 * See `absorb`, `sandbox`, `mapErrorCause` for other functions that can
 * recover from defects.
 * @tsplus static effect/core/io/Effect.Aspects catchAllCause
 * @tsplus pipeable effect/core/io/Effect catchAllCause
 * @tsplus location "@effect/core/io/Effect/operations/catchAllCause"
 */
export declare function catchAllCause<E, R2, E2, A2>(f: (cause: Cause<E>) => Effect<R2, E2, A2>): <R, A>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R2 | R, E2, A2 | A>;
//# sourceMappingURL=catchAllCause.d.ts.map