import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Recovers from all defects with provided function.
 *
 * **WARNING**: There is no sensible way to recover from defects. This
 * method should be used only at the boundary between Effect and an external
 * system, to transmit information on a defect for diagnostic or explanatory
 * purposes.
 * @tsplus static effect/core/io/Effect.Aspects catchAllDefect
 * @tsplus pipeable effect/core/io/Effect catchAllDefect
 * @tsplus location "@effect/core/io/Effect/operations/catchAllDefect"
 */
export declare function catchAllDefect<R2, E2, A2>(f: (defect: unknown) => Effect<R2, E2, A2>): <R, E, A>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R2 | R, E2 | E, A2 | A>;
//# sourceMappingURL=catchAllDefect.d.ts.map