import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Recovers from some or all of the defects with provided partial function.
 *
 * **WARNING**: There is no sensible way to recover from defects. This
 * method should be used only at the boundary between Effect and an external
 * system, to transmit information on a defect for diagnostic or explanatory
 * purposes.
 * @tsplus static effect/core/io/Effect.Aspects catchSomeDefect
 * @tsplus pipeable effect/core/io/Effect catchSomeDefect
 * @tsplus location "@effect/core/io/Effect/operations/catchSomeDefect"
 */
export declare function catchSomeDefect<R2, E2, A2>(pf: (_: unknown) => Maybe<Effect<R2, E2, A2>>): <R, E, A>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R2 | R, E2 | E, A2 | A>;
//# sourceMappingURL=catchSomeDefect.d.ts.map