import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Evaluate each effect in the structure from left to right, collecting the
 * the successful values and discarding the empty cases. For a parallel version, see `collectPar`.
 * @tsplus static effect/core/io/Effect.Ops collect
 * @tsplus location "@effect/core/io/Effect/operations/collect"
 */
export declare function collect<A, R, E, B>(as: Collection<A>, f: (a: A) => Effect<R, Maybe<E>, B>): Effect<R, E, Chunk<B>>;
//# sourceMappingURL=collect.d.ts.map