import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Collects the first element of the `Collection<A?` for which the effectual
 * function `f` returns `Some`.
 * @tsplus static effect/core/io/Effect.Ops collectFirst
 * @tsplus location "@effect/core/io/Effect/operations/collectFirst"
 */
export declare function collectFirst<R, E, A, B>(as: Collection<A>, f: (a: A) => Effect<R, E, Maybe<B>>): Effect<R, E, Maybe<B>>;
//# sourceMappingURL=collectFirst.d.ts.map