import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Evaluate each effect in the structure in parallel, collecting the
 * the successful values and discarding the empty cases.
 * @tsplus static effect/core/io/Effect.Ops collectPar
 * @tsplus location "@effect/core/io/Effect/operations/collectPar"
 */
export declare function collectPar<A, R, E, B>(as: Collection<A>, f: (a: A) => Effect<R, Maybe<E>, B>): Effect<R, E, Chunk<B>>;
//# sourceMappingURL=collectPar.d.ts.map