import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Evaluate the predicate, return the given `A` as success if predicate returns
 * true, and the given `E` as error otherwise
 *
 * For effectful conditionals, see `ifEffect`.
 * @tsplus static effect/core/io/Effect.Ops cond
 * @tsplus location "@effect/core/io/Effect/operations/cond"
 */
export declare function cond<E, A>(predicate: LazyArg<boolean>, result: LazyArg<A>, error: LazyArg<E>): Effect<never, E, A>;
//# sourceMappingURL=cond.d.ts.map