"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deriveAccess = deriveAccess;
exports.deriveAccessEffect = deriveAccessEffect;
exports.deriveLifted = deriveLifted;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/serviceWith"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @tsplus static effect/core/io/Effect.Ops deriveLifted
 */
function deriveLifted(S) {
  return (functions, constants, values) => {
    const ret = {};

    for (const k of functions) {
      ret[k] = (...args) => tsplus_module_1.serviceWithEffect(S, h => h[k](...args));
    }

    for (const k of constants) {
      ret[k] = tsplus_module_1.serviceWithEffect(S, h => h[k]);
    }

    for (const k of values) {
      ret[k] = tsplus_module_2.serviceWith(S, h => h[k]);
    }

    return ret;
  };
}
/**
 * @tsplus static effect/core/io/Effect.Ops deriveAccessEffect
 */


function deriveAccessEffect(S) {
  return generics => {
    const ret = {};

    for (const k of generics) {
      ret[k] = (f, trace) => tsplus_module_1.serviceWithEffect(S, h => f(h[k]));
    }

    return ret;
  };
}
/**
 * @tsplus static effect/core/io/Effect.Ops deriveAccess
 */


function deriveAccess(S) {
  return generics => {
    const ret = {};

    for (const k of generics) {
      ret[k] = (f, trace) => tsplus_module_2.serviceWith(S, h => f(h[k]));
    }

    return ret;
  };
}
//# sourceMappingURL=derive.js.map