import { Effect } from "@effect/core/io/Effect/definition";
import { MergeRecord } from "@tsplus/stdlib/utilities/Types";
/**
 * Binds an effectful value in a `do` scope
 * @tsplus static effect/core/io/Effect.Aspects bind
 * @tsplus pipeable effect/core/io/Effect bind
 * @tsplus location "@effect/core/io/Effect/operations/do"
 */
export declare function bind<N extends string, K, R2, E2, A>(tag: Exclude<N, keyof K>, f: (_: K) => Effect<R2, E2, A>): <R, E>(self: import("../definition").Effect<R, E, K>) => import("../definition").Effect<R2 | R, E2 | E, import("@tsplus/stdlib/utilities/Types").MergeRecord<K, { [k in N]: A; }>>;
/**
 * Like bind for values
 * @tsplus static effect/core/io/Effect.Aspects bindValue
 * @tsplus pipeable effect/core/io/Effect bindValue
 * @tsplus location "@effect/core/io/Effect/operations/do"
 */
export declare function bindValue<N extends string, K, A>(tag: Exclude<N, keyof K>, f: (_: K) => A): <R, E>(self: import("../definition").Effect<R, E, K>) => import("../definition").Effect<R, E, import("@tsplus/stdlib/utilities/Types").MergeRecord<K, { [k in N]: A; }>>;
/**
 * @tsplus static effect/core/io/Effect.Ops Do
 * @tsplus location "@effect/core/io/Effect/operations/do"
 */
export declare function Do(): Effect<never, never, {}>;
//# sourceMappingURL=do.d.ts.map