import { Effect } from "@effect/core/io/Effect/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Returns an effect whose failure and success have been lifted into an
 * `Either`. The resulting effect cannot fail, because the failure case has
 * been exposed as part of the `Either` success case.
 *
 * This method is useful for recovering from effects that may fail.
 *
 * The error parameter of the returned `Effect` is `never`, since it is
 * guaranteed the effect does not model failure.
 * @tsplus getter effect/core/io/Effect either
 * @tsplus location "@effect/core/io/Effect/operations/either"
 */
export declare function either<R, E, A>(self: Effect<R, E, A>): Effect<R, never, Either<E, A>>;
//# sourceMappingURL=either.d.ts.map