import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns an effect that, if this effect _starts_ execution, then the
 * specified `finalizer` is guaranteed to begin execution, whether this effect
 * succeeds, fails, or is interrupted.
 *
 * For use cases that need access to the effect's result, see `onExit`.
 *
 * Finalizers offer very powerful guarantees, but they are low-level, and
 * should generally not be used for releasing resources. For higher-level
 * logic built on `ensuring`, see `acquireReleaseWith`.
 * @tsplus static effect/core/io/Effect.Aspects ensuring
 * @tsplus pipeable effect/core/io/Effect ensuring
 * @tsplus location "@effect/core/io/Effect/operations/ensuring"
 */
export declare function ensuring<R1, X>(finalizer: Effect<R1, never, X>): <R, E, A>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R1 | R, E, A>;
//# sourceMappingURL=ensuring.d.ts.map