import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Determines whether any element of the `Collection<A>` satisfies the effectual
 * predicate `f`, working in parallel. Interrupts all effects on any failure or
 * finding an element that satisfies the predicate.
 * @tsplus static effect/core/io/Effect.Ops existsPar
 * @tsplus location "@effect/core/io/Effect/operations/existsPar"
 */
export declare function existsPar<R, E, A>(as: Collection<A>, f: (a: A) => Effect<R, E, boolean>): Effect<R, E, boolean>;
//# sourceMappingURL=existsPar.d.ts.map