import { Refinement, LazyArg } from "@tsplus/stdlib/data/Function";
import { Effect } from "@effect/core/io/Effect/definition";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Applies `f` if the predicate fails.
 * @tsplus static effect/core/io/Effect.Aspects filterOrElse
 * @tsplus pipeable effect/core/io/Effect filterOrElse
 * @tsplus location "@effect/core/io/Effect/operations/filterOrElse"
 */
export declare function filterOrElse<A, B extends A, R1, E1, A1>(f: Refinement<A, B>, effect: LazyArg<Effect<R1, E1, A1>>): <R, E>(self: Effect<R, E, A>) => Effect<R | R1, E | E1, B | A1>;
export declare function filterOrElse<A, R1, E1, A1>(f: Predicate<A>, effect: LazyArg<Effect<R1, E1, A1>>): <R, E>(self: Effect<R, E, A>) => Effect<R | R1, E | E1, A | A1>;
//# sourceMappingURL=filterOrElse.d.ts.map