import { Refinement } from "@tsplus/stdlib/data/Function";
import { Effect } from "@effect/core/io/Effect/definition";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Applies `f` if the predicate fails.
 * @tsplus static effect/core/io/Effect.Aspects filterOrElseWith
 * @tsplus pipeable effect/core/io/Effect filterOrElseWith
 * @tsplus location "@effect/core/io/Effect/operations/filterOrElseWith"
 */
export declare function filterOrElseWith<A, B extends A, R1, E1, A1>(f: Refinement<A, B>, orElse: (a: A) => Effect<R1, E1, A1>): <R, E>(self: Effect<R, E, A>) => Effect<R | R1, E | E1, B | A1>;
export declare function filterOrElseWith<A, R1, E1, A1>(f: Predicate<A>, orElse: (a: A) => Effect<R1, E1, A1>): <R, E>(self: Effect<R, E, A>) => Effect<R | R1, E | E1, A | A1>;
//# sourceMappingURL=filterOrElseWith.d.ts.map