"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.find = find;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/suspendSucceed"));

var _Chunk = /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Returns the first element that satisfies the effectful predicate.
 *
 * @tsplus static effect/core/io/Effect.Ops find
 */
function find(self, f) {
  return tsplus_module_5.suspendSucceed(() => {
    const chunk = tsplus_module_1.from(self);

    const iterator = chunk._arrayLikeIterator();

    let next;

    const loop = (iterator, array, i, length) => {
      if (i < length) {
        const a = array[i];
        return tsplus_module_4.flatMap(r => r ? tsplus_module_3.succeed(tsplus_module_2.some(a)) : loop(iterator, array, i + 1, length))(f(a));
      } else if (!(next = iterator.next()).done) {
        return loop(iterator, next.value, 0, next.value.length);
      } else {
        return tsplus_module_3.succeed(tsplus_module_2.none);
      }
    };

    next = iterator.next();

    if (!next.done) {
      return loop(iterator, next.value, 0, next.value.length);
    } else {
      return tsplus_module_3.succeed(tsplus_module_2.none);
    }
  });
}
//# sourceMappingURL=find.js.map