import { Cause } from "@effect/core/io/Cause/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * A more powerful version of `fold` that allows recovering from any kind of
 * failure except interruptions.
 * @tsplus static effect/core/io/Effect.Aspects foldCause
 * @tsplus pipeable effect/core/io/Effect foldCause
 * @tsplus location "@effect/core/io/Effect/operations/foldCause"
 */
export declare function foldCause<E, A, A2, A3>(failure: (cause: Cause<E>) => A2, success: (a: A) => A3): <R>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R, never, A2 | A3>;
//# sourceMappingURL=foldCause.d.ts.map