import { Cause } from "@effect/core/io/Cause/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * A more powerful version of `foldEffect` that allows recovering from any kind
 * of failure except interruptions.
 * @tsplus static effect/core/io/Effect.Aspects foldCauseEffect
 * @tsplus pipeable effect/core/io/Effect foldCauseEffect
 * @tsplus location "@effect/core/io/Effect/operations/foldCauseEffect"
 */
export declare function foldCauseEffect<E, A, R2, E2, A2, R3, E3, A3>(failure: (cause: Cause<E>) => Effect<R2, E2, A2>, success: (a: A) => Effect<R3, E3, A3>): <R>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R2 | R3 | R, E2 | E3, A2 | A3>;
//# sourceMappingURL=foldCauseEffect.d.ts.map