"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.foldCauseEffect = foldCauseEffect;

var _primitives = /*#__PURE__*/require("@effect/core/io/Effect/definition/primitives");

/**
 * A more powerful version of `foldEffect` that allows recovering from any kind
 * of failure except interruptions.
 *
 * @tsplus static effect/core/io/Effect.Aspects foldCauseEffect
 * @tsplus pipeable effect/core/io/Effect foldCauseEffect
 */
function foldCauseEffect(failure, success) {
  return self => new _primitives.IOnSuccessAndFailure(self, success, failure);
}
//# sourceMappingURL=foldCauseEffect.js.map