import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Returns a new effect that will pass the success value of this effect to the
 * provided callback. If this effect fails, then the failure will be ignored.
 * @tsplus static effect/core/io/Effect.Aspects forEachEffect
 * @tsplus pipeable effect/core/io/Effect forEachEffect
 * @tsplus location "@effect/core/io/Effect/operations/forEachEffect"
 */
export declare function forEachEffect<A, R1, E1, B>(f: (a: A) => Effect<R1, E1, B>): <R, E>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R1 | R, E1, import("@tsplus/stdlib/data/Maybe").Maybe<B>>;
//# sourceMappingURL=forEachEffect.d.ts.map