import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Fiber } from "@effect/core/io/Fiber/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Returns an effect that forks all of the specified values, and returns a
 * composite fiber that produces a list of their results, in order.
 * @tsplus static effect/core/io/Effect.Ops forkAll
 * @tsplus location "@effect/core/io/Effect/operations/forkAll"
 */
export declare function forkAll<R, E, A>(effects: Collection<Effect<R, E, A>>): Effect<R, never, Fiber<E, Chunk<A>>>;
//# sourceMappingURL=forkAll.d.ts.map