import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns an effect that forks all of the specified values, and returns a
 * composite fiber that produces unit. This version is faster than `forkAll`
 * in cases where the results of the forked fibers are not needed.
 * @tsplus static effect/core/io/Effect.Ops forkAllDiscard
 * @tsplus location "@effect/core/io/Effect/operations/forkAllDiscard"
 */
export declare function forkAllDiscard<R, E, A>(effects: Collection<Effect<R, E, A>>): Effect<R, never, void>;
//# sourceMappingURL=forkAllDiscard.d.ts.map