import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Lifts an `Maybe` into an `Effect` but preserves the error as an option in
 * the error channel, making it easier to compose in some scenarios.
 * @tsplus static effect/core/io/Effect.Ops fromMaybe
 * @tsplus location "@effect/core/io/Effect/operations/fromMaybe"
 */
export declare function fromMaybe<A>(option: Maybe<A>): Effect<never, Maybe<never>, A>;
//# sourceMappingURL=fromMaybe.d.ts.map