"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports._GenR = exports._GenE = exports._GenA = exports.GenEffect = void 0;
exports.gen = gen;
exports.genScoped = genScoped;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Either/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/fromEither"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/failSync"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/sync"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/getOrFail"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/service/Tag"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/suspendSucceed"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unit"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Scope/operations/close"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Scope/operations/make"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * inspired by https://github.com/tusharmath/qio/pull/22 (revised)
 */
const _GenR = /*#__PURE__*/Symbol.for("@effect/core/io/Effect/Gen/R");

exports._GenR = _GenR;

const _GenE = /*#__PURE__*/Symbol.for("@effect/core/io/Effect/Gen/E");

exports._GenE = _GenE;

const _GenA = /*#__PURE__*/Symbol.for("@effect/core/io/Effect/Gen/A");

exports._GenA = _GenA;

class GenEffect {
  constructor(effect) {
    this.effect = effect;
  }

  *[Symbol.iterator]() {
    return yield this;
  }

}

exports.GenEffect = GenEffect;

function adapter(_, __) {
  if (tsplus_module_1.isEither(_)) {
    return new GenEffect(tsplus_module_2.fromEither(_));
  }

  if (tsplus_module_3.isMaybe(_)) {
    if (__ && typeof __ === "function") {
      return new GenEffect(_._tag === "None" ? tsplus_module_4.failSync(() => __()) : tsplus_module_5.sync(() => _.value));
    }

    return new GenEffect(tsplus_module_6.getOrFail(_));
  }

  if (tsplus_module_7.Tag.is(_)) {
    return new GenEffect(tsplus_module_8.service(_));
  }

  return new GenEffect(_);
}
/**
 * @tsplus static effect/core/io/Effect.Ops genWithManaged
 */


function genScoped(f) {
  return tsplus_module_10.suspendSucceed(() => {
    const iterator = f(adapter);
    const state = iterator.next();

    function run(scope, state) {
      if (state.done) {
        return tsplus_module_9.succeed(state.value);
      }

      return tsplus_module_11.flatMap(val => {
        const next = iterator.next(val);
        return run(scope, next);
      })(tsplus_module_10.suspendSucceed(() => state.value.effect));
    }

    return tsplus_module_11.flatMap(scope => tsplus_module_8.acquireUseReleaseExit(tsplus_module_12.unit, () => run(scope, state), (_, exit) => tsplus_module_13.close(exit)(scope)))(tsplus_module_14.make);
  });
}
/**
 * @tsplus static effect/core/io/Effect.Ops gen
 */


function gen(f) {
  return tsplus_module_10.suspendSucceed(() => {
    const iterator = f(adapter);
    const state = iterator.next();

    function run(state) {
      if (state.done) {
        return tsplus_module_9.succeed(state.value);
      }

      return tsplus_module_11.flatMap(val => run(iterator.next(val)))(tsplus_module_10.suspendSucceed(() => state.value["effect"]));
    }

    return run(state);
  });
}
//# sourceMappingURL=gen.js.map