import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { NoSuchElement } from "@tsplus/stdlib/exceptions";
/**
 * Lifts an `Maybe` into an `Effect`, if the option is not defined it fails
 * with `NoSuchElementException`.
 * @tsplus static effect/core/io/Effect.Ops getOrFail
 * @tsplus location "@effect/core/io/Effect/operations/getOrFail"
 */
export declare function getOrFail<A>(option: Maybe<A>): Effect<never, NoSuchElement, A>;
//# sourceMappingURL=getOrFail.d.ts.map