import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Lifts an `Maybe` into an `Effect`. If the option is not defined, fail with
 * the specified `e` value.
 * @tsplus static effect/core/io/Effect.Ops getOrFailWith
 * @tsplus location "@effect/core/io/Effect/operations/getOrFailWith"
 */
export declare function getOrFailWith<E, A>(option: Maybe<A>, e: LazyArg<E>): Effect<never, E, A>;
//# sourceMappingURL=getOrFailWith.d.ts.map