import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Iterates with the specified effectual function. The moral equivalent of:
 *
 * ```typescript
 * let s = initial
 *
 * while (cont(s)) {
 *   s = body(s)
 * }
 *
 * return s
 * ```
 * @tsplus static effect/core/io/Effect.Ops iterate
 * @tsplus location "@effect/core/io/Effect/operations/iterate"
 */
export declare function iterate<Z>(initial: Z, cont: (z: Z) => boolean): <R, E>(body: (z: Z) => import("../definition").Effect<R, E, Z>) => import("../definition").Effect<R, E, Z>;
//# sourceMappingURL=iterate.d.ts.map