"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.log = log;
exports.logAnnotate = logAnnotate;
exports.logAnnotations = logAnnotations;
exports.logDebug = logDebug;
exports.logDebugCause = logDebugCause;
exports.logDebugCauseMessage = logDebugCauseMessage;
exports.logError = logError;
exports.logErrorCause = logErrorCause;
exports.logErrorCauseMessage = logErrorCauseMessage;
exports.logFatal = logFatal;
exports.logFatalCause = logFatalCause;
exports.logFatalCauseMessage = logFatalCauseMessage;
exports.logInfo = logInfo;
exports.logInfoCause = logInfoCause;
exports.logInfoCauseMessage = logInfoCauseMessage;
exports.logSpan = logSpan;
exports.logTrace = logTrace;
exports.logTraceCause = logTraceCause;
exports.logTraceCauseMessage = logTraceCauseMessage;
exports.logWarning = logWarning;
exports.logWarningCause = logWarningCause;
exports.logWarningCauseMessage = logWarningCauseMessage;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/LogLevel/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Cause/definition"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unit"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/withFiberRuntime"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/LogSpan/definition"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/prepend"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/suspendSucceed"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Clock/operations/currentTime"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableMap/set"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const someFatal = /*#__PURE__*/tsplus_module_2.some(tsplus_module_1.Fatal);
const someError = /*#__PURE__*/tsplus_module_2.some(tsplus_module_1.Error);
const someWarning = /*#__PURE__*/tsplus_module_2.some(tsplus_module_1.Warning);
const someTrace = /*#__PURE__*/tsplus_module_2.some(tsplus_module_1.Trace);
const someInfo = /*#__PURE__*/tsplus_module_2.some(tsplus_module_1.Info);
const someDebug = /*#__PURE__*/tsplus_module_2.some(tsplus_module_1.Debug);
/**
 * Logs the specified message at the current log level.
 *
 * @tsplus static effect/core/io/Effect.Ops log
 */

function log(message) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log(message, tsplus_module_3.empty, tsplus_module_2.none);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified message at the debug log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logDebug
 */


function logDebug(message) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log(message, tsplus_module_3.empty, someDebug);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified cause at the debug log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logDebugCause
 */


function logDebugCause(cause) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log("", cause, someDebug);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified message and cause at the debug log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logDebugCauseMessage
 */


function logDebugCauseMessage(message, cause) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log(message, cause, someDebug);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified message at the error log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logError
 */


function logError(message) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log(message, tsplus_module_3.empty, someError);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified cause at the error log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logErrorCause
 */


function logErrorCause(cause) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log("", cause, someError);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified message and cause at the error log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logErrorCauseMessage
 */


function logErrorCauseMessage(message, cause) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log(message, cause, someError);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified message at the fatal log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logFatal
 */


function logFatal(message) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log(message, tsplus_module_3.empty, someFatal);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified cause at the fatal log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logFatalCause
 */


function logFatalCause(cause) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log("", cause, someFatal);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified message and cause at the fatal log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logFatalCauseMessage
 */


function logFatalCauseMessage(message, cause) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log(message, cause, someFatal);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified message at the informational log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logInfo
 */


function logInfo(message) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log(message, tsplus_module_3.empty, someInfo);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified cause at the informational log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logInfoCause
 */


function logInfoCause(cause) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log("", cause, someInfo);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified message and cause at the informational log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logInfoCauseMessage
 */


function logInfoCauseMessage(message, cause) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log(message, cause, someInfo);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified message at the warning log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logWarning
 */


function logWarning(message) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log(message, tsplus_module_3.empty, someWarning);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified cause at the warning log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logWarningCause
 */


function logWarningCause(cause) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log("", cause, someWarning);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified message and cause at the warning log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logWarningCauseMessage
 */


function logWarningCauseMessage(message, cause) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log(message, cause, someWarning);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified message at the trace log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logTrace
 */


function logTrace(message) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log(message, tsplus_module_3.empty, someTrace);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified cause at the trace log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logTraceCause
 */


function logTraceCause(cause) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log("", cause, someTrace);
    return tsplus_module_4.unit;
  });
}
/**
 * Logs the specified message and cause at the trace log level.
 *
 * @tsplus static effect/core/io/Effect.Ops logTraceCauseMessage
 */


function logTraceCauseMessage(message, cause) {
  return tsplus_module_5.withFiberRuntime(fiberState => {
    fiberState.log(message, cause, someTrace);
    return tsplus_module_4.unit;
  });
}
/**
 * Adjusts the label for the current logging span.
 *
 * @tsplus static effect/core/io/Effect.Ops logSpan
 */


function logSpan(label) {
  return effect => tsplus_module_11.flatMap(stack => tsplus_module_11.flatMap(now => tsplus_module_9.suspendSucceed(() => {
    const logSpan = tsplus_module_6.apply(label, now);
    return tsplus_module_8.currentLogSpan.locally(tsplus_module_7.prepend(logSpan)(stack))(effect);
  }))(tsplus_module_10.currentTime))(tsplus_module_8.currentLogSpan.get);
}
/**
 * Annotates each log in this effect with the specified log annotation.
 *
 * @tsplus static effect/core/io/Effect.Ops logAnnotate
 */


function logAnnotate(key, value) {
  return effect => tsplus_module_11.flatMap(annotations => tsplus_module_9.suspendSucceed(() => tsplus_module_8.currentLogAnnotations.locally(tsplus_module_12.set(key, value)(annotations))(effect)))(tsplus_module_8.currentLogAnnotations.get);
}
/**
 * Retrieves the log annotations associated with the current scope.
 *
 * @tsplus static effect/core/io/Effect.Ops logAnnotations
 */


function logAnnotations() {
  return tsplus_module_8.currentLogAnnotations.get;
}
//# sourceMappingURL=logging.js.map