import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Loops with the specified effectual function purely for its effects. The
 * moral equivalent of:
 *
 * ```typescript
 * var s = initial
 *
 * while (cont(s)) {
 *   body(s)
 *   s = inc(s)
 * }
 * ```
 * @tsplus static effect/core/io/Effect.Ops loopDiscard
 * @tsplus location "@effect/core/io/Effect/operations/loopDiscard"
 */
export declare function loopDiscard<Z>(initial: Z, cont: (z: Z) => boolean, inc: (z: Z) => Z): <R, E, X>(body: (z: Z) => import("../definition").Effect<R, E, X>) => import("../definition").Effect<R, E, void>;
//# sourceMappingURL=loopDiscard.d.ts.map