import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Statefully and effectfully maps over the elements of this chunk to produce
 * new elements.
 * @tsplus static effect/core/io/Effect.Ops mapAccum
 * @tsplus location "@effect/core/io/Effect/operations/mapAccum"
 */
export declare function mapAccum<A, B, R, E, S>(self: Collection<A>, s: S, f: (s: S, a: A) => Effect<R, E, readonly [S, B]>): Effect<R, E, readonly [S, Chunk<B>]>;
//# sourceMappingURL=mapAccum.d.ts.map