import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns an effect whose success is mapped by the specified side effecting
 * `f` function, translating any thrown exceptions into typed failed effects.
 * @tsplus static effect/core/io/Effect.Aspects mapTryCatch
 * @tsplus pipeable effect/core/io/Effect mapTryCatch
 * @tsplus location "@effect/core/io/Effect/operations/mapTryCatch"
 */
export declare function mapTryCatch<A, B, E1>(f: (a: A) => B, onThrow: (u: unknown) => E1): <R, E>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R, E1 | E, B>;
//# sourceMappingURL=mapTryCatch.d.ts.map