import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Lifts an `Maybe` into a `IO`. If the option is empty it succeeds with
 * `undefined`. If the option is defined it fails with the content.
 * @tsplus static effect/core/io/Effect.Ops noneOrFail
 * @tsplus location "@effect/core/io/Effect/operations/noneOrFail"
 */
export declare function noneOrFail<E>(option: Maybe<E>): Effect<never, E, void>;
//# sourceMappingURL=noneOrFail.d.ts.map