import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Lifts an `Maybe` into a `IO`. If the option is empty it succeeds with
 * `undefined`. If the option is defined it fails with an error adapted with
 * the specified function.
 * @tsplus static effect/core/io/Effect.Ops noneOrFailWith
 * @tsplus location "@effect/core/io/Effect/operations/noneOrFailWith"
 */
export declare function noneOrFailWith<E, A>(option: Maybe<A>, f: (a: A) => E): Effect<never, E, void>;
//# sourceMappingURL=noneOrFailWith.d.ts.map