import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Effect } from "@effect/core/io/Effect/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Returns an effect that will produce the value of this effect, unless it
 * fails, in which case, it will produce the value of the specified effect.
 * @tsplus static effect/core/io/Effect.Aspects orElseEither
 * @tsplus pipeable effect/core/io/Effect orElseEither
 * @tsplus location "@effect/core/io/Effect/operations/orElseEither"
 */
export declare function orElseEither<R2, E2, A2>(that: LazyArg<Effect<R2, E2, A2>>): <R, E, A>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R2 | R, E2, import("@tsplus/stdlib/data/Either").Either<A, A2>>;
//# sourceMappingURL=orElseEither.d.ts.map