import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Returns an effect that will produce the value of this effect, unless it
 * fails with the `None` value, in which case it will produce the value of
 * the specified effect.
 * @tsplus static effect/core/io/Effect.Aspects orElseOptional
 * @tsplus pipeable effect/core/io/Effect orElseOptional
 * @tsplus location "@effect/core/io/Effect/operations/orElseOptional"
 */
export declare function orElseOptional<R, E, A, R2, E2, A2>(that: LazyArg<Effect<R2, Maybe<E2>, A2>>): (self: Effect<R, Maybe<E>, A>) => Effect<R | R2, Maybe<E | E2>, A | A2>;
//# sourceMappingURL=orElseOptional.d.ts.map