import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Feeds elements of type `A` to a function `f` that returns an effect.
 * Collects all successes and failures in a tupled fashion.
 * @tsplus static effect/core/io/Effect.Ops partition
 * @tsplus location "@effect/core/io/Effect/operations/partition"
 */
export declare function partition<R, E, A, B>(as: Collection<A>, f: (a: A) => Effect<R, E, B>): Effect<R, never, readonly [Chunk<E>, Chunk<B>]>;
//# sourceMappingURL=partition.d.ts.map