import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Feeds elements of type `A` to a function `f` that returns an effect.
 * Collects all successes and failures in parallel and returns the result as a
 * tuple.
 * @tsplus static effect/core/io/Effect.Ops partitionPar
 * @tsplus location "@effect/core/io/Effect/operations/partitionPar"
 */
export declare function partitionPar<R, E, A, B>(as: Collection<A>, f: (a: A) => Effect<R, E, B>): Effect<R, never, readonly [Chunk<E>, Chunk<B>]>;
//# sourceMappingURL=partitionPar.d.ts.map