"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.promise = promise;
exports.tryCatchPromise = tryCatchPromise;
exports.tryPromise = tryPromise;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/fail"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/async"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/tryCatch"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/attempt"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/die"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/sync"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Create an `Effect` that when executed will construct `promise` and wait for
 * its result, errors will be handled using `onReject`.
 *
 * @tsplus static effect/core/io/Effect.Ops tryCatchPromise
 */
function tryCatchPromise(promise, onReject) {
  return tsplus_module_5.flatMap(promise => tsplus_module_3._async(resolve => {
    promise.then(a => resolve(tsplus_module_2.succeed(a))).catch(e => resolve(tsplus_module_1.fail(onReject(e))));
  }))(tsplus_module_4.tryCatch(promise, onReject));
}
/**
 * Create an `Effect` that when executed will construct `promise` and wait for
 * its result, errors will produce failure as `unknown`.
 *
 * @tsplus static effect/core/io/Effect.Ops tryPromise
 */


function tryPromise(promise) {
  return tsplus_module_5.flatMap(promise => tsplus_module_3._async(resolve => {
    promise.then(a => resolve(tsplus_module_2.succeed(a))).catch(e => resolve(tsplus_module_1.fail(e)));
  }))(tsplus_module_6.attempt(promise));
}
/**
 * Like `tryPromise` but produces a defect in case of errors.
 *
 * @tsplus static effect/core/io/Effect.Ops promise
 */


function promise(promise) {
  return tsplus_module_5.flatMap(promise => tsplus_module_3._async(resolve => {
    promise.then(a => resolve(tsplus_module_2.succeed(a))).catch(e => resolve(tsplus_module_7.die(e)));
  }))(tsplus_module_8.sync(promise));
}
//# sourceMappingURL=promise.js.map