import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Fiber } from "@effect/core/io/Fiber/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Deferred } from "@effect/core/io/Deferred/definition";
import { Ref } from "@effect/core/io/Ref/definition";
import { Exit } from "@effect/core/io/Exit/definition";
/**
 * Returns an effect that races this effect with all the specified effects,
 * yielding the value of the first effect to succeed with a value. Losers of
 * the race will be interrupted immediately
 * @tsplus static effect/core/io/Effect.Aspects raceAll
 * @tsplus pipeable effect/core/io/Effect raceAll
 * @tsplus location "@effect/core/io/Effect/operations/raceAll"
 */
export declare function raceAll<R1, E1, A1>(effects: Collection<Effect<R1, E1, A1>>): <R, E, A>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R1 | R, E1 | E, A1 | A>;
//# sourceMappingURL=raceAll.d.ts.map