"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.raceAll = raceAll;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unit"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/interrupt"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipLeft"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/reduce"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/inheritAll"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/as"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipRight"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/prepend"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/excl-forEach"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/size"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Ref/operations/make"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Deferred/operations/make"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/sync"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatten"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/foldEffect"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Returns an effect that races this effect with all the specified effects,
 * yielding the value of the first effect to succeed with a value. Losers of
 * the race will be interrupted immediately
 *
 * @tsplus static effect/core/io/Effect.Aspects raceAll
 * @tsplus pipeable effect/core/io/Effect raceAll
 */
function raceAll(effects) {
  return self => tsplus_module_5.flatMap(ios => tsplus_module_5.flatMap(done => tsplus_module_5.flatMap(fails => tsplus_module_6.uninterruptibleMask(({
    restore
  }) => tsplus_module_5.flatMap(head => tsplus_module_5.flatMap(tail => {
    const fs = tsplus_module_10.prepend(head)(tail);
    return tsplus_module_5.flatMap(() => {
      const inheritAll = res => tsplus_module_8.as(res[0])(tsplus_module_7.inheritAll(res[1]));

      return tsplus_module_6.onInterrupt(() => tsplus_module_4.reduce(tsplus_module_1.unit, (io, fiber) => tsplus_module_3.zipLeft(tsplus_module_2.interrupt(fiber))(io))(fs))(restore(tsplus_module_5.flatMap(inheritAll)(done.await)));
    })(tsplus_module_4.reduce(tsplus_module_1.unit, (io, fiber) => tsplus_module_9.zipRight(tsplus_module_6.fork(tsplus_module_5.flatMap(arbiter(fs, fiber, done, fails))(fiber.await)))(io))(fs));
  })(tsplus_module_11.forEach(ios, io => tsplus_module_6.fork(tsplus_module_6.interruptible(io)))))(tsplus_module_6.fork(tsplus_module_6.interruptible(self)))))(tsplus_module_13.makeRef(() => tsplus_module_12.size(ios))))(tsplus_module_14.make()))(tsplus_module_16.sync(() => tsplus_module_15.from(effects)));
}

function arbiter(fibers, winner, promise, fails) {
  return exit => {
    return tsplus_module_18.foldEffect(e => tsplus_module_17.flatten(fails.modify(c => [c === 0 ? tsplus_module_1.asUnit(promise.failCause(() => e)) : tsplus_module_1.unit, c - 1])), a => tsplus_module_5.flatMap(set => set ? tsplus_module_4.reduce(tsplus_module_1.unit, (io, fiber) => fiber === winner ? io : tsplus_module_3.zipLeft(tsplus_module_2.interrupt(fiber))(io))(fibers) : tsplus_module_1.unit)(promise.succeed([a, winner])))(exit);
  };
}
//# sourceMappingURL=raceAll.js.map