import { Effect } from "@effect/core/io/Effect/definition";
import { Fiber } from "@effect/core/io/Fiber/definition";
import { AtomicReference } from "@tsplus/stdlib/data/AtomicReference";
/**
 * Forks this effect and the specified effect into their own fibers, and races
 * them, calling one of two specified callbacks depending on which fiber wins
 * the race. This method does not interrupt, join, or otherwise do anything
 * with the fibers. It can be considered a low-level building block for
 * higher-level operators like `race`.
 * @tsplus static effect/core/io/Effect.Aspects raceFibersWith
 * @tsplus pipeable effect/core/io/Effect raceFibersWith
 * @tsplus location "@effect/core/io/Effect/operations/raceFibersWith"
 */
export declare function raceFibersWith<E, A, R1, E1, A1, R2, E2, A2, R3, E3, A3>(that: Effect<R1, E1, A1>, selfWins: (winner: Fiber<E, A>, loser: Fiber<E1, A1>) => Effect<R2, E2, A2>, thatWins: (winner: Fiber<E1, A1>, loser: Fiber<E, A>) => Effect<R3, E3, A3>): <R>(self: Effect<R, E, A>) => Effect<R | R1 | R2 | R3, E2 | E3, A2 | A3>;
//# sourceMappingURL=raceFibersWith.d.ts.map