import { Effect } from "@effect/core/io/Effect/definition";
import { Exit } from "@effect/core/io/Exit/definition";
import { Fiber } from "@effect/core/io/Fiber/definition";
/**
 * Returns an effect that races this effect with the specified effect, calling
 * the specified finisher as soon as one result or the other has been computed.
 * @tsplus static effect/core/io/Effect.Aspects raceWith
 * @tsplus pipeable effect/core/io/Effect raceWith
 * @tsplus location "@effect/core/io/Effect/operations/raceWith"
 */
export declare function raceWith<E, A, R1, E1, A1, R2, E2, A2, R3, E3, A3>(that: Effect<R1, E1, A1>, leftDone: (exit: Exit<E, A>, fiber: Fiber<E1, A1>) => Effect<R2, E2, A2>, rightDone: (exit: Exit<E1, A1>, fiber: Fiber<E, A>) => Effect<R3, E3, A3>): <R>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R1 | R2 | R3 | R, E2 | E3, A2 | A3>;
//# sourceMappingURL=raceWith.d.ts.map