import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Folds an `Collection<A>` using an effectual function f, working sequentially from left to right.
 * @tsplus static effect/core/io/Effect.Ops reduce
 * @tsplus location "@effect/core/io/Effect/operations/reduce"
 */
export declare function reduce<A, Z, R, E>(as: Collection<A>, z: Z, f: (z: Z, a: A) => Effect<R, E, Z>): Effect<R, E, Z>;
//# sourceMappingURL=reduce.d.ts.map