import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Folds an `Collection<A>` using an effectual function f, working sequentially from left to right.
 * @tsplus static effect/core/io/Effect.Ops reduceRight
 * @tsplus location "@effect/core/io/Effect/operations/reduceRight"
 */
export declare function reduceRight_<A, Z, R, E>(as: Collection<A>, z: Z, f: (a: A, z: Z) => Effect<R, E, Z>): Effect<R, E, Z>;
//# sourceMappingURL=reduceRight.d.ts.map