"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reduceWhile = reduceWhile;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/suspendSucceed"));

var _Chunk = /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Folds over the elements in this chunk from the left.
 * Stops the fold early when the condition is not fulfilled.
 *
 * @tsplus static effect/core/io/Effect.Ops reduceWhile
 */
function reduceWhile(self, s, p, f) {
  const chunk = tsplus_module_1.from(self);

  const iterator = chunk._arrayLikeIterator();

  const next = iterator.next();

  if (next.done) {
    return tsplus_module_2.succeed(s);
  } else {
    const array = next.value;
    const length = array.length;
    return reduceWhileLoop(s, iterator, array, 0, length, p, f);
  }
}

function reduceWhileLoop(s, iterator, array, i, length, p, f) {
  if (i < length) {
    if (p(s)) {
      return tsplus_module_3.flatMap(s1 => reduceWhileLoop(s1, iterator, array, i + 1, length, p, f))(f(s, array[i]));
    } else {
      return tsplus_module_2.succeed(s);
    }
  } else {
    const next = iterator.next();

    if (next.done) {
      return tsplus_module_2.succeed(s);
    } else {
      const arr = next.value;
      return tsplus_module_4.suspendSucceed(() => reduceWhileLoop(s, iterator, arr, 0, arr.length, p, f));
    }
  }
}
//# sourceMappingURL=reduceWhile.js.map