import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Continue with the returned computation if the `PartialFunction` matches,
 * translating the successful match into a failure, otherwise continue with
 * our held value.
 * @tsplus static effect/core/io/Effect.Aspects rejectEffect
 * @tsplus pipeable effect/core/io/Effect rejectEffect
 * @tsplus location "@effect/core/io/Effect/operations/rejectEffect"
 */
export declare function rejectEffect<A, R1, E1>(pf: (a: A) => Maybe<Effect<R1, E1, E1>>): <R, E>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R1 | R, E1 | E, A>;
//# sourceMappingURL=rejectEffect.d.ts.map