import { Schedule } from "@effect/core/io/Schedule/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns a new effect that repeats this effect according to the specified
 * schedule or until the first failure. Scheduled recurrences are in addition
 * to the first execution, so that `io.repeat(Schedule.once)` yields an effect
 * that executes `io`, and then if that succeeds, executes `io` an additional
 * time.
 * @tsplus static effect/core/io/Effect.Aspects repeat
 * @tsplus pipeable effect/core/io/Effect repeat
 * @tsplus location "@effect/core/io/Effect/operations/repeat"
 */
export declare function repeat<S, R1, A, B>(schedule: Schedule<S, R1, A, B>): <R, E>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R1 | R, E, B>;
//# sourceMappingURL=repeat.d.ts.map