import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns a new effect that repeats this effect the specified number of times
 * or until the first failure. Repeats are in addition to the first execution,
 * so that `io.repeatN(1)` yields an effect that executes `io`, and then if
 * that succeeds, executes `io` an additional time.
 * @tsplus static effect/core/io/Effect.Aspects repeatN
 * @tsplus pipeable effect/core/io/Effect repeatN
 * @tsplus location "@effect/core/io/Effect/operations/repeatN"
 */
export declare function repeatN(n: number): <R, E, A>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R, E, A>;
//# sourceMappingURL=repeatN.d.ts.map