import { Schedule } from "@effect/core/io/Schedule/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns a new effect that repeats this effect according to the specified
 * schedule or until the first failure, at which point, the failure value and
 * schedule output are passed to the specified handler.
 *
 * Scheduled recurrences are in addition to the first execution, so that
 * `io.repeat(Schedule.once)` yields an effect that executes `io`, and then if
 * that succeeds, executes `io` an additional time.
 * @tsplus static effect/core/io/Effect.Aspects repeatOrElse
 * @tsplus pipeable effect/core/io/Effect repeatOrElse
 * @tsplus location "@effect/core/io/Effect/operations/repeatOrElse"
 */
export declare function repeatOrElse<S, R1, A, B, E, R2, E2>(schedule: Schedule<S, R1, A, B>, orElse: (e: E, option: Maybe<B>) => Effect<R2, E2, B>): <R>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R1 | R2 | R, E2, B>;
//# sourceMappingURL=repeatOrElse.d.ts.map