import { Schedule } from "@effect/core/io/Schedule/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Retries with the specified retry policy. Retries are done following the
 * failure of the original `io` (up to a fixed maximum with `once` or `recurs`
 * for example), so that that `io.retry(Schedule.once)` means "execute `io`
 * and in case of failure, try again once".
 * @tsplus static effect/core/io/Effect.Aspects retry
 * @tsplus pipeable effect/core/io/Effect retry
 * @tsplus location "@effect/core/io/Effect/operations/retry"
 */
export declare function retry<S, R1, E, B>(policy: Schedule<S, R1, E, B>): <R, A>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R1 | R, E, A>;
//# sourceMappingURL=retry.d.ts.map