import { Schedule } from "@effect/core/io/Schedule/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Retries with the specified schedule, until it fails, and then both the
 * value produced by the schedule together with the last error are passed to
 * the recovery function.
 * @tsplus static effect/core/io/Effect.Aspects retryOrElse
 * @tsplus pipeable effect/core/io/Effect retryOrElse
 * @tsplus location "@effect/core/io/Effect/operations/retryOrElse"
 */
export declare function retryOrElse<S, R1, E extends E3, A1, R2, E2, A2, E3>(policy: Schedule<S, R1, E3, A1>, orElse: (e: E, out: A1) => Effect<R2, E2, A2>): <R, A>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R1 | R2 | R, E | E2, A2 | A>;
//# sourceMappingURL=retryOrElse.d.ts.map