import { Schedule } from "@effect/core/io/Schedule/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Retries with the specified schedule, until it fails, and then both the
 * value produced by the schedule together with the last error are passed to
 * the recovery function.
 * @tsplus static effect/core/io/Effect.Aspects retryOrElseEither
 * @tsplus pipeable effect/core/io/Effect retryOrElseEither
 * @tsplus location "@effect/core/io/Effect/operations/retryOrElseEither"
 */
export declare function retryOrElseEither<S, R1, E extends E3, A1, R2, E2, A2, E3>(policy: Schedule<S, R1, E3, A1>, orElse: (e: E, out: A1) => Effect<R2, E2, A2>): <R, A>(self: Effect<R, E, A>) => Effect<R | R1 | R2, E | E2, Either<A2, A>>;
//# sourceMappingURL=retryOrElseEither.d.ts.map