"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultRuntime = exports.defaultFlags = void 0;
exports.runtime = runtime;
exports.unsafeRunWith = exports.unsafeRunSyncExit = exports.unsafeRunSync = exports.unsafeRunPromiseExit = exports.unsafeRunPromise = exports.unsafeRunAsyncWith = exports.unsafeRunAsync = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Runtime/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/withFiberRuntime"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/RuntimeFlags/definition"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/service/Env"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableMap/empty"));

var _FiberRefs = /*#__PURE__*/require("@effect/core/io/FiberRefs");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Returns an effect that accesses the runtime, which can be used to
 * (unsafely) execute tasks. This is useful for integration with legacy code
 * that must call back into Effect code.
 *
 * @tsplus static effect/core/io/Effect.Ops runtime
 */
function runtime() {
  return tsplus_module_4.withFiberRuntime((state, status) => tsplus_module_3.succeed(new tsplus_module_1.Runtime(state.getFiberRef(tsplus_module_2.currentEnvironment), status.runtimeFlags, state.getFiberRefs)));
}

const defaultFlags = /*#__PURE__*/tsplus_module_5.RuntimeFlags(tsplus_module_5.RuntimeFlags.FiberRoots, tsplus_module_5.RuntimeFlags.Interruption, tsplus_module_5.RuntimeFlags.CooperativeYielding);
exports.defaultFlags = defaultFlags;
const defaultRuntime = /*#__PURE__*/new tsplus_module_1.Runtime(tsplus_module_6.Env.empty, defaultFlags, /*#__PURE__*/new _FiberRefs.FiberRefs( /*#__PURE__*/tsplus_module_7.empty()));
/**
 * @tsplus fluent effect/core/io/Effect unsafeRunPromise
 * @tsplus static effect/core/io/Effect.Aspects unsafeRunPromise
 */

exports.defaultRuntime = defaultRuntime;
const unsafeRunPromise = defaultRuntime.unsafeRunPromise;
/**
 * @tsplus fluent effect/core/io/Effect unsafeRunAsync
 * @tsplus static effect/core/io/Effect.Aspects unsafeRunAsync
 */

exports.unsafeRunPromise = unsafeRunPromise;
const unsafeRunAsync = defaultRuntime.unsafeRunAsync;
/**
 * @tsplus fluent effect/core/io/Effect unsafeRunAsyncWith
 * @tsplus static effect/core/io/Effect.Aspects unsafeRunAsyncWith
 */

exports.unsafeRunAsync = unsafeRunAsync;
const unsafeRunAsyncWith = defaultRuntime.unsafeRunAsyncWith;
/**
 * @tsplus fluent effect/core/io/Effect unsafeRunPromiseExit
 * @tsplus static effect/core/io/Effect.Aspects unsafeRunPromiseExit
 */

exports.unsafeRunAsyncWith = unsafeRunAsyncWith;
const unsafeRunPromiseExit = defaultRuntime.unsafeRunPromiseExit;
/**
 * @tsplus fluent effect/core/io/Effect unsafeRunWith
 * @tsplus static effect/core/io/Effect.Aspects unsafeRunWith
 */

exports.unsafeRunPromiseExit = unsafeRunPromiseExit;
const unsafeRunWith = defaultRuntime.unsafeRunWith;
/**
 * @tsplus fluent effect/core/io/Effect unsafeRunSync
 * @tsplus static effect/core/io/Effect.Aspects unsafeRunSync
 */

exports.unsafeRunWith = unsafeRunWith;
const unsafeRunSync = defaultRuntime.unsafeRunSync;
/**
 * @tsplus fluent effect/core/io/Effect unsafeRunSyncExit
 * @tsplus static effect/core/io/Effect.Aspects unsafeRunSyncExit
 */

exports.unsafeRunSync = unsafeRunSync;
const unsafeRunSyncExit = defaultRuntime.unsafeRunSyncExit;
exports.unsafeRunSyncExit = unsafeRunSyncExit;
//# sourceMappingURL=runtime.js.map