import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Scopes all resources uses in this workflow to the lifetime of the workflow,
 * ensuring that their finalizers are run as soon as this workflow completes
 * execution, whether by success, failure, or interruption.
 * @tsplus static effect/core/io/Effect.Ops scoped
 * @tsplus getter effect/core/io/Effect scoped
 * @tsplus location "@effect/core/io/Effect/operations/scoped"
 */
export declare function scoped<R, E, A>(effect: Effect<R, E, A>): Effect<Exclude<R, Scope>, E, A>;
//# sourceMappingURL=scoped.d.ts.map