import { Effect } from "@effect/core/io/Effect/definition";
import { EnforceNonEmptyRecord } from "@tsplus/stdlib/utilities/Types";
import type { EffectURI } from "@effect/core/io/Effect/definition/base";
/**
 * Applicative structure.
 * @tsplus static effect/core/io/Effect.Ops struct
 * @tsplus location "@effect/core/io/Effect/operations/struct"
 */
export declare function struct<NER extends Record<string, Effect<any, any, any>>>(r: EnforceNonEmptyRecord<NER> | Record<string, Effect<any, any, any>>): Effect<[
    NER[keyof NER]
] extends [{
    [EffectURI]: {
        _R: (_: never) => infer R;
    };
}] ? R : never, [
    NER[keyof NER]
] extends [{
    [EffectURI]: {
        _E: (_: never) => infer E;
    };
}] ? E : never, {
    [K in keyof NER]: [NER[K]] extends [{
        [EffectURI]: {
            _A: (_: never) => infer A;
        };
    }] ? A : never;
}>;
/**
 * Applicative structure processed in parallel.
 * @tsplus static effect/core/io/Effect.Ops structPar
 * @tsplus location "@effect/core/io/Effect/operations/struct"
 */
export declare function structPar<NER extends Record<string, Effect<any, any, any>>>(r: EnforceNonEmptyRecord<NER> | Record<string, Effect<any, any, any>>): Effect<[
    NER[keyof NER]
] extends [{
    [EffectURI]: {
        _R: (_: never) => infer R;
    };
}] ? R : never, [
    NER[keyof NER]
] extends [{
    [EffectURI]: {
        _E: (_: never) => infer E;
    };
}] ? E : never, {
    [K in keyof NER]: [NER[K]] extends [{
        [EffectURI]: {
            _A: (_: never) => infer A;
        };
    }] ? A : never;
}>;
//# sourceMappingURL=struct.d.ts.map