import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns a lazily constructed effect, whose construction may itself require
 * effects. When no environment is required (i.e., when `R == unknown`) it is
 * conceptually equivalent to `flatten(succeed(io))`.
 * @tsplus static effect/core/io/Effect.Ops suspend
 * @tsplus location "@effect/core/io/Effect/operations/suspend"
 */
export declare function suspend<R, E, A>(f: LazyArg<Effect<R, E, A>>): Effect<R, unknown, A>;
//# sourceMappingURL=suspend.d.ts.map