import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns an effect that effectfully "peeks" at the success of this effect.
 * If the partial function isn't defined at the input, the result is
 * equivalent to the original effect.
 * @tsplus static effect/core/io/Effect.Aspects tapSome
 * @tsplus pipeable effect/core/io/Effect tapSome
 * @tsplus location "@effect/core/io/Effect/operations/tapSome"
 */
export declare function tapSome<A, R1, E1, X>(pf: (a: A) => Maybe<Effect<R1, E1, X>>): <R, E>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R1 | R, E1 | E, A>;
//# sourceMappingURL=tapSome.d.ts.map