import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Cause } from "@effect/core/io/Cause/definition";
import { Duration } from "@tsplus/stdlib/data/Duration";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * The same as `timeout`, but instead of producing a `None` in the event of
 * timeout, it will produce the specified failure.
 * @tsplus static effect/core/io/Effect.Aspects timeoutFailCause
 * @tsplus pipeable effect/core/io/Effect timeoutFailCause
 * @tsplus location "@effect/core/io/Effect/operations/timeoutFailCause"
 */
export declare function timeoutFailCause<E1>(cause: LazyArg<Cause<E1>>, duration: Duration): <R, E, A>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R, E1 | E, A>;
//# sourceMappingURL=timeoutFailCause.d.ts.map