import { Duration } from "@tsplus/stdlib/data/Duration";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns an effect that will timeout this effect, returning either the
 * default value if the timeout elapses before the effect has produced a
 * value or returning the result of applying the function `f` to the
 * success value of the effect.
 *
 * If the timeout elapses without producing a value, the running effect will
 * be safely interrupted.
 * @tsplus static effect/core/io/Effect.Aspects timeoutTo
 * @tsplus pipeable effect/core/io/Effect timeoutTo
 * @tsplus location "@effect/core/io/Effect/operations/timeoutTo"
 */
export declare function timeoutTo<A, B, B1>(def: B1, f: (a: A) => B, duration: Duration): <R, E>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R, E, B | B1>;
//# sourceMappingURL=timeoutTo.d.ts.map