import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Imports a synchronous side-effect into a pure value, translating any
 * thrown exceptions into typed failed effects.
 * @tsplus static effect/core/io/Effect.Ops tryCatch
 * @tsplus location "@effect/core/io/Effect/operations/tryCatch"
 */
export declare function tryCatch<E, A>(attempt: LazyArg<A>, onThrow: (u: unknown) => E): Effect<never, E, A>;
//# sourceMappingURL=tryCatch.d.ts.map