import { Effect } from "@effect/core/io/Effect/definition";
import { Cause } from "@effect/core/io/Cause/definition";
/**
 * When this effect succeeds with a cause, then this method returns a new
 * effect that either fails with the cause that this effect succeeded with, or
 * succeeds with unit, depending on whether the cause is empty.
 *
 * This operation is the opposite of `cause`.
 * @tsplus getter effect/core/io/Effect uncause
 * @tsplus location "@effect/core/io/Effect/operations/uncause"
 */
export declare function uncause<R, E>(self: Effect<R, never, Cause<E>>): Effect<R, E, void>;
//# sourceMappingURL=uncause.d.ts.map