import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Constructs a `Chunk` by repeatedly applying the effectual function `f` as
 * long as it returns `Some`.
 * @tsplus static effect/core/io/Effect.Ops unfold
 * @tsplus location "@effect/core/io/Effect/operations/unfold"
 */
export declare function unfold<A, R, E, S>(s: S, f: (s: S) => Effect<R, E, Maybe<readonly [A, S]>>): Effect<R, E, Chunk<A>>;
//# sourceMappingURL=unfold.d.ts.map