import { Effect } from "@effect/core/io/Effect/definition";
/**
 * An effect that succeeds with a unit value.
 * @tsplus static effect/core/io/Effect.Ops unit
 * @tsplus location "@effect/core/io/Effect/operations/unit"
 */
export declare const unit: Effect<never, never, void>;
/**
 * An effect that succeeds with a unit value.
 * @tsplus static effect/core/io/Effect.Ops unitTraced
 * @tsplus location "@effect/core/io/Effect/operations/unit"
 */
export declare function unitTraced(): Effect<never, never, void>;
/**
 * Ignores the result of the effect replacing it with a void
 * @tsplus getter effect/core/io/Effect unit
 * @tsplus location "@effect/core/io/Effect/operations/unit"
 */
export declare function asUnit<R, E, X>(self: Effect<R, E, X>): Effect<R, E, void>;
//# sourceMappingURL=unit.d.ts.map