import { Effect } from "@effect/core/io/Effect/definition";
import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Sequentially zips the this result with the specified result. Combines both
 * `Cause<E1>` when both effects fail.
 * @tsplus static effect/core/io/Effect.Aspects validate
 * @tsplus pipeable effect/core/io/Effect validate
 * @tsplus location "@effect/core/io/Effect/operations/validate"
 */
export declare function validateNow<R1, E1, B>(that: Effect<R1, E1, B>): <R, E, A>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R1 | R, E1 | E, readonly [A, B]>;
/**
 * Feeds elements of type `A` to `f` and accumulates all errors in error
 * channel or successes in success channel.
 *
 * This combinator is lossy meaning that if there are errors all successes
 * will be lost. To retain all information please use `partition`.
 * @tsplus static effect/core/io/Effect.Ops validate
 * @tsplus location "@effect/core/io/Effect/operations/validate"
 */
export declare function validate<R, E, A, B>(as: Collection<A>, f: (a: A) => Effect<R, E, B>): Effect<R, Chunk<E>, Chunk<B>>;
//# sourceMappingURL=validate.d.ts.map