import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Feeds elements of type `A` to `f` until it succeeds. Returns first success
 * or the accumulation of all errors.
 * @tsplus static effect/core/io/Effect.Ops validateFirst
 * @tsplus location "@effect/core/io/Effect/operations/validateFirst"
 */
export declare function validateFirst<R, E, A, B>(as: Collection<A>, f: (a: A) => Effect<R, E, B>): Effect<R, Chunk<E>, B>;
//# sourceMappingURL=validateFirst.d.ts.map