import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Feeds elements of type `A` to `f` in parallel and accumulates all errors,
 * discarding the successes.
 * @tsplus static effect/core/io/Effect.Ops validateParDiscard
 * @tsplus location "@effect/core/io/Effect/operations/validateParDiscard"
 */
export declare function validateParDiscard<R, E, A, X>(as: Collection<A>, f: (a: A) => Effect<R, E, X>): Effect<R, Chunk<E>, void>;
//# sourceMappingURL=validateParDiscard.d.ts.map