import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns an effect that executes both this effect and the specified effect,
 * in parallel, combining their results with the specified `f` function. If
 * both sides fail, then the cause will be combined.
 * @tsplus static effect/core/io/Effect.Aspects validateWithPar
 * @tsplus pipeable effect/core/io/Effect validateWithPar
 * @tsplus location "@effect/core/io/Effect/operations/validateWithPar"
 */
export declare function validateWithPar<A, R1, E1, B, C>(that: Effect<R1, E1, B>, f: (a: A, b: B) => C): <R, E>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<R1 | R, E1 | E, C>;
//# sourceMappingURL=validateWithPar.d.ts.map