import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * A low-level while-loop with direct support in the ZIO runtime. The only
 * reason to use this constructor is performance.
 *
 * See [[Effect.iterate]] for a user-friendly version of this operator that is
 * compatible with purely functional code.
 * @tsplus static effect/core/io/Effect.Ops whileLoop
 * @tsplus location "@effect/core/io/Effect/operations/whileLoop"
 */
export declare function whileLoop<R, E, A>(check: LazyArg<boolean>, body: LazyArg<Effect<R, E, A>>, process: (a: A) => void): Effect<R, E, A>;
//# sourceMappingURL=whileLoop.d.ts.map