"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.whileLoop = whileLoop;

var _primitives = /*#__PURE__*/require("@effect/core/io/Effect/definition/primitives");

/**
 * A low-level while-loop with direct support in the ZIO runtime. The only
 * reason to use this constructor is performance.
 *
 * See [[Effect.iterate]] for a user-friendly version of this operator that is
 * compatible with purely functional code.
 *
 * @tsplus static effect/core/io/Effect.Ops whileLoop
 */
function whileLoop(check, body, process) {
  return new _primitives.IWhileLoop(check, body, process);
}
//# sourceMappingURL=whileLoop.js.map