import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Treats this effect as the acquisition of a resource and adds the
 * specified finalizer to the current scope. This effect will be run
 * uninterruptibly and the finalizer will be run when the scope is closed.
 * @tsplus static effect/core/io/Effect.Aspects withFinalizer
 * @tsplus pipeable effect/core/io/Effect withFinalizer
 * @tsplus location "@effect/core/io/Effect/operations/withFinalizer"
 */
export declare function withFinalizer<R2, X>(finalizer: Effect<R2, never, X>): <R, E, A>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<import("../../Scope").Scope | R2 | R, E, A>;
//# sourceMappingURL=withFinalizer.d.ts.map