import { Exit } from "@effect/core/io/Exit/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * A more powerful variant of `withFinalizer` that allows the finalizer to
 * depend on the `Exit` value that the scope is closed with.
 * @tsplus static effect/core/io/Effect.Aspects withFinalizerExit
 * @tsplus pipeable effect/core/io/Effect withFinalizerExit
 * @tsplus location "@effect/core/io/Effect/operations/withFinalizerExit"
 */
export declare function withFinalizerExit<R2, X>(finalizer: (exit: Exit<unknown, unknown>) => Effect<R2, never, X>): <R, E, A>(self: import("../definition").Effect<R, E, A>) => import("../definition").Effect<import("../../Scope").Scope | R2 | R, E, A>;
//# sourceMappingURL=withFinalizerExit.d.ts.map