"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withRuntimeFlags = withRuntimeFlags;

var _primitives = /*#__PURE__*/require("@effect/core/io/Effect/definition/primitives");

/**
 * Returns a new Effect that will update the runtime flags according to
 * the specified patch within the scope of this Effect.
 *
 * @tsplus pipeable effect/core/io/Effect withRuntimeFlags
 */
function withRuntimeFlags(update) {
  return self => new _primitives.IUpdateRuntimeFlagsDynamic(update, () => self);
}
//# sourceMappingURL=withRuntimeFlags.js.map