"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.zipWithPar = zipWithPar;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/raceFibersWith"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/fiberIdWith"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/transplant"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Cause/definition"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/failCause"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/fold"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/interruptAs"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/inheritAll"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipRight"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/sync"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/await"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Sequentially zips this effect with the specified effect using the
 * specified combiner function.
 *
 * @tsplus static effect/core/io/Effect.Aspects zipWithPar
 * @tsplus pipeable effect/core/io/Effect zipWithPar
 */
function zipWithPar(that, f) {
  return self => {
    const g = (b, a) => f(a, b);

    return tsplus_module_4.uninterruptibleMask(mask => tsplus_module_3.transplant(graft => tsplus_module_2.fiberIdWith(fiberId => tsplus_module_1.raceFibersWith(graft(mask.restore(that)), (w, l) => coordinate(fiberId, f, true, w, l), (w, l) => coordinate(fiberId, g, false, w, l))(graft(mask.restore(self))))));
  };
}

function coordinate(fiberId, f, leftWinner, winner, loser) {
  return tsplus_module_9.flatMap(winnerExit => tsplus_module_7.fold(winnerCause => tsplus_module_9.flatMap(loserExit => tsplus_module_7.fold(loserCause => leftWinner ? tsplus_module_6.failCause(tsplus_module_5.combinePar(winnerCause, loserCause)) : tsplus_module_6.failCause(tsplus_module_5.combinePar(loserCause, winnerCause)), () => tsplus_module_6.failCause(winnerCause))(loserExit))(tsplus_module_8.interruptAsNow(fiberId)(loser)), a => tsplus_module_9.flatMap(loserExit => tsplus_module_7.fold(loserCause => tsplus_module_6.failCause(loserCause), b => tsplus_module_11.zipRight(tsplus_module_12.sync(() => f(a, b)))(tsplus_module_11.zipRight(tsplus_module_10.inheritAll(loser))(tsplus_module_10.inheritAll(winner))))(loserExit))(tsplus_module_13._await(loser)))(winnerExit))(tsplus_module_13._await(winner));
}
//# sourceMappingURL=zipWithPar.js.map