"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fold = fold;

/**
 * Folds over the value or cause.
 *
 * @tsplus static effect/core/io/Exit.Aspects fold
 * @tsplus pipeable effect/core/io/Exit fold
 */
function fold(failed, completed) {
  return self => {
    switch (self._tag) {
      case "Failure":
        return failed(self.cause);

      case "Success":
        return completed(self.value);
    }
  };
}
//# sourceMappingURL=fold.js.map