import { Cause } from "@effect/core/io/Cause/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Exit } from "@effect/core/io/Exit/definition";
/**
 * Sequentially zips the this result with the specified result or else returns
 * the failed `Cause<E>`.
 * @tsplus static effect/core/io/Exit.Aspects foldEffect
 * @tsplus pipeable effect/core/io/Exit foldEffect
 * @tsplus location "@effect/core/io/Exit/operations/foldEffect"
 */
export declare function foldEffect<E, A, R1, E1, A1, R2, E2, A2>(failed: (cause: Cause<E>) => Effect<R1, E1, A1>, completed: (a: A) => Effect<R2, E2, A2>): (self: Exit<E, A>) => Effect<R1 | R2, E1 | E2, A1 | A2>;
//# sourceMappingURL=foldEffect.d.ts.map