"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.foldEffect = foldEffect;

/**
 * Sequentially zips the this result with the specified result or else returns
 * the failed `Cause<E>`.
 *
 * @tsplus static effect/core/io/Exit.Aspects foldEffect
 * @tsplus pipeable effect/core/io/Exit foldEffect
 */
function foldEffect(failed, completed) {
  return self => {
    switch (self._tag) {
      case "Failure":
        return failed(self.cause);

      case "Success":
        return completed(self.value);
    }
  };
}
//# sourceMappingURL=foldEffect.js.map