"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fold = fold;

var _definition = /*#__PURE__*/require("@effect/core/io/Fiber/definition");

/**
 * Folds over the runtime or synthetic fiber.
 *
 * @tsplus static effect/core/io/Fiber.Aspects fold
 * @tsplus static effect/core/io/RuntimeFiber.Aspects fold
 * @tsplus pipeable effect/core/io/Fiber fold
 * @tsplus pipeable effect/core/io/RuntimeFiber fold
 */
function fold(onRuntime, onSynthetic) {
  return self => {
    void 0;

    switch (self._tag) {
      case "RuntimeFiber":
        {
          return onRuntime(self);
        }

      case "SyntheticFiber":
        {
          return onSynthetic(self);
        }
    }
  };
}
//# sourceMappingURL=fold.js.map