import { Fiber } from "@effect/core/io/Fiber/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Exit } from "@effect/core/io/Exit/definition";
/**
 * Interrupts the fiber from whichever fiber is calling this method. If the
 * fiber has already exited, the returned effect will resume immediately.
 * Otherwise, the effect will resume when the fiber exits.
 * @tsplus getter effect/core/io/Fiber interrupt
 * @tsplus getter effect/core/io/RuntimeFiber interrupt
 * @tsplus location "@effect/core/io/Fiber/operations/interrupt"
 */
export declare function interrupt<E, A>(self: Fiber<E, A>): Effect<never, never, Exit<E, A>>;
//# sourceMappingURL=interrupt.d.ts.map