import { Fiber } from "@effect/core/io/Fiber/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Interrupts the fiber from whichever fiber is calling this method. The
 * interruption will happen in a separate daemon fiber, and the returned
 * effect will always resume immediately without waiting.
 * @tsplus getter effect/core/io/Fiber interruptFork
 * @tsplus getter effect/core/io/RuntimeFiber interruptFork
 * @tsplus location "@effect/core/io/Fiber/operations/interruptFork"
 */
export declare function interruptFork<E, A>(self: Fiber<E, A>): Effect<never, never, void>;
//# sourceMappingURL=interruptFork.d.ts.map