import { Fiber } from "@effect/core/io/Fiber/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Joins the fiber, which suspends the joining fiber until the result of the
 * fiber has been determined. Attempting to join a fiber that has erred will
 * result in a catchable error. Joining an interrupted fiber will result in an
 * "inner interruption" of this fiber, unlike interruption triggered by
 * another fiber, "inner interruption" can be caught and recovered.
 * @tsplus getter effect/core/io/Fiber join
 * @tsplus getter effect/core/io/RuntimeFiber join
 * @tsplus location "@effect/core/io/Fiber/operations/join"
 */
export declare function join<E, A>(self: Fiber<E, A>): Effect<never, E, A>;
//# sourceMappingURL=join.d.ts.map