import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Fiber } from "@effect/core/io/Fiber/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Joins all fibers, awaiting their _successful_ completion. Attempting to
 * join a fiber that has erred will result in a catchable error, _if_ that
 * error does not result from interruption.
 * @tsplus static effect/core/io/Fiber.Ops joinAll
 * @tsplus location "@effect/core/io/Fiber/operations/joinAll"
 */
export declare function joinAll<E, A>(fibers: Collection<Fiber<E, A>>): Effect<never, E, void>;
//# sourceMappingURL=joinAll.d.ts.map