import { Fiber } from "@effect/core/io/Fiber/definition";
/**
 * Returns a fiber that prefers `this` fiber, but falls back to the `that` one
 * when `this` one fails. Interrupting the returned fiber will interrupt both
 * fibers, sequentially, from left to right.
 * @tsplus pipeable-operator effect/core/io/Fiber |
 * @tsplus pipeable-operator effect/core/io/RuntimeFiber |
 * @tsplus static effect/core/io/Fiber.Aspects orElse
 * @tsplus static effect/core/io/RuntimeFiber.Aspects orElse
 * @tsplus pipeable effect/core/io/Fiber orElse
 * @tsplus pipeable effect/core/io/RuntimeFiber orElse
 * @tsplus location "@effect/core/io/Fiber/operations/orElse"
 */
export declare function orElse<E2, A2>(that: Fiber<E2, A2>): <E, A>(self: import("@effect/core/io/Fiber/definition").Fiber<E, A>) => import("@effect/core/io/Fiber/definition").Fiber<E2 | E, A2 | A>;
//# sourceMappingURL=orElse.d.ts.map