"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.orElse = orElse;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/id"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/FiberId/operations/getOrElse"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/await"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipWith"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/children"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/inheritAll"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipRight"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/interruptAs"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/poll"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fold"));

var _definition2 = /*#__PURE__*/require("@effect/core/io/Fiber/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Returns a fiber that prefers `this` fiber, but falls back to the `that` one
 * when `this` one fails. Interrupting the returned fiber will interrupt both
 * fibers, sequentially, from left to right.
 *
 * @tsplus pipeable-operator effect/core/io/Fiber |
 * @tsplus pipeable-operator effect/core/io/RuntimeFiber |
 * @tsplus static effect/core/io/Fiber.Aspects orElse
 * @tsplus static effect/core/io/RuntimeFiber.Aspects orElse
 * @tsplus pipeable effect/core/io/Fiber orElse
 * @tsplus pipeable effect/core/io/RuntimeFiber orElse
 */
function orElse(that) {
  return self => (0, _definition2.makeSynthetic)({
    id: tsplus_module_2.getOrElse(() => tsplus_module_1.id(that))(tsplus_module_1.id(self)),
    await: tsplus_module_4.zipWith(tsplus_module_3._await(that), (e1, e2) => e1._tag === "Success" ? e1 : e2)(tsplus_module_3._await(self)),
    children: tsplus_module_5.children(self),
    inheritAll: tsplus_module_7.zipRight(tsplus_module_6.inheritAll(self))(tsplus_module_6.inheritAll(that)),
    interruptAsFork: id => tsplus_module_7.zipRight(tsplus_module_8.interruptAsNow(id)(that))(tsplus_module_8.interruptAsNow(id)(self)),
    poll: tsplus_module_4.zipWith(tsplus_module_9.poll(that), (o1, o2) => tsplus_module_11.fold(() => tsplus_module_10.none, _ => _._tag === "Success" ? o1 : o2)(o1))(tsplus_module_9.poll(self))
  });
}
//# sourceMappingURL=orElse.js.map