import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Fiber } from "@effect/core/io/Fiber/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Returns a fiber that prefers `this` fiber, but falls back to the `that` one
 * when `this` one fails. Interrupting the returned fiber will interrupt both
 * fibers, sequentially, from left to right.
 * @tsplus static effect/core/io/Fiber.Aspects orElseEither
 * @tsplus static effect/core/io/RuntimeFiber.Aspects orElseEither
 * @tsplus pipeable effect/core/io/Fiber orElseEither
 * @tsplus pipeable effect/core/io/RuntimeFiber orElseEither
 * @tsplus location "@effect/core/io/Fiber/operations/orElseEither"
 */
export declare function orElseEither<E2, A2>(that: LazyArg<Fiber<E2, A2>>): <E, A>(self: import("../definition").Fiber<E, A>) => import("../definition").Fiber<E2 | E, import("@tsplus/stdlib/data/Either").Either<A, A2>>;
//# sourceMappingURL=orElseEither.d.ts.map