import { Fiber } from "@effect/core/io/Fiber/definition";
/**
 * Zips this fiber with the specified fiber, combining their results using the
 * specified combiner function. Both joins and interruptions are performed in
 * sequential order from left to right.
 * @tsplus static effect/core/io/Fiber.Aspects zipWith
 * @tsplus static effect/core/io/RuntimeFiber.Aspects zipWith
 * @tsplus pipeable effect/core/io/Fiber zipWith
 * @tsplus pipeable effect/core/io/RuntimeFiber zipWith
 * @tsplus location "@effect/core/io/Fiber/operations/zipWith"
 */
export declare function zipWith<E2, A, B, C>(that: Fiber<E2, B>, f: (a: A, b: B) => C): <E>(self: import("@effect/core/io/Fiber/definition").Fiber<E, A>) => import("@effect/core/io/Fiber/definition").Fiber<E2 | E, C>;
//# sourceMappingURL=zipWith.d.ts.map