import { Equals } from "@tsplus/stdlib/structure/Equals";
import { Hash } from "@tsplus/stdlib/structure/Hash";
import { RuntimeFlags } from "@effect/core/io/RuntimeFlags/definition";
import { FiberId } from "@effect/core/io/FiberId/definition";
export declare const FiberStatusSym: unique symbol;
export type FiberStatusSym = typeof FiberStatusSym;
/**
 * @tsplus type effect/core/io/Fiber/Status
 */
export type FiberStatus = Done | Running | Suspended;
/**
 * @tsplus type effect/core/io/Fiber/Status.Ops
 */
export interface FiberStatusOps {
}
export declare const FiberStatus: FiberStatusOps;
export declare class Done implements Equals {
    readonly _tag = "Done";
    readonly [FiberStatusSym]: FiberStatusSym;
    [Hash.sym](): number;
    [Equals.sym](that: unknown): boolean;
}
export declare class Running implements Equals {
    readonly runtimeFlags: RuntimeFlags;
    readonly _tag = "Running";
    readonly [FiberStatusSym]: FiberStatusSym;
    constructor(runtimeFlags: RuntimeFlags);
    [Hash.sym](): number;
    [Equals.sym](that: unknown): boolean;
}
export declare class Suspended implements Equals {
    readonly runtimeFlags: RuntimeFlags;
    readonly blockingOn: FiberId;
    readonly _tag = "Suspended";
    readonly [FiberStatusSym]: FiberStatusSym;
    constructor(runtimeFlags: RuntimeFlags, blockingOn: FiberId);
    [Hash.sym](): number;
    [Equals.sym](that: unknown): boolean;
}
/**
 * @tsplus static effect/core/io/Fiber/Status.Ops isFiberStatus
 * @tsplus location "@effect/core/io/Fiber/status"
 */
export declare function isFiberStatus(u: unknown): u is FiberStatus;
//# sourceMappingURL=status.d.ts.map