"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isFiberStatus = exports.Suspended = exports.Running = exports.FiberStatusSym = exports.FiberStatus = exports.Done = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a, _b, _c;

const isFiberStatus = isFiberStatus_1;
exports.isFiberStatus = isFiberStatus;
const FiberStatusSym = /*#__PURE__*/Symbol.for("@effect/core/Fiber/FiberStatus");
exports.FiberStatusSym = FiberStatusSym;
const FiberStatus = {};
exports.FiberStatus = FiberStatus;

class Done {
  constructor() {
    this._tag = "Done";
    this[_a] = FiberStatusSym;
  }

  [(_a = FiberStatusSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.hashString(this._tag);
  }

  [tsplus_module_2.Equals.sym](that) {
    return isFiberStatus_1(that) && that._tag === "Done";
  }

}

exports.Done = Done;

class Running {
  constructor(runtimeFlags) {
    this.runtimeFlags = runtimeFlags;
    this._tag = "Running";
    this[_b] = FiberStatusSym;
  }

  [(_b = FiberStatusSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString(this._tag), tsplus_module_1.hashNumber(this.runtimeFlags));
  }

  [tsplus_module_2.Equals.sym](that) {
    return isFiberStatus_1(that) && that._tag === "Running" && this.runtimeFlags === that.runtimeFlags;
  }

}

exports.Running = Running;

class Suspended {
  constructor(runtimeFlags, blockingOn) {
    this.runtimeFlags = runtimeFlags;
    this.blockingOn = blockingOn;
    this._tag = "Suspended";
    this[_c] = FiberStatusSym;
  }

  [(_c = FiberStatusSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString(this._tag), tsplus_module_1.combine(tsplus_module_1.hashNumber(this.runtimeFlags), tsplus_module_1.hashUnknown(this.blockingOn)));
  }

  [tsplus_module_2.Equals.sym](that) {
    return isFiberStatus_1(that) && that._tag === "Suspended" && this.runtimeFlags === that.runtimeFlags && tsplus_module_2.equals(this.blockingOn, that.blockingOn);
  }

}
/**
 * @tsplus static effect/core/io/Fiber/Status.Ops isFiberStatus
 */


exports.Suspended = Suspended;

function isFiberStatus_1(u) {
  return typeof u === "object" && u != null && FiberStatusSym in u;
}
//# sourceMappingURL=status.js.map