"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isFiberId = exports.RuntimeFiberId = exports.None = exports.FiberIdSym = exports.FiberId = exports.CompositeFiberId = void 0;
exports.realFiberId = realFiberId;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashSet/operations/equals"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a, _b, _c;

const isFiberId = isFiberId_1;
exports.isFiberId = isFiberId;
const FiberIdSym = /*#__PURE__*/Symbol.for("@effect/core/io/FiberId");
exports.FiberIdSym = FiberIdSym;
const FiberId = {
  $: {}
};
/**
 * @tsplus macro remove
 */

exports.FiberId = FiberId;

function realFiberId(_) {//
}

class None {
  constructor() {
    this._tag = "None";
    this[_a] = FiberIdSym;
  }

  [(_a = FiberIdSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.hashString(this._tag);
  }

  [tsplus_module_2.Equals.sym](that) {
    if (isFiberId_1(that)) {
      void 0;
      return that._tag === "None";
    }

    return false;
  }

}

exports.None = None;

class RuntimeFiberId {
  constructor(id, startTimeMillis) {
    this.id = id;
    this.startTimeMillis = startTimeMillis;
    this._tag = "Runtime";
    this[_b] = FiberIdSym;
  }

  [(_b = FiberIdSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString(this._tag), tsplus_module_1.combine(tsplus_module_1.hashNumber(this.id), tsplus_module_1.hashNumber(this.startTimeMillis)));
  }

  [tsplus_module_2.Equals.sym](that) {
    if (isFiberId_1(that)) {
      void 0;
      return this._tag === that._tag && this.id === that.id && this.startTimeMillis === that.startTimeMillis;
    }

    return false;
  }

}

exports.RuntimeFiberId = RuntimeFiberId;

class CompositeFiberId {
  constructor(fiberIds) {
    this.fiberIds = fiberIds;
    this._tag = "Composite";
    this[_c] = FiberIdSym;
  }

  [(_c = FiberIdSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString(this._tag), tsplus_module_1.hashUnknown(this.fiberIds));
  }

  [tsplus_module_2.Equals.sym](that) {
    if (isFiberId_1(that)) {
      void 0;
      return that._tag === "Composite" && tsplus_module_3.equals(that.fiberIds)(this.fiberIds);
    }

    return false;
  }

}
/**
 * Checks if the specified unknown value is a `FiberId`.
 *
 * @tsplus static effect/core/io/FiberId.Ops isFiberId
 */


exports.CompositeFiberId = CompositeFiberId;

function isFiberId_1(self) {
  return typeof self === "object" && self != null && FiberIdSym in self;
}
//# sourceMappingURL=definition.js.map