"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.combine = combine;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashSet/operations/from"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashSet/operations/add"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashSet/operations/union"));

var _definition = /*#__PURE__*/require("@effect/core/io/FiberId/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Combine two `FiberId`s.
 *
 * @tsplus pipeable-operator effect/core/io/FiberId +
 * @tsplus static effect/core/io/FiberId.Aspects combine
 * @tsplus pipeable effect/core/io/FiberId combine
 */
function combine(that) {
  return self => {
    void 0;

    switch (self._tag) {
      case "None":
        {
          return that;
        }

      case "Runtime":
        {
          void 0;

          switch (that._tag) {
            case "None":
              {
                return self;
              }

            case "Runtime":
              {
                return new _definition.CompositeFiberId(tsplus_module_1.from([self, that]));
              }

            case "Composite":
              {
                return new _definition.CompositeFiberId(tsplus_module_2.add(self)(that.fiberIds));
              }
          }
        }

      case "Composite":
        {
          void 0;

          switch (that._tag) {
            case "None":
              {
                return self;
              }

            case "Runtime":
              {
                return new _definition.CompositeFiberId(tsplus_module_2.add(that)(self.fiberIds));
              }

            case "Composite":
              {
                return new _definition.CompositeFiberId(tsplus_module_3.union(that.fiberIds)(self.fiberIds));
              }
          }
        }
    }
  };
}
//# sourceMappingURL=combine.js.map