"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isNone = isNone;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/io/Eval/run"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/io/Eval/succeed"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/io/Eval/suspend"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/io/Eval/zipWith"));

var _definition = /*#__PURE__*/require("@effect/core/io/FiberId/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Determines if the `FiberId` is a `None`.
 *
 * @tsplus fluent effect/core/io/FiberId isNone
 */
function isNone(self) {
  return tsplus_module_1.run(isNoneSafe(self));
}

function isNoneSafe(self) {
  void 0;

  switch (self._tag) {
    case "None":
      {
        return tsplus_module_2.succeed(() => true);
      }

    case "Runtime":
      {
        return tsplus_module_2.succeed(() => false);
      }

    case "Composite":
      {
        let base = tsplus_module_2.succeed(() => true);

        for (const fiberId of self.fiberIds) {
          base = tsplus_module_4.zipWith(base, (a, b) => a && b)(tsplus_module_3.suspend(() => isNoneSafe(fiberId)));
        }

        return base;
      }
  }
}
//# sourceMappingURL=isNone.js.map