"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.globalScope = exports._roots = exports.Local = exports.Global = exports.FiberScope = void 0;
exports.make = make;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/FiberId/operations/none"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/RuntimeFlags/definition"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/RuntimeFlags/operations/isEnabled"));

var _message = /*#__PURE__*/require("@effect/core/io/Fiber/_internal/message");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const FiberScope = {};
exports.FiberScope = FiberScope;

class Global {
  constructor() {
    this.fiberId = tsplus_module_1.none;
  }

  add(runtimeFlags, child) {
    if (tsplus_module_3.isEnabled(tsplus_module_2.RuntimeFlags.FiberRoots)(runtimeFlags)) {
      _roots_1.add(child);

      child.addObserver(() => {
        _roots_1.delete(child);
      });
    }
  }

}

exports.Global = Global;

class Local {
  constructor(fiberId, parent) {
    this.fiberId = fiberId;
    this.parent = parent;
  }

  add(_runtimeFlags, child) {
    this.parent.tell(new _message.Stateful(parentFiber => {
      parentFiber.addChild(child);
      child.addObserver(() => {
        parentFiber.removeChild(child);
      });
    }));
  }

}
/**
 * The global scope. Anything forked onto the global scope is not supervised,
 * and will only terminate on its own accord (never from interruption of a
 * parent fiber, because there is no parent fiber).
 *
 * @tsplus static effect/core/io/FiberScope.Ops global
 */


exports.Local = Local;
const globalScope = /*#__PURE__*/new Global();
/**
 * Unsafely creats a new `Scope` from a `Fiber`.
 *
 * @tsplus static effect/core/io/FiberScope.Ops make
 */

exports.globalScope = globalScope;

function make(fiber) {
  return new Local(fiber.id, fiber);
}
/**
 * @tsplus static effect/core/io/FiberScope.Ops _roots
 */


const _roots_1 = /*#__PURE__*/new Set();

const _roots = _roots_1;
exports._roots = _roots;
//# sourceMappingURL=definition.js.map