"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeBounded = makeBounded;

var _BoundedHubArb = /*#__PURE__*/require("@effect/core/io/Hub/operations/_internal/BoundedHubArb");

var _BoundedHubPow = /*#__PURE__*/require("@effect/core/io/Hub/operations/_internal/BoundedHubPow2");

var _BoundedHubSingle = /*#__PURE__*/require("@effect/core/io/Hub/operations/_internal/BoundedHubSingle");

var _errors = /*#__PURE__*/require("@effect/core/io/Hub/operations/_internal/errors");

function nextPow2(n) {
  const nextPow = Math.ceil(Math.log(n) / Math.log(2.0));
  return Math.max(Math.pow(2, nextPow), 2);
}

function makeBounded(requestedCapacity) {
  (0, _errors.ensureCapacity)(requestedCapacity);

  if (requestedCapacity === 1) {
    return new _BoundedHubSingle.BoundedHubSingle();
  } else if (nextPow2(requestedCapacity) === requestedCapacity) {
    return new _BoundedHubPow.BoundedHubPow2(requestedCapacity);
  } else {
    return new _BoundedHubArb.BoundedHubArb(requestedCapacity);
  }
}
//# sourceMappingURL=makeBounded.js.map