"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeHub = makeHub;
exports.unsafeMakeHub = unsafeMakeHub;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/mutable/MutableHashSet/empty"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/AtomicBoolean"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Deferred/operations/make"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Scope/operations/make"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/single"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/suspendSucceed"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/isEmpty"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Scope/operations/addFinalizer"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/tap"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/sync"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/interrupt"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Scope/operations/close"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipRight"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/whenEffect"));

var tsplus_module_19 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unit"));

var tsplus_module_20 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/withFiberRuntime"));

var _definition = /*#__PURE__*/require("@effect/core/io/Hub/definition");

var _makeSubscription = /*#__PURE__*/require("@effect/core/io/Hub/operations/_internal/makeSubscription");

var _unsafePublishAll = /*#__PURE__*/require("@effect/core/io/Hub/operations/_internal/unsafePublishAll");

var _definition2 = /*#__PURE__*/require("@effect/core/io/Queue/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Creates a hub with the specified strategy.
 */
function makeHub(hub, strategy) {
  return tsplus_module_6.flatMap(scope => tsplus_module_4.map(deferred => unsafeMakeHub(hub, tsplus_module_1.empty(), scope, deferred, new tsplus_module_2.AtomicBoolean(false), strategy))(tsplus_module_3.make()))(tsplus_module_5.make);
}

class HubImpl {
  get [_definition2._In]() {
    return a => a;
  }

  get [_definition.HubSym]() {
    return _definition.HubSym;
  }

  get [_definition2.QueueSym]() {
    return _definition2.QueueSym;
  }

  constructor(hub, subscribers, scope, shutdownHook, shutdownFlag, strategy) {
    this.hub = hub;
    this.subscribers = subscribers;
    this.scope = scope;
    this.shutdownHook = shutdownHook;
    this.shutdownFlag = shutdownFlag;
    this.strategy = strategy;
  }

  publish(a) {
    return tsplus_module_10.suspendSucceed(() => {
      if (this.shutdownFlag.get) {
        return tsplus_module_7.interrupt;
      }

      if (this.hub.publish(a)) {
        this.strategy.unsafeCompleteSubscribers(this.hub, this.subscribers);
        return tsplus_module_8.succeed(true);
      }

      return this.strategy.handleSurplus(this.hub, this.subscribers, tsplus_module_9.single(a), this.shutdownFlag);
    });
  }

  publishAll(as) {
    return tsplus_module_10.suspendSucceed(() => {
      if (this.shutdownFlag.get) {
        return tsplus_module_7.interrupt;
      }

      const surplus = (0, _unsafePublishAll.unsafePublishAll)(this.hub, as);
      this.strategy.unsafeCompleteSubscribers(this.hub, this.subscribers);

      if (tsplus_module_11.isEmpty(surplus)) {
        return tsplus_module_8.succeed(true);
      }

      return this.strategy.handleSurplus(this.hub, this.subscribers, surplus, this.shutdownFlag);
    });
  }

  get subscribe() {
    return tsplus_module_7.acquireRelease(tsplus_module_13.tap(dequeue => tsplus_module_12.addFinalizer(dequeue.shutdown)(this.scope))((0, _makeSubscription.makeSubscription)(this.hub, this.subscribers, this.strategy)), dequeue => dequeue.shutdown);
  }

  offer(a) {
    return this.publish(a);
  }

  offerAll(as) {
    return this.publishAll(as);
  }

  get capacity() {
    return this.hub.capacity;
  }

  get size() {
    return tsplus_module_10.suspendSucceed(() => this.shutdownFlag.get ? tsplus_module_7.interrupt : tsplus_module_14.sync(() => this.hub.size));
  }

  get awaitShutdown() {
    return this.shutdownHook.await;
  }

  get isShutdown() {
    return tsplus_module_14.sync(() => this.shutdownFlag.get);
  }

  get shutdown() {
    return tsplus_module_7.uninterruptible(tsplus_module_20.withFiberRuntime(state => {
      this.shutdownFlag.set(true);
      return tsplus_module_19.asUnit(tsplus_module_18.whenEffect(this.shutdownHook.succeed(undefined), tsplus_module_17.zipRight(this.strategy.shutdown)(tsplus_module_16.close(tsplus_module_15.interrupt(state.id))(this.scope))));
    }));
  }

  get isFull() {
    return tsplus_module_4.map(size => size === this.capacity)(this.size);
  }

  get isEmpty() {
    return tsplus_module_4.map(size => size === 0)(this.size);
  }

}
/**
 * Unsafely creates a hub with the specified strategy.
 */


function unsafeMakeHub(hub, subscribers, scope, shutdownHook, shutdownFlag, strategy) {
  return new HubImpl(hub, subscribers, scope, shutdownHook, shutdownFlag, strategy);
}
//# sourceMappingURL=makeHub.js.map