import { MutableHashSet } from "@tsplus/stdlib/collections/mutable/MutableHashSet/definition";
import { MutableQueue } from "@tsplus/stdlib/collections/mutable/MutableQueue/definition";
import { Deferred } from "@effect/core/io/Deferred/definition";
import { Dequeue } from "@effect/core/io/Queue/definition/common";
import { AtomicBoolean } from "@tsplus/stdlib/data/AtomicBoolean";
import { EmptyMutableQueue } from "@tsplus/stdlib/collections/mutable/MutableQueue";
import { Effect } from "@effect/core/io/Effect/definition";
import type { AtomicHub } from "@effect/core/io/Hub/operations/_internal/AtomicHub";
import type { Subscription } from "@effect/core/io/Hub/operations/_internal/Subscription";
import type { Strategy } from "@effect/core/io/Hub/operations/strategy";
/**
 * Creates a subscription with the specified strategy.
 */
export declare function makeSubscription<A>(hub: AtomicHub<A>, subscribers: MutableHashSet<readonly [Subscription<A>, MutableQueue<Deferred<never, A>>]>, strategy: Strategy<A>): Effect<never, never, Dequeue<A>>;
/**
 * Unsafely creates a subscription with the specified strategy.
 */
export declare function unsafeMakeSubscription<A>(hub: AtomicHub<A>, subscribers: MutableHashSet<readonly [Subscription<A>, MutableQueue<Deferred<never, A>>]>, subscription: Subscription<A>, pollers: MutableQueue<Deferred<never, A>>, shutdownHook: Deferred<never, void>, shutdownFlag: AtomicBoolean, strategy: Strategy<A>): Dequeue<A>;
//# sourceMappingURL=makeSubscription.d.ts.map