"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeSubscription = makeSubscription;
exports.unsafeMakeSubscription = unsafeMakeSubscription;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/mutable/MutableQueue/unbounded"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/AtomicBoolean"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Deferred/operations/make"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/mutable/MutableQueue"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/sync"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/suspendSucceed"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/withFiberRuntime"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/concat"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/append"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/head"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/excl-forEach"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipRight"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/whenEffect"));

var tsplus_module_19 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unit"));

var _unsafePollAllSubscription = /*#__PURE__*/require("@effect/core/io/Hub/operations/_internal/unsafePollAllSubscription");

var _unsafePollN = /*#__PURE__*/require("@effect/core/io/Hub/operations/_internal/unsafePollN");

var _unsafeRemove = /*#__PURE__*/require("@effect/core/io/Hub/operations/_internal/unsafeRemove");

var _definition = /*#__PURE__*/require("@effect/core/io/Queue/definition");

var _unsafePollAll = /*#__PURE__*/require("@effect/core/io/Queue/operations/_internal/unsafePollAll");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Creates a subscription with the specified strategy.
 */
function makeSubscription(hub, subscribers, strategy) {
  return tsplus_module_4.map(deferred => unsafeMakeSubscription(hub, subscribers, hub.subscribe(), tsplus_module_1.unbounded(), deferred, new tsplus_module_2.AtomicBoolean(false), strategy))(tsplus_module_3.make());
}

class SubscriptionImpl {
  get [_definition.QueueSym]() {
    return _definition.QueueSym;
  }

  get [_definition._Out]() {
    return a => a;
  }

  constructor(hub, subscribers, subscription, pollers, shutdownHook, shutdownFlag, strategy) {
    this.hub = hub;
    this.subscribers = subscribers;
    this.subscription = subscription;
    this.pollers = pollers;
    this.shutdownHook = shutdownHook;
    this.shutdownFlag = shutdownFlag;
    this.strategy = strategy;
  }

  get take() {
    return tsplus_module_10.withFiberRuntime(state => {
      if (this.shutdownFlag.get) {
        return tsplus_module_5.interrupt;
      }

      const message = this.pollers.isEmpty ? this.subscription.poll(tsplus_module_6.EmptyMutableQueue) : tsplus_module_6.EmptyMutableQueue;

      if (message === tsplus_module_6.EmptyMutableQueue) {
        const deferred = tsplus_module_5.unsafeMakeDeferred(state.id);
        return tsplus_module_5.onInterrupt(() => tsplus_module_7.sync(() => (0, _unsafeRemove.unsafeRemove)(this.pollers, deferred)))(tsplus_module_8.suspendSucceed(() => {
          this.pollers.offer(deferred);
          this.subscribers.add([this.subscription, this.pollers]);
          this.strategy.unsafeCompletePollers(this.hub, this.subscribers, this.subscription, this.pollers);
          return this.shutdownFlag.get ? tsplus_module_5.interrupt : deferred.await;
        }));
      } else {
        this.strategy.unsafeOnHubEmptySpace(this.hub, this.subscribers);
        return tsplus_module_9.succeed(message);
      }
    });
  }

  get takeAll() {
    return tsplus_module_8.suspendSucceed(() => {
      if (this.shutdownFlag.get) {
        return tsplus_module_5.interrupt;
      }

      const as = this.pollers.isEmpty ? (0, _unsafePollAllSubscription.unsafePollAllSubscription)(this.subscription) : tsplus_module_11.empty();
      this.strategy.unsafeOnHubEmptySpace(this.hub, this.subscribers);
      return tsplus_module_9.succeed(as);
    });
  }

  takeUpTo(max) {
    return tsplus_module_8.suspendSucceed(() => {
      if (this.shutdownFlag.get) {
        return tsplus_module_5.interrupt;
      }

      const as = this.pollers.isEmpty ? (0, _unsafePollN.unsafePollN)(this.subscription, max) : tsplus_module_11.empty();
      this.strategy.unsafeOnHubEmptySpace(this.hub, this.subscribers);
      return tsplus_module_9.succeed(as);
    });
  }

  takeRemainderLoop(self, min, max, acc) {
    if (max < min) {
      return tsplus_module_9.succeed(acc);
    }

    return tsplus_module_14.flatMap(bs => {
      const remaining = min - bs.length;

      if (remaining === 1) {
        return tsplus_module_4.map(b => tsplus_module_13.append(b)(tsplus_module_12.concat(bs)(acc)))(self.take);
      }

      if (remaining > 1) {
        return tsplus_module_14.flatMap(b => this.takeRemainderLoop(self, remaining - 1, max - bs.length - 1, tsplus_module_13.append(b)(tsplus_module_12.concat(bs)(acc))))(self.take);
      }

      return tsplus_module_9.succeed(tsplus_module_12.concat(bs)(acc));
    })(self.takeUpTo(max));
  }

  takeBetween(min, max) {
    return tsplus_module_8.suspendSucceed(() => this.takeRemainderLoop(this, min, max, tsplus_module_11.empty()));
  }

  takeN(n) {
    return this.takeBetween(n, n);
  }

  get poll() {
    return tsplus_module_4.map(chunk => tsplus_module_15.head(chunk))(this.takeUpTo(1));
  }

  get capacity() {
    return this.hub.capacity;
  }

  get size() {
    return tsplus_module_8.suspendSucceed(() => this.shutdownFlag.get ? tsplus_module_5.interrupt : tsplus_module_9.succeed(this.subscription.size));
  }

  get awaitShutdown() {
    return this.shutdownHook.await;
  }

  get isShutdown() {
    return tsplus_module_7.sync(() => this.shutdownFlag.get);
  }

  get shutdown() {
    return tsplus_module_5.uninterruptible(tsplus_module_10.withFiberRuntime(state => {
      this.shutdownFlag.set(true);
      return tsplus_module_19.asUnit(tsplus_module_18.whenEffect(this.shutdownHook.succeed(undefined), tsplus_module_17.zipRight(tsplus_module_7.sync(() => this.strategy.unsafeOnHubEmptySpace(this.hub, this.subscribers)))(tsplus_module_17.zipRight(tsplus_module_7.sync(() => this.subscription.unsubscribe()))(tsplus_module_16.forEachPar((0, _unsafePollAll.unsafePollAll)(this.pollers), deferred => deferred.interruptAs(state.id))))));
    }));
  }

  get isFull() {
    return tsplus_module_4.map(size => size === this.capacity)(this.size);
  }

  get isEmpty() {
    return tsplus_module_4.map(size => size === 0)(this.size);
  }

}
/**
 * Unsafely creates a subscription with the specified strategy.
 */


function unsafeMakeSubscription(hub, subscribers, subscription, pollers, shutdownHook, shutdownFlag, strategy) {
  return new SubscriptionImpl(hub, subscribers, subscription, pollers, shutdownHook, shutdownFlag, strategy);
}
//# sourceMappingURL=makeSubscription.js.map