import { Effect } from "@effect/core/io/Effect/definition";
import { Hub } from "@effect/core/io/Hub/definition";
/**
 * Creates a bounded hub with the back pressure strategy. The hub will retain
 * messages until they have been taken by all subscribers, applying back
 * pressure to publishers if the hub is at capacity.
 *
 * For best performance use capacities that are powers of two.
 * @tsplus static effect/core/io/Hub.Ops bounded
 * @tsplus location "@effect/core/io/Hub/operations/bounded"
 */
export declare function bounded<A>(requestedCapacity: number): Effect<never, never, Hub<A>>;
//# sourceMappingURL=bounded.d.ts.map