import { Effect } from "@effect/core/io/Effect/definition";
import { Hub } from "@effect/core/io/Hub/definition";
/**
 * Creates a bounded hub with the sliding strategy. The hub will add new
 * messages and drop old messages if the hub is at capacity.
 *
 * For best performance use capacities that are powers of two.
 * @tsplus static effect/core/io/Hub.Ops sliding
 * @tsplus location "@effect/core/io/Hub/operations/sliding"
 */
export declare function sliding<A>(requestedCapacity: number): Effect<never, never, Hub<A>>;
//# sourceMappingURL=sliding.d.ts.map