"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Uninterruptible = exports.Interruptible = exports.InterruptStatusImpl = exports.InterruptStatus = void 0;
exports.fromBoolean = fromBoolean;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const InterruptStatus = {
  $: {}
};
exports.InterruptStatus = InterruptStatus;

class InterruptStatusImpl {
  constructor(isInterruptible) {
    this.isInterruptible = isInterruptible;
  }

  get isUninterruptible() {
    return !this.isInterruptible;
  }

  get toBoolean() {
    return this.isInterruptible;
  }

  [tsplus_module_1.Hash.sym]() {
    return tsplus_module_1.hashUnknown(this.isInterruptible);
  }

  [tsplus_module_2.Equals.sym](u) {
    return u instanceof InterruptStatusImpl && this.isInterruptible === u.isInterruptible;
  }

}
/**
 * Indicates the fiber can be interrupted right now.
 *
 * @tsplus static effect/core/io/InterruptStatus.Ops Interruptible
 */


exports.InterruptStatusImpl = InterruptStatusImpl;
const Interruptible_1 = /*#__PURE__*/new InterruptStatusImpl(true);
const Interruptible = Interruptible_1;
/**
 * Indicates the fiber cannot be interrupted right now.
 *
 * @tsplus static effect/core/io/InterruptStatus.Ops Uninterruptible
 */

exports.Interruptible = Interruptible;
const Uninterruptible_1 = /*#__PURE__*/new InterruptStatusImpl(false);
const Uninterruptible = Uninterruptible_1;
/**
 * @tsplus static effect/core/io/InterruptStatus.Ops fromBoolean
 */

exports.Uninterruptible = Uninterruptible;

function fromBoolean(b) {
  return b ? Interruptible_1 : Uninterruptible_1;
}
//# sourceMappingURL=definition.js.map