"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MemoMap = void 0;
exports.build = build;
exports.isFresh = exports.buildWithScope = void 0;
exports.makeMemoMap = makeMemoMap;
exports.withScope = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fromNullable"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unit"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Scope/operations/addFinalizerExit"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/fold"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/inheritFiberRefs"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/as"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/onExit"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Scope/operations/close"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipRight"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/failCause"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/whenEffect"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/getFiberRefs"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zip"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/exit"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Scope/operations/make"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/do"));

var tsplus_module_19 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_20 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Ref/operations/make"));

var tsplus_module_21 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_22 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Deferred/operations/make"));

var tsplus_module_23 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatten"));

var tsplus_module_24 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/sync"));

var tsplus_module_25 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Scope/definition"));

var tsplus_module_26 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/scopeWith"));

var tsplus_module_27 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/foldCauseEffect"));

var tsplus_module_28 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Scope/operations/extend"));

var tsplus_module_29 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipWithPar"));

var tsplus_module_30 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Match"));

var _definition2 = /*#__PURE__*/require("@effect/core/io/Layer/definition");

var _Function = /*#__PURE__*/require("@tsplus/stdlib/data/Function");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const buildWithScope = buildWithScope_1;
exports.buildWithScope = buildWithScope;
const withScope = withScope_1;
exports.withScope = withScope;
const isFresh = isFresh_1;
exports.isFresh = isFresh;

/**
 * A `MemoMap` memoizes layers.
 */
class MemoMap {
  constructor(ref) {
    this.ref = ref;
  }
  /**
   * Checks the memo map to see if a layer exists. If it is, immediately
   * returns it. Otherwise, obtains the layer, stores it in the memo map,
   * and adds a finalizer to the `Scope`.
   */


  getOrElseMemoize(layer, scope) {
    return tsplus_module_23.flatten(this.ref.modifyEffect(map => {
      const inMap = tsplus_module_1.fromNullable(map.get(layer));

      switch (inMap._tag) {
        case "Some":
          {
            const [acquire, release] = inMap.value;
            const cached = tsplus_module_8.onExit(exit => tsplus_module_4.fold(() => tsplus_module_2.unit, () => tsplus_module_3.addFinalizerExit(release)(scope))(exit))(tsplus_module_7.flatMap(([b, refs]) => tsplus_module_6.as(b)(tsplus_module_5.inheritFiberRefs(refs)))(acquire));
            return tsplus_module_9.succeed([cached, map]);
          }

        case "None":
          {
            return tsplus_module_7.flatMap(observers => tsplus_module_7.flatMap(deferred => tsplus_module_21.map(finalizerRef => {
              const resource = tsplus_module_19.uninterruptibleMask(({
                restore
              }) => tsplus_module_7.flatMap(({
                innerScope,
                outerScope
              }) => tsplus_module_7.flatMap(exit => {
                switch (exit._tag) {
                  case "Failure":
                    {
                      return tsplus_module_11.zipRight(tsplus_module_12.failCause(exit.cause))(tsplus_module_11.zipRight(tsplus_module_10.close(exit)(innerScope))(deferred.failCause(() => exit.cause)));
                    }

                  case "Success":
                    {
                      return tsplus_module_6.as(exit.value[0])(tsplus_module_11.zipRight(deferred.succeed(exit.value))(tsplus_module_11.zipRight(tsplus_module_3.addFinalizerExit(e => tsplus_module_7.flatMap(fin => fin(e))(finalizerRef.get))(outerScope))(tsplus_module_11.zipRight(observers.update(n => n + 1))(finalizerRef.set(exit => tsplus_module_13.whenEffect(observers.modify(n => [n === 1, n - 1]), tsplus_module_10.close(exit)(innerScope)))))));
                    }
                }
              })(tsplus_module_16.exit(restore(tsplus_module_7.flatMap(f => tsplus_module_15.zip(tsplus_module_14.getFiberRefs)(f(this)))(withScope_1(innerScope)(layer))))))(tsplus_module_18.bind("innerScope", () => tsplus_module_17.make)(tsplus_module_18.bindValue("outerScope", () => scope)(tsplus_module_18.Do()))));
              const memoized = [tsplus_module_8.onExit(exit => tsplus_module_4.fold(() => tsplus_module_2.unit, () => observers.update(n => n + 1))(exit))(deferred.await), e => tsplus_module_7.flatMap(fin => fin(e))(finalizerRef.get)];
              return [resource, isFresh_1(layer) ? map : map.set(layer, memoized)];
            })(tsplus_module_20.makeSynchronized(() => (0, _Function.constant)(tsplus_module_2.unit))))(tsplus_module_22.make()))(tsplus_module_20.makeSynchronized(() => 0));
          }
      }
    }));
  }

}
/**
 * Creates an empty `MemoMap`.
 */


exports.MemoMap = MemoMap;

function makeMemoMap() {
  return tsplus_module_7.flatMap(r => tsplus_module_24.sync(() => new MemoMap(r)))(tsplus_module_20.makeSynchronized(() => new Map()));
}
/**
 * Builds a layer into a scoped value.
 *
 * @tsplus getter effect/core/io/Layer build
 */


function build(self) {
  return tsplus_module_19.serviceWithEffect(tsplus_module_25.Scope.Tag, scope => buildWithScope_1(scope)(self));
}
/**
 * Builds a layer into an Effect value. Any resources associated with this layer
 * will be released when the specified scope is closed unless their scope has
 * been extended. This allows building layers where the lifetime of some of
 * the services output by the layer exceed the lifetime of the effect the
 * layer is provided to.
 *
 * @tsplus static effect/core/io/Layer.Aspects buildWithScope
 * @tsplus pipeable effect/core/io/Layer buildWithScope
 */


function buildWithScope_1(scope) {
  return self => tsplus_module_7.flatMap(memoMap => tsplus_module_7.flatMap(run => run(memoMap))(withScope_1(scope)(self)))(makeMemoMap());
}
/**
 * @tsplus static effect/core/io/Layer.Aspects withScope
 * @tsplus pipeable effect/core/io/Layer withScope
 */


function withScope_1(scope) {
  return self => tsplus_module_30.matchTag_(self, {
    LayerApply: _ => tsplus_module_24.sync(() => _memoMap => _.self),
    LayerExtendScope: _ => tsplus_module_24.sync(() => memoMap => tsplus_module_26.scopeWith(scope => memoMap.getOrElseMemoize(_.self, scope))),
    LayerFold: _ => tsplus_module_24.sync(() => memoMap => tsplus_module_27.foldCauseEffect(e => memoMap.getOrElseMemoize(_.failure(e), scope), r => memoMap.getOrElseMemoize(_.success(r), scope))(memoMap.getOrElseMemoize(_.self, scope))),
    LayerFresh: _ => tsplus_module_24.sync(() => __ => buildWithScope_1(scope)(_.self)),
    LayerScoped: _ => tsplus_module_24.sync(() => __ => tsplus_module_28.extend(_.self)(scope)),
    LayerSuspend: _ => tsplus_module_24.sync(() => memoMap => memoMap.getOrElseMemoize(_.self(), scope)),
    LayerTo: _ => tsplus_module_24.sync(() => memoMap => tsplus_module_7.flatMap(r => tsplus_module_19.provideEnvironment(r)(memoMap.getOrElseMemoize(_.that, scope)))(memoMap.getOrElseMemoize(_.self, scope))),
    LayerZipWithPar: _ => tsplus_module_24.sync(() => memoMap => tsplus_module_29.zipWithPar(memoMap.getOrElseMemoize(_.that, scope), _.f)(memoMap.getOrElseMemoize(_.self, scope)))
  });
}
/**
 * Returns whether this layer is a fresh version that will not be shared.
 *
 * @tsplus getter effect/core/io/Layer isFresh
 */


function isFresh_1(self) {
  return self._tag === "LayerFresh";
}
//# sourceMappingURL=memoMap.js.map