import { Layer } from "@effect/core/io/Layer/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Extends the scope of this layer, returning a new layer that when provided
 * to an effect will not immediately release its associated resources when
 * that effect completes execution but instead when the scope the resulting
 * effect depends on is closed.
 * @tsplus getter effect/core/io/Layer extendScope
 * @tsplus location "@effect/core/io/Layer/operations/extendScope"
 */
export declare function extendScope<RIn, E, ROut>(self: Layer<RIn, E, ROut>): Layer<RIn | Scope, E, ROut>;
//# sourceMappingURL=extendScope.d.ts.map