import { Cause } from "@effect/core/io/Cause/definition";
import { Layer } from "@effect/core/io/Layer/definition";
import { Env } from "@tsplus/stdlib/service/Env";
/**
 * Feeds the error or output services of this layer into the input of either
 * the specified `failure` or `success` layers, resulting in a new layer with
 * the inputs of this layer, and the error or outputs of the specified layer.
 * @tsplus static effect/core/io/Layer.Aspects foldCauseLayer
 * @tsplus pipeable effect/core/io/Layer foldCauseLayer
 * @tsplus location "@effect/core/io/Layer/operations/foldCauseLayer"
 */
export declare function foldCauseLayer<E, A, R2, E2, A2, R3, E3, A3>(failure: (cause: Cause<E>) => Layer<R2, E2, A2>, success: (env: Env<A>) => Layer<R3, E3, A3>): <R>(self: import("@effect/core/io/Layer/definition").Layer<R, E, A>) => import("@effect/core/io/Layer/definition").Layer<R2 | R3 | R, E2 | E3, A2 | A3>;
//# sourceMappingURL=foldCauseLayer.d.ts.map