"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.foldCauseLayer = foldCauseLayer;

var _definition = /*#__PURE__*/require("@effect/core/io/Layer/definition");

/**
 * Feeds the error or output services of this layer into the input of either
 * the specified `failure` or `success` layers, resulting in a new layer with
 * the inputs of this layer, and the error or outputs of the specified layer.
 *
 * @tsplus static effect/core/io/Layer.Aspects foldCauseLayer
 * @tsplus pipeable effect/core/io/Layer foldCauseLayer
 */
function foldCauseLayer(failure, success) {
  return self => new _definition.ILayerFold(self, failure, success);
}
//# sourceMappingURL=foldCauseLayer.js.map