"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.retry = retry;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/service/Tag"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Layer/operations/succeed"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Layer/operations/flatMap"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Layer/operations/suspend"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Layer/operations/fresh"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Layer/operations/catchAll"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/fail"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Schedule/Intervals"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Clock/operations/sleep"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/as"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Clock/operations/currentTime"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Layer/operations/fromEffect"));

var _Duration = /*#__PURE__*/require("@tsplus/stdlib/data/Duration");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Retries constructing this layer according to the specified schedule.
 *
 * @tsplus static effect/core/io/Layer.Aspects retry
 * @tsplus pipeable effect/core/io/Layer retry
 */
function retry(schedule) {
  return self => tsplus_module_4.suspend(() => {
    const stateTag = tsplus_module_1.Tag();
    return tsplus_module_3.flatMap(env => loop(self, schedule, stateTag, env.get(stateTag).state))(tsplus_module_2.succeed(stateTag)({
      state: schedule.initial
    }));
  });
}

function loop(self, schedule, stateTag, s) {
  return tsplus_module_6.catchAll(e => tsplus_module_3.flatMap(env => tsplus_module_5.fresh(loop(self, schedule, stateTag, env.get(stateTag).state)))(update(schedule, stateTag, e, s)))(self);
}

function update(schedule, stateTag, e, s) {
  return tsplus_module_13.fromEffect(stateTag)(tsplus_module_11.flatMap(now => tsplus_module_11.flatMap(([state, _, decision]) => decision._tag === "Done" ? tsplus_module_7.fail(e) : tsplus_module_10.as({
    state
  })(tsplus_module_9.sleep(new _Duration.DurationInternal(tsplus_module_8.start(decision.intervals) - now))))(schedule.step(now, e, s)))(tsplus_module_12.currentTime));
}
//# sourceMappingURL=retry.js.map