import { Layer } from "@effect/core/io/Layer/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
import { Runtime } from "@effect/core/io/Runtime/definition";
/**
 * Converts a layer that requires no services into a scoped runtime, which can
 * be used to execute effects.
 * @tsplus static effect/core/io/Layer.Aspects toRuntime
 * @tsplus fluent effect/core/io/Layer toRuntime
 * @tsplus location "@effect/core/io/Layer/operations/toRuntime"
 */
export declare function toRuntime<RIn, E, ROut>(self: Layer<RIn, E, ROut>): Effect<RIn | Scope, E, Runtime<ROut>>;
//# sourceMappingURL=toRuntime.d.ts.map