"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.greaterThan = greaterThan;
exports.greaterThanEqual = greaterThanEqual;
exports.lessThan = lessThan;
exports.lessThanEqual = lessThanEqual;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/LogLevel/instances/Ord"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/Ord/operations"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @tsplus pipeable-operator effect/core/io/LogLevel <
 * @tsplus static effect/core/io/LogLevel.Aspects lessThen
 * @tsplus pipeable effect/core/io/LogLevel lessThan
 */
function lessThan(that) {
  return self => tsplus_module_2.lt(tsplus_module_1.ordLogLevel)(self, that);
}
/**
 * @tsplus pipeable-operator effect/core/io/LogLevel <=
 * @tsplus static effect/core/io/LogLevel.Aspects lessThanEqual
 * @tsplus pipeable effect/core/io/LogLevel lessThanEqual
 */


function lessThanEqual(that) {
  return self => tsplus_module_2.leq(tsplus_module_1.ordLogLevel)(self, that);
}
/**
 * @tsplus pipeable-operator effect/core/io/LogLevel >
 * @tsplus static effect/core/io/LogLevel.Aspects greaterThan
 * @tsplus pipeable effect/core/io/LogLevel greaterThan
 */


function greaterThan(that) {
  return self => tsplus_module_2.gt(tsplus_module_1.ordLogLevel)(self, that);
}
/**
 * @tsplus pipeable-operator effect/core/io/LogLevel >=
 * @tsplus static effect/core/io/LogLevel.Aspects greaterThanEqual
 * @tsplus pipeable effect/core/io/LogLevel greaterThanEqual
 */


function greaterThanEqual(that) {
  return self => !tsplus_module_2.lt(tsplus_module_1.ordLogLevel)(self, that);
}
//# sourceMappingURL=ordinal.js.map