"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.zip = zip;

/**
 * Combines this logger with the specified logger to produce a new logger that
 * logs to both this logger and that logger.
 *
 * @tsplus pipeable-operator effect/core/io/Logger +
 * @tsplus static effect/core/io/Logger.Aspects zip
 * @tsplus pipeable effect/core/io/Logger zip
 */
function zip(that) {
  return self => ({
    apply: (fiberId, logLevel, message, cause, context, spans, annotations) => [self.apply(fiberId, logLevel, message, cause, context, spans, annotations), that.apply(fiberId, logLevel, message, cause, context, spans, annotations)]
  });
}
//# sourceMappingURL=zip.js.map