"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HistogramBoundariesSym = exports.HistogramBoundariesInternal = exports.HistogramBoundaries = void 0;
exports.exponential = exponential;
exports.isHistogramBoundaries = exports.fromChunk = void 0;
exports.linear = linear;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/equals"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/Equivalence/number"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/single"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/concat"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/uniq"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/range"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/map"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a;

const fromChunk = fromChunk_1;
exports.fromChunk = fromChunk;
const isHistogramBoundaries = isHistogramBoundaries_1;
exports.isHistogramBoundaries = isHistogramBoundaries;
const HistogramBoundariesSym = /*#__PURE__*/Symbol.for("@effect/core/io/Metrics/Histogram/Boundaries");
exports.HistogramBoundariesSym = HistogramBoundariesSym;

class HistogramBoundariesInternal {
  constructor(values) {
    this.values = values;
    this[_a] = HistogramBoundariesSym;
  }

  [(_a = HistogramBoundariesSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString("effect/core/io/Metrics/Histogram/Boundaries"), tsplus_module_1.hashUnknown(this.values));
  }

  [tsplus_module_2.Equals.sym](u) {
    return isHistogramBoundaries_1(u) && tsplus_module_3.equals(u.values)(this.values);
  }

}

exports.HistogramBoundariesInternal = HistogramBoundariesInternal;
const HistogramBoundaries = {};
/**
 * @tsplus static effect/core/io/Metrics/Histogram/Boundaries.Ops linear
 */

exports.HistogramBoundaries = HistogramBoundaries;

function fromChunk_1(chunk) {
  return new HistogramBoundariesInternal(tsplus_module_7.uniq(tsplus_module_4.number)(tsplus_module_6.concat(tsplus_module_5.single(Number.MAX_VALUE))(chunk)));
}
/**
 * A helper method to create histogram bucket boundaries for a histogram
 * with linear increasing values.
 *
 * @tsplus static effect/core/io/Metrics/Histogram/Boundaries.Ops linear
 */


function linear(start, width, count) {
  return fromChunk_1(tsplus_module_9.map(i => start + i * width)(tsplus_module_8.range(0, count - 1)));
}
/**
 * A helper method to create histogram bucket boundaries for a histogram
 * with exponentially increasing values.
 *
 * @tsplus static effect/core/io/Metrics/Histogram/Boundaries.Ops exponential
 */


function exponential(start, factor, count) {
  return fromChunk_1(tsplus_module_9.map(i => start * Math.pow(factor, i))(tsplus_module_8.range(0, count - 1)));
}
/**
 * @tsplus static effect/core/io/Metrics/Histogram/Boundaries.Ops isHistogramBoundaries
 */


function isHistogramBoundaries_1(u) {
  return typeof u === "object" && u != null && HistogramBoundariesSym in u;
}
//# sourceMappingURL=Boundaries.js.map