import { MetricState } from "@effect/core/io/Metrics/MetricState";
/**
 * @tsplus type effect/core/io/Metrics/MetricHook
 */
export interface MetricHook<In, Out> {
    readonly update: (input: In) => void;
    readonly get: () => Out;
}
/**
 * @tsplus type effect/core/io/Metrics/MetricHook.Ops
 */
export interface MetricHookOps {
}
export declare const MetricHook: MetricHookOps;
export declare namespace MetricHook {
    type Root = MetricHook<any, MetricState.Untyped>;
    type Untyped = MetricHook<any, any>;
    type Counter = MetricHook<number, MetricState.Counter>;
    type Gauge = MetricHook<number, MetricState.Gauge>;
    type Frequency = MetricHook<string, MetricState.Frequency>;
    type Histogram = MetricHook<number, MetricState.Histogram>;
    type Summary = MetricHook<readonly [number, number], MetricState.Summary>;
}
/**
 * @tsplus static effect/core/io/Metrics/MetricHook.Ops __call
 * @tsplus location "@effect/core/io/Metrics/MetricHook"
 */
export declare function make<In, Out>(update: (input: In) => void, get: () => Out): MetricHook<In, Out>;
/**
 * @tsplus static effect/core/io/Metrics/MetricHook.Aspects onUpdate
 * @tsplus pipeable effect/core/io/Metrics/MetricHook onUpdate
 * @tsplus location "@effect/core/io/Metrics/MetricHook"
 */
export declare function onUpdate<In, Out>(f: (input: In) => void): (self: MetricHook<In, Out>) => MetricHook<In, Out>;
//# sourceMappingURL=MetricHook.d.ts.map