"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MetricHook = void 0;
exports.make = make;
exports.onUpdate = onUpdate;
const MetricHook = {};
/**
 * @tsplus static effect/core/io/Metrics/MetricHook.Ops __call
 */

exports.MetricHook = MetricHook;

function make(update, get) {
  return {
    update,
    get
  };
}
/**
 * @tsplus static effect/core/io/Metrics/MetricHook.Aspects onUpdate
 * @tsplus pipeable effect/core/io/Metrics/MetricHook onUpdate
 */


function onUpdate(f) {
  return self => ({
    update: input => {
      self.update(input);
      return f(input);
    },
    get: self.get
  });
}
//# sourceMappingURL=MetricHook.js.map