import { MetricKey } from "@effect/core/io/Metrics/MetricKey";
import { MetricHook } from "@effect/core/io/Metrics/MetricHook";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * @tsplus type effect/core/io/Metrics/MetricHooks.Ops
 */
export interface MetricHooksOps {
}
export declare const MetricHooks: MetricHooksOps;
/**
 * @tsplus static effect/core/io/Metrics/MetricHooks.Ops counter
 * @tsplus location "@effect/core/io/Metrics/MetricHooks"
 */
export declare function counter(_key: MetricKey.Counter): MetricHook.Counter;
/**
 * @tsplus static effect/core/io/Metrics/MetricHooks.Ops gauge
 * @tsplus location "@effect/core/io/Metrics/MetricHooks"
 */
export declare function gauge(_key: MetricKey.Gauge, startAt: number): MetricHook.Gauge;
/**
 * @tsplus static effect/core/io/Metrics/MetricHooks.Ops frequency
 * @tsplus location "@effect/core/io/Metrics/MetricHooks"
 */
export declare function frequency(_key: MetricKey.Frequency): MetricHook.Frequency;
/**
 * @tsplus static effect/core/io/Metrics/MetricHooks.Ops histogram
 * @tsplus location "@effect/core/io/Metrics/MetricHooks"
 */
export declare function histogram(key: MetricKey.Histogram): MetricHook.Histogram;
/**
 * @tsplus static effect/core/io/Metrics/MetricHooks.Ops summary
 * @tsplus location "@effect/core/io/Metrics/MetricHooks"
 */
export declare function summary(key: MetricKey.Summary): MetricHook.Summary;
export declare class ResolvedQuantile {
    /**
     * The quantile that shall be resolved.
     */
    readonly quantile: number;
    /**
     * `Some<number>` if a value for the quantile could be found, otherwise
     * `None`.
     */
    readonly value: Maybe<number>;
    /**
     * How many samples have been consumed prior to this quantile.
     */
    readonly consumed: number;
    /**
     * The rest of the samples after the quantile has been resolved.
     */
    readonly rest: Chunk<number>;
    constructor(
    /**
     * The quantile that shall be resolved.
     */
    quantile: number, 
    /**
     * `Some<number>` if a value for the quantile could be found, otherwise
     * `None`.
     */
    value: Maybe<number>, 
    /**
     * How many samples have been consumed prior to this quantile.
     */
    consumed: number, 
    /**
     * The rest of the samples after the quantile has been resolved.
     */
    rest: Chunk<number>);
}
//# sourceMappingURL=MetricHooks.d.ts.map