"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.gauge = exports.frequency = exports.counter = exports._Out = exports._In = exports.SummaryKeySym = exports.SummaryKey = exports.MetricKeyTypeSym = exports.MetricKeyType = exports.HistogramKeySym = exports.HistogramKey = exports.GaugeKeySym = exports.GaugeKey = exports.FrequencyKeySym = exports.FrequencyKey = exports.CounterKeySym = exports.CounterKey = exports.BaseMetricKeyType = void 0;
exports.histogram = histogram;
exports.isHistogramKey = exports.isGaugeKey = exports.isFrequencyKey = exports.isCounterKey = void 0;
exports.isMetricKeyType = isMetricKeyType;
exports.isSummaryKey = void 0;
exports.summary = summary;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Metrics/definition"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Duration"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/equals"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a, _b, _c, _d, _e, _f;

const isCounterKey = isCounterKey_1;
exports.isCounterKey = isCounterKey;
const isGaugeKey = isGaugeKey_1;
exports.isGaugeKey = isGaugeKey;
const isFrequencyKey = isFrequencyKey_1;
exports.isFrequencyKey = isFrequencyKey;
const isHistogramKey = isHistogramKey_1;
exports.isHistogramKey = isHistogramKey;
const isSummaryKey = isSummaryKey_1;
exports.isSummaryKey = isSummaryKey;
const MetricKeyTypeSym = /*#__PURE__*/Symbol.for("@effect/core/io/Metric/MetricKeyType");
exports.MetricKeyTypeSym = MetricKeyTypeSym;

const _In = /*#__PURE__*/Symbol.for("@effect/core/io/Metric/MetricKeyType/In");

exports._In = _In;

const _Out = /*#__PURE__*/Symbol.for("@effect/core/io/Metric/MetricKeyType/Out");

exports._Out = _Out;
const CounterKeySym = /*#__PURE__*/Symbol.for("@effect/core/io/Metric/MetricKeyType/Counter");
exports.CounterKeySym = CounterKeySym;
const FrequencyKeySym = /*#__PURE__*/Symbol.for("@effect/core/io/Metric/MetricKeyType/Frequency");
exports.FrequencyKeySym = FrequencyKeySym;
const GaugeKeySym = /*#__PURE__*/Symbol.for("@effect/core/io/Metric/MetricKeyType/Gauge");
exports.GaugeKeySym = GaugeKeySym;
const HistogramKeySym = /*#__PURE__*/Symbol.for("@effect/core/io/Metric/MetricKeyType/Histogram");
exports.HistogramKeySym = HistogramKeySym;
const SummaryKeySym = /*#__PURE__*/Symbol.for("@effect/core/io/Metric/MetricKeyType/Summary");
exports.SummaryKeySym = SummaryKeySym;

class BaseMetricKeyType {
  constructor() {
    this[_a] = MetricKeyTypeSym;
  }

}

exports.BaseMetricKeyType = BaseMetricKeyType;
_a = MetricKeyTypeSym;

class CounterKey extends BaseMetricKeyType {
  constructor() {
    super(...arguments);
    this[_b] = CounterKeySym;
  }

  [(_b = CounterKeySym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.hashString("effect/core/io/Metrics/MetricKeyType/Counter");
  }

  [tsplus_module_2.Equals.sym](u) {
    return isCounterKey_1(u);
  }

}

exports.CounterKey = CounterKey;

class GaugeKey extends BaseMetricKeyType {
  constructor() {
    super(...arguments);
    this[_c] = GaugeKeySym;
  }

  [(_c = GaugeKeySym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.hashString("effect/core/io/Metrics/MetricKeyType/Gauge");
  }

  [tsplus_module_2.Equals.sym](u) {
    return isGaugeKey_1(u);
  }

}

exports.GaugeKey = GaugeKey;

class FrequencyKey extends BaseMetricKeyType {
  constructor() {
    super(...arguments);
    this[_d] = FrequencyKeySym;
  }

  [(_d = FrequencyKeySym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.hashString("effect/core/io/Metrics/MetricKeyType/Frequency");
  }

  [tsplus_module_2.Equals.sym](u) {
    return isFrequencyKey_1(u);
  }

}

exports.FrequencyKey = FrequencyKey;

class HistogramKey extends BaseMetricKeyType {
  constructor(boundaries) {
    super();
    this.boundaries = boundaries;
    this[_e] = HistogramKeySym;
  }

  [(_e = HistogramKeySym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString("effect/core/io/Metrics/MetricKeyType/Histogram"), tsplus_module_1.hashUnknown(this.boundaries));
  }

  [tsplus_module_2.Equals.sym](u) {
    return isHistogramKey_1(u) && tsplus_module_2.equals(this.boundaries, u.boundaries);
  }

}

exports.HistogramKey = HistogramKey;

class SummaryKey extends BaseMetricKeyType {
  constructor(maxAge, maxSize, error, quantiles) {
    super();
    this.maxAge = maxAge;
    this.maxSize = maxSize;
    this.error = error;
    this.quantiles = quantiles;
    this[_f] = SummaryKeySym;
  }

  [(_f = SummaryKeySym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString("effect/core/io/Metrics/MetricKeyType/Summary"), tsplus_module_1.combine(tsplus_module_1.hashUnknown(this.maxAge), tsplus_module_1.combine(tsplus_module_1.hashNumber(this.maxSize), tsplus_module_1.combine(tsplus_module_1.hashNumber(this.error), tsplus_module_1.hashUnknown(this.quantiles)))));
  }

  [tsplus_module_2.Equals.sym](u) {
    return isSummaryKey_1(u) && tsplus_module_4.equals(u.maxAge)(this.maxAge) && this.maxSize === u.maxSize && this.error === u.error && tsplus_module_5.equals(u.quantiles)(this.quantiles);
  }

}

exports.SummaryKey = SummaryKey;
const MetricKeyType = {};
/**
 * @tsplus static effect/core/io/Metrics/MetricKeyType.Ops Counter
 */

exports.MetricKeyType = MetricKeyType;
const counter = /*#__PURE__*/new CounterKey();
/**
 * @tsplus static effect/core/io/Metrics/MetricKeyType.Ops Frequency
 */

exports.counter = counter;
const frequency = /*#__PURE__*/new FrequencyKey();
/**
 * @tsplus static effect/core/io/Metrics/MetricKeyType.Ops Gauge
 */

exports.frequency = frequency;
const gauge = /*#__PURE__*/new GaugeKey();
/**
 * @tsplus static effect/core/io/Metrics/MetricKeyType.Ops Histogram
 */

exports.gauge = gauge;

function histogram(boundaries) {
  return new HistogramKey(boundaries);
}
/**
 * @tsplus static effect/core/io/Metrics/MetricKeyType.Ops Summary
 */


function summary(maxAge, maxSize, error, quantiles) {
  return new SummaryKey(maxAge, maxSize, error, quantiles);
}
/**
 * @tsplus static effect/core/io/Metrics/MetricKeyType.Ops isMetricKeyType
 */


function isMetricKeyType(u) {
  return typeof u === "object" && u != null && MetricKeyTypeSym in u;
}
/**
 * @tsplus static effect/core/io/Metrics/MetricKeyType.Ops isCounterKey
 */


function isCounterKey_1(u) {
  return typeof u === "object" && u != null && CounterKeySym in u;
}
/**
 * @tsplus static effect/core/io/Metrics/MetricKeyType.Ops isGaugeKey
 */


function isGaugeKey_1(u) {
  return typeof u === "object" && u != null && GaugeKeySym in u;
}
/**
 * @tsplus static effect/core/io/Metrics/MetricKeyType.Ops isFrequencyKey
 */


function isFrequencyKey_1(u) {
  return typeof u === "object" && u != null && FrequencyKeySym in u;
}
/**
 * @tsplus static effect/core/io/Metrics/MetricKeyType.Ops isHistogramKey
 */


function isHistogramKey_1(u) {
  return typeof u === "object" && u != null && HistogramKeySym in u;
}
/**
 * @tsplus static effect/core/io/Metrics/MetricKeyType.Ops isSummaryKey
 */


function isSummaryKey_1(u) {
  return typeof u === "object" && u != null && SummaryKeySym in u;
}
//# sourceMappingURL=MetricKeyType.js.map