import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { MetricLabel } from "@effect/core/io/Metrics/MetricLabel";
import { Metric } from "@effect/core/io/Metrics/definition";
/**
 * Returns a new metric, which is identical in every way to this one, except
 * the specified tags have been added to the tags of this metric.
 * @tsplus static effect/core/io/Metrics/Metric.Aspects taggedWithLabels
 * @tsplus pipeable effect/core/io/Metrics/Metric taggedWithLabels
 * @tsplus location "@effect/core/io/Metrics/operations/taggedWithLabels"
 */
export declare function taggedWithLabels<Type, In, Out>(extraTags: Collection<MetricLabel>): (self: Metric<Type, In, Out>) => Metric<Type, In, Out>;
//# sourceMappingURL=taggedWithLabels.d.ts.map