import { Metric } from "@effect/core/io/Metrics/definition";
import { MetricKeyType } from "@effect/core/io/Metrics/MetricKeyType";
import { Duration } from "@tsplus/stdlib/data/Duration";
import { MetricState } from "@effect/core/io/Metrics/MetricState";
/**
 * Creates a timer metric, based on a histogram, which keeps track of
 * durations in milliseconds. The unit of time will automatically be added to
 * the metric as a tag (i.e. `"time_unit: milliseconds"`).
 * @tsplus static effect/core/io/Metrics/Metric.Ops timer
 * @tsplus location "@effect/core/io/Metrics/operations/timer"
 */
export declare function timer(name: string): Metric<MetricKeyType.Histogram, Duration, MetricState.Histogram>;
//# sourceMappingURL=timer.d.ts.map