import { Metric } from "@effect/core/io/Metrics/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns an aspect that will update this metric with the specified constant
 * value every time the aspect is applied to an effect, regardless of whether
 * that effect fails or succeeds.
 * @tsplus static effect/core/io/Metrics/Metric.Aspects trackAll
 * @tsplus pipeable effect/core/io/Metrics/Metric trackAll
 * @tsplus location "@effect/core/io/Metrics/operations/trackAll"
 */
export declare function trackAll<In>(input: In): <Type, Out>(self: import("../definition").Metric<Type, In, Out>) => <R, E, A>(effect: import("../../Effect").Effect<R, E, A>) => import("../../Effect").Effect<R, E, A>;
//# sourceMappingURL=trackAll.d.ts.map