import { Metric } from "@effect/core/io/Metrics/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns an aspect that will update this metric with the result of applying
 * the specified function to the defect throwables of the effects that the
 * aspect is applied to.
 * @tsplus static effect/core/io/Metrics/Metric.Aspects trackDefectWith
 * @tsplus pipeable effect/core/io/Metrics/Metric trackDefectWith
 * @tsplus location "@effect/core/io/Metrics/operations/trackDefectWith"
 */
export declare function trackDefectWith<In>(f: (defect: unknown) => In): <Type, Out>(self: import("../definition").Metric<Type, In, Out>) => <R, E, A>(effect: import("../../Effect").Effect<R, E, A>) => import("../../Effect").Effect<R, E, A>;
//# sourceMappingURL=trackDefectWith.d.ts.map