import { Metric } from "@effect/core/io/Metrics/definition";
import { Duration } from "@tsplus/stdlib/data/Duration";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns an aspect that will update this metric with the duration that the
 * effect takes to execute. To call this method, the input type of the metric
 * must be `Duration`.
 * @tsplus getter effect/core/io/Metrics/Metric trackDuration
 * @tsplus location "@effect/core/io/Metrics/operations/trackDuration"
 */
export declare function trackDuration<Type, Out>(self: Metric<Type, Duration, Out>): <R, E, A>(effect: Effect<R, E, A>) => Effect<R, E, A>;
//# sourceMappingURL=trackDuration.d.ts.map