import { Metric } from "@effect/core/io/Metrics/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns an aspect that will update this metric with the result of applying
 * the specified function to the error value of the effects that the aspect is
 * applied to.
 * @tsplus static effect/core/io/Metrics/Metric.Aspects trackErrorWith
 * @tsplus pipeable effect/core/io/Metrics/Metric trackErrorWith
 * @tsplus location "@effect/core/io/Metrics/operations/trackErrorWith"
 */
export declare function trackErrorWith<In, In2>(f: (error: In2) => In): <Type, Out>(self: import("../definition").Metric<Type, In, Out>) => <R, E extends In2, A>(effect: import("../../Effect").Effect<R, E, A>) => import("../../Effect").Effect<R, E, A>;
//# sourceMappingURL=trackErrorWith.d.ts.map