import { Metric } from "@effect/core/io/Metrics/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns an aspect that will update this metric with the result of applying
 * the specified function to the success value of the effects that the aspect is
 * applied to.
 * @tsplus static effect/core/io/Metrics/Metric.Aspects trackSuccessWith
 * @tsplus pipeable effect/core/io/Metrics/Metric trackSuccessWith
 * @tsplus location "@effect/core/io/Metrics/operations/trackSuccessWith"
 */
export declare function trackSuccessWith<In, In2>(f: (value: In2) => In): <Type, Out>(self: import("../definition").Metric<Type, In, Out>) => <R, E, A extends In2>(effect: import("../../Effect").Effect<R, E, A>) => import("../../Effect").Effect<R, E, A>;
//# sourceMappingURL=trackSuccessWith.d.ts.map