import { Effect } from "@effect/core/io/Effect/definition";
import { Queue } from "@effect/core/io/Queue/definition/common";
/**
 * Makes a new bounded queue. When the capacity of the queue is reached, any
 * additional calls to `offer` will be suspended until there is more room in
 * the queue.
 *
 * **Note**: When possible use only power of 2 capacities; this will provide
 * better performance by utilising an optimised version of the underlying
 * `RingBuffer`.
 * @tsplus static effect/core/io/Queue.Ops bounded
 * @tsplus location "@effect/core/io/Queue/external/bounded"
 */
export declare const bounded: <A>(requestedCapacity: number) => Effect<never, never, Queue<A>>;
//# sourceMappingURL=bounded.d.ts.map