"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.bounded = void 0;

var _exclForEach = /*#__PURE__*/require("@effect/core/io/Effect/operations/excl-forEach");

/**
 * Makes a new bounded queue. When the capacity of the queue is reached, any
 * additional calls to `offer` will be suspended until there is more room in
 * the queue.
 *
 * **Note**: When possible use only power of 2 capacities; this will provide
 * better performance by utilising an optimised version of the underlying
 * `RingBuffer`.
 *
 * @tsplus static effect/core/io/Queue.Ops bounded
 */
const bounded = _exclForEach.makeBoundedQueue;
exports.bounded = bounded;
//# sourceMappingURL=bounded.js.map