import { MutableQueue } from "@tsplus/stdlib/collections/mutable/MutableQueue/definition";
import { Deferred } from "@effect/core/io/Deferred/definition";
import { AtomicBoolean } from "@tsplus/stdlib/data/AtomicBoolean";
import { Queue } from "@effect/core/io/Queue/definition/common";
import type { Strategy } from "@effect/core/io/Queue/operations/strategy";
/**
 * Unsafely creates a new `Queue` using the provided `Strategy`.
 * @tsplus static effect/core/io/Queue.Ops unsafeCreate
 * @tsplus location "@effect/core/io/Queue/external/unsafeCreate"
 */
export declare const unsafeCreate: <A>(queue: MutableQueue<A>, takers: MutableQueue<Deferred<never, A>>, shutdownHook: Deferred<never, void>, shutdownFlag: AtomicBoolean, strategy: Strategy<A>) => Queue<A>;
//# sourceMappingURL=unsafeCreate.d.ts.map