"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unsafeCompleteTakers = unsafeCompleteTakers;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/mutable/MutableQueue"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/prepend"));

var _unsafeCompleteDeferred = /*#__PURE__*/require("@effect/core/io/Queue/operations/_internal/unsafeCompleteDeferred");

var _unsafeOfferAll = /*#__PURE__*/require("@effect/core/io/Queue/operations/_internal/unsafeOfferAll");

var _unsafePollAll = /*#__PURE__*/require("@effect/core/io/Queue/operations/_internal/unsafePollAll");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function unsafeCompleteTakers(strategy, queue, takers) {
  // Check both a taker and an item are in the queue, starting with the taker
  let keepPolling = true;

  while (keepPolling && !queue.isEmpty) {
    const taker = takers.poll(tsplus_module_1.EmptyMutableQueue);

    if (taker !== tsplus_module_1.EmptyMutableQueue) {
      const element = queue.poll(tsplus_module_1.EmptyMutableQueue);

      if (element !== tsplus_module_1.EmptyMutableQueue) {
        (0, _unsafeCompleteDeferred.unsafeCompleteDeferred)(taker, element);
        strategy.unsafeOnQueueEmptySpace(queue, takers);
      } else {
        (0, _unsafeOfferAll.unsafeOfferAll)(takers, tsplus_module_2.prepend(taker)((0, _unsafePollAll.unsafePollAll)(takers)));
      }

      keepPolling = true;
    } else {
      keepPolling = false;
    }
  }
}
//# sourceMappingURL=unsafeCompleteTakers.js.map