import { Effect } from "@effect/core/io/Effect/definition";
import { Queue } from "@effect/core/io/Queue/definition/common";
/**
 * Makes a new bounded queue with the dropping strategy. When the capacity of
 * the queue is reached, new elements will be dropped.
 *
 * **Note**: When possible use only power of 2 capacities; this will provide
 * better performance by utilising an optimised version of the underlying
 * `RingBuffer`.
 * @tsplus static effect/core/io/Queue.Ops dropping
 * @tsplus location "@effect/core/io/Queue/operations/dropping"
 */
export declare function dropping<A>(requestedCapacity: number): Effect<never, never, Queue<A>>;
//# sourceMappingURL=dropping.d.ts.map