import { Effect } from "@effect/core/io/Effect/definition";
import { Queue } from "@effect/core/io/Queue/definition/common";
/**
 * Makes a new bounded queue with sliding strategy. When the capacity of the
 * queue is reached, new elements will be added and the old elements will be
 * dropped.
 *
 * **Note**: When possible use only power of 2 capacities; this will provide
 * better performance by utilising an optimised version of the underlying
 * `RingBuffer`.
 * @tsplus static effect/core/io/Queue.Ops sliding
 * @tsplus location "@effect/core/io/Queue/operations/sliding"
 */
export declare function sliding<A>(requestedCapacity: number): Effect<never, never, Queue<A>>;
//# sourceMappingURL=sliding.d.ts.map