import { Effect } from "@effect/core/io/Effect/definition";
import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Tag } from "@tsplus/stdlib/service/Tag";
export declare const RandomSym: unique symbol;
export type RandomSym = typeof RandomSym;
/**
 * @tsplus type effect/core/io/Random
 */
export interface Random {
    readonly [RandomSym]: RandomSym;
    readonly next: Effect<never, never, number>;
    readonly nextBoolean: Effect<never, never, boolean>;
    readonly nextInt: Effect<never, never, number>;
    readonly nextRange: (low: number, high: number) => Effect<never, never, number>;
    readonly nextIntBetween: (low: number, high: number) => Effect<never, never, number>;
    readonly shuffle: <A>(collection: Collection<A>) => Effect<never, never, Collection<A>>;
}
/**
 * @tsplus type effect/core/io/Random.Ops
 */
export interface RandomOps {
    $: RandomAspects;
    Tag: Tag<Random>;
}
export declare const Random: RandomOps;
/**
 * @tsplus type effect/core/io/Random.Aspects
 */
export interface RandomAspects {
}
//# sourceMappingURL=definition.d.ts.map