import { Random } from "@effect/core/io/Random/definition";
import { PCGRandom } from "@tsplus/stdlib/io/Random/PCGRandom";
import { Effect } from "@effect/core/io/Effect/definition";
import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { RandomSym } from "@effect/core/io/Random/definition";
export declare class LiveRandom implements Random {
    readonly seed: number;
    readonly [RandomSym]: RandomSym;
    readonly PRNG: PCGRandom;
    constructor(seed: number);
    get next(): Effect<never, never, number>;
    get nextBoolean(): Effect<never, never, boolean>;
    get nextInt(): Effect<never, never, number>;
    nextRange(low: number, high: number): Effect<never, never, number>;
    nextIntBetween(low: number, high: number): Effect<never, never, number>;
    shuffle<A>(collection: Collection<A>): Effect<never, never, Collection<A>>;
}
/**
 * @tsplus static effect/core/io/Random.Ops default
 * @tsplus location "@effect/core/io/Random/operations/live"
 */
export declare const defaultRandom: LiveRandom;
/**
 * @tsplus static effect/core/io/Random.Ops live
 * @tsplus location "@effect/core/io/Random/operations/live"
 */
export declare const live: import("../../Layer").Layer<never, never, import("@effect/core/io/Random/definition").Random>;
//# sourceMappingURL=live.d.ts.map