import { AtomicReference } from "@tsplus/stdlib/data/AtomicReference";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Ref } from "@effect/core/io/Ref/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { _A, RefSym } from "@effect/core/io/Ref/definition";
export declare class UnsafeAPI<A> {
    readonly value: AtomicReference<A>;
    constructor(value: AtomicReference<A>);
    get get(): A;
    getAndSet(a: A): A;
    getAndUpdate(f: (a: A) => A): A;
    getAndUpdateSome(pf: (a: A) => Maybe<A>): A;
    modify<B>(f: (a: A) => readonly [B, A]): B;
    modifySome<B>(fallback: B, pf: (a: A) => Maybe<readonly [B, A]>): B;
    set(a: A): void;
    update(f: (a: A) => A): void;
    updateAndGet(f: (a: A) => A): A;
    updateSome(pf: (a: A) => Maybe<A>): void;
    updateSomeAndGet(pf: (a: A) => Maybe<A>): A;
}
export declare class AtomicInternal<A> implements Ref<A> {
    readonly unsafe: UnsafeAPI<A>;
    constructor(unsafe: UnsafeAPI<A>);
    get [_A](): (_: never) => A;
    /**
     * Internal Discriminator
     */
    get [RefSym](): RefSym;
    get get(): Effect<never, never, A>;
    modify<B>(this: this, f: (a: A) => readonly [B, A]): Effect<never, never, B>;
    set(this: this, a: A): Effect<never, never, void>;
    getAndSet(this: this, a: A): Effect<never, never, A>;
    getAndUpdate(this: this, f: (a: A) => A): Effect<never, never, A>;
    getAndUpdateSome(this: this, pf: (a: A) => Maybe<A>): Effect<never, never, A>;
    modifySome<B>(this: this, fallback: B, pf: (a: A) => Maybe<readonly [B, A]>): Effect<never, never, B>;
    update(this: this, f: (a: A) => A): Effect<never, never, void>;
    updateAndGet(this: this, f: (a: A) => A): Effect<never, never, A>;
    updateSome(this: this, pf: (a: A) => Maybe<A>): Effect<never, never, void>;
    updateSomeAndGet(this: this, pf: (a: A) => Maybe<A>): Effect<never, never, A>;
}
//# sourceMappingURL=AtomicInternal.d.ts.map