"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SynchronizedInternal = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/as"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TSemaphore/operations/withPermit"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/getOrElse"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/sync"));

var _definition = /*#__PURE__*/require("@effect/core/io/Ref/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

class SynchronizedInternal {
  get [_definition.RefSym]() {
    return _definition.RefSym;
  }

  get [_definition.SynchronizedSym]() {
    return _definition.SynchronizedSym;
  }

  get [_definition._A]() {
    return a => a;
  }

  constructor(ref, semaphore) {
    this.ref = ref;
    this.semaphore = semaphore;
  }

  modifyEffect(f) {
    return tsplus_module_3.withPermit(this.semaphore)(tsplus_module_2.flatMap(tp => {
      const [b, a] = tp;
      return tsplus_module_1.as(b)(this.ref.set(a));
    })(tsplus_module_2.flatMap(f)(this.get)));
  }

  getAndUpdateEffect(f) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [v, result])(f(v)));
  }

  getAndUpdateSomeEffect(pf) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [v, result])(tsplus_module_6.getOrElse_(pf(v), () => tsplus_module_5.succeed(v))));
  }

  modifySomeEffect(fallback, pf) {
    return this.modifyEffect(v => tsplus_module_6.getOrElse_(pf(v), () => tsplus_module_5.succeed([fallback, v])));
  }

  updateEffect(f) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [undefined, result])(f(v)));
  }

  updateAndGetEffect(f) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [result, result])(f(v)));
  }

  updateSomeEffect(pf) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [undefined, result])(tsplus_module_6.getOrElse_(pf(v), () => tsplus_module_5.succeed(v))));
  }

  updateSomeAndGetEffect(pf) {
    return this.modifyEffect(v => tsplus_module_4.map(result => [result, result])(tsplus_module_6.getOrElse_(pf(v), () => tsplus_module_5.succeed(v))));
  }

  get get() {
    return this.ref.get;
  }

  modify(f) {
    return this.modifyEffect(a => tsplus_module_7.sync(() => f(a)));
  }

  set(a) {
    return tsplus_module_3.withPermit(this.semaphore)(this.ref.set(a));
  }

  getAndSet(a) {
    return this.modify(v => [v, a]);
  }

  getAndUpdate(f) {
    return this.modify(v => [v, f(v)]);
  }

  getAndUpdateSome(pf) {
    return this.modify(v => [v, tsplus_module_6.getOrElse_(pf(v), () => v)]);
  }

  modifySome(fallback, pf) {
    return this.modify(v => tsplus_module_6.getOrElse_(pf(v), () => [fallback, v]));
  }

  update(f) {
    return this.modify(v => [undefined, f(v)]);
  }

  updateAndGet(f) {
    return this.modify(v => {
      const result = f(v);
      return [result, result];
    });
  }

  updateSome(pf) {
    return this.modify(v => [undefined, tsplus_module_6.getOrElse_(pf(v), () => v)]);
  }

  updateSomeAndGet(pf) {
    return this.modify(v => {
      const result = tsplus_module_6.getOrElse_(pf(v), () => v);
      return [result, result];
    });
  }

}

exports.SynchronizedInternal = SynchronizedInternal;
//# sourceMappingURL=SynchronizedInternal.js.map