import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Effect } from "@effect/core/io/Effect/definition";
import { Ref } from "@effect/core/io/Ref/definition";
/**
 * Creates a new `Ref` with the specified value.
 * @tsplus static effect/core/io/Ref.Ops make
 * @tsplus location "@effect/core/io/Ref/operations/make"
 */
export declare function makeRef<A>(value: LazyArg<A>): Effect<never, never, Ref<A>>;
/**
 * Creates a new `Ref.Synchronized` with the specified value.
 * @tsplus static effect/core/io/Ref/Synchronized.Ops make
 * @tsplus static effect/core/io/Ref/Synchronized.Ops __call
 * @tsplus location "@effect/core/io/Ref/operations/make"
 */
export declare function makeSynchronized<A>(value: LazyArg<A>): Effect<never, never, Ref.Synchronized<A>>;
//# sourceMappingURL=make.d.ts.map