"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeRef = void 0;
exports.makeSynchronized = makeSynchronized;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Ref/operations/unsafeMake"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/sync"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TSemaphore/operations/makeCommit"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var _SynchronizedInternal = /*#__PURE__*/require("@effect/core/io/Ref/operations/_internal/SynchronizedInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const makeRef = makeRef_1;
exports.makeRef = makeRef;

/**
 * Creates a new `Ref` with the specified value.
 *
 * @tsplus static effect/core/io/Ref.Ops make
 */
function makeRef_1(value) {
  return tsplus_module_2.sync(() => tsplus_module_1.unsafeMake(value()));
}
/**
 * Creates a new `Ref.Synchronized` with the specified value.
 *
 * @tsplus static effect/core/io/Ref/Synchronized.Ops make
 * @tsplus static effect/core/io/Ref/Synchronized.Ops __call
 */


function makeSynchronized(value) {
  return tsplus_module_5.flatMap(ref => tsplus_module_4.map(semaphore => new _SynchronizedInternal.SynchronizedInternal(ref, semaphore))(tsplus_module_3.makeCommit(1)))(makeRef_1(value));
}
//# sourceMappingURL=make.js.map