"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReloadableInternal = void 0;
exports.reloadableTag = reloadableTag;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/ignoreLogged"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unit"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/weak/IterableWeakMap"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/service/Tag"));

var _definition2 = /*#__PURE__*/require("@effect/core/io/Reloadable/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a;

class ReloadableInternal {
  constructor(scopedRef, reload) {
    this.scopedRef = scopedRef;
    this.reload = reload;
    this[_a] = {
      _Service: _ => _
    };
  }

  get get() {
    return this.scopedRef.get;
  }

  get reloadFork() {
    return tsplus_module_3.asUnit(tsplus_module_2.forkDaemon(tsplus_module_1.ignoreLogged(this.reload)));
  }

}

exports.ReloadableInternal = ReloadableInternal;
_a = _definition2.ReloadableURI;
const tagMap = /*#__PURE__*/tsplus_module_4.make([]);
/**
 * @tsplus getter Tag reloadable
 */

function reloadableTag(tag) {
  const already = tsplus_module_4.getMaybe(tag)(tagMap);

  if (tsplus_module_5.isSome(already)) {
    return already.value;
  }

  const newTag = tsplus_module_6.Tag();
  tagMap.set(tag, newTag);
  return newTag;
}
//# sourceMappingURL=ReloadableInternal.js.map