import { Tag } from "@tsplus/stdlib/service/Tag";
import { Layer } from "@effect/core/io/Layer/definition";
import { Schedule } from "@effect/core/io/Schedule/definition";
import { Reloadable } from "@effect/core/io/Reloadable/definition";
/**
 * Makes a new reloadable service from a layer that describes the construction
 * of a static service. The service is automatically reloaded according to the
 * provided schedule.
 * @tsplus static effect/core/io/Reloadable.Ops auto
 * @tsplus location "@effect/core/io/Reloadable/operations/auto"
 */
export declare function auto<In, E, Out, State, Env, Out2>(outTag: Tag<Out>, layer: Layer<In, E, Out>, policy: Schedule<State, Env, In, Out2>): Layer<Env | In, E, Reloadable<Out>>;
//# sourceMappingURL=auto.d.ts.map