import { Tag } from "@tsplus/stdlib/service/Tag";
import { Layer } from "@effect/core/io/Layer/definition";
import { Env } from "@tsplus/stdlib/service/Env";
import { Schedule } from "@effect/core/io/Schedule/definition";
import { Reloadable } from "@effect/core/io/Reloadable/definition";
/**
 * Makes a new reloadable service from a layer that describes the construction
 * of a static service. The service is automatically reloaded according to a
 * schedule, which is extracted from the input to the layer.
 * @tsplus static effect/core/io/Reloadable.Ops autoFromConfig
 * @tsplus location "@effect/core/io/Reloadable/operations/autoFromConfig"
 */
export declare function autoFromConfig<In, E, Out, State, R, Out2>(outTag: Tag<Out>, layer: Layer<In, E, Out>, scheduleFromConfig: (env: Env<In>) => Schedule<State, R, In, Out2>): Layer<R | In, E, Reloadable<Out>>;
//# sourceMappingURL=autoFromConfig.d.ts.map