import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { NoSuchElement } from "@tsplus/stdlib/exceptions";
import { _Env, _In, _Out, _State } from "@effect/core/io/Schedule/definition";
export declare const DriverSym: unique symbol;
export type DriverSym = typeof DriverSym;
/**
 * @tsplus type effect/core/io/Schedule/Driver
 * @tsplus companion effect/core/io/Schedule/Driver.Ops
 */
export declare class Driver<State, Env, In, Out> {
    readonly next: (input: In) => Effect<Env, Maybe<never>, Out>;
    readonly last: Effect<never, NoSuchElement, Out>;
    readonly reset: Effect<never, never, void>;
    readonly state: Effect<never, never, State>;
    readonly [DriverSym]: DriverSym;
    readonly [_Env]: (_: Env) => void;
    readonly [_In]: (_: In) => void;
    readonly [_Out]: () => Out;
    readonly [_State]: unknown;
    constructor(next: (input: In) => Effect<Env, Maybe<never>, Out>, last: Effect<never, NoSuchElement, Out>, reset: Effect<never, never, void>, state: Effect<never, never, State>);
}
/**
 * @tsplus static effect/core/io/Schedule/Driver.Ops __call
 * @tsplus location "@effect/core/io/Schedule/Driver"
 */
export declare function make<State, Env, In, Out>(next: (input: In) => Effect<Env, Maybe<never>, Out>, last: Effect<never, NoSuchElement, Out>, reset: Effect<never, never, void>, state: Effect<never, never, State>): Driver<State, Env, In, Out>;
//# sourceMappingURL=Driver.d.ts.map