import { Schedule } from "@effect/core/io/Schedule/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Returns a new schedule that first executes this schedule to completion, and
 * then executes the specified schedule to completion.
 * @tsplus pipeable-operator effect/core/io/Schedule %
 * @tsplus static effect/core/io/Schedule.Aspects andThenEither
 * @tsplus pipeable effect/core/io/Schedule andThenEither
 * @tsplus location "@effect/core/io/Schedule/operations/andThenEither"
 */
export declare function andThenEither<State1, Env1, In1, Out2>(that: Schedule<State1, Env1, In1, Out2>): <State, Env_1, In, Out>(self: import("../definition").Schedule<State, Env_1, In, Out>) => import("../definition").Schedule<readonly [State, State1, boolean], Env1 | Env_1, In & In1, import("@tsplus/stdlib/data/Either").Either<Out, Out2>>;
//# sourceMappingURL=andThenEither.d.ts.map