import { Effect } from "@effect/core/io/Effect/definition";
import { Schedule } from "@effect/core/io/Schedule/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * A schedule that recurs until the effectful condition f fails, collecting
 * all inputs into a list.
 * @tsplus static effect/core/io/Schedule.Ops collectUntilEffect
 * @tsplus location "@effect/core/io/Schedule/operations/collectUntilEffect"
 */
export declare function collectUntilEffect<Env, A>(f: (a: A) => Effect<Env, never, boolean>): Schedule<readonly [void, Chunk<A>], Env, A, Chunk<A>>;
//# sourceMappingURL=collectUntilEffect.d.ts.map