import { Effect } from "@effect/core/io/Effect/definition";
import { Schedule } from "@effect/core/io/Schedule/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * A schedule that recurs as long as the effectful condition holds, collecting
 * all inputs into a list.
 * @tsplus static effect/core/io/Schedule.Ops collectWhileEffect
 * @tsplus location "@effect/core/io/Schedule/operations/collectWhileEffect"
 */
export declare function collectWhileEffect<Env, A>(f: (a: A) => Effect<Env, never, boolean>): Schedule<readonly [void, Chunk<A>], Env, A, Chunk<A>>;
//# sourceMappingURL=collectWhileEffect.d.ts.map