import { Schedule } from "@effect/core/io/Schedule/definition";
/**
 * Returns the composition of this schedule and the specified schedule, by
 * piping the output of this one into the input of the other. Effects
 * described by this schedule will always be executed before the effects
 * described by the second schedule.
 * @tsplus pipeable-operator effect/core/io/Schedule >>
 * @tsplus static effect/core/io/Schedule.Aspects compose
 * @tsplus pipeable effect/core/io/Schedule compose
 * @tsplus location "@effect/core/io/Schedule/operations/compose"
 */
export declare function compose<Out, State1, Env1, Out2>(that: Schedule<State1, Env1, Out, Out2>): <State, Env_1, In>(self: import("../definition").Schedule<State, Env_1, In, Out>) => import("../definition").Schedule<readonly [State, State1], Env1 | Env_1, In, Out2>;
//# sourceMappingURL=compose.d.ts.map