import { Schedule } from "@effect/core/io/Schedule/definition";
/**
 * Cron-like schedule that recurs every specified `day` of month. Won't recur
 * on months containing less days than specified in `day` param.
 *
 * It triggers at zero hour of the day. Producing a count of repeats: 0, 1, 2.
 *
 * NOTE: `day` parameter is validated lazily. Must be in range 1...31.
 * @tsplus static effect/core/io/Schedule.Ops dayOfMonth
 * @tsplus location "@effect/core/io/Schedule/operations/dayOfMonth"
 */
export declare function dayOfMonth(day: number): Schedule<readonly [number, number], never, unknown, number>;
//# sourceMappingURL=dayOfMonth.d.ts.map