import { Schedule } from "@effect/core/io/Schedule/definition";
/**
 * Cron-like schedule that recurs every specified `day` of each week. It
 * triggers at zero hour of the week. Producing a count of repeats: 0, 1, 2.
 *
 * NOTE: `day` parameter is validated lazily. Must be in range 1 (Monday)...7
 * (Sunday).
 * @tsplus static effect/core/io/Schedule.Ops dayOfWeek
 * @tsplus location "@effect/core/io/Schedule/operations/dayOfWeek"
 */
export declare function dayOfWeek(day: number): Schedule<readonly [number, number], never, unknown, number>;
//# sourceMappingURL=dayOfWeek.d.ts.map