"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.driver = driver;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/exceptions"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/failSync"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fold"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Ref/operations/make"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/fail"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipRight"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Schedule/Intervals"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/sleep"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/as"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Clock/operations/currentTime"));

var _Driver = /*#__PURE__*/require("@effect/core/io/Schedule/Driver");

var _Duration = /*#__PURE__*/require("@tsplus/stdlib/data/Duration");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Returns a driver that can be used to step the schedule, appropriately
 * handling sleeping.
 *
 * @tsplus getter effect/core/io/Schedule driver
 */
function driver(self) {
  return tsplus_module_7.map(ref => {
    const last = tsplus_module_5.flatMap(([element, _]) => tsplus_module_4.fold(() => tsplus_module_2.failSync(() => new tsplus_module_1.NoSuchElement()), out => tsplus_module_3.succeed(out))(element))(ref.get);
    const reset = ref.set([tsplus_module_6.none, self.initial]);
    const state = tsplus_module_7.map(tuple => tuple[1])(ref.get);
    return new _Driver.Driver(next(self, ref), last, reset, state);
  })(tsplus_module_8.makeRef(() => [tsplus_module_6.none, self.initial]));
}

function next(self, ref) {
  return input => tsplus_module_5.flatMap(({
    now,
    decision: [state, out, decision]
  }) => decision._tag === "Done" ? tsplus_module_10.zipRight(tsplus_module_9.fail(tsplus_module_6.none))(ref.set([tsplus_module_6.some(out), state])) : tsplus_module_10.zipRight(tsplus_module_13.as(out)(tsplus_module_12.sleep(new _Duration.DurationInternal(tsplus_module_11.start(decision.intervals) - now))))(ref.set([tsplus_module_6.some(out), state])))(tsplus_module_5.flatMap(state => tsplus_module_5.flatMap(now => tsplus_module_7.map(decision => ({
    now,
    decision
  }))(self.step(now, input, state)))(tsplus_module_14.currentTime))(tsplus_module_7.map(tuple => tuple[1])(ref.get)));
}
//# sourceMappingURL=driver.js.map