import { Effect } from "@effect/core/io/Effect/definition";
import { Schedule } from "@effect/core/io/Schedule/definition";
/**
 * Returns a new schedule that will run the specified finalizer as soon as the
 * schedule is complete. Note that unlike `Effect.ensuring`, this method does not
 * guarantee the finalizer will be run. The `Schedule` may not initialize or
 * the driver of the schedule may not run to completion. However, if the
 * `Schedule` ever decides not to continue, then the finalizer will be run.
 * @tsplus static effect/core/io/Schedule.Aspects ensuring
 * @tsplus pipeable effect/core/io/Schedule ensuring
 * @tsplus location "@effect/core/io/Schedule/operations/ensuring"
 */
export declare function ensuring<X>(finalizer: Effect<never, never, X>): <State, Env_1, In, Out>(self: import("../definition").Schedule<State, Env_1, In, Out>) => import("../definition").Schedule<State, Env_1, In, Out>;
//# sourceMappingURL=ensuring.d.ts.map