import { Duration } from "@tsplus/stdlib/data/Duration";
import { Schedule } from "@effect/core/io/Schedule/definition";
/**
 * A schedule that always recurs, but will wait a certain amount between
 * repetitions, given by `base * factor.pow(n)`, where `n` is the number of
 * repetitions so far. Returns the current duration between recurrences.
 * @tsplus static effect/core/io/Schedule.Ops exponential
 * @tsplus location "@effect/core/io/Schedule/operations/exponential"
 */
export declare function exponential(base: Duration, factor?: number): Schedule<number, never, unknown, Duration>;
//# sourceMappingURL=exponential.d.ts.map