import { Duration } from "@tsplus/stdlib/data/Duration";
import { Schedule } from "@effect/core/io/Schedule/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * A schedule that recurs on a fixed interval. Returns the number of
 * repetitions of the schedule so far.
 *
 * If the action run between updates takes longer than the interval, then the
 * action will be run immediately, but re-runs will not "pile up".
 *
 * ```text
 * |-----interval-----|-----interval-----|-----interval-----|
 * |---------action--------||action|-----|action|-----------|
 * ```
 * @tsplus static effect/core/io/Schedule.Ops fixed
 * @tsplus location "@effect/core/io/Schedule/operations/fixed"
 */
export declare function fixed(interval: Duration): Schedule<readonly [Maybe<readonly [number, number]>, number], never, unknown, number>;
//# sourceMappingURL=fixed.d.ts.map