import { Duration } from "@tsplus/stdlib/data/Duration";
import { Schedule } from "@effect/core/io/Schedule/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * A schedule that recurs once for each of the specified durations, delaying
 * each time for the length of the specified duration. Returns the length of
 * the current duration between recurrences.
 * @tsplus static effect/core/io/Schedule.Ops fromDurations
 * @tsplus location "@effect/core/io/Schedule/operations/fromDurations"
 */
export declare function fromDurations(duration: Duration, ...durations: Array<Duration>): Schedule<readonly [Chunk<Duration>, boolean], never, unknown, Duration>;
//# sourceMappingURL=fromDurations.d.ts.map