import { Schedule } from "@effect/core/io/Schedule/definition";
/**
 * Cron-like schedule that recurs every specified `hour` of each day. It
 * triggers at zero minute of the hour. Producing a count of repeats: 0, 1, 2.
 *
 * NOTE: `hour` parameter is validated lazily. Must be in range 0...23.
 * @tsplus static effect/core/io/Schedule.Ops hourOfDay
 * @tsplus location "@effect/core/io/Schedule/operations/hourOfDay"
 */
export declare function hourOfDay(hour: number): Schedule<readonly [number, number], never, unknown, number>;
//# sourceMappingURL=hourOfDay.d.ts.map