import { Schedule } from "@effect/core/io/Schedule/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import type { Intervals } from "@effect/core/io/Schedule/Intervals";
/**
 * Returns a new schedule that combines this schedule with the specified
 * schedule, continuing as long as both schedules want to continue and merging
 * the next intervals according to the specified merge function.
 * @tsplus static effect/core/io/Schedule.Aspects intersectWith
 * @tsplus pipeable effect/core/io/Schedule intersectWith
 * @tsplus location "@effect/core/io/Schedule/operations/intersectWith"
 */
export declare function intersectWith<State1, Env1, In1, Out2>(that: Schedule<State1, Env1, In1, Out2>, f: (x: Intervals, y: Intervals) => Intervals): <State, Env_1, In, Out>(self: import("../definition").Schedule<State, Env_1, In, Out>) => import("../definition").Schedule<readonly [State, State1], Env1 | Env_1, In & In1, readonly [Out, Out2]>;
//# sourceMappingURL=intersectWith.d.ts.map