import { Schedule } from "@effect/core/io/Schedule/definition";
import { Random } from "@effect/core/io/Random/definition";
/**
 * Returns a new schedule that randomly modifies the size of the intervals of
 * this schedule.
 *
 * The new interval size is between `min * old interval size` and `max * old
 * interval size`.
 * @tsplus static effect/core/io/Schedule.Aspects jittered
 * @tsplus pipeable effect/core/io/Schedule jittered
 * @tsplus location "@effect/core/io/Schedule/operations/jittered"
 */
export declare function jittered(min: number, max: number): <State, Env_1, In, Out>(self: import("../definition").Schedule<State, Env_1, In, Out>) => import("../definition").Schedule<State, import("../../Random").Random | Env_1, In, Out>;
/**
 * Returns a new schedule that randomly modifies the size of the intervals of
 * this schedule.
 *
 * The new interval size is between `min * old interval size` and `max * old
 * interval size`.
 * @tsplus getter effect/core/io/Schedule jitteredDefault
 * @tsplus location "@effect/core/io/Schedule/operations/jittered"
 */
export declare function jitteredDefault<State, Env, In, Out>(self: Schedule<State, Env, In, Out>): Schedule<State, Env | Random, In, Out>;
//# sourceMappingURL=jittered.d.ts.map