import { Schedule } from "@effect/core/io/Schedule/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Returns a new schedule that makes this schedule available on the `Left`
 * side of an `Either` input, allowing propagating some type `X` through this
 * channel on demand.
 * @tsplus getter effect/core/io/Schedule left
 * @tsplus location "@effect/core/io/Schedule/operations/left"
 */
export declare function left<State, Env, In, Out, X>(self: Schedule<State, Env, In, Out>): Schedule<readonly [State, void], Env, Either<In, X>, Either<Out, X>>;
//# sourceMappingURL=left.d.ts.map