import { Schedule } from "@effect/core/io/Schedule/definition";
/**
 * Cron-like schedule that recurs every specified `minute` of each hour. It
 * triggers at zero second of the minute. Producing a count of repeats: 0, 1,
 * 2.
 *
 * NOTE: `minute` parameter is validated lazily. Must be in range 0...59.
 * @tsplus static effect/core/io/Schedule.Ops minuteOfHour
 * @tsplus location "@effect/core/io/Schedule/operations/minuteOfHour"
 */
export declare function minuteOfHour(minute: number): Schedule<readonly [number, number], never, unknown, number>;
//# sourceMappingURL=minuteOfHour.d.ts.map