"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.modifyDelayEffect = modifyDelayEffect;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Schedule/Intervals"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Schedule/Interval"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Schedule/Decision"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var _makeWithState = /*#__PURE__*/require("@effect/core/io/Schedule/operations/_internal/makeWithState");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Returns a new schedule that modifies the delay using the specified
 * effectual function.
 *
 * @tsplus static effect/core/io/Schedule.Aspects modifyDelayEffect
 * @tsplus pipeable effect/core/io/Schedule modifyDelayEffect
 */
function modifyDelayEffect(f) {
  return self => (0, _makeWithState.makeWithState)(self.initial, (now, input, state) => tsplus_module_6.flatMap(([state, out, decision]) => {
    switch (decision._tag) {
      case "Done":
        {
          return tsplus_module_1.succeed([state, out, decision]);
        }

      case "Continue":
        {
          const intervals = decision.intervals;
          const delay = tsplus_module_3.size(tsplus_module_3.fromStartEndMillis(now, tsplus_module_2.start(intervals)));
          return tsplus_module_5.map(duration => {
            const oldStart = tsplus_module_2.start(intervals);
            const newStart = now + duration.millis;
            const delta = newStart - oldStart;
            const newEnd = Math.min(Math.max(0, tsplus_module_2.end(intervals) + delta), Number.MAX_SAFE_INTEGER);
            const newInterval = tsplus_module_3.fromStartEndMillis(newStart, newEnd);
            return [state, out, tsplus_module_4.continueWith(newInterval)];
          })(f(out, delay));
        }
    }
  })(self.step(now, input, state)));
}
//# sourceMappingURL=modifyDelayEffect.js.map