import { Effect } from "@effect/core/io/Effect/definition";
import { Schedule } from "@effect/core/io/Schedule/definition";
import type { Decision } from "@effect/core/io/Schedule/Decision";
/**
 * Returns a new schedule that applies the current one but runs the specified
 * effect for every decision of this schedule. This can be used to create
 * schedules that log failures, decisions, or computed values.
 * @tsplus static effect/core/io/Schedule.Aspects onDecision
 * @tsplus pipeable effect/core/io/Schedule onDecision
 * @tsplus location "@effect/core/io/Schedule/operations/onDecision"
 */
export declare function onDecision<State, Out, Env1, X>(f: (state: State, out: Out, decision: Decision) => Effect<Env1, never, X>): <Env_1, In>(self: import("../definition").Schedule<State, Env_1, In, Out>) => import("../definition").Schedule<State, Env1 | Env_1, In, Out>;
//# sourceMappingURL=onDecision.d.ts.map