import { Either } from "@tsplus/stdlib/data/Either/definition";
import { Schedule } from "@effect/core/io/Schedule/definition";
import type { Decision } from "@effect/core/io/Schedule/Decision";
import type { Interval } from "@effect/core/io/Schedule/Interval";
/**
 * Returns a new schedule that reconsiders every decision made by this
 * schedule, possibly modifying the next interval and the output type in the
 * process.
 * @tsplus static effect/core/io/Schedule.Aspects reconsider
 * @tsplus pipeable effect/core/io/Schedule reconsider
 * @tsplus location "@effect/core/io/Schedule/operations/reconsider"
 */
export declare function reconsider<State, Out, Out2>(f: (state: State, out: Out, decision: Decision) => Either<Out2, readonly [Out2, Interval]>): <Env_1, In>(self: import("../definition").Schedule<State, Env_1, In, Out>) => import("../definition").Schedule<State, Env_1, In, Out2>;
//# sourceMappingURL=reconsider.d.ts.map