import { Effect } from "@effect/core/io/Effect/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
import { Schedule } from "@effect/core/io/Schedule/definition";
import { Decision } from "@effect/core/io/Schedule/Decision";
import type { Interval } from "@effect/core/io/Schedule/Interval";
/**
 * Returns a new schedule that effectfully reconsiders every decision made by
 * this schedule, possibly modifying the next interval and the output type in
 * the process.
 * @tsplus static effect/core/io/Schedule.Aspects reconsiderEffect
 * @tsplus pipeable effect/core/io/Schedule reconsiderEffect
 * @tsplus location "@effect/core/io/Schedule/operations/reconsiderEffect"
 */
export declare function reconsiderEffect<State, Out, Env1, Out2>(f: (state: State, out: Out, decision: Decision) => Effect<Env1, never, Either<Out2, readonly [Out2, Interval]>>): <Env_1, In>(self: import("../definition").Schedule<State, Env_1, In, Out>) => import("../definition").Schedule<State, Env1 | Env_1, In, Out2>;
//# sourceMappingURL=reconsiderEffect.d.ts.map