import { Schedule } from "@effect/core/io/Schedule/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Returns a new schedule that makes this schedule available on the `Right`
 * side of an `Either` input, allowing propagating some type `X` through this
 * channel on demand.
 * @tsplus getter effect/core/io/Schedule right
 * @tsplus location "@effect/core/io/Schedule/operations/right"
 */
export declare function right<State, Env, In, Out, X>(self: Schedule<State, Env, In, Out>): Schedule<readonly [void, State], Env, Either<X, In>, Either<X, Out>>;
//# sourceMappingURL=right.d.ts.map