import { Schedule } from "@effect/core/io/Schedule/definition";
/**
 * Cron-like schedule that recurs every specified `second` of each minute. It
 * triggers at zero nanosecond of the second. Producing a count of repeats: 0,
 * 1, 2.
 *
 * NOTE: `second` parameter is validated lazily. Must be in range 0...59.
 * @tsplus static effect/core/io/Schedule.Ops secondOfMinute
 * @tsplus location "@effect/core/io/Schedule/operations/secondOfMinute"
 */
export declare function secondOfMinute(second: number): Schedule<readonly [number, number], never, unknown, number>;
//# sourceMappingURL=secondOfMinute.d.ts.map