import { Schedule } from "@effect/core/io/Schedule/definition";
import type { Intervals } from "@effect/core/io/Schedule/Intervals";
/**
 * Returns a new schedule that combines this schedule with the specified
 * schedule, continuing as long as either schedule wants to continue and
 * merging the next intervals according to the specified merge function.
 * @tsplus static effect/core/io/Schedule.Aspects unionWith
 * @tsplus pipeable effect/core/io/Schedule unionWith
 * @tsplus location "@effect/core/io/Schedule/operations/unionWith"
 */
export declare function unionWith<State1, Env1, In1, Out2>(that: Schedule<State1, Env1, In1, Out2>, f: (x: Intervals, y: Intervals) => Intervals): <State, Env_1, In, Out>(self: import("../definition").Schedule<State, Env_1, In, Out>) => import("../definition").Schedule<readonly [State, State1], Env1 | Env_1, In & In1, readonly [Out, Out2]>;
//# sourceMappingURL=unionWith.d.ts.map