import { Duration } from "@tsplus/stdlib/data/Duration";
import { Schedule } from "@effect/core/io/Schedule/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * A schedule that divides the timeline to `interval`-long windows, and sleeps
 * until the nearest window boundary every time it recurs.
 *
 * For example, `windowed(Duration.seconds(10))` would produce a schedule as
 * follows:
 *
 * ```text
 *      10s        10s        10s       10s
 * |----------|----------|----------|----------|
 * |action------|sleep---|act|-sleep|action----|
 * ```
 * @tsplus static effect/core/io/Schedule.Ops windowed
 * @tsplus location "@effect/core/io/Schedule/operations/windowed"
 */
export declare function windowed(interval: Duration): Schedule<readonly [Maybe<number>, number], never, unknown, number>;
//# sourceMappingURL=windowed.d.ts.map