import { Scope } from "@effect/core/io/Scope/definition";
import { ReleaseMap } from "@effect/core/io/Scope/ReleaseMap/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Adds a finalizer to the finalizers associated with this scope. If the
 * finalizers associated with this scope have already been run this
 * finalizer will be run immediately.
 *
 * The finalizer returned from this method will remove the original
 * finalizer from the map and run it.
 * @tsplus static effect/core/io/ReleaseMap.Aspects add
 * @tsplus pipeable effect/core/io/ReleaseMap add
 * @tsplus location "@effect/core/io/Scope/ReleaseMap/operations/add"
 */
export declare function add(finalizer: Scope.Finalizer): (self: ReleaseMap) => Effect<never, never, Scope.Finalizer>;
//# sourceMappingURL=add.d.ts.map