import { Scope } from "@effect/core/io/Scope/definition";
import { ReleaseMap } from "@effect/core/io/Scope/ReleaseMap/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Adds a finalizer to the finalizers associated with this scope. If the
 * scope is still open, a key will be returned. This is an identifier that can
 * be used to activate this finalizer and remove it from the map. If the scope
 * has been closed, the finalizer will be executed immediately (with the `Exit`
 * value with which the scope has ended) and no key will be returned.
 * @tsplus static effect/core/io/ReleaseMap.Aspects addIfOpen
 * @tsplus pipeable effect/core/io/ReleaseMap addIfOpen
 * @tsplus location "@effect/core/io/Scope/ReleaseMap/operations/addIfOpen"
 */
export declare function addIfOpen(finalizer: Scope.Finalizer): (self: ReleaseMap) => Effect<never, never, Maybe<number>>;
//# sourceMappingURL=addIfOpen.d.ts.map