"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.release = release;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unit"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fromNullable"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fold"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatten"));

var _State = /*#__PURE__*/require("@effect/core/io/Scope/ReleaseMap/_internal/State");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Runs the specified finalizer and removes it from the finalizers associated
 * with this scope.
 *
 * @tsplus static effect/core/io/ReleaseMap.Aspects release
 * @tsplus pipeable effect/core/io/ReleaseMap release
 */
function release(key, exit) {
  return self => tsplus_module_4.flatten(self.ref.modify(s => {
    switch (s._tag) {
      case "Exited":
        {
          return [tsplus_module_1.unit, s];
        }

      case "Running":
        {
          const finalizers = s.finalizers();
          const finalizer = tsplus_module_2.fromNullable(finalizers.get(key));
          finalizers.delete(key);
          return [tsplus_module_3.fold(() => tsplus_module_1.unit, fin => s.update(fin)(exit))(finalizer), new _State.Running(s.nextKey, finalizers, s.update)];
        }
    }
  }));
}
//# sourceMappingURL=release.js.map