"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.remove = remove;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fromNullable"));

var _State = /*#__PURE__*/require("@effect/core/io/Scope/ReleaseMap/_internal/State");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Removes the finalizer associated with this key and returns it.
 *
 * @tsplus static effect/core/io/ReleaseMap.Aspects remove
 * @tsplus pipeable effect/core/io/ReleaseMap remove
 */
function remove(key) {
  return self => self.ref.modify(s => {
    switch (s._tag) {
      case "Exited":
        {
          return [tsplus_module_1.none, new _State.Exited(s.nextKey, s.exit, s.update)];
        }

      case "Running":
        {
          const finalizers = s.finalizers();
          const finalizer = tsplus_module_2.fromNullable(finalizers.get(key));
          finalizers.delete(key);
          return [finalizer, new _State.Running(s.nextKey, finalizers, s.update)];
        }
    }
  });
}
//# sourceMappingURL=remove.js.map