"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.updateAll = updateAll;

var _State = /*#__PURE__*/require("@effect/core/io/Scope/ReleaseMap/_internal/State");

/**
 * Updates the finalizers associated with this scope using the specified
 * function.
 *
 * @tsplus static effect/core/io/ReleaseMap.Aspects updateAll
 * @tsplus pipeable effect/core/io/ReleaseMap updateAll
 */
function updateAll(f) {
  return self => self.ref.update(state => {
    switch (state._tag) {
      case "Exited":
        {
          return new _State.Exited(state.nextKey, state.exit, _ => f(state.update(_)));
        }

      case "Running":
        {
          return new _State.Running(state.nextKey, state.finalizers(), _ => f(state.update(_)));
        }
    }
  });
}
//# sourceMappingURL=updateAll.js.map