import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Adds a finalizer to this scope. The finalizer is guaranteed to be run when
 * the scope is closed.
 * @tsplus static effect/core/io/Scope.Aspects addFinalizer
 * @tsplus pipeable effect/core/io/Scope addFinalizer
 * @tsplus pipeable effect/core/io/Scope/Closeable addFinalizer
 * @tsplus location "@effect/core/io/Scope/operations/addFinalizer"
 */
export declare function addFinalizer(finalizer: Effect<never, never, unknown>): (self: Scope) => Effect<never, never, void>;
//# sourceMappingURL=addFinalizer.d.ts.map