import { Scope } from "@effect/core/io/Scope/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * A simplified version of `addFinalizerWith` when the `finalizer` does not
 * depend on the `Exit` value that the scope is closed with.
 * @tsplus static effect/core/io/Scope.Aspects addFinalizerExit
 * @tsplus pipeable effect/core/io/Scope addFinalizerExit
 * @tsplus pipeable effect/core/io/Scope/Closeable addFinalizerExit
 * @tsplus location "@effect/core/io/Scope/operations/addFinalizerExit"
 */
export declare function addFinalizerExit(finalizer: Scope.Finalizer): (self: Scope) => Effect<never, never, void>;
//# sourceMappingURL=addFinalizerExit.d.ts.map