"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addFinalizerExit = addFinalizerExit;

var _ScopeInternal = /*#__PURE__*/require("@effect/core/io/Scope/operations/_internal/ScopeInternal");

/**
 * A simplified version of `addFinalizerWith` when the `finalizer` does not
 * depend on the `Exit` value that the scope is closed with.
 *
 * @tsplus static effect/core/io/Scope.Aspects addFinalizerExit
 * @tsplus pipeable effect/core/io/Scope addFinalizerExit
 * @tsplus pipeable effect/core/io/Scope/Closeable addFinalizerExit
 */
function addFinalizerExit(finalizer) {
  return self => {
    void 0;
    return self._addFinalizerExit(finalizer);
  };
}
//# sourceMappingURL=addFinalizerExit.js.map