import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
import { Env } from "@tsplus/stdlib/service/Env";
/**
 * Extends the scope of an `Effect` workflow that needs a scope into this
 * scope by providing it to the workflow but not closing the scope when the
 * workflow completes execution. This allows extending a scoped value into a
 * larger scope.
 * @tsplus static effect/core/io/Scope.Aspects extend
 * @tsplus pipeable effect/core/io/Scope extend
 * @tsplus pipeable effect/core/io/Scope/Closeable extend
 * @tsplus location "@effect/core/io/Scope/operations/extend"
 */
export declare function extend<R, E, A>(effect: Effect<R, E, A>): (self: Scope) => Effect<Exclude<R, Scope>, E, A>;
//# sourceMappingURL=extend.d.ts.map