import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Uses the scope by providing it to an `Effect` workflow that needs a scope,
 * guaranteeing that the scope is closed with the result of that workflow as
 * soon as the workflow completes execution, whether by success, failure, or
 * interruption.
 * @tsplus pipeable effect/core/io/Scope/Closeable use
 * @tsplus location "@effect/core/io/Scope/operations/use"
 */
export declare function use<R, E, A>(effect: Effect<R, E, A>): (self: Scope.Closeable) => Effect<Exclude<R, Scope>, E, A>;
//# sourceMappingURL=use.d.ts.map