import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
import { ScopedRef } from "@effect/core/io/ScopedRef/definition";
/**
 * Creates a new `ScopedRef` from the specified value. This method should
 * not be used for values whose creation require the acquisition of resources.
 * @tsplus static effect/core/io/ScopedRef.Ops make
 * @tsplus location "@effect/core/io/ScopedRef/operations/make"
 */
export declare function make<A>(value: LazyArg<A>): Effect<Scope, never, ScopedRef<A>>;
//# sourceMappingURL=make.d.ts.map