import { TRef } from "@effect/core/stm/TRef/definition";
import { Versioned } from "@effect/core/stm/STM/Versioned";
export declare const EntrySym: unique symbol;
export type EntrySym = typeof EntrySym;
/**
 * @tsplus type effect/core/stm/STM/Entry
 * @tsplus companion effect/core/stm/STM/Entry.Ops
 */
export declare class Entry {
    readonly use: <X>(f: <S>(entry: EntryOps<S>) => X) => X;
    readonly [EntrySym]: EntrySym;
    constructor(use: <X>(f: <S>(entry: EntryOps<S>) => X) => X);
}
/**
 * @tsplus static effect/core/stm/STM/Entry.Ops __call
 * @tsplus location "@effect/core/stm/STM/Entry"
 */
export declare function makeEntry<A0>(tref0: TRef<A0>, isNew0: boolean): Entry;
export declare const EntryOpsSym: unique symbol;
export type EntryOpsSym = typeof EntryOpsSym;
export declare class EntryOps<S> {
    readonly [EntryOpsSym]: EntryOpsSym;
    readonly tref: TRef<S>;
    readonly expected: Versioned<S>;
    newValue: S;
    readonly isNew: boolean;
    _isChanged: boolean;
    constructor(tref: TRef<S>, expected: Versioned<S>, newValue: S, isNew: boolean, isChanged: boolean);
    unsafeSet(value: unknown): void;
    unsafeGet<B>(): B;
    commit(): void;
    copy(): Entry;
    isInvalid(): boolean;
    isValid(): boolean;
    isChanged(): boolean;
    toString(): string;
}
//# sourceMappingURL=Entry.d.ts.map