"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.STMSucceedNow = exports.STMSucceed = exports.STMRetryExceptionSym = exports.STMRetryException = exports.STMProvide = exports.STMOnSuccess = exports.STMOnRetry = exports.STMOnFailure = exports.STMInterruptExceptionSym = exports.STMInterruptException = exports.STMFailExceptionSym = exports.STMFailException = exports.STMEffect = exports.STMDriver = exports.STMDieExceptionSym = exports.STMDieException = exports.STMBase = void 0;
exports.addTodo = addTodo;
exports.analyzeJournal = analyzeJournal;
exports.catchAll = exports.atomically = void 0;
exports.collectTodos = collectTodos;
exports.commit = void 0;
exports.commitJournal = commitJournal;
exports.completeTodos = completeTodos;
exports.concreteSTM = concreteSTM;
exports.ensuring = exports.emptyTodoMap = void 0;
exports.execTodos = execTodos;
exports.isInterruptException = exports.isFailException = exports.isDieException = exports.foldSTM = exports.flatMap = exports.fail = void 0;
exports.isInvalid = isInvalid;
exports.isRetryException = void 0;
exports.isValid = isValid;
exports.map = void 0;
exports.prepareResetJournal = prepareResetJournal;
exports.sync = exports.succeed = void 0;
exports.tryCommit = tryCommit;
exports.tryCommitAsync = tryCommitAsync;
exports.tryCommitSync = tryCommitSync;
exports.untrackedTodoTargets = untrackedTodoTargets;
exports.zipWith = exports.zipRight = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/done"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/TxnId"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/AtomicReference"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/State"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/async"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/failCause"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/catchAllCause"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/withFiberRuntime"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Either/fold"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Either/definition"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Stack"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TExit/definition"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/succeed"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/fail"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/die"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/interrupt"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/TryCommit"));

var tsplus_module_19 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/operations/empty"));

var tsplus_module_20 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/_internal/hashMap"));

var tsplus_module_21 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/operations/set"));

var _definition3 = /*#__PURE__*/require("@effect/core/io/Effect/definition");

var _base = /*#__PURE__*/require("@effect/core/stm/STM/definition/base");

var _TRefInternal = /*#__PURE__*/require("@effect/core/stm/TRef/operations/_internal/TRefInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a, _b, _c, _d, _e, _f;

const isFailException = isFailException_1;
exports.isFailException = isFailException;
const isDieException = isDieException_1;
exports.isDieException = isDieException;
const isInterruptException = isInterruptException_1;
exports.isInterruptException = isInterruptException;
const isRetryException = isRetryException_1;
exports.isRetryException = isRetryException;
const commit = commit_1;
exports.commit = commit;
const atomically = atomically_1;
exports.atomically = atomically;
const ensuring = ensuring_1;
exports.ensuring = ensuring;
const fail = fail_1;
exports.fail = fail;
const succeed = succeed_1;
exports.succeed = succeed;
const foldSTM = foldSTM_1;
exports.foldSTM = foldSTM;
const map = map_1;
exports.map = map;
const zipRight = zipRight_1;
exports.zipRight = zipRight;
const zipWith = zipWith_1;
exports.zipWith = zipWith;
const sync = sync_1;
exports.sync = sync;
const catchAll = catchAll_1;
exports.catchAll = catchAll;
const flatMap = flatMap_1;
exports.flatMap = flatMap;

class STMBase {
  constructor() {
    this._tag = "ICommit";
    this[_a] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
    this[_b] = {
      _R: _ => _,
      _E: _ => _,
      _A: _ => _
    };
  }

  get commit() {
    return commit_1(this);
  }

}

exports.STMBase = STMBase;
_a = _base.STMTypeId, _b = _definition3.EffectURI;

class STMEffect extends STMBase {
  constructor(f) {
    super();
    this.f = f;
    this._stmtag = "STMEffect";
  }

}

exports.STMEffect = STMEffect;

class STMOnFailure extends STMBase {
  constructor(stm, onFailure) {
    super();
    this.stm = stm;
    this.onFailure = onFailure;
    this._stmtag = "STMOnFailure";
  }

  apply(a) {
    return new STMSucceedNow(a);
  }

}

exports.STMOnFailure = STMOnFailure;

class STMOnRetry extends STMBase {
  constructor(stm, onRetry) {
    super();
    this.stm = stm;
    this.onRetry = onRetry;
    this._stmtag = "STMOnRetry";
  }

  apply(a) {
    return new STMSucceedNow(a);
  }

}

exports.STMOnRetry = STMOnRetry;

class STMOnSuccess extends STMBase {
  constructor(stm, apply) {
    super();
    this.stm = stm;
    this.apply = apply;
    this._stmtag = "STMOnSuccess";
  }

}

exports.STMOnSuccess = STMOnSuccess;

class STMProvide extends STMBase {
  constructor(stm, f) {
    super();
    this.stm = stm;
    this.f = f;
    this._stmtag = "STMProvide";
  }

}

exports.STMProvide = STMProvide;

class STMSucceedNow extends STMBase {
  constructor(a) {
    super();
    this.a = a;
    this._stmtag = "STMSucceedNow";
  }

}

exports.STMSucceedNow = STMSucceedNow;

class STMSucceed extends STMBase {
  constructor(a) {
    super();
    this.a = a;
    this._stmtag = "STMSucceed";
  }

}

exports.STMSucceed = STMSucceed;
const STMFailExceptionSym = /*#__PURE__*/Symbol.for("@effect/core/stm/STM/FailException");
exports.STMFailExceptionSym = STMFailExceptionSym;

class STMFailException {
  constructor(e) {
    this.e = e;
    this[_c] = STMFailExceptionSym;
  }

}

exports.STMFailException = STMFailException;
_c = STMFailExceptionSym;
/**
 * @tsplus static effect/core/stm/STM.Ops isFailException
 */

function isFailException_1(u) {
  return typeof u === "object" && u != null && STMFailExceptionSym in u;
}

const STMDieExceptionSym = /*#__PURE__*/Symbol.for("@effect/core/stm/STM/DieException");
exports.STMDieExceptionSym = STMDieExceptionSym;

class STMDieException {
  constructor(e) {
    this.e = e;
    this[_d] = STMDieExceptionSym;
  }

}

exports.STMDieException = STMDieException;
_d = STMDieExceptionSym;
/**
 * @tsplus static effect/core/stm/STM.Ops isDieException
 */

function isDieException_1(u) {
  return typeof u === "object" && u != null && STMDieExceptionSym in u;
}

const STMInterruptExceptionSym = /*#__PURE__*/Symbol.for("@effect/core/stm/STM/InterruptException");
exports.STMInterruptExceptionSym = STMInterruptExceptionSym;

class STMInterruptException {
  constructor(fiberId) {
    this.fiberId = fiberId;
    this[_e] = STMInterruptExceptionSym;
  }

}

exports.STMInterruptException = STMInterruptException;
_e = STMInterruptExceptionSym;
/**
 * @tsplus static effect/core/stm/STM.Ops isInterruptException
 */

function isInterruptException_1(u) {
  return typeof u === "object" && u != null && STMInterruptExceptionSym in u;
}

const STMRetryExceptionSym = /*#__PURE__*/Symbol.for("@effect/core/stm/STM/RetryException");
exports.STMRetryExceptionSym = STMRetryExceptionSym;

class STMRetryException {
  constructor() {
    this[_f] = STMRetryExceptionSym;
  }

}

exports.STMRetryException = STMRetryException;
_f = STMRetryExceptionSym;
/**
 * @tsplus static effect/core/stm/STM.Ops isRetryException
 */

function isRetryException_1(u) {
  return typeof u === "object" && u != null && STMRetryExceptionSym in u;
}
/**
 * Commits this transaction atomically.
 *
 * @tsplus getter effect/core/stm/STM commit
 */


function commit_1(self) {
  return atomically_1(self);
}
/**
 * @tsplus static effect/core/stm/STM.Ops atomically
 */


function atomically_1(self) {
  return tsplus_module_9.withFiberRuntime(state => {
    const fiberId = state.id;
    const env = state.getFiberRef(tsplus_module_1.currentEnvironment);
    const scheduler = state.getFiberRef(tsplus_module_1.currentScheduler);
    const commitResult = tryCommitSync(fiberId, self, env, scheduler);

    switch (commitResult._tag) {
      case "Done":
        {
          return tsplus_module_2.done(commitResult.exit);
        }

      case "Suspend":
        {
          const txnId = tsplus_module_3.makeTxnId();
          const state = new tsplus_module_4.AtomicReference(tsplus_module_5.running);

          const io = tsplus_module_6._async(tryCommitAsync(commitResult.journal, fiberId, self, txnId, state, env, scheduler));

          return tsplus_module_1.uninterruptibleMask(({
            restore
          }) => tsplus_module_8.catchAllCause(cause => {
            state.compareAndSet(tsplus_module_5.running, tsplus_module_5.interrupted);
            const currentState = state.get;
            return currentState._tag === "Done" ? tsplus_module_2.done(currentState.exit) : tsplus_module_7.failCause(cause);
          })(restore(io)));
        }
    }
  });
}
/**
 * Executes the specified finalization transaction whether or
 * not this effect succeeds. Note that as with all STM transactions,
 * if the full transaction fails, everything will be rolled back.
 *
 * @tsplus static effect/core/stm/STM.Aspects ensuring
 * @tsplus pipeable effect/core/stm/STM ensuring
 */


function ensuring_1(finalizer) {
  return self => foldSTM_1(e => zipRight_1(fail_1(e))(finalizer), a => zipRight_1(succeed_1(a))(finalizer))(self);
}
/**
 * Returns a value that models failure in the transaction.
 *
 * @tsplus static effect/core/stm/STM.Ops fail
 */


function fail_1(e) {
  return new STMEffect(() => {
    throw new STMFailException(e);
  });
}
/**
 * Returns an `STM` effect that succeeds with the specified value.
 *
 * @tsplus static effect/core/stm/STM.Ops succeed
 */


function succeed_1(a) {
  return new STMSucceedNow(a);
}
/**
 * Effectfully folds over the `STM` effect, handling both failure and
 * success.
 *
 * @tsplus static effect/core/stm/STM.Aspects foldSTM
 * @tsplus pipeable effect/core/stm/STM foldSTM
 */


function foldSTM_1(g, f) {
  return self => flatMap_1(either => tsplus_module_10.fold(succeed_1, f)(either))(catchAll_1(e => map_1(tsplus_module_11.left)(g(e)))(map_1(tsplus_module_11.right)(self)));
}
/**
 * Maps the value produced by the effect.
 *
 * @tsplus static effect/core/stm/STM.Aspects map
 * @tsplus pipeable effect/core/stm/STM map
 */


function map_1(f) {
  return self => flatMap_1(a => sync_1(() => f(a)))(self);
}
/**
 * Sequentially zips this value with the specified one, discarding the first
 * element of the tuple.
 *
 * @tsplus pipeable-operator effect/core/stm/STM >
 * @tsplus static effect/core/stm/STM.Aspects zipRight
 * @tsplus pipeable effect/core/stm/STM zipRight
 */


function zipRight_1(that) {
  return self => zipWith_1(that, (_, b) => b)(self);
}
/**
 * Sequentially zips this value with the specified one, combining the values
 * using the specified combiner function.
 *
 * @tsplus static effect/core/stm/STM.Aspects zipWith
 * @tsplus pipeable effect/core/stm/STM zipWith
 */


function zipWith_1(that, f) {
  return self => flatMap_1(a => map_1(b => f(a, b))(that))(self);
}
/**
 * Returns an `STM` effect that succeeds with the specified value.
 *
 * @tsplus static effect/core/stm/STM.Ops sync
 */


function sync_1(a) {
  return new STMSucceed(a);
}
/**
 * Recovers from all errors.
 *
 * @tsplus static effect/core/stm/STM.Aspects catchAll
 * @tsplus pipeable effect/core/stm/STM catchAll
 */


function catchAll_1(f) {
  return self => new STMOnFailure(self, f);
}
/**
 * Feeds the value produced by this effect to the specified function,
 * and then runs the returned effect as well to produce its results.
 *
 * @tsplus static effect/core/stm/STM.Aspects flatMap
 * @tsplus pipeable effect/core/stm/STM flatMap
 */


function flatMap_1(f) {
  return self => new STMOnSuccess(self, f);
}
/**
 * @tsplus macro remove
 */


function concreteSTM(_) {//
}

class STMDriver {
  constructor(self, journal, fiberId, r0) {
    this.self = self;
    this.journal = journal;
    this.fiberId = fiberId;
    this.yieldOpCount = 2048;
    this.envStack = new tsplus_module_12.Stack(r0);
  }

  unwindStack(error, isRetry) {
    let result = undefined;

    while (this.contStack && result == null) {
      const cont = this.contStack.value;
      this.contStack = this.contStack.previous;

      if (cont._stmtag === "STMOnFailure") {
        if (!isRetry) {
          result = cont.onFailure(error);
        }
      }

      if (cont._stmtag === "STMOnRetry") {
        if (isRetry) {
          result = cont.onRetry();
        }
      }
    }

    return result;
  }

  run() {
    let curr = this.self;
    let exit = undefined;
    let opCount = 0;

    while (exit == null && curr != null) {
      if (opCount === this.yieldOpCount) {
        let valid = true;

        for (const entry of this.journal) {
          valid = entry[1].use(_ => _.isValid());
        }

        if (!valid) {
          exit = tsplus_module_13.retry;
        } else {
          opCount = 0;
        }
      } else {
        const k = curr;
        void 0;

        switch (k._stmtag) {
          case "STMEffect":
            {
              try {
                const a = k.f(this.journal, this.fiberId, this.envStack.value);

                if (!this.contStack) {
                  exit = tsplus_module_13.succeed(a);
                } else {
                  const cont = this.contStack.value;
                  this.contStack = this.contStack.previous;
                  curr = cont.apply(a);
                }
              } catch (e) {
                if (isRetryException_1(e)) {
                  curr = this.unwindStack(undefined, true);

                  if (!curr) {
                    exit = tsplus_module_13.retry;
                  }
                } else if (isFailException_1(e)) {
                  curr = this.unwindStack(e.e, false);

                  if (!curr) {
                    exit = tsplus_module_13.fail(e.e);
                  }
                } else if (isDieException_1(e)) {
                  curr = this.unwindStack(e.e, false);

                  if (!curr) {
                    exit = tsplus_module_13.die(e.e);
                  }
                } else if (isInterruptException_1(e)) {
                  exit = tsplus_module_13.interrupt(e.fiberId);
                } else {
                  throw e;
                }
              }

              break;
            }

          case "STMOnSuccess":
            {
              this.contStack = new tsplus_module_12.Stack(k, this.contStack);
              curr = k.stm;
              break;
            }

          case "STMOnFailure":
            {
              this.contStack = new tsplus_module_12.Stack(k, this.contStack);
              curr = k.stm;
              break;
            }

          case "STMOnRetry":
            {
              this.contStack = new tsplus_module_12.Stack(k, this.contStack);
              curr = k.stm;
              break;
            }

          case "STMProvide":
            {
              this.envStack = new tsplus_module_12.Stack(k.f(this.envStack.value), this.envStack);
              curr = ensuring_1(sync_1(() => {
                this.envStack = this.envStack.previous;
              }))(k.stm);
              break;
            }

          case "STMSucceedNow":
            {
              const a = k.a;

              if (!this.contStack) {
                exit = tsplus_module_13.succeed(a);
              } else {
                const cont = this.contStack.value;
                this.contStack = this.contStack.previous;
                curr = cont.apply(a);
              }

              break;
            }

          case "STMSucceed":
            {
              const a = k.a();

              if (!this.contStack) {
                exit = tsplus_module_13.succeed(a);
              } else {
                const cont = this.contStack.value;
                this.contStack = this.contStack.previous;
                curr = cont.apply(a);
              }

              break;
            }
        }

        opCount = opCount + 1;
      }
    }

    return exit;
  }

}

exports.STMDriver = STMDriver;

function tryCommit(fiberId, stm, state, env, scheduler) {
  const journal = new Map();
  const value = new STMDriver(stm, journal, fiberId, env).run();
  const analysis = analyzeJournal(journal);

  if (analysis === "RW") {
    state.compareAndSet(tsplus_module_5.running, tsplus_module_5.done(value));
    commitJournal(journal);
  } else if (analysis === "I") {
    throw new Error("Bug: invalid journal");
  }

  switch (value._tag) {
    case "Succeed":
      {
        return completeTodos(tsplus_module_14.succeed(value.value), journal, scheduler);
      }

    case "Fail":
      {
        return completeTodos(tsplus_module_15.fail(value.value), journal, scheduler);
      }

    case "Die":
      {
        return completeTodos(tsplus_module_16.die(value.value), journal, scheduler);
      }

    case "Interrupt":
      {
        return completeTodos(tsplus_module_17.interrupt(fiberId), journal, scheduler);
      }

    case "Retry":
      {
        return tsplus_module_18.suspend(journal);
      }
  }
}

function tryCommitSync(fiberId, stm, env, scheduler) {
  const journal = new Map();
  const value = new STMDriver(stm, journal, fiberId, env).run();
  const analysis = analyzeJournal(journal);

  if (analysis === "RW" && value._tag === "Succeed") {
    commitJournal(journal);
  } else if (analysis === "I") {
    throw new Error("Bug: invalid journal");
  }

  switch (value._tag) {
    case "Succeed":
      {
        return completeTodos(tsplus_module_14.succeed(value.value), journal, scheduler);
      }

    case "Fail":
      {
        return completeTodos(tsplus_module_15.fail(value.value), journal, scheduler);
      }

    case "Die":
      {
        return completeTodos(tsplus_module_16.die(value.value), journal, scheduler);
      }

    case "Interrupt":
      {
        return completeTodos(tsplus_module_17.interrupt(fiberId), journal, scheduler);
      }

    case "Retry":
      {
        return tsplus_module_18.suspend(journal);
      }
  }
}

function completeTryCommit(exit, k) {
  k(tsplus_module_2.done(exit));
}

function suspendTryCommit(fiberId, stm, txnId, state, env, k, accum, journal, scheduler) {
  // eslint-disable-next-line no-constant-condition
  while (1) {
    addTodo(txnId, journal, () => tryCommitAsync(undefined, fiberId, stm, txnId, state, env, scheduler)(k));

    if (isInvalid(journal)) {
      const v = tryCommit(fiberId, stm, state, env, scheduler);

      switch (v._tag) {
        case "Done":
          {
            completeTryCommit(v.exit, k);
            return;
          }

        case "Suspend":
          {
            const untracked = untrackedTodoTargets(accum, v.journal);

            if (untracked.size > 0) {
              for (const entry of untracked) {
                accum.set(entry[0], entry[1]);
              }

              journal = untracked;
            }

            break;
          }
      }
    } else {
      return;
    }
  }
}

function tryCommitAsync(journal, fiberId, stm, txnId, state, env, scheduler) {
  return k => {
    if (tsplus_module_5.isRunning(state.get)) {
      if (journal == null) {
        const v = tryCommit(fiberId, stm, state, env, scheduler);

        switch (v._tag) {
          case "Done":
            {
              completeTryCommit(v.exit, k);
              break;
            }

          case "Suspend":
            {
              suspendTryCommit(fiberId, stm, txnId, state, env, k, v.journal, v.journal, scheduler);
              break;
            }
        }
      } else {
        suspendTryCommit(fiberId, stm, txnId, state, env, k, journal, journal, scheduler);
      }
    }
  };
}
/**
 * Creates a function that can reset the journal.
 */


function prepareResetJournal(journal) {
  const saved = new Map();

  for (const entry of journal) {
    saved.set(entry[0], entry[1].use(_ => _.copy()));
  }

  return () => {
    journal.clear();

    for (const entry of saved) {
      journal.set(entry[0], entry[1]);
    }
  };
}
/**
 * Commits the journal.
 */


function commitJournal(journal) {
  for (const entry of journal) {
    entry[1].use(_ => _.commit());
  }
}
/**
 * Analyzes the journal, determining whether it is valid and whether it is
 * read only in a single pass. Note that information on whether the
 * journal is read only will only be accurate if the journal is valid, due
 * to short-circuiting that occurs on an invalid journal.
 */


function analyzeJournal(journal) {
  let val = "RO";

  for (const entry of journal) {
    val = entry[1].use(_ => _.isInvalid() ? "I" : _.isChanged() ? "RW" : val);

    if (val === "I") {
      return val;
    }
  }

  return val;
}

const emptyTodoMap = /*#__PURE__*/tsplus_module_19.empty();
/**
 * Atomically collects and clears all the todos from any `TRef` that
 * participated in the transaction.
 */

exports.emptyTodoMap = emptyTodoMap;

function collectTodos(journal) {
  const allTodos = new Map();

  for (const entry of journal) {
    const tref = entry[1].use(_ => _.tref);
    void 0;
    const todos = tref.todo.get;

    for (const todo of todos) {
      allTodos.set(todo[0], todo[1]);
    }

    tref.todo.set(emptyTodoMap);
  }

  return allTodos;
}
/**
 * Executes the todos in the current thread, sequentially.
 */


function execTodos(todos) {
  for (const todo of todos) {
    todo[1]();
  }
}
/**
 * Runs all the todos.
 */


function completeTodos(exit, journal, scheduler) {
  const todos = collectTodos(journal);

  if (todos.size > 0) {
    scheduler.scheduleTask(() => execTodos(todos));
  }

  return tsplus_module_18.done(exit);
}
/**
 * For the given transaction id, adds the specified todo effect to all
 * `TRef` values.
 */


function addTodo(txnId, journal, todoEffect) {
  let added = false;

  for (const entry of journal) {
    const tref = entry[1].use(_ => _.tref);
    void 0;
    const oldTodo = tref.todo.get;

    if (!tsplus_module_20.has_(oldTodo, txnId)) {
      const newTodo = tsplus_module_21.set(txnId, todoEffect)(oldTodo);
      tref.todo.set(newTodo);
      added = true;
    }
  }

  return added;
}
/**
 * Finds all the new todo targets that are not already tracked in the
 * `oldJournal`.
 */


function untrackedTodoTargets(oldJournal, newJournal) {
  const untracked = new Map();

  for (const entry of newJournal) {
    const key = entry[0];
    const value = entry[1];

    if ( // We already tracked this one
    !oldJournal.has(key) && // This `TRef` was created in the current transaction, so no need to
    // add any todos to it, because it cannot be modified from the outside
    // until the transaction succeeds; so any todo added to it would never
    // succeed.
    !value.use(_ => _.isNew)) {
      untracked.set(key, value);
    }
  }

  return untracked;
}
/**
 * Determines if the journal is valid.
 */


function isValid(journal) {
  let valid = true;

  for (const entry of journal) {
    valid = entry[1].use(_ => _.isValid());

    if (!valid) {
      return valid;
    }
  }

  return valid;
}
/**
 * Determines if the journal is invalid.
 */


function isInvalid(journal) {
  return !isValid(journal);
}
//# sourceMappingURL=primitives.js.map