import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { STM } from "@effect/core/stm/STM/definition/base";
/**
 * Collects all the transactional effects, returning a single transactional
 * effect that produces `Unit`.
 *
 * Equivalent to `collectAll(i).unit`, but without the cost of building the
 * list of results.
 * @tsplus static effect/core/stm/STM.Ops collectAllDiscard
 * @tsplus location "@effect/core/stm/STM/operations/collectAllDiscard"
 */
export declare function collectAllDiscard<R, E, A>(as: Collection<STM<R, E, A>>): STM<R, E, void>;
//# sourceMappingURL=collectAllDiscard.d.ts.map