import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { STM } from "@effect/core/stm/STM/definition/base";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Collects the first element of the `Collection<A?` for which the effectual
 * function `f` returns `Some`.
 * @tsplus static effect/core/stm/STM.Ops collectFirst
 * @tsplus location "@effect/core/stm/STM/operations/collectFirst"
 */
export declare function collectFirst<R, E, A, B>(as: Collection<A>, f: (a: A) => STM<R, E, Maybe<B>>): STM<R, E, Maybe<B>>;
//# sourceMappingURL=collectFirst.d.ts.map