import { LazyArg } from "@tsplus/stdlib/data/Function";
import { STM } from "@effect/core/stm/STM/definition/base";
/**
 * Evaluate the predicate, return the given `A` as success if predicate returns
 * true, and the given `E` as error otherwise
 *
 * For effectful conditionals, see `ifSTM`.
 * @tsplus static effect/core/stm/STM.Ops cond
 * @tsplus location "@effect/core/stm/STM/operations/cond"
 */
export declare function cond<E, A>(predicate: LazyArg<boolean>, result: LazyArg<A>, error: LazyArg<E>): STM<never, E, A>;
//# sourceMappingURL=cond.d.ts.map