import { STM } from "@effect/core/stm/STM/definition/base";
import { MergeRecord } from "@tsplus/stdlib/utilities/Types";
/**
 * Binds an effectful value in a `do` scope
 * @tsplus static effect/core/stm/STM.Aspects bind
 * @tsplus pipeable effect/core/stm/STM bind
 * @tsplus location "@effect/core/stm/STM/operations/do"
 */
export declare function bind<R, E, A, K, N extends string>(tag: Exclude<N, keyof K>, f: (_: K) => STM<R, E, A>): <R2, E2>(self: import("../definition").STM<R2, E2, K>) => import("../definition").STM<R | R2, E | E2, import("@tsplus/stdlib/utilities/Types").MergeRecord<K, { [k in N]: A; }>>;
/**
 * Like bind for values
 * @tsplus static effect/core/stm/STM.Aspects bindValue
 * @tsplus pipeable effect/core/stm/STM bindValue
 * @tsplus location "@effect/core/stm/STM/operations/do"
 */
export declare function bindValue<A, K, N extends string>(tag: Exclude<N, keyof K>, f: (_: K) => A): <R2, E2>(self: import("../definition").STM<R2, E2, K>) => import("../definition").STM<R2, E2, import("@tsplus/stdlib/utilities/Types").MergeRecord<K, { [k in N]: A; }>>;
/**
 * @tsplus static effect/core/stm/STM.Ops Do
 * @tsplus location "@effect/core/stm/STM/operations/do"
 */
export declare function Do(): STM<never, never, {}>;
//# sourceMappingURL=do.d.ts.map