import { Refinement, LazyArg } from "@tsplus/stdlib/data/Function";
import { STM } from "@effect/core/stm/STM/definition/base";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Fails with the specified error if the predicate fails.
 * @tsplus static effect/core/stm/STM.Aspects filterOrFail
 * @tsplus pipeable effect/core/stm/STM filterOrFail
 * @tsplus location "@effect/core/stm/STM/operations/filterOrFail"
 */
export declare function filterOrFail<A, B extends A, E1>(f: Refinement<A, B>, e: LazyArg<E1>): <R, E>(self: STM<R, E, A>) => STM<R, E | E1, B>;
export declare function filterOrFail<A, E1>(f: Predicate<A>, e: LazyArg<E1>): <R, E>(self: STM<R, E, A>) => STM<R, E | E1, A>;
//# sourceMappingURL=filterOrFail.d.ts.map