import { Refinement } from "@tsplus/stdlib/data/Function";
import { STM } from "@effect/core/stm/STM/definition/base";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Fails with `failWith` if the predicate fails.
 * @tsplus static effect/core/stm/STM.Aspects filterOrFailWith
 * @tsplus pipeable effect/core/stm/STM filterOrFailWith
 * @tsplus location "@effect/core/stm/STM/operations/filterOrFailWith"
 */
export declare function filterOrFailWith<A, B extends A, E1>(f: Refinement<A, B>, failWith: (a: Exclude<A, B>) => E1): <R, E>(self: STM<R, E, A>) => STM<R, E | E1, B>;
export declare function filterOrFailWith<A, E1>(f: Predicate<A>, failWith: (a: A) => E1): <R, E>(self: STM<R, E, A>) => STM<R, E | E1, A>;
//# sourceMappingURL=filterOrFailWith.d.ts.map