import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { STM } from "@effect/core/stm/STM/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Applies the function `f` to each element of the `Collection<A>` and
 * returns a transactional effect that produces a new `Chunk<B>`.
 * @tsplus static effect/core/stm/STM.Ops forEach
 * @tsplus location "@effect/core/stm/STM/operations/forEach"
 */
export declare function forEach<A, R, E, B>(as: Collection<A>, f: (a: A) => STM<R, E, B>): STM<R, E, Chunk<B>>;
//# sourceMappingURL=forEach.d.ts.map