import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { STM } from "@effect/core/stm/STM/definition/base";
/**
 * Applies the function `f` to each element of the `Collection<A>` and runs
 * produced effects sequentially.
 *
 * Equivalent to `unit(forEach(as, f))`, but without the cost of building
 * the list of results.
 * @tsplus static effect/core/stm/STM.Ops forEachDiscard
 * @tsplus location "@effect/core/stm/STM/operations/forEachDiscard"
 */
export declare function forEachDiscard<R, E, A, X>(as: Collection<A>, f: (a: A) => STM<R, E, X>): STM<R, E, void>;
//# sourceMappingURL=forEachDiscard.d.ts.map