"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GenSTM = void 0;
exports.gen = gen;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/definition/primitives"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/suspend"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * inspired by https://github.com/tusharmath/qio/pull/22 (revised)
 */
class GenSTM {
  constructor(stm) {
    this.stm = stm;
  }

  *[Symbol.iterator]() {
    return yield this;
  }

}

exports.GenSTM = GenSTM;

const adapter = (_, __) => {
  return new GenSTM(_);
};
/**
 * Do simulation using Generators
 *
 * @tsplus static effect/core/stm/STM.Ops gen
 */


function gen(f) {
  return tsplus_module_2.suspend(() => {
    const iterator = f(adapter);
    const state = iterator.next();

    function run(state) {
      if (state.done) {
        return tsplus_module_1.succeed(state.value);
      }

      return tsplus_module_1.flatMap(val => {
        const next = iterator.next(val);
        return run(next);
      })(state.value["stm"]);
    }

    return run(state);
  });
}
//# sourceMappingURL=gen.js.map