import { STM } from "@effect/core/stm/STM/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { ListBuffer } from "@tsplus/stdlib/collections/mutable/ListBuffer";
/**
 * Loops with the specified transactional function, collecting the results
 * into a list. The moral equivalent of:
 *
 * ```typescript
 * let s  = initial
 * let as = [] as readonly A[]
 *
 * while (cont(s)) {
 *   as = [body(s), ...as]
 *   s  = inc(s)
 * }
 *
 * A.reverse(as)
 * ```
 * @tsplus static effect/core/stm/STM.Ops loop
 * @tsplus location "@effect/core/stm/STM/operations/loop"
 */
export declare function loop<Z>(initial: Z, cont: (z: Z) => boolean, inc: (z: Z) => Z): <R, E, A>(body: (z: Z) => import("../definition").STM<R, E, A>) => import("../definition").STM<R, E, import("@tsplus/stdlib/collections/Chunk").Chunk<A>>;
//# sourceMappingURL=loop.d.ts.map