import { STM } from "@effect/core/stm/STM/definition/base";
/**
 * Loops with the specified transactional function purely for its
 * transactional effects. The moral equivalent of:
 *
 * ```typescript
 * var s = initial
 *
 * while (cont(s)) {
 *   body(s)
 *   s = inc(s)
 * }
 * ```
 * @tsplus static effect/core/stm/STM.Ops loopDiscard
 * @tsplus location "@effect/core/stm/STM/operations/loopDiscard"
 */
export declare function loopDiscard<Z>(initial: Z, cont: (z: Z) => boolean, inc: (z: Z) => Z): <R, E, X>(body: (z: Z) => import("../definition").STM<R, E, X>) => import("../definition").STM<R, E, void>;
//# sourceMappingURL=loopDiscard.d.ts.map