import { LazyArg } from "@tsplus/stdlib/data/Function";
import { STM } from "@effect/core/stm/STM/definition/base";
import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Returns a transactional effect that will produce the value of this effect
 * in left side, unless it fails or retries, in which case, it will produce
 * the value of the specified effect in right side.
 * @tsplus static effect/core/stm/STM.Aspects orElseEither
 * @tsplus pipeable effect/core/stm/STM orElseEither
 * @tsplus location "@effect/core/stm/STM/operations/orElseEither"
 */
export declare function orElseEither<R1, E1, B>(that: LazyArg<STM<R1, E1, B>>): <R, E, A>(self: import("../definition").STM<R, E, A>) => import("../definition").STM<R1 | R, E1 | E, import("@tsplus/stdlib/data/Either").Either<A, B>>;
//# sourceMappingURL=orElseEither.d.ts.map