import { LazyArg } from "@tsplus/stdlib/data/Function";
import { STM } from "@effect/core/stm/STM/definition/base";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Returns an effect that will produce the value of this effect, unless it
 * fails with the `None` value, in which case it will produce the value of the
 * specified effect.
 * @tsplus static effect/core/stm/STM.Aspects orElseOptional
 * @tsplus pipeable effect/core/stm/STM orElseOptional
 * @tsplus location "@effect/core/stm/STM/operations/orElseOptional"
 */
export declare function orElseOptional<R1, E1, A1>(that: LazyArg<STM<R1, Maybe<E1>, A1>>): <R, E, A>(self: import("../definition").STM<R, import("@tsplus/stdlib/data/Maybe").Maybe<E>, A>) => import("../definition").STM<R1 | R, import("@tsplus/stdlib/data/Maybe").Maybe<E1 | E>, A1 | A>;
//# sourceMappingURL=orElseOptional.d.ts.map