"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.orTry = orTry;

var _primitives = /*#__PURE__*/require("@effect/core/stm/STM/definition/primitives");

/**
 * Tries this effect first, and if it enters retry, then it tries the other
 * effect. This is an equivalent of haskell's orElse.
 *
 * @tsplus static effect/core/stm/STM.Aspects orTry
 * @tsplus pipeable effect/core/stm/STM orTry
 */
function orTry(that) {
  return self => new _primitives.STMOnRetry(self, that);
}
//# sourceMappingURL=orTry.js.map