import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { STM } from "@effect/core/stm/STM/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Feeds elements of type `A` to a function `f` that returns an effect.
 * Collects all successes and failures in a tupled fashion.
 * @tsplus static effect/core/stm/STM.Ops partition
 * @tsplus location "@effect/core/stm/STM/operations/partition"
 */
export declare function partition<R, E, A, B>(as: Collection<A>, f: (a: A) => STM<R, E, B>): STM<R, never, readonly [Chunk<E>, Chunk<B>]>;
//# sourceMappingURL=partition.d.ts.map