import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { STM } from "@effect/core/stm/STM/definition/base";
/**
 * Continue with the returned computation if the `PartialFunction` matches,
 * translating the successful match into a failure, otherwise continue with
 * our held value.
 * @tsplus static effect/core/stm/STM.Aspects rejectSTM
 * @tsplus pipeable effect/core/stm/STM rejectSTM
 * @tsplus location "@effect/core/stm/STM/operations/rejectSTM"
 */
export declare function rejectSTM<A, R1, E1>(pf: (a: A) => Maybe<STM<R1, E1, E1>>): <R, E>(self: import("../definition").STM<R, E, A>) => import("../definition").STM<R1 | R, E1 | E, A>;
//# sourceMappingURL=rejectSTM.d.ts.map