import { STM } from "@effect/core/stm/STM/definition/base";
import type { STMTypeId } from "@effect/core/stm/STM";
type NonEmptyArraySTM = Array<STM<any, any, any>> & {
    readonly 0: STM<any, any, any>;
};
export type TupleA<T extends NonEmptyArraySTM> = {
    [K in keyof T]: [T[K]] extends [STM<any, any, infer A>] ? A : never;
};
/**
 * Like `forEach` + `identity` with a tuple type.
 * @tsplus static effect/core/stm/STM.Ops tuple
 * @tsplus location "@effect/core/stm/STM/operations/tuple"
 */
export declare function tuple<T extends NonEmptyArraySTM>(...t: T & {
    0: STM<any, any, any>;
}): STM<[
    T[number]
] extends [{
    [STMTypeId]: {
        _R: (_: never) => infer R;
    };
}] ? R : never, [
    T[number]
] extends [{
    [STMTypeId]: {
        _E: (_: never) => infer E;
    };
}] ? E : never, TupleA<T>>;
export {};
//# sourceMappingURL=tuple.d.ts.map