import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { STM } from "@effect/core/stm/STM/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Feeds elements of type `A` to `f` and accumulates all errors in error
 * channel or successes in success channel.
 *
 * This combinator is lossy meaning that if there are errors all successes
 * will be lost. To retain all information please use `partition`.
 * @tsplus static effect/core/stm/STM.Ops validate
 * @tsplus location "@effect/core/stm/STM/operations/validate"
 */
export declare function validate<R, E, A, B>(as: Collection<A>, f: (a: A) => STM<R, E, B>): STM<R, Chunk<E>, Chunk<B>>;
//# sourceMappingURL=validate.d.ts.map