import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { STM } from "@effect/core/stm/STM/definition/base";
import { TArray } from "@effect/core/stm/TArray/definition";
/**
 * Finds the result of applying an transactional partial function to the first
 * value in its domain.
 * @tsplus static effect/core/stm/TArray.Aspects collectFirstSTM
 * @tsplus pipeable effect/core/stm/TArray collectFirstSTM
 * @tsplus location "@effect/core/stm/TArray/operations/collectFirstSTM"
 */
export declare function collectFirstSTM<A, E, B>(pf: (a: A) => Maybe<STM<never, E, B>>): (self: TArray<A>) => STM<never, E, Maybe<B>>;
//# sourceMappingURL=collectFirstSTM.d.ts.map