"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.findLast = findLast;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeGet"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/effect"));

var _InternalTArray = /*#__PURE__*/require("@effect/core/stm/TArray/operations/_internal/InternalTArray");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Find the last element in the array matching a predicate.
 *
 * @tsplus static effect/core/stm/TArray.Aspects findLast
 * @tsplus pipeable effect/core/stm/TArray findLast
 */
function findLast(f) {
  return self => tsplus_module_4.effect(journal => {
    void 0;
    let i = self.chunk.length - 1;
    let res = tsplus_module_1.empty();

    while (tsplus_module_1.isNone(res) && i >= 0) {
      const a = tsplus_module_3.unsafeGet(journal)(tsplus_module_2.unsafeGet(i)(self.chunk));

      if (f(a)) {
        res = tsplus_module_1.some(a);
      }

      i = i - 1;
    }

    return res;
  });
}
//# sourceMappingURL=findLast.js.map