"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.findSTM = findSTM;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/definition/primitives"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/get"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/iterate"));

var _InternalTArray = /*#__PURE__*/require("@effect/core/stm/TArray/operations/_internal/InternalTArray");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Find the first element in the array matching a transactional predicate.
 *
 * @tsplus static effect/core/stm/TArray.Aspects findSTM
 * @tsplus pipeable effect/core/stm/TArray findSTM
 */
function findSTM(f) {
  return self => {
    void 0;
    const init = [tsplus_module_1.empty(), 0];

    const cont = s => tsplus_module_1.isNone(s[0]) && s[1] < self.chunk.length;

    return tsplus_module_2.map(tuple => tuple[0])(tsplus_module_5.iterate(init, cont)(s => {
      const index = s[1];
      return tsplus_module_2.flatMap(a => tsplus_module_2.map(result => [result ? tsplus_module_1.some(a) : tsplus_module_1.none, index + 1])(f(a)))(tsplus_module_4.get(tsplus_module_3.unsafeGet(index)(self.chunk)));
    }));
  };
}
//# sourceMappingURL=findSTM.js.map