"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.indexWhereFromSTM = indexWhereFromSTM;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/definition/primitives"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/get"));

var _InternalTArray = /*#__PURE__*/require("@effect/core/stm/TArray/operations/_internal/InternalTArray");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Starting at specified index, get the index of the next entry that matches a
 * transactional predicate.
 *
 * @tsplus static effect/core/stm/TArray.Aspects indexWhereFromSTM
 * @tsplus pipeable effect/core/stm/TArray indexWhereFromSTM
 */
function indexWhereFromSTM(f, from) {
  return self => {
    if (from < 0) {
      return tsplus_module_1.succeed(-1);
    }

    return forIndex(self, from, f);
  };
}

function forIndex(self, index, f) {
  void 0;
  return index < self.chunk.length ? tsplus_module_1.flatMap(result => result ? tsplus_module_1.succeed(index) : forIndex(self, index + 1, f))(tsplus_module_1.flatMap(f)(tsplus_module_3.get(tsplus_module_2.unsafeGet(index)(self.chunk)))) : tsplus_module_1.succeed(-1);
}
//# sourceMappingURL=indexWhereFromSTM.js.map