"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.updateSTM = updateSTM;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/set"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/definition/primitives"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/get"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/exceptions"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/dieSync"));

var _InternalTArray = /*#__PURE__*/require("@effect/core/stm/TArray/operations/_internal/InternalTArray");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Atomically updates element in the array with given transactional effect.
 *
 * @tsplus static effect/core/stm/TArray.Aspects updateSTM
 * @tsplus pipeable effect/core/stm/TArray updateSTM
 */
function updateSTM(index, f) {
  return self => {
    void 0;

    if (0 <= index && index < self.chunk.length) {
      return tsplus_module_3.flatMap(currentVal => tsplus_module_3.flatMap(newVal => tsplus_module_2.set(newVal)(tsplus_module_1.unsafeGet(index)(self.chunk)))(f(currentVal)))(tsplus_module_4.get(tsplus_module_1.unsafeGet(index)(self.chunk)));
    } else {
      return tsplus_module_6.dieSync(() => new tsplus_module_5.IndexOutOfBounds(index, 0, self.chunk.length));
    }
  };
}
//# sourceMappingURL=updateSTM.js.map