"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports._A = exports.THubSym = exports.THub = exports.Sliding = exports.Dropping = exports.BackPressure = void 0;

var _TDequeue = /*#__PURE__*/require("@effect/core/stm/THub/definition/TDequeue");

const THubSym = /*#__PURE__*/Symbol.for("@effect/core/stm/THub");
exports.THubSym = THubSym;

const _A = /*#__PURE__*/Symbol.for("@effect/core/stm/THub/A");

exports._A = _A;
const THub = {
  $: {},
  TDequeue: _TDequeue.TDequeueOps,
  Node: {}
};
/**
 * A strategy that retries if the hub is at capacity.
 *
 * @tsplus static effect/core/stm/THub.Ops BackPressure
 */

exports.THub = THub;
const BackPressure = {
  _tag: "BackPressure"
};
/**
 * A strategy that drops new messages if the hub is at capacity.
 *
 * @tsplus static effect/core/stm/THub.Ops Dropping
 */

exports.BackPressure = BackPressure;
const Dropping = {
  _tag: "Dropping"
};
/**
 * A strategy that drops old messages if the hub is at capacity.
 *
 * @tsplus static effect/core/stm/THub.Ops Sliding
 */

exports.Dropping = Dropping;
const Sliding = {
  _tag: "Sliding"
};
exports.Sliding = Sliding;
//# sourceMappingURL=THub.js.map