import { THub } from "@effect/core/stm/THub/definition";
import { STM } from "@effect/core/stm/STM/definition/base";
/**
 * Drops elements from the queue while they do not satisfy the predicate,
 * taking and returning the first element that does satisfy the predicate.
 * Retries if no elements satisfy the predicate.
 * @tsplus static effect/core/stm/THub/TDequeue.Aspects seek
 * @tsplus pipeable effect/core/stm/THub/TDequeue seek
 * @tsplus location "@effect/core/stm/THub/operations/TDequeue/seek"
 */
export declare function seek<A>(f: (a: A) => boolean): (self: THub.TDequeue<A>) => STM<never, never, A>;
//# sourceMappingURL=seek.d.ts.map