"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.size = size;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeGet"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/effect"));

var _STM = /*#__PURE__*/require("@effect/core/stm/STM");

var _InternalTDequeue = /*#__PURE__*/require("@effect/core/stm/THub/operations/_internal/InternalTDequeue");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * The current number of values in the queue.
 *
 * @tsplus getter effect/core/stm/THub/TDequeue size
 */
function size(self) {
  void 0;
  return tsplus_module_2.effect((journal, fiberId) => {
    let currentSubscriberHead = tsplus_module_1.unsafeGet(journal)(self.subscriberHead);

    if (currentSubscriberHead == null) {
      throw new _STM.STMInterruptException(fiberId);
    }

    let loop = true;
    let size = 0;

    while (loop) {
      const node = tsplus_module_1.unsafeGet(journal)(currentSubscriberHead);

      if (node == null) {
        loop = false;
      } else {
        const head = node.head;
        const tail = node.tail;

        if (head != null) {
          size += 1;

          if (size == Number.MAX_SAFE_INTEGER) {
            loop = false;
          }
        }

        currentSubscriberHead = tail;
      }
    }

    return size;
  });
}
//# sourceMappingURL=size.js.map