"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.shutdown = shutdown;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeGet"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeSet"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashSet/operations/forEach"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashSet/operations/empty"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/effect"));

var _InternalTHub = /*#__PURE__*/require("@effect/core/stm/THub/operations/_internal/InternalTHub");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Shuts down the hub.
 *
 * @tsplus getter effect/core/stm/THub shutdown
 */
function shutdown(self) {
  void 0;
  return tsplus_module_5.effect(journal => {
    const currentPublisherTail = tsplus_module_1.unsafeGet(journal)(self.publisherTail);

    if (currentPublisherTail == null) {
      tsplus_module_2.unsafeSet(undefined, journal)(self.publisherTail);
      const currentSubscribers = tsplus_module_1.unsafeGet(journal)(self.subscribers);
      tsplus_module_3.forEach(_ => tsplus_module_2.unsafeSet(undefined, journal)(_))(currentSubscribers);
      tsplus_module_2.unsafeSet(tsplus_module_4.empty(), journal)(self.subscribers);
    }
  });
}
//# sourceMappingURL=shutdown.js.map