import { STM } from "@effect/core/stm/STM/definition/base";
import { THub } from "@effect/core/stm/THub/definition";
/**
 * Creates a bounded hub with the sliding strategy. The hub will add new
 * messages and drop old messages if the hub is at capacity.
 *
 * For best performance use capacities that are powers of two.
 * @tsplus static effect/core/stm/THub.Ops sliding
 * @tsplus location "@effect/core/stm/THub/operations/THub/sliding"
 */
export declare function sliding<A>(requestedCapacity: number): STM<never, never, THub<A>>;
//# sourceMappingURL=sliding.d.ts.map