"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports._delete = void 0;
exports.delete = _delete_1;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeGet"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TMap/operations/indexOf"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/partition"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/definition"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeSet"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/effect"));

var _InternalTArray = /*#__PURE__*/require("@effect/core/stm/TArray/operations/_internal/InternalTArray");

var _InternalTMap = /*#__PURE__*/require("@effect/core/stm/TMap/operations/_internal/InternalTMap");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const _delete = _delete_1;
exports._delete = _delete;

/**
 * Removes binding for given key.
 *
 * @tsplus static effect/core/stm/TMap.Aspects delete
 * @tsplus pipeable effect/core/stm/TMap delete
 */
function _delete_1(k) {
  return self => {
    void 0;
    return tsplus_module_8.effect(journal => {
      const buckets = tsplus_module_1.unsafeGet(journal)(self.tBuckets);
      void 0;
      const idx = tsplus_module_2.indexOf(k, buckets.chunk.length);
      const bucket = tsplus_module_1.unsafeGet(journal)(tsplus_module_3.unsafeGet(idx)(buckets.chunk));
      const [toRemove, toRetain] = tsplus_module_5.partition(_ => !tsplus_module_4.equals(_[0], k))(bucket);

      if (tsplus_module_6.isCons(toRemove)) {
        const currSize = tsplus_module_1.unsafeGet(journal)(self.tSize);
        tsplus_module_7.unsafeSet(toRetain, journal)(tsplus_module_3.unsafeGet(idx)(buckets.chunk));
        tsplus_module_7.unsafeSet(currSize - 1, journal)(self.tSize);
      }
    });
  };
}
//# sourceMappingURL=delete.js.map