import { STM } from "@effect/core/stm/STM/definition/base";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { TMap } from "@effect/core/stm/TMap/definition";
/**
 * Finds the key/value pair matching the specified predicate, and uses the
 * provided effectful function to extract a value out of it.
 * @tsplus static effect/core/stm/TMap.Aspects findSTM
 * @tsplus pipeable effect/core/stm/TMap findSTM
 * @tsplus location "@effect/core/stm/TMap/operations/findSTM"
 */
export declare function findSTM<K, V, R, E, A>(f: (kv: readonly [K, V]) => STM<R, Maybe<E>, A>): (self: TMap<K, V>) => STM<R, E, Maybe<A>>;
//# sourceMappingURL=findSTM.d.ts.map