"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fold = fold;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeGet"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/reduce"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/effect"));

var _InternalTArray = /*#__PURE__*/require("@effect/core/stm/TArray/operations/_internal/InternalTArray");

var _InternalTMap = /*#__PURE__*/require("@effect/core/stm/TMap/operations/_internal/InternalTMap");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Atomically folds using a pure function.
 *
 * @tsplus static effect/core/stm/TMap.Aspects fold
 * @tsplus pipeable effect/core/stm/TMap fold
 */
function fold(zero, op) {
  return self => {
    void 0;
    return tsplus_module_4.effect(journal => {
      const buckets = tsplus_module_1.unsafeGet(journal)(self.tBuckets);
      void 0;
      let res = zero;
      let i = 0;

      while (i < buckets.chunk.length) {
        const bucket = tsplus_module_2.unsafeGet(i)(buckets.chunk);
        const items = tsplus_module_1.unsafeGet(journal)(bucket);
        res = tsplus_module_3.reduce(res, op)(items);
        i += 1;
      }

      return res;
    });
  };
}
//# sourceMappingURL=fold.js.map