import { TMap } from "@effect/core/stm/TMap/definition";
import { STM } from "@effect/core/stm/STM/definition/base";
/**
 * If the key `k` is not already associated with a value, stores the provided
 * value, otherwise merge the existing value with the new one using function
 * `f` and store the result
 * @tsplus static effect/core/stm/TMap.Aspects merge
 * @tsplus pipeable effect/core/stm/TMap merge
 * @tsplus location "@effect/core/stm/TMap/operations/merge"
 */
export declare function merge_<K, V>(k: K, v: V, f: (values: readonly [V, V]) => V): (self: TMap<K, V>) => STM<never, never, V>;
//# sourceMappingURL=merge.d.ts.map