"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.put = put;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeGet"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TMap/operations/indexOf"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeMake"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeSet"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/exists"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/map"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/effect"));

var _InternalTArray = /*#__PURE__*/require("@effect/core/stm/TArray/operations/_internal/InternalTArray");

var _InternalTMap = /*#__PURE__*/require("@effect/core/stm/TMap/operations/_internal/InternalTMap");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const LOAD_FACTOR = .75;

function resize(self, journal, buckets, k, v) {
  void 0;
  const capacity = buckets.chunk.length;
  const newCapacity = capacity << 1;
  const newBuckets = Array.from({
    length: newCapacity
  }, () => tsplus_module_1.nil());
  let i = 0;

  while (i < capacity) {
    const pairs = tsplus_module_3.unsafeGet(journal)(tsplus_module_2.unsafeGet(i)(buckets.chunk));

    for (const pair of pairs) {
      const idx = tsplus_module_4.indexOf(pair[0], newCapacity);
      newBuckets[idx] = tsplus_module_1.cons(pair, newBuckets[idx]);
    }

    i += 1;
  }

  const newIdx = tsplus_module_4.indexOf(k, newCapacity);
  newBuckets[newIdx] = tsplus_module_1.cons([k, v], newBuckets[newIdx]);
  const newArray = new Array(newCapacity);
  i = 0;

  while (i < newCapacity) {
    newArray[i] = tsplus_module_5.unsafeMake(newBuckets[i]);
    i += 1;
  }

  void 0;
  tsplus_module_7.unsafeSet(new _InternalTArray.InternalTArray(tsplus_module_6.from(newArray)), journal)(self.tBuckets);
}
/**
 * Stores new binding into the map.
 *
 * @tsplus static effect/core/stm/TMap.Aspects put
 * @tsplus pipeable effect/core/stm/TMap put
 */


function put(k, v) {
  return self => {
    void 0;
    return tsplus_module_11.effect(journal => {
      const buckets = tsplus_module_3.unsafeGet(journal)(self.tBuckets);
      void 0;
      const capacity = buckets.chunk.length;
      const idx = tsplus_module_4.indexOf(k, capacity);
      const bucket = tsplus_module_3.unsafeGet(journal)(tsplus_module_2.unsafeGet(idx)(buckets.chunk));
      const shouldUpdate = tsplus_module_9.exists(_ => tsplus_module_8.equals(_[0], k))(bucket);

      if (shouldUpdate) {
        const newBucket = tsplus_module_10.map(kv => tsplus_module_8.equals(kv[0], k) ? [k, v] : kv)(bucket);
        tsplus_module_7.unsafeSet(newBucket, journal)(tsplus_module_2.unsafeGet(idx)(buckets.chunk));
      } else {
        const newSize = tsplus_module_3.unsafeGet(journal)(self.tSize) + 1;
        tsplus_module_7.unsafeSet(newSize, journal)(self.tSize);

        if (capacity * LOAD_FACTOR < newSize) {
          resize(self, journal, buckets, k, v);
        } else {
          const newBucket = tsplus_module_1.cons([k, v], bucket);
          tsplus_module_7.unsafeSet(newBucket, journal)(tsplus_module_2.unsafeGet(idx)(buckets.chunk));
        }
      }
    });
  };
}
//# sourceMappingURL=put.js.map