"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.removeIfDiscard = removeIfDiscard;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeGet"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/empty"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/prepend"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeSet"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/effect"));

var _InternalTArray = /*#__PURE__*/require("@effect/core/stm/TArray/operations/_internal/InternalTArray");

var _InternalTMap = /*#__PURE__*/require("@effect/core/stm/TMap/operations/_internal/InternalTMap");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Removes bindings matching predicate.
 *
 * @tsplus static effect/core/stm/TMap.Aspects removeIfDiscard
 * @tsplus pipeable effect/core/stm/TMap removeIfDiscard
 */
function removeIfDiscard(f) {
  return self => {
    void 0;
    return tsplus_module_6.effect(journal => {
      const buckets = tsplus_module_1.unsafeGet(journal)(self.tBuckets);
      void 0;
      const capacity = buckets.chunk.length;
      let i = 0;
      let newSize = 0;

      while (i < capacity) {
        const bucket = tsplus_module_1.unsafeGet(journal)(tsplus_module_2.unsafeGet(i)(buckets.chunk));
        let newBucket = tsplus_module_3.empty();

        for (const pair of bucket) {
          if (!f(pair)) {
            newBucket = tsplus_module_4.prepend(pair)(newBucket);
            newSize += 1;
          }
        }

        tsplus_module_5.unsafeSet(newBucket, journal)(tsplus_module_2.unsafeGet(i)(buckets.chunk));
        i += 1;
      }

      tsplus_module_5.unsafeSet(newSize, journal)(self.tSize);
    });
  };
}
//# sourceMappingURL=removeIfDiscard.js.map