"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.takeFirst = takeFirst;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Function"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeGet"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/exists"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/empty"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/prepend"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeSet"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/effect"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/continueOrRetry"));

var _InternalTArray = /*#__PURE__*/require("@effect/core/stm/TArray/operations/_internal/InternalTArray");

var _InternalTMap = /*#__PURE__*/require("@effect/core/stm/TMap/operations/_internal/InternalTMap");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Takes the first matching value, or retries until there is one.
 *
 * @tsplus static effect/core/stm/TMap.Aspects takeFirst
 * @tsplus pipeable effect/core/stm/TMap takeFirst
 */
function takeFirst(pf) {
  return self => {
    void 0;
    return tsplus_module_10.continueOrRetry(tsplus_module_1.identity)(tsplus_module_9.effect(journal => {
      let result = tsplus_module_2.none;
      const size = tsplus_module_3.unsafeGet(journal)(self.tSize);
      const buckets = tsplus_module_3.unsafeGet(journal)(self.tBuckets);
      void 0;
      const capacity = buckets.chunk.length;
      let i = 0;

      while (i < capacity && tsplus_module_2.isNone(result)) {
        const bucket = tsplus_module_3.unsafeGet(journal)(tsplus_module_4.unsafeGet(i)(buckets.chunk));
        const recreate = tsplus_module_5.exists(_ => tsplus_module_2.isSome(pf(_)))(bucket);

        if (recreate) {
          let newBucket = tsplus_module_6.empty();

          for (const pair of bucket) {
            result = pf(pair);

            if (tsplus_module_2.isSome(result)) {
              newBucket = tsplus_module_7.prepend(pair)(newBucket);
              break;
            }
          }

          tsplus_module_8.unsafeSet(newBucket, journal)(tsplus_module_4.unsafeGet(i)(buckets.chunk));
        }

        i += 1;
      }

      if (tsplus_module_2.isSome(result)) {
        tsplus_module_8.unsafeSet(size - 1, journal)(self.tSize);
      }

      return result;
    }));
  };
}
//# sourceMappingURL=takeFirst.js.map