import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { TMap } from "@effect/core/stm/TMap/definition";
import { STM } from "@effect/core/stm/STM/definition/base";
/**
 * Updates the mapping for the specified key with the specified function,
 * which takes the current value of the key as an input, if it exists, and
 * either returns `Some` with a new value to indicate to update the value in
 * the map or `None` to remove the value from the map. Returns `Some` with the
 * updated value or `None` if the value was removed from the map.
 * @tsplus static effect/core/stm/TMap.Aspects updateWith
 * @tsplus pipeable effect/core/stm/TMap updateWith
 * @tsplus location "@effect/core/stm/TMap/operations/updateWith"
 */
export declare function updateWith<K, V>(k: K, f: (v: Maybe<V>) => Maybe<V>): (self: TMap<K, V>) => STM<never, never, Maybe<V>>;
//# sourceMappingURL=updateWith.d.ts.map