export declare const TQueueSym: unique symbol;
export type TQueueSym = typeof TQueueSym;
export declare const _A: unique symbol;
export type _A = typeof _A;
/**
 * A `TQueue` is a transactional queue. Offerors can offer values to the queue
 * and takers can take values from the queue.
 *
 * @tsplus type effect/core/stm/TQueue
 */
export interface TQueue<A> {
    readonly [TQueueSym]: TQueueSym;
    readonly [_A]: (_: A) => A;
}
/**
 * @tsplus type effect/core/stm/TQueue.Ops
 */
export interface TQueueOps {
    $: TQueueAspects;
}
export declare const TQueue: TQueueOps;
/**
 * @tsplus type effect/core/stm/TQueue.Aspects
 */
export interface TQueueAspects {
}
/**
 * @tsplus type effect/core/stm/TQueue
 */
export type Strategy = BackPressure | Dropping | Sliding;
export interface BackPressure {
    _tag: "BackPressure";
}
export interface Dropping {
    _tag: "Dropping";
}
export interface Sliding {
    _tag: "Sliding";
}
/**
 * @tsplus static effect/core/stm/TQueue.Ops BackPressure
 * @tsplus location "@effect/core/stm/TQueue/definition"
 */
export declare const BackPressure: Strategy;
/**
 * @tsplus static effect/core/stm/TQueue.Ops Dropping
 * @tsplus location "@effect/core/stm/TQueue/definition"
 */
export declare const Dropping: Strategy;
/**
 * @tsplus static effect/core/stm/TQueue.Ops Sliding
 * @tsplus location "@effect/core/stm/TQueue/definition"
 */
export declare const Sliding: Strategy;
//# sourceMappingURL=definition.d.ts.map