import { USTM } from "@effect/core/stm/STM/definition/base";
import { TQueue } from "@effect/core/stm/TQueue/definition";
/**
 * Creates a bounded queue with the back pressure strategy. The queue will
 * retain values until they have been taken, applying back pressure to
 * offerors if the queue is at capacity.
 *
 * For best performance use capacities that are powers of two.
 * @tsplus static effect/core/stm/TQueue.Ops bounded
 * @tsplus location "@effect/core/stm/TQueue/operations/bounded"
 */
export declare function bounded<A>(requestedCapacity: number): USTM<TQueue<A>>;
//# sourceMappingURL=bounded.d.ts.map