"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.offerAll = offerAll;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/from"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeGet"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableQueue/size"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/definition"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableQueue/appendAll"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeSet"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TQueue/definition"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Collection/functions"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableQueue/drop"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/effect"));

var _STM = /*#__PURE__*/require("@effect/core/stm/STM");

var _InternalTQueue = /*#__PURE__*/require("@effect/core/stm/TQueue/operations/_internal/InternalTQueue");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Offers all of the specified values to the queue, returning whether they
 * were offered to the queue.
 *
 * @tsplus static effect/core/stm/TQueue.Aspects offerAll
 * @tsplus pipeable effect/core/stm/TQueue offerAll
 */
function offerAll(as0) {
  return self => {
    void 0;
    const as = tsplus_module_1.from(as0);
    return tsplus_module_11.effect((journal, fiberId) => {
      const queue = tsplus_module_2.unsafeGet(journal)(self.ref);

      if (tsplus_module_3.equals(queue, null)) {
        throw new _STM.STMInterruptException(fiberId);
      }

      if (tsplus_module_4.size(queue) + tsplus_module_5.length(as) <= self.capacity) {
        tsplus_module_7.unsafeSet(tsplus_module_6.appendAll(as)(queue), journal)(self.ref);
        return true;
      }

      switch (self.strategy) {
        case tsplus_module_8.BackPressure:
          throw new _STM.STMRetryException();

        case tsplus_module_8.Dropping:
          {
            const forQueue = tsplus_module_9.take(self.capacity - tsplus_module_4.size(queue))(as);
            tsplus_module_7.unsafeSet(tsplus_module_6.appendAll(forQueue)(queue), journal)(self.ref);
            return false;
          }

        case tsplus_module_8.Sliding:
          {
            const forQueue = tsplus_module_1.from(tsplus_module_9.take(self.capacity)(as));
            const toDrop = tsplus_module_4.size(queue) + tsplus_module_5.length(forQueue) - self.capacity;
            tsplus_module_7.unsafeSet(tsplus_module_6.appendAll(forQueue)(tsplus_module_10.drop(toDrop)(queue)), journal)(self.ref);
            return true;
          }
      }

      return false;
    });
  };
}
//# sourceMappingURL=offerAll.js.map