import { TQueue } from "@effect/core/stm/TQueue/definition";
import { STM } from "@effect/core/stm/STM/definition/base";
/**
 * Drops elements from the queue while they do not satisfy the predicate,
 * taking and returning the first element that does satisfy the predicate.
 * Retries if no elements satisfy the predicate.
 * @tsplus static effect/core/stm/TQueue.Aspects seek
 * @tsplus pipeable effect/core/stm/TQueue seek
 * @tsplus location "@effect/core/stm/TQueue/operations/seek"
 */
export declare function seek<A>(f: (a: A) => boolean): (self: TQueue<A>) => STM<never, never, A>;
//# sourceMappingURL=seek.d.ts.map