import { USTM } from "@effect/core/stm/STM/definition/base";
import { TQueue } from "@effect/core/stm/TQueue/definition";
/**
 * Creates a bounded queue with the sliding strategy. The queue will add new
 * values and drop old values if the queue is at capacity.
 *
 * For best performance use capacities that are powers of two.
 * @tsplus static effect/core/stm/TQueue.Ops sliding
 * @tsplus location "@effect/core/stm/TQueue/operations/sliding"
 */
export declare function sliding<A>(requestedCapacity: number): USTM<TQueue<A>>;
//# sourceMappingURL=sliding.d.ts.map