"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.takeUpTo = takeUpTo;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeGet"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableQueue/splitAt"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeSet"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/effect"));

var _STM = /*#__PURE__*/require("@effect/core/stm/STM");

var _InternalTQueue = /*#__PURE__*/require("@effect/core/stm/TQueue/operations/_internal/InternalTQueue");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Takes up to the specified number of values from the queue.
 *
 * @tsplus static effect/core/stm/TQueue.Aspects takeUpTo
 * @tsplus pipeable effect/core/stm/TQueue takeUpTo
 */
function takeUpTo(max) {
  return self => {
    void 0;
    return tsplus_module_6.effect((journal, fiberId) => {
      const queue = tsplus_module_1.unsafeGet(journal)(self.ref);

      if (tsplus_module_2.equals(queue, null)) {
        throw new _STM.STMInterruptException(fiberId);
      }

      const [toTake, remaining] = tsplus_module_3.splitAt(max)(queue);
      tsplus_module_4.unsafeSet(remaining, journal)(self.ref);
      return tsplus_module_5.from(toTake);
    });
  };
}
//# sourceMappingURL=takeUpTo.js.map