import { TRandom } from "@effect/core/stm/TRandom/definition";
import { TRef } from "@effect/core/stm/TRef/definition";
import { STM } from "@effect/core/stm/STM/definition/base";
import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { TRandomSym } from "@effect/core/stm/TRandom/definition";
import type { PCGRandomState } from "@tsplus/stdlib/io/Random";
/**
 * @tsplus static effect/core/stm/TRandom.Ops default
 * @tsplus location "@effect/core/stm/TRandom/operations/live"
 */
export declare const defaultTRandom: import("../../../io/Effect").Effect<never, never, LiveTRandom>;
/**
 * @tsplus static effect/core/stm/TRandom.Ops live
 * @tsplus location "@effect/core/stm/TRandom/operations/live"
 */
export declare const live: import("../../../io/Layer").Layer<never, never, import("@effect/core/stm/TRandom/definition").TRandom>;
export declare class LiveTRandom implements TRandom {
    readonly state: TRef<PCGRandomState>;
    readonly [TRandomSym]: TRandomSym;
    constructor(state: TRef<PCGRandomState>);
    withState<A>(f: (state: PCGRandomState) => readonly [A, PCGRandomState]): STM<never, never, A>;
    get next(): STM<never, never, number>;
    get nextBoolean(): STM<never, never, boolean>;
    get nextInt(): STM<never, never, number>;
    nextRange(low: number, high: number): STM<never, never, number>;
    nextIntBetween(low: number, high: number): STM<never, never, number>;
    shuffle<A>(collection: Collection<A>): STM<never, never, Collection<A>>;
}
//# sourceMappingURL=live.d.ts.map