"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.live = exports.defaultTRandom = exports.LiveTRandom = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/io/Random/PCGRandom"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/make"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/definition/primitives"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRandom/definition"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Layer/operations/fromEffect"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/modify"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TArray/operations/toChunk"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/forEachDiscard"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TArray/operations/update"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TArray/operations/get"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TArray/operations/updateSTM"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/tap"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/unit"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TArray/operations/from"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a;

/**
 * @tsplus static effect/core/stm/TRandom.Ops default
 */
const defaultTRandom_1 = /*#__PURE__*/tsplus_module_3.map(_ => new LiveTRandom(_))( /*#__PURE__*/tsplus_module_2.make(() => new tsplus_module_1.PCGRandom(Math.random() * 4294967296 >>> 0).getState())).commit;
const defaultTRandom = defaultTRandom_1;
/**
 * @tsplus static effect/core/stm/TRandom.Ops live
 */

exports.defaultTRandom = defaultTRandom;
const live = /*#__PURE__*/tsplus_module_5.fromEffect(tsplus_module_4.TRandom.Tag)(defaultTRandom_1);
exports.live = live;

function rndInt(state) {
  const prng = new tsplus_module_1.PCGRandom();
  prng.setState(state);
  return [prng.integer(0), prng.getState()];
}

function rndIntBetween(low, high) {
  return state => {
    const prng = new tsplus_module_1.PCGRandom();
    prng.setState(state);
    return [prng.integer(high - low) + low, prng.getState()];
  };
}

function rndNumber(state) {
  const prng = new tsplus_module_1.PCGRandom();
  prng.setState(state);
  return [prng.number(), prng.getState()];
}

class LiveTRandom {
  constructor(state) {
    this.state = state;
    this[_a] = tsplus_module_4.TRandomSym;
  }

  withState(f) {
    return tsplus_module_6.modify(f)(this.state);
  }

  get next() {
    return this.withState(rndNumber);
  }

  get nextBoolean() {
    return tsplus_module_3.flatMap(n => tsplus_module_3.succeed(n > 0.5))(this.next);
  }

  get nextInt() {
    return this.withState(rndInt);
  }

  nextRange(low, high) {
    return tsplus_module_3.flatMap(n => tsplus_module_3.succeed((high - low) * n + low))(this.next);
  }

  nextIntBetween(low, high) {
    return this.withState(rndIntBetween(low, high));
  }

  shuffle(collection) {
    return shuffleWith(collection, n => this.nextIntBetween(0, n));
  }

}

exports.LiveTRandom = LiveTRandom;
_a = tsplus_module_4.TRandomSym;

function shuffleWith(collection, nextIntBounded) {
  return (() => {
    const array = Array.from(collection);
    return tsplus_module_3.flatMap(buffer => {
      const swap = (i1, i2) => tsplus_module_13.unit(tsplus_module_12.tap(tmp => tsplus_module_9.update(i2, _ => tmp)(buffer))(tsplus_module_12.tap(() => tsplus_module_11.updateSTM(i1, _ => tsplus_module_10.get(i2)(buffer))(buffer))(tsplus_module_10.get(i1)(buffer))));

      const ns = [];

      for (let i = array.length; i >= 2; i = i - 1) {
        ns.push(i);
      }

      return tsplus_module_3.flatMap(() => tsplus_module_7.toChunk(buffer))(tsplus_module_8.forEachDiscard(ns, n => tsplus_module_3.flatMap(k => swap(n - 1, k))(nextIntBounded(n))));
    })(tsplus_module_14.from(array));
  })();
}
//# sourceMappingURL=live.js.map