import { FiberId } from "@effect/core/io/FiberId/definition";
import { TReentrantLock } from "@effect/core/stm/TReentrantLock/definition";
/**
 * Determines if there is no other holder of read locks aside from the
 * specified fiber id. If there are no other holders of read locks aside
 * from the specified fiber id, then it is safe to upgrade the read lock
 * into a write lock.
 * @tsplus static effect/core/stm/TReentrantLock/ReadLock.Aspects noOtherHolder
 * @tsplus pipeable effect/core/stm/TReentrantLock/ReadLock noOtherHolder
 * @tsplus location "@effect/core/stm/TReentrantLock/operations/ReadLock/noOtherHolder"
 */
export declare function noOtherHolder(fiberId: FiberId): (self: TReentrantLock.ReadLock) => boolean;
//# sourceMappingURL=noOtherHolder.d.ts.map