"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.releaseWrite = releaseWrite;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeGet"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TReentrantLock/operations/ReadLock/apply"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TReentrantLock/definition"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TReentrantLock/operations/WriteLock/make"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeSet"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/effect"));

var _InternalTReentrantLock = /*#__PURE__*/require("@effect/core/stm/TReentrantLock/operations/_internal/InternalTReentrantLock");

var _InternalWriteLock = /*#__PURE__*/require("@effect/core/stm/TReentrantLock/operations/_internal/InternalWriteLock");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Releases a write lock held by this fiber. Succeeds with the outstanding
 * number of write locks held by this fiber.
 *
 * @tsplus getter effect/core/stm/TReentrantLock releaseWrite
 */
function releaseWrite(self) {
  void 0;
  return tsplus_module_7.effect((journal, fiberId) => {
    const lock = tsplus_module_1.unsafeGet(journal)(self.data);
    let res;

    if (lock instanceof _InternalWriteLock.InternalWriteLock && tsplus_module_2.equals(fiberId, lock.fiberId) && lock.writeLocks >= 1) {
      if (lock.writeLocks === 1) {
        res = tsplus_module_3.apply(fiberId, lock.readLocks);
      } else {
        res = tsplus_module_5.make(lock.writeLocks - 1, lock.readLocks, fiberId);
      }
    } else {
      throw new Error(`Defect: Fiber ${fiberId} releasing write lock it does not hold: ${lock}`);
    }

    tsplus_module_6.unsafeSet(res, journal)(self.data);
    return res.writeLocksHeld(fiberId);
  });
}
//# sourceMappingURL=releaseWrite.js.map