"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.make = make;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/AtomicReference"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/Entry"));

var _primitives = /*#__PURE__*/require("@effect/core/stm/STM/definition/primitives");

var _Versioned = /*#__PURE__*/require("@effect/core/stm/STM/Versioned");

var _TRefInternal = /*#__PURE__*/require("@effect/core/stm/TRef/operations/_internal/TRefInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Makes a new `TRef` that is initialized to the specified value.
 *
 * @tsplus static effect/core/stm/TRef.Ops make
 */
function make(a) {
  return new _primitives.STMEffect(journal => {
    const value = a();
    const versioned = new _Versioned.Versioned(value);
    const todo = new tsplus_module_1.AtomicReference(_primitives.emptyTodoMap);
    const tref = new _TRefInternal.TRefInternal(versioned, todo);
    journal.set(tref, tsplus_module_2.makeEntry(tref, true));
    return tref;
  });
}
//# sourceMappingURL=make.js.map