"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unsafeSet = unsafeSet;

var _getOrMakeEntry = /*#__PURE__*/require("@effect/core/stm/TRef/operations/_internal/getOrMakeEntry");

/**
 * Unsafely sets the value of the `TRef`.
 *
 * @tsplus static effect/core/stm/TRef.Aspects unsafeSet
 * @tsplus pipeable effect/core/stm/TRef unsafeSet
 */
function unsafeSet(value, journal) {
  return self => {
    const entry = (0, _getOrMakeEntry.getOrMakeEntry)(self, journal);
    entry.use(_ => _.unsafeSet(value));
    return undefined;
  };
}
//# sourceMappingURL=unsafeSet.js.map