"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.releaseN = releaseN;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Cause/errors"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeGet"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/TRef/operations/unsafeSet"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stm/STM/operations/effect"));

var _TSemaphoreInternal = /*#__PURE__*/require("@effect/core/stm/TSemaphore/operations/_internal/TSemaphoreInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Releases the specified number of permits in a transactional context
 *
 * @tsplus static effect/core/stm/TSemaphore.Aspects releaseN
 * @tsplus pipeable effect/core/stm/TSemaphore releaseN
 */
function releaseN(n) {
  return self => {
    void 0;
    return tsplus_module_4.effect(journal => {
      if (n < 0) {
        throw new tsplus_module_1.IllegalArgumentException(`Unexpected negative value ${n} passed to releaseN`);
      }

      const current = tsplus_module_2.unsafeGet(journal)(self.permits);
      return tsplus_module_3.unsafeSet(current + n, journal)(self.permits);
    });
  };
}
//# sourceMappingURL=releaseN.js.map