import { TSemaphore } from "@effect/core/stm/TSemaphore/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Returns a scoped effect that describes acquiring a permit as the `acquire`
 * action and releasing it as the `release` action.
 * @tsplus getter effect/core/stm/TSemaphore withPermitScoped
 * @tsplus location "@effect/core/stm/TSemaphore/operations/withPermitScoped"
 */
export declare function withPermitScoped(self: TSemaphore): Effect<Scope, never, void>;
//# sourceMappingURL=withPermitScoped.d.ts.map