import { TSemaphore } from "@effect/core/stm/TSemaphore/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Returns a scoped effect that describes acquiring the specified number of
 * permits and releasing them when the scope is closed.
 * @tsplus static effect/core/stm/TSemaphore.Aspects withPermitsScoped
 * @tsplus pipeable effect/core/stm/TSemaphore withPermitsScoped
 * @tsplus location "@effect/core/stm/TSemaphore/operations/withPermitsScoped"
 */
export declare function withPermitsScoped(permits: number): (self: TSemaphore) => Effect<Scope, never, void>;
//# sourceMappingURL=withPermitsScoped.d.ts.map