"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.channelStateDone = exports._R = exports._E = exports.ChannelStateSym = exports.ChannelStateRead = exports.ChannelStateEmit = exports.ChannelStateEffect = exports.ChannelStateDone = exports.ChannelStateBase = exports.ChannelState = void 0;
exports.channelStateEffect = channelStateEffect;
exports.channelStateEmit = void 0;
exports.channelStateRead = channelStateRead;
exports.concreteChannelState = concreteChannelState;
exports.effectOrUndefinedIgnored = effectOrUndefinedIgnored;
exports.effectOrUnit = effectOrUnit;
exports.unifyChannelState = unifyChannelState;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unit"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/ignore"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a;

const ChannelStateSym = /*#__PURE__*/Symbol.for("@effect/core/stream/Channel/ChannelState");
exports.ChannelStateSym = ChannelStateSym;

const _R = /*#__PURE__*/Symbol.for("@effect/core/stream/Channel/ChannelState/R");

exports._R = _R;

const _E = /*#__PURE__*/Symbol.for("@effect/core/stream/Channel/ChannelState/E");

exports._E = _E;

class ChannelStateBase {
  constructor() {
    this[_a] = ChannelStateSym;
  }

}

exports.ChannelStateBase = ChannelStateBase;
_a = ChannelStateSym;

class ChannelStateDone extends ChannelStateBase {
  constructor() {
    super(...arguments);
    this._tag = "Done";
  }

}

exports.ChannelStateDone = ChannelStateDone;

class ChannelStateEmit extends ChannelStateBase {
  constructor() {
    super(...arguments);
    this._tag = "Emit";
  }

}

exports.ChannelStateEmit = ChannelStateEmit;

class ChannelStateEffect extends ChannelStateBase {
  constructor(effect) {
    super();
    this.effect = effect;
    this._tag = "Effect";
  }

}

exports.ChannelStateEffect = ChannelStateEffect;

class ChannelStateRead extends ChannelStateBase {
  constructor(upstream, onEffect, onEmit, onDone) {
    super();
    this.upstream = upstream;
    this.onEffect = onEffect;
    this.onEmit = onEmit;
    this.onDone = onDone;
    this._tag = "Read";
  }

}

exports.ChannelStateRead = ChannelStateRead;
const ChannelState = {};
/**
 * @tsplus unify effect/core/stream/Channel/State
 */

exports.ChannelState = ChannelState;

function unifyChannelState(self) {
  return self;
}
/**
 * @tsplus macro remove
 */


function concreteChannelState(_) {//
}
/**
 * @tsplus static effect/core/stream/Channel/State.Ops Done
 */


const channelStateDone = /*#__PURE__*/new ChannelStateDone();
/**
 * @tsplus static effect/core/stream/Channel/State.Ops Emit
 */

exports.channelStateDone = channelStateDone;
const channelStateEmit = /*#__PURE__*/new ChannelStateEmit();
/**
 * @tsplus static effect/core/stream/Channel/State.Ops Effect
 */

exports.channelStateEmit = channelStateEmit;

function channelStateEffect(effect) {
  return new ChannelStateEffect(effect);
}
/**
 * @tsplus static effect/core/stream/Channel/State.Ops Read
 */


function channelStateRead(upstream, onEffect, onEmit, onDone) {
  return new ChannelStateRead(upstream, onEffect, onEmit, onDone);
}
/**
 * @tsplus fluent effect/core/stream/Channel/State effectOrUnit
 */


function effectOrUnit(self) {
  void 0;
  return self._tag === "Effect" ? self.effect : tsplus_module_1.unit;
}
/**
 * @tsplus fluent effect/core/stream/Channel/State effectOrUndefinedIgnored
 */


function effectOrUndefinedIgnored(self) {
  void 0;
  return self._tag === "Effect" ? tsplus_module_1.asUnit(tsplus_module_2.ignore(self.effect)) : undefined;
}
//# sourceMappingURL=ChannelState.js.map