import { Effect } from "@effect/core/io/Effect/definition";
import { Exit } from "@effect/core/io/Exit/definition";
export declare const MergeDecisionSym: unique symbol;
export type MergeDecisionSym = typeof MergeDecisionSym;
export declare const _R: unique symbol;
export type _R = typeof _R;
export declare const _E0: unique symbol;
export type _E0 = typeof _E0;
export declare const _Z0: unique symbol;
export type _Z0 = typeof _Z0;
export declare const _E: unique symbol;
export type _E = typeof _E;
export declare const _Z: unique symbol;
export type _Z = typeof _Z;
/**
 * @tsplus type effect/core/stream/Channel/MergeDecision
 */
export interface MergeDecision<R, E0, Z0, E, Z> {
    readonly [MergeDecisionSym]: typeof MergeDecisionSym;
    readonly [_R]: () => R;
    readonly [_E0]: (_: E0) => void;
    readonly [_Z0]: (_: Z0) => void;
    readonly [_E]: () => E;
    readonly [_Z]: () => Z;
}
/**
 * @tsplus type effect/core/stream/Channel/MergeDecision.Ops
 */
export interface MergeDecisionOps {
}
export declare const MergeDecision: MergeDecisionOps;
export declare abstract class MergeDecisionBase<R, E0, Z0, E, Z> implements MergeDecision<R, E0, Z0, E, Z> {
    readonly [MergeDecisionSym]: typeof MergeDecisionSym;
    readonly [_R]: () => R;
    readonly [_E0]: (_: E0) => void;
    readonly [_Z0]: (_: Z0) => void;
    readonly [_E]: () => E;
    readonly [_Z]: () => Z;
}
/**
 * @tsplus unify effect/core/stream/Channel/MergeDecision
 */
export declare function unifyMergeDecision<X extends MergeDecision<any, any, any, any, any>>(self: X): MergeDecision<[
    X
] extends [{
    [k in typeof _R]: () => infer R;
}] ? R : never, [
    X
] extends [{
    [k in typeof _E0]: (_: infer E0) => void;
}] ? E0 : never, [
    X
] extends [{
    [k in typeof _Z0]: (_: infer Z0) => void;
}] ? Z0 : never, [
    X
] extends [{
    [k in typeof _E]: () => infer E;
}] ? E : never, [
    X
] extends [{
    [k in typeof _Z]: () => infer A;
}] ? A : never>;
export declare class Done<R, E, Z> extends MergeDecisionBase<R, unknown, unknown, E, Z> {
    readonly io: Effect<R, E, Z>;
    readonly _tag = "Done";
    constructor(io: Effect<R, E, Z>);
}
export declare class Await<R, E0, Z0, E, Z> extends MergeDecisionBase<R, E0, Z0, E, Z> {
    readonly f: (ex: Exit<E0, Z0>) => Effect<R, E, Z>;
    readonly _tag = "Await";
    constructor(f: (ex: Exit<E0, Z0>) => Effect<R, E, Z>);
}
/**
 * @tsplus static effect/core/stream/Channel/MergeDecision.Ops done
 * @tsplus location "@effect/core/stream/Channel/MergeDecision"
 */
export declare function done<R, E, Z>(io: Effect<R, E, Z>): MergeDecision<R, unknown, unknown, E, Z>;
/**
 * @tsplus static effect/core/stream/Channel/MergeDecision.Ops await
 * @tsplus location "@effect/core/stream/Channel/MergeDecision"
 */
export declare function _await<R, E0, Z0, E, Z>(f: (ex: Exit<E0, Z0>) => Effect<R, E, Z>): MergeDecision<R, E0, Z0, E, Z>;
/**
 * @tsplus static effect/core/stream/Channel/MergeDecision.Ops awaitConst
 * @tsplus location "@effect/core/stream/Channel/MergeDecision"
 */
export declare function awaitConst<R, E, Z>(io: Effect<R, E, Z>): MergeDecision<R, unknown, unknown, E, Z>;
/**
 * @tsplus macro remove
 */
export declare function concreteMergeDecision<R, E0, Z0, E, Z>(_: MergeDecision<R, E0, Z0, E, Z>): asserts _ is Done<R, E, Z> | Await<R, E0, Z0, E, Z>;
//# sourceMappingURL=MergeDecision.d.ts.map