"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StateError = exports.StateEmpty = exports.StateEmit = exports.StateDone = exports.SingleProducerAsyncInput = exports.ErrorTypeId = exports.EmptyTypeId = exports.EmitTypeId = exports.DoneTypeId = void 0;
exports.make = make;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Either/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Cause/operations/map"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/failCause"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/succeed"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/fail"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Cause/definition"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/fiberId"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unit"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatten"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableQueue/dequeue"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableQueue/size"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Deferred/operations/make"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/excl-forEach"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Either/fold"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/foldCause"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableQueue/append"));

var tsplus_module_19 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/sync"));

var tsplus_module_20 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipRight"));

var tsplus_module_21 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableQueue/single"));

var tsplus_module_22 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Ref/operations/make"));

var tsplus_module_23 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const DoneTypeId = /*#__PURE__*/Symbol.for("@effect/core/stream/Channel/Producer/Done");
exports.DoneTypeId = DoneTypeId;

class StateDone {
  constructor(a) {
    this.a = a;
    this._typeId = DoneTypeId;
  }

}

exports.StateDone = StateDone;
const ErrorTypeId = /*#__PURE__*/Symbol.for("@effect/core/stream/Channel/Producer/Error");
exports.ErrorTypeId = ErrorTypeId;

class StateError {
  constructor(cause) {
    this.cause = cause;
    this._typeId = ErrorTypeId;
  }

}

exports.StateError = StateError;
const EmptyTypeId = /*#__PURE__*/Symbol.for("@effect/core/stream/Channel/Producer/Empty");
exports.EmptyTypeId = EmptyTypeId;

class StateEmpty {
  constructor(notifyProducer) {
    this.notifyProducer = notifyProducer;
    this._typeId = EmptyTypeId;
  }

}

exports.StateEmpty = StateEmpty;
const EmitTypeId = /*#__PURE__*/Symbol.for("@effect/core/stream/Channel/Producer/Emit");
exports.EmitTypeId = EmitTypeId;

class StateEmit {
  constructor(notifyConsumers) {
    this.notifyConsumers = notifyConsumers;
    this._typeId = EmitTypeId;
  }

}
/**
 * An MVar-like abstraction for sending data to channels asynchronously.
 * Designed for one producer and multiple consumers.
 *
 * Features the following semantics:
 *   - Buffer of size 1.
 *   - When emitting, the producer waits for a consumer to pick up the value to
 *     prevent "reading ahead" too much.
 *   - Once an emitted element is read by a consumer, it is cleared from the
 *     buffer, so that at most one consumer sees every emitted element.
 *   - When sending a done or error signal, the producer does not wait for a
 *     consumer to pick up the signal. The signal stays in the buffer after
 *     being read by a consumer, so it can be propagated to multiple consumers.
 *   - Trying to publish another emit/error/done after an error/done have
 *     already been published results in an interruption.
 *
 * @tsplus type effect/core/stream/Channel/SingleProducerAsyncInput
 * @tsplus companion effect/core/stream/Channel/SingleProducerAsyncInput.Ops
 */


exports.StateEmit = StateEmit;

class SingleProducerAsyncInput {
  constructor(ref) {
    this.ref = ref;
  }

  get take() {
    return this.takeWith(cause => tsplus_module_3.failCause(tsplus_module_2.map(tsplus_module_1.left)(cause)), element => tsplus_module_4.succeed(element), done => tsplus_module_5.fail(tsplus_module_1.right(done)));
  }

  get close() {
    return tsplus_module_8.flatMap(fiberId => this.error(tsplus_module_6.interrupt(fiberId)))(tsplus_module_7.fiberId);
  }

  get awaitRead() {
    return tsplus_module_10.flatten(this.ref.modify(state => state._typeId === EmptyTypeId ? [state.notifyProducer.await, state] : [tsplus_module_9.unit, state]));
  }

  emit(el) {
    return tsplus_module_8.flatMap(deferred => tsplus_module_10.flatten(this.ref.modify(state => {
      switch (state._typeId) {
        case EmitTypeId:
          {
            const dequeued = tsplus_module_11.dequeue(state.notifyConsumers);

            if (dequeued._tag === "Some") {
              const [notifyConsumer, notifyConsumers] = dequeued.value;
              return [notifyConsumer.succeed(tsplus_module_1.right(el)), tsplus_module_12.size(notifyConsumers) === 0 ? new StateEmpty(deferred) : new StateEmit(notifyConsumers)];
            }

            throw new Error("SingleProducerAsyncInput#emit: queue was empty");
          }

        case ErrorTypeId:
          {
            return [tsplus_module_13.interrupt, state];
          }

        case DoneTypeId:
          {
            return [tsplus_module_13.interrupt, state];
          }

        case EmptyTypeId:
          {
            return [state.notifyProducer.await, state];
          }
      }
    })))(tsplus_module_14.make());
  }

  done(a) {
    return tsplus_module_10.flatten(this.ref.modify(state => {
      switch (state._typeId) {
        case EmitTypeId:
          {
            return [tsplus_module_15.forEachDiscard(state.notifyConsumers, promise => promise.succeed(tsplus_module_1.left(a))), new StateDone(a)];
          }

        case ErrorTypeId:
          {
            return [tsplus_module_13.interrupt, state];
          }

        case DoneTypeId:
          {
            return [tsplus_module_13.interrupt, state];
          }

        case EmptyTypeId:
          {
            return [state.notifyProducer.await, state];
          }
      }
    }));
  }

  error(cause) {
    return tsplus_module_10.flatten(this.ref.modify(state => {
      switch (state._typeId) {
        case EmitTypeId:
          {
            return [tsplus_module_15.forEachDiscard(state.notifyConsumers, promise => promise.failCause(() => cause)), new StateError(cause)];
          }

        case ErrorTypeId:
          {
            return [tsplus_module_13.interrupt, state];
          }

        case DoneTypeId:
          {
            return [tsplus_module_13.interrupt, state];
          }

        case EmptyTypeId:
          {
            return [state.notifyProducer.await, state];
          }
      }
    }));
  }

  takeWith(onError, onElement, onDone) {
    return tsplus_module_8.flatMap(deferred => tsplus_module_10.flatten(this.ref.modify(state => {
      switch (state._typeId) {
        case EmitTypeId:
          {
            return [tsplus_module_17.foldCause(onError, either => tsplus_module_16.fold(onDone, onElement)(either))(deferred.await), new StateEmit(tsplus_module_18.append(deferred)(state.notifyConsumers))];
          }

        case ErrorTypeId:
          {
            return [tsplus_module_19.sync(() => onError(state.cause)), state];
          }

        case DoneTypeId:
          {
            return [tsplus_module_19.sync(() => onDone(state.a)), state];
          }

        case EmptyTypeId:
          {
            return [tsplus_module_20.zipRight(tsplus_module_17.foldCause(onError, either => tsplus_module_16.fold(onDone, onElement)(either))(deferred.await))(state.notifyProducer.succeed(undefined)), new StateEmit(tsplus_module_21.single(deferred))];
          }
      }
    })))(tsplus_module_14.make());
  }

}
/**
 * Creates a `SingleProducerAsyncInput`.
 *
 * @tsplus static effect/core/stream/Channel/SingleProducerAsyncInput.Ops make
 */


exports.SingleProducerAsyncInput = SingleProducerAsyncInput;

function make() {
  return tsplus_module_23.map(ref => new SingleProducerAsyncInput(ref))(tsplus_module_8.flatMap(deferred => tsplus_module_22.makeRef(() => new StateEmpty(deferred)))(tsplus_module_14.make()));
}
//# sourceMappingURL=SingleProducerAsyncInput.js.map