"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Suspend = exports.SucceedNow = exports.Succeed = exports.Read = exports.Provide = exports.PipeTo = exports.FromEffect = exports.Fold = exports.Fail = exports.Ensuring = exports.Emit = exports.ContinuationK = exports.ContinuationFinalizer = exports.Continuation = exports.ConcatAll = exports.Bridge = exports.BracketOut = void 0;
exports.concrete = concrete;
exports.concreteContinuation = concreteContinuation;

var _base = /*#__PURE__*/require("@effect/core/stream/Channel/definition/base");

var _symbols = /*#__PURE__*/require("@effect/core/stream/Channel/definition/symbols");

// -----------------------------------------------------------------------------
// PipeTo
// -----------------------------------------------------------------------------
class PipeTo extends _base.ChannelBase {
  constructor(left, right) {
    super();
    this.left = left;
    this.right = right;
    this._tag = "PipeTo";
  }

} // -----------------------------------------------------------------------------
// Read
// -----------------------------------------------------------------------------


exports.PipeTo = PipeTo;

class Read extends _base.ChannelBase {
  constructor(more, done) {
    super();
    this.more = more;
    this.done = done;
    this._tag = "Read";
  }

} // -----------------------------------------------------------------------------
// SucceedNow
// -----------------------------------------------------------------------------


exports.Read = Read;

class SucceedNow extends _base.ChannelBase {
  constructor(terminal) {
    super();
    this.terminal = terminal;
    this._tag = "SucceedNow";
  }

} // -----------------------------------------------------------------------------
// Fail
// -----------------------------------------------------------------------------


exports.SucceedNow = SucceedNow;

class Fail extends _base.ChannelBase {
  constructor(error) {
    super();
    this.error = error;
    this._tag = "Fail";
  }

} // -----------------------------------------------------------------------------
// FromEffect
// -----------------------------------------------------------------------------


exports.Fail = Fail;

class FromEffect extends _base.ChannelBase {
  constructor(effect) {
    super();
    this.effect = effect;
    this._tag = "FromEffect";
  }

} // -----------------------------------------------------------------------------
// Emit
// -----------------------------------------------------------------------------


exports.FromEffect = FromEffect;

class Emit extends _base.ChannelBase {
  constructor(out) {
    super();
    this.out = out;
    this._tag = "Emit";
  }

} // -----------------------------------------------------------------------------
// Succeed
// -----------------------------------------------------------------------------


exports.Emit = Emit;

class Succeed extends _base.ChannelBase {
  constructor(effect) {
    super();
    this.effect = effect;
    this._tag = "Succeed";
  }

} // -----------------------------------------------------------------------------
// Suspend
// -----------------------------------------------------------------------------


exports.Succeed = Succeed;

class Suspend extends _base.ChannelBase {
  constructor(effect) {
    super();
    this.effect = effect;
    this._tag = "Suspend";
  }

} // -----------------------------------------------------------------------------
// Ensuring
// -----------------------------------------------------------------------------


exports.Suspend = Suspend;

class Ensuring extends _base.ChannelBase {
  constructor(channel, finalizer) {
    super();
    this.channel = channel;
    this.finalizer = finalizer;
    this._tag = "Ensuring";
  }

} // -----------------------------------------------------------------------------
// ConcatAll
// -----------------------------------------------------------------------------


exports.Ensuring = Ensuring;

class ConcatAll extends _base.ChannelBase {
  constructor(combineInners, combineAll, onPull, onEmit, value, k) {
    super();
    this.combineInners = combineInners;
    this.combineAll = combineAll;
    this.onPull = onPull;
    this.onEmit = onEmit;
    this.value = value;
    this.k = k;
    this._tag = "ConcatAll";
  }

} // -----------------------------------------------------------------------------
// Fold
// -----------------------------------------------------------------------------


exports.ConcatAll = ConcatAll;

class Fold extends _base.ChannelBase {
  constructor(value, k) {
    super();
    this.value = value;
    this.k = k;
    this._tag = "Fold";
  }

} // -----------------------------------------------------------------------------
// Bridge
// -----------------------------------------------------------------------------


exports.Fold = Fold;

class Bridge extends _base.ChannelBase {
  constructor(input, channel) {
    super();
    this.input = input;
    this.channel = channel;
    this._tag = "Bridge";
  }

} // -----------------------------------------------------------------------------
// BracketOut
// -----------------------------------------------------------------------------


exports.Bridge = Bridge;

class BracketOut extends _base.ChannelBase {
  constructor(acquire, finalizer) {
    super();
    this.acquire = acquire;
    this.finalizer = finalizer;
    this._tag = "BracketOut";
  }

} // -----------------------------------------------------------------------------
// Provide
// -----------------------------------------------------------------------------


exports.BracketOut = BracketOut;

class Provide extends _base.ChannelBase {
  constructor(env, channel) {
    super();
    this.env = env;
    this.channel = channel;
    this._tag = "Provide";
  }

}
/**
 * @tsplus macro remove
 */


exports.Provide = Provide;

function concrete(_) {//
} // -----------------------------------------------------------------------------
// Continuation
// -----------------------------------------------------------------------------


class Continuation {}
/**
 * @tsplus macro remove
 */


exports.Continuation = Continuation;

function concreteContinuation(_) {//
}

class ContinuationK extends Continuation {
  constructor(onSuccess, onHalt) {
    super();
    this.onSuccess = onSuccess;
    this.onHalt = onHalt;
    this._tag = "ContinuationK";
  }

  onExit(exit) {
    switch (exit._tag) {
      case "Failure":
        {
          return this.onHalt(exit.cause);
        }

      case "Success":
        {
          return this.onSuccess(exit.value);
        }
    }
  }

}

exports.ContinuationK = ContinuationK;

class ContinuationFinalizer extends Continuation {
  constructor(finalizer) {
    super();
    this.finalizer = finalizer;
    this._tag = "ContinuationFinalizer";
  }

}

exports.ContinuationFinalizer = ContinuationFinalizer;
//# sourceMappingURL=primitives.js.map