import { Cause } from "@effect/core/io/Cause/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * Returns a new channel that is the same as this one, except if this channel
 * errors for any cause at all, then the returned channel will switch over to
 * using the fallback channel returned by the specified error handler.
 * @tsplus static effect/core/stream/Channel.Aspects catchAllCause
 * @tsplus pipeable effect/core/stream/Channel catchAllCause
 * @tsplus location "@effect/core/stream/Channel/operations/catchAllCause"
 */
export declare function catchAllCause<Env1, InErr1, InElem1, InDone1, OutErr, OutErr1, OutElem1, OutDone1>(f: (cause: Cause<OutErr>) => Channel<Env1, InErr1, InElem1, InDone1, OutErr1, OutElem1, OutDone1>): <Env_1, InErr, InElem, InDone, OutElem, OutDone>(self: import("../definition").Channel<Env_1, InErr, InElem, InDone, OutErr, OutElem, OutDone>) => import("../definition").Channel<Env1 | Env_1, InErr & InErr1, InElem & InElem1, InDone & InDone1, OutErr1, OutElem1 | OutElem, OutDone1 | OutDone>;
//# sourceMappingURL=catchAllCause.d.ts.map