import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * Returns a new channel whose outputs are fed to the specified factory
 * function, which creates new channels in response. These new channels are
 * sequentially concatenated together, and all their outputs appear as outputs
 * of the newly returned channel.
 * @tsplus static effect/core/stream/Channel.Aspects concatMap
 * @tsplus pipeable effect/core/stream/Channel concatMap
 * @tsplus location "@effect/core/stream/Channel/operations/concatMap"
 */
export declare function concatMap<OutElem, OutElem2, OutDone2, Env2, InErr2, InElem2, InDone2, OutErr2>(f: (o: OutElem) => Channel<Env2, InErr2, InElem2, InDone2, OutErr2, OutElem2, OutDone2>): <Env_1, InErr, InElem, InDone, OutErr, OutDone>(self: import("../definition").Channel<Env_1, InErr, InElem, InDone, OutErr, OutElem, OutDone>) => import("../definition").Channel<Env2 | Env_1, InErr & InErr2, InElem & InElem2, InDone & InDone2, OutErr2 | OutErr, OutElem2, unknown>;
//# sourceMappingURL=concatMap.d.ts.map