import { Exit } from "@effect/core/io/Exit/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * Returns a new channel with an attached finalizer. The finalizer is
 * guaranteed to be executed so long as the channel begins execution (and
 * regardless of whether or not it completes).
 * @tsplus static effect/core/stream/Channel.Aspects ensuringWith
 * @tsplus pipeable effect/core/stream/Channel ensuringWith
 * @tsplus location "@effect/core/stream/Channel/operations/ensuringWith"
 */
export declare function ensuringWith<Env2, OutErr, OutDone>(finalizer: (e: Exit<OutErr, OutDone>) => Effect<Env2, never, unknown>): <Env_1, InErr, InElem, InDone, OutElem>(self: import("../definition").Channel<Env_1, InErr, InElem, InDone, OutErr, OutElem, OutDone>) => import("../definition").Channel<Env2 | Env_1, InErr, InElem, InDone, OutErr, OutElem, OutDone>;
//# sourceMappingURL=ensuringWith.d.ts.map