"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ensuringWith = ensuringWith;

var _primitives = /*#__PURE__*/require("@effect/core/stream/Channel/definition/primitives");

/**
 * Returns a new channel with an attached finalizer. The finalizer is
 * guaranteed to be executed so long as the channel begins execution (and
 * regardless of whether or not it completes).
 *
 * @tsplus static effect/core/stream/Channel.Aspects ensuringWith
 * @tsplus pipeable effect/core/stream/Channel ensuringWith
 */
function ensuringWith(finalizer) {
  return self => new _primitives.Ensuring(self, finalizer);
}
//# sourceMappingURL=ensuringWith.js.map