import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * Returns a new channel, which sequentially combines this channel, together
 * with the provided factory function, which creates a second channel based on
 * the terminal value of this channel. The result is a channel that will first
 * perform the functions of this channel, before performing the functions of
 * the created channel (including yielding its terminal value).
 * @tsplus static effect/core/stream/Channel.Aspects flatMap
 * @tsplus pipeable effect/core/stream/Channel flatMap
 * @tsplus location "@effect/core/stream/Channel/operations/flatMap"
 */
export declare function flatMap<OutDone, Env1, InErr1, InElem1, InDone1, OutErr1, OutElem1, OutDone2>(f: (d: OutDone) => Channel<Env1, InErr1, InElem1, InDone1, OutErr1, OutElem1, OutDone2>): <Env_1, InErr, InElem, InDone, OutErr, OutElem>(self: import("../definition").Channel<Env_1, InErr, InElem, InDone, OutErr, OutElem, OutDone>) => import("../definition").Channel<Env1 | Env_1, InErr & InErr1, InElem & InElem1, InDone & InDone1, OutErr1 | OutErr, OutElem1 | OutElem, OutDone2>;
//# sourceMappingURL=flatMap.d.ts.map