"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.foldCauseChannel = foldCauseChannel;

var _primitives = /*#__PURE__*/require("@effect/core/stream/Channel/definition/primitives");

/**
 * Fold the channel exposing success and full error cause.
 *
 * @tsplus static effect/core/stream/Channel.Aspects foldCauseChannel
 * @tsplus pipeable effect/core/stream/Channel foldCauseChannel
 */
function foldCauseChannel(onErr, onSucc) {
  return self => new _primitives.Fold(self, new _primitives.ContinuationK(onSucc, onErr));
}
//# sourceMappingURL=foldCauseChannel.js.map