import { Effect } from "@effect/core/io/Effect/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * Returns a new channel, which is the same as this one, except it will be
 * interrupted when the specified effect completes. If the effect completes
 * successfully before the underlying channel is done, then the returned
 * channel will yield the success value of the effect as its terminal value.
 * On the other hand, if the underlying channel finishes first, then the
 * returned channel will yield the success value of the underlying channel as
 * its terminal value.
 * @tsplus static effect/core/stream/Channel.Aspects interruptWhen
 * @tsplus pipeable effect/core/stream/Channel interruptWhen
 * @tsplus location "@effect/core/stream/Channel/operations/interruptWhen"
 */
export declare function interruptWhen<Env1, OutErr1, OutDone1>(io: Effect<Env1, OutErr1, OutDone1>): <Env_1, InErr, InElem, InDone, OutErr, OutElem, OutDone>(self: import("../definition").Channel<Env_1, InErr, InElem, InDone, OutErr, OutElem, OutDone>) => import("../definition").Channel<Env1 | Env_1, InErr, InElem, InDone, OutErr1 | OutErr, OutElem, OutDone1 | OutDone>;
//# sourceMappingURL=interruptWhen.d.ts.map