import { Deferred } from "@effect/core/io/Deferred/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * Returns a new channel, which is the same as this one, except it will be
 * interrupted when the specified deferred is completed. If the deferred is
 * completed before the underlying channel is done, then the returned channel
 * will yield the value of the deferred. Otherwise, if the underlying channel
 * finishes first, then the returned channel will yield the value of the
 * underlying channel.
 * @tsplus static effect/core/stream/Channel.Aspects interruptWhenDeferred
 * @tsplus pipeable effect/core/stream/Channel interruptWhenDeferred
 * @tsplus location "@effect/core/stream/Channel/operations/interruptWhenDeferred"
 */
export declare function interruptWhenDeferred<OutErr1, OutDone1>(deferred: Deferred<OutErr1, OutDone1>): <Env_1, InErr, InElem, InDone, OutErr, OutElem, OutDone>(self: import("../definition").Channel<Env_1, InErr, InElem, InDone, OutErr, OutElem, OutDone>) => import("../definition").Channel<Env_1, InErr, InElem, InDone, OutErr1 | OutErr, OutElem, OutDone1 | OutDone>;
//# sourceMappingURL=interruptWhenDeferred.d.ts.map