import { Cause } from "@effect/core/io/Cause/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * A more powerful version of `mapError` which also surfaces the `Cause`
 * of the channel failure.
 * @tsplus static effect/core/stream/Channel.Aspects mapErrorCause
 * @tsplus pipeable effect/core/stream/Channel mapErrorCause
 * @tsplus location "@effect/core/stream/Channel/operations/mapErrorCause"
 */
export declare function mapErrorCause<OutErr, OutErr2>(f: (cause: Cause<OutErr>) => Cause<OutErr2>): <Env_1, InErr, InElem, InDone, OutElem, OutDone>(self: import("../definition").Channel<Env_1, InErr, InElem, InDone, OutErr, OutElem, OutDone>) => import("../definition").Channel<Env_1, InErr, InElem, InDone, OutErr2, OutElem, OutDone>;
//# sourceMappingURL=mapErrorCause.d.ts.map