import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Exit } from "@effect/core/io/Exit/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
import { Fiber } from "@effect/core/io/Fiber/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import type { MergeDecision } from "@effect/core/stream/Channel/MergeDecision";
/**
 * Returns a new channel, which is the merge of this channel and the specified
 * channel, where the behavior of the returned channel on left or right early
 * termination is decided by the specified `leftDone` and `rightDone` merge
 * decisions.
 * @tsplus static effect/core/stream/Channel.Aspects mergeWith
 * @tsplus pipeable effect/core/stream/Channel mergeWith
 * @tsplus location "@effect/core/stream/Channel/operations/mergeWith"
 */
export declare function mergeWith_<Env1, InErr1, InElem1, InDone1, OutErr, OutErr1, OutErr2, OutErr3, OutElem1, OutDone, OutDone1, OutDone2, OutDone3>(that: Channel<Env1, InErr1, InElem1, InDone1, OutErr1, OutElem1, OutDone1>, leftDone: (ex: Exit<OutErr, OutDone>) => MergeDecision<Env1, OutErr1, OutDone1, OutErr2, OutDone2>, rightDone: (ex: Exit<OutErr1, OutDone1>) => MergeDecision<Env1, OutErr, OutDone, OutErr3, OutDone3>): <Env_1, InErr, InElem, InDone, OutElem>(self: import("../definition").Channel<Env_1, InErr, InElem, InDone, OutErr, OutElem, OutDone>) => import("../definition").Channel<Env1 | Env_1, InErr & InErr1, InElem & InElem1, InDone & InDone1, OutErr2 | OutErr3, OutElem1 | OutElem, OutDone2 | OutDone3>;
//# sourceMappingURL=mergeWith.d.ts.map