"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mergeWith_ = mergeWith_;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/MergeState"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipWith"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fromEffect"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/embedInput"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/join"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/raceWith"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unwrap"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/failCause"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/succeed"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Either/fold"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/fold"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/exit"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/interrupt"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipRight"));

var tsplus_module_19 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_20 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/zipRight"));

var tsplus_module_21 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/await"));

var tsplus_module_22 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_23 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/toPull"));

var tsplus_module_24 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_25 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fromInput"));

var tsplus_module_26 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/SingleProducerAsyncInput"));

var tsplus_module_27 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unwrapScoped"));

var _MergeDecision = /*#__PURE__*/require("@effect/core/stream/Channel/MergeDecision");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Returns a new channel, which is the merge of this channel and the specified
 * channel, where the behavior of the returned channel on left or right early
 * termination is decided by the specified `leftDone` and `rightDone` merge
 * decisions.
 *
 * @tsplus static effect/core/stream/Channel.Aspects mergeWith
 * @tsplus pipeable effect/core/stream/Channel mergeWith
 */
function mergeWith_(that, leftDone, rightDone) {
  return self => tsplus_module_27.unwrapScoped(tsplus_module_24.flatMap(input => {
    const queueReader = tsplus_module_25.fromInput(input);
    return tsplus_module_24.flatMap(pullL => tsplus_module_16.map(pullR => {
      const handleSide = (exit, fiber, pull) => (done, both, single) => {
        const onDecision = decision => {
          void 0;

          if (decision._tag === "Done") {
            return tsplus_module_19.succeed(tsplus_module_4.fromEffect(tsplus_module_18.zipRight(decision.io)(tsplus_module_17.interrupt(fiber))));
          }

          return tsplus_module_16.map(exit => tsplus_module_14.fold(cause => tsplus_module_4.fromEffect(decision.f(tsplus_module_10.failCause(cause))), either => tsplus_module_13.fold(done => tsplus_module_4.fromEffect(decision.f(tsplus_module_11.succeed(done))), elem => tsplus_module_20.zipRight(go(single(decision.f)))(tsplus_module_12.write(elem)))(either))(exit))(tsplus_module_21._await(fiber));
        };

        return tsplus_module_14.fold(cause => onDecision(done(tsplus_module_10.failCause(cause))), either => tsplus_module_13.fold(z => onDecision(done(tsplus_module_11.succeed(z))), elem => tsplus_module_19.succeed(tsplus_module_5.flatMap(() => tsplus_module_5.flatMap(leftFiber => go(both(leftFiber, fiber)))(tsplus_module_4.fromEffect(tsplus_module_1.forkDaemon(pull))))(tsplus_module_12.write(elem))))(either))(exit);
      };

      const go = state => {
        switch (state._tag) {
          case "BothRunning":
            {
              const lj = tsplus_module_7.join(state.left);
              const rj = tsplus_module_7.join(state.right);
              return tsplus_module_9.unwrap(tsplus_module_8.raceWith(rj, (leftEx, _) => handleSide(leftEx, state.right, pullL)(leftDone, (l, r) => tsplus_module_2.bothRunning(l, r), _ => tsplus_module_2.leftDone(_)), (rightEx, _) => handleSide(rightEx, state.left, pullR)(rightDone, (l, r) => tsplus_module_2.bothRunning(r, l), _ => tsplus_module_2.rightDone(_)))(lj));
            }

          case "LeftDone":
            {
              return tsplus_module_9.unwrap(tsplus_module_16.map(exit => tsplus_module_14.fold(cause => tsplus_module_4.fromEffect(state.f(tsplus_module_10.failCause(cause))), either => tsplus_module_13.fold(done => tsplus_module_4.fromEffect(state.f(tsplus_module_11.succeed(done))), elem => tsplus_module_5.flatMap(() => go(tsplus_module_2.leftDone(state.f)))(tsplus_module_12.write(elem)))(either))(exit))(tsplus_module_15.exit(pullR)));
            }

          case "RightDone":
            {
              return tsplus_module_9.unwrap(tsplus_module_16.map(exit => tsplus_module_14.fold(cause => tsplus_module_4.fromEffect(state.f(tsplus_module_10.failCause(cause))), either => tsplus_module_13.fold(done => tsplus_module_4.fromEffect(state.f(tsplus_module_11.succeed(done))), elem => tsplus_module_5.flatMap(() => go(tsplus_module_2.rightDone(state.f)))(tsplus_module_12.write(elem)))(either))(exit))(tsplus_module_15.exit(pullL)));
            }
        }
      };

      return tsplus_module_6.embedInput(input)(tsplus_module_5.flatMap(go)(tsplus_module_4.fromEffect(tsplus_module_3.zipWith(tsplus_module_1.forkDaemon(pullR), (left, right) => tsplus_module_2.bothRunning(left, right))(tsplus_module_1.forkDaemon(pullL)))));
    })(tsplus_module_23.toPull(tsplus_module_22.pipeTo(that)(queueReader))))(tsplus_module_23.toPull(tsplus_module_22.pipeTo(self)(queueReader)));
  })(tsplus_module_26.make()));
}
//# sourceMappingURL=mergeWith.js.map