import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * Returns a new channel that will perform the operations of this one, until
 * failure, and then it will switch over to the operations of the specified
 * fallback channel.
 * @tsplus pipeable-operator effect/core/stream/Channel |
 * @tsplus static effect/core/stream/Channel.Aspects orElse
 * @tsplus pipeable effect/core/stream/Channel orElse
 * @tsplus location "@effect/core/stream/Channel/operations/orElse"
 */
export declare function orElse<Env1, InErr1, InElem1, InDone1, OutErr1, OutElem1, OutDone1>(that: LazyArg<Channel<Env1, InErr1, InElem1, InDone1, OutErr1, OutElem1, OutDone1>>): <Env_1, InErr, InElem, InDone, OutErr, OutElem, OutDone>(self: import("../definition").Channel<Env_1, InErr, InElem, InDone, OutErr, OutElem, OutDone>) => import("../definition").Channel<Env1 | Env_1, InErr & InErr1, InElem & InElem1, InDone & InDone1, OutErr1, OutElem1 | OutElem, OutDone1 | OutDone>;
//# sourceMappingURL=orElse.d.ts.map