"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.runScoped = runScoped;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/suspendSucceed"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Function"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/sync"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unit"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/done"));

var _ChannelExecutor = /*#__PURE__*/require("@effect/core/stream/Channel/ChannelExecutor");

var _ChannelState = /*#__PURE__*/require("@effect/core/stream/Channel/ChannelState");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Runs a channel until the end is received.
 *
 * @tsplus getter effect/core/stream/Channel runScoped
 */
function runScoped(self) {
  return tsplus_module_6.flatMap(exec => tsplus_module_1.suspendSucceed(() => interpret(exec.run(), exec)))(tsplus_module_5.acquireReleaseExit(tsplus_module_3.sync(() => new _ChannelExecutor.ChannelExecutor(() => self, undefined, tsplus_module_2.identity)), (exec, exit) => {
    const finalize = exec.close(exit);
    return finalize != null ? finalize : tsplus_module_4.unit;
  }));
}

function interpret(channelState, exec) {
  void 0;

  switch (channelState._tag) {
    case "Effect":
      {
        return tsplus_module_6.flatMap(() => interpret(exec.run(), exec))(channelState.effect);
      }

    case "Emit":
      {
        // Can't really happen because Out <:< Nothing. So just skip ahead.
        return interpret(exec.run(), exec);
      }

    case "Done":
      {
        return tsplus_module_7.done(exec.getDone());
      }

    case "Read":
      {
        return (0, _ChannelExecutor.readUpstream)(channelState, () => interpret(exec.run(), exec));
      }
  }
}
//# sourceMappingURL=runScoped.js.map