import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * Returns a new channel that is the sequential composition of this channel
 * and the specified channel. The returned channel terminates with the result
 * of calling the specified function on the terminal values of both channels.
 * @tsplus static effect/core/stream/Channel.Aspects zipWith
 * @tsplus pipeable effect/core/stream/Channel zipWith
 * @tsplus location "@effect/core/stream/Channel/operations/zipWith"
 */
export declare function zipWith<Env1, InErr1, InElem1, InDone1, OutErr1, OutElem1, OutDone, OutDone1, OutDone2>(that: Channel<Env1, InErr1, InElem1, InDone1, OutErr1, OutElem1, OutDone1>, f: (outDone: OutDone, outDone1: OutDone1) => OutDone2): <Env_1, InErr, InElem, InDone, OutErr, OutElem>(self: import("../definition").Channel<Env_1, InErr, InElem, InDone, OutErr, OutElem, OutDone>) => import("../definition").Channel<Env1 | Env_1, InErr & InErr1, InElem & InElem1, InDone & InDone1, OutErr1 | OutErr, OutElem1 | OutElem, OutDone2>;
//# sourceMappingURL=zipWith.d.ts.map