"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GroupByInternal = exports.FirstInternal = exports.FilterInternal = void 0;
exports.concreteGroupBy = concreteGroupBy;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/fromQueueWithShutdown"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/flattenExitMaybe"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/flatMapPar"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/operations/set"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/map"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/succeed"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipRight"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/as"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fold"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/operations/get"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/mapEffect"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/distributedWithDynamic"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/operations/empty"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Ref/operations/make"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Queue/external/bounded"));

var tsplus_module_19 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_20 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Deferred/operations/make"));

var tsplus_module_21 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/unwrapScoped"));

var tsplus_module_22 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/zipWithIndex"));

var tsplus_module_23 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/filterEffect"));

var tsplus_module_24 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/map"));

var _base = /*#__PURE__*/require("@effect/core/stream/GroupBy/definition/base");

var _symbols = /*#__PURE__*/require("@effect/core/stream/GroupBy/definition/symbols");

var _mapDequeue = /*#__PURE__*/require("@effect/core/stream/GroupBy/operations/_internal/mapDequeue");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a;

class GroupByInternal {
  constructor(stream, key, buffer) {
    this.stream = stream;
    this.key = key;
    this.buffer = buffer;
    this[_a] = _base.GroupBySym;
  }
  /**
   * Run the function across all groups, collecting the results in an
   * arbitrary order.
   */


  apply(f) {
    return tsplus_module_3.flatMapPar(Number.MAX_SAFE_INTEGER, ([key, queue]) => f(key, tsplus_module_2.flattenExitMaybe(tsplus_module_1.fromQueueWithShutdown(queue))), this.buffer)(this.grouped());
  }

  grouped() {
    return tsplus_module_21.unwrapScoped(tsplus_module_9.flatMap(decider => tsplus_module_9.flatMap(out => tsplus_module_9.flatMap(ref => tsplus_module_9.flatMap(add => tsplus_module_13.map(() => tsplus_module_2.flattenExitMaybe(tsplus_module_1.fromQueueWithShutdown(out)))(decider.succeed((k, _) => tsplus_module_9.flatMap(option => tsplus_module_11.fold(() => tsplus_module_9.flatMap(([id, queue]) => tsplus_module_8.as(n => n === id)(tsplus_module_7.zipRight(out.offer(tsplus_module_6.succeed([k, (0, _mapDequeue.mapDequeue)(queue, exit => tsplus_module_5.map(_ => _[1])(exit))])))(ref.update(map => tsplus_module_4.set(k, id)(map)))))(add), id => tsplus_module_10.succeed(n => n === id))(option))(tsplus_module_13.map(map => tsplus_module_12.get(k)(map))(ref.get)))))(tsplus_module_15.distributedWithDynamic(this.buffer, ([k, v]) => tsplus_module_9.flatMap(f => f(k, v))(decider.await), exit => out.offer(exit))(tsplus_module_14.mapEffect(this.key)(this.stream))))(tsplus_module_17.makeRef(() => tsplus_module_16.empty())))(tsplus_module_19.acquireRelease(tsplus_module_18.bounded(this.buffer), queue => queue.shutdown)))(tsplus_module_20.make()));
  }
  /**
   * Only consider the first `n` groups found in the stream.
   */


  first(n) {
    return new FirstInternal(this.stream, this.key, this.buffer, n);
  }
  /**
   * Filter the groups to be processed.
   */


  filter(f) {
    return new FilterInternal(this.stream, this.key, this.buffer, f);
  }

}

exports.GroupByInternal = GroupByInternal;
_a = _base.GroupBySym;
/**
 * @tsplus macro remove
 */

function concreteGroupBy(_) {//
}

class FirstInternal extends GroupByInternal {
  constructor(stream, key, buffer, n) {
    super(stream, key, buffer);
    this.n = n;
  }

  grouped() {
    return tsplus_module_24.map(tuple => tuple[0])(tsplus_module_23.filterEffect(elem => {
      const [[_, queue], i] = elem;
      return i < this.n ? tsplus_module_8.as(true)(tsplus_module_10.succeed(elem)) : tsplus_module_8.as(false)(queue.shutdown);
    })(tsplus_module_22.zipWithIndex(super.grouped())));
  }

}

exports.FirstInternal = FirstInternal;

class FilterInternal extends GroupByInternal {
  constructor(stream, key, buffer, f) {
    super(stream, key, buffer);
    this.f = f;
  }

  grouped() {
    return tsplus_module_23.filterEffect(elem => {
      const [k, queue] = elem;
      return this.f(k) ? tsplus_module_8.as(true)(tsplus_module_10.succeed(elem)) : tsplus_module_8.as(false)(queue.shutdown);
    })(super.grouped());
  }

}

exports.FilterInternal = FilterInternal;
//# sourceMappingURL=GroupByInternal.js.map