"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapDequeue = mapDequeue;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/map"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/map"));

var _definition = /*#__PURE__*/require("@effect/core/io/Queue/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

class MapDequeueImpl {
  constructor(dequeue, f) {
    this.dequeue = dequeue;
    this.f = f;
  }

  get take() {
    return tsplus_module_1.map(this.f)(this.dequeue.take);
  }

  get takeAll() {
    return tsplus_module_1.map(all => tsplus_module_2.map(this.f)(all))(this.dequeue.takeAll);
  }

  takeUpTo(max) {
    return tsplus_module_1.map(upTo => tsplus_module_2.map(this.f)(upTo))(this.dequeue.takeUpTo(max));
  }

  takeBetween(min, max) {
    return tsplus_module_1.map(upTo => tsplus_module_2.map(this.f)(upTo))(this.dequeue.takeBetween(min, max));
  }

  takeN(n) {
    return tsplus_module_1.map(upTo => tsplus_module_2.map(this.f)(upTo))(this.dequeue.takeN(n));
  }

  get poll() {
    return tsplus_module_1.map(m => tsplus_module_3.map(this.f)(m))(this.dequeue.poll);
  }

  get [_definition._Out]() {
    return a => a;
  }

  get capacity() {
    return this.dequeue.capacity;
  }

  get size() {
    return this.dequeue.size;
  }

  get awaitShutdown() {
    return this.dequeue.awaitShutdown;
  }

  get isShutdown() {
    return this.dequeue.isShutdown;
  }

  get shutdown() {
    return this.dequeue.shutdown;
  }

  get isFull() {
    return this.dequeue.isFull;
  }

  get isEmpty() {
    return this.dequeue.isEmpty;
  }

  get [_definition.QueueSym]() {
    return _definition.QueueSym;
  }

}

function mapDequeue(dequeue, f) {
  return new MapDequeueImpl(dequeue, f);
}
//# sourceMappingURL=mapDequeue.js.map