import { Sink } from "@effect/core/stream/Sink/definition/base";
import { HashMap } from "@tsplus/stdlib/collections/HashMap/definition";
/**
 * A sink that collects all of its inputs into a map. The keys are extracted
 * from inputs using the keying function `key`; if multiple inputs use the
 * same key, they are merged using the `f` function.
 * @tsplus static effect/core/stream/Sink.Ops collectAllToMap
 * @tsplus location "@effect/core/stream/Sink/operations/collectAllToMap"
 */
export declare function collectAllToMap<In, K>(key: (in_: In) => K, f: (in1: In, in2: In) => In): Sink<never, never, In, never, HashMap<K, In>>;
//# sourceMappingURL=collectAllToMap.d.ts.map