import { Sink } from "@effect/core/stream/Sink/definition/base";
import { HashMap } from "@tsplus/stdlib/collections/HashMap/definition";
/**
 * A sink that collects first `n` keys into a map. The keys are calculated
 * from inputs using the keying function `key`; if multiple inputs use the the
 * same key, they are merged using the `f` function.
 * @tsplus static effect/core/stream/Sink.Ops collectAllToMapN
 * @tsplus location "@effect/core/stream/Sink/operations/collectAllToMapN"
 */
export declare function collectAllToMapN<In, K>(n: number, key: (in_: In) => K, f: (in1: In, in2: In) => In): Sink<never, never, In, In, HashMap<K, In>>;
//# sourceMappingURL=collectAllToMapN.d.ts.map