import { Effect } from "@effect/core/io/Effect/definition";
import { Sink } from "@effect/core/stream/Sink/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { List } from "@tsplus/stdlib/collections/List/definition";
/**
 * Accumulates incoming elements into a chunk as long as they verify effectful
 * predicate `p`.
 * @tsplus static effect/core/stream/Sink.Ops collectAllWhileEffect
 * @tsplus location "@effect/core/stream/Sink/operations/collectAllWhileEffect"
 */
export declare function collectAllWhileEffect<R, E, In>(p: (input: In) => Effect<R, E, boolean>): Sink<R, E, In, In, Chunk<In>>;
//# sourceMappingURL=collectAllWhileEffect.d.ts.map