import { Predicate } from "@tsplus/stdlib/data/Predicate";
import { Sink } from "@effect/core/stream/Sink/definition/base";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Ref } from "@effect/core/io/Ref/definition";
/**
 * Repeatedly runs the sink for as long as its results satisfy the predicate
 * `p`. The sink's results will be accumulated using the stepping function
 * `f`.
 * @tsplus static effect/core/stream/Sink.Aspects collectAllWhileWith
 * @tsplus pipeable effect/core/stream/Sink collectAllWhileWith
 * @tsplus location "@effect/core/stream/Sink/operations/collectAllWhileWith"
 */
export declare function collectAllWhileWith<Z, S>(z: S, p: Predicate<Z>, f: (s: S, z: Z) => S): <R, E, In, L extends In>(self: import("../definition").Sink<R, E, In, L, Z>) => import("../definition").Sink<R, E, In, L, S>;
//# sourceMappingURL=collectAllWhileWith.d.ts.map