"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.collectAllWhileWith = collectAllWhileWith;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fail"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fromEffect"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/as"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWith"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/bufferChunk"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Ref/operations/make"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zip"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/flatten"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/doneCollect"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/foldChannel"));

var _SinkInternal = /*#__PURE__*/require("@effect/core/stream/Sink/operations/_internal/SinkInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Repeatedly runs the sink for as long as its results satisfy the predicate
 * `p`. The sink's results will be accumulated using the stepping function
 * `f`.
 *
 * @tsplus static effect/core/stream/Sink.Aspects collectAllWhileWith
 * @tsplus pipeable effect/core/stream/Sink collectAllWhileWith
 */
function collectAllWhileWith(z, p, f) {
  return self => {
    void 0;
    return new _SinkInternal.SinkInternal(tsplus_module_2.flatMap(([leftoversRef, upstreamDoneRef]) => {
      const upstreamMarker = tsplus_module_6.readWith(chunk => tsplus_module_2.flatMap(() => upstreamMarker)(tsplus_module_1.write(chunk)), err => tsplus_module_3.fail(err), x => tsplus_module_5.as(x)(tsplus_module_4.fromEffect(upstreamDoneRef.set(true))));
      return tsplus_module_8.pipeTo(loop(self, leftoversRef, upstreamDoneRef, z, p, f))(tsplus_module_8.pipeTo(tsplus_module_7.bufferChunk(leftoversRef))(upstreamMarker));
    })(tsplus_module_4.fromEffect(tsplus_module_11.zip(tsplus_module_9.makeRef(() => false))(tsplus_module_9.makeRef(() => tsplus_module_10.empty())))));
  };
}

function loop(self, leftoversRef, upstreamDoneRef, currentResult, p, f) {
  void 0;
  return tsplus_module_14.foldChannel(err => tsplus_module_3.fail(err), ([leftovers, doneValue]) => p(doneValue) ? tsplus_module_2.flatMap(() => tsplus_module_2.flatMap(upstreamDone => {
    const accumulatedResult = f(currentResult, doneValue);
    return upstreamDone ? tsplus_module_5.as(accumulatedResult)(tsplus_module_1.write(tsplus_module_12.flatten(leftovers))) : loop(self, leftoversRef, upstreamDoneRef, accumulatedResult, p, f);
  })(tsplus_module_4.fromEffect(upstreamDoneRef.get)))(tsplus_module_4.fromEffect(leftoversRef.set(tsplus_module_12.flatten(leftovers)))) : tsplus_module_5.as(currentResult)(tsplus_module_1.write(tsplus_module_12.flatten(leftovers))))(tsplus_module_13.doneCollect(self.channel));
}
//# sourceMappingURL=collectAllWhileWith.js.map