import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Sink } from "@effect/core/stream/Sink/definition/base";
/**
 * Effectfully transforms both input chunks and result of this sink using the
 * provided functions. `f` and `g` must preserve chunking-invariance.
 * @tsplus static effect/core/stream/Sink.Aspects dimapChunksEffect
 * @tsplus pipeable effect/core/stream/Sink dimapChunksEffect
 * @tsplus location "@effect/core/stream/Sink/operations/dimapChunksEffect"
 */
export declare function dimapChunksEffect<R2, E2, In, In1, Z, Z1>(f: (input: Chunk<In1>) => Effect<R2, E2, Chunk<In>>, g: (z: Z) => Z1): <R, E, L>(self: import("../definition").Sink<R, E, In, L, Z>) => import("../definition").Sink<R2 | R, E2 | E, In1, L, Z1>;
//# sourceMappingURL=dimapChunksEffect.d.ts.map