import { Sink } from "@effect/core/stream/Sink/definition/base";
/**
 * Runs this sink until it yields a result, then uses that result to create
 * another sink from the provided function which will continue to run until it
 * yields a result.
 *
 * This function essentially runs sinks in sequence.
 * @tsplus static effect/core/stream/Sink.Aspects flatMap
 * @tsplus pipeable effect/core/stream/Sink flatMap
 * @tsplus location "@effect/core/stream/Sink/operations/flatMap"
 */
export declare function flatMap<R1, E1, In, In1 extends In, L, L1 extends L, Z, Z1>(f: (z: Z) => Sink<R1, E1, In1, L1, Z1>): <R, E>(self: import("../definition").Sink<R, E, In, L, Z>) => import("../definition").Sink<R1 | R, E1 | E, In & In1, L1, Z1>;
//# sourceMappingURL=flatMap.d.ts.map