"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fold = fold;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Sink/operations/suspend"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/succeed"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/isNonEmpty"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/as"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fail"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWith"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/drop"));

var _SinkInternal = /*#__PURE__*/require("@effect/core/stream/Sink/operations/_internal/SinkInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * A sink that folds its inputs with the provided function, termination
 * predicate and initial state.
 *
 * @tsplus static effect/core/stream/Sink.Ops fold
 */
function fold(z, cont, f) {
  return tsplus_module_1.suspend(() => new _SinkInternal.SinkInternal(reader(z, cont, f)));
}

function reader(z, cont, f) {
  return !cont(z) ? tsplus_module_2.succeed(z) : tsplus_module_7.readWith(chunk => {
    const [nextS, leftovers] = foldChunkSplit(z, chunk, cont, f);
    return tsplus_module_3.isNonEmpty(leftovers) ? tsplus_module_5.as(nextS)(tsplus_module_4.write(leftovers)) : reader(nextS, cont, f);
  }, err => tsplus_module_6.fail(err), () => tsplus_module_2.succeed(z));
}

function foldChunkSplit(z, chunk, cont, f) {
  return foldInternal(z, chunk, cont, f, 0, chunk.length);
}

function foldInternal(z, chunk, cont, f, index, length) {
  if (index === length) {
    return [z, tsplus_module_8.empty()];
  }

  const z1 = f(z, tsplus_module_9.unsafeGet(index)(chunk));
  return cont(z1) ? foldInternal(z1, chunk, cont, f, index + 1, length) : [z1, tsplus_module_10.drop(index + 1)(chunk)];
}
//# sourceMappingURL=fold.js.map