import { Predicate } from "@tsplus/stdlib/data/Predicate";
import { Effect } from "@effect/core/io/Effect/definition";
import { Sink } from "@effect/core/stream/Sink/definition/base";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * A sink that effectfully folds its inputs with the provided function,
 * termination predicate and initial state.
 * @tsplus static effect/core/stream/Sink.Ops foldEffect
 * @tsplus location "@effect/core/stream/Sink/operations/foldEffect"
 */
export declare function foldEffect<R, E, In, S>(z: S, cont: Predicate<S>, f: (s: S, input: In) => Effect<R, E, S>): Sink<R, E, In, In, S>;
//# sourceMappingURL=foldEffect.d.ts.map