import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Sink } from "@effect/core/stream/Sink/definition/base";
/**
 * A sink that effectfully folds its input chunks with the provided function
 * and initial state. `f` must preserve chunking-invariance.
 * @tsplus static effect/core/stream/Sink.Ops foldLeftChunksEffect
 * @tsplus location "@effect/core/stream/Sink/operations/foldLeftChunksEffect"
 */
export declare function foldLeftChunksEffect<R, E, In, S>(z: S, f: (s: S, input: Chunk<In>) => Effect<R, E, S>): Sink<R, E, In, never, S>;
//# sourceMappingURL=foldLeftChunksEffect.d.ts.map