"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.foldSink_ = foldSink_;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/AtomicReference"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/isNonEmpty"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/filter"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/writeChunk"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/sync"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/identity"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/zipRight"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/as"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/doneCollect"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/suspend"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/foldChannel"));

var _SinkInternal = /*#__PURE__*/require("@effect/core/stream/Sink/operations/_internal/SinkInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @tsplus static effect/core/stream/Sink.Aspects foldSink
 * @tsplus pipeable effect/core/stream/Sink foldSink
 */
function foldSink_(failure, success) {
  return self => {
    void 0;
    return new _SinkInternal.SinkInternal(tsplus_module_14.foldChannel(err => {
      const result = failure(err);
      void 0;
      return result.channel;
    }, ([leftovers, z]) => tsplus_module_13.suspend(() => {
      const leftoversRef = new tsplus_module_1.AtomicReference(tsplus_module_3.filter(chunk => tsplus_module_2.isNonEmpty(chunk))(leftovers));
      const refReader = tsplus_module_7.flatMap(chunk => tsplus_module_4.writeChunk(chunk))(tsplus_module_6.sync(() => leftoversRef.getAndSet(tsplus_module_5.empty())));
      const passThrough = tsplus_module_8.identity();
      const result = success(z);
      void 0;
      const continuationSink = tsplus_module_10.pipeTo(result.channel)(tsplus_module_9.zipRight(passThrough)(refReader));
      return tsplus_module_7.flatMap(([newLeftovers, z1]) => tsplus_module_9.zipRight(tsplus_module_11.as(z1)(tsplus_module_4.writeChunk(newLeftovers)))(tsplus_module_7.flatMap(chunk => tsplus_module_4.writeChunk(chunk))(tsplus_module_6.sync(() => leftoversRef.get))))(tsplus_module_12.doneCollect(continuationSink));
    }))(tsplus_module_12.doneCollect(self.channel)));
  };
}
//# sourceMappingURL=foldSink.js.map