import { Effect } from "@effect/core/io/Effect/definition";
import { Sink } from "@effect/core/stream/Sink/definition/base";
/**
 * Creates a sink that effectfully folds elements of type `In` into a
 * structure of type `S` until `max` elements have been folded.
 *
 * Like `foldWeightedEffect`, but with a constant cost function of 1.
 * @tsplus static effect/core/stream/Sink.Ops foldUntilEffect
 * @tsplus location "@effect/core/stream/Sink/operations/foldUntilEffect"
 */
export declare function foldUntilEffect<R, E, In, S>(z: S, max: number, f: (s: S, input: In) => Effect<R, E, S>): Sink<R, E, In, In, S>;
//# sourceMappingURL=foldUntilEffect.d.ts.map