import { Effect } from "@effect/core/io/Effect/definition";
import { Sink } from "@effect/core/stream/Sink/definition/base";
/**
 * Creates a sink that effectfully folds elements of type `In` into a
 * structure of type `S`, until `max` worth of elements (determined by the
 * `costFn`) have been folded.
 * @note Elements that have an individual cost larger than `max` will force the
sink to cross the `max` cost. See `foldWeightedDecomposeEffect` for a variant
that can handle these cases.
 * @tsplus static effect/core/stream/Sink.Ops foldWeightedEffect
 * @tsplus location "@effect/core/stream/Sink/operations/foldWeightedEffect"
 */
export declare function foldWeightedEffect<R, E, R2, E2, In, S>(z: S, costFn: (s: S, input: In) => Effect<R, E, number>, max: number, f: (s: S, input: In) => Effect<R2, E2, S>): Sink<R | R2, E | E2, In, In, S>;
//# sourceMappingURL=foldWeightedEffect.d.ts.map