import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Sink } from "@effect/core/stream/Sink/definition/base";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * A sink that executes the provided effectful function for every chunk fed to
 * it.
 * @tsplus static effect/core/stream/Sink.Ops forEachChunk
 * @tsplus location "@effect/core/stream/Sink/operations/forEachChunk"
 */
export declare function forEachChunk<R, E, In, Z>(f: (input: Chunk<In>) => Effect<R, E, Z>): Sink<R, E, In, never, void>;
//# sourceMappingURL=forEachChunk.d.ts.map