import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Sink } from "@effect/core/stream/Sink/definition/base";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * A sink that executes the provided effectful function for every chunk fed to
 * it until `f` evaluates to `false`.
 * @tsplus static effect/core/stream/Sink.Ops forEachChunkWhile
 * @tsplus location "@effect/core/stream/Sink/operations/forEachChunkWhile"
 */
export declare function forEachChunkWhile<R, E, In>(f: (input: Chunk<In>) => Effect<R, E, boolean>): Sink<R, E, In, In, void>;
//# sourceMappingURL=forEachChunkWhile.d.ts.map