import { Effect } from "@effect/core/io/Effect/definition";
import { Sink } from "@effect/core/stream/Sink/definition/base";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * A sink that executes the provided effectful function for every element fed
 * to it until `f` evaluates to `false`.
 * @tsplus static effect/core/stream/Sink.Ops forEachWhile
 * @tsplus location "@effect/core/stream/Sink/operations/forEachWhile"
 */
export declare function forEachWhile<R, E, In>(f: (input: In) => Effect<R, E, boolean>): Sink<R, E, In, In, void>;
//# sourceMappingURL=forEachWhile.d.ts.map