import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Sink } from "@effect/core/stream/Sink/definition/base";
/**
 * Returns a new sink that will perform the operations of this one, until
 * failure, and then it will switch over to the operations of the specified
 * fallback sink.
 * @tsplus pipeable-operator effect/core/stream/Sink |
 * @tsplus static effect/core/stream/Sink.Aspects orElse
 * @tsplus pipeable effect/core/stream/Sink orElse
 * @tsplus location "@effect/core/stream/Sink/operations/orElse"
 */
export declare function orElse<R1, E1, In, In1 extends In, L, L1 extends L, Z1>(that: LazyArg<Sink<R1, E1, In1, L1, Z1>>): <R, E, Z>(self: import("../definition").Sink<R, E, In, L, Z>) => import("../definition").Sink<R1 | R, E1, In & In1, L, Z1 | Z>;
//# sourceMappingURL=orElse.d.ts.map