import { Sink } from "@effect/core/stream/Sink/definition/base";
import { Exit } from "@effect/core/io/Exit/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { MergeDecision } from "@effect/core/stream/Channel/MergeDecision";
/**
 * Runs both sinks in parallel on the input, using the specified merge
 * function as soon as one result or the other has been computed.
 * @tsplus static effect/core/stream/Sink.Aspects raceWith
 * @tsplus pipeable effect/core/stream/Sink raceWith
 * @tsplus location "@effect/core/stream/Sink/operations/raceWith"
 */
export declare function raceWith<R1, E1, In1, L1, Z1, E, Z, Z2>(that: Sink<R1, E1, In1, L1, Z1>, leftDone: (exit: Exit<E, Z>) => MergeDecision<R1, E1, Z1, E | E1, Z2>, rightDone: (exit: Exit<E1, Z1>) => MergeDecision<R1, E, Z, E | E1, Z2>, capacity?: number): <R, In, L>(self: import("../definition").Sink<R, E, In, L, Z>) => import("../definition").Sink<R1 | R, E1 | E, In & In1, L1 | L, Z2>;
//# sourceMappingURL=raceWith.d.ts.map