import { Predicate } from "@tsplus/stdlib/data/Predicate";
import { Sink } from "@effect/core/stream/Sink/definition/base";
import { Ref } from "@effect/core/io/Ref/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * Splits the sink on the specified predicate, returning a new sink that
 * consumes elements until an element after the first satisfies the specified
 * predicate.
 * @tsplus static effect/core/stream/Sink.Aspects splitWhere
 * @tsplus pipeable effect/core/stream/Sink splitWhere
 * @tsplus location "@effect/core/stream/Sink/operations/splitWhere"
 */
export declare function splitWhere<In1>(f: Predicate<In1>): <R, E, In, L extends In1, Z>(self: import("../definition").Sink<R, E, In, L, Z>) => import("../definition").Sink<R, E, In & In1, In1, Z>;
//# sourceMappingURL=splitWhere.d.ts.map