"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.splitWhere = splitWhere;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/succeed"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/flatten"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/concat"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fromEffect"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeToOrFail"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/doneCollect"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Ref/operations/make"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/isEmpty"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/indexWhere"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/splitAt"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/indexWhereFrom"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/failCause"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWithCause"));

var _SinkInternal = /*#__PURE__*/require("@effect/core/stream/Sink/operations/_internal/SinkInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Splits the sink on the specified predicate, returning a new sink that
 * consumes elements until an element after the first satisfies the specified
 * predicate.
 *
 * @tsplus static effect/core/stream/Sink.Aspects splitWhere
 * @tsplus pipeable effect/core/stream/Sink splitWhere
 */
function splitWhere(f) {
  return self => {
    void 0;
    return new _SinkInternal.SinkInternal(tsplus_module_5.flatMap(ref => tsplus_module_5.flatMap(([leftovers, z]) => tsplus_module_5.flatMap(leftover => tsplus_module_5.flatMap(() => tsplus_module_1.succeed(z))(tsplus_module_4.write(tsplus_module_3.concat(tsplus_module_2.flatten(leftovers))(leftover))))(tsplus_module_6.fromEffect(ref.get)))(tsplus_module_8.doneCollect(tsplus_module_7.pipeToOrFail(self.channel)(splitter(false, ref, f)))))(tsplus_module_6.fromEffect(tsplus_module_10.makeRef(() => tsplus_module_9.empty()))));
  };
}

function splitter(written, leftovers, f) {
  return tsplus_module_16.readWithCause(input => {
    if (tsplus_module_11.isEmpty(input)) {
      return splitter(written, leftovers, f);
    }

    if (written) {
      const index = tsplus_module_12.indexWhere(f)(input);

      if (index === -1) {
        return tsplus_module_5.flatMap(() => splitter(true, leftovers, f))(tsplus_module_4.write(input));
      }

      const [left, right] = tsplus_module_13.splitAt(index)(input);
      return tsplus_module_5.flatMap(() => tsplus_module_6.fromEffect(leftovers.set(right)))(tsplus_module_4.write(left));
    }

    const index = tsplus_module_14.indexWhereFrom(1, f)(input);

    if (index === -1) {
      return tsplus_module_5.flatMap(() => splitter(true, leftovers, f))(tsplus_module_4.write(input));
    }

    const [left, right] = tsplus_module_13.splitAt(Math.max(index, 1))(input);
    return tsplus_module_5.flatMap(() => tsplus_module_6.fromEffect(leftovers.set(right)))(tsplus_module_4.write(left));
  }, cause => tsplus_module_15.failCause(cause), done => tsplus_module_1.succeed(done));
}
//# sourceMappingURL=splitWhere.js.map