import { Sink } from "@effect/core/stream/Sink/definition/base";
import { Duration } from "@tsplus/stdlib/data/Duration";
/**
 * Returns the sink that executes this one and times its execution in
 * milliseconds.
 * @tsplus getter effect/core/stream/Sink timed
 * @tsplus location "@effect/core/stream/Sink/operations/timed"
 */
export declare function withDuration<R, E, In, L, Z>(self: Sink<R, E, In, L, Z>): Sink<R, E, In, L, readonly [Z, Duration]>;
/**
 * Times the execution of a sink in milliseconds.
 * @tsplus static effect/core/stream/Sink.Aspects timed
 * @tsplus location "@effect/core/stream/Sink/operations/timed"
 */
export declare function timed(): Sink<never, never, unknown, never, Duration>;
//# sourceMappingURL=timed.d.ts.map