"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.timed = timed;
exports.withDuration = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Clock/operations/currentTime"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Sink/operations/summarized"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Sink/operations/drain"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Sink/operations/map"));

var _Duration = /*#__PURE__*/require("@tsplus/stdlib/data/Duration");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const withDuration = withDuration_1;
exports.withDuration = withDuration;

/**
 * Returns the sink that executes this one and times its execution in
 * milliseconds.
 *
 * @tsplus getter effect/core/stream/Sink timed
 */
function withDuration_1(self) {
  return tsplus_module_2.summarized(tsplus_module_1.currentTime, (start, end) => new _Duration.DurationInternal(end - start))(self);
}
/**
 * Times the execution of a sink in milliseconds.
 *
 * @tsplus static effect/core/stream/Sink.Aspects timed
 */


function timed() {
  return tsplus_module_4.map(tuple => tuple[1])(withDuration_1(tsplus_module_3.drain()));
}
//# sourceMappingURL=timed.js.map