import { Sink } from "@effect/core/stream/Sink/definition/base";
/**
 * Feeds inputs to this sink until it yields a result, then switches over to
 * the provided sink until it yields a result, finally combining the two
 * results with `f`.
 * @tsplus static effect/core/stream/Sink.Aspects zipWith
 * @tsplus pipeable effect/core/stream/Sink zipWith
 * @tsplus location "@effect/core/stream/Sink/operations/zipWith"
 */
export declare function zipWith<R1, E1, In, In1 extends In, L, L1 extends L, Z, Z1, Z2>(that: Sink<R1, E1, In1, L1, Z1>, f: (z: Z, z1: Z1) => Z2): <R, E>(self: import("../definition").Sink<R, E, In, L, Z>) => import("../definition").Sink<R1 | R, E1 | E, In & In1, L1, Z2>;
//# sourceMappingURL=zipWith.d.ts.map