import { Sink } from "@effect/core/stream/Sink/definition/base";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Feeds inputs to this sink until it yields a result, then switches over to
 * the provided sink until it yields a result, finally combining the two
 * results with `f`.
 * @tsplus static effect/core/stream/Sink.Aspects zipWithPar
 * @tsplus pipeable effect/core/stream/Sink zipWithPar
 * @tsplus location "@effect/core/stream/Sink/operations/zipWithPar"
 */
export declare function zipWithPar<R1, E1, In1, L1, Z, Z1, Z2>(that: Sink<R1, E1, In1, L1, Z1>, f: (z: Z, z1: Z1) => Z2): <R, E, In, L>(self: import("../definition").Sink<R, E, In, L, Z>) => import("../definition").Sink<R1 | R, E1 | E, In & In1, L1 | L, Z2>;
//# sourceMappingURL=zipWithPar.d.ts.map