import { Ord } from "@tsplus/stdlib/prelude/Ord/definition";
import { SortedByKey } from "@effect/core/stream/SortedByKey/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Zips this stream that is sorted by distinct keys and the specified stream
 * that is sorted by distinct keys to produce a new stream that is sorted by
 * distinct keys. Combines values associated with each key into a tuple,
 * using the specified values `defaultLeft` and `defaultRight` to fill in
 * missing values.
 *
 * This allows zipping potentially unbounded streams of data by key in
 * constant space but the caller is responsible for ensuring that the
 * streams are sorted by distinct keys.
 * @tsplus static effect/core/stream/SortedByKey.Aspects zipAllSortedByKey
 * @tsplus pipeable effect/core/stream/SortedByKey zipAllSortedByKey
 * @tsplus static effect/core/stream/Stream.Aspects zipAllSortedByKey
 * @tsplus pipeable effect/core/stream/Stream zipAllSortedByKey
 * @tsplus location "@effect/core/stream/SortedByKey/operations/zipAllSortedByKey"
 */
export declare function zipAllSortedByKey<K, R2, E2, A, A2>(ord: Ord<K>, that: SortedByKey<R2, E2, K, A2>, defaultLeft: A, defaultRight: A2): <R, E>(self: import("../definition").SortedByKey<R, E, K, A>) => import("../../Stream").Stream<R2 | R, E2 | E, readonly [K, readonly [A, A2]]>;
//# sourceMappingURL=zipAllSortedByKey.d.ts.map