import { Ord } from "@tsplus/stdlib/prelude/Ord/definition";
import { SortedByKey } from "@effect/core/stream/SortedByKey/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Zips this stream that is sorted by distinct keys and the specified stream
 * that is sorted by distinct keys to produce a new stream that is sorted by
 * distinct keys. Keeps only values from that stream, using the specified
 * value `default` to fill in missing values.
 *
 * This allows zipping potentially unbounded streams of data by key in
 * constant space but the caller is responsible for ensuring that the
 * streams are sorted by distinct keys.
 * @tsplus static effect/core/stream/SortedByKey.Aspects zipAllSortedByKeyRight
 * @tsplus pipeable effect/core/stream/SortedByKey zipAllSortedByKeyRight
 * @tsplus static effect/core/stream/Stream.Aspects zipAllSortedByKeyRight
 * @tsplus pipeable effect/core/stream/Stream zipAllSortedByKeyRight
 * @tsplus location "@effect/core/stream/SortedByKey/operations/zipAllSortedByKeyRight"
 */
export declare function zipAllSortedByKeyRight<K, R2, E2, A2>(ord: Ord<K>, that: SortedByKey<R2, E2, K, A2>, def: A2): <R, E, A>(self: import("../definition").SortedByKey<R, E, K, A>) => import("../../Stream").Stream<R2 | R, E2 | E, readonly [K, A2]>;
//# sourceMappingURL=zipAllSortedByKeyRight.d.ts.map