"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PullRight = exports.PullLeft = exports.PullBoth = exports.DrainRight = exports.DrainLeft = void 0;
exports.zipAllSortedByKeyWith = zipAllSortedByKeyWith;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/fail"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/map"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/succeed"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/fold"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/isEmpty"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unsome"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipPar"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/foldEffect"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fold"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/builder"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/size"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/drop"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/combineChunks"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

class DrainLeft {
  constructor() {
    this._tag = "DrainLeft";
  }

}

exports.DrainLeft = DrainLeft;

class DrainRight {
  constructor() {
    this._tag = "DrainRight";
  }

}

exports.DrainRight = DrainRight;

class PullBoth {
  constructor() {
    this._tag = "PullBoth";
  }

}

exports.PullBoth = PullBoth;

class PullLeft {
  constructor(rightChunk) {
    this.rightChunk = rightChunk;
    this._tag = "PullLeft";
  }

}

exports.PullLeft = PullLeft;

class PullRight {
  constructor(leftChunk) {
    this.leftChunk = leftChunk;
    this._tag = "PullRight";
  }

}
/**
 * Zips this stream that is sorted by distinct keys and the specified stream
 * that is sorted by distinct keys to produce a new stream that is sorted by
 * distinct keys. Uses the functions `left`, `right`, and `both` to handle
 * the cases where a key and value exist in this stream, that stream, or
 * both streams.
 *
 * This allows zipping potentially unbounded streams of data by key in
 * constant space but the caller is responsible for ensuring that the
 * streams are sorted by distinct keys.
 *
 * @tsplus static effect/core/stream/SortedByKey.Aspects zipAllSortedByKeyWith
 * @tsplus pipeable effect/core/stream/SortedByKey zipAllSortedByKeyWith
 * @tsplus static effect/core/stream/Stream.Aspects zipAllSortedByKeyWith
 * @tsplus pipeable effect/core/stream/Stream zipAllSortedByKeyWith
 */


exports.PullRight = PullRight;

function zipAllSortedByKeyWith(ord, that, left, right, both) {
  return self => {
    const pull = (state, pullLeft, pullRight) => {
      switch (state._tag) {
        case "DrainLeft":
          return tsplus_module_4.fold(e => tsplus_module_1.fail(e), leftChunk => tsplus_module_3.succeed([tsplus_module_2.map(([k, a]) => [k, left(a)])(leftChunk), new DrainLeft()]))(pullLeft);

        case "DrainRight":
          return tsplus_module_4.fold(e => tsplus_module_1.fail(e), rightChunk => tsplus_module_3.succeed([tsplus_module_2.map(([k, b]) => [k, right(b)])(rightChunk), new DrainRight()]))(pullRight);

        case "PullBoth":
          {
            return tsplus_module_10.foldEffect(e => tsplus_module_6.succeed(tsplus_module_1.fail(tsplus_module_5.some(e))), ([a, b]) => {
              if (tsplus_module_5.isSome(a) && tsplus_module_5.isSome(b)) {
                const leftChunk = a.value;
                const rightChunk = b.value;

                if (tsplus_module_7.isEmpty(leftChunk) && tsplus_module_7.isEmpty(rightChunk)) {
                  return pull(new PullBoth(), pullLeft, pullRight);
                } else if (tsplus_module_7.isEmpty(leftChunk)) {
                  return pull(new PullLeft(rightChunk), pullLeft, pullRight);
                } else if (tsplus_module_7.isEmpty(rightChunk)) {
                  return pull(new PullRight(leftChunk), pullLeft, pullRight);
                } else {
                  return tsplus_module_6.succeed(tsplus_module_3.succeed(mergeSortedByKeyChunk(leftChunk, rightChunk)));
                }
              } else if (tsplus_module_5.isSome(a)) {
                const leftChunk = a.value;
                return tsplus_module_7.isEmpty(leftChunk) ? pull(new DrainLeft(), pullLeft, pullRight) : tsplus_module_6.succeed(tsplus_module_3.succeed([tsplus_module_2.map(([k, a]) => [k, left(a)])(leftChunk), new DrainLeft()]));
              } else if (tsplus_module_5.isSome(b)) {
                const rightChunk = b.value;
                return tsplus_module_7.isEmpty(rightChunk) ? pull(new DrainLeft(), pullLeft, pullRight) : tsplus_module_6.succeed(tsplus_module_3.succeed([tsplus_module_2.map(([k, b]) => [k, right(b)])(rightChunk), new DrainRight()]));
              } else {
                return tsplus_module_6.succeed(tsplus_module_1.fail(tsplus_module_5.none));
              }
            })(tsplus_module_9.zipPar(tsplus_module_8.unsome(pullRight))(tsplus_module_8.unsome(pullLeft)));
          }

        case "PullLeft":
          {
            const rightChunk = state.rightChunk;
            return tsplus_module_10.foldEffect(option => tsplus_module_11.fold(() => tsplus_module_6.succeed(tsplus_module_3.succeed([tsplus_module_2.map(([k, b]) => [k, right(b)])(rightChunk), new DrainRight()])), e => tsplus_module_6.succeed(tsplus_module_1.fail(tsplus_module_5.some(e))))(option), leftChunk => tsplus_module_7.isEmpty(leftChunk) ? pull(new PullLeft(rightChunk), pullLeft, pullRight) : tsplus_module_6.succeed(tsplus_module_3.succeed(mergeSortedByKeyChunk(leftChunk, rightChunk))))(pullLeft);
          }

        case "PullRight":
          {
            const leftChunk = state.leftChunk;
            return tsplus_module_10.foldEffect(option => tsplus_module_11.fold(() => tsplus_module_6.succeed(tsplus_module_3.succeed([tsplus_module_2.map(([k, a]) => [k, left(a)])(leftChunk), new DrainLeft()])), e => tsplus_module_6.succeed(tsplus_module_1.fail(tsplus_module_5.some(e))))(option), rightChunk => tsplus_module_7.isEmpty(rightChunk) ? pull(new PullRight(leftChunk), pullLeft, pullRight) : tsplus_module_6.succeed(tsplus_module_3.succeed(mergeSortedByKeyChunk(leftChunk, rightChunk))))(pullRight);
          }
      }
    };

    function mergeSortedByKeyChunk(leftChunk, rightChunk) {
      const builder = tsplus_module_12.builder();
      let state;
      let leftIndex = 0;
      let rightIndex = 0;
      let leftTuple = tsplus_module_13.unsafeGet(leftIndex)(leftChunk);
      let rightTuple = tsplus_module_13.unsafeGet(rightIndex)(rightChunk);
      let k1 = leftTuple[0];
      let a = leftTuple[1];
      let k2 = rightTuple[0];
      let b = rightTuple[1];
      let loop = true;

      const hasNext = (c, index) => index < tsplus_module_14.size(c) - 1;

      while (loop) {
        const compare = ord.compare(k1, k2);

        if (compare === 0) {
          builder.append([k1, both(a, b)]);

          if (hasNext(leftChunk, leftIndex) && hasNext(rightChunk, rightIndex)) {
            leftIndex += 1;
            rightIndex += 1;
            leftTuple = tsplus_module_13.unsafeGet(leftIndex)(leftChunk);
            rightTuple = tsplus_module_13.unsafeGet(rightIndex)(rightChunk);
            k1 = leftTuple[0];
            a = leftTuple[1];
            k2 = rightTuple[0];
            b = rightTuple[1];
          } else if (hasNext(leftChunk, leftIndex)) {
            state = new PullRight(tsplus_module_15.drop(leftIndex + 1)(leftChunk));
            loop = false;
          } else if (hasNext(rightChunk, rightIndex)) {
            state = new PullLeft(tsplus_module_15.drop(rightIndex + 1)(rightChunk));
            loop = false;
          } else {
            state = new PullBoth();
            loop = false;
          }
        } else if (compare < 0) {
          builder.append([k1, left(a)]);

          if (hasNext(leftChunk, leftIndex)) {
            leftIndex += 1;
            leftTuple = tsplus_module_13.unsafeGet(leftIndex)(leftChunk);
            k1 = leftTuple[0];
            a = leftTuple[1];
          } else {
            const rightBuilder = tsplus_module_12.builder();
            rightBuilder.append(rightTuple);

            while (hasNext(rightChunk, rightIndex)) {
              rightIndex += 1;
              rightTuple = tsplus_module_13.unsafeGet(rightIndex)(rightChunk);
              rightBuilder.append(rightTuple);
              state = new PullLeft(rightBuilder.build());
              loop = false;
            }
          }
        } else {
          builder.append([k2, right(b)]);

          if (hasNext(rightChunk, rightIndex)) {
            rightIndex += 1;
            rightTuple = tsplus_module_13.unsafeGet(rightIndex)(rightChunk);
            k2 = rightTuple[0];
            b = rightTuple[1];
          } else {
            const leftBuilder = tsplus_module_12.builder();
            leftBuilder.append(leftTuple);

            while (hasNext(leftChunk, leftIndex)) {
              leftIndex += 1;
              leftTuple = tsplus_module_13.unsafeGet(leftIndex)(leftChunk);
              leftBuilder.append(leftTuple);
              state = new PullRight(leftBuilder.build());
              loop = false;
            }
          }
        }
      }

      return [builder.build(), state];
    }

    return tsplus_module_16.combineChunks(that, new PullBoth(), pull)(self);
  };
}
//# sourceMappingURL=zipAllSortedByKeyWith.js.map