"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Emit = void 0;
exports.apply = apply;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/dieSync"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/dieMessage"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/single"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/mapBoth"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/done"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/fail"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/mapBoth"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/mapError"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Cause/operations/map"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/failCauseSync"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const Emit = {};
/**
 * @tsplus static effect/core/stream/Stream/Emit.Ops __call
 */

exports.Emit = Emit;

function apply(fn) {
  const ops = {
    chunk(as) {
      return this(tsplus_module_1.succeed(as));
    },

    die(err) {
      return this(tsplus_module_2.dieSync(() => err));
    },

    dieMessage(message) {
      return this(tsplus_module_3.dieMessage(message));
    },

    done(exit) {
      return this(tsplus_module_7.done(tsplus_module_6.mapBoth(e => tsplus_module_4.some(e), a => tsplus_module_5.single(a))(exit)));
    },

    end() {
      return this(tsplus_module_8.fail(tsplus_module_4.none));
    },

    fail(e) {
      return this(tsplus_module_8.fail(tsplus_module_4.some(e)));
    },

    fromEffect(io) {
      return this(tsplus_module_9.mapBoth(e => tsplus_module_4.some(e), a => tsplus_module_5.single(a))(io));
    },

    fromEffectChunk(io) {
      return this(tsplus_module_10.mapError(e => tsplus_module_4.some(e))(io));
    },

    halt(cause) {
      return this(tsplus_module_12.failCauseSync(() => tsplus_module_11.map(e => tsplus_module_4.some(e))(cause)));
    },

    single(a) {
      return this(tsplus_module_1.succeed(tsplus_module_5.single(a)));
    }

  };
  return Object.assign(fn, ops);
}
//# sourceMappingURL=Emit.js.map