"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HandoffSignal = exports.Halt = exports.End = exports.Emit = void 0;
exports.emit = emit;
exports.end = end;
exports.halt = halt;

class Emit {
  constructor(elements) {
    this.elements = elements;
    this._tag = "Emit";
  }

}

exports.Emit = Emit;

class Halt {
  constructor(error) {
    this.error = error;
    this._tag = "Halt";
  }

}

exports.Halt = Halt;

class End {
  constructor(reason) {
    this.reason = reason;
    this._tag = "End";
  }

}

exports.End = End;
const HandoffSignal = {};
/**
 * @tsplus static effect/core/stream/Stream/HandoffSignal.Ops Emit
 */

exports.HandoffSignal = HandoffSignal;

function emit(elements) {
  return new Emit(elements);
}
/**
 * @tsplus static effect/core/stream/Stream/HandoffSignal.Ops Halt
 */


function halt(error) {
  return new Halt(error);
}
/**
 * @tsplus static effect/core/stream/Stream/HandoffSignal.Ops End
 */


function end(reason) {
  return new End(reason);
}
//# sourceMappingURL=HandoffSignal.js.map