"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.utf8DecodeNoBom = utf8DecodeNoBom;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/suspend"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fail"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/isEmpty"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unit"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWith"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/concat"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/splitAt"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/materialize"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/single"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/from"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/find"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const emptyByteChunk = /*#__PURE__*/tsplus_module_1.empty();
const emptyStringChunk = /*#__PURE__*/tsplus_module_1.empty();

function utf8DecodeNoBom(stream) {
  void 0;
  return new _StreamInternal.StreamInternal(tsplus_module_3.suspend(() => tsplus_module_2.pipeTo(readThenTransduce(emptyByteChunk))(stream.channel)));
}

function readThenTransduce(buffer) {
  return tsplus_module_9.readWith(received => {
    const [string, buffered] = process(buffer, received);
    return tsplus_module_5.flatMap(() => readThenTransduce(buffered))(tsplus_module_4.write(string));
  }, err => tsplus_module_6.fail(err), () => tsplus_module_7.isEmpty(buffer) ? tsplus_module_8.unit : tsplus_module_4.write(stringChunkFrom(buffer)));
}

function process(buffered, received) {
  const bytes = tsplus_module_10.concat(received)(buffered);
  const [chunk, rest] = tsplus_module_11.splitAt(computeSplitIndex(bytes))(bytes);

  if (tsplus_module_7.isEmpty(chunk)) {
    return [emptyStringChunk, tsplus_module_12.materialize(rest)];
  }

  if (tsplus_module_7.isEmpty(rest)) {
    return [stringChunkFrom(chunk), emptyByteChunk];
  }

  return [stringChunkFrom(chunk), rest];
}

function stringChunkFrom(bytes) {
  return tsplus_module_13.single(String.fromCharCode(...bytes));
}

function computeSplitIndex(chunk) {
  // There are 3 bad patterns we need to check to detect an incomplete chunk:
  // - 2/3/4 byte sequences that start on the last byte
  // - 3/4 byte sequences that start on the second-to-last byte
  // - 4 byte sequences that start on the third-to-last byte
  //
  // Otherwise, we can convert the entire concatenated chunk to a string.
  const size = chunk.length;

  if (size >= 1 && tsplus_module_17.isSome(tsplus_module_16.find(f => f(tsplus_module_14.unsafeGet(size - 1)(chunk)))(tsplus_module_15.make(is2ByteStart, is3ByteStart, is4ByteStart)))) {
    return size - 1;
  }

  if (size >= 2 && tsplus_module_17.isSome(tsplus_module_16.find(f => f(tsplus_module_14.unsafeGet(size - 2)(chunk)))(tsplus_module_15.make(is3ByteStart, is4ByteStart)))) {
    return size - 2;
  }

  if (size >= 3 && is4ByteStart(tsplus_module_14.unsafeGet(size - 3)(chunk))) {
    return size - 3;
  }

  return size;
}

function is2ByteStart(byte) {
  return (byte & 0xe0) === 0xc0;
}

function is3ByteStart(byte) {
  return (byte & 0xf0) === 0xe0;
}

function is4ByteStart(byte) {
  return (byte & 0xf8) === 0xf0;
}
//# sourceMappingURL=utf8DecodeNoBom.js.map