"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.utfDecodeDetectingBom = utfDecodeDetectingBom;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/suspend"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/fromChunk"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fail"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unit"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWith"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/concat"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/splitAt"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/isEmpty"));

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function utfDecodeDetectingBom(bomSize, processBom) {
  return stream => {
    void 0;
    return new _StreamInternal.StreamInternal(tsplus_module_3.suspend(() => tsplus_module_2.pipeTo(lookingForBom(tsplus_module_1.empty(), bomSize, processBom))(stream.channel)));
  };
}

function passThrough(decodingPipeline) {
  return tsplus_module_8.readWith(received => {
    const stream = decodingPipeline(tsplus_module_4.fromChunk(received));
    void 0;
    return tsplus_module_5.flatMap(() => passThrough(decodingPipeline))(stream.channel);
  }, err => tsplus_module_6.fail(err), () => tsplus_module_7.unit);
}

function lookingForBom(buffer, bomSize, processBom) {
  return tsplus_module_8.readWith(received => {
    const data = tsplus_module_9.concat(received)(buffer);

    if (data.length >= bomSize) {
      const [bom, rest] = tsplus_module_10.splitAt(bomSize)(data);
      const [dataWithoutBom, decodingPipeline] = processBom(bom);
      const stream = decodingPipeline(tsplus_module_4.fromChunk(tsplus_module_9.concat(rest)(dataWithoutBom)));
      void 0;
      return tsplus_module_5.flatMap(() => passThrough(decodingPipeline))(stream.channel);
    }

    return lookingForBom(data, bomSize, processBom);
  }, err => tsplus_module_6.fail(err), () => {
    if (tsplus_module_11.isEmpty(buffer)) {
      return tsplus_module_7.unit;
    }

    const [dataWithoutBom, decodingPipeline] = processBom(buffer);
    const stream = decodingPipeline(tsplus_module_4.fromChunk(dataWithoutBom));
    void 0;
    return tsplus_module_5.flatMap(() => passThrough(decodingPipeline))(stream.channel);
  });
}
//# sourceMappingURL=utfDecodeDetectingBom.js.map