"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.utfDecodeFixedLength = utfDecodeFixedLength;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/suspend"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fail"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/isEmpty"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unit"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWith"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/concat"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/splitAt"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/materialize"));

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

var _stringChunkFrom = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/stringChunkFrom");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const emptyByteChunk = /*#__PURE__*/tsplus_module_1.empty();
const emptyStringChunk = /*#__PURE__*/tsplus_module_1.empty();

function utfDecodeFixedLength(charset, fixedLength) {
  return stream => {
    void 0;
    return new _StreamInternal.StreamInternal(tsplus_module_3.suspend(() => tsplus_module_2.pipeTo(readThenTransduce(emptyByteChunk, charset, fixedLength))(stream.channel)));
  };
}

function readThenTransduce(buffer, charset, fixedLength) {
  return tsplus_module_9.readWith(received => {
    const [string, buffered] = process(buffer, received, charset, fixedLength);
    return tsplus_module_5.flatMap(() => readThenTransduce(buffered, charset, fixedLength))(tsplus_module_4.write(string));
  }, err => tsplus_module_6.fail(err), () => tsplus_module_7.isEmpty(buffer) ? tsplus_module_8.unit : tsplus_module_4.write((0, _stringChunkFrom.stringChunkFrom)(buffer, charset)));
}

function process(buffered, received, charset, fixedLength) {
  const bytes = tsplus_module_10.concat(received)(buffered);
  const remainder = bytes.length % fixedLength;

  if (remainder === 0) {
    return [(0, _stringChunkFrom.stringChunkFrom)(bytes, charset), emptyByteChunk];
  }

  if (bytes.length > fixedLength) {
    const [fullChunk, rest] = tsplus_module_11.splitAt(bytes.length - remainder)(bytes);
    return [(0, _stringChunkFrom.stringChunkFrom)(fullChunk, charset), rest];
  }

  return [emptyStringChunk, tsplus_module_12.materialize(bytes)];
}
//# sourceMappingURL=utfDecodeFixedLength.js.map