import { Sink } from "@effect/core/stream/Sink/definition/base";
import { Schedule } from "@effect/core/io/Schedule/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Like `aggregateWithinEither`, but only returns the `Right` results.
 * @param sink Used for the aggregation
 * @param schedule Used for signalling for when to stop the aggregation
 * @tsplus static effect/core/stream/Stream.Aspects aggregateWithin
 * @tsplus pipeable effect/core/stream/Stream aggregateWithin
 * @tsplus location "@effect/core/stream/Stream/operations/aggregateWithin"
 */
export declare function aggregateWithin<A, R2, E2, A2, S, R3, B, C>(sink: Sink<R2, E2, A | A2, A2, B>, schedule: Schedule<S, R3, Maybe<B>, C>): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R3 | R, E2 | E, B>;
//# sourceMappingURL=aggregateWithin.d.ts.map