import { Stream } from "@effect/core/stream/Stream/definition";
import type { Emit } from "@effect/core/stream/Stream/Emit";
/**
 * Creates a stream from an asynchronous callback that can be called multiple
 * times. The optionality of the error type `E` can be used to signal the end
 * of the stream, by setting it to `None`.
 * @tsplus static effect/core/stream/Stream.Ops async
 * @tsplus location "@effect/core/stream/Stream/operations/async"
 */
export declare function _async<R, E, A>(register: (emit: Emit<R, E, A, void>) => void, outputBuffer?: number): Stream<R, E, A>;
export { _async as async };
//# sourceMappingURL=async.d.ts.map