import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Take } from "@effect/core/stream/Take/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Emit } from "@effect/core/stream/Stream/Emit";
/**
 * Creates a stream from an asynchronous callback that can be called multiple
 * times The registration of the callback itself returns an effect. The
 * optionality of the error type `E` can be used to signal the end of the
 * stream, by setting it to `None`.
 * @tsplus static effect/core/stream/Stream.Ops asyncEffect
 * @tsplus location "@effect/core/stream/Stream/operations/asyncEffect"
 */
export declare function asyncEffect<R, E, A, Z>(register: (emit: Emit<R, E, A, void>) => Effect<R, E, Z>, outputBuffer?: number): Stream<R, E, A>;
//# sourceMappingURL=asyncEffect.d.ts.map