import { Either } from "@tsplus/stdlib/data/Either/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Take } from "@effect/core/stream/Take/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Emit } from "@effect/core/stream/Stream/Emit";
/**
 * Creates a stream from an asynchronous callback that can be called multiple
 * times. The registration of the callback returns either a canceler or
 * synchronously returns a stream. The optionality of the error type `E` can be
 * used to signal the end of the stream, by setting it to `None`.
 * @tsplus static effect/core/stream/Stream.Ops asyncInterrupt
 * @tsplus location "@effect/core/stream/Stream/operations/asyncInterrupt"
 */
export declare function asyncInterrupt<R, E, A>(register: (emit: Emit<R, E, A, void>) => Either<Effect<R, never, void>, Stream<R, E, A>>, outputBuffer?: number): Stream<R, E, A>;
//# sourceMappingURL=asyncInterrupt.d.ts.map