import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import type { Emit } from "@effect/core/stream/Stream/Emit";
/**
 * Creates a stream from an asynchronous callback that can be called multiple
 * times. The registration of the callback can possibly return the stream
 * synchronously. The optionality of the error type `E` can be used to signal
 * the end of the stream, by setting it to `None`.
 * @tsplus static effect/core/stream/Stream.Ops asyncMaybe
 * @tsplus location "@effect/core/stream/Stream/operations/asyncMaybe"
 */
export declare function asyncMaybe<R, E, A>(register: (emit: Emit<R, E, A, void>) => Maybe<Stream<R, E, A>>, outputBuffer?: number): Stream<R, E, A>;
//# sourceMappingURL=asyncMaybe.d.ts.map