import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Scope } from "@effect/core/io/Scope/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Take } from "@effect/core/stream/Take/definition";
/**
 * Creates a stream from an asynchronous callback that can be called multiple
 * times. The registration of the callback itself returns an a scoped
 * resource. The optionality of the error type `E` can be used to signal the
 * end of the stream, by setting it to `None`.
 * @tsplus static effect/core/stream/Stream.Ops asyncScoped
 * @tsplus location "@effect/core/stream/Stream/operations/asyncScoped"
 */
export declare function asyncScoped<R, E, A>(register: (f: (effect: Effect<R, Maybe<E>, Chunk<A>>) => void) => Effect<R | Scope, E, unknown>, outputBuffer?: number): Stream<R, E, A>;
//# sourceMappingURL=asyncScoped.d.ts.map