import { Stream } from "@effect/core/stream/Stream/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
interface Pipeline<R, E, A, R2, E2, B> {
    (stream: Stream<R, E, A>): Stream<R2, E2, B>;
}
/**
 * Reads the first `n` values from the stream and uses them to choose the
 * pipeline that will be used for the remainder of the stream.
 * @tsplus static effect/core/stream/Stream.Aspects branchAfter
 * @tsplus pipeable effect/core/stream/Stream branchAfter
 * @tsplus location "@effect/core/stream/Stream/operations/branchAfter"
 */
export declare function branchAfter<R, E, A, R2, E2, B>(n: number, f: (output: Chunk<A>) => Pipeline<R, E, A, R2, E2, B>): (self: Stream<R, E, A>) => Stream<R | R2, E | E2, B>;
export {};
//# sourceMappingURL=branchAfter.d.ts.map