"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.branchAfter = branchAfter;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/suspend"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/concat"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/splitAt"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/fromChunk"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/failCauseSync"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/isEmpty"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unit"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/empty"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWithCause"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/failCause"));

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Reads the first `n` values from the stream and uses them to choose the
 * pipeline that will be used for the remainder of the stream.
 *
 * @tsplus static effect/core/stream/Stream.Aspects branchAfter
 * @tsplus pipeable effect/core/stream/Stream branchAfter
 */
function branchAfter(n, f) {
  return self => {
    void 0;
    return new _StreamInternal.StreamInternal(tsplus_module_3.suspend(() => tsplus_module_2.pipeTo(collecting(tsplus_module_1.empty(), n, f))(self.channel)));
  };
}

function collecting(buffer, n, f) {
  return tsplus_module_12.readWithCause(chunk => {
    const newBuffer = tsplus_module_4.concat(chunk)(buffer);

    if (newBuffer.length >= n) {
      const [inputs, inputs1] = tsplus_module_5.splitAt(n)(newBuffer);
      const pipeline = f(inputs);
      const stream = pipeline(tsplus_module_6.fromChunk(inputs1));
      void 0;
      return tsplus_module_7.flatMap(() => emitting(pipeline))(stream.channel);
    }

    return collecting(newBuffer, n, f);
  }, cause => tsplus_module_8.failCauseSync(() => cause), () => {
    if (tsplus_module_9.isEmpty(buffer)) {
      return tsplus_module_10.unit;
    }

    const pipeline = f(buffer);
    const stream = pipeline(tsplus_module_11.empty);
    void 0;
    return stream.channel;
  });
}

function emitting(pipeline) {
  return tsplus_module_12.readWithCause(chunk => {
    const stream = pipeline(tsplus_module_6.fromChunk(chunk));
    void 0;
    return tsplus_module_7.flatMap(() => emitting(pipeline))(stream.channel);
  }, cause => tsplus_module_13.failCause(cause), () => tsplus_module_10.unit);
}
//# sourceMappingURL=branchAfter.js.map