import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Fan out the stream, producing a dynamic number of streams that have the
 * same elements as this stream. The driver stream will only ever advance the
 * `maximumLag` chunks before the slowest downstream stream.
 * @tsplus static effect/core/stream/Stream.Aspects broadcastDynamic
 * @tsplus pipeable effect/core/stream/Stream broadcastDynamic
 * @tsplus location "@effect/core/stream/Stream/operations/broadcastDynamic"
 */
export declare function broadcastDynamic(maximumLag: number): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R, never, import("../definition").Stream<never, E, A>>;
//# sourceMappingURL=broadcastDynamic.d.ts.map