import { Stream } from "@effect/core/stream/Stream/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Allows a faster producer to progress independently of a slower consumer by
 * buffering up to `capacity` elements in a queue.
 *
 * This combinator destroys the chunking structure. It's recommended to use
 * rechunk afterwards.
 *
 * Note: prefer capacities that are powers of 2 for better performance.
 * @tsplus static effect/core/stream/Stream.Aspects buffer
 * @tsplus pipeable effect/core/stream/Stream buffer
 * @tsplus location "@effect/core/stream/Stream/operations/buffer"
 */
export declare function buffer(capacity: number): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R, E, A>;
//# sourceMappingURL=buffer.d.ts.map