import { Stream } from "@effect/core/stream/Stream/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Allows a faster producer to progress independently of a slower consumer by
 * buffering up to `capacity` chunks in a queue.
 *
 * Note: prefer capacities that are powers of 2 for better performance.
 * @tsplus static effect/core/stream/Stream.Aspects bufferChunks
 * @tsplus pipeable effect/core/stream/Stream bufferChunks
 * @tsplus location "@effect/core/stream/Stream/operations/bufferChunks"
 */
export declare function bufferChunks(capacity: number): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R, E, A>;
//# sourceMappingURL=bufferChunks.d.ts.map