import { Cause } from "@effect/core/io/Cause/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Switches over to the stream produced by the provided function in case this
 * one fails. Allows recovery from all causes of failure, including
 * interruption if the stream is uninterruptible.
 * @tsplus static effect/core/stream/Stream.Aspects catchAllCause
 * @tsplus pipeable effect/core/stream/Stream catchAllCause
 * @tsplus location "@effect/core/stream/Stream/operations/catchAllCause"
 */
export declare function catchAllCause<E, R2, E2, A2>(f: (cause: Cause<E>) => Stream<R2, E2, A2>): <R, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2, A2 | A>;
//# sourceMappingURL=catchAllCause.d.ts.map