import { Cause } from "@effect/core/io/Cause/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Switches over to the stream produced by the provided function in case this
 * one fails with some errors. Allows recovery from all causes of failure,
 * including interruption if the stream is uninterruptible.
 * @tsplus static effect/core/stream/Stream.Aspects catchSomeCause
 * @tsplus pipeable effect/core/stream/Stream catchSomeCause
 * @tsplus location "@effect/core/stream/Stream/operations/catchSomeCause"
 */
export declare function catchSomeCause<E, R2, E2, A2>(pf: (cause: Cause<E>) => Maybe<Stream<R2, E2, A2>>): <R, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E | E2, A2 | A>;
//# sourceMappingURL=catchSomeCause.d.ts.map