import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Returns a new stream that only emits elements that are not equal to the
 * previous element emitted, using the specified effectual function to
 * determine whether two elements are equal.
 * @tsplus static effect/core/stream/Stream.Aspects changesWithEffect
 * @tsplus pipeable effect/core/stream/Stream changesWithEffect
 * @tsplus location "@effect/core/stream/Stream/operations/changesWithEffect"
 */
export declare function changesWithEffect<A, R2, E2>(f: (x: A, y: A) => Effect<R2, E2, boolean>): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, A>;
//# sourceMappingURL=changesWithEffect.d.ts.map