import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Effectfully transforms all elements of the stream for as long as the
 * specified partial function is defined.
 * @tsplus static effect/core/stream/Stream.Aspects collectWhileEffect
 * @tsplus pipeable effect/core/stream/Stream collectWhileEffect
 * @tsplus location "@effect/core/stream/Stream/operations/collectWhileEffect"
 */
export declare function collectWhileEffect<A, R2, E2, A2>(pf: (a: A) => Maybe<Effect<R2, E2, A2>>): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, A2>;
//# sourceMappingURL=collectWhileEffect.d.ts.map