import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Exit } from "@effect/core/io/Exit/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * Combines the elements from this stream and the specified stream by
 * repeatedly applying the function `f` to extract an element using both sides
 * and conceptually "offer" it to the destination stream. `f` can maintain
 * some internal state to control the combining process, with the initial
 * state being specified by `s`.
 *
 * Where possible, prefer `Stream.combineChunks` for a more efficient
 * implementation.
 * @tsplus static effect/core/stream/Stream.Aspects combine
 * @tsplus pipeable effect/core/stream/Stream combine
 * @tsplus location "@effect/core/stream/Stream/operations/combine"
 */
export declare function combine<R, E, A, R2, E2, A2, S, A3>(that: Stream<R2, E2, A2>, s: S, f: (s: S, pullLeft: Effect<R, Maybe<E>, A>, pullRight: Effect<R2, Maybe<E2>, A2>) => Effect<R | R2, never, Exit<Maybe<E | E2>, readonly [A3, S]>>): (self: Stream<R, E, A>) => Stream<R | R2, E | E2, A3>;
//# sourceMappingURL=combine.d.ts.map