"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.combine = combine;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/done"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unsome"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/unfoldEffect"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/Handoff"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipRight"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/writeChunk"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/concatMap"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/runScoped"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/forkScoped"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unwrapScoped"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/succeed"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fromEffect"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Cause/operations/map"));

var tsplus_module_19 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/failCause"));

var tsplus_module_20 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/fail"));

var tsplus_module_21 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWithCause"));

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Combines the elements from this stream and the specified stream by
 * repeatedly applying the function `f` to extract an element using both sides
 * and conceptually "offer" it to the destination stream. `f` can maintain
 * some internal state to control the combining process, with the initial
 * state being specified by `s`.
 *
 * Where possible, prefer `Stream.combineChunks` for a more efficient
 * implementation.
 *
 * @tsplus static effect/core/stream/Stream.Aspects combine
 * @tsplus pipeable effect/core/stream/Stream combine
 */
function combine(that, s, f) {
  return self => new _StreamInternal.StreamInternal(tsplus_module_13.unwrapScoped(tsplus_module_3.flatMap(left => tsplus_module_3.flatMap(right => tsplus_module_3.flatMap(latchL => tsplus_module_3.flatMap(latchR => {
    void 0;
    return tsplus_module_3.flatMap(() => {
      void 0;
      return tsplus_module_12.map(() => {
        const pullLeft = tsplus_module_6.zipRight(tsplus_module_3.flatMap(exit => tsplus_module_1.done(exit))(tsplus_module_5.take(left)))(tsplus_module_5.offer(undefined)(latchL));
        const pullRight = tsplus_module_6.zipRight(tsplus_module_3.flatMap(exit => tsplus_module_1.done(exit))(tsplus_module_5.take(right)))(tsplus_module_5.offer(undefined)(latchR));
        const stream = tsplus_module_4.unfoldEffect(s, s => tsplus_module_3.flatMap(exit => tsplus_module_2.unsome(tsplus_module_1.done(exit)))(f(s, pullLeft, pullRight)));
        void 0;
        return stream.channel;
      })(tsplus_module_11.forkScoped(tsplus_module_10.runScoped(tsplus_module_9.pipeTo(producer(right, latchR))(tsplus_module_8.concatMap(chunk => tsplus_module_7.writeChunk(chunk))(that.channel)))));
    })(tsplus_module_11.forkScoped(tsplus_module_10.runScoped(tsplus_module_9.pipeTo(producer(left, latchL))(tsplus_module_8.concatMap(chunk => tsplus_module_7.writeChunk(chunk))(self.channel)))));
  })(tsplus_module_5.make()))(tsplus_module_5.make()))(tsplus_module_5.make()))(tsplus_module_5.make())));
}

function producer(handoff, latch) {
  return tsplus_module_16.flatMap(() => tsplus_module_21.readWithCause(value => tsplus_module_16.flatMap(() => producer(handoff, latch))(tsplus_module_15.fromEffect(tsplus_module_5.offer(tsplus_module_14.succeed(value))(handoff))), cause => tsplus_module_15.fromEffect(tsplus_module_5.offer(tsplus_module_19.failCause(tsplus_module_18.map(tsplus_module_17.some)(cause)))(handoff)), () => tsplus_module_16.flatMap(() => producer(handoff, latch))(tsplus_module_15.fromEffect(tsplus_module_5.offer(tsplus_module_20.fail(tsplus_module_17.none))(handoff)))))(tsplus_module_15.fromEffect(tsplus_module_5.take(latch)));
}
//# sourceMappingURL=combine.js.map