"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.combineChunks = combineChunks;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/done"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/unsome"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/unfoldChunkEffect"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Take/operations/done"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/Handoff"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipRight"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/runScoped"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/forkScoped"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unwrapScoped"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Take/operations/chunk"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fromEffect"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Take/operations/failCause"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Take/operations/end"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWithCause"));

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Combines the chunks from this stream and the specified stream by repeatedly
 * applying the function `f` to extract a chunk using both sides and
 * conceptually "offer" it to the destination stream. `f` can maintain some
 * internal state to control the combining process, with the initial state
 * being specified by `s`.
 *
 * @tsplus static effect/core/stream/Stream.Aspects combineChunks
 * @tsplus pipeable effect/core/stream/Stream combineChunks
 */
function combineChunks(that, s, f) {
  return self => new _StreamInternal.StreamInternal(tsplus_module_12.unwrapScoped(tsplus_module_3.flatMap(left => tsplus_module_3.flatMap(right => tsplus_module_3.flatMap(latchL => tsplus_module_3.flatMap(latchR => {
    void 0;
    return tsplus_module_3.flatMap(() => {
      void 0;
      return tsplus_module_11.map(() => {
        const pullLeft = tsplus_module_7.zipRight(tsplus_module_3.flatMap(take => tsplus_module_5.done(take))(tsplus_module_6.take(left)))(tsplus_module_6.offer(undefined)(latchL));
        const pullRight = tsplus_module_7.zipRight(tsplus_module_3.flatMap(take => tsplus_module_5.done(take))(tsplus_module_6.take(right)))(tsplus_module_6.offer(undefined)(latchR));
        const stream = tsplus_module_4.unfoldChunkEffect(s, s => tsplus_module_3.flatMap(exit => tsplus_module_2.unsome(tsplus_module_1.done(exit)))(f(s, pullLeft, pullRight)));
        void 0;
        return stream.channel;
      })(tsplus_module_10.forkScoped(tsplus_module_9.runScoped(tsplus_module_8.pipeTo(producer(right, latchR))(that.channel))));
    })(tsplus_module_10.forkScoped(tsplus_module_9.runScoped(tsplus_module_8.pipeTo(producer(left, latchL))(self.channel))));
  })(tsplus_module_6.make()))(tsplus_module_6.make()))(tsplus_module_6.make()))(tsplus_module_6.make())));
}

function producer(handoff, latch) {
  return tsplus_module_15.flatMap(() => tsplus_module_18.readWithCause(chunk => tsplus_module_15.flatMap(() => producer(handoff, latch))(tsplus_module_14.fromEffect(tsplus_module_6.offer(tsplus_module_13.chunk(chunk))(handoff))), cause => tsplus_module_14.fromEffect(tsplus_module_6.offer(tsplus_module_16.failCause(cause))(handoff)), () => tsplus_module_15.flatMap(() => producer(handoff, latch))(tsplus_module_14.fromEffect(tsplus_module_6.offer(tsplus_module_17.end)(handoff)))))(tsplus_module_14.fromEffect(tsplus_module_6.take(latch)));
}
//# sourceMappingURL=combineChunks.js.map