import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Composes this stream with the specified stream to create a cartesian
 * product of elements. The `that` stream would be run multiple times, for
 * every element in the `this` stream.
 *
 * See also `Stream.zip` for the more common point-wise variant.
 * @tsplus static effect/core/stream/Stream.Aspects cross
 * @tsplus pipeable effect/core/stream/Stream cross
 * @tsplus location "@effect/core/stream/Stream/operations/cross"
 */
export declare function cross<R2, E2, A2>(that: Stream<R2, E2, A2>): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, readonly [A, A2]>;
//# sourceMappingURL=cross.d.ts.map