import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Composes this stream with the specified stream to create a cartesian
 * product of elements. The `that` stream would be run multiple times, for
 * every element in the `this` stream.
 *
 * See also `Stream.zip` for the more common point-wise variant.
 * @tsplus static effect/core/stream/Stream.Aspects crossFlatten
 * @tsplus pipeable effect/core/stream/Stream crossFlatten
 * @tsplus location "@effect/core/stream/Stream/operations/crossFlatten"
 */
export declare function crossFlatten<R2, E2, A2>(that: Stream<R2, E2, A2>): <R, E, A extends readonly any[]>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, readonly [...A, A2]>;
//# sourceMappingURL=crossFlatten.d.ts.map