import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Composes this stream with the specified stream to create a cartesian
 * product of elements, but keeps only elements from this stream. The `that`
 * stream would be run multiple times, for every element in the `this` stream.
 *
 * See also `Stream.zipLeft` for the more common point-wise variant.
 * @tsplus pipeable-operator effect/core/stream/Stream <
 * @tsplus static effect/core/stream/Stream.Aspects crossLeft
 * @tsplus pipeable effect/core/stream/Stream crossLeft
 * @tsplus location "@effect/core/stream/Stream/operations/crossLeft"
 */
export declare function crossLeft<R2, E2, A2>(that: Stream<R2, E2, A2>): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, A>;
//# sourceMappingURL=crossLeft.d.ts.map