import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Composes this stream with the specified stream to create a cartesian
 * product of elements with a specified function. The `that` stream would be
 * run multiple times, for every element in the `this` stream.
 *
 * See also `Stream.zip` for the more common point-wise variant.
 * @tsplus static effect/core/stream/Stream.Aspects crossWith
 * @tsplus pipeable effect/core/stream/Stream crossWith
 * @tsplus location "@effect/core/stream/Stream/operations/crossWith"
 */
export declare function crossWith<R2, E2, B, A, C>(that: Stream<R2, E2, B>, f: (a: A, b: B) => C): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, C>;
//# sourceMappingURL=crossWith.d.ts.map