"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.debounce = debounce;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/runScoped"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/forkScoped"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/scoped"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/crossRight"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unwrap"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/failCause"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unit"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/Handoff"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/join"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/interrupt"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/as"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Exit/operations/fold"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_19 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/raceWith"));

var tsplus_module_20 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/single"));

var tsplus_module_21 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/HandoffSignal"));

var tsplus_module_22 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fromEffect"));

var tsplus_module_23 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/last"));

var tsplus_module_24 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fold"));

var tsplus_module_25 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/SinkEndReason"));

var tsplus_module_26 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWithCause"));

var tsplus_module_27 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Clock/operations/sleep"));

var tsplus_module_28 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

var tsplus_module_29 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/transplant"));

var tsplus_module_30 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/unwrap"));

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

class NotStarted {
  constructor() {
    this._tag = "NotStarted";
  }

}

class Previous {
  constructor(fiber) {
    this.fiber = fiber;
    this._tag = "Previous";
  }

}

class Current {
  constructor(fiber) {
    this.fiber = fiber;
    this._tag = "Current";
  }

}
/**
 * Delays the emission of values by holding new values for a set duration. If
 * no new values arrive during that time the value is emitted, however if a
 * new value is received during the holding period the previous value is
 * discarded and the process is repeated with the new value.
 *
 * This operator is useful if you have a stream of "bursty" events which
 * eventually settle down and you only need the final event of the burst.
 *
 * @example A search engine may only want to initiate a search after a user has
 * paused typing so as to not prematurely recommend results.
 *
 * @tsplus static effect/core/stream/Stream.Aspects debounce
 * @tsplus pipeable effect/core/stream/Stream debounce
 */


function debounce(duration) {
  return self => tsplus_module_30.unwrap(tsplus_module_29.transplant(grafter => tsplus_module_10.map(handoff => {
    function enqueue(last) {
      return tsplus_module_10.map(fiber => consumer(new Previous(fiber)))(grafter(tsplus_module_28.fork(tsplus_module_13.as(last)(tsplus_module_27.sleep(duration)))));
    }

    const producer = tsplus_module_26.readWithCause(input => tsplus_module_24.fold(() => producer, last => tsplus_module_15.flatMap(() => producer)(tsplus_module_22.fromEffect(tsplus_module_9.offer(tsplus_module_21.emit(tsplus_module_20.single(last)))(handoff))))(tsplus_module_23.last(input)), cause => tsplus_module_22.fromEffect(tsplus_module_9.offer(tsplus_module_21.halt(cause))(handoff)), () => tsplus_module_22.fromEffect(tsplus_module_9.offer(tsplus_module_21.end(tsplus_module_25.upstreamEnd))(handoff)));

    function consumer(state) {
      return tsplus_module_6.unwrap((() => {
        switch (state._tag) {
          case "NotStarted":
            {
              return tsplus_module_10.map(signal => {
                switch (signal._tag) {
                  case "Emit":
                    {
                      return tsplus_module_6.unwrap(enqueue(signal.elements));
                    }

                  case "Halt":
                    {
                      return tsplus_module_7.failCause(signal.error);
                    }

                  case "End":
                    {
                      return tsplus_module_8.unit;
                    }
                }
              })(tsplus_module_9.take(handoff));
            }

          case "Current":
            {
              return tsplus_module_10.map(signal => {
                switch (signal._tag) {
                  case "Emit":
                    {
                      return tsplus_module_6.unwrap(enqueue(signal.elements));
                    }

                  case "Halt":
                    {
                      return tsplus_module_7.failCause(signal.error);
                    }

                  case "End":
                    {
                      return tsplus_module_8.unit;
                    }
                }
              })(tsplus_module_11.join(state.fiber));
            }

          case "Previous":
            {
              return tsplus_module_19.raceWith(tsplus_module_9.take(handoff), (exit, current) => tsplus_module_17.fold(cause => tsplus_module_13.as(tsplus_module_7.failCause(cause))(tsplus_module_12.interrupt(current)), chunk => tsplus_module_16.succeed(tsplus_module_15.flatMap(() => consumer(new Current(current)))(tsplus_module_14.write(chunk))))(exit), (exit, previous) => tsplus_module_17.fold(cause => tsplus_module_13.as(tsplus_module_7.failCause(cause))(tsplus_module_12.interrupt(previous)), signal => {
                switch (signal._tag) {
                  case "Emit":
                    {
                      return tsplus_module_18.flatMap(() => enqueue(signal.elements))(tsplus_module_12.interrupt(previous));
                    }

                  case "Halt":
                    {
                      return tsplus_module_13.as(tsplus_module_7.failCause(signal.error))(tsplus_module_12.interrupt(previous));
                    }

                  case "End":
                    {
                      return tsplus_module_10.map(chunk => tsplus_module_15.flatMap(() => tsplus_module_8.unit)(tsplus_module_14.write(chunk)))(tsplus_module_11.join(previous));
                    }
                }
              })(exit))(tsplus_module_11.join(state.fiber));
            }
        }
      })());
    }

    void 0;
    return tsplus_module_5.crossRight(new _StreamInternal.StreamInternal(consumer(new NotStarted())))(tsplus_module_4.scoped(tsplus_module_3.forkScoped(tsplus_module_2.runScoped(tsplus_module_1.pipeTo(producer)(self.channel)))));
  })(tsplus_module_9.make())));
}
//# sourceMappingURL=debounce.js.map