import { Stream } from "@effect/core/stream/Stream/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * If this stream is empty, produce the specified element or chunk of elements,
 * or switch to the specified stream.
 * @tsplus static effect/core/stream/Stream.Aspects defaultIfEmpty
 * @tsplus pipeable effect/core/stream/Stream defaultIfEmpty
 * @tsplus location "@effect/core/stream/Stream/operations/defaultIfEmpty"
 */
export declare function defaultIfEmpty<R1, E1, A1>(stream: Stream<R1, E1, A1>): <R, E, A>(self: Stream<R, E, A>) => Stream<R | R1, E | E1, A | A1>;
export declare function defaultIfEmpty<A1>(chunk: Chunk<A1>): <R, E, A>(self: Stream<R, E, A>) => Stream<R, E, A | A1>;
export declare function defaultIfEmpty<A1>(value: A1): <R, E, A>(self: Stream<R, E, A>) => Stream<R, E, A | A1>;
//# sourceMappingURL=defaultIfEmpty.d.ts.map