import { Stream } from "@effect/core/stream/Stream/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Returns a stream whose failures and successes have been lifted into an
 * `Either`. The resulting stream cannot fail, because the failures have been
 * exposed as part of the `Either` success case.
 * @note The stream will end as soon as the first error occurs.
 * @tsplus getter effect/core/stream/Stream either
 * @tsplus location "@effect/core/stream/Stream/operations/either"
 */
export declare function either<R, E, A>(self: Stream<R, E, A>): Stream<R, never, Either<E, A>>;
//# sourceMappingURL=either.d.ts.map