import { Refinement } from "@tsplus/stdlib/data/Function";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Filters the elements emitted by this stream using the provided function.
 * @tsplus static effect/core/stream/Stream.Aspects filter
 * @tsplus pipeable effect/core/stream/Stream filter
 * @tsplus location "@effect/core/stream/Stream/operations/filter"
 */
export declare function filter<A, B extends A>(f: Refinement<A, B>): <R, E>(self: Stream<R, E, A>) => Stream<R, E, B>;
export declare function filter<A>(f: Predicate<A>): <R, E>(self: Stream<R, E, A>) => Stream<R, E, A>;
//# sourceMappingURL=filter.d.ts.map