import { Refinement } from "@tsplus/stdlib/data/Function";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Filters this stream by the specified predicate, removing all elements for
 * which the predicate evaluates to true.
 * @tsplus static effect/core/stream/Stream.Aspects filterNot
 * @tsplus pipeable effect/core/stream/Stream filterNot
 * @tsplus location "@effect/core/stream/Stream/operations/filterNot"
 */
export declare function filterNot<A, B extends A>(f: Refinement<A, B>): <R, E>(self: Stream<R, E, A>) => Stream<R, E, A>;
export declare function filterNot<A>(f: Predicate<A>): <R, E>(self: Stream<R, E, A>) => Stream<R, E, A>;
//# sourceMappingURL=filterNot.d.ts.map