import { Refinement } from "@tsplus/stdlib/data/Function";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Finds the first element emitted by this stream that satisfies the provided
 * predicate.
 * @tsplus static effect/core/stream/Stream.Aspects find
 * @tsplus pipeable effect/core/stream/Stream find
 * @tsplus location "@effect/core/stream/Stream/operations/find"
 */
export declare function find<A, B extends A>(f: Refinement<A, B>): <R, E>(self: Stream<R, E, A>) => Stream<R, E, B>;
export declare function find<A>(f: Predicate<A>): <R, E>(self: Stream<R, E, A>) => Stream<R, E, A>;
//# sourceMappingURL=find.d.ts.map