import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Maps each element of this stream to another stream and returns the
 * non-deterministic merge of those streams, executing up to `n` inner streams
 * concurrently. When a new stream is created from an element of the source
 * stream, the oldest executing stream is cancelled. Up to `bufferSize`
 * elements of the produced streams may be buffered in memory by this
 * operator.
 * @tsplus static effect/core/stream/Stream.Aspects flatMapParSwitch
 * @tsplus pipeable effect/core/stream/Stream flatMapParSwitch
 * @tsplus location "@effect/core/stream/Stream/operations/flatMapParSwitch"
 */
export declare function flatMapParSwitch<R2, E2, A, B>(n: number, f: (a: A) => Stream<R2, E2, B>, bufferSize?: number): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, B>;
//# sourceMappingURL=flatMapParSwitch.d.ts.map