import { Stream } from "@effect/core/stream/Stream/definition";
import { Exit } from "@effect/core/io/Exit/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Unwraps `Exit` values that also signify end-of-stream by failing with `None`.
 *
 * For `Exit<E, A>` values that do not signal end-of-stream, prefer:
 *
 * ```typescript
 * stream.mapEffect((exit) => Effect.done(exit))
 * ```
 * @tsplus getter effect/core/stream/Stream flattenExitMaybe
 * @tsplus location "@effect/core/stream/Stream/operations/flattenExitMaybe"
 */
export declare function flattenExitMaybe<R, E, A>(self: Stream<R, E, Exit<Maybe<E>, A>>): Stream<R, E, A>;
//# sourceMappingURL=flattenExitMaybe.d.ts.map