import { Hub } from "@effect/core/io/Hub/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Creates a stream from a subscription to a hub in the context of a scoped
 * effect. The scoped effect describes subscribing to receive messages from
 * the hub while the stream describes taking messages from the hub.
 * @tsplus static effect/core/stream/Stream.Ops fromChunkHubScoped
 * @tsplus location "@effect/core/stream/Stream/operations/fromChunkHubScoped"
 */
export declare function fromChunkHubScoped<A>(hub: Hub<Chunk<A>>): Effect<Scope, never, Stream<never, never, A>>;
//# sourceMappingURL=fromChunkHubScoped.d.ts.map