import { Hub } from "@effect/core/io/Hub/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Creates a stream from a subscription to a hub in the context of a scoped
 * effect. The scoped effect describes subscribing to receive messages from
 * the hub while the stream describes taking messages from the hub.
 *
 * The hub will be shut down once the stream is closed.
 * @param maxChunkSize   Maximum number of queued elements to put in one chunk in the stream.
 * @tsplus static effect/core/stream/Stream.Ops fromHubScopedWithShutdown
 * @tsplus location "@effect/core/stream/Stream/operations/fromHubScopedWithShutdown"
 */
export declare function fromHubScopedWithShutdown<A>(hub: Hub<A>, maxChunkSize?: number): Effect<Scope, never, Stream<never, never, A>>;
//# sourceMappingURL=fromHubScopedWithShutdown.d.ts.map