import { Hub } from "@effect/core/io/Hub/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Creates a stream from a subscription to a hub.
 *
 * The hub will be shut down once the stream is closed.
 * @param maxChunkSize   Maximum number of queued elements to put in one chunk in the stream.
 * @tsplus static effect/core/stream/Stream.Ops fromHubWithShutdown
 * @tsplus location "@effect/core/stream/Stream/operations/fromHubWithShutdown"
 */
export declare function fromHubWithShutdown<A>(hub: Hub<A>, maxChunkSize?: number): Stream<never, never, A>;
//# sourceMappingURL=fromHubWithShutdown.d.ts.map