import { Dequeue } from "@effect/core/io/Queue/definition/common";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Creates a stream from a `Queue` of values. The queue will be shutdown once
 * the stream is closed.
 * @param maxChunkSize   Maximum number of queued elements to put in one chunk in the stream.
 * @tsplus static effect/core/stream/Stream.Ops fromQueueWithShutdown
 * @tsplus location "@effect/core/stream/Stream/operations/fromQueueWithShutdown"
 */
export declare function fromQueueWithShutdown<A>(queue: Dequeue<A>, maxChunkSize?: number): Stream<never, never, A>;
//# sourceMappingURL=fromQueueWithShutdown.d.ts.map