"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.groupAdjacentBy = groupAdjacentBy;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/failCause"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unit"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/single"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fold"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWithCause"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/append"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/reduce"));

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Creates a stream that groups on adjacent keys, calculated by function f.
 *
 * @tsplus static effect/core/stream/Stream.Aspects groupAdjacentBy
 * @tsplus pipeable effect/core/stream/Stream groupAdjacentBy
 */
function groupAdjacentBy(f) {
  return self => {
    void 0;
    return new _StreamInternal.StreamInternal(tsplus_module_2.pipeTo(chunkAdjacent(tsplus_module_1.none, f))(self.channel));
  };
}

function chunkAdjacent(buffer, f) {
  return tsplus_module_9.readWithCause(chunk => {
    const [outputs, newBuffer] = go(chunk, buffer, f);
    return tsplus_module_4.flatMap(() => chunkAdjacent(newBuffer, f))(tsplus_module_3.write(outputs));
  }, cause => tsplus_module_5.failCause(cause), () => tsplus_module_8.fold(() => tsplus_module_6.unit, o => tsplus_module_3.write(tsplus_module_7.single(o)))(buffer));
}

function go(input, state, f) {
  return tsplus_module_12.reduce([tsplus_module_10.empty(), state], ([os, o], a) => tsplus_module_8.fold(() => [os, tsplus_module_1.some([f(a), tsplus_module_7.single(a)])], agg => {
    const k2 = f(a);
    const [k, aggregated] = agg;

    if (k === k2) {
      return [os, tsplus_module_1.some([k, tsplus_module_11.append(a)(aggregated)])];
    } else {
      return [tsplus_module_11.append(agg)(os), tsplus_module_1.some([k2, tsplus_module_7.single(a)])];
    }
  })(o))(input);
}
//# sourceMappingURL=groupAdjacentBy.js.map