import { Duration } from "@tsplus/stdlib/data/Duration";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Specialized version of haltWhen which halts the evaluation of this stream
 * after the given duration.
 *
 * An element in the process of being pulled will not be interrupted when the
 * given duration completes. See `interruptAfter` for this behavior.
 * @tsplus static effect/core/stream/Stream.Aspects haltAfter
 * @tsplus pipeable effect/core/stream/Stream haltAfter
 * @tsplus location "@effect/core/stream/Stream/operations/haltAfter"
 */
export declare function haltAfter(duration: Duration): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R, E, A>;
//# sourceMappingURL=haltAfter.d.ts.map