import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Fiber } from "@effect/core/io/Fiber/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Halts the evaluation of this stream when the provided IO completes. The
 * given IO will be forked as part of the returned stream, and its success
 * will be discarded.
 *
 * An element in the process of being pulled will not be interrupted when the
 * IO completes. See `interruptWhen` for this behavior.
 *
 * If the IO completes with a failure, the stream will emit that failure.
 * @tsplus static effect/core/stream/Stream.Aspects haltWhen
 * @tsplus pipeable effect/core/stream/Stream haltWhen
 * @tsplus location "@effect/core/stream/Stream/operations/haltWhen"
 */
export declare function haltWhen<R2, E2, Z>(io: Effect<R2, E2, Z>): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, A>;
//# sourceMappingURL=haltWhen.d.ts.map