import { Deferred } from "@effect/core/io/Deferred/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Halts the evaluation of this stream when the provided deferred resolves.
 *
 * If the deferred completes with a failure, the stream will emit that failure.
 * @tsplus static effect/core/stream/Stream.Aspects haltWhenDeferred
 * @tsplus pipeable effect/core/stream/Stream haltWhenDeferred
 * @tsplus location "@effect/core/stream/Stream/operations/haltWhenDeferred"
 */
export declare function haltWhenDeferred<E2, Z>(deferred: Deferred<E2, Z>): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R, E2 | E, A>;
//# sourceMappingURL=haltWhenDeferred.d.ts.map