import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Interleaves this stream and the specified stream deterministically by
 * alternating pulling values from this stream and the specified stream. When
 * one stream is exhausted all remaining values in the other stream will be
 * pulled.
 * @tsplus static effect/core/stream/Stream.Aspects interleave
 * @tsplus pipeable effect/core/stream/Stream interleave
 * @tsplus location "@effect/core/stream/Stream/operations/interleave"
 */
export declare function interleave<R2, E2, A2>(that: Stream<R2, E2, A2>): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, A2 | A>;
//# sourceMappingURL=interleave.d.ts.map