import { Stream } from "@effect/core/stream/Stream/definition";
import { Take } from "@effect/core/stream/Take/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Combines this stream and the specified stream deterministically using the
 * stream of boolean values `b` to control which stream to pull from next.
 * `true` indicates to pull from this stream and `false` indicates to pull
 * from the specified stream. Only consumes as many elements as requested by
 * `b`. If either this stream or the specified stream are exhausted further
 * requests for values from that stream will be ignored.
 * @tsplus static effect/core/stream/Stream.Aspects interleaveWith
 * @tsplus pipeable effect/core/stream/Stream interleaveWith
 * @tsplus location "@effect/core/stream/Stream/operations/interleaveWith"
 */
export declare function interleaveWith<R2, E2, A2, R3, E3>(that: Stream<R2, E2, A2>, b: Stream<R3, E3, boolean>): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R3 | R, E2 | E3 | E, A2 | A>;
//# sourceMappingURL=interleaveWith.d.ts.map