"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.interleaveWith = interleaveWith;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/writeChunk"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/concatMap"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/runScoped"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/forkScoped"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/Handoff"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unwrapScoped"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Take/operations/single"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fromEffect"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Take/operations/failCause"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Take/operations/end"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWithCause"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unit"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/failCause"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_19 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Take/operations/fold"));

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Combines this stream and the specified stream deterministically using the
 * stream of boolean values `b` to control which stream to pull from next.
 * `true` indicates to pull from this stream and `false` indicates to pull
 * from the specified stream. Only consumes as many elements as requested by
 * `b`. If either this stream or the specified stream are exhausted further
 * requests for values from that stream will be ignored.
 *
 * @tsplus static effect/core/stream/Stream.Aspects interleaveWith
 * @tsplus pipeable effect/core/stream/Stream interleaveWith
 */
function interleaveWith(that, b) {
  return self => {
    void 0;
    return new _StreamInternal.StreamInternal(tsplus_module_9.unwrapScoped(tsplus_module_7.flatMap(left => tsplus_module_7.flatMap(right => tsplus_module_7.flatMap(() => {
      void 0;
      return tsplus_module_6.map(() => {
        void 0;
        return tsplus_module_3.pipeTo(process(left, right, false, false))(tsplus_module_2.concatMap(tsplus_module_1.writeChunk)(b.channel));
      })(tsplus_module_5.forkScoped(tsplus_module_4.runScoped(tsplus_module_3.pipeTo(producer(right))(tsplus_module_2.concatMap(tsplus_module_1.writeChunk)(that.channel)))));
    })(tsplus_module_5.forkScoped(tsplus_module_4.runScoped(tsplus_module_3.pipeTo(producer(left))(tsplus_module_2.concatMap(tsplus_module_1.writeChunk)(self.channel))))))(tsplus_module_8.make()))(tsplus_module_8.make())));
  };
}

function producer(handoff) {
  return tsplus_module_15.readWithCause(value => tsplus_module_12.flatMap(() => producer(handoff))(tsplus_module_11.fromEffect(tsplus_module_8.offer(tsplus_module_10.single(value))(handoff))), cause => tsplus_module_11.fromEffect(tsplus_module_8.offer(tsplus_module_13.failCause(cause))(handoff)), () => tsplus_module_11.fromEffect(tsplus_module_8.offer(tsplus_module_14.end)(handoff)));
}

function process(left, right, leftDone, rightDone) {
  return tsplus_module_15.readWithCause(bool => {
    if (bool && !leftDone) {
      return tsplus_module_12.flatMap(take => tsplus_module_19.fold(rightDone ? tsplus_module_16.unit : process(left, right, true, rightDone), cause => tsplus_module_17.failCause(cause), chunk => tsplus_module_12.flatMap(() => process(left, right, leftDone, rightDone))(tsplus_module_18.write(chunk)))(take))(tsplus_module_11.fromEffect(tsplus_module_8.take(left)));
    }

    if (!bool && !rightDone) {
      return tsplus_module_12.flatMap(take => tsplus_module_19.fold(leftDone ? tsplus_module_16.unit : process(left, right, leftDone, true), cause => tsplus_module_17.failCause(cause), chunk => tsplus_module_12.flatMap(() => process(left, right, leftDone, rightDone))(tsplus_module_18.write(chunk)))(take))(tsplus_module_11.fromEffect(tsplus_module_8.take(right)));
    }

    return process(left, right, leftDone, rightDone);
  }, cause => tsplus_module_17.failCause(cause), () => tsplus_module_16.unit);
}
//# sourceMappingURL=interleaveWith.js.map