import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Interrupts the evaluation of this stream when the provided effect completes.
 * The given effect will be forked as part of this stream, and its success will
 * be discarded. This combinator will also interrupt any in-progress element
 * being pulled from upstream.
 *
 * If the effect completes with a failure before the stream completes, the
 * returned stream will emit that failure.
 * @tsplus static effect/core/stream/Stream.Aspects interruptWhen
 * @tsplus pipeable effect/core/stream/Stream interruptWhen
 * @tsplus location "@effect/core/stream/Stream/operations/interruptWhen"
 */
export declare function interruptWhen<R2, E2, Z>(effect: Effect<R2, E2, Z>): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, A>;
//# sourceMappingURL=interruptWhen.d.ts.map