import { Deferred } from "@effect/core/io/Deferred/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Interrupts the evaluation of this stream when the provided deferred
 * resolves. This combinator will also interrupt any in-progress element being
 * pulled from upstream.
 *
 * If the deferred completes with a failure, the stream will emit that failure.
 * @tsplus static effect/core/stream/Stream.Aspects interruptWhenDeferred
 * @tsplus pipeable effect/core/stream/Stream interruptWhenDeferred
 * @tsplus location "@effect/core/stream/Stream/operations/interruptWhenDeferred"
 */
export declare function interruptWhenDeferred<E2, Z>(promise: Deferred<E2, Z>): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R, E2 | E, A>;
//# sourceMappingURL=interruptWhenDeferred.d.ts.map