import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Returns an infinite stream of iterative function application: `a`, `f(a)`,
 * `f(f(a))`, `f(f(f(a)))`, ...
 * @tsplus static effect/core/stream/Stream.Ops iterate
 * @tsplus location "@effect/core/stream/Stream/operations/iterate"
 */
export declare function iterate<A>(a: A, f: (a: A) => A): Stream<never, never, A>;
//# sourceMappingURL=iterate.d.ts.map