import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Maps over elements of the stream with the specified effectful function,
 * executing up to `n` invocations of `f` concurrently. Transformed elements
 * will be emitted in the original order.
 * @note This combinator destroys the chunking structure. It's recommended to use
rechunk afterwards.
 * @tsplus static effect/core/stream/Stream.Aspects mapEffectPar
 * @tsplus pipeable effect/core/stream/Stream mapEffectPar
 * @tsplus location "@effect/core/stream/Stream/operations/mapEffectPar"
 */
export declare function mapEffectPar<A, R1, E1, B>(n: number, f: (a: A) => Effect<R1, E1, B>): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R1 | R, E1 | E, B>;
//# sourceMappingURL=mapEffectPar.d.ts.map