import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Maps over elements of the stream with the specified effectful function,
 * executing up to `n` invocations of `f` concurrently. The element order is
 * not enforced by this combinator, and elements may be reordered.
 * @tsplus static effect/core/stream/Stream.Aspects mapEffectParUnordered
 * @tsplus pipeable effect/core/stream/Stream mapEffectParUnordered
 * @tsplus location "@effect/core/stream/Stream/operations/mapEffectParUnordered"
 */
export declare function mapEffectParUnordered<A, R1, E1, B>(n: number, f: (a: A) => Effect<R1, E1, B>): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R1 | R, E1 | E, B>;
//# sourceMappingURL=mapEffectParUnordered.d.ts.map