import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Maps over elements of the stream with the specified effectful function,
 * partitioned by `p` executing invocations of `f` concurrently. The number of
 * concurrent invocations of `f` is determined by the number of different
 * outputs of type `K`. Up to `buffer` elements may be buffered per partition.
 * Transformed elements may be reordered but the order within a partition is
 * maintained.
 * @tsplus static effect/core/stream/Stream.Aspects mapEffectPartitioned
 * @tsplus pipeable effect/core/stream/Stream mapEffectPartitioned
 * @tsplus location "@effect/core/stream/Stream/operations/mapEffectPartitioned"
 */
export declare function mapEffectPartitioned<A, R2, E2, A2, K>(keyBy: (a: A) => K, f: (a: A) => Effect<R2, E2, A2>, buffer?: number): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, A2>;
//# sourceMappingURL=mapEffectPartitioned.d.ts.map