import { Stream } from "@effect/core/stream/Stream/definition";
import { Exit } from "@effect/core/io/Exit/definition";
import { TerminationStrategy } from "@effect/core/stream/Stream/TerminationStrategy";
/**
 * Merges this stream and the specified stream together to a common element
 * type with the specified mapping functions.
 *
 * New produced stream will terminate when both specified stream terminate if
 * no termination strategy is specified.
 * @tsplus static effect/core/stream/Stream.Aspects mergeWith
 * @tsplus pipeable effect/core/stream/Stream mergeWith
 * @tsplus location "@effect/core/stream/Stream/operations/mergeWith"
 */
export declare function mergeWith<R2, E2, A, A2, A3>(that: Stream<R2, E2, A2>, left: (a: A) => A3, right: (a2: A2) => A3, strategy?: TerminationStrategy): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, A3>;
//# sourceMappingURL=mergeWith.d.ts.map