import { Cause } from "@effect/core/io/Cause/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Runs the specified effect if this stream fails, providing the error to the
 * effect if it exists.
 *
 * Note: Unlike `Effect.onError`, there is no guarantee that the provided
 * effect will not be interrupted.
 * @tsplus static effect/core/stream/Stream.Aspects onError
 * @tsplus pipeable effect/core/stream/Stream onError
 * @tsplus location "@effect/core/stream/Stream/operations/onError"
 */
export declare function onError<E, R2, Z>(cleanup: (cause: Cause<E>) => Effect<R2, never, Z>): <R, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E, A>;
//# sourceMappingURL=onError.d.ts.map