import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Switches to the provided stream in case this one fails with a typed error.
 *
 * See also `Stream.catchAll`.
 * @tsplus static effect/core/stream/Stream.Aspects orElseEither
 * @tsplus pipeable effect/core/stream/Stream orElseEither
 * @tsplus location "@effect/core/stream/Stream/operations/orElseEither"
 */
export declare function orElseEither<R2, E2, A2>(that: LazyArg<Stream<R2, E2, A2>>): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, import("@tsplus/stdlib/data/Either").Either<A, A2>>;
//# sourceMappingURL=orElseEither.d.ts.map