import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Switches to the provided stream in case this one fails with the `None`
 * value.
 *
 * See also `Stream.catchAll`.
 * @tsplus static effect/core/stream/Stream.Aspects orElseOptional
 * @tsplus pipeable effect/core/stream/Stream orElseOptional
 * @tsplus location "@effect/core/stream/Stream/operations/orElseOptional"
 */
export declare function orElseOptional<R2, E2, A2>(that: LazyArg<Stream<R2, Maybe<E2>, A2>>): <R, E, A>(self: import("../definition").Stream<R, import("@tsplus/stdlib/data/Maybe").Maybe<E>, A>) => import("../definition").Stream<R2 | R, import("@tsplus/stdlib/data/Maybe").Maybe<E2 | E>, A2 | A>;
//# sourceMappingURL=orElseOptional.d.ts.map