import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Like `unfold`, but allows the emission of values to end one step further than
 * the unfolding of the state. This is useful for embedding paginated APIs,
 * hence the name.
 * @tsplus static effect/core/stream/Stream.Ops paginate
 * @tsplus location "@effect/core/stream/Stream/operations/paginate"
 */
export declare function paginate<S, A>(s: S, f: (s: S) => readonly [A, Maybe<S>]): Stream<never, never, A>;
//# sourceMappingURL=paginate.d.ts.map