import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * Like `unfoldChunk`, but allows the emission of values to end one step
 * further than the unfolding of the state. This is useful for embedding
 * paginated APIs, hence the name.
 * @tsplus static effect/core/stream/Stream.Ops paginateChunk
 * @tsplus location "@effect/core/stream/Stream/operations/paginateChunk"
 */
export declare function paginateChunk<S, A>(s: S, f: (s: S) => readonly [Chunk<A>, Maybe<S>]): Stream<never, never, A>;
//# sourceMappingURL=paginateChunk.d.ts.map