import { Effect } from "@effect/core/io/Effect/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * Like `unfoldChunkEffect`, but allows the emission of values to end one step
 * further than the unfolding of the state. This is useful for embedding
 * paginated APIs, hence the name.
 * @tsplus static effect/core/stream/Stream.Ops paginateChunkEffect
 * @tsplus location "@effect/core/stream/Stream/operations/paginateChunkEffect"
 */
export declare function paginateChunkEffect<S, R, E, A>(s: S, f: (s: S) => Effect<R, E, readonly [Chunk<A>, Maybe<S>]>): Stream<R, E, A>;
//# sourceMappingURL=paginateChunkEffect.d.ts.map