import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Like `unfoldEffect`, but allows the emission of values to end one step
 * further than the unfolding of the state. This is useful for embedding
 * paginated APIs, hence the name.
 * @tsplus static effect/core/stream/Stream.Ops paginateEffect
 * @tsplus location "@effect/core/stream/Stream/operations/paginateEffect"
 */
export declare function paginateEffect<S, R, E, A>(s: S, f: (s: S) => Effect<R, E, readonly [A, Maybe<S>]>): Stream<R, E, A>;
//# sourceMappingURL=paginateEffect.d.ts.map