import { Predicate } from "@tsplus/stdlib/data/Predicate";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Partition a stream using a predicate. The first stream will contain all
 * element evaluated to true and the second one will contain all element
 * evaluated to false. The faster stream may advance by up to buffer elements
 * further than the slower one.
 * @tsplus static effect/core/stream/Stream.Aspects partition
 * @tsplus pipeable effect/core/stream/Stream partition
 * @tsplus location "@effect/core/stream/Stream/operations/partition"
 */
export declare function partition<A>(p: Predicate<A>, buffer?: number): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R, E, readonly [import("../definition").Stream<never, E, A>, import("../definition").Stream<never, E, A>]>;
//# sourceMappingURL=partition.d.ts.map