import { Effect } from "@effect/core/io/Effect/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Split a stream by a predicate. The faster stream may advance by up to
 * buffer elements further than the slower one.
 * @tsplus static effect/core/stream/Stream.Aspects partitionEither
 * @tsplus pipeable effect/core/stream/Stream partitionEither
 * @tsplus location "@effect/core/stream/Stream/operations/partitionEither"
 */
export declare function partitionEither<A, R2, E2, A2, A3>(p: (a: A) => Effect<R2, E2, Either<A2, A3>>, buffer?: number): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R2 | R, E2 | E, readonly [import("../definition").Stream<never, E2 | E, A2>, import("../definition").Stream<never, E2 | E, A3>]>;
//# sourceMappingURL=partitionEither.d.ts.map