import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Cause } from "@effect/core/io/Cause/definition";
import { Sink } from "@effect/core/stream/Sink/definition/base";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
export declare class Emit<A> {
    readonly elements: Chunk<A>;
    readonly _tag = "Emit";
    constructor(elements: Chunk<A>);
}
export declare class Halt<E> {
    readonly error: Cause<E>;
    readonly _tag = "Halt";
    constructor(error: Cause<E>);
}
export declare class End {
    readonly _tag = "End";
}
/**
 * Peels off enough material from the stream to construct a `Z` using the
 * provided `Sink` and then returns both the `Z` and the rest of the
 * `Stream` in a scope. Like all scoped values, the provided stream is valid
 * only within the scope.
 * @tsplus static effect/core/stream/Stream.Aspects peel
 * @tsplus pipeable effect/core/stream/Stream peel
 * @tsplus location "@effect/core/stream/Stream/operations/peel"
 */
export declare function peel<R2, E2, A2, Z>(sink: Sink<R2, E2, A2, A2, Z>): <R, E extends E2, A extends A2>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R2 | R, E2 | E, readonly [Z, import("../definition").Stream<never, E, A2>]>;
//# sourceMappingURL=peel.d.ts.map