"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Halt = exports.End = exports.Emit = void 0;
exports.peel = peel;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/tapErrorCause"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/runScoped"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/forkScoped"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/failCause"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unit"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/Handoff"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unwrap"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Sink/operations/fromEffect"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Sink/operations/fail"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Sink/operations/zipRight"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fromEffect"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWithCause"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Sink/operations/exposeLeftover"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Sink/operations/foldSink"));

var tsplus_module_19 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Deferred/operations/make"));

var tsplus_module_20 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatten"));

var _SinkInternal = /*#__PURE__*/require("@effect/core/stream/Sink/operations/_internal/SinkInternal");

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

class Emit {
  constructor(elements) {
    this.elements = elements;
    this._tag = "Emit";
  }

}

exports.Emit = Emit;

class Halt {
  constructor(error) {
    this.error = error;
    this._tag = "Halt";
  }

}

exports.Halt = Halt;

class End {
  constructor() {
    this._tag = "End";
  }

}
/**
 * Peels off enough material from the stream to construct a `Z` using the
 * provided `Sink` and then returns both the `Z` and the rest of the
 * `Stream` in a scope. Like all scoped values, the provided stream is valid
 * only within the scope.
 *
 * @tsplus static effect/core/stream/Stream.Aspects peel
 * @tsplus pipeable effect/core/stream/Stream peel
 */


exports.End = End;

function peel(sink) {
  return self => tsplus_module_20.flatten(tsplus_module_4.flatMap(deferred => tsplus_module_5.map(handoff => {
    const consumer = tsplus_module_18.foldSink_(e => tsplus_module_14.zipRight(tsplus_module_13.fail(e))(tsplus_module_12.fromEffect(deferred.fail(e))), ([z1, leftovers]) => {
      const loop = tsplus_module_16.readWithCause(chunk => tsplus_module_7.flatMap(() => loop)(tsplus_module_15.fromEffect(tsplus_module_10.offer(new Emit(chunk))(handoff))), cause => tsplus_module_7.flatMap(() => tsplus_module_8.failCause(cause))(tsplus_module_15.fromEffect(tsplus_module_10.offer(new Halt(cause))(handoff))), () => tsplus_module_7.flatMap(() => tsplus_module_9.unit)(tsplus_module_15.fromEffect(tsplus_module_10.offer(new End())(handoff))));
      return new _SinkInternal.SinkInternal(tsplus_module_7.flatMap(() => loop)(tsplus_module_7.flatMap(() => tsplus_module_15.fromEffect(tsplus_module_10.offer(new Emit(leftovers))(handoff)))(tsplus_module_15.fromEffect(deferred.succeed(z1)))));
    })(tsplus_module_17.exposeLeftover(sink));
    const producer = tsplus_module_11.unwrap(tsplus_module_5.map(signal => {
      switch (signal._tag) {
        case "Emit":
          {
            return tsplus_module_7.flatMap(() => producer)(tsplus_module_6.write(signal.elements));
          }

        case "Halt":
          {
            return tsplus_module_8.failCause(signal.error);
          }

        case "End":
          {
            return tsplus_module_9.unit;
          }
      }
    })(tsplus_module_10.take(handoff)));
    return tsplus_module_5.map(z => [z, new _StreamInternal.StreamInternal(producer)])(tsplus_module_4.flatMap(() => deferred.await)(tsplus_module_3.forkScoped(tsplus_module_2.runScoped(consumer)(tsplus_module_1.tapErrorCause(cause => deferred.failCause(() => cause))(self)))));
  })(tsplus_module_10.make()))(tsplus_module_19.make()));
}
//# sourceMappingURL=peel.js.map