"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.range = range;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/suspend"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/range"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var _definition = /*#__PURE__*/require("@effect/core/stream/Stream/definition");

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Constructs a stream from a range of integers (lower bound included, upper
 * bound not included).
 *
 * @tsplus static effect/core/stream/Stream.Ops range
 */
function range(min, max, chunkSize = _definition.DEFAULT_CHUNK_SIZE) {
  return tsplus_module_1.suspend(() => new _StreamInternal.StreamInternal(go(min, max, chunkSize)));
}

function go(min, max, chunkSize) {
  const remaining = max - min;
  return remaining > chunkSize ? tsplus_module_4.flatMap(() => go(min + chunkSize, max, chunkSize))(tsplus_module_3.write(tsplus_module_2.range(min, min + chunkSize - 1))) : tsplus_module_3.write(tsplus_module_2.range(min, min + remaining - 1));
}
//# sourceMappingURL=range.js.map