"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.rechunk = rechunk;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/size"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/empty"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/prepend"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/reverse"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/writeAll"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/failCause"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWithCause"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/builder"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unit"));

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Re-chunks the elements of the stream into chunks of `n` elements each. The
 * last chunk might contain less than `n` elements.
 *
 * @tsplus static effect/core/stream/Stream.Aspects rechunk
 * @tsplus pipeable effect/core/stream/Stream rechunk
 */
function rechunk(n) {
  return self => {
    void 0;
    return new _StreamInternal.StreamInternal(tsplus_module_1.pipeTo(process(new Rechunker(n), n))(self.channel));
  };
}

function process(rechunker, target) {
  return tsplus_module_11.readWithCause(chunk => {
    if (tsplus_module_2.size(chunk) === target && rechunker.isEmpty()) {
      return tsplus_module_4.flatMap(() => process(rechunker, target))(tsplus_module_3.write(chunk));
    }

    if (tsplus_module_2.size(chunk) > 0) {
      let chunks = tsplus_module_5.empty();
      let result = undefined;
      let i = 0;

      while (i < tsplus_module_2.size(chunk)) {
        while (i < tsplus_module_2.size(chunk) && result == null) {
          result = rechunker.write(tsplus_module_6.unsafeGet(i)(chunk));
          i = i + 1;
        }

        if (result != null) {
          chunks = tsplus_module_7.prepend(result)(chunks);
          result = undefined;
        }
      }

      return tsplus_module_4.flatMap(() => process(rechunker, target))(tsplus_module_9.writeAll(...tsplus_module_8.reverse(chunks)));
    }

    return process(rechunker, target);
  }, cause => tsplus_module_4.flatMap(() => tsplus_module_10.failCause(cause))(rechunker.emitIfNotEmpty()), () => rechunker.emitIfNotEmpty());
}

class Rechunker {
  constructor(n) {
    this.n = n;
    this.builder = tsplus_module_12.builder();
    this.pos = 0;
  }

  isEmpty() {
    return this.pos === 0;
  }

  write(elem) {
    this.builder.append(elem);
    this.pos += 1;

    if (this.pos === this.n) {
      const result = this.builder.build();
      this.builder = tsplus_module_12.builder();
      this.pos = 0;
      return result;
    }

    return undefined;
  }

  emitIfNotEmpty() {
    if (this.pos !== 0) {
      return tsplus_module_3.write(this.builder.build());
    } else {
      return tsplus_module_13.unit;
    }
  }

}
//# sourceMappingURL=rechunk.js.map