import { Schedule } from "@effect/core/io/Schedule/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Repeats the entire stream using the specified schedule. The stream will
 * execute normally, and then repeat again according to the provided schedule.
 * @tsplus static effect/core/stream/Stream.Aspects repeat
 * @tsplus pipeable effect/core/stream/Stream repeat
 * @tsplus location "@effect/core/stream/Stream/operations/repeat"
 */
export declare function repeatNow<S, R2, B>(schedule: Schedule<S, R2, unknown, B>): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E, A>;
/**
 * Repeats the provided value infinitely.
 * @tsplus static effect/core/stream/Stream.Ops repeat
 * @tsplus location "@effect/core/stream/Stream/operations/repeat"
 */
export declare function repeat<A>(a: A): Stream<never, never, A>;
//# sourceMappingURL=repeat.d.ts.map