import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Creates a stream from an effect producing chunks of `A` values until it
 * fails with `None`.
 * @tsplus static effect/core/stream/Stream.Ops repeatEffectChunkMaybe
 * @tsplus location "@effect/core/stream/Stream/operations/repeatEffectChunkMaybe"
 */
export declare function repeatEffectChunkMaybe<R, E, A>(effect: Effect<R, Maybe<E>, Chunk<A>>): Stream<R, E, A>;
//# sourceMappingURL=repeatEffectChunkMaybe.d.ts.map