import { Effect } from "@effect/core/io/Effect/definition";
import { Schedule } from "@effect/core/io/Schedule/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Creates a stream from an effect producing a value of type `A`, which is
 * repeated using the specified schedule.
 * @tsplus static effect/core/stream/Stream.Ops repeatEffectWithSchedule
 * @tsplus location "@effect/core/stream/Stream/operations/repeatEffectWithSchedule"
 */
export declare function repeatEffectWithSchedule<S, R, E, A>(effect: Effect<R, E, A>, schedule: Schedule<S, R, A, unknown>): Stream<R, E, A>;
//# sourceMappingURL=repeatEffectWithSchedule.d.ts.map