import { Schedule } from "@effect/core/io/Schedule/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Repeats the entire stream using the specified schedule. The stream will
 * execute normally, and then repeat again according to the provided schedule.
 * The schedule output will be emitted at the end of each repetition.
 * @tsplus static effect/core/stream/Stream.Aspects repeatEither
 * @tsplus pipeable effect/core/stream/Stream repeatEither
 * @tsplus location "@effect/core/stream/Stream/operations/repeatEither"
 */
export declare function repeatEither<S, R2, B>(schedule: Schedule<S, R2, unknown, B>): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E, import("@tsplus/stdlib/data/Either").Either<B, A>>;
//# sourceMappingURL=repeatEither.d.ts.map