import { Schedule } from "@effect/core/io/Schedule/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Repeats each element of the stream using the provided schedule. Repetitions
 * are done in addition to the first execution, which means using
 * `Schedule.recurs(1)` actually results in the original effect, plus an
 * additional recurrence, for a total of two repetitions of each value in the
 * stream.
 * @tsplus static effect/core/stream/Stream.Aspects repeatElements
 * @tsplus pipeable effect/core/stream/Stream repeatElements
 * @tsplus location "@effect/core/stream/Stream/operations/repeatElements"
 */
export declare function repeatElements<S, R2, B>(schedule: Schedule<S, R2, unknown, B>): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E, A>;
//# sourceMappingURL=repeatElements.d.ts.map