import { Schedule } from "@effect/core/io/Schedule/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Repeats each element of the stream using the provided schedule. When the
 * schedule is finished, then the output of the schedule will be emitted into
 * the stream. Repetitions are done in addition to the first execution, which
 * means using `Schedule.recurs(1)` actually results in the original effect,
 * plus an additional recurrence, for a total of two repetitions of each value
 * in the stream.
 * @tsplus static effect/core/stream/Stream.Aspects repeatElementsEither
 * @tsplus pipeable effect/core/stream/Stream repeatElementsEither
 * @tsplus location "@effect/core/stream/Stream/operations/repeatElementsEither"
 */
export declare function repeatElementsEither<S, R2, B>(schedule: Schedule<S, R2, unknown, B>): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E, import("@tsplus/stdlib/data/Either").Either<B, A>>;
//# sourceMappingURL=repeatElementsEither.d.ts.map