import { Schedule } from "@effect/core/io/Schedule/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Repeats each element of the stream using the provided schedule. When the
 * schedule is finished, then the output of the schedule will be emitted into
 * the stream. Repetitions are done in addition to the first execution, which
 * means using `Schedule.recurs(1)` actually results in the original effect,
 * plus an additional recurrence, for a total of two repetitions of each value
 * in the stream.
 *
 * This function accepts two conversion functions, which allow the output of
 * this stream and the output of the provided schedule to be unified into a
 * single type. For example, `Either` or similar data type.
 * @tsplus static effect/core/stream/Stream.Aspects repeatElementsWith
 * @tsplus pipeable effect/core/stream/Stream repeatElementsWith
 * @tsplus location "@effect/core/stream/Stream/operations/repeatElementsWith"
 */
export declare function repeatElementsWith<A, S, R2, B, C1, C2>(schedule: Schedule<S, R2, unknown, B>, f: (a: A) => C1, g: (b: B) => C2): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E, C1 | C2>;
//# sourceMappingURL=repeatElementsWith.d.ts.map