import { Schedule } from "@effect/core/io/Schedule/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Repeats the entire stream using the specified schedule. The stream will
 * execute normally, and then repeat again according to the provided schedule.
 * The schedule output will be emitted at the end of each repetition and can
 * be unified with the stream elements using the provided functions.
 * @tsplus static effect/core/stream/Stream.Aspects repeatWith
 * @tsplus pipeable effect/core/stream/Stream repeatWith
 * @tsplus location "@effect/core/stream/Stream/operations/repeatWith"
 */
export declare function repeatWith<A, S, R2, B, C1, C2>(schedule: Schedule<S, R2, unknown, B>, f: (a: A) => C1, g: (b: B) => C2): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E, C1 | C2>;
//# sourceMappingURL=repeatWith.d.ts.map