import { Schedule } from "@effect/core/io/Schedule/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * When the stream fails, retry it according to the given schedule
 *
 * This retries the entire stream, so will re-execute all of the stream's
 * acquire operations.
 *
 * The schedule is reset as soon as the first element passes through the
 * stream again.
 * @param schedule Schedule receiving as input the errors of the stream.
 * @tsplus static effect/core/stream/Stream.Aspects retry
 * @tsplus pipeable effect/core/stream/Stream retry
 * @tsplus location "@effect/core/stream/Stream/operations/retry"
 */
export declare function retry<E, S, R2, Z>(schedule: Schedule<S, R2, E, Z>): <R, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E, A>;
//# sourceMappingURL=retry.d.ts.map