import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Executes a pure fold over the stream of values - reduces all elements in
 * the stream to a value of type `S`.
 * @tsplus static effect/core/stream/Stream.Aspects runFold
 * @tsplus pipeable effect/core/stream/Stream runFold
 * @tsplus location "@effect/core/stream/Stream/operations/runFold"
 */
export declare function runFold<S, A>(s: S, f: (s: S, a: A) => S): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<R, E, S>;
//# sourceMappingURL=runFold.d.ts.map