import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Executes a pure fold over the stream of values - reduces all elements in
 * the stream to a value of type `S`.
 * @tsplus static effect/core/stream/Stream.Aspects runFoldEffect
 * @tsplus pipeable effect/core/stream/Stream runFoldEffect
 * @tsplus location "@effect/core/stream/Stream/operations/runFoldEffect"
 */
export declare function runFoldEffect<S, A, R2, E2>(s: S, f: (s: S, a: A) => Effect<R2, E2, S>): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<R2 | R, E2 | E, S>;
//# sourceMappingURL=runFoldEffect.d.ts.map