import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Executes a pure fold over the stream of values. Returns a scoped value
 * that represents the scope of the stream.
 * @tsplus static effect/core/stream/Stream.Aspects runFoldScoped
 * @tsplus pipeable effect/core/stream/Stream runFoldScoped
 * @tsplus location "@effect/core/stream/Stream/operations/runFoldScoped"
 */
export declare function runFoldScoped<S, A>(s: S, f: (s: S, a: A) => S): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R, E, S>;
//# sourceMappingURL=runFoldScoped.d.ts.map