import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Executes an effectful fold over the stream of values. Returns a scoped
 * value that represents the scope of the stream.
 * @tsplus static effect/core/stream/Stream.Aspects runFoldScopedEffect
 * @tsplus pipeable effect/core/stream/Stream runFoldScopedEffect
 * @tsplus location "@effect/core/stream/Stream/operations/runFoldScopedEffect"
 */
export declare function runFoldScopedEffect<S, A, R2, E2>(s: S, f: (s: S, a: A) => Effect<R2, E2, S>): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R2 | R, E2 | E, S>;
//# sourceMappingURL=runFoldScopedEffect.d.ts.map