import { Predicate } from "@tsplus/stdlib/data/Predicate";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect/definition";
/**
 * Reduces the elements in the stream to a value of type `S`. Stops the fold
 * early when the condition is not fulfilled.
 * @tsplus static effect/core/stream/Stream.Aspects runFoldWhile
 * @tsplus pipeable effect/core/stream/Stream runFoldWhile
 * @tsplus location "@effect/core/stream/Stream/operations/runFoldWhile"
 */
export declare function runFoldWhile<S, A>(s: S, cont: Predicate<S>, f: (s: S, a: A) => S): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<R, E, S>;
//# sourceMappingURL=runFoldWhile.d.ts.map