import { Predicate } from "@tsplus/stdlib/data/Predicate";
import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Reduces the elements in the stream to a value of type `S`. Stops the fold
 * early when the condition is not fulfilled.
 * @tsplus static effect/core/stream/Stream.Aspects runFoldWhileEffect
 * @tsplus pipeable effect/core/stream/Stream runFoldWhileEffect
 * @tsplus location "@effect/core/stream/Stream/operations/runFoldWhileEffect"
 */
export declare function runFoldWhileEffect<S, A, R2, E2>(s: S, cont: Predicate<S>, f: (s: S, a: A) => Effect<R2, E2, S>): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<R2 | R, E2 | E, S>;
//# sourceMappingURL=runFoldWhileEffect.d.ts.map