import { Predicate } from "@tsplus/stdlib/data/Predicate";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Executes a pure fold over the stream of values. Returns a scoped value
 * that represents the scope of the stream. Stops the fold early when the
 * condition is not fulfilled.
 * @param cont A function which defines the early termination condition.
 * @tsplus static effect/core/stream/Stream.Aspects runFoldWhileScoped
 * @tsplus pipeable effect/core/stream/Stream runFoldWhileScoped
 * @tsplus location "@effect/core/stream/Stream/operations/runFoldWhileScoped"
 */
export declare function runFoldWhileScoped<S, A>(s: S, cont: Predicate<S>, f: (s: S, a: A) => S): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R, E, S>;
//# sourceMappingURL=runFoldWhileScoped.d.ts.map