import { Predicate } from "@tsplus/stdlib/data/Predicate";
import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Executes an effectful fold over the stream of values. Returns a scoped
 * value that represents the scope of the stream. Stops the fold early when
 * the condition is not fulfilled.
 * @param cont A function which defines the early termination condition.
 * @tsplus static effect/core/stream/Stream.Aspects runFoldWhileScopedEffect
 * @tsplus pipeable effect/core/stream/Stream runFoldWhileScopedEffect
 * @tsplus location "@effect/core/stream/Stream/operations/runFoldWhileScopedEffect"
 */
export declare function runFoldWhileScopedEffect<S, A, R2, E2>(s: S, cont: Predicate<S>, f: (s: S, a: A) => Effect<R2, E2, S>): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R2 | R, E2 | E, S>;
//# sourceMappingURL=runFoldWhileScopedEffect.d.ts.map