import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Like `Stream.runForEachChunk`, but returns a scoped `Effect` so the
 * finalization order can be controlled.
 * @tsplus static effect/core/stream/Stream.Aspects runForEachChunkScoped
 * @tsplus pipeable effect/core/stream/Stream runForEachChunkScoped
 * @tsplus location "@effect/core/stream/Stream/operations/runForEachChunkScoped"
 */
export declare function runForEachChunkScoped<A, R2, E2, Z>(f: (chunk: Chunk<A>) => Effect<R2, E2, Z>): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R2 | R, E2 | E, void>;
//# sourceMappingURL=runForEachChunkScoped.d.ts.map