import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Like `Stream.forEach`, but returns an `Effect` so the finalization
 * order can be controlled.
 * @tsplus static effect/core/stream/Stream.Aspects runForEachScoped
 * @tsplus pipeable effect/core/stream/Stream runForEachScoped
 * @tsplus location "@effect/core/stream/Stream/operations/runForEachScoped"
 */
export declare function runForEachScoped<A, R1, E1, Z>(f: (a: A) => Effect<R1, E1, Z>): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R1 | R, E1 | E, void>;
//# sourceMappingURL=runForEachScoped.d.ts.map