import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Like `Stream.runForEachWhile`, but returns a scoped `Effect` so the
 * finalization order can be controlled.
 * @tsplus static effect/core/stream/Stream.Aspects runForEachWhileScoped
 * @tsplus pipeable effect/core/stream/Stream runForEachWhileScoped
 * @tsplus location "@effect/core/stream/Stream/operations/runForEachWhileScoped"
 */
export declare function runForEachWhileScoped<A, R2, E2, Z>(f: (a: A) => Effect<R2, E2, boolean>): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R2 | R, E2 | E, void>;
//# sourceMappingURL=runForEachWhileScoped.d.ts.map