import { Hub } from "@effect/core/io/Hub/definition";
import { Take } from "@effect/core/stream/Take/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
/**
 * Like `Stream.runIntoHub`, but provides the result as a scoped effect to
 * allow for scope composition.
 * @tsplus static effect/core/stream/Stream.Aspects runIntoHubScoped
 * @tsplus pipeable effect/core/stream/Stream runIntoHubScoped
 * @tsplus location "@effect/core/stream/Stream/operations/runIntoHubScoped"
 */
export declare function runIntoHubScoped<E1, A>(hub: Hub<Take<E1, A>>): <R, E extends E1>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R, E1 | E, void>;
//# sourceMappingURL=runIntoHubScoped.d.ts.map