import { Enqueue } from "@effect/core/io/Queue/definition/common";
import { Exit } from "@effect/core/io/Exit/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Like `Stream.runIntoQueue`, but provides the result as a scoped effect to
 * allow for scope composition.
 * @tsplus static effect/core/stream/Stream.Aspects runIntoQueueElementsScoped
 * @tsplus pipeable effect/core/stream/Stream runIntoQueueElementsScoped
 * @tsplus location "@effect/core/stream/Stream/operations/runIntoQueueElementsScoped"
 */
export declare function runIntoQueueElementsScoped<E1, A>(queue: Enqueue<Exit<Maybe<E1>, A>>): <R, E extends E1>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R, E1 | E, void>;
//# sourceMappingURL=runIntoQueueElementsScoped.d.ts.map