import { Schedule } from "@effect/core/io/Schedule/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Schedules the output of the stream using the provided `schedule` and emits
 * its output at the end (if `schedule` is finite).
 * @tsplus static effect/core/stream/Stream.Aspects scheduleEither
 * @tsplus pipeable effect/core/stream/Stream scheduleEither
 * @tsplus location "@effect/core/stream/Stream/operations/scheduleEither"
 */
export declare function scheduleEither<S, R2, A, B>(schedule: Schedule<S, R2, A, B>): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E, import("@tsplus/stdlib/data/Either").Either<B, A>>;
//# sourceMappingURL=scheduleEither.d.ts.map