import { Schedule } from "@effect/core/io/Schedule/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * Schedules the output of the stream using the provided `schedule` and emits
 * its output at the end (if `schedule` is finite). Uses the provided function
 * to align the stream and schedule outputs on the same type.
 * @tsplus static effect/core/stream/Stream.Aspects scheduleWith
 * @tsplus pipeable effect/core/stream/Stream scheduleWith
 * @tsplus location "@effect/core/stream/Stream/operations/scheduleWith"
 */
export declare function scheduleWith<S, R2, A, B, C>(schedule: Schedule<S, R2, A, B>, f: (a: A) => C, g: (b: B) => C): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E, C>;
//# sourceMappingURL=scheduleWith.d.ts.map