"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.split = split;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/concat"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/splitWhere"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/isEmpty"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/drop"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/single"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/fail"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unit"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/find"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWith"));

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Splits elements based on a predicate.
 *
 * @tsplus static effect/core/stream/Stream.Aspects split
 * @tsplus pipeable effect/core/stream/Stream split
 */
function split(f) {
  return self => {
    void 0;
    return new _StreamInternal.StreamInternal(tsplus_module_2.pipeTo(loop(tsplus_module_1.empty(), f))(self.channel));
  };
}

function splitInternal(leftovers, input, f) {
  const [chunk, remaining] = tsplus_module_4.splitWhere(f)(tsplus_module_3.concat(input)(leftovers));
  return tsplus_module_5.isEmpty(chunk) || tsplus_module_5.isEmpty(remaining) ? loop(tsplus_module_3.concat(tsplus_module_6.drop(1)(remaining))(chunk), f) : tsplus_module_9.flatMap(() => splitInternal(tsplus_module_1.empty(), tsplus_module_6.drop(1)(remaining), f))(tsplus_module_8.write(tsplus_module_7.single(chunk)));
}

function loop(leftovers, f) {
  return tsplus_module_14.readWith(input => splitInternal(leftovers, input, f), err => tsplus_module_10.fail(err), () => tsplus_module_5.isEmpty(leftovers) ? tsplus_module_11.unit : tsplus_module_13.isNone(tsplus_module_12.find(f)(leftovers)) ? tsplus_module_9.flatMap(() => tsplus_module_11.unit)(tsplus_module_8.write(tsplus_module_7.single(leftovers))) : tsplus_module_9.flatMap(() => tsplus_module_11.unit)(splitInternal(tsplus_module_1.empty(), leftovers, f)));
}
//# sourceMappingURL=split.js.map