"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.splitLines = splitLines;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/builder"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/getOrElse"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/zipWithIndex"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/drop"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/reduce"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/forEach"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/failCause"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/single"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fold"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/succeed"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWithCause"));

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Splits strings on newlines. Handles both Windows newlines (`\r\n`) and UNIX
 * newlines (`\n`).
 *
 * @tsplus static effect/core/stream/Stream.Ops splitLines
 */
function splitLines(self) {
  void 0;
  return new _StreamInternal.StreamInternal(tsplus_module_2.pipeTo(next(tsplus_module_1.none, false))(self.channel));
}

function next(leftover, wasSplitCRLF) {
  return tsplus_module_16.readWithCause(incomingChunk => {
    const buffer = tsplus_module_3.builder();
    let inCRLF = wasSplitCRLF;
    let carry = tsplus_module_4.getOrElse_(leftover, () => "");
    tsplus_module_9.forEach(string => {
      const concatenated = carry + string;

      if (concatenated.length > 0) {
        // If we had a split CRLF, start reading from the last character of
        // the leftover, which was the '\r'. Otherwise we just skip over the
        // entire previous leftover, as it doesn't contain a newline.
        const continueFrom = inCRLF && carry.length > 0 ? carry.length - 1 : carry.length;
        const [sliceStart, _, midCRLF] = tsplus_module_8.reduce([0, false, inCRLF], ([sliceStart, skipNext, midCRLF], [char, index]) => {
          if (skipNext) {
            return [sliceStart, false, false];
          }

          switch (char) {
            case "\n":
              {
                buffer.append(concatenated.substring(sliceStart, index));
                return [index + 1, false, midCRLF];
              }

            case "\r":
              {
                if (index + 1 < concatenated.length && concatenated[index + 1] === "\n") {
                  buffer.append(concatenated.substring(sliceStart, index));
                  return [index + 2, true, false];
                }

                if (index === concatenated.length - 1) {
                  return [sliceStart, false, true];
                }

                return [sliceStart, false, false];
              }

            default:
              {
                return [sliceStart, false, midCRLF];
              }
          }
        })(tsplus_module_7.drop(continueFrom)(tsplus_module_6.zipWithIndex(tsplus_module_5.from(concatenated))));
        carry = concatenated.slice(sliceStart);
        inCRLF = midCRLF;
      }
    })(incomingChunk);
    return tsplus_module_11.flatMap(() => next(carry.length > 0 ? tsplus_module_1.some(carry) : tsplus_module_1.none, inCRLF))(tsplus_module_10.write(buffer.build()));
  }, cause => tsplus_module_14.fold(() => tsplus_module_12.failCause(cause), value => tsplus_module_11.flatMap(() => tsplus_module_12.failCause(cause))(tsplus_module_10.write(tsplus_module_13.single(value))))(leftover), done => tsplus_module_14.fold(() => tsplus_module_15.succeed(done), value => tsplus_module_11.flatMap(() => tsplus_module_15.succeed(done))(tsplus_module_10.write(tsplus_module_13.single(value))))(leftover));
}
//# sourceMappingURL=splitLines.js.map