"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.splitOnChunk = splitOnChunk;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/pipeTo"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/builder"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/getOrElse"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/append"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/take"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeHead"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/reduce"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/isNonEmpty"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/write"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/flatMap"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/failCause"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/single"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fold"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/succeed"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/readWithCause"));

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Splits elements on a delimiter and transforms the splits into desired
 * output.
 *
 * @tsplus static effect/core/stream/Stream.Aspects splitOnChunk
 * @tsplus pipeable effect/core/stream/Stream splitOnChunk
 */
function splitOnChunk(delimiter) {
  return self => {
    void 0;
    return new _StreamInternal.StreamInternal(tsplus_module_2.pipeTo(next(delimiter, tsplus_module_1.none, 0))(self.channel));
  };
}

function next(delimiter, leftover, delimiterIndex) {
  return tsplus_module_18.readWithCause(inputChunk => {
    const buffer = tsplus_module_3.builder();
    const [carry, delimiterCursor] = tsplus_module_10.reduce([tsplus_module_5.getOrElse_(leftover, () => tsplus_module_4.empty()), delimiterIndex], ([carry, delimiterCursor], a) => {
      const concatenated = tsplus_module_6.append(a)(carry);

      if (delimiterCursor < delimiter.length && a === tsplus_module_7.unsafeGet(delimiterCursor)(delimiter)) {
        if (delimiterCursor + 1 === delimiter.length) {
          buffer.append(tsplus_module_8.take(concatenated.length - delimiter.length)(concatenated));
          return [tsplus_module_4.empty(), 0];
        }

        return [concatenated, delimiterCursor + 1];
      }

      return [concatenated, a === tsplus_module_9.unsafeHead(delimiter) ? 1 : 0];
    })(inputChunk);
    return tsplus_module_13.flatMap(() => next(delimiter, tsplus_module_11.isNonEmpty(carry) ? tsplus_module_1.some(carry) : tsplus_module_1.none, delimiterCursor))(tsplus_module_12.write(buffer.build()));
  }, cause => tsplus_module_16.fold(() => tsplus_module_14.failCause(cause), chunk => tsplus_module_13.flatMap(() => tsplus_module_14.failCause(cause))(tsplus_module_12.write(tsplus_module_15.single(chunk))))(leftover), done => tsplus_module_16.fold(() => tsplus_module_17.succeed(done), chunk => tsplus_module_13.flatMap(() => tsplus_module_17.succeed(done))(tsplus_module_12.write(tsplus_module_15.single(chunk))))(leftover));
}
//# sourceMappingURL=splitOnChunk.js.map