import { Cause } from "@effect/core/io/Cause/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Returns a stream that effectfully "peeks" at the cause of failure of the
 * stream.
 * @tsplus static effect/core/stream/Stream.Aspects tapErrorCause
 * @tsplus pipeable effect/core/stream/Stream tapErrorCause
 * @tsplus location "@effect/core/stream/Stream/operations/tapErrorCause"
 */
export declare function tapErrorCause<E, R2, E2, A2>(f: (cause: Cause<E>) => Effect<R2, E2, A2>): <R, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E | E2, A>;
//# sourceMappingURL=tapErrorCause.d.ts.map