import { Duration } from "@tsplus/stdlib/data/Duration";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Throttles the chunks of this stream according to the given bandwidth
 * parameters using the token bucket algorithm. Allows for burst in the
 * processing of elements by allowing the token bucket to accumulate tokens up
 * to a `units + burst` threshold. Chunks that do not meet the bandwidth
 * constraints are dropped. The weight of each chunk is determined by the
 * `costFn` function.
 * @tsplus static effect/core/stream/Stream.Aspects throttleEnforce
 * @tsplus pipeable effect/core/stream/Stream throttleEnforce
 * @tsplus location "@effect/core/stream/Stream/operations/throttleEnforce"
 */
export declare function throttleEnforce<A>(units: number, duration: Duration, costFn: (input: Chunk<A>) => number, burst?: number): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R, E, A>;
//# sourceMappingURL=throttleEnforce.d.ts.map