import { Duration } from "@tsplus/stdlib/data/Duration";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Delays the chunks of this stream according to the given bandwidth
 * parameters using the token bucket algorithm. Allows for burst in the
 * processing of elements by allowing the token bucket to accumulate tokens up
 * to a `units + burst` threshold. The weight of each chunk is determined by
 * the `costFn` function.
 * @tsplus static effect/core/stream/Stream.Aspects throttleShape
 * @tsplus pipeable effect/core/stream/Stream throttleShape
 * @tsplus location "@effect/core/stream/Stream/operations/throttleShape"
 */
export declare function throttleShape<A>(units: number, duration: Duration, costFn: (input: Chunk<A>) => number, burst?: number): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R, E, A>;
//# sourceMappingURL=throttleShape.d.ts.map