import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Cause } from "@effect/core/io/Cause/definition";
import { Duration } from "@tsplus/stdlib/data/Duration";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Fails the stream with given cause if it does not produce a value after the
 * specified duration.
 * @tsplus static effect/core/stream/Stream.Aspects timeoutFailCause
 * @tsplus pipeable effect/core/stream/Stream timeoutFailCause
 * @tsplus location "@effect/core/stream/Stream/operations/timeoutFailCause"
 */
export declare function timeoutFailCause<E2>(cause: LazyArg<Cause<E2>>, duration: Duration): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R, E2 | E, A>;
//# sourceMappingURL=timeoutFailCause.d.ts.map