import { Duration } from "@tsplus/stdlib/data/Duration";
import { Stream } from "@effect/core/stream/Stream/definition";
export declare const StreamTimeoutErrorSym: unique symbol;
export declare class StreamTimeoutError {
    readonly message?: string | undefined;
    readonly [StreamTimeoutErrorSym] = "StreamTimeoutError";
    constructor(message?: string | undefined);
}
export declare function isStreamTimeoutError(u: unknown): u is StreamTimeoutError;
/**
 * Switches the stream if it does not produce a value after the spcified
 * duration.
 * @tsplus static effect/core/stream/Stream.Aspects timeoutTo
 * @tsplus pipeable effect/core/stream/Stream timeoutTo
 * @tsplus location "@effect/core/stream/Stream/operations/timeoutTo"
 */
export declare function timeoutTo<R2, E2, A2>(duration: Duration, that: Stream<R2, E2, A2>): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, A2 | A>;
//# sourceMappingURL=timeoutTo.d.ts.map