"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StreamTimeoutErrorSym = exports.StreamTimeoutError = void 0;
exports.isStreamTimeoutError = isStreamTimeoutError;
exports.timeoutTo = timeoutTo;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Cause/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/timeoutFailCause"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/catchSomeCause"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a;

const StreamTimeoutErrorSym = /*#__PURE__*/Symbol.for("@effect/core/stream/Stream/StreamTimeoutError");
exports.StreamTimeoutErrorSym = StreamTimeoutErrorSym;

class StreamTimeoutError {
  constructor(message) {
    this.message = message;
    this[_a] = "StreamTimeoutError";
  }

}

exports.StreamTimeoutError = StreamTimeoutError;
_a = StreamTimeoutErrorSym;

function isStreamTimeoutError(u) {
  return u instanceof StreamTimeoutError && u[StreamTimeoutErrorSym] === "StreamTimeoutError";
}
/**
 * Switches the stream if it does not produce a value after the spcified
 * duration.
 *
 * @tsplus static effect/core/stream/Stream.Aspects timeoutTo
 * @tsplus pipeable effect/core/stream/Stream timeoutTo
 */


function timeoutTo(duration, that) {
  return self => tsplus_module_4.catchSomeCause(cause => tsplus_module_1.isDieType(cause) && isStreamTimeoutError(cause.value) ? tsplus_module_2.some(that) : tsplus_module_2.none)(tsplus_module_3.timeoutFailCause(() => tsplus_module_1.die(new StreamTimeoutError()), duration)(self));
}
//# sourceMappingURL=timeoutTo.js.map