import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
import { Hub } from "@effect/core/io/Hub/definition";
import { Take } from "@effect/core/stream/Take/definition";
/**
 * Converts the stream to a scoped hub of chunks. After the scope is closed,
 * the hub will never again produce values and should be discarded.
 * @tsplus static effect/core/stream/Stream.Aspects toHub
 * @tsplus pipeable effect/core/stream/Stream toHub
 * @tsplus location "@effect/core/stream/Stream/operations/toHub"
 */
export declare function toHub(capacity: number): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R, never, import("../../../io/Hub").Hub<import("../../Take").Take<E, A>>>;
//# sourceMappingURL=toHub.d.ts.map