import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
import { Dequeue } from "@effect/core/io/Queue/definition/common";
import { Take } from "@effect/core/stream/Take/definition";
/**
 * Converts the stream to a sliding scoped queue of chunks. After the scope is
 * closed, the queue will never again produce values and should be discarded.
 * @tsplus static effect/core/stream/Stream.Aspects toQueueSliding
 * @tsplus pipeable effect/core/stream/Stream toQueueSliding
 * @tsplus location "@effect/core/stream/Stream/operations/toQueueSliding"
 */
export declare function toQueueSliding(capacity?: number): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../../../io/Effect").Effect<import("../../../io/Scope").Scope | R, never, import("../../../io/Queue").Dequeue<import("../../Take").Take<E, A>>>;
//# sourceMappingURL=toQueueSliding.d.ts.map