import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Scope } from "@effect/core/io/Scope/definition";
import { Dequeue } from "@effect/core/io/Queue/definition/common";
import { Take } from "@effect/core/stream/Take/definition";
/**
 * Converts the stream into an unbounded scoped queue. After the scope is
 * closed, the queue will never again produce values and should be discarded.
 * @tsplus getter effect/core/stream/Stream toQueueUnbounded
 * @tsplus location "@effect/core/stream/Stream/operations/toQueueUnbounded"
 */
export declare function toQueueUnbounded<R, E, A>(self: Stream<R, E, A>): Effect<R | Scope, never, Dequeue<Take<E, A>>>;
//# sourceMappingURL=toQueueUnbounded.d.ts.map