import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Channel } from "@effect/core/stream/Channel/definition/base";
/**
 * Creates a stream by effectfully peeling off the "layers" of a value of type
 * `S`.
 * @tsplus static effect/core/stream/Stream.Ops unfoldChunkEffect
 * @tsplus location "@effect/core/stream/Stream/operations/unfoldChunkEffect"
 */
export declare function unfoldChunkEffect<S, R, E, A>(s: S, f: (s: S) => Effect<R, E, Maybe<readonly [Chunk<A>, S]>>): Stream<R, E, A>;
//# sourceMappingURL=unfoldChunkEffect.d.ts.map