import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Zips this stream with another point-wise, creating a new stream of pairs of
 * elements from both sides.
 *
 * The defaults `defaultLeft` and `defaultRight` will be used if the streams
 * have different lengths and one of the streams has ended before the other.
 * @tsplus static effect/core/stream/Stream.Aspects zipAllFlatten
 * @tsplus pipeable effect/core/stream/Stream zipAllFlatten
 * @tsplus location "@effect/core/stream/Stream/operations/zipAllFlatten"
 */
export declare function zipAllFlatten<R2, E2, A2, A extends ReadonlyArray<any>>(that: Stream<R2, E2, A2>, defaultLeft: A, defaultRight: A2): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, readonly [...A, A2]>;
//# sourceMappingURL=zipAllFlatten.d.ts.map