import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Zips this stream with another point-wise, and keeps only elements from the
 * other stream.
 *
 * The provided default value will be used if this stream ends before the
 * other one.
 * @tsplus static effect/core/stream/Stream.Aspects zipAllRight
 * @tsplus pipeable effect/core/stream/Stream zipAllRight
 * @tsplus location "@effect/core/stream/Stream/operations/zipAllRight"
 */
export declare function zipAllRight<R2, E2, A2>(that: Stream<R2, E2, A2>, def: A2): <R, E, A>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, A2>;
//# sourceMappingURL=zipAllRight.d.ts.map