import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Exit } from "@effect/core/io/Exit/definition";
/**
 * Zips this stream with another point-wise. The provided functions will be
 * used to create elements for the composed stream.
 *
 * The functions `left` and `right` will be used if the streams have different
 * lengths and one of the streams has ended before the other.
 * @tsplus static effect/core/stream/Stream.Aspects zipAllWith
 * @tsplus pipeable effect/core/stream/Stream zipAllWith
 * @tsplus location "@effect/core/stream/Stream/operations/zipAllWith"
 */
export declare function zipAllWith<R2, E2, A2, A, A3>(that: Stream<R2, E2, A2>, left: (a: A) => A3, right: (a2: A2) => A3, both: (a: A, a2: A2) => A3): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, A3>;
//# sourceMappingURL=zipAllWith.d.ts.map