import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Zips this stream with another point-wise and applies the function to the
 * paired elements.
 *
 * The new stream will end when one of the sides ends.
 * @tsplus static effect/core/stream/Stream.Aspects zipWith
 * @tsplus pipeable effect/core/stream/Stream zipWith
 * @tsplus location "@effect/core/stream/Stream/operations/zipWith"
 */
export declare function zipWith<R2, E2, A2, A, A3>(that: Stream<R2, E2, A2>, f: (a: A, a2: A2) => A3): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, A3>;
//# sourceMappingURL=zipWith.d.ts.map