import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Exit } from "@effect/core/io/Exit/definition";
/**
 * Zips this stream with another point-wise and applies the function to the
 * paired elements.
 *
 * The new stream will end when one of the sides ends.
 * @tsplus static effect/core/stream/Stream.Aspects zipWithChunks
 * @tsplus pipeable effect/core/stream/Stream zipWithChunks
 * @tsplus location "@effect/core/stream/Stream/operations/zipWithChunks"
 */
export declare function zipWithChunks<R2, E2, A2, A, A3>(that: Stream<R2, E2, A2>, f: (leftChunk: Chunk<A>, rightChunk: Chunk<A2>) => readonly [Chunk<A3>, Either<Chunk<A>, Chunk<A2>>]): <R, E>(self: import("../definition").Stream<R, E, A>) => import("../definition").Stream<R2 | R, E2 | E, A3>;
//# sourceMappingURL=zipWithChunks.d.ts.map