"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.zipWithLatest = zipWithLatest;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/size"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/map"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/fromChunk"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Either/fold"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/repeatEffectMaybe"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/mergeEither"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/mapEffect"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/flatMap"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/concat"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Ref/operations/make"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/fromEffect"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/operations/join"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/done"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/zipWith"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/raceWith"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/fromEffectMaybe"));

var tsplus_module_18 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/toPull"));

var tsplus_module_19 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/map"));

var tsplus_module_20 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/flatMap"));

var tsplus_module_21 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/fromPull"));

var tsplus_module_22 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/isEmpty"));

var tsplus_module_23 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/succeed"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Zips the two streams so that when a value is emitted by either of the two
 * streams, it is combined with the latest value from the other stream to
 * produce a result.
 *
 * Note: tracking the latest value is done on a per-chunk basis. That means
 * that emitted elements that are not the last value in chunks will never be
 * used for zipping.
 *
 * @tsplus static effect/core/stream/Stream.Aspects zipWithLatest
 * @tsplus pipeable effect/core/stream/Stream zipWithLatest
 */
function zipWithLatest(that, f) {
  return self => tsplus_module_21.fromPull(tsplus_module_20.flatMap(left => tsplus_module_20.flatMap(right => tsplus_module_18.toPull(tsplus_module_9.flatMap(([l, r, leftFirst]) => tsplus_module_9.flatMap(latest => tsplus_module_10.concat(tsplus_module_9.flatMap(chunk => tsplus_module_4.fromChunk(chunk))(tsplus_module_8.mapEffect(either => tsplus_module_5.fold(leftChunk => latest.modify(([_, rightLatest]) => [tsplus_module_3.map(a => f(a, rightLatest))(leftChunk), [tsplus_module_2.unsafeGet(tsplus_module_1.size(leftChunk) - 1)(leftChunk), rightLatest]]), rightChunk => latest.modify(([leftLatest, _]) => [tsplus_module_3.map(a2 => f(leftLatest, a2))(rightChunk), [leftLatest, tsplus_module_2.unsafeGet(tsplus_module_1.size(rightChunk) - 1)(rightChunk)]]))(either))(tsplus_module_7.mergeEither(tsplus_module_6.repeatEffectMaybe(right))(tsplus_module_6.repeatEffectMaybe(left)))))(tsplus_module_4.fromChunk(leftFirst ? tsplus_module_3.map(a2 => f(tsplus_module_2.unsafeGet(tsplus_module_1.size(l) - 1)(l), a2))(r) : tsplus_module_3.map(a => f(a, tsplus_module_2.unsafeGet(tsplus_module_1.size(r) - 1)(r)))(l))))(tsplus_module_12.fromEffect(tsplus_module_11.makeRef(() => [tsplus_module_2.unsafeGet(tsplus_module_1.size(l) - 1)(l), tsplus_module_2.unsafeGet(tsplus_module_1.size(r) - 1)(r)]))))(tsplus_module_17.fromEffectMaybe(tsplus_module_16.raceWith(right, (leftDone, rightFiber) => tsplus_module_15.zipWith(tsplus_module_13.join(rightFiber), (left, right) => [left, right, true])(tsplus_module_14.done(leftDone)), (rightDone, leftFiber) => tsplus_module_15.zipWith(tsplus_module_13.join(leftFiber), (right, left) => [left, right, false])(tsplus_module_14.done(rightDone)))(left)))))(tsplus_module_19.map(pullNonEmpty)(tsplus_module_18.toPull(that))))(tsplus_module_19.map(pullNonEmpty)(tsplus_module_18.toPull(self))));
}

function pullNonEmpty(pull) {
  return tsplus_module_20.flatMap(chunk => tsplus_module_22.isEmpty(chunk) ? pullNonEmpty(pull) : tsplus_module_23.succeed(chunk))(pull);
}
//# sourceMappingURL=zipWithLatest.js.map