import { SubscriptionRef } from "@effect/core/stream/SubscriptionRef/definition";
import { Ref } from "@effect/core/io/Ref/definition";
import { Hub } from "@effect/core/io/Hub/definition";
import { TSemaphore } from "@effect/core/stm/TSemaphore/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
import { Effect } from "@effect/core/io/Effect";
import { _A, RefSym, SynchronizedSym } from "@effect/core/io/Ref/definition";
import { SubscriptionRefSym } from "@effect/core/stream/SubscriptionRef/definition";
import type { Maybe } from "@tsplus/stdlib/data/Maybe";
export declare class SubscriptionRefInternal<A> implements SubscriptionRef<A> {
    readonly ref: Ref<A>;
    readonly hub: Hub<A>;
    readonly semaphore: TSemaphore;
    get [RefSym](): RefSym;
    get [SynchronizedSym](): SynchronizedSym;
    get [SubscriptionRefSym](): SubscriptionRefSym;
    get [_A](): (_: never) => A;
    constructor(ref: Ref<A>, hub: Hub<A>, semaphore: TSemaphore);
    get changes(): Stream.UIO<A>;
    modifyEffect<R, E, B>(this: this, f: (a: A) => Effect<R, E, readonly [B, A]>): Effect<R, E, B>;
    getAndUpdateEffect<R, E>(this: this, f: (a: A) => Effect<R, E, A>): Effect<R, E, A>;
    getAndUpdateSomeEffect<R, E>(this: this, pf: (a: A) => Maybe<Effect<R, E, A>>): Effect<R, E, A>;
    modifySomeEffect<R, E, B>(this: this, fallback: B, pf: (a: A) => Maybe<Effect<R, E, readonly [B, A]>>): Effect<R, E, B>;
    updateEffect<R, E>(this: this, f: (a: A) => Effect<R, E, A>): Effect<R, E, void>;
    updateAndGetEffect<R, E>(this: this, f: (a: A) => Effect<R, E, A>): Effect<R, E, A>;
    updateSomeEffect<R, E>(this: this, pf: (a: A) => Maybe<Effect<R, E, A>>): Effect<R, E, void>;
    updateSomeAndGetEffect<R, E>(this: this, pf: (a: A) => Maybe<Effect<R, E, A>>): Effect<R, E, A>;
    get get(): Effect<never, never, A>;
    modify<B>(this: this, f: (a: A) => readonly [B, A]): Effect<never, never, B>;
    set(this: this, a: A): Effect<never, never, void>;
    getAndSet(this: this, a: A): Effect<never, never, A>;
    getAndUpdate(this: this, f: (a: A) => A): Effect<never, never, A>;
    getAndUpdateSome(this: this, pf: (a: A) => Maybe<A>): Effect<never, never, A>;
    modifySome<B>(this: this, fallback: B, pf: (a: A) => Maybe<readonly [B, A]>): Effect<never, never, B>;
    update(this: this, f: (a: A) => A): Effect<never, never, void>;
    updateAndGet(this: this, f: (a: A) => A): Effect<never, never, A>;
    updateSome(this: this, pf: (a: A) => Maybe<A>): Effect<never, never, void>;
    updateSomeAndGet(this: this, pf: (a: A) => Maybe<A>): Effect<never, never, A>;
}
//# sourceMappingURL=SubscriptionRefInternal.d.ts.map