import { Effect } from "@effect/core/io/Effect/definition";
import { Cause } from "@effect/core/io/Cause/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Take } from "@effect/core/stream/Take/definition";
/**
 * Effectful version of `Take.fold`.
 *
 * Folds over the failure cause, success value and end-of-stream marker to
 * yield an effect.
 * @tsplus static effect/core/stream/Take.Aspects foldEffect
 * @tsplus pipeable effect/core/stream/Take foldEffect
 * @tsplus location "@effect/core/stream/Take/operations/foldEffect"
 */
export declare function foldEffect<R, E1, Z, E, R1, E2, A, R2, E3>(end: Effect<R, E1, Z>, error: (cause: Cause<E>) => Effect<R1, E2, Z>, value: (chunk: Chunk<A>) => Effect<R2, E3, Z>): (self: Take<E, A>) => Effect<R | R1 | R2, E1 | E2 | E3, Z>;
//# sourceMappingURL=foldEffect.d.ts.map