import { Effect } from "@effect/core/io/Effect/definition";
import { Take } from "@effect/core/stream/Take/definition";
/**
 * Creates an effect from `Effect<R, E, A>` that does not fail, but succeeds
 * with the `Take<E, A>`. Any error returned from the stream when pulling is
 * converted to `Take.halt`. Creates a singleton chunk.
 * @tsplus static effect/core/stream/Take.Ops fromEffect
 * @tsplus location "@effect/core/stream/Take/operations/fromEffect"
 */
export declare function fromEffect<R, E, A>(effect: Effect<R, E, A>): Effect<R, never, Take<E, A>>;
//# sourceMappingURL=fromEffect.d.ts.map