import { Pull } from "@effect/core/stream/Pull/definition";
import { Effect } from "@effect/core/io/Effect/definition";
import { Take } from "@effect/core/stream/Take/definition";
/**
 * Creates effect from `Pull<R, E, A>` that does not fail, but succeeds with the
 * `Take<E, A>`. Any error returned from stream when pulling is converted to
 * `Take.failCause`, and the end of stream to `Take.end`.
 * @tsplus static effect/core/stream/Take.Ops fromPull
 * @tsplus location "@effect/core/stream/Take/operations/fromPull"
 */
export declare function fromPull<R, E, A>(pull: Pull<R, E, A>): Effect<R, never, Take<E, A>>;
//# sourceMappingURL=fromPull.d.ts.map