"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unicodeChar = exports.printableChar = exports.numericChar = exports.hexCharUpper = exports.hexCharLower = exports.hexChar = exports.fullUnicodeChar = exports.char16 = exports.char = exports.base64Char = exports.asciiChar = exports.alphaNumericChar = exports.alphaChar = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/testing/Gen/operations/weighted"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Function"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/testing/Gen/operations/int"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/testing/Gen/operations/map"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const char = char_1;
exports.char = char;
const gapSize = 0xdfff + 1 - 0xd800;
/**
 * A generator of alpha characters.
 *
 * @tsplus static effect/core/testing/Gen.Ops alphaChar
 */

const alphaChar = /*#__PURE__*/tsplus_module_1.weighted([/*#__PURE__*/char_1({
  min: 65,
  max: 90
}), 26], [/*#__PURE__*/char_1({
  min: 97,
  max: 122
}), 26]);
/**
 * A generator of alphanumeric characters. Shrinks toward '0'.
 *
 * @tsplus static effect/core/testing/Gen.Ops alphaNumericChar
 */

exports.alphaChar = alphaChar;
const alphaNumericChar = /*#__PURE__*/tsplus_module_1.weighted([/*#__PURE__*/char_1({
  min: 48,
  max: 57
}), 10], [/*#__PURE__*/char_1({
  min: 65,
  max: 90
}), 26], [/*#__PURE__*/char_1({
  min: 97,
  max: 122
}), 26]);
/**
 * A generator of US-ASCII characters. Shrinks toward '0'.
 *
 * @tsplus static effect/core/testing/Gen.Ops asciiChar
 */

exports.alphaNumericChar = alphaNumericChar;

const asciiChar = /*#__PURE__*/_char(0x00, 0x7f, indexToPrintableIndex);
/**
 * A generator of base-64 characters. Shrinks towards '0'.
 *
 * @tsplus static effect/core/testing/Gen.Ops base64Char
 */


exports.asciiChar = asciiChar;

const base64Char = /*#__PURE__*/_char(0, 63, base64ToCharCode);
/**
 * A generator of character values inside the specified range: [start, end].
 * The shrinker will shrink toward the lower end of the range ("smallest").
 *
 * @tsplus static effect/core/testing/Gen.Ops char
 */


exports.base64Char = base64Char;

function char_1(constraints) {
  return _char(constraints.min, constraints.max, tsplus_module_2.identity);
}
/**
 * A generator of UTF-16 characters. Shrinks towards '\x00'.
 *
 * @tsplus static effect/core/testing/Gen.Ops char16
 */


const char16 = /*#__PURE__*/_char(0x0000, 0xffff, indexToPrintableIndex);
/**
 * @tsplus static effect/core/testing/Gen.Ops fullUnicodeChar
 */


exports.char16 = char16;

const fullUnicodeChar = /*#__PURE__*/_char(0x0000, 0x10ffff - gapSize, unicodeToCharCode);
/**
 * A generator of numeric characters. Shrinks toward '0'.
 *
 * @tsplus static effect/core/testing/Gen.Ops numericChar
 */


exports.fullUnicodeChar = fullUnicodeChar;
const numericChar = /*#__PURE__*/tsplus_module_1.weighted([/*#__PURE__*/char_1({
  min: 48,
  max: 57
}), 10]);
/**
 * A generator of hex chars(0-9,a-f,A-F).
 *
 * @tsplus static effect/core/testing/Gen.Ops hexChar
 */

exports.numericChar = numericChar;

const hexChar = /*#__PURE__*/_char(0, 15, hexToCharCode);
/**
 * A generator of lower hex chars(0-9, a-f).
 *
 * @tsplus static effect/core/testing/Gen.Ops hexCharLower
 */


exports.hexChar = hexChar;
const hexCharLower = /*#__PURE__*/tsplus_module_1.weighted([/*#__PURE__*/_char(48, 57, hexToCharCode), 10], [/*#__PURE__*/_char(97, 102, hexToCharCode), 6]);
/**
 * A generator of upper hex chars(0-9, A-F).
 *
 * @tsplus static effect/core/testing/Gen.Ops hexCharUpper
 */

exports.hexCharLower = hexCharLower;
const hexCharUpper = /*#__PURE__*/tsplus_module_1.weighted([/*#__PURE__*/_char(48, 57, hexToCharCode), 10], [/*#__PURE__*/_char(65, 70, hexToCharCode), 10]);
/**
 * A generator of printable characters. Shrinks toward '!'.
 *
 * @tsplus static effect/core/testing/Gen.Ops printableChar
 */

exports.hexCharUpper = hexCharUpper;
const printableChar = /*#__PURE__*/char_1({
  min: 0x20,
  max: 0x7e
});
/**
 * A generator of Unicode characters. Shrinks toward '0'.
 *
 * @tsplus static effect/core/testing/Gen.Ops unicodeChar
 */

exports.printableChar = printableChar;

const unicodeChar = /*#__PURE__*/_char(0x0000, 0xffff - gapSize, unicodeToCharCode);

exports.unicodeChar = unicodeChar;

function _char(min, max, mapToCode) {
  return tsplus_module_4.map(n => String.fromCharCode(mapToCode(n)))(tsplus_module_3.int({
    min,
    max
  }));
}

function indexToPrintableIndex(v) {
  return v < 95 ? v + 0x20 : v <= 0x7e ? v - 95 : v;
}

function base64ToCharCode(v) {
  if (v < 26) return v + 65; // A-Z

  if (v < 52) return v + 97 - 26; // a-z

  if (v < 62) return v + 48 - 52; // 0-9

  return v === 62 ? 43 : 47; // +/
}

function hexToCharCode(v) {
  return v < 10 ? v + 48 // 0-9
  : v + 97 - 10; // a-f
}

function unicodeToCharCode(v) {
  return v < 0xd800 ? indexToPrintableIndex(v) : v + gapSize;
}
//# sourceMappingURL=char.js.map