import { Refinement } from "@tsplus/stdlib/data/Function";
import { Gen } from "@effect/core/testing/Gen/definition";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Filters the values produced by this generator, discarding any values that
 * do not meet the specified predicate. Using `filter` can reduce test
 * performance, especially if many values must be discarded. It is recommended
 * to use combinators such as `map` and `flatMap` to create generators of the
 * desired values instead.
 * @tsplus static effect/core/testing/Gen.Aspects filter
 * @tsplus pipeable effect/core/testing/Gen filter
 * @tsplus location "@effect/core/testing/Gen/operations/filter"
 */
export declare function filter<A, B extends A>(f: Refinement<A, B>): <R>(self: Gen<R, A>) => Gen<R, B>;
export declare function filter<A>(f: Predicate<A>): <R>(self: Gen<R, A>) => Gen<R, A>;
//# sourceMappingURL=filter.d.ts.map