import { Gen } from "@effect/core/testing/Gen/definition";
import { Sized } from "@effect/core/testing/Sized";
/**
 * A sized generator that uses an exponential distribution of size values. The
 * majority of sizes will be towards the lower end of the range but some
 * larger sizes will be generated as well.
 * @tsplus static effect/core/testing/Gen.Ops medium
 * @tsplus location "@effect/core/testing/Gen/operations/medium"
 */
export declare function medium<R, A>(f: (n: number) => Gen<R, A>, min?: number): Gen<R | Sized, A>;
//# sourceMappingURL=medium.d.ts.map