import { Gen } from "@effect/core/testing/Gen/definition";
import { Sized } from "@effect/core/testing/Sized";
/**
 * A sized generator that uses an exponential distribution of size values. The
 * values generated will be strongly concentrated towards the lower end of the
 * range but a few larger values will still be generated.
 * @tsplus static effect/core/testing/Gen.Ops small
 * @tsplus location "@effect/core/testing/Gen/operations/small"
 */
export declare function small<R, A>(f: (n: number) => Gen<R, A>, min?: number): Gen<R | Sized, A>;
//# sourceMappingURL=small.d.ts.map