"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.small = small;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/testing/Gen/operations/exponential"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/testing/Gen/operations/map"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/testing/Gen/operations/size"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/testing/Gen/operations/flatMap"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/testing/Sample/operations/shrinkIntegral"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/testing/Gen/operations/reshrink"));

var _math = /*#__PURE__*/require("@effect/core/testing/_internal/math");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * A sized generator that uses an exponential distribution of size values. The
 * values generated will be strongly concentrated towards the lower end of the
 * range but a few larger values will still be generated.
 *
 * @tsplus static effect/core/testing/Gen.Ops small
 */
function small(f, min = 0) {
  const gen = tsplus_module_4.flatMap(max => tsplus_module_2.map(n => (0, _math.clamp)(Math.round(n * max / 10.0), min, max))(tsplus_module_1.exponential))(tsplus_module_3.size);
  return tsplus_module_4.flatMap(f)(tsplus_module_6.reshrink(tsplus_module_5.shrinkIntegral(min))(gen));
}
//# sourceMappingURL=small.js.map