import { Gen } from "@effect/core/testing/Gen/definition";
import { Sized } from "@effect/core/testing/Sized";
import { List } from "@tsplus/stdlib/collections/List/definition";
/**
 * A sized generator of collections, where each collection is generated by
 * repeatedly applying a function to an initial state.
 * @tsplus static effect/core/testing/Gen.Ops unfoldGen
 * @tsplus location "@effect/core/testing/Gen/operations/unfoldGen"
 */
export declare function unfoldGen<S, R, A>(s: S, f: (s: S) => Gen<R, readonly [S, A]>): Gen<R | Sized, List<A>>;
//# sourceMappingURL=unfoldGen.d.ts.map