import { Gen } from "@effect/core/testing/Gen/definition";
import { SortedMap } from "@tsplus/stdlib/collections/SortedMap/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * A generator which chooses one of the given generators according to their
 * weights. For example, the following generator will generate 90% true and
 * 10% false values.
 * @tsplus static effect/core/testing/Gen.Ops weighted
 * @tsplus location "@effect/core/testing/Gen/operations/weighted"
 */
export declare function weighted<R, A>(...gens: Array<readonly [Gen<R, A>, number]>): Gen<R, A>;
//# sourceMappingURL=weighted.d.ts.map