"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.weighted = weighted;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/SortedMap/set"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/Ord/common"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/SortedMap/empty"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/exceptions"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/getOrElse"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/testing/Gen/operations/uniform"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/testing/Gen/operations/flatMap"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var _SortedMapInternal = /*#__PURE__*/require("@tsplus/stdlib/collections/SortedMap/_internal/SortedMapInternal");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * A generator which chooses one of the given generators according to their
 * weights. For example, the following generator will generate 90% true and
 * 10% false values.
 *
 * @tsplus static effect/core/testing/Gen.Ops weighted
 */
function weighted(...gens) {
  const sum = gens.reduce((acc, [_, n]) => acc + n, 0);
  const [map, _] = gens.reduce(([map, acc], [gen, d]) => (acc + d) / sum > acc / sum ? [tsplus_module_1.set((acc + d) / sum, gen)(map), acc + d] : [map, acc], [tsplus_module_3.empty(tsplus_module_2.number), 0]);
  return tsplus_module_7.flatMap(n => tsplus_module_5.getOrElse_(getGreaterThanEqual(map, n), () => {
    throw new tsplus_module_4.NoSuchElement();
  }))(tsplus_module_6.uniform());
}

function getGreaterThanEqual(map, key) {
  void 0;
  const cmp = map.tree.ord.compare;
  let n = map.tree.root;
  let lastValue = tsplus_module_8.empty();

  while (n) {
    const d = cmp(key, n.key);

    if (d <= 0) {
      lastValue = tsplus_module_8.some(n.value);
      n = n.left;
    } else {
      if (lastValue._tag === "Some") {
        break;
      }

      n = n.right;
    }
  }

  return lastValue;
}
//# sourceMappingURL=weighted.js.map