"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.live = exports.defaultLive = exports.Live = void 0;
exports.withLive = withLive;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/service/Tag"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/DefaultServices/definition"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/environmentWith"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Layer/operations/fromEffect"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Fiber/_internal/runtime"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const live = live_1;
exports.live = live;
const Live = {
  Tag: /*#__PURE__*/tsplus_module_1.Tag()
};
/**
 * Constructs a new `Live` service that implements the `Live` interface. This
 * typically should not be necessary as the `TestEnvironment` already includes
 * the `Live` service but could be useful if you are mixing in interfaces to
 * create your own environment type.
 *
 * @tsplus static effect/core/testing/Live.Ops default
 */

exports.Live = Live;
const defaultLive = /*#__PURE__*/tsplus_module_4.fromEffect(Live.Tag)( /*#__PURE__*/tsplus_module_3.environmentWith(env => ({
  provide: effect => tsplus_module_2.currentServices.locallyWith(_ => _.merge(env))(effect)
})));
/**
 * Provides a workflow with the "live" default ZIO services.
 *
 * @tsplus static effect/core/testing/Live.Ops live
 */

exports.defaultLive = defaultLive;

function live_1(effect) {
  return tsplus_module_5.serviceWithEffect(Live.Tag, live => live.provide(effect));
}
/**
 * Runs a transformation function with the live default Effect services while
 * ensuring that the workflow itself is run with the test services.
 *
 * @tsplus static effect/core/testing/Live.Ops withLive
 */


function withLive(effect, f) {
  return tsplus_module_2.currentServices.getWith(services => live_1(f(tsplus_module_2.currentServices.locally(services)(effect))));
}
//# sourceMappingURL=Live.js.map