"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.shrinkBigInt = shrinkBigInt;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/unfold"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/testing/Sample/operations/unfold"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @tsplus static effect/core/testing/Sample.Ops shrinkBigInt
 */
function shrinkBigInt(smallest) {
  return a => tsplus_module_3.unfold(a, max => [max, tsplus_module_2.unfold(smallest, min => {
    const mid = min + (max - min) / BigInt(2);

    if (mid === max) {
      return tsplus_module_1.none;
    } else if (bigIntAbs(max - mid) === BigInt(1)) {
      return tsplus_module_1.some([mid, max]);
    } else {
      return tsplus_module_1.some([mid, mid]);
    }
  })]);
}

function bigIntAbs(x) {
  return x < BigInt(0) ? -x : x;
}
//# sourceMappingURL=shrinkBigInt.js.map