import { Predicate } from "@tsplus/stdlib/data/Predicate";
import { Sample } from "@effect/core/testing/Sample/definition";
import { Stream } from "@effect/core/stream/Stream/definition";
/**
 * Converts the shrink tree into a stream of shrinkings by recursively
 * searching the shrink tree, using the specified function to determine
 * whether a value is a failure. The resulting stream will contain all values
 * explored, regardless of whether they are successes or failures.
 * @tsplus static effect/core/testing/Sample.Aspects shrinkSearch
 * @tsplus pipeable effect/core/testing/Sample shrinkSearch
 * @tsplus location "@effect/core/testing/Sample/operations/shrinkSearch"
 */
export declare function shrinkSearch<A>(f: Predicate<A>): <R>(self: import("../definition").Sample<R, A>) => import("../../../stream/Stream").Stream<R, never, A>;
//# sourceMappingURL=shrinkSearch.d.ts.map