"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.shrinkSearch = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/empty"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/map"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/getOrElse"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/takeUntil"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/flatMap"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/make"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/concat"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const shrinkSearch = shrinkSearch_1;
/**
 * Converts the shrink tree into a stream of shrinkings by recursively
 * searching the shrink tree, using the specified function to determine
 * whether a value is a failure. The resulting stream will contain all values
 * explored, regardless of whether they are successes or failures.
 *
 * @tsplus static effect/core/testing/Sample.Aspects shrinkSearch
 * @tsplus pipeable effect/core/testing/Sample shrinkSearch
 */

exports.shrinkSearch = shrinkSearch;

function shrinkSearch_1(f) {
  return self => f(self.value) ? tsplus_module_7.concat(tsplus_module_5.flatMap(maybe => tsplus_module_3.getOrElse_(tsplus_module_2.map(sample => shrinkSearch_1(f)(sample))(maybe), () => tsplus_module_1.empty))(tsplus_module_4.takeUntil(maybe => {
    switch (maybe._tag) {
      case "None":
        {
          return false;
        }

      case "Some":
        {
          return f(maybe.value.value);
        }
    }
  })(self.shrink)))(tsplus_module_6.make(self.value)) : tsplus_module_6.make(self.value);
}
//# sourceMappingURL=shrinkSearch.js.map