import { Effect } from "@effect/core/io/Effect/definition";
import { Gen } from "@effect/core/testing/Gen/definition";
import { Tag } from "@tsplus/stdlib/service/Tag";
import { Layer } from "@effect/core/io/Layer/definition";
/**
 * @tsplus type effect/core/testing/Sized
 */
export interface Sized {
    readonly size: Effect<never, never, number>;
    readonly withSize: (size: number) => <R, E, A>(effect: Effect<R, E, A>) => Effect<R, E, A>;
    readonly withSizeGen: (size: number) => <R, A>(gen: Gen<R, A>) => Gen<R, A>;
}
/**
 * @tsplus type effect/core/testing/Sized.Ops
 */
export interface SizedOps {
    readonly Tag: Tag<Sized>;
}
export declare const Sized: SizedOps;
/**
 * @tsplus type effect/core/testing/Sized.Aspects
 */
export interface SizedAspects {
}
/**
 * @tsplus static effect/core/testing/Sized.Ops live
 * @tsplus location "@effect/core/testing/Sized"
 */
export declare function live(size: number): Layer<never, never, Sized>;
/**
 * @tsplus static effect/core/testing/Sized.Ops default
 * @tsplus location "@effect/core/testing/Sized"
 */
export declare const defaultSized: Layer<never, never, Sized>;
/**
 * @tsplus static effect/core/testing/Sized.Ops size
 * @tsplus location "@effect/core/testing/Sized"
 */
export declare const size: Effect<Sized, never, number>;
/**
 * @tsplus static effect/core/testing/Sized.Ops withSize
 * @tsplus location "@effect/core/testing/Sized"
 */
export declare function withSize(size: number): <R, E, A>(effect: import("../io/Effect").Effect<R, E, A>) => import("../io/Effect").Effect<Sized | R, E, A>;
/**
 * @tsplus static effect/core/testing/Sized.Ops withSizeGen
 * @tsplus location "@effect/core/testing/Sized"
 */
export declare function withSizeGen(size: number): <R, A>(gen: import("./Gen").Gen<R, A>) => import("./Gen").Gen<Sized | R, A>;
//# sourceMappingURL=Sized.d.ts.map