import { Equals } from "@tsplus/stdlib/structure/Equals";
import { Tag } from "@tsplus/stdlib/service/Tag";
import { Hash } from "@tsplus/stdlib/structure/Hash";
export declare const TestAnnotationSym: unique symbol;
export type TestAnnotationSym = typeof TestAnnotationSym;
/**
 * A type of annotation.
 *
 * @tsplus type effect/core/testing/TestAnnotation
 * @tsplus companion effect/core/testing/TestAnnotation.Ops
 */
export declare class TestAnnotation<V> implements Equals {
    readonly identifier: string;
    readonly initial: V;
    readonly combine: (a: V, b: V) => V;
    readonly tag: Tag<V>;
    readonly [TestAnnotationSym]: TestAnnotationSym;
    constructor(identifier: string, initial: V, combine: (a: V, b: V) => V, tag: Tag<V>);
    [Hash.sym](): number;
    [Equals.sym](that: unknown): boolean;
}
/**
 * @tsplus static effect/core/testing/TestAnnotation.Ops is
 * @tsplus location "@effect/core/testing/TestAnnotation/definition"
 */
export declare function isTestAnnotation(u: unknown): u is TestAnnotation<unknown>;
//# sourceMappingURL=definition.d.ts.map