"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isTestAnnotation = exports.TestAnnotationSym = exports.TestAnnotation = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a;

const isTestAnnotation = isTestAnnotation_1;
exports.isTestAnnotation = isTestAnnotation;
const TestAnnotationSym = /*#__PURE__*/Symbol.for("@effect/core/testing/TestAnnotation");
/**
 * A type of annotation.
 *
 * @tsplus type effect/core/testing/TestAnnotation
 * @tsplus companion effect/core/testing/TestAnnotation.Ops
 */

exports.TestAnnotationSym = TestAnnotationSym;

class TestAnnotation {
  constructor(identifier, initial, combine, tag) {
    this.identifier = identifier;
    this.initial = initial;
    this.combine = combine;
    this.tag = tag;
    this[_a] = TestAnnotationSym;
  }

  [(_a = TestAnnotationSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString(this.identifier), tsplus_module_1.hashUnknown(this.tag));
  }

  [tsplus_module_2.Equals.sym](that) {
    return isTestAnnotation_1(that) && this.identifier === that.identifier && tsplus_module_2.equals(this.tag, that.tag);
  }

}
/**
 * @tsplus static effect/core/testing/TestAnnotation.Ops is
 */


exports.TestAnnotation = TestAnnotation;

function isTestAnnotation_1(u) {
  return typeof u === "object" && u != null && TestAnnotationSym in u;
}
//# sourceMappingURL=definition.js.map