import { List } from "@tsplus/stdlib/collections/List/definition";
import { Deferred } from "@effect/core/io/Deferred/definition";
/**
 * `Data` represents the state of the `TestClock`, including the clock time
 * and time zone.
 *
 * @tsplus type effect/core/testing/TestClock.Data
 */
export interface Data {
    readonly instant: number;
    readonly sleeps: List<readonly [number, Deferred<never, void>]>;
}
/**
 * @tsplus type effect/core/testing/TestClock.Data.Ops
 */
export interface DataOps {
    (instant: number, sleeps: List<readonly [number, Deferred<never, void>]>): Data;
}
/**
 * @tsplus static effect/core/testing/TestClock.Ops Data
 * @tsplus location "@effect/core/testing/TestClock/Data"
 */
export declare const Data: DataOps;
//# sourceMappingURL=Data.d.ts.map