import { Fiber } from "@effect/core/io/Fiber/definition";
/**
 * @tsplus type effect/core/testing/TestClock.SuspendedWarningData
 */
export type SuspendedWarningData = Start | Pending | Done;
/**
 * @tsplus type effect/core/testing/TestClock.SuspendedWarningData.Ops
 */
export interface SuspendedWarningDataOps {
}
export declare const SuspendedWarningData: SuspendedWarningDataOps;
export interface Start {
    readonly _tag: "Start";
}
export interface Pending {
    readonly _tag: "Pending";
    readonly fiber: Fiber<Error, void>;
}
export interface Done {
    readonly _tag: "Done";
}
/**
 * State indicating that a test has not adjusted the clock.
 * @tsplus static effect/core/testing/TestClock.SuspendedWarningData.Ops Start
 * @tsplus location "@effect/core/testing/TestClock/_internal/SuspendedWarningData"
 */
export declare const start: SuspendedWarningData;
/**
 * State indicating that a test has adjusted the clock but a fiber is still
 * running with a reference to the fiber that will display the warning
 * message.
 * @tsplus static effect/core/testing/TestClock.SuspendedWarningData.Ops Pending
 * @tsplus location "@effect/core/testing/TestClock/_internal/SuspendedWarningData"
 */
export declare function pending(fiber: Fiber<Error, void>): SuspendedWarningData;
/**
 * State indicating that the warning message has already been displayed.
 * @tsplus static effect/core/testing/TestClock.SuspendedWarningData.Ops Done
 * @tsplus location "@effect/core/testing/TestClock/_internal/SuspendedWarningData"
 */
export declare const done: SuspendedWarningData;
//# sourceMappingURL=SuspendedWarningData.d.ts.map