"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.shrinks = exports.samples = exports.retries = exports.repeats = exports.live = exports.defaultTestConfig = exports.TestConfig = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/service/Tag"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Layer/operations/succeed"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/io/Effect/operations/serviceWith"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const live = live_1;
exports.live = live;
const TestConfig = /*#__PURE__*/Object.assign(params => params, {
  $: {},
  Tag: /*#__PURE__*/tsplus_module_1.Tag()
});
/**
 * Constructs a new `TestConfig` service with the specified settings.
 *
 * @tsplus static effect/core/testing/TestConfig.Ops live
 */

exports.TestConfig = TestConfig;

function live_1(params) {
  return tsplus_module_2.succeed(TestConfig.Tag)(TestConfig(params));
}
/**
 * Constructs a new `TestConfig` with the default settings.
 *
 * @tsplus static effect/core/testing/TestConfig.Ops default
 */


const defaultTestConfig = /*#__PURE__*/live_1({
  repeats: 100,
  retries: 100,
  samples: 200,
  shrinks: 1000
});
/**
 * The number of times to repeat tests to ensure they are stable.
 *
 * @tsplus static effect/core/testing/TestConfig.Ops repeats
 */

exports.defaultTestConfig = defaultTestConfig;
const repeats = /*#__PURE__*/tsplus_module_3.serviceWith(TestConfig.Tag, _ => _.repeats);
/**
 * The number of times to retry flaky tests.
 *
 * @tsplus static effect/core/testing/TestConfig.Ops retries
 */

exports.repeats = repeats;
const retries = /*#__PURE__*/tsplus_module_3.serviceWith(TestConfig.Tag, _ => _.retries);
/**
 * The number of sufficient samples to check for a random variable.
 *
 * @tsplus static effect/core/testing/TestConfig.Ops samples
 */

exports.retries = retries;
const samples = /*#__PURE__*/tsplus_module_3.serviceWith(TestConfig.Tag, _ => _.samples);
/**
 * The maximum number of shrinkings to minimize large failures.
 *
 * @tsplus static effect/core/testing/TestConfig.Ops shrinks
 */

exports.samples = samples;
const shrinks = /*#__PURE__*/tsplus_module_3.serviceWith(TestConfig.Tag, _ => _.shrinks);
exports.shrinks = shrinks;
//# sourceMappingURL=TestConfig.js.map