"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.flatMapStream = flatMapStream;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/rechunk"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/unit"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/zipRight"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Either/definition"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/map"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/make"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/map"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/reduce"));

var tsplus_module_9 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/head"));

var tsplus_module_10 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/flatten"));

var tsplus_module_11 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_12 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/UpstreamPullStrategy"));

var tsplus_module_13 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/single"));

var tsplus_module_14 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/ChildExecutorDecision"));

var tsplus_module_15 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Channel/operations/concatMapWithCustom"));

var tsplus_module_16 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/fromChannel"));

var tsplus_module_17 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@effect/core/stream/Stream/operations/filter"));

var _StreamInternal = /*#__PURE__*/require("@effect/core/stream/Stream/operations/_internal/StreamInternal");

var _Function = /*#__PURE__*/require("@tsplus/stdlib/data/Function");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function flatMapStream(stream, f) {
  const rechunked = tsplus_module_1.rechunk(1)(stream);
  void 0;
  const channel = tsplus_module_15.concatMapWithCustom(as => tsplus_module_8.reduce(tsplus_module_2.unit, (a, b) => tsplus_module_3.zipRight(b)(a))(tsplus_module_7.map(maybe => {
    switch (maybe._tag) {
      case "Some":
        {
          const stream = tsplus_module_5.map(maybe => {
            switch (maybe._tag) {
              case "None":
                {
                  return tsplus_module_4.left(true);
                }

              case "Some":
                {
                  return tsplus_module_4.right(maybe.value);
                }
            }
          })(tsplus_module_1.rechunk(1)(f(maybe.value)));
          void 0;
          return stream.channel;
        }

      case "None":
        {
          const stream = tsplus_module_6.make(tsplus_module_4.left(false));
          void 0;
          return stream.channel;
        }
    }
  })(as)), _Function.constVoid, _Function.constVoid, request => {
    switch (request._tag) {
      case "Pulled":
        {
          const maybe = tsplus_module_10.flatten(tsplus_module_9.head(request.value));

          switch (maybe._tag) {
            case "Some":
              {
                return tsplus_module_12.pullAfterNext(tsplus_module_11.none);
              }

            case "None":
              {
                return tsplus_module_12.pullAfterAllEnqueued(tsplus_module_11.none);
              }
          }
        }

      case "NoUpstream":
        {
          return tsplus_module_12.pullAfterAllEnqueued(request.activeDownstreamCount > 0 ? tsplus_module_11.some(tsplus_module_13.single(tsplus_module_4.left(false))) : tsplus_module_11.none);
        }
    }
  }, chunk => {
    const maybe = tsplus_module_9.head(chunk);
    return tsplus_module_11.isSome(maybe) && tsplus_module_4.isLeft(maybe.value) && maybe.value.left ? tsplus_module_14._yield : tsplus_module_14._continue;
  })(rechunked.channel);
  return tsplus_module_5.map(either => {
    switch (either._tag) {
      case "Left":
        {
          return tsplus_module_11.none;
        }

      case "Right":
        {
          return tsplus_module_11.some(either.right);
        }
    }
  })(tsplus_module_17.filter(either => !(tsplus_module_4.isLeft(either) && either.left))(tsplus_module_16.fromChannel(channel)));
}
//# sourceMappingURL=flatMapStream.js.map